#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1147
#define LARGE_STATE_COUNT 299
#define SYMBOL_COUNT 291
#define ALIAS_COUNT 1
#define TOKEN_COUNT 130
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 37
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 220

enum {
  sym_identifier = 1,
  sym_decimal_integer_literal = 2,
  sym_hex_integer_literal = 3,
  sym_octal_integer_literal = 4,
  sym_binary_integer_literal = 5,
  sym_decimal_floating_point_literal = 6,
  sym_hex_floating_point_literal = 7,
  sym_true = 8,
  sym_false = 9,
  sym_character_literal = 10,
  sym_string_literal = 11,
  sym_text_block = 12,
  sym_null_literal = 13,
  anon_sym_LPAREN = 14,
  anon_sym_AMP = 15,
  anon_sym_RPAREN = 16,
  anon_sym_EQ = 17,
  anon_sym_PLUS_EQ = 18,
  anon_sym_DASH_EQ = 19,
  anon_sym_STAR_EQ = 20,
  anon_sym_SLASH_EQ = 21,
  anon_sym_AMP_EQ = 22,
  anon_sym_PIPE_EQ = 23,
  anon_sym_CARET_EQ = 24,
  anon_sym_PERCENT_EQ = 25,
  anon_sym_LT_LT_EQ = 26,
  anon_sym_GT_GT_EQ = 27,
  anon_sym_GT_GT_GT_EQ = 28,
  anon_sym_GT = 29,
  anon_sym_LT = 30,
  anon_sym_GT_EQ = 31,
  anon_sym_LT_EQ = 32,
  anon_sym_EQ_EQ = 33,
  anon_sym_BANG_EQ = 34,
  anon_sym_AMP_AMP = 35,
  anon_sym_PIPE_PIPE = 36,
  anon_sym_PLUS = 37,
  anon_sym_DASH = 38,
  anon_sym_STAR = 39,
  anon_sym_SLASH = 40,
  anon_sym_PIPE = 41,
  anon_sym_CARET = 42,
  anon_sym_PERCENT = 43,
  anon_sym_LT_LT = 44,
  anon_sym_GT_GT = 45,
  anon_sym_GT_GT_GT = 46,
  anon_sym_instanceof = 47,
  anon_sym_DASH_GT = 48,
  anon_sym_COMMA = 49,
  anon_sym_QMARK = 50,
  anon_sym_COLON = 51,
  anon_sym_BANG = 52,
  anon_sym_TILDE = 53,
  anon_sym_PLUS_PLUS = 54,
  anon_sym_DASH_DASH = 55,
  anon_sym_new = 56,
  anon_sym_LBRACK = 57,
  anon_sym_RBRACK = 58,
  anon_sym_DOT = 59,
  anon_sym_class = 60,
  anon_sym_COLON_COLON = 61,
  anon_sym_extends = 62,
  anon_sym_switch = 63,
  anon_sym_LBRACE = 64,
  anon_sym_RBRACE = 65,
  anon_sym_case = 66,
  anon_sym_default = 67,
  anon_sym_SEMI = 68,
  anon_sym_assert = 69,
  anon_sym_do = 70,
  anon_sym_while = 71,
  anon_sym_break = 72,
  anon_sym_continue = 73,
  anon_sym_return = 74,
  anon_sym_yield = 75,
  anon_sym_synchronized = 76,
  anon_sym_throw = 77,
  anon_sym_try = 78,
  anon_sym_catch = 79,
  anon_sym_finally = 80,
  anon_sym_if = 81,
  anon_sym_else = 82,
  anon_sym_for = 83,
  anon_sym_AT = 84,
  anon_sym_open = 85,
  anon_sym_module = 86,
  anon_sym_requires = 87,
  anon_sym_transitive = 88,
  anon_sym_static = 89,
  anon_sym_exports = 90,
  anon_sym_to = 91,
  anon_sym_opens = 92,
  anon_sym_uses = 93,
  anon_sym_provides = 94,
  anon_sym_with = 95,
  anon_sym_package = 96,
  anon_sym_import = 97,
  anon_sym_enum = 98,
  anon_sym_public = 99,
  anon_sym_protected = 100,
  anon_sym_private = 101,
  anon_sym_abstract = 102,
  anon_sym_final = 103,
  anon_sym_strictfp = 104,
  anon_sym_native = 105,
  anon_sym_transient = 106,
  anon_sym_volatile = 107,
  anon_sym_sealed = 108,
  anon_sym_non_DASHsealed = 109,
  anon_sym_implements = 110,
  anon_sym_permits = 111,
  anon_sym_record = 112,
  anon_sym_ATinterface = 113,
  anon_sym_interface = 114,
  anon_sym_byte = 115,
  anon_sym_short = 116,
  anon_sym_int = 117,
  anon_sym_long = 118,
  anon_sym_char = 119,
  anon_sym_float = 120,
  anon_sym_double = 121,
  sym_boolean_type = 122,
  sym_void_type = 123,
  anon_sym_DOT_DOT_DOT = 124,
  anon_sym_throws = 125,
  sym_this = 126,
  sym_super = 127,
  sym_line_comment = 128,
  sym_block_comment = 129,
  sym_program = 130,
  sym__literal = 131,
  sym_expression = 132,
  sym_cast_expression = 133,
  sym_assignment_expression = 134,
  sym_binary_expression = 135,
  sym_instanceof_expression = 136,
  sym_lambda_expression = 137,
  sym_inferred_parameters = 138,
  sym_ternary_expression = 139,
  sym_unary_expression = 140,
  sym_update_expression = 141,
  sym_primary_expression = 142,
  sym_array_creation_expression = 143,
  sym_dimensions_expr = 144,
  sym_parenthesized_expression = 145,
  sym_class_literal = 146,
  sym_object_creation_expression = 147,
  sym__unqualified_object_creation_expression = 148,
  sym_field_access = 149,
  sym_array_access = 150,
  sym_method_invocation = 151,
  sym_argument_list = 152,
  sym_method_reference = 153,
  sym_type_arguments = 154,
  sym_wildcard = 155,
  sym__wildcard_bounds = 156,
  sym_dimensions = 157,
  sym_switch_expression = 158,
  sym_switch_block = 159,
  sym_switch_block_statement_group = 160,
  sym_switch_rule = 161,
  sym_switch_label = 162,
  sym_statement = 163,
  sym_block = 164,
  sym_expression_statement = 165,
  sym_labeled_statement = 166,
  sym_assert_statement = 167,
  sym_do_statement = 168,
  sym_break_statement = 169,
  sym_continue_statement = 170,
  sym_return_statement = 171,
  sym_yield_statement = 172,
  sym_synchronized_statement = 173,
  sym_throw_statement = 174,
  sym_try_statement = 175,
  sym_catch_clause = 176,
  sym_catch_formal_parameter = 177,
  sym_catch_type = 178,
  sym_finally_clause = 179,
  sym_try_with_resources_statement = 180,
  sym_resource_specification = 181,
  sym_resource = 182,
  sym_if_statement = 183,
  sym_while_statement = 184,
  sym_for_statement = 185,
  sym_enhanced_for_statement = 186,
  sym__annotation = 187,
  sym_marker_annotation = 188,
  sym_annotation = 189,
  sym_annotation_argument_list = 190,
  sym_element_value_pair = 191,
  sym__element_value = 192,
  sym_element_value_array_initializer = 193,
  sym_declaration = 194,
  sym_module_declaration = 195,
  sym_module_body = 196,
  sym_module_directive = 197,
  sym_requires_module_directive = 198,
  sym_requires_modifier = 199,
  sym_exports_module_directive = 200,
  sym_opens_module_directive = 201,
  sym_uses_module_directive = 202,
  sym_provides_module_directive = 203,
  sym_package_declaration = 204,
  sym_import_declaration = 205,
  sym_asterisk = 206,
  sym_enum_declaration = 207,
  sym_enum_body = 208,
  sym_enum_body_declarations = 209,
  sym_enum_constant = 210,
  sym_class_declaration = 211,
  sym_modifiers = 212,
  sym_type_parameters = 213,
  sym_type_parameter = 214,
  sym_type_bound = 215,
  sym_superclass = 216,
  sym_super_interfaces = 217,
  sym_type_list = 218,
  sym_permits = 219,
  sym_class_body = 220,
  sym_static_initializer = 221,
  sym_constructor_declaration = 222,
  sym__constructor_declarator = 223,
  sym_constructor_body = 224,
  sym_explicit_constructor_invocation = 225,
  sym_scoped_identifier = 226,
  sym_field_declaration = 227,
  sym_record_declaration = 228,
  sym_annotation_type_declaration = 229,
  sym_annotation_type_body = 230,
  sym_annotation_type_element_declaration = 231,
  sym__default_value = 232,
  sym_interface_declaration = 233,
  sym_extends_interfaces = 234,
  sym_interface_body = 235,
  sym_constant_declaration = 236,
  sym__variable_declarator_list = 237,
  sym_variable_declarator = 238,
  sym__variable_declarator_id = 239,
  sym_array_initializer = 240,
  sym__type = 241,
  sym__unannotated_type = 242,
  sym_annotated_type = 243,
  sym_scoped_type_identifier = 244,
  sym_generic_type = 245,
  sym_array_type = 246,
  sym_integral_type = 247,
  sym_floating_point_type = 248,
  sym__method_header = 249,
  sym__method_declarator = 250,
  sym_formal_parameters = 251,
  sym_formal_parameter = 252,
  sym_receiver_parameter = 253,
  sym_spread_parameter = 254,
  sym_throws = 255,
  sym_local_variable_declaration = 256,
  sym_method_declaration = 257,
  aux_sym_program_repeat1 = 258,
  aux_sym_cast_expression_repeat1 = 259,
  aux_sym_inferred_parameters_repeat1 = 260,
  aux_sym_array_creation_expression_repeat1 = 261,
  aux_sym_dimensions_expr_repeat1 = 262,
  aux_sym_argument_list_repeat1 = 263,
  aux_sym_type_arguments_repeat1 = 264,
  aux_sym_dimensions_repeat1 = 265,
  aux_sym_switch_block_repeat1 = 266,
  aux_sym_switch_block_repeat2 = 267,
  aux_sym_switch_block_statement_group_repeat1 = 268,
  aux_sym_try_statement_repeat1 = 269,
  aux_sym_catch_type_repeat1 = 270,
  aux_sym_resource_specification_repeat1 = 271,
  aux_sym_for_statement_repeat1 = 272,
  aux_sym_for_statement_repeat2 = 273,
  aux_sym_annotation_argument_list_repeat1 = 274,
  aux_sym_element_value_array_initializer_repeat1 = 275,
  aux_sym_module_body_repeat1 = 276,
  aux_sym_requires_module_directive_repeat1 = 277,
  aux_sym_exports_module_directive_repeat1 = 278,
  aux_sym_provides_module_directive_repeat1 = 279,
  aux_sym_enum_body_repeat1 = 280,
  aux_sym_enum_body_declarations_repeat1 = 281,
  aux_sym_modifiers_repeat1 = 282,
  aux_sym_type_parameters_repeat1 = 283,
  aux_sym_type_bound_repeat1 = 284,
  aux_sym_type_list_repeat1 = 285,
  aux_sym_annotation_type_body_repeat1 = 286,
  aux_sym_interface_body_repeat1 = 287,
  aux_sym__variable_declarator_list_repeat1 = 288,
  aux_sym_array_initializer_repeat1 = 289,
  aux_sym_formal_parameters_repeat1 = 290,
  alias_sym_type_identifier = 291,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_decimal_integer_literal] = "decimal_integer_literal",
  [sym_hex_integer_literal] = "hex_integer_literal",
  [sym_octal_integer_literal] = "octal_integer_literal",
  [sym_binary_integer_literal] = "binary_integer_literal",
  [sym_decimal_floating_point_literal] = "decimal_floating_point_literal",
  [sym_hex_floating_point_literal] = "hex_floating_point_literal",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_text_block] = "text_block",
  [sym_null_literal] = "null_literal",
  [anon_sym_LPAREN] = "(",
  [anon_sym_AMP] = "&",
  [anon_sym_RPAREN] = ")",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_COMMA] = ",",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COLON] = ":",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_extends] = "extends",
  [anon_sym_switch] = "switch",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_SEMI] = ";",
  [anon_sym_assert] = "assert",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_synchronized] = "synchronized",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_AT] = "@",
  [anon_sym_open] = "open",
  [anon_sym_module] = "module",
  [anon_sym_requires] = "requires",
  [anon_sym_transitive] = "transitive",
  [anon_sym_static] = "static",
  [anon_sym_exports] = "exports",
  [anon_sym_to] = "to",
  [anon_sym_opens] = "opens",
  [anon_sym_uses] = "uses",
  [anon_sym_provides] = "provides",
  [anon_sym_with] = "with",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_enum] = "enum",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_private] = "private",
  [anon_sym_abstract] = "abstract",
  [anon_sym_final] = "final",
  [anon_sym_strictfp] = "strictfp",
  [anon_sym_native] = "native",
  [anon_sym_transient] = "transient",
  [anon_sym_volatile] = "volatile",
  [anon_sym_sealed] = "sealed",
  [anon_sym_non_DASHsealed] = "non-sealed",
  [anon_sym_implements] = "implements",
  [anon_sym_permits] = "permits",
  [anon_sym_record] = "record",
  [anon_sym_ATinterface] = "@interface",
  [anon_sym_interface] = "interface",
  [anon_sym_byte] = "byte",
  [anon_sym_short] = "short",
  [anon_sym_int] = "int",
  [anon_sym_long] = "long",
  [anon_sym_char] = "char",
  [anon_sym_float] = "float",
  [anon_sym_double] = "double",
  [sym_boolean_type] = "boolean_type",
  [sym_void_type] = "void_type",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_throws] = "throws",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_line_comment] = "line_comment",
  [sym_block_comment] = "block_comment",
  [sym_program] = "program",
  [sym__literal] = "_literal",
  [sym_expression] = "expression",
  [sym_cast_expression] = "cast_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_instanceof_expression] = "instanceof_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_inferred_parameters] = "inferred_parameters",
  [sym_ternary_expression] = "ternary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_primary_expression] = "primary_expression",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_dimensions_expr] = "dimensions_expr",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_class_literal] = "class_literal",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym__unqualified_object_creation_expression] = "_unqualified_object_creation_expression",
  [sym_field_access] = "field_access",
  [sym_array_access] = "array_access",
  [sym_method_invocation] = "method_invocation",
  [sym_argument_list] = "argument_list",
  [sym_method_reference] = "method_reference",
  [sym_type_arguments] = "type_arguments",
  [sym_wildcard] = "wildcard",
  [sym__wildcard_bounds] = "_wildcard_bounds",
  [sym_dimensions] = "dimensions",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_block] = "switch_block",
  [sym_switch_block_statement_group] = "switch_block_statement_group",
  [sym_switch_rule] = "switch_rule",
  [sym_switch_label] = "switch_label",
  [sym_statement] = "statement",
  [sym_block] = "block",
  [sym_expression_statement] = "expression_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_assert_statement] = "assert_statement",
  [sym_do_statement] = "do_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_return_statement] = "return_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_synchronized_statement] = "synchronized_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_formal_parameter] = "catch_formal_parameter",
  [sym_catch_type] = "catch_type",
  [sym_finally_clause] = "finally_clause",
  [sym_try_with_resources_statement] = "try_with_resources_statement",
  [sym_resource_specification] = "resource_specification",
  [sym_resource] = "resource",
  [sym_if_statement] = "if_statement",
  [sym_while_statement] = "while_statement",
  [sym_for_statement] = "for_statement",
  [sym_enhanced_for_statement] = "enhanced_for_statement",
  [sym__annotation] = "_annotation",
  [sym_marker_annotation] = "marker_annotation",
  [sym_annotation] = "annotation",
  [sym_annotation_argument_list] = "annotation_argument_list",
  [sym_element_value_pair] = "element_value_pair",
  [sym__element_value] = "_element_value",
  [sym_element_value_array_initializer] = "element_value_array_initializer",
  [sym_declaration] = "declaration",
  [sym_module_declaration] = "module_declaration",
  [sym_module_body] = "module_body",
  [sym_module_directive] = "module_directive",
  [sym_requires_module_directive] = "requires_module_directive",
  [sym_requires_modifier] = "requires_modifier",
  [sym_exports_module_directive] = "exports_module_directive",
  [sym_opens_module_directive] = "opens_module_directive",
  [sym_uses_module_directive] = "uses_module_directive",
  [sym_provides_module_directive] = "provides_module_directive",
  [sym_package_declaration] = "package_declaration",
  [sym_import_declaration] = "import_declaration",
  [sym_asterisk] = "asterisk",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_enum_body_declarations] = "enum_body_declarations",
  [sym_enum_constant] = "enum_constant",
  [sym_class_declaration] = "class_declaration",
  [sym_modifiers] = "modifiers",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_type_bound] = "type_bound",
  [sym_superclass] = "superclass",
  [sym_super_interfaces] = "super_interfaces",
  [sym_type_list] = "type_list",
  [sym_permits] = "permits",
  [sym_class_body] = "class_body",
  [sym_static_initializer] = "static_initializer",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym__constructor_declarator] = "_constructor_declarator",
  [sym_constructor_body] = "constructor_body",
  [sym_explicit_constructor_invocation] = "explicit_constructor_invocation",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_field_declaration] = "field_declaration",
  [sym_record_declaration] = "record_declaration",
  [sym_annotation_type_declaration] = "annotation_type_declaration",
  [sym_annotation_type_body] = "annotation_type_body",
  [sym_annotation_type_element_declaration] = "annotation_type_element_declaration",
  [sym__default_value] = "_default_value",
  [sym_interface_declaration] = "interface_declaration",
  [sym_extends_interfaces] = "extends_interfaces",
  [sym_interface_body] = "interface_body",
  [sym_constant_declaration] = "constant_declaration",
  [sym__variable_declarator_list] = "_variable_declarator_list",
  [sym_variable_declarator] = "variable_declarator",
  [sym__variable_declarator_id] = "_variable_declarator_id",
  [sym_array_initializer] = "array_initializer",
  [sym__type] = "_type",
  [sym__unannotated_type] = "_unannotated_type",
  [sym_annotated_type] = "annotated_type",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_generic_type] = "generic_type",
  [sym_array_type] = "array_type",
  [sym_integral_type] = "integral_type",
  [sym_floating_point_type] = "floating_point_type",
  [sym__method_header] = "_method_header",
  [sym__method_declarator] = "_method_declarator",
  [sym_formal_parameters] = "formal_parameters",
  [sym_formal_parameter] = "formal_parameter",
  [sym_receiver_parameter] = "receiver_parameter",
  [sym_spread_parameter] = "spread_parameter",
  [sym_throws] = "throws",
  [sym_local_variable_declaration] = "local_variable_declaration",
  [sym_method_declaration] = "method_declaration",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_cast_expression_repeat1] = "cast_expression_repeat1",
  [aux_sym_inferred_parameters_repeat1] = "inferred_parameters_repeat1",
  [aux_sym_array_creation_expression_repeat1] = "array_creation_expression_repeat1",
  [aux_sym_dimensions_expr_repeat1] = "dimensions_expr_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_dimensions_repeat1] = "dimensions_repeat1",
  [aux_sym_switch_block_repeat1] = "switch_block_repeat1",
  [aux_sym_switch_block_repeat2] = "switch_block_repeat2",
  [aux_sym_switch_block_statement_group_repeat1] = "switch_block_statement_group_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_catch_type_repeat1] = "catch_type_repeat1",
  [aux_sym_resource_specification_repeat1] = "resource_specification_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_for_statement_repeat2] = "for_statement_repeat2",
  [aux_sym_annotation_argument_list_repeat1] = "annotation_argument_list_repeat1",
  [aux_sym_element_value_array_initializer_repeat1] = "element_value_array_initializer_repeat1",
  [aux_sym_module_body_repeat1] = "module_body_repeat1",
  [aux_sym_requires_module_directive_repeat1] = "requires_module_directive_repeat1",
  [aux_sym_exports_module_directive_repeat1] = "exports_module_directive_repeat1",
  [aux_sym_provides_module_directive_repeat1] = "provides_module_directive_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_enum_body_declarations_repeat1] = "enum_body_declarations_repeat1",
  [aux_sym_modifiers_repeat1] = "modifiers_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_type_bound_repeat1] = "type_bound_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym_annotation_type_body_repeat1] = "annotation_type_body_repeat1",
  [aux_sym_interface_body_repeat1] = "interface_body_repeat1",
  [aux_sym__variable_declarator_list_repeat1] = "_variable_declarator_list_repeat1",
  [aux_sym_array_initializer_repeat1] = "array_initializer_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_decimal_integer_literal] = sym_decimal_integer_literal,
  [sym_hex_integer_literal] = sym_hex_integer_literal,
  [sym_octal_integer_literal] = sym_octal_integer_literal,
  [sym_binary_integer_literal] = sym_binary_integer_literal,
  [sym_decimal_floating_point_literal] = sym_decimal_floating_point_literal,
  [sym_hex_floating_point_literal] = sym_hex_floating_point_literal,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_text_block] = sym_text_block,
  [sym_null_literal] = sym_null_literal,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_synchronized] = anon_sym_synchronized,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_open] = anon_sym_open,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_transitive] = anon_sym_transitive,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_exports] = anon_sym_exports,
  [anon_sym_to] = anon_sym_to,
  [anon_sym_opens] = anon_sym_opens,
  [anon_sym_uses] = anon_sym_uses,
  [anon_sym_provides] = anon_sym_provides,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_strictfp] = anon_sym_strictfp,
  [anon_sym_native] = anon_sym_native,
  [anon_sym_transient] = anon_sym_transient,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_non_DASHsealed] = anon_sym_non_DASHsealed,
  [anon_sym_implements] = anon_sym_implements,
  [anon_sym_permits] = anon_sym_permits,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_ATinterface] = anon_sym_ATinterface,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_char] = anon_sym_char,
  [anon_sym_float] = anon_sym_float,
  [anon_sym_double] = anon_sym_double,
  [sym_boolean_type] = sym_boolean_type,
  [sym_void_type] = sym_void_type,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_throws] = anon_sym_throws,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_line_comment] = sym_line_comment,
  [sym_block_comment] = sym_block_comment,
  [sym_program] = sym_program,
  [sym__literal] = sym__literal,
  [sym_expression] = sym_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_instanceof_expression] = sym_instanceof_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_inferred_parameters] = sym_inferred_parameters,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_dimensions_expr] = sym_dimensions_expr,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_class_literal] = sym_class_literal,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym__unqualified_object_creation_expression] = sym__unqualified_object_creation_expression,
  [sym_field_access] = sym_field_access,
  [sym_array_access] = sym_array_access,
  [sym_method_invocation] = sym_method_invocation,
  [sym_argument_list] = sym_argument_list,
  [sym_method_reference] = sym_method_reference,
  [sym_type_arguments] = sym_type_arguments,
  [sym_wildcard] = sym_wildcard,
  [sym__wildcard_bounds] = sym__wildcard_bounds,
  [sym_dimensions] = sym_dimensions,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_block] = sym_switch_block,
  [sym_switch_block_statement_group] = sym_switch_block_statement_group,
  [sym_switch_rule] = sym_switch_rule,
  [sym_switch_label] = sym_switch_label,
  [sym_statement] = sym_statement,
  [sym_block] = sym_block,
  [sym_expression_statement] = sym_expression_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_assert_statement] = sym_assert_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_synchronized_statement] = sym_synchronized_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_formal_parameter] = sym_catch_formal_parameter,
  [sym_catch_type] = sym_catch_type,
  [sym_finally_clause] = sym_finally_clause,
  [sym_try_with_resources_statement] = sym_try_with_resources_statement,
  [sym_resource_specification] = sym_resource_specification,
  [sym_resource] = sym_resource,
  [sym_if_statement] = sym_if_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_enhanced_for_statement] = sym_enhanced_for_statement,
  [sym__annotation] = sym__annotation,
  [sym_marker_annotation] = sym_marker_annotation,
  [sym_annotation] = sym_annotation,
  [sym_annotation_argument_list] = sym_annotation_argument_list,
  [sym_element_value_pair] = sym_element_value_pair,
  [sym__element_value] = sym__element_value,
  [sym_element_value_array_initializer] = sym_element_value_array_initializer,
  [sym_declaration] = sym_declaration,
  [sym_module_declaration] = sym_module_declaration,
  [sym_module_body] = sym_module_body,
  [sym_module_directive] = sym_module_directive,
  [sym_requires_module_directive] = sym_requires_module_directive,
  [sym_requires_modifier] = sym_requires_modifier,
  [sym_exports_module_directive] = sym_exports_module_directive,
  [sym_opens_module_directive] = sym_opens_module_directive,
  [sym_uses_module_directive] = sym_uses_module_directive,
  [sym_provides_module_directive] = sym_provides_module_directive,
  [sym_package_declaration] = sym_package_declaration,
  [sym_import_declaration] = sym_import_declaration,
  [sym_asterisk] = sym_asterisk,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_body_declarations] = sym_enum_body_declarations,
  [sym_enum_constant] = sym_enum_constant,
  [sym_class_declaration] = sym_class_declaration,
  [sym_modifiers] = sym_modifiers,
  [sym_type_parameters] = sym_type_parameters,
  [sym_type_parameter] = sym_type_parameter,
  [sym_type_bound] = sym_type_bound,
  [sym_superclass] = sym_superclass,
  [sym_super_interfaces] = sym_super_interfaces,
  [sym_type_list] = sym_type_list,
  [sym_permits] = sym_permits,
  [sym_class_body] = sym_class_body,
  [sym_static_initializer] = sym_static_initializer,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym__constructor_declarator] = sym__constructor_declarator,
  [sym_constructor_body] = sym_constructor_body,
  [sym_explicit_constructor_invocation] = sym_explicit_constructor_invocation,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_field_declaration] = sym_field_declaration,
  [sym_record_declaration] = sym_record_declaration,
  [sym_annotation_type_declaration] = sym_annotation_type_declaration,
  [sym_annotation_type_body] = sym_annotation_type_body,
  [sym_annotation_type_element_declaration] = sym_annotation_type_element_declaration,
  [sym__default_value] = sym__default_value,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_extends_interfaces] = sym_extends_interfaces,
  [sym_interface_body] = sym_interface_body,
  [sym_constant_declaration] = sym_constant_declaration,
  [sym__variable_declarator_list] = sym__variable_declarator_list,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym__variable_declarator_id] = sym__variable_declarator_id,
  [sym_array_initializer] = sym_array_initializer,
  [sym__type] = sym__type,
  [sym__unannotated_type] = sym__unannotated_type,
  [sym_annotated_type] = sym_annotated_type,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_generic_type] = sym_generic_type,
  [sym_array_type] = sym_array_type,
  [sym_integral_type] = sym_integral_type,
  [sym_floating_point_type] = sym_floating_point_type,
  [sym__method_header] = sym__method_header,
  [sym__method_declarator] = sym__method_declarator,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_formal_parameter] = sym_formal_parameter,
  [sym_receiver_parameter] = sym_receiver_parameter,
  [sym_spread_parameter] = sym_spread_parameter,
  [sym_throws] = sym_throws,
  [sym_local_variable_declaration] = sym_local_variable_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_cast_expression_repeat1] = aux_sym_cast_expression_repeat1,
  [aux_sym_inferred_parameters_repeat1] = aux_sym_inferred_parameters_repeat1,
  [aux_sym_array_creation_expression_repeat1] = aux_sym_array_creation_expression_repeat1,
  [aux_sym_dimensions_expr_repeat1] = aux_sym_dimensions_expr_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_dimensions_repeat1] = aux_sym_dimensions_repeat1,
  [aux_sym_switch_block_repeat1] = aux_sym_switch_block_repeat1,
  [aux_sym_switch_block_repeat2] = aux_sym_switch_block_repeat2,
  [aux_sym_switch_block_statement_group_repeat1] = aux_sym_switch_block_statement_group_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_catch_type_repeat1] = aux_sym_catch_type_repeat1,
  [aux_sym_resource_specification_repeat1] = aux_sym_resource_specification_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_for_statement_repeat2] = aux_sym_for_statement_repeat2,
  [aux_sym_annotation_argument_list_repeat1] = aux_sym_annotation_argument_list_repeat1,
  [aux_sym_element_value_array_initializer_repeat1] = aux_sym_element_value_array_initializer_repeat1,
  [aux_sym_module_body_repeat1] = aux_sym_module_body_repeat1,
  [aux_sym_requires_module_directive_repeat1] = aux_sym_requires_module_directive_repeat1,
  [aux_sym_exports_module_directive_repeat1] = aux_sym_exports_module_directive_repeat1,
  [aux_sym_provides_module_directive_repeat1] = aux_sym_provides_module_directive_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_enum_body_declarations_repeat1] = aux_sym_enum_body_declarations_repeat1,
  [aux_sym_modifiers_repeat1] = aux_sym_modifiers_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_type_bound_repeat1] = aux_sym_type_bound_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym_annotation_type_body_repeat1] = aux_sym_annotation_type_body_repeat1,
  [aux_sym_interface_body_repeat1] = aux_sym_interface_body_repeat1,
  [aux_sym__variable_declarator_list_repeat1] = aux_sym__variable_declarator_list_repeat1,
  [aux_sym_array_initializer_repeat1] = aux_sym_array_initializer_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_floating_point_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_text_block] = {
    .visible = true,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_synchronized] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_open] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exports] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_to] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_opens] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uses] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_provides] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_strictfp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_native] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transient] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_non_DASHsealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_permits] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATinterface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_float] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_double] = {
    .visible = true,
    .named = false,
  },
  [sym_boolean_type] = {
    .visible = true,
    .named = true,
  },
  [sym_void_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throws] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_instanceof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_inferred_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dimensions_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__unqualified_object_creation_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym_array_access] = {
    .visible = true,
    .named = true,
  },
  [sym_method_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_method_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym__wildcard_bounds] = {
    .visible = false,
    .named = true,
  },
  [sym_dimensions] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_block_statement_group] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_synchronized_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_type] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_try_with_resources_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_resource_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_resource] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_enhanced_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__annotation] = {
    .visible = false,
    .named = true,
  },
  [sym_marker_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_element_value_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__element_value] = {
    .visible = false,
    .named = true,
  },
  [sym_element_value_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module_body] = {
    .visible = true,
    .named = true,
  },
  [sym_module_directive] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_requires_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_exports_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_opens_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_uses_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_provides_module_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_package_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_asterisk] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_super_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_permits] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_static_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_body] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_constructor_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_body] = {
    .visible = true,
    .named = true,
  },
  [sym_annotation_type_element_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__default_value] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_extends_interfaces] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_body] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_list] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_declarator_id] = {
    .visible = false,
    .named = true,
  },
  [sym_array_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__unannotated_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_annotated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_integral_type] = {
    .visible = true,
    .named = true,
  },
  [sym_floating_point_type] = {
    .visible = true,
    .named = true,
  },
  [sym__method_header] = {
    .visible = false,
    .named = true,
  },
  [sym__method_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_receiver_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_spread_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_throws] = {
    .visible = true,
    .named = true,
  },
  [sym_local_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inferred_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimensions_expr_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dimensions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_block_statement_group_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_catch_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_resource_specification_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_element_value_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exports_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_provides_module_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_declarations_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_bound_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_annotation_type_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_declarator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alternative = 1,
  field_arguments = 2,
  field_array = 3,
  field_body = 4,
  field_condition = 5,
  field_consequence = 6,
  field_constructor = 7,
  field_declarator = 8,
  field_dimensions = 9,
  field_element = 10,
  field_field = 11,
  field_index = 12,
  field_init = 13,
  field_interfaces = 14,
  field_key = 15,
  field_left = 16,
  field_modifiers = 17,
  field_module = 18,
  field_modules = 19,
  field_name = 20,
  field_object = 21,
  field_operand = 22,
  field_operator = 23,
  field_package = 24,
  field_parameters = 25,
  field_permits = 26,
  field_provided = 27,
  field_provider = 28,
  field_resources = 29,
  field_right = 30,
  field_scope = 31,
  field_superclass = 32,
  field_type = 33,
  field_type_arguments = 34,
  field_type_parameters = 35,
  field_update = 36,
  field_value = 37,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_array] = "array",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declarator] = "declarator",
  [field_dimensions] = "dimensions",
  [field_element] = "element",
  [field_field] = "field",
  [field_index] = "index",
  [field_init] = "init",
  [field_interfaces] = "interfaces",
  [field_key] = "key",
  [field_left] = "left",
  [field_modifiers] = "modifiers",
  [field_module] = "module",
  [field_modules] = "modules",
  [field_name] = "name",
  [field_object] = "object",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_permits] = "permits",
  [field_provided] = "provided",
  [field_provider] = "provider",
  [field_resources] = "resources",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_superclass] = "superclass",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 3},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 6, .length = 2},
  [9] = {.index = 8, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 1},
  [13] = {.index = 12, .length = 2},
  [14] = {.index = 14, .length = 3},
  [15] = {.index = 17, .length = 2},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 17, .length = 2},
  [18] = {.index = 19, .length = 2},
  [19] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 2},
  [21] = {.index = 25, .length = 1},
  [22] = {.index = 26, .length = 1},
  [23] = {.index = 27, .length = 2},
  [24] = {.index = 29, .length = 2},
  [25] = {.index = 31, .length = 2},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 33, .length = 3},
  [28] = {.index = 21, .length = 2},
  [30] = {.index = 36, .length = 2},
  [31] = {.index = 36, .length = 2},
  [32] = {.index = 33, .length = 3},
  [33] = {.index = 38, .length = 2},
  [35] = {.index = 40, .length = 2},
  [36] = {.index = 42, .length = 3},
  [37] = {.index = 45, .length = 2},
  [38] = {.index = 45, .length = 2},
  [39] = {.index = 47, .length = 2},
  [40] = {.index = 49, .length = 2},
  [42] = {.index = 51, .length = 3},
  [43] = {.index = 54, .length = 1},
  [44] = {.index = 55, .length = 2},
  [45] = {.index = 57, .length = 2},
  [46] = {.index = 59, .length = 3},
  [47] = {.index = 62, .length = 3},
  [48] = {.index = 59, .length = 3},
  [49] = {.index = 62, .length = 3},
  [50] = {.index = 65, .length = 3},
  [51] = {.index = 65, .length = 3},
  [52] = {.index = 68, .length = 3},
  [53] = {.index = 71, .length = 3},
  [54] = {.index = 74, .length = 3},
  [55] = {.index = 77, .length = 3},
  [56] = {.index = 80, .length = 2},
  [57] = {.index = 80, .length = 2},
  [58] = {.index = 82, .length = 2},
  [59] = {.index = 82, .length = 2},
  [61] = {.index = 84, .length = 2},
  [62] = {.index = 86, .length = 3},
  [63] = {.index = 86, .length = 3},
  [65] = {.index = 89, .length = 2},
  [66] = {.index = 91, .length = 2},
  [67] = {.index = 93, .length = 1},
  [68] = {.index = 94, .length = 2},
  [69] = {.index = 96, .length = 3},
  [71] = {.index = 99, .length = 3},
  [73] = {.index = 102, .length = 2},
  [74] = {.index = 104, .length = 4},
  [75] = {.index = 108, .length = 4},
  [76] = {.index = 112, .length = 5},
  [77] = {.index = 117, .length = 6},
  [78] = {.index = 123, .length = 4},
  [79] = {.index = 127, .length = 4},
  [80] = {.index = 131, .length = 4},
  [81] = {.index = 135, .length = 4},
  [82] = {.index = 139, .length = 4},
  [83] = {.index = 143, .length = 4},
  [84] = {.index = 147, .length = 2},
  [85] = {.index = 149, .length = 3},
  [86] = {.index = 152, .length = 1},
  [87] = {.index = 153, .length = 2},
  [88] = {.index = 155, .length = 1},
  [89] = {.index = 156, .length = 2},
  [90] = {.index = 158, .length = 3},
  [91] = {.index = 161, .length = 3},
  [92] = {.index = 164, .length = 2},
  [93] = {.index = 164, .length = 2},
  [94] = {.index = 166, .length = 4},
  [95] = {.index = 166, .length = 4},
  [96] = {.index = 170, .length = 3},
  [97] = {.index = 173, .length = 3},
  [98] = {.index = 176, .length = 3},
  [99] = {.index = 179, .length = 3},
  [100] = {.index = 182, .length = 3},
  [101] = {.index = 185, .length = 2},
  [102] = {.index = 187, .length = 2},
  [103] = {.index = 187, .length = 2},
  [104] = {.index = 189, .length = 4},
  [105] = {.index = 193, .length = 5},
  [106] = {.index = 198, .length = 6},
  [107] = {.index = 204, .length = 3},
  [108] = {.index = 207, .length = 5},
  [109] = {.index = 212, .length = 4},
  [110] = {.index = 102, .length = 2},
  [111] = {.index = 216, .length = 5},
  [112] = {.index = 221, .length = 5},
  [113] = {.index = 226, .length = 5},
  [114] = {.index = 231, .length = 5},
  [115] = {.index = 236, .length = 4},
  [116] = {.index = 240, .length = 2},
  [117] = {.index = 242, .length = 1},
  [118] = {.index = 243, .length = 2},
  [119] = {.index = 245, .length = 2},
  [120] = {.index = 247, .length = 1},
  [121] = {.index = 247, .length = 1},
  [122] = {.index = 248, .length = 2},
  [123] = {.index = 250, .length = 1},
  [124] = {.index = 250, .length = 1},
  [125] = {.index = 54, .length = 1},
  [126] = {.index = 251, .length = 3},
  [127] = {.index = 254, .length = 4},
  [128] = {.index = 258, .length = 3},
  [129] = {.index = 258, .length = 3},
  [130] = {.index = 261, .length = 4},
  [131] = {.index = 265, .length = 4},
  [132] = {.index = 269, .length = 4},
  [133] = {.index = 273, .length = 4},
  [134] = {.index = 277, .length = 4},
  [135] = {.index = 281, .length = 4},
  [136] = {.index = 285, .length = 3},
  [137] = {.index = 288, .length = 3},
  [138] = {.index = 291, .length = 3},
  [139] = {.index = 294, .length = 4},
  [140] = {.index = 298, .length = 5},
  [141] = {.index = 303, .length = 3},
  [142] = {.index = 303, .length = 3},
  [143] = {.index = 306, .length = 6},
  [144] = {.index = 312, .length = 4},
  [145] = {.index = 316, .length = 1},
  [146] = {.index = 317, .length = 2},
  [147] = {.index = 319, .length = 2},
  [148] = {.index = 321, .length = 1},
  [149] = {.index = 322, .length = 2},
  [150] = {.index = 324, .length = 2},
  [151] = {.index = 326, .length = 2},
  [152] = {.index = 328, .length = 3},
  [153] = {.index = 331, .length = 3},
  [154] = {.index = 334, .length = 2},
  [155] = {.index = 334, .length = 2},
  [156] = {.index = 336, .length = 3},
  [157] = {.index = 339, .length = 4},
  [158] = {.index = 339, .length = 4},
  [159] = {.index = 343, .length = 5},
  [160] = {.index = 348, .length = 5},
  [161] = {.index = 353, .length = 5},
  [162] = {.index = 358, .length = 5},
  [163] = {.index = 363, .length = 4},
  [164] = {.index = 367, .length = 3},
  [165] = {.index = 370, .length = 2},
  [166] = {.index = 372, .length = 3},
  [167] = {.index = 375, .length = 3},
  [168] = {.index = 378, .length = 3},
  [169] = {.index = 381, .length = 3},
  [170] = {.index = 384, .length = 3},
  [171] = {.index = 387, .length = 5},
  [172] = {.index = 392, .length = 4},
  [173] = {.index = 396, .length = 4},
  [174] = {.index = 400, .length = 2},
  [175] = {.index = 400, .length = 2},
  [176] = {.index = 400, .length = 2},
  [177] = {.index = 400, .length = 2},
  [178] = {.index = 402, .length = 1},
  [179] = {.index = 402, .length = 1},
  [180] = {.index = 402, .length = 1},
  [181] = {.index = 402, .length = 1},
  [182] = {.index = 403, .length = 2},
  [183] = {.index = 405, .length = 6},
  [184] = {.index = 411, .length = 3},
  [185] = {.index = 414, .length = 4},
  [186] = {.index = 418, .length = 4},
  [187] = {.index = 422, .length = 4},
  [188] = {.index = 426, .length = 4},
  [189] = {.index = 430, .length = 4},
  [190] = {.index = 434, .length = 5},
  [191] = {.index = 439, .length = 5},
  [192] = {.index = 444, .length = 1},
  [193] = {.index = 444, .length = 1},
  [194] = {.index = 445, .length = 3},
  [195] = {.index = 448, .length = 2},
  [196] = {.index = 445, .length = 3},
  [197] = {.index = 445, .length = 3},
  [198] = {.index = 445, .length = 3},
  [199] = {.index = 450, .length = 1},
  [200] = {.index = 450, .length = 1},
  [201] = {.index = 451, .length = 2},
  [202] = {.index = 453, .length = 2},
  [203] = {.index = 451, .length = 2},
  [204] = {.index = 451, .length = 2},
  [205] = {.index = 451, .length = 2},
  [206] = {.index = 455, .length = 2},
  [207] = {.index = 457, .length = 1},
  [208] = {.index = 458, .length = 3},
  [209] = {.index = 461, .length = 3},
  [210] = {.index = 464, .length = 3},
  [211] = {.index = 467, .length = 5},
  [212] = {.index = 472, .length = 5},
  [213] = {.index = 477, .length = 5},
  [214] = {.index = 482, .length = 3},
  [215] = {.index = 485, .length = 3},
  [216] = {.index = 488, .length = 4},
  [217] = {.index = 492, .length = 4},
  [218] = {.index = 496, .length = 6},
  [219] = {.index = 502, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_arguments, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_arguments, 0, .inherited = true},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_name, 1},
  [6] =
    {field_arguments, 1},
    {field_name, 0},
  [8] =
    {field_name, 0},
  [9] =
    {field_dimensions, 1},
    {field_element, 0},
  [11] =
    {field_declarator, 0},
  [12] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [14] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
  [17] =
    {field_arguments, 2},
    {field_type, 1},
  [19] =
    {field_dimensions, 2},
    {field_type, 1},
  [21] =
    {field_body, 2},
    {field_name, 1},
  [23] =
    {field_body, 2},
    {field_condition, 1},
  [25] =
    {field_body, 2},
  [26] =
    {field_body, 1},
  [27] =
    {field_body, 2},
    {field_resources, 1},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_arguments, 2},
    {field_name, 1},
  [33] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [36] =
    {field_field, 2},
    {field_object, 0},
  [38] =
    {field_body, 2},
    {field_parameters, 0},
  [40] =
    {field_left, 0},
    {field_right, 2},
  [42] =
    {field_arguments, 2, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type_arguments, 2, .inherited = true},
  [45] =
    {field_dimensions, 1},
    {field_name, 0},
  [47] =
    {field_declarator, 1, .inherited = true},
    {field_type, 0},
  [49] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [51] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
  [54] =
    {field_type, 1},
  [55] =
    {field_type, 1},
    {field_value, 3},
  [57] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [59] =
    {field_dimensions, 2},
    {field_type, 1},
    {field_value, 3},
  [62] =
    {field_dimensions, 2},
    {field_dimensions, 3},
    {field_type, 1},
  [65] =
    {field_arguments, 3},
    {field_type, 2},
    {field_type_arguments, 1},
  [68] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [71] =
    {field_body, 3},
    {field_name, 1},
    {field_superclass, 2},
  [74] =
    {field_body, 3},
    {field_interfaces, 2},
    {field_name, 1},
  [77] =
    {field_body, 3},
    {field_name, 1},
    {field_permits, 2},
  [80] =
    {field_name, 2},
    {field_scope, 0},
  [82] =
    {field_body, 3},
    {field_name, 2},
  [84] =
    {field_body, 3},
    {field_name, 1},
  [86] =
    {field_arguments, 3},
    {field_name, 2},
    {field_object, 0},
  [89] =
    {field_array, 0},
    {field_index, 2},
  [91] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1},
  [93] =
    {field_declarator, 1},
  [94] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [96] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2},
  [99] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
    {field_value, 4},
  [102] =
    {field_name, 0},
    {field_parameters, 1},
  [104] =
    {field_body, 1},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [108] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 0},
  [112] =
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [117] =
    {field_body, 1},
    {field_dimensions, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [123] =
    {field_body, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [127] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [131] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
    {field_type_parameters, 2},
  [135] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 1},
    {field_superclass, 2},
  [139] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
    {field_superclass, 2},
  [143] =
    {field_body, 4},
    {field_interfaces, 2},
    {field_name, 1},
    {field_permits, 3},
  [147] =
    {field_body, 1},
    {field_condition, 3},
  [149] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [152] =
    {field_init, 1},
  [153] =
    {field_init, 0, .inherited = true},
    {field_init, 1, .inherited = true},
  [155] =
    {field_modifiers, 0},
  [156] =
    {field_body, 1},
    {field_name, 0},
  [158] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [161] =
    {field_body, 4},
    {field_name, 1},
    {field_permits, 3},
  [164] =
    {field_field, 4},
    {field_object, 0},
  [166] =
    {field_arguments, 4},
    {field_name, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [170] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [173] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [176] =
    {field_body, 4},
    {field_name, 2},
    {field_superclass, 3},
  [179] =
    {field_body, 4},
    {field_interfaces, 3},
    {field_name, 2},
  [182] =
    {field_body, 4},
    {field_name, 2},
    {field_permits, 3},
  [185] =
    {field_body, 4},
    {field_name, 2},
  [187] =
    {field_body, 4},
    {field_name, 3},
  [189] =
    {field_body, 2},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [193] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [198] =
    {field_body, 2},
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [204] =
    {field_name, 1},
    {field_parameters, 2},
    {field_type_parameters, 0},
  [207] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_parameters, 2, .inherited = true},
    {field_type, 1},
    {field_type_parameters, 0},
  [212] =
    {field_body, 2},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
    {field_type_parameters, 0, .inherited = true},
  [216] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 1},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [221] =
    {field_body, 5},
    {field_name, 1},
    {field_permits, 4},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [226] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 1},
    {field_permits, 4},
    {field_type_parameters, 2},
  [231] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 1},
    {field_permits, 4},
    {field_superclass, 2},
  [236] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
    {field_type, 0},
    {field_value, 3},
  [240] =
    {field_dimensions, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [242] =
    {field_body, 5},
  [243] =
    {field_body, 5},
    {field_init, 2},
  [245] =
    {field_key, 0},
    {field_value, 2},
  [247] =
    {field_module, 1},
  [248] =
    {field_modifiers, 0, .inherited = true},
    {field_modifiers, 1, .inherited = true},
  [250] =
    {field_package, 1},
  [251] =
    {field_arguments, 1},
    {field_body, 2},
    {field_name, 0},
  [254] =
    {field_body, 5},
    {field_name, 1},
    {field_permits, 4},
    {field_type_parameters, 2},
  [258] =
    {field_arguments, 5},
    {field_name, 4},
    {field_object, 0},
  [261] =
    {field_body, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [265] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [269] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
    {field_type_parameters, 3},
  [273] =
    {field_body, 5},
    {field_interfaces, 4},
    {field_name, 2},
    {field_superclass, 3},
  [277] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
    {field_superclass, 3},
  [281] =
    {field_body, 5},
    {field_interfaces, 3},
    {field_name, 2},
    {field_permits, 4},
  [285] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [288] =
    {field_body, 5},
    {field_name, 2},
    {field_permits, 4},
  [291] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [294] =
    {field_body, 3},
    {field_name, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
    {field_type_parameters, 1, .inherited = true},
  [298] =
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_parameters, 3, .inherited = true},
    {field_type, 2},
    {field_type_parameters, 0},
  [303] =
    {field_dimensions, 2},
    {field_name, 0},
    {field_parameters, 1},
  [306] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 1},
    {field_permits, 5},
    {field_superclass, 3},
    {field_type_parameters, 2},
  [312] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
    {field_type, 1},
    {field_value, 4},
  [316] =
    {field_body, 4},
  [317] =
    {field_dimensions, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [319] =
    {field_body, 6},
    {field_update, 4},
  [321] =
    {field_update, 1},
  [322] =
    {field_update, 0, .inherited = true},
    {field_update, 1, .inherited = true},
  [324] =
    {field_body, 6},
    {field_condition, 3},
  [326] =
    {field_body, 6},
    {field_init, 2},
  [328] =
    {field_body, 6},
    {field_init, 2},
    {field_update, 4},
  [331] =
    {field_body, 6},
    {field_condition, 3},
    {field_init, 2},
  [334] =
    {field_modifiers, 1, .inherited = true},
    {field_module, 2},
  [336] =
    {field_arguments, 2},
    {field_body, 3},
    {field_name, 1},
  [339] =
    {field_arguments, 6},
    {field_name, 5},
    {field_object, 0},
    {field_type_arguments, 4},
  [343] =
    {field_body, 6},
    {field_interfaces, 5},
    {field_name, 2},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [348] =
    {field_body, 6},
    {field_name, 2},
    {field_permits, 5},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [353] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 2},
    {field_permits, 5},
    {field_type_parameters, 3},
  [358] =
    {field_body, 6},
    {field_interfaces, 4},
    {field_name, 2},
    {field_permits, 5},
    {field_superclass, 3},
  [363] =
    {field_body, 6},
    {field_name, 2},
    {field_permits, 5},
    {field_type_parameters, 3},
  [367] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [370] =
    {field_arguments, 1},
    {field_constructor, 0},
  [372] =
    {field_body, 7},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [375] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [378] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 5},
  [381] =
    {field_body, 7},
    {field_condition, 4},
    {field_init, 2},
  [384] =
    {field_body, 7},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [387] =
    {field_body, 7},
    {field_dimensions, 3, .inherited = true},
    {field_name, 3, .inherited = true},
    {field_type, 2},
    {field_value, 5},
  [392] =
    {field_body, 7},
    {field_init, 2},
    {field_update, 4},
    {field_update, 5, .inherited = true},
  [396] =
    {field_body, 7},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
  [400] =
    {field_modules, 3},
    {field_package, 1},
  [402] =
    {field_provided, 1},
  [403] =
    {field_name, 1},
    {field_type, 0},
  [405] =
    {field_body, 7},
    {field_interfaces, 5},
    {field_name, 2},
    {field_permits, 6},
    {field_superclass, 4},
    {field_type_parameters, 3},
  [411] =
    {field_arguments, 2},
    {field_constructor, 1},
    {field_type_arguments, 0},
  [414] =
    {field_body, 8},
    {field_condition, 3},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [418] =
    {field_body, 8},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [422] =
    {field_body, 8},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
  [426] =
    {field_body, 8},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
  [430] =
    {field_body, 8},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
  [434] =
    {field_body, 8},
    {field_dimensions, 4, .inherited = true},
    {field_name, 4, .inherited = true},
    {field_type, 3},
    {field_value, 6},
  [439] =
    {field_body, 8},
    {field_condition, 3},
    {field_init, 2},
    {field_update, 5},
    {field_update, 6, .inherited = true},
  [444] =
    {field_modules, 1},
  [445] =
    {field_modules, 3},
    {field_modules, 4, .inherited = true},
    {field_package, 1},
  [448] =
    {field_modules, 0, .inherited = true},
    {field_modules, 1, .inherited = true},
  [450] =
    {field_provider, 1},
  [451] =
    {field_provided, 1},
    {field_provider, 4, .inherited = true},
  [453] =
    {field_provider, 0, .inherited = true},
    {field_provider, 1, .inherited = true},
  [455] =
    {field_name, 2},
    {field_type, 1},
  [457] =
    {field_value, 1},
  [458] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
  [461] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 4, .inherited = true},
  [464] =
    {field_arguments, 3},
    {field_constructor, 2},
    {field_object, 0},
  [467] =
    {field_body, 9},
    {field_condition, 4},
    {field_init, 2},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [472] =
    {field_body, 9},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 6},
    {field_update, 7, .inherited = true},
  [477] =
    {field_body, 9},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
  [482] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
  [485] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 5, .inherited = true},
  [488] =
    {field_dimensions, 4},
    {field_name, 1},
    {field_type, 0},
    {field_value, 5, .inherited = true},
  [492] =
    {field_arguments, 4},
    {field_constructor, 3},
    {field_object, 0},
    {field_type_arguments, 2},
  [496] =
    {field_body, 10},
    {field_condition, 5},
    {field_init, 2},
    {field_init, 3, .inherited = true},
    {field_update, 7},
    {field_update, 8, .inherited = true},
  [502] =
    {field_dimensions, 5},
    {field_name, 2},
    {field_type, 1},
    {field_value, 6, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_type_identifier,
  },
  [5] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = sym_identifier,
  },
  [9] = {
    [0] = sym_identifier,
  },
  [17] = {
    [1] = alias_sym_type_identifier,
  },
  [18] = {
    [1] = alias_sym_type_identifier,
  },
  [25] = {
    [1] = sym_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [28] = {
    [1] = sym_identifier,
  },
  [29] = {
    [1] = sym_identifier,
  },
  [30] = {
    [2] = sym_identifier,
  },
  [34] = {
    [0] = alias_sym_type_identifier,
    [2] = alias_sym_type_identifier,
  },
  [37] = {
    [0] = sym_identifier,
  },
  [41] = {
    [2] = alias_sym_type_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [51] = {
    [2] = alias_sym_type_identifier,
  },
  [56] = {
    [0] = sym_identifier,
  },
  [58] = {
    [2] = sym_identifier,
  },
  [60] = {
    [2] = sym_identifier,
  },
  [62] = {
    [2] = sym_identifier,
  },
  [64] = {
    [0] = alias_sym_type_identifier,
    [3] = alias_sym_type_identifier,
  },
  [70] = {
    [3] = alias_sym_type_identifier,
  },
  [72] = {
    [1] = alias_sym_type_identifier,
  },
  [92] = {
    [4] = sym_identifier,
  },
  [94] = {
    [3] = sym_identifier,
  },
  [102] = {
    [3] = sym_identifier,
  },
  [110] = {
    [0] = sym_identifier,
  },
  [120] = {
    [1] = sym_identifier,
  },
  [123] = {
    [1] = sym_identifier,
  },
  [125] = {
    [1] = sym_identifier,
  },
  [128] = {
    [4] = sym_identifier,
  },
  [141] = {
    [0] = sym_identifier,
  },
  [154] = {
    [2] = sym_identifier,
  },
  [157] = {
    [5] = sym_identifier,
  },
  [174] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [175] = {
    [1] = sym_identifier,
  },
  [176] = {
    [3] = sym_identifier,
  },
  [178] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [179] = {
    [1] = sym_identifier,
  },
  [180] = {
    [3] = sym_identifier,
  },
  [192] = {
    [1] = sym_identifier,
  },
  [194] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [196] = {
    [1] = sym_identifier,
  },
  [197] = {
    [3] = sym_identifier,
  },
  [199] = {
    [1] = sym_identifier,
  },
  [201] = {
    [1] = sym_identifier,
    [3] = sym_identifier,
  },
  [203] = {
    [1] = sym_identifier,
  },
  [204] = {
    [3] = sym_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= '$' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? c == '$'
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6400
    ? (c < 2979
      ? (c < 2365
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < '_'
                ? (c < '0'
                  ? c == '$'
                  : (c <= '9' || (c >= 'A' && c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c >= 'a' && c <= 'z')
                  : (c <= 170 || c == 181))))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1749
              ? (c < 1632
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1641 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1808
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1984 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2185
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : (c <= 2154 || (c >= 2160 && c <= 2183)))
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2534
            ? (c < 2474
              ? (c < 2417
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2406 && c <= 2415)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : (c <= 2448 || (c >= 2451 && c <= 2472)))))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2662
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : (c <= 2652 || c == 2654))
                : (c <= 2671 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2866
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2831
                ? (c < 2809
                  ? (c >= 2790 && c <= 2799)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2947
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2929
                  ? (c >= 2918 && c <= 2927)
                  : c <= 2929)))
              : (c <= 2947 || (c < 2969
                ? (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : (c <= 2960 || (c >= 2962 && c <= 2965)))
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 3872
        ? (c < 3406
          ? (c < 3205
            ? (c < 3114
              ? (c < 3046
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3055 || (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3200
                  ? (c >= 3174 && c <= 3183)
                  : c <= 3200)))))
            : (c <= 3212 || (c < 3296
              ? (c < 3253
                ? (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))
                : (c <= 3257 || (c < 3293
                  ? c == 3261
                  : c <= 3294)))
              : (c <= 3297 || (c < 3342
                ? (c < 3313
                  ? (c >= 3302 && c <= 3311)
                  : (c <= 3314 || (c >= 3332 && c <= 3340)))
                : (c <= 3344 || (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)))))))
          : (c <= 3406 || (c < 3664
            ? (c < 3507
              ? (c < 3450
                ? (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : (c <= 3425 || (c >= 3430 && c <= 3439)))
                : (c <= 3455 || (c < 3482
                  ? (c >= 3461 && c <= 3478)
                  : c <= 3505)))
              : (c <= 3515 || (c < 3585
                ? (c < 3520
                  ? c == 3517
                  : (c <= 3526 || (c >= 3558 && c <= 3567)))
                : (c <= 3632 || (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : c <= 3654)))))
            : (c <= 3673 || (c < 3762
              ? (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))
              : (c <= 3763 || (c < 3792
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3801 || (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)))))))))
        : (c <= 3881 || (c < 4802
          ? (c < 4295
            ? (c < 4193
              ? (c < 4096
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))
                : (c <= 4138 || (c < 4176
                  ? (c >= 4159 && c <= 4169)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))
              : (c <= 4193 || (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4256
                  ? (c >= 4240 && c <= 4249)
                  : c <= 4293)))))
            : (c <= 4295 || (c < 4698
              ? (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))
              : (c <= 4701 || (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))))))
          : (c <= 4805 || (c < 5919
            ? (c < 5112
              ? (c < 4888
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : (c <= 4880 || (c >= 4882 && c <= 4885)))
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))
              : (c <= 5117 || (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : c <= 5905)))))
            : (c <= 5937 || (c < 6112
              ? (c < 6016
                ? (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : (c <= 5996 || (c >= 5998 && c <= 6000)))
                : (c <= 6067 || (c < 6108
                  ? c == 6103
                  : c <= 6108)))
              : (c <= 6121 || (c < 6279
                ? (c < 6176
                  ? (c >= 6160 && c <= 6169)
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))))))))))))
    : (c <= 6430 || (c < 43216
      ? (c < 8490
        ? (c < 7968
          ? (c < 7086
            ? (c < 6784
              ? (c < 6576
                ? (c < 6512
                  ? (c >= 6470 && c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))
                : (c <= 6601 || (c < 6656
                  ? (c >= 6608 && c <= 6617)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6793 || (c < 6981
                ? (c < 6823
                  ? (c >= 6800 && c <= 6809)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7043
                  ? (c >= 6992 && c <= 7001)
                  : c <= 7072)))))
            : (c <= 7141 || (c < 7401
              ? (c < 7296
                ? (c < 7232
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7241 || (c >= 7245 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))
              : (c <= 7404 || (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))))))
          : (c <= 8005 || (c < 8160
            ? (c < 8064
              ? (c < 8027
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : (c <= 8023 || c == 8025))
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))
              : (c <= 8116 || (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))))
            : (c <= 8172 || (c < 8455
              ? (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))
              : (c <= 8455 || (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))))))))
        : (c <= 8493 || (c < 12449
          ? (c < 11680
            ? (c < 11506
              ? (c < 8526
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))
                : (c <= 8526 || (c < 11264
                  ? (c >= 8579 && c <= 8580)
                  : (c <= 11492 || (c >= 11499 && c <= 11502)))))
              : (c <= 11507 || (c < 11568
                ? (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : (c <= 11559 || c == 11565))
                : (c <= 11623 || (c < 11648
                  ? c == 11631
                  : c <= 11670)))))
            : (c <= 11686 || (c < 11736
              ? (c < 11712
                ? (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : (c <= 11702 || (c >= 11704 && c <= 11710)))
                : (c <= 11718 || (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : c <= 11734)))
              : (c <= 11742 || (c < 12347
                ? (c < 12293
                  ? c == 11823
                  : (c <= 12294 || (c >= 12337 && c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)))))))
          : (c <= 12538 || (c < 42623
            ? (c < 19903
              ? (c < 12704
                ? (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : (c <= 12591 || (c >= 12593 && c <= 12686)))
                : (c <= 12735 || (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : c <= 13312)))
              : (c <= 19903 || (c < 42240
                ? (c < 40959
                  ? c == 19968
                  : (c <= 42124 || (c >= 42192 && c <= 42237)))
                : (c <= 42508 || (c < 42560
                  ? (c >= 42512 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 42965
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42954 || (c < 42963
                  ? (c >= 42960 && c <= 42961)
                  : c <= 42963)))
              : (c <= 42969 || (c < 43020
                ? (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : (c <= 43013 || (c >= 43015 && c <= 43018)))
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))))))))))
      : (c <= 43225 || (c < 65296
        ? (c < 43808
          ? (c < 43616
            ? (c < 43471
              ? (c < 43264
                ? (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : (c <= 43259 || (c >= 43261 && c <= 43262)))
                : (c <= 43301 || (c < 43360
                  ? (c >= 43312 && c <= 43334)
                  : (c <= 43388 || (c >= 43396 && c <= 43442)))))
              : (c <= 43481 || (c < 43584
                ? (c < 43494
                  ? (c >= 43488 && c <= 43492)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43600
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43609)))))
            : (c <= 43638 || (c < 43714
              ? (c < 43701
                ? (c < 43646
                  ? c == 43642
                  : (c <= 43695 || c == 43697))
                : (c <= 43702 || (c < 43712
                  ? (c >= 43705 && c <= 43709)
                  : c <= 43712)))
              : (c <= 43714 || (c < 43777
                ? (c < 43744
                  ? (c >= 43739 && c <= 43741)
                  : (c <= 43754 || (c >= 43762 && c <= 43764)))
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64285
            ? (c < 55203
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 44032
                  ? (c >= 44016 && c <= 44025)
                  : c <= 44032)))
              : (c <= 55203 || (c < 64112
                ? (c < 55243
                  ? (c >= 55216 && c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64275
                  ? (c >= 64256 && c <= 64262)
                  : c <= 64279)))))
            : (c <= 64285 || (c < 64326
              ? (c < 64318
                ? (c < 64298
                  ? (c >= 64287 && c <= 64296)
                  : (c <= 64310 || (c >= 64312 && c <= 64316)))
                : (c <= 64318 || (c < 64323
                  ? (c >= 64320 && c <= 64321)
                  : c <= 64324)))
              : (c <= 64433 || (c < 65008
                ? (c < 64848
                  ? (c >= 64467 && c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65305 || (c < 66816
          ? (c < 65664
            ? (c < 65498
              ? (c < 65474
                ? (c < 65345
                  ? (c >= 65313 && c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : c <= 65495)))
              : (c <= 65500 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : c <= 65629)))))
            : (c <= 65786 || (c < 66432
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66368 || (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)))
              : (c <= 66461 || (c < 66720
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : (c <= 66511 || (c >= 66560 && c <= 66717)))
                : (c <= 66729 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67463
            ? (c < 66979
              ? (c < 66956
                ? (c < 66928
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))
                : (c <= 66962 || (c < 66967
                  ? (c >= 66964 && c <= 66965)
                  : c <= 66977)))
              : (c <= 66993 || (c < 67392
                ? (c < 67003
                  ? (c >= 66995 && c <= 67001)
                  : (c <= 67004 || (c >= 67072 && c <= 67382)))
                : (c <= 67413 || (c < 67456
                  ? (c >= 67424 && c <= 67431)
                  : c <= 67461)))))
            : (c <= 67504 || (c < 67647
              ? (c < 67594
                ? (c < 67584
                  ? (c >= 67506 && c <= 67514)
                  : (c <= 67589 || c == 67592))
                : (c <= 67637 || (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : c <= 67644)))
              : (c <= 67669 || (c < 67828
                ? (c < 67712
                  ? (c >= 67680 && c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(90);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(120);
      if (lookahead == '.') ADVANCE(153);
      if (lookahead == '/') ADVANCE(125);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '>') ADVANCE(106);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(127);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(1);
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(1);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(19);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(144);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(119);
      if (lookahead == '.') ADVANCE(51);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(105);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '&') ADVANCE(90);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(123);
      if (lookahead == '+') ADVANCE(118);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(120);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == '/') ADVANCE(125);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(109);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '>') ADVANCE(106);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(130);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(127);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(151);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(85);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead != 0) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(86);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(10);
      END_STATE();
    case 12:
      if (lookahead == '&') ADVANCE(88);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '.') ADVANCE(152);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(105);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(126);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 13:
      if (lookahead == '\'') ADVANCE(83);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(13);
      END_STATE();
    case 14:
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '.') ADVANCE(151);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 15:
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == '.') ADVANCE(151);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '@') ADVANCE(159);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(15)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(169);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(163);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '<') ADVANCE(108);
      if (lookahead == '@') ADVANCE(41);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(167);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 25:
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(13);
      END_STATE();
    case 26:
      if (lookahead == '_') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 28:
      if (lookahead == '_') ADVANCE(28);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 31:
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(42);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == 'c') ADVANCE(39);
      END_STATE();
    case 35:
      if (lookahead == 'd') ADVANCE(161);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(44);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 39:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 40:
      if (lookahead == 'f') ADVANCE(33);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 42:
      if (lookahead == 'l') ADVANCE(38);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(46);
      END_STATE();
    case 44:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(36);
      END_STATE();
    case 47:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 49:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(72);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(9);
      END_STATE();
    case 57:
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 58:
      if (lookahead != 0) ADVANCE(8);
      END_STATE();
    case 59:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(143);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == '[') ADVANCE(149);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 60:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(145);
      if (lookahead == '"') ADVANCE(7);
      if (lookahead == '%') ADVANCE(131);
      if (lookahead == '&') ADVANCE(89);
      if (lookahead == '\'') ADVANCE(25);
      if (lookahead == '(') ADVANCE(87);
      if (lookahead == ')') ADVANCE(91);
      if (lookahead == '*') ADVANCE(122);
      if (lookahead == '+') ADVANCE(117);
      if (lookahead == ',') ADVANCE(140);
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(51);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(63);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(158);
      if (lookahead == '<') ADVANCE(110);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(107);
      if (lookahead == '?') ADVANCE(141);
      if (lookahead == '@') ADVANCE(160);
      if (lookahead == ']') ADVANCE(150);
      if (lookahead == '^') ADVANCE(129);
      if (lookahead == 'n') ADVANCE(166);
      if (lookahead == '{') ADVANCE(156);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(157);
      if (lookahead == '~') ADVANCE(146);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(60)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(64);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(167);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(76);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(49);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(62);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(50);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(21);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_decimal_integer_literal);
      if (lookahead == '.') ADVANCE(76);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(62);
      if (lookahead == '_') ADVANCE(26);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_hex_integer_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (lookahead == '.') ADVANCE(82);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(65);
      if (lookahead == '_') ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(68);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_octal_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(69);
      if (lookahead == '_') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_binary_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(71);
      if (lookahead == '_') ADVANCE(49);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(27);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_decimal_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(47);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(31);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('D' <= lookahead && lookahead <= 'F') ||
          ('d' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      if (('A' <= lookahead && lookahead <= 'C') ||
          ('a' <= lookahead && lookahead <= 'c')) ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'd' ||
          lookahead == 'f') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(53);
      if (lookahead == '_') ADVANCE(55);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_hex_floating_point_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(81);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(78);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_character_literal);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_string_literal);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_string_literal);
      if (lookahead == '"') ADVANCE(2);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_text_block);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(115);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(135);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(136);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(134);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(133);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '=') ADVANCE(95);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(148);
      if (lookahead == '>') ADVANCE(139);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(168);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(99);
      if (lookahead == '|') ADVANCE(116);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(116);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(155);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(20);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(74);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == 'i') ADVANCE(43);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_non_DASHsealed);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_ATinterface);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(45);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(164);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(165);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_block_comment);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'p') ADVANCE(12);
      if (lookahead == 'r') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      if (lookahead == 't') ADVANCE(15);
      if (lookahead == 'u') ADVANCE(16);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == 'w') ADVANCE(18);
      if (lookahead == 'y') ADVANCE(19);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(22);
      if (lookahead == 'r') ADVANCE(23);
      if (lookahead == 'y') ADVANCE(24);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(25);
      if (lookahead == 'h') ADVANCE(26);
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'o') ADVANCE(28);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'n') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(33);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'i') ADVANCE(35);
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(38);
      if (lookahead == 'm') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(40);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'e') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      END_STATE();
    case 11:
      if (lookahead == 'p') ADVANCE(46);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'e') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      if (lookahead == 'u') ADVANCE(50);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(51);
      END_STATE();
    case 14:
      if (lookahead == 'e') ADVANCE(52);
      if (lookahead == 'h') ADVANCE(53);
      if (lookahead == 't') ADVANCE(54);
      if (lookahead == 'u') ADVANCE(55);
      if (lookahead == 'w') ADVANCE(56);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'h') ADVANCE(58);
      if (lookahead == 'o') ADVANCE(59);
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'o') ADVANCE(62);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(63);
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 19:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 20:
      if (lookahead == 's') ADVANCE(66);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 24:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 25:
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(73);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(74);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(75);
      END_STATE();
    case 29:
      if (lookahead == 'f') ADVANCE(76);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(78);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(79);
      END_STATE();
    case 33:
      if (lookahead == 'p') ADVANCE(80);
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(82);
      END_STATE();
    case 35:
      if (lookahead == 'n') ADVANCE(83);
      END_STATE();
    case 36:
      if (lookahead == 'o') ADVANCE(84);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(85);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 39:
      if (lookahead == 'p') ADVANCE(86);
      END_STATE();
    case 40:
      if (lookahead == 's') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(89);
      END_STATE();
    case 42:
      if (lookahead == 'd') ADVANCE(90);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 44:
      if (lookahead == 'w') ADVANCE(92);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 47:
      if (lookahead == 'c') ADVANCE(95);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 'o') ADVANCE(98);
      END_STATE();
    case 50:
      if (lookahead == 'b') ADVANCE(99);
      END_STATE();
    case 51:
      if (lookahead == 'c') ADVANCE(100);
      if (lookahead == 'q') ADVANCE(101);
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(103);
      END_STATE();
    case 53:
      if (lookahead == 'o') ADVANCE(104);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 55:
      if (lookahead == 'p') ADVANCE(107);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(108);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(110);
      if (lookahead == 'r') ADVANCE(111);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_to);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(112);
      if (lookahead == 'u') ADVANCE(113);
      if (lookahead == 'y') ADVANCE(114);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(116);
      if (lookahead == 'l') ADVANCE(117);
      END_STATE();
    case 63:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(120);
      END_STATE();
    case 66:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(123);
      END_STATE();
    case 69:
      if (lookahead == 'a') ADVANCE(124);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(125);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(127);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 74:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(130);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(131);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(132);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(133);
      END_STATE();
    case 79:
      if (lookahead == 'm') ADVANCE(134);
      END_STATE();
    case 80:
      if (lookahead == 'o') ADVANCE(135);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(139);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(141);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_int);
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 89:
      if (lookahead == 'g') ADVANCE(144);
      END_STATE();
    case 90:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(146);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(147);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(149);
      END_STATE();
    case 96:
      if (lookahead == 'm') ADVANCE(150);
      END_STATE();
    case 97:
      if (lookahead == 'v') ADVANCE(151);
      END_STATE();
    case 98:
      if (lookahead == 't') ADVANCE(152);
      if (lookahead == 'v') ADVANCE(153);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(154);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(155);
      END_STATE();
    case 101:
      if (lookahead == 'u') ADVANCE(156);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(157);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(158);
      END_STATE();
    case 104:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(160);
      END_STATE();
    case 106:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 109:
      if (lookahead == 'c') ADVANCE(164);
      END_STATE();
    case 110:
      if (lookahead == 's') ADVANCE(165);
      END_STATE();
    case 111:
      if (lookahead == 'o') ADVANCE(166);
      END_STATE();
    case 112:
      if (lookahead == 'n') ADVANCE(167);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(168);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 115:
      if (lookahead == 's') ADVANCE(169);
      END_STATE();
    case 116:
      if (lookahead == 'd') ADVANCE(170);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(171);
      END_STATE();
    case 118:
      if (lookahead == 'l') ADVANCE(172);
      END_STATE();
    case 119:
      if (lookahead == 'h') ADVANCE(173);
      END_STATE();
    case 120:
      if (lookahead == 'l') ADVANCE(174);
      END_STATE();
    case 121:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 122:
      if (lookahead == 'r') ADVANCE(176);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 124:
      if (lookahead == 'k') ADVANCE(178);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_byte);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(179);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 129:
      if (lookahead == 's') ADVANCE(180);
      END_STATE();
    case 130:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(182);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 135:
      if (lookahead == 'r') ADVANCE(184);
      END_STATE();
    case 136:
      if (lookahead == 'n') ADVANCE(185);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(186);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(187);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(189);
      END_STATE();
    case 141:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(191);
      END_STATE();
    case 143:
      if (lookahead == 'r') ADVANCE(192);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 145:
      if (lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 146:
      if (lookahead == 'v') ADVANCE(194);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_null_literal);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_open);
      if (lookahead == 's') ADVANCE(195);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(196);
      END_STATE();
    case 150:
      if (lookahead == 'i') ADVANCE(197);
      END_STATE();
    case 151:
      if (lookahead == 'a') ADVANCE(198);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(199);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(200);
      END_STATE();
    case 154:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 156:
      if (lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 157:
      if (lookahead == 'r') ADVANCE(204);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(205);
      END_STATE();
    case 159:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 161:
      if (lookahead == 'c') ADVANCE(208);
      END_STATE();
    case 162:
      if (lookahead == 'r') ADVANCE(209);
      END_STATE();
    case 163:
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 164:
      if (lookahead == 'h') ADVANCE(211);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 166:
      if (lookahead == 'w') ADVANCE(212);
      END_STATE();
    case 167:
      if (lookahead == 's') ADVANCE(213);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_uses);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_void_type);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 174:
      if (lookahead == 'd') ADVANCE(216);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(217);
      END_STATE();
    case 176:
      if (lookahead == 't') ADVANCE(218);
      END_STATE();
    case 177:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(220);
      END_STATE();
    case 182:
      if (lookahead == 'l') ADVANCE(221);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 184:
      if (lookahead == 't') ADVANCE(223);
      END_STATE();
    case 185:
      if (lookahead == 'd') ADVANCE(224);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_final);
      if (lookahead == 'l') ADVANCE(225);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_float);
      END_STATE();
    case 189:
      if (lookahead == 'm') ADVANCE(226);
      END_STATE();
    case 190:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 191:
      if (lookahead == 'n') ADVANCE(228);
      END_STATE();
    case 192:
      if (lookahead == 'f') ADVANCE(229);
      END_STATE();
    case 193:
      if (lookahead == 'e') ADVANCE(230);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_opens);
      END_STATE();
    case 196:
      if (lookahead == 'g') ADVANCE(232);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 198:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 199:
      if (lookahead == 'c') ADVANCE(235);
      END_STATE();
    case 200:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 201:
      if (lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 202:
      if (lookahead == 'd') ADVANCE(238);
      END_STATE();
    case 203:
      if (lookahead == 'r') ADVANCE(239);
      END_STATE();
    case 204:
      if (lookahead == 'n') ADVANCE(240);
      END_STATE();
    case 205:
      if (lookahead == 'd') ADVANCE(241);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 208:
      if (lookahead == 't') ADVANCE(243);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 210:
      if (lookahead == 'h') ADVANCE(244);
      END_STATE();
    case 211:
      if (lookahead == 'r') ADVANCE(245);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_throw);
      if (lookahead == 's') ADVANCE(246);
      END_STATE();
    case 213:
      if (lookahead == 'i') ADVANCE(247);
      END_STATE();
    case 214:
      if (lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 217:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(250);
      END_STATE();
    case 220:
      if (lookahead == 'u') ADVANCE(251);
      END_STATE();
    case 221:
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_double);
      END_STATE();
    case 223:
      if (lookahead == 's') ADVANCE(253);
      END_STATE();
    case 224:
      if (lookahead == 's') ADVANCE(254);
      END_STATE();
    case 225:
      if (lookahead == 'y') ADVANCE(255);
      END_STATE();
    case 226:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 228:
      if (lookahead == 'c') ADVANCE(257);
      END_STATE();
    case 229:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_native);
      END_STATE();
    case 232:
      if (lookahead == 'e') ADVANCE(259);
      END_STATE();
    case 233:
      if (lookahead == 's') ADVANCE(260);
      END_STATE();
    case 234:
      if (lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 235:
      if (lookahead == 't') ADVANCE(262);
      END_STATE();
    case 236:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 239:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 243:
      if (lookahead == 'f') ADVANCE(265);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 245:
      if (lookahead == 'o') ADVANCE(266);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_throws);
      END_STATE();
    case 247:
      if (lookahead == 'e') ADVANCE(267);
      if (lookahead == 't') ADVANCE(268);
      END_STATE();
    case 248:
      if (lookahead == 'l') ADVANCE(269);
      END_STATE();
    case 249:
      if (lookahead == 't') ADVANCE(270);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_boolean_type);
      END_STATE();
    case 251:
      if (lookahead == 'e') ADVANCE(271);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_exports);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 256:
      if (lookahead == 'n') ADVANCE(272);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 258:
      if (lookahead == 'c') ADVANCE(274);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_permits);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 263:
      if (lookahead == 's') ADVANCE(276);
      END_STATE();
    case 264:
      if (lookahead == 's') ADVANCE(277);
      END_STATE();
    case 265:
      if (lookahead == 'p') ADVANCE(278);
      END_STATE();
    case 266:
      if (lookahead == 'n') ADVANCE(279);
      END_STATE();
    case 267:
      if (lookahead == 'n') ADVANCE(280);
      END_STATE();
    case 268:
      if (lookahead == 'i') ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'e') ADVANCE(282);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 272:
      if (lookahead == 't') ADVANCE(283);
      END_STATE();
    case 273:
      if (lookahead == 'o') ADVANCE(284);
      END_STATE();
    case 274:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 275:
      if (lookahead == 'd') ADVANCE(286);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_provides);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_strictfp);
      END_STATE();
    case 279:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 280:
      if (lookahead == 't') ADVANCE(288);
      END_STATE();
    case 281:
      if (lookahead == 'v') ADVANCE(289);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 283:
      if (lookahead == 's') ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'f') ADVANCE(291);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 287:
      if (lookahead == 'z') ADVANCE(292);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_transient);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_transitive);
      END_STATE();
    case 294:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_synchronized);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 60},
  [2] = {.lex_state = 60},
  [3] = {.lex_state = 60},
  [4] = {.lex_state = 60},
  [5] = {.lex_state = 60},
  [6] = {.lex_state = 60},
  [7] = {.lex_state = 60},
  [8] = {.lex_state = 60},
  [9] = {.lex_state = 60},
  [10] = {.lex_state = 60},
  [11] = {.lex_state = 60},
  [12] = {.lex_state = 60},
  [13] = {.lex_state = 60},
  [14] = {.lex_state = 60},
  [15] = {.lex_state = 60},
  [16] = {.lex_state = 60},
  [17] = {.lex_state = 60},
  [18] = {.lex_state = 60},
  [19] = {.lex_state = 60},
  [20] = {.lex_state = 60},
  [21] = {.lex_state = 60},
  [22] = {.lex_state = 60},
  [23] = {.lex_state = 60},
  [24] = {.lex_state = 60},
  [25] = {.lex_state = 60},
  [26] = {.lex_state = 60},
  [27] = {.lex_state = 60},
  [28] = {.lex_state = 60},
  [29] = {.lex_state = 60},
  [30] = {.lex_state = 60},
  [31] = {.lex_state = 60},
  [32] = {.lex_state = 60},
  [33] = {.lex_state = 60},
  [34] = {.lex_state = 60},
  [35] = {.lex_state = 60},
  [36] = {.lex_state = 60},
  [37] = {.lex_state = 60},
  [38] = {.lex_state = 60},
  [39] = {.lex_state = 60},
  [40] = {.lex_state = 60},
  [41] = {.lex_state = 60},
  [42] = {.lex_state = 60},
  [43] = {.lex_state = 60},
  [44] = {.lex_state = 60},
  [45] = {.lex_state = 59},
  [46] = {.lex_state = 59},
  [47] = {.lex_state = 60},
  [48] = {.lex_state = 60},
  [49] = {.lex_state = 60},
  [50] = {.lex_state = 60},
  [51] = {.lex_state = 60},
  [52] = {.lex_state = 59},
  [53] = {.lex_state = 60},
  [54] = {.lex_state = 4},
  [55] = {.lex_state = 4},
  [56] = {.lex_state = 4},
  [57] = {.lex_state = 60},
  [58] = {.lex_state = 60},
  [59] = {.lex_state = 60},
  [60] = {.lex_state = 60},
  [61] = {.lex_state = 3},
  [62] = {.lex_state = 3},
  [63] = {.lex_state = 3},
  [64] = {.lex_state = 3},
  [65] = {.lex_state = 3},
  [66] = {.lex_state = 60},
  [67] = {.lex_state = 60},
  [68] = {.lex_state = 60},
  [69] = {.lex_state = 60},
  [70] = {.lex_state = 60},
  [71] = {.lex_state = 60},
  [72] = {.lex_state = 60},
  [73] = {.lex_state = 60},
  [74] = {.lex_state = 60},
  [75] = {.lex_state = 60},
  [76] = {.lex_state = 60},
  [77] = {.lex_state = 60},
  [78] = {.lex_state = 60},
  [79] = {.lex_state = 60},
  [80] = {.lex_state = 3},
  [81] = {.lex_state = 60},
  [82] = {.lex_state = 60},
  [83] = {.lex_state = 60},
  [84] = {.lex_state = 60},
  [85] = {.lex_state = 60},
  [86] = {.lex_state = 60},
  [87] = {.lex_state = 60},
  [88] = {.lex_state = 60},
  [89] = {.lex_state = 60},
  [90] = {.lex_state = 60},
  [91] = {.lex_state = 60},
  [92] = {.lex_state = 60},
  [93] = {.lex_state = 60},
  [94] = {.lex_state = 60},
  [95] = {.lex_state = 60},
  [96] = {.lex_state = 60},
  [97] = {.lex_state = 60},
  [98] = {.lex_state = 60},
  [99] = {.lex_state = 60},
  [100] = {.lex_state = 60},
  [101] = {.lex_state = 60},
  [102] = {.lex_state = 60},
  [103] = {.lex_state = 60},
  [104] = {.lex_state = 60},
  [105] = {.lex_state = 60},
  [106] = {.lex_state = 60},
  [107] = {.lex_state = 60},
  [108] = {.lex_state = 3},
  [109] = {.lex_state = 60},
  [110] = {.lex_state = 60},
  [111] = {.lex_state = 60},
  [112] = {.lex_state = 60},
  [113] = {.lex_state = 60},
  [114] = {.lex_state = 60},
  [115] = {.lex_state = 60},
  [116] = {.lex_state = 60},
  [117] = {.lex_state = 60},
  [118] = {.lex_state = 3},
  [119] = {.lex_state = 60},
  [120] = {.lex_state = 60},
  [121] = {.lex_state = 60},
  [122] = {.lex_state = 60},
  [123] = {.lex_state = 60},
  [124] = {.lex_state = 60},
  [125] = {.lex_state = 60},
  [126] = {.lex_state = 60},
  [127] = {.lex_state = 60},
  [128] = {.lex_state = 60},
  [129] = {.lex_state = 60},
  [130] = {.lex_state = 60},
  [131] = {.lex_state = 60},
  [132] = {.lex_state = 60},
  [133] = {.lex_state = 60},
  [134] = {.lex_state = 60},
  [135] = {.lex_state = 3},
  [136] = {.lex_state = 3},
  [137] = {.lex_state = 3},
  [138] = {.lex_state = 3},
  [139] = {.lex_state = 3},
  [140] = {.lex_state = 3},
  [141] = {.lex_state = 60},
  [142] = {.lex_state = 60},
  [143] = {.lex_state = 60},
  [144] = {.lex_state = 60},
  [145] = {.lex_state = 60},
  [146] = {.lex_state = 60},
  [147] = {.lex_state = 60},
  [148] = {.lex_state = 60},
  [149] = {.lex_state = 60},
  [150] = {.lex_state = 60},
  [151] = {.lex_state = 60},
  [152] = {.lex_state = 60},
  [153] = {.lex_state = 60},
  [154] = {.lex_state = 60},
  [155] = {.lex_state = 60},
  [156] = {.lex_state = 60},
  [157] = {.lex_state = 60},
  [158] = {.lex_state = 60},
  [159] = {.lex_state = 60},
  [160] = {.lex_state = 60},
  [161] = {.lex_state = 60},
  [162] = {.lex_state = 60},
  [163] = {.lex_state = 60},
  [164] = {.lex_state = 60},
  [165] = {.lex_state = 60},
  [166] = {.lex_state = 60},
  [167] = {.lex_state = 60},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 60},
  [170] = {.lex_state = 60},
  [171] = {.lex_state = 60},
  [172] = {.lex_state = 60},
  [173] = {.lex_state = 60},
  [174] = {.lex_state = 60},
  [175] = {.lex_state = 60},
  [176] = {.lex_state = 60},
  [177] = {.lex_state = 60},
  [178] = {.lex_state = 60},
  [179] = {.lex_state = 60},
  [180] = {.lex_state = 60},
  [181] = {.lex_state = 60},
  [182] = {.lex_state = 60},
  [183] = {.lex_state = 3},
  [184] = {.lex_state = 60},
  [185] = {.lex_state = 60},
  [186] = {.lex_state = 60},
  [187] = {.lex_state = 3},
  [188] = {.lex_state = 60},
  [189] = {.lex_state = 60},
  [190] = {.lex_state = 60},
  [191] = {.lex_state = 60},
  [192] = {.lex_state = 60},
  [193] = {.lex_state = 3},
  [194] = {.lex_state = 60},
  [195] = {.lex_state = 60},
  [196] = {.lex_state = 60},
  [197] = {.lex_state = 60},
  [198] = {.lex_state = 60},
  [199] = {.lex_state = 60},
  [200] = {.lex_state = 60},
  [201] = {.lex_state = 60},
  [202] = {.lex_state = 60},
  [203] = {.lex_state = 60},
  [204] = {.lex_state = 60},
  [205] = {.lex_state = 60},
  [206] = {.lex_state = 60},
  [207] = {.lex_state = 60},
  [208] = {.lex_state = 60},
  [209] = {.lex_state = 60},
  [210] = {.lex_state = 60},
  [211] = {.lex_state = 60},
  [212] = {.lex_state = 60},
  [213] = {.lex_state = 60},
  [214] = {.lex_state = 60},
  [215] = {.lex_state = 60},
  [216] = {.lex_state = 60},
  [217] = {.lex_state = 60},
  [218] = {.lex_state = 3},
  [219] = {.lex_state = 3},
  [220] = {.lex_state = 3},
  [221] = {.lex_state = 3},
  [222] = {.lex_state = 3},
  [223] = {.lex_state = 3},
  [224] = {.lex_state = 3},
  [225] = {.lex_state = 3},
  [226] = {.lex_state = 3},
  [227] = {.lex_state = 3},
  [228] = {.lex_state = 3},
  [229] = {.lex_state = 3},
  [230] = {.lex_state = 3},
  [231] = {.lex_state = 3},
  [232] = {.lex_state = 3},
  [233] = {.lex_state = 3},
  [234] = {.lex_state = 3},
  [235] = {.lex_state = 3},
  [236] = {.lex_state = 3},
  [237] = {.lex_state = 3},
  [238] = {.lex_state = 3},
  [239] = {.lex_state = 3},
  [240] = {.lex_state = 3},
  [241] = {.lex_state = 3},
  [242] = {.lex_state = 3},
  [243] = {.lex_state = 3},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 3},
  [246] = {.lex_state = 3},
  [247] = {.lex_state = 3},
  [248] = {.lex_state = 3},
  [249] = {.lex_state = 3},
  [250] = {.lex_state = 3},
  [251] = {.lex_state = 3},
  [252] = {.lex_state = 3},
  [253] = {.lex_state = 3},
  [254] = {.lex_state = 3},
  [255] = {.lex_state = 3},
  [256] = {.lex_state = 3},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 3},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 3},
  [261] = {.lex_state = 3},
  [262] = {.lex_state = 3},
  [263] = {.lex_state = 3},
  [264] = {.lex_state = 3},
  [265] = {.lex_state = 3},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 3},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 3},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 60},
  [273] = {.lex_state = 3},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 3},
  [276] = {.lex_state = 3},
  [277] = {.lex_state = 3},
  [278] = {.lex_state = 3},
  [279] = {.lex_state = 3},
  [280] = {.lex_state = 3},
  [281] = {.lex_state = 3},
  [282] = {.lex_state = 3},
  [283] = {.lex_state = 3},
  [284] = {.lex_state = 3},
  [285] = {.lex_state = 3},
  [286] = {.lex_state = 3},
  [287] = {.lex_state = 3},
  [288] = {.lex_state = 3},
  [289] = {.lex_state = 3},
  [290] = {.lex_state = 3},
  [291] = {.lex_state = 4},
  [292] = {.lex_state = 60},
  [293] = {.lex_state = 60},
  [294] = {.lex_state = 4},
  [295] = {.lex_state = 60},
  [296] = {.lex_state = 60},
  [297] = {.lex_state = 4},
  [298] = {.lex_state = 4},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 0},
  [301] = {.lex_state = 0},
  [302] = {.lex_state = 0},
  [303] = {.lex_state = 0},
  [304] = {.lex_state = 0},
  [305] = {.lex_state = 5},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 0},
  [308] = {.lex_state = 5},
  [309] = {.lex_state = 5},
  [310] = {.lex_state = 5},
  [311] = {.lex_state = 5},
  [312] = {.lex_state = 5},
  [313] = {.lex_state = 5},
  [314] = {.lex_state = 5},
  [315] = {.lex_state = 0},
  [316] = {.lex_state = 0},
  [317] = {.lex_state = 0},
  [318] = {.lex_state = 5},
  [319] = {.lex_state = 5},
  [320] = {.lex_state = 5},
  [321] = {.lex_state = 5},
  [322] = {.lex_state = 5},
  [323] = {.lex_state = 5},
  [324] = {.lex_state = 5},
  [325] = {.lex_state = 5},
  [326] = {.lex_state = 6},
  [327] = {.lex_state = 6},
  [328] = {.lex_state = 5},
  [329] = {.lex_state = 5},
  [330] = {.lex_state = 14},
  [331] = {.lex_state = 14},
  [332] = {.lex_state = 4},
  [333] = {.lex_state = 6},
  [334] = {.lex_state = 6},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 6},
  [337] = {.lex_state = 3},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 3},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 14},
  [342] = {.lex_state = 14},
  [343] = {.lex_state = 3},
  [344] = {.lex_state = 3},
  [345] = {.lex_state = 6},
  [346] = {.lex_state = 6},
  [347] = {.lex_state = 6},
  [348] = {.lex_state = 0},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 0},
  [351] = {.lex_state = 0},
  [352] = {.lex_state = 0},
  [353] = {.lex_state = 0},
  [354] = {.lex_state = 0},
  [355] = {.lex_state = 0},
  [356] = {.lex_state = 0},
  [357] = {.lex_state = 0},
  [358] = {.lex_state = 0},
  [359] = {.lex_state = 6},
  [360] = {.lex_state = 0},
  [361] = {.lex_state = 0},
  [362] = {.lex_state = 6},
  [363] = {.lex_state = 6},
  [364] = {.lex_state = 0},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 6},
  [367] = {.lex_state = 6},
  [368] = {.lex_state = 6},
  [369] = {.lex_state = 0},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 6},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 6},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 6},
  [381] = {.lex_state = 6},
  [382] = {.lex_state = 6},
  [383] = {.lex_state = 6},
  [384] = {.lex_state = 6},
  [385] = {.lex_state = 6},
  [386] = {.lex_state = 6},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 6},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 6},
  [391] = {.lex_state = 6},
  [392] = {.lex_state = 6},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 6},
  [395] = {.lex_state = 6},
  [396] = {.lex_state = 6},
  [397] = {.lex_state = 6},
  [398] = {.lex_state = 6},
  [399] = {.lex_state = 6},
  [400] = {.lex_state = 6},
  [401] = {.lex_state = 6},
  [402] = {.lex_state = 6},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 6},
  [405] = {.lex_state = 6},
  [406] = {.lex_state = 6},
  [407] = {.lex_state = 6},
  [408] = {.lex_state = 6},
  [409] = {.lex_state = 6},
  [410] = {.lex_state = 6},
  [411] = {.lex_state = 6},
  [412] = {.lex_state = 6},
  [413] = {.lex_state = 6},
  [414] = {.lex_state = 6},
  [415] = {.lex_state = 6},
  [416] = {.lex_state = 6},
  [417] = {.lex_state = 6},
  [418] = {.lex_state = 6},
  [419] = {.lex_state = 6},
  [420] = {.lex_state = 6},
  [421] = {.lex_state = 0},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 3},
  [426] = {.lex_state = 3},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 3},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 3},
  [431] = {.lex_state = 3},
  [432] = {.lex_state = 3},
  [433] = {.lex_state = 3},
  [434] = {.lex_state = 12},
  [435] = {.lex_state = 3},
  [436] = {.lex_state = 12},
  [437] = {.lex_state = 3},
  [438] = {.lex_state = 3},
  [439] = {.lex_state = 3},
  [440] = {.lex_state = 3},
  [441] = {.lex_state = 3},
  [442] = {.lex_state = 12},
  [443] = {.lex_state = 3},
  [444] = {.lex_state = 3},
  [445] = {.lex_state = 3},
  [446] = {.lex_state = 3},
  [447] = {.lex_state = 4},
  [448] = {.lex_state = 3},
  [449] = {.lex_state = 6},
  [450] = {.lex_state = 3},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 3},
  [453] = {.lex_state = 3},
  [454] = {.lex_state = 3},
  [455] = {.lex_state = 3},
  [456] = {.lex_state = 3},
  [457] = {.lex_state = 3},
  [458] = {.lex_state = 15},
  [459] = {.lex_state = 15},
  [460] = {.lex_state = 3},
  [461] = {.lex_state = 4},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 3},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 15},
  [471] = {.lex_state = 15},
  [472] = {.lex_state = 6},
  [473] = {.lex_state = 12},
  [474] = {.lex_state = 3},
  [475] = {.lex_state = 3},
  [476] = {.lex_state = 12},
  [477] = {.lex_state = 4},
  [478] = {.lex_state = 4},
  [479] = {.lex_state = 3},
  [480] = {.lex_state = 3},
  [481] = {.lex_state = 3},
  [482] = {.lex_state = 3},
  [483] = {.lex_state = 3},
  [484] = {.lex_state = 3},
  [485] = {.lex_state = 3},
  [486] = {.lex_state = 3},
  [487] = {.lex_state = 3},
  [488] = {.lex_state = 3},
  [489] = {.lex_state = 3},
  [490] = {.lex_state = 3},
  [491] = {.lex_state = 3},
  [492] = {.lex_state = 4},
  [493] = {.lex_state = 4},
  [494] = {.lex_state = 3},
  [495] = {.lex_state = 3},
  [496] = {.lex_state = 3},
  [497] = {.lex_state = 3},
  [498] = {.lex_state = 12},
  [499] = {.lex_state = 3},
  [500] = {.lex_state = 4},
  [501] = {.lex_state = 3},
  [502] = {.lex_state = 12},
  [503] = {.lex_state = 4},
  [504] = {.lex_state = 3},
  [505] = {.lex_state = 4},
  [506] = {.lex_state = 3},
  [507] = {.lex_state = 4},
  [508] = {.lex_state = 3},
  [509] = {.lex_state = 3},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 4},
  [512] = {.lex_state = 3},
  [513] = {.lex_state = 3},
  [514] = {.lex_state = 3},
  [515] = {.lex_state = 4},
  [516] = {.lex_state = 3},
  [517] = {.lex_state = 3},
  [518] = {.lex_state = 3},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 22},
  [521] = {.lex_state = 3},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 3},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 4},
  [527] = {.lex_state = 4},
  [528] = {.lex_state = 4},
  [529] = {.lex_state = 3},
  [530] = {.lex_state = 3},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 3},
  [533] = {.lex_state = 3},
  [534] = {.lex_state = 3},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 3},
  [539] = {.lex_state = 3},
  [540] = {.lex_state = 3},
  [541] = {.lex_state = 3},
  [542] = {.lex_state = 3},
  [543] = {.lex_state = 3},
  [544] = {.lex_state = 3},
  [545] = {.lex_state = 3},
  [546] = {.lex_state = 3},
  [547] = {.lex_state = 3},
  [548] = {.lex_state = 3},
  [549] = {.lex_state = 3},
  [550] = {.lex_state = 3},
  [551] = {.lex_state = 3},
  [552] = {.lex_state = 22},
  [553] = {.lex_state = 3},
  [554] = {.lex_state = 3},
  [555] = {.lex_state = 3},
  [556] = {.lex_state = 3},
  [557] = {.lex_state = 3},
  [558] = {.lex_state = 3},
  [559] = {.lex_state = 4},
  [560] = {.lex_state = 12},
  [561] = {.lex_state = 5},
  [562] = {.lex_state = 5},
  [563] = {.lex_state = 12},
  [564] = {.lex_state = 3},
  [565] = {.lex_state = 5},
  [566] = {.lex_state = 5},
  [567] = {.lex_state = 3},
  [568] = {.lex_state = 3},
  [569] = {.lex_state = 3},
  [570] = {.lex_state = 3},
  [571] = {.lex_state = 3},
  [572] = {.lex_state = 3},
  [573] = {.lex_state = 3},
  [574] = {.lex_state = 12},
  [575] = {.lex_state = 12},
  [576] = {.lex_state = 12},
  [577] = {.lex_state = 12},
  [578] = {.lex_state = 22},
  [579] = {.lex_state = 12},
  [580] = {.lex_state = 12},
  [581] = {.lex_state = 3},
  [582] = {.lex_state = 3},
  [583] = {.lex_state = 3},
  [584] = {.lex_state = 12},
  [585] = {.lex_state = 3},
  [586] = {.lex_state = 12},
  [587] = {.lex_state = 12},
  [588] = {.lex_state = 3},
  [589] = {.lex_state = 22},
  [590] = {.lex_state = 3},
  [591] = {.lex_state = 12},
  [592] = {.lex_state = 5},
  [593] = {.lex_state = 12},
  [594] = {.lex_state = 12},
  [595] = {.lex_state = 12},
  [596] = {.lex_state = 12},
  [597] = {.lex_state = 3},
  [598] = {.lex_state = 5},
  [599] = {.lex_state = 3},
  [600] = {.lex_state = 3},
  [601] = {.lex_state = 3},
  [602] = {.lex_state = 12},
  [603] = {.lex_state = 5},
  [604] = {.lex_state = 3},
  [605] = {.lex_state = 3},
  [606] = {.lex_state = 3},
  [607] = {.lex_state = 3},
  [608] = {.lex_state = 3},
  [609] = {.lex_state = 3},
  [610] = {.lex_state = 3},
  [611] = {.lex_state = 5},
  [612] = {.lex_state = 3},
  [613] = {.lex_state = 3},
  [614] = {.lex_state = 3},
  [615] = {.lex_state = 3},
  [616] = {.lex_state = 5},
  [617] = {.lex_state = 5},
  [618] = {.lex_state = 5},
  [619] = {.lex_state = 3},
  [620] = {.lex_state = 5},
  [621] = {.lex_state = 3},
  [622] = {.lex_state = 3},
  [623] = {.lex_state = 3},
  [624] = {.lex_state = 3},
  [625] = {.lex_state = 3},
  [626] = {.lex_state = 5},
  [627] = {.lex_state = 3},
  [628] = {.lex_state = 3},
  [629] = {.lex_state = 5},
  [630] = {.lex_state = 3},
  [631] = {.lex_state = 5},
  [632] = {.lex_state = 3},
  [633] = {.lex_state = 3},
  [634] = {.lex_state = 4},
  [635] = {.lex_state = 4},
  [636] = {.lex_state = 3},
  [637] = {.lex_state = 5},
  [638] = {.lex_state = 4},
  [639] = {.lex_state = 4},
  [640] = {.lex_state = 3},
  [641] = {.lex_state = 5},
  [642] = {.lex_state = 4},
  [643] = {.lex_state = 3},
  [644] = {.lex_state = 4},
  [645] = {.lex_state = 4},
  [646] = {.lex_state = 3},
  [647] = {.lex_state = 3},
  [648] = {.lex_state = 4},
  [649] = {.lex_state = 3},
  [650] = {.lex_state = 5},
  [651] = {.lex_state = 3},
  [652] = {.lex_state = 5},
  [653] = {.lex_state = 3},
  [654] = {.lex_state = 3},
  [655] = {.lex_state = 3},
  [656] = {.lex_state = 5},
  [657] = {.lex_state = 5},
  [658] = {.lex_state = 3},
  [659] = {.lex_state = 5},
  [660] = {.lex_state = 5},
  [661] = {.lex_state = 3},
  [662] = {.lex_state = 3},
  [663] = {.lex_state = 3},
  [664] = {.lex_state = 3},
  [665] = {.lex_state = 3},
  [666] = {.lex_state = 12},
  [667] = {.lex_state = 3},
  [668] = {.lex_state = 3},
  [669] = {.lex_state = 3},
  [670] = {.lex_state = 3},
  [671] = {.lex_state = 3},
  [672] = {.lex_state = 3},
  [673] = {.lex_state = 3},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 3},
  [676] = {.lex_state = 3},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 3},
  [679] = {.lex_state = 3},
  [680] = {.lex_state = 3},
  [681] = {.lex_state = 3},
  [682] = {.lex_state = 3},
  [683] = {.lex_state = 3},
  [684] = {.lex_state = 3},
  [685] = {.lex_state = 3},
  [686] = {.lex_state = 3},
  [687] = {.lex_state = 3},
  [688] = {.lex_state = 3},
  [689] = {.lex_state = 3},
  [690] = {.lex_state = 3},
  [691] = {.lex_state = 4},
  [692] = {.lex_state = 3},
  [693] = {.lex_state = 3},
  [694] = {.lex_state = 3},
  [695] = {.lex_state = 3},
  [696] = {.lex_state = 3},
  [697] = {.lex_state = 3},
  [698] = {.lex_state = 3},
  [699] = {.lex_state = 3},
  [700] = {.lex_state = 3},
  [701] = {.lex_state = 3},
  [702] = {.lex_state = 4},
  [703] = {.lex_state = 3},
  [704] = {.lex_state = 3},
  [705] = {.lex_state = 3},
  [706] = {.lex_state = 3},
  [707] = {.lex_state = 3},
  [708] = {.lex_state = 3},
  [709] = {.lex_state = 3},
  [710] = {.lex_state = 3},
  [711] = {.lex_state = 3},
  [712] = {.lex_state = 3},
  [713] = {.lex_state = 3},
  [714] = {.lex_state = 3},
  [715] = {.lex_state = 3},
  [716] = {.lex_state = 3},
  [717] = {.lex_state = 3},
  [718] = {.lex_state = 3},
  [719] = {.lex_state = 4},
  [720] = {.lex_state = 3},
  [721] = {.lex_state = 4},
  [722] = {.lex_state = 3},
  [723] = {.lex_state = 3},
  [724] = {.lex_state = 3},
  [725] = {.lex_state = 3},
  [726] = {.lex_state = 3},
  [727] = {.lex_state = 4},
  [728] = {.lex_state = 3},
  [729] = {.lex_state = 3},
  [730] = {.lex_state = 3},
  [731] = {.lex_state = 3},
  [732] = {.lex_state = 3},
  [733] = {.lex_state = 3},
  [734] = {.lex_state = 4},
  [735] = {.lex_state = 3},
  [736] = {.lex_state = 3},
  [737] = {.lex_state = 3},
  [738] = {.lex_state = 3},
  [739] = {.lex_state = 3},
  [740] = {.lex_state = 3},
  [741] = {.lex_state = 3},
  [742] = {.lex_state = 3},
  [743] = {.lex_state = 3},
  [744] = {.lex_state = 3},
  [745] = {.lex_state = 3},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 5},
  [748] = {.lex_state = 5},
  [749] = {.lex_state = 3},
  [750] = {.lex_state = 3},
  [751] = {.lex_state = 12},
  [752] = {.lex_state = 5},
  [753] = {.lex_state = 5},
  [754] = {.lex_state = 3},
  [755] = {.lex_state = 3},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 3},
  [758] = {.lex_state = 3},
  [759] = {.lex_state = 3},
  [760] = {.lex_state = 5},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 3},
  [763] = {.lex_state = 5},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 12},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 3},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 3},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 3},
  [772] = {.lex_state = 3},
  [773] = {.lex_state = 3},
  [774] = {.lex_state = 3},
  [775] = {.lex_state = 3},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 3},
  [778] = {.lex_state = 3},
  [779] = {.lex_state = 3},
  [780] = {.lex_state = 3},
  [781] = {.lex_state = 4},
  [782] = {.lex_state = 3},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 3},
  [785] = {.lex_state = 3},
  [786] = {.lex_state = 3},
  [787] = {.lex_state = 3},
  [788] = {.lex_state = 3},
  [789] = {.lex_state = 3},
  [790] = {.lex_state = 3},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 3},
  [793] = {.lex_state = 3},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 3},
  [796] = {.lex_state = 3},
  [797] = {.lex_state = 3},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 3},
  [800] = {.lex_state = 5},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 3},
  [803] = {.lex_state = 3},
  [804] = {.lex_state = 5},
  [805] = {.lex_state = 5},
  [806] = {.lex_state = 3},
  [807] = {.lex_state = 3},
  [808] = {.lex_state = 5},
  [809] = {.lex_state = 5},
  [810] = {.lex_state = 5},
  [811] = {.lex_state = 5},
  [812] = {.lex_state = 5},
  [813] = {.lex_state = 5},
  [814] = {.lex_state = 3},
  [815] = {.lex_state = 4},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 5},
  [818] = {.lex_state = 5},
  [819] = {.lex_state = 12},
  [820] = {.lex_state = 0},
  [821] = {.lex_state = 3},
  [822] = {.lex_state = 3},
  [823] = {.lex_state = 3},
  [824] = {.lex_state = 3},
  [825] = {.lex_state = 3},
  [826] = {.lex_state = 3},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 3},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 5},
  [831] = {.lex_state = 3},
  [832] = {.lex_state = 3},
  [833] = {.lex_state = 12},
  [834] = {.lex_state = 3},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 3},
  [837] = {.lex_state = 4},
  [838] = {.lex_state = 3},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 3},
  [841] = {.lex_state = 3},
  [842] = {.lex_state = 3},
  [843] = {.lex_state = 3},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 3},
  [847] = {.lex_state = 0},
  [848] = {.lex_state = 3},
  [849] = {.lex_state = 5},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 4},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 0},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 5},
  [861] = {.lex_state = 4},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 5},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 3},
  [866] = {.lex_state = 3},
  [867] = {.lex_state = 0},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 5},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 5},
  [875] = {.lex_state = 5},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 3},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 5},
  [882] = {.lex_state = 3},
  [883] = {.lex_state = 0},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 3},
  [888] = {.lex_state = 3},
  [889] = {.lex_state = 4},
  [890] = {.lex_state = 3},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 5},
  [893] = {.lex_state = 5},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 4},
  [897] = {.lex_state = 4},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 5},
  [901] = {.lex_state = 0},
  [902] = {.lex_state = 5},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 5},
  [905] = {.lex_state = 5},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 5},
  [912] = {.lex_state = 0},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 5},
  [915] = {.lex_state = 5},
  [916] = {.lex_state = 5},
  [917] = {.lex_state = 3},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 3},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 4},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 4},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 3},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 4},
  [936] = {.lex_state = 3},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 5},
  [945] = {.lex_state = 5},
  [946] = {.lex_state = 4},
  [947] = {.lex_state = 3},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 5},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 3},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 3},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 3},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 5},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 4},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 4},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 4},
  [993] = {.lex_state = 4},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 3},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 5},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 5},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 5},
  [1008] = {.lex_state = 5},
  [1009] = {.lex_state = 5},
  [1010] = {.lex_state = 5},
  [1011] = {.lex_state = 5},
  [1012] = {.lex_state = 5},
  [1013] = {.lex_state = 5},
  [1014] = {.lex_state = 5},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 3},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 3},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 5},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 4},
  [1033] = {.lex_state = 3},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 3},
  [1037] = {.lex_state = 3},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 4},
  [1042] = {.lex_state = 4},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 5},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 5},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 5},
  [1052] = {.lex_state = 5},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 5},
  [1061] = {.lex_state = 5},
  [1062] = {.lex_state = 3},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 3},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 5},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 3},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 3},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 3},
  [1088] = {.lex_state = 3},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 5},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 3},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 3},
  [1101] = {.lex_state = 3},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 3},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 3},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 3},
  [1120] = {.lex_state = 3},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 3},
  [1131] = {.lex_state = 3},
  [1132] = {.lex_state = 3},
  [1133] = {.lex_state = 3},
  [1134] = {.lex_state = 3},
  [1135] = {.lex_state = 3},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 3},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 3},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 3},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 3},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_decimal_integer_literal] = ACTIONS(1),
    [sym_hex_integer_literal] = ACTIONS(1),
    [sym_octal_integer_literal] = ACTIONS(1),
    [sym_binary_integer_literal] = ACTIONS(1),
    [sym_decimal_floating_point_literal] = ACTIONS(1),
    [sym_hex_floating_point_literal] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_character_literal] = ACTIONS(1),
    [sym_string_literal] = ACTIONS(1),
    [sym_text_block] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_synchronized] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_open] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_transitive] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_exports] = ACTIONS(1),
    [anon_sym_to] = ACTIONS(1),
    [anon_sym_opens] = ACTIONS(1),
    [anon_sym_uses] = ACTIONS(1),
    [anon_sym_provides] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_strictfp] = ACTIONS(1),
    [anon_sym_native] = ACTIONS(1),
    [anon_sym_transient] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_non_DASHsealed] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_permits] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_ATinterface] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_float] = ACTIONS(1),
    [anon_sym_double] = ACTIONS(1),
    [sym_boolean_type] = ACTIONS(1),
    [sym_void_type] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_throws] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(1075),
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(9),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(472),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_type_arguments] = STATE(1033),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(6),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_explicit_constructor_invocation] = STATE(7),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(85),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(89),
    [sym_super] = ACTIONS(91),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_switch_label] = STATE(1084),
    [sym_statement] = STATE(5),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(5),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_switch_block_statement_group_repeat1] = STATE(165),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(93),
    [anon_sym_case] = ACTIONS(95),
    [anon_sym_default] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [ts_builtin_sym_end] = ACTIONS(97),
    [sym_identifier] = ACTIONS(99),
    [sym_decimal_integer_literal] = ACTIONS(102),
    [sym_hex_integer_literal] = ACTIONS(102),
    [sym_octal_integer_literal] = ACTIONS(105),
    [sym_binary_integer_literal] = ACTIONS(105),
    [sym_decimal_floating_point_literal] = ACTIONS(105),
    [sym_hex_floating_point_literal] = ACTIONS(102),
    [sym_true] = ACTIONS(102),
    [sym_false] = ACTIONS(102),
    [sym_character_literal] = ACTIONS(105),
    [sym_string_literal] = ACTIONS(102),
    [sym_text_block] = ACTIONS(105),
    [sym_null_literal] = ACTIONS(102),
    [anon_sym_LPAREN] = ACTIONS(108),
    [anon_sym_PLUS] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(114),
    [anon_sym_PLUS_PLUS] = ACTIONS(117),
    [anon_sym_DASH_DASH] = ACTIONS(117),
    [anon_sym_new] = ACTIONS(120),
    [anon_sym_class] = ACTIONS(123),
    [anon_sym_switch] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(129),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_case] = ACTIONS(132),
    [anon_sym_default] = ACTIONS(134),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_assert] = ACTIONS(140),
    [anon_sym_do] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(146),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_continue] = ACTIONS(152),
    [anon_sym_return] = ACTIONS(155),
    [anon_sym_yield] = ACTIONS(158),
    [anon_sym_synchronized] = ACTIONS(161),
    [anon_sym_throw] = ACTIONS(164),
    [anon_sym_try] = ACTIONS(167),
    [anon_sym_if] = ACTIONS(170),
    [anon_sym_for] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(176),
    [anon_sym_open] = ACTIONS(179),
    [anon_sym_module] = ACTIONS(182),
    [anon_sym_static] = ACTIONS(134),
    [anon_sym_package] = ACTIONS(185),
    [anon_sym_import] = ACTIONS(188),
    [anon_sym_enum] = ACTIONS(191),
    [anon_sym_public] = ACTIONS(134),
    [anon_sym_protected] = ACTIONS(134),
    [anon_sym_private] = ACTIONS(134),
    [anon_sym_abstract] = ACTIONS(134),
    [anon_sym_final] = ACTIONS(134),
    [anon_sym_strictfp] = ACTIONS(134),
    [anon_sym_native] = ACTIONS(134),
    [anon_sym_transient] = ACTIONS(134),
    [anon_sym_volatile] = ACTIONS(134),
    [anon_sym_sealed] = ACTIONS(134),
    [anon_sym_non_DASHsealed] = ACTIONS(194),
    [anon_sym_ATinterface] = ACTIONS(197),
    [anon_sym_interface] = ACTIONS(200),
    [anon_sym_byte] = ACTIONS(203),
    [anon_sym_short] = ACTIONS(203),
    [anon_sym_int] = ACTIONS(203),
    [anon_sym_long] = ACTIONS(203),
    [anon_sym_char] = ACTIONS(203),
    [anon_sym_float] = ACTIONS(206),
    [anon_sym_double] = ACTIONS(206),
    [sym_boolean_type] = ACTIONS(209),
    [sym_void_type] = ACTIONS(209),
    [sym_this] = ACTIONS(212),
    [sym_super] = ACTIONS(215),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(218),
    [anon_sym_case] = ACTIONS(220),
    [anon_sym_default] = ACTIONS(220),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(10),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(10),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(224),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [ts_builtin_sym_end] = ACTIONS(226),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(228),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(8),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(8),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(230),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(4),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(4),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(232),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(12),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(150),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(159),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(195),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(1081),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(197),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(198),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(158),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(189),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(199),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(151),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(155),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(192),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(160),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(180),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(185),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(186),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(148),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(202),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(149),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [33] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(154),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [34] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(156),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [35] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(200),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [36] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(161),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [37] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(205),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [38] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(162),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [39] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(203),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [40] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(215),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [41] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(157),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [42] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(196),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [43] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(153),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [44] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(53),
    [sym_statement] = STATE(164),
    [sym_block] = STATE(178),
    [sym_expression_statement] = STATE(178),
    [sym_labeled_statement] = STATE(178),
    [sym_assert_statement] = STATE(178),
    [sym_do_statement] = STATE(178),
    [sym_break_statement] = STATE(178),
    [sym_continue_statement] = STATE(178),
    [sym_return_statement] = STATE(178),
    [sym_yield_statement] = STATE(178),
    [sym_synchronized_statement] = STATE(178),
    [sym_throw_statement] = STATE(178),
    [sym_try_statement] = STATE(178),
    [sym_try_with_resources_statement] = STATE(178),
    [sym_if_statement] = STATE(178),
    [sym_while_statement] = STATE(178),
    [sym_for_statement] = STATE(178),
    [sym_enhanced_for_statement] = STATE(178),
    [sym__annotation] = STATE(427),
    [sym_marker_annotation] = STATE(427),
    [sym_annotation] = STATE(427),
    [sym_declaration] = STATE(178),
    [sym_module_declaration] = STATE(201),
    [sym_package_declaration] = STATE(201),
    [sym_import_declaration] = STATE(201),
    [sym_enum_declaration] = STATE(201),
    [sym_class_declaration] = STATE(201),
    [sym_modifiers] = STATE(578),
    [sym_annotation_type_declaration] = STATE(201),
    [sym_interface_declaration] = STATE(201),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(598),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(178),
    [aux_sym_dimensions_expr_repeat1] = STATE(537),
    [aux_sym_modifiers_repeat1] = STATE(348),
    [sym_identifier] = ACTIONS(7),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_class] = ACTIONS(23),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_default] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(31),
    [anon_sym_assert] = ACTIONS(33),
    [anon_sym_do] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_return] = ACTIONS(43),
    [anon_sym_yield] = ACTIONS(45),
    [anon_sym_synchronized] = ACTIONS(47),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_try] = ACTIONS(51),
    [anon_sym_if] = ACTIONS(53),
    [anon_sym_for] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(57),
    [anon_sym_open] = ACTIONS(59),
    [anon_sym_module] = ACTIONS(61),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_package] = ACTIONS(63),
    [anon_sym_import] = ACTIONS(65),
    [anon_sym_enum] = ACTIONS(67),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_final] = ACTIONS(29),
    [anon_sym_strictfp] = ACTIONS(29),
    [anon_sym_native] = ACTIONS(29),
    [anon_sym_transient] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_non_DASHsealed] = ACTIONS(69),
    [anon_sym_ATinterface] = ACTIONS(71),
    [anon_sym_interface] = ACTIONS(73),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(236),
    [sym_identifier] = ACTIONS(238),
    [sym_decimal_integer_literal] = ACTIONS(238),
    [sym_hex_integer_literal] = ACTIONS(238),
    [sym_octal_integer_literal] = ACTIONS(236),
    [sym_binary_integer_literal] = ACTIONS(236),
    [sym_decimal_floating_point_literal] = ACTIONS(236),
    [sym_hex_floating_point_literal] = ACTIONS(238),
    [sym_true] = ACTIONS(238),
    [sym_false] = ACTIONS(238),
    [sym_character_literal] = ACTIONS(236),
    [sym_string_literal] = ACTIONS(238),
    [sym_text_block] = ACTIONS(236),
    [sym_null_literal] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(236),
    [anon_sym_AMP] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(236),
    [anon_sym_GT] = ACTIONS(238),
    [anon_sym_LT] = ACTIONS(238),
    [anon_sym_GT_EQ] = ACTIONS(236),
    [anon_sym_LT_EQ] = ACTIONS(236),
    [anon_sym_EQ_EQ] = ACTIONS(236),
    [anon_sym_BANG_EQ] = ACTIONS(236),
    [anon_sym_AMP_AMP] = ACTIONS(236),
    [anon_sym_PIPE_PIPE] = ACTIONS(236),
    [anon_sym_PLUS] = ACTIONS(238),
    [anon_sym_DASH] = ACTIONS(238),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_SLASH] = ACTIONS(238),
    [anon_sym_PIPE] = ACTIONS(238),
    [anon_sym_CARET] = ACTIONS(236),
    [anon_sym_PERCENT] = ACTIONS(236),
    [anon_sym_LT_LT] = ACTIONS(236),
    [anon_sym_GT_GT] = ACTIONS(238),
    [anon_sym_GT_GT_GT] = ACTIONS(236),
    [anon_sym_instanceof] = ACTIONS(238),
    [anon_sym_DASH_GT] = ACTIONS(236),
    [anon_sym_COMMA] = ACTIONS(236),
    [anon_sym_QMARK] = ACTIONS(236),
    [anon_sym_COLON] = ACTIONS(238),
    [anon_sym_BANG] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(236),
    [anon_sym_PLUS_PLUS] = ACTIONS(236),
    [anon_sym_DASH_DASH] = ACTIONS(236),
    [anon_sym_new] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_RBRACK] = ACTIONS(236),
    [anon_sym_DOT] = ACTIONS(238),
    [anon_sym_class] = ACTIONS(238),
    [anon_sym_COLON_COLON] = ACTIONS(236),
    [anon_sym_switch] = ACTIONS(238),
    [anon_sym_LBRACE] = ACTIONS(236),
    [anon_sym_RBRACE] = ACTIONS(236),
    [anon_sym_case] = ACTIONS(238),
    [anon_sym_default] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(236),
    [anon_sym_assert] = ACTIONS(238),
    [anon_sym_do] = ACTIONS(238),
    [anon_sym_while] = ACTIONS(238),
    [anon_sym_break] = ACTIONS(238),
    [anon_sym_continue] = ACTIONS(238),
    [anon_sym_return] = ACTIONS(238),
    [anon_sym_yield] = ACTIONS(238),
    [anon_sym_synchronized] = ACTIONS(238),
    [anon_sym_throw] = ACTIONS(238),
    [anon_sym_try] = ACTIONS(238),
    [anon_sym_if] = ACTIONS(238),
    [anon_sym_else] = ACTIONS(238),
    [anon_sym_for] = ACTIONS(238),
    [anon_sym_AT] = ACTIONS(238),
    [anon_sym_open] = ACTIONS(238),
    [anon_sym_module] = ACTIONS(238),
    [anon_sym_static] = ACTIONS(238),
    [anon_sym_package] = ACTIONS(238),
    [anon_sym_import] = ACTIONS(238),
    [anon_sym_enum] = ACTIONS(238),
    [anon_sym_public] = ACTIONS(238),
    [anon_sym_protected] = ACTIONS(238),
    [anon_sym_private] = ACTIONS(238),
    [anon_sym_abstract] = ACTIONS(238),
    [anon_sym_final] = ACTIONS(238),
    [anon_sym_strictfp] = ACTIONS(238),
    [anon_sym_native] = ACTIONS(238),
    [anon_sym_transient] = ACTIONS(238),
    [anon_sym_volatile] = ACTIONS(238),
    [anon_sym_sealed] = ACTIONS(238),
    [anon_sym_non_DASHsealed] = ACTIONS(236),
    [anon_sym_record] = ACTIONS(238),
    [anon_sym_ATinterface] = ACTIONS(236),
    [anon_sym_interface] = ACTIONS(238),
    [anon_sym_byte] = ACTIONS(238),
    [anon_sym_short] = ACTIONS(238),
    [anon_sym_int] = ACTIONS(238),
    [anon_sym_long] = ACTIONS(238),
    [anon_sym_char] = ACTIONS(238),
    [anon_sym_float] = ACTIONS(238),
    [anon_sym_double] = ACTIONS(238),
    [sym_boolean_type] = ACTIONS(238),
    [sym_void_type] = ACTIONS(238),
    [sym_this] = ACTIONS(238),
    [sym_super] = ACTIONS(238),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(240),
    [sym_identifier] = ACTIONS(242),
    [sym_decimal_integer_literal] = ACTIONS(242),
    [sym_hex_integer_literal] = ACTIONS(242),
    [sym_octal_integer_literal] = ACTIONS(240),
    [sym_binary_integer_literal] = ACTIONS(240),
    [sym_decimal_floating_point_literal] = ACTIONS(240),
    [sym_hex_floating_point_literal] = ACTIONS(242),
    [sym_true] = ACTIONS(242),
    [sym_false] = ACTIONS(242),
    [sym_character_literal] = ACTIONS(240),
    [sym_string_literal] = ACTIONS(242),
    [sym_text_block] = ACTIONS(240),
    [sym_null_literal] = ACTIONS(242),
    [anon_sym_LPAREN] = ACTIONS(240),
    [anon_sym_AMP] = ACTIONS(242),
    [anon_sym_RPAREN] = ACTIONS(240),
    [anon_sym_GT] = ACTIONS(242),
    [anon_sym_LT] = ACTIONS(242),
    [anon_sym_GT_EQ] = ACTIONS(240),
    [anon_sym_LT_EQ] = ACTIONS(240),
    [anon_sym_EQ_EQ] = ACTIONS(240),
    [anon_sym_BANG_EQ] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(240),
    [anon_sym_PIPE_PIPE] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_SLASH] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(240),
    [anon_sym_PERCENT] = ACTIONS(240),
    [anon_sym_LT_LT] = ACTIONS(240),
    [anon_sym_GT_GT] = ACTIONS(242),
    [anon_sym_GT_GT_GT] = ACTIONS(240),
    [anon_sym_instanceof] = ACTIONS(242),
    [anon_sym_DASH_GT] = ACTIONS(240),
    [anon_sym_COMMA] = ACTIONS(240),
    [anon_sym_QMARK] = ACTIONS(240),
    [anon_sym_COLON] = ACTIONS(242),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(240),
    [anon_sym_PLUS_PLUS] = ACTIONS(240),
    [anon_sym_DASH_DASH] = ACTIONS(240),
    [anon_sym_new] = ACTIONS(242),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_RBRACK] = ACTIONS(240),
    [anon_sym_DOT] = ACTIONS(242),
    [anon_sym_class] = ACTIONS(242),
    [anon_sym_COLON_COLON] = ACTIONS(240),
    [anon_sym_switch] = ACTIONS(242),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_case] = ACTIONS(242),
    [anon_sym_default] = ACTIONS(242),
    [anon_sym_SEMI] = ACTIONS(240),
    [anon_sym_assert] = ACTIONS(242),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_while] = ACTIONS(242),
    [anon_sym_break] = ACTIONS(242),
    [anon_sym_continue] = ACTIONS(242),
    [anon_sym_return] = ACTIONS(242),
    [anon_sym_yield] = ACTIONS(242),
    [anon_sym_synchronized] = ACTIONS(242),
    [anon_sym_throw] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(242),
    [anon_sym_if] = ACTIONS(242),
    [anon_sym_else] = ACTIONS(242),
    [anon_sym_for] = ACTIONS(242),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_open] = ACTIONS(242),
    [anon_sym_module] = ACTIONS(242),
    [anon_sym_static] = ACTIONS(242),
    [anon_sym_package] = ACTIONS(242),
    [anon_sym_import] = ACTIONS(242),
    [anon_sym_enum] = ACTIONS(242),
    [anon_sym_public] = ACTIONS(242),
    [anon_sym_protected] = ACTIONS(242),
    [anon_sym_private] = ACTIONS(242),
    [anon_sym_abstract] = ACTIONS(242),
    [anon_sym_final] = ACTIONS(242),
    [anon_sym_strictfp] = ACTIONS(242),
    [anon_sym_native] = ACTIONS(242),
    [anon_sym_transient] = ACTIONS(242),
    [anon_sym_volatile] = ACTIONS(242),
    [anon_sym_sealed] = ACTIONS(242),
    [anon_sym_non_DASHsealed] = ACTIONS(240),
    [anon_sym_record] = ACTIONS(242),
    [anon_sym_ATinterface] = ACTIONS(240),
    [anon_sym_interface] = ACTIONS(242),
    [anon_sym_byte] = ACTIONS(242),
    [anon_sym_short] = ACTIONS(242),
    [anon_sym_int] = ACTIONS(242),
    [anon_sym_long] = ACTIONS(242),
    [anon_sym_char] = ACTIONS(242),
    [anon_sym_float] = ACTIONS(242),
    [anon_sym_double] = ACTIONS(242),
    [sym_boolean_type] = ACTIONS(242),
    [sym_void_type] = ACTIONS(242),
    [sym_this] = ACTIONS(242),
    [sym_super] = ACTIONS(242),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_identifier] = ACTIONS(246),
    [sym_decimal_integer_literal] = ACTIONS(246),
    [sym_hex_integer_literal] = ACTIONS(246),
    [sym_octal_integer_literal] = ACTIONS(244),
    [sym_binary_integer_literal] = ACTIONS(244),
    [sym_decimal_floating_point_literal] = ACTIONS(244),
    [sym_hex_floating_point_literal] = ACTIONS(246),
    [sym_true] = ACTIONS(246),
    [sym_false] = ACTIONS(246),
    [sym_character_literal] = ACTIONS(244),
    [sym_string_literal] = ACTIONS(246),
    [sym_text_block] = ACTIONS(244),
    [sym_null_literal] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_AMP] = ACTIONS(246),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_GT] = ACTIONS(246),
    [anon_sym_LT] = ACTIONS(246),
    [anon_sym_GT_EQ] = ACTIONS(244),
    [anon_sym_LT_EQ] = ACTIONS(244),
    [anon_sym_EQ_EQ] = ACTIONS(244),
    [anon_sym_BANG_EQ] = ACTIONS(244),
    [anon_sym_AMP_AMP] = ACTIONS(244),
    [anon_sym_PIPE_PIPE] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(246),
    [anon_sym_DASH] = ACTIONS(246),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_SLASH] = ACTIONS(246),
    [anon_sym_PIPE] = ACTIONS(246),
    [anon_sym_CARET] = ACTIONS(244),
    [anon_sym_PERCENT] = ACTIONS(244),
    [anon_sym_LT_LT] = ACTIONS(244),
    [anon_sym_GT_GT] = ACTIONS(246),
    [anon_sym_GT_GT_GT] = ACTIONS(244),
    [anon_sym_instanceof] = ACTIONS(246),
    [anon_sym_DASH_GT] = ACTIONS(244),
    [anon_sym_COMMA] = ACTIONS(244),
    [anon_sym_QMARK] = ACTIONS(244),
    [anon_sym_COLON] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(246),
    [anon_sym_TILDE] = ACTIONS(244),
    [anon_sym_PLUS_PLUS] = ACTIONS(244),
    [anon_sym_DASH_DASH] = ACTIONS(244),
    [anon_sym_new] = ACTIONS(246),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_class] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_case] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(244),
    [anon_sym_assert] = ACTIONS(246),
    [anon_sym_do] = ACTIONS(246),
    [anon_sym_while] = ACTIONS(246),
    [anon_sym_break] = ACTIONS(246),
    [anon_sym_continue] = ACTIONS(246),
    [anon_sym_return] = ACTIONS(246),
    [anon_sym_yield] = ACTIONS(246),
    [anon_sym_synchronized] = ACTIONS(246),
    [anon_sym_throw] = ACTIONS(246),
    [anon_sym_try] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(246),
    [anon_sym_else] = ACTIONS(246),
    [anon_sym_for] = ACTIONS(246),
    [anon_sym_AT] = ACTIONS(246),
    [anon_sym_open] = ACTIONS(246),
    [anon_sym_module] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(246),
    [anon_sym_package] = ACTIONS(246),
    [anon_sym_import] = ACTIONS(246),
    [anon_sym_enum] = ACTIONS(246),
    [anon_sym_public] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_abstract] = ACTIONS(246),
    [anon_sym_final] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_native] = ACTIONS(246),
    [anon_sym_transient] = ACTIONS(246),
    [anon_sym_volatile] = ACTIONS(246),
    [anon_sym_sealed] = ACTIONS(246),
    [anon_sym_non_DASHsealed] = ACTIONS(244),
    [anon_sym_record] = ACTIONS(246),
    [anon_sym_ATinterface] = ACTIONS(244),
    [anon_sym_interface] = ACTIONS(246),
    [anon_sym_byte] = ACTIONS(246),
    [anon_sym_short] = ACTIONS(246),
    [anon_sym_int] = ACTIONS(246),
    [anon_sym_long] = ACTIONS(246),
    [anon_sym_char] = ACTIONS(246),
    [anon_sym_float] = ACTIONS(246),
    [anon_sym_double] = ACTIONS(246),
    [sym_boolean_type] = ACTIONS(246),
    [sym_void_type] = ACTIONS(246),
    [sym_this] = ACTIONS(246),
    [sym_super] = ACTIONS(246),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(248),
    [sym_identifier] = ACTIONS(250),
    [sym_decimal_integer_literal] = ACTIONS(250),
    [sym_hex_integer_literal] = ACTIONS(250),
    [sym_octal_integer_literal] = ACTIONS(248),
    [sym_binary_integer_literal] = ACTIONS(248),
    [sym_decimal_floating_point_literal] = ACTIONS(248),
    [sym_hex_floating_point_literal] = ACTIONS(250),
    [sym_true] = ACTIONS(250),
    [sym_false] = ACTIONS(250),
    [sym_character_literal] = ACTIONS(248),
    [sym_string_literal] = ACTIONS(250),
    [sym_text_block] = ACTIONS(248),
    [sym_null_literal] = ACTIONS(250),
    [anon_sym_LPAREN] = ACTIONS(248),
    [anon_sym_AMP] = ACTIONS(250),
    [anon_sym_RPAREN] = ACTIONS(248),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_LT] = ACTIONS(250),
    [anon_sym_GT_EQ] = ACTIONS(248),
    [anon_sym_LT_EQ] = ACTIONS(248),
    [anon_sym_EQ_EQ] = ACTIONS(248),
    [anon_sym_BANG_EQ] = ACTIONS(248),
    [anon_sym_AMP_AMP] = ACTIONS(248),
    [anon_sym_PIPE_PIPE] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(250),
    [anon_sym_DASH] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(248),
    [anon_sym_SLASH] = ACTIONS(250),
    [anon_sym_PIPE] = ACTIONS(250),
    [anon_sym_CARET] = ACTIONS(248),
    [anon_sym_PERCENT] = ACTIONS(248),
    [anon_sym_LT_LT] = ACTIONS(248),
    [anon_sym_GT_GT] = ACTIONS(250),
    [anon_sym_GT_GT_GT] = ACTIONS(248),
    [anon_sym_instanceof] = ACTIONS(250),
    [anon_sym_DASH_GT] = ACTIONS(248),
    [anon_sym_COMMA] = ACTIONS(248),
    [anon_sym_QMARK] = ACTIONS(248),
    [anon_sym_COLON] = ACTIONS(248),
    [anon_sym_BANG] = ACTIONS(250),
    [anon_sym_TILDE] = ACTIONS(248),
    [anon_sym_PLUS_PLUS] = ACTIONS(248),
    [anon_sym_DASH_DASH] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(250),
    [anon_sym_RBRACK] = ACTIONS(248),
    [anon_sym_class] = ACTIONS(250),
    [anon_sym_switch] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(248),
    [anon_sym_RBRACE] = ACTIONS(248),
    [anon_sym_case] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_assert] = ACTIONS(250),
    [anon_sym_do] = ACTIONS(250),
    [anon_sym_while] = ACTIONS(250),
    [anon_sym_break] = ACTIONS(250),
    [anon_sym_continue] = ACTIONS(250),
    [anon_sym_return] = ACTIONS(250),
    [anon_sym_yield] = ACTIONS(250),
    [anon_sym_synchronized] = ACTIONS(250),
    [anon_sym_throw] = ACTIONS(250),
    [anon_sym_try] = ACTIONS(250),
    [anon_sym_if] = ACTIONS(250),
    [anon_sym_else] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(250),
    [anon_sym_AT] = ACTIONS(250),
    [anon_sym_open] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_static] = ACTIONS(250),
    [anon_sym_package] = ACTIONS(250),
    [anon_sym_import] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(250),
    [anon_sym_public] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_abstract] = ACTIONS(250),
    [anon_sym_final] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_native] = ACTIONS(250),
    [anon_sym_transient] = ACTIONS(250),
    [anon_sym_volatile] = ACTIONS(250),
    [anon_sym_sealed] = ACTIONS(250),
    [anon_sym_non_DASHsealed] = ACTIONS(248),
    [anon_sym_record] = ACTIONS(250),
    [anon_sym_ATinterface] = ACTIONS(248),
    [anon_sym_interface] = ACTIONS(250),
    [anon_sym_byte] = ACTIONS(250),
    [anon_sym_short] = ACTIONS(250),
    [anon_sym_int] = ACTIONS(250),
    [anon_sym_long] = ACTIONS(250),
    [anon_sym_char] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [sym_boolean_type] = ACTIONS(250),
    [sym_void_type] = ACTIONS(250),
    [sym_this] = ACTIONS(250),
    [sym_super] = ACTIONS(250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(252),
    [sym_identifier] = ACTIONS(254),
    [sym_decimal_integer_literal] = ACTIONS(254),
    [sym_hex_integer_literal] = ACTIONS(254),
    [sym_octal_integer_literal] = ACTIONS(252),
    [sym_binary_integer_literal] = ACTIONS(252),
    [sym_decimal_floating_point_literal] = ACTIONS(252),
    [sym_hex_floating_point_literal] = ACTIONS(254),
    [sym_true] = ACTIONS(254),
    [sym_false] = ACTIONS(254),
    [sym_character_literal] = ACTIONS(252),
    [sym_string_literal] = ACTIONS(254),
    [sym_text_block] = ACTIONS(252),
    [sym_null_literal] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_AMP] = ACTIONS(254),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_GT_EQ] = ACTIONS(252),
    [anon_sym_LT_EQ] = ACTIONS(252),
    [anon_sym_EQ_EQ] = ACTIONS(252),
    [anon_sym_BANG_EQ] = ACTIONS(252),
    [anon_sym_AMP_AMP] = ACTIONS(252),
    [anon_sym_PIPE_PIPE] = ACTIONS(252),
    [anon_sym_PLUS] = ACTIONS(254),
    [anon_sym_DASH] = ACTIONS(254),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_SLASH] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(254),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_PERCENT] = ACTIONS(252),
    [anon_sym_LT_LT] = ACTIONS(252),
    [anon_sym_GT_GT] = ACTIONS(254),
    [anon_sym_GT_GT_GT] = ACTIONS(252),
    [anon_sym_instanceof] = ACTIONS(254),
    [anon_sym_DASH_GT] = ACTIONS(252),
    [anon_sym_COMMA] = ACTIONS(252),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_COLON] = ACTIONS(252),
    [anon_sym_BANG] = ACTIONS(254),
    [anon_sym_TILDE] = ACTIONS(252),
    [anon_sym_PLUS_PLUS] = ACTIONS(252),
    [anon_sym_DASH_DASH] = ACTIONS(252),
    [anon_sym_new] = ACTIONS(254),
    [anon_sym_RBRACK] = ACTIONS(252),
    [anon_sym_class] = ACTIONS(254),
    [anon_sym_switch] = ACTIONS(254),
    [anon_sym_LBRACE] = ACTIONS(252),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_default] = ACTIONS(254),
    [anon_sym_SEMI] = ACTIONS(252),
    [anon_sym_assert] = ACTIONS(254),
    [anon_sym_do] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_break] = ACTIONS(254),
    [anon_sym_continue] = ACTIONS(254),
    [anon_sym_return] = ACTIONS(254),
    [anon_sym_yield] = ACTIONS(254),
    [anon_sym_synchronized] = ACTIONS(254),
    [anon_sym_throw] = ACTIONS(254),
    [anon_sym_try] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_else] = ACTIONS(254),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_open] = ACTIONS(254),
    [anon_sym_module] = ACTIONS(254),
    [anon_sym_static] = ACTIONS(254),
    [anon_sym_package] = ACTIONS(254),
    [anon_sym_import] = ACTIONS(254),
    [anon_sym_enum] = ACTIONS(254),
    [anon_sym_public] = ACTIONS(254),
    [anon_sym_protected] = ACTIONS(254),
    [anon_sym_private] = ACTIONS(254),
    [anon_sym_abstract] = ACTIONS(254),
    [anon_sym_final] = ACTIONS(254),
    [anon_sym_strictfp] = ACTIONS(254),
    [anon_sym_native] = ACTIONS(254),
    [anon_sym_transient] = ACTIONS(254),
    [anon_sym_volatile] = ACTIONS(254),
    [anon_sym_sealed] = ACTIONS(254),
    [anon_sym_non_DASHsealed] = ACTIONS(252),
    [anon_sym_ATinterface] = ACTIONS(252),
    [anon_sym_interface] = ACTIONS(254),
    [anon_sym_byte] = ACTIONS(254),
    [anon_sym_short] = ACTIONS(254),
    [anon_sym_int] = ACTIONS(254),
    [anon_sym_long] = ACTIONS(254),
    [anon_sym_char] = ACTIONS(254),
    [anon_sym_float] = ACTIONS(254),
    [anon_sym_double] = ACTIONS(254),
    [sym_boolean_type] = ACTIONS(254),
    [sym_void_type] = ACTIONS(254),
    [sym_this] = ACTIONS(254),
    [sym_super] = ACTIONS(254),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(256),
    [sym_identifier] = ACTIONS(258),
    [sym_decimal_integer_literal] = ACTIONS(258),
    [sym_hex_integer_literal] = ACTIONS(258),
    [sym_octal_integer_literal] = ACTIONS(256),
    [sym_binary_integer_literal] = ACTIONS(256),
    [sym_decimal_floating_point_literal] = ACTIONS(256),
    [sym_hex_floating_point_literal] = ACTIONS(258),
    [sym_true] = ACTIONS(258),
    [sym_false] = ACTIONS(258),
    [sym_character_literal] = ACTIONS(256),
    [sym_string_literal] = ACTIONS(258),
    [sym_text_block] = ACTIONS(256),
    [sym_null_literal] = ACTIONS(258),
    [anon_sym_LPAREN] = ACTIONS(256),
    [anon_sym_AMP] = ACTIONS(258),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(258),
    [anon_sym_LT] = ACTIONS(258),
    [anon_sym_GT_EQ] = ACTIONS(256),
    [anon_sym_LT_EQ] = ACTIONS(256),
    [anon_sym_EQ_EQ] = ACTIONS(256),
    [anon_sym_BANG_EQ] = ACTIONS(256),
    [anon_sym_AMP_AMP] = ACTIONS(256),
    [anon_sym_PIPE_PIPE] = ACTIONS(256),
    [anon_sym_PLUS] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(258),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_SLASH] = ACTIONS(258),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_CARET] = ACTIONS(256),
    [anon_sym_PERCENT] = ACTIONS(256),
    [anon_sym_LT_LT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(258),
    [anon_sym_GT_GT_GT] = ACTIONS(256),
    [anon_sym_instanceof] = ACTIONS(258),
    [anon_sym_DASH_GT] = ACTIONS(256),
    [anon_sym_COMMA] = ACTIONS(256),
    [anon_sym_QMARK] = ACTIONS(256),
    [anon_sym_COLON] = ACTIONS(256),
    [anon_sym_BANG] = ACTIONS(258),
    [anon_sym_TILDE] = ACTIONS(256),
    [anon_sym_PLUS_PLUS] = ACTIONS(256),
    [anon_sym_DASH_DASH] = ACTIONS(256),
    [anon_sym_new] = ACTIONS(258),
    [anon_sym_RBRACK] = ACTIONS(256),
    [anon_sym_class] = ACTIONS(258),
    [anon_sym_switch] = ACTIONS(258),
    [anon_sym_LBRACE] = ACTIONS(256),
    [anon_sym_RBRACE] = ACTIONS(256),
    [anon_sym_case] = ACTIONS(258),
    [anon_sym_default] = ACTIONS(258),
    [anon_sym_SEMI] = ACTIONS(256),
    [anon_sym_assert] = ACTIONS(258),
    [anon_sym_do] = ACTIONS(258),
    [anon_sym_while] = ACTIONS(258),
    [anon_sym_break] = ACTIONS(258),
    [anon_sym_continue] = ACTIONS(258),
    [anon_sym_return] = ACTIONS(258),
    [anon_sym_yield] = ACTIONS(258),
    [anon_sym_synchronized] = ACTIONS(258),
    [anon_sym_throw] = ACTIONS(258),
    [anon_sym_try] = ACTIONS(258),
    [anon_sym_if] = ACTIONS(258),
    [anon_sym_else] = ACTIONS(258),
    [anon_sym_for] = ACTIONS(258),
    [anon_sym_AT] = ACTIONS(258),
    [anon_sym_open] = ACTIONS(258),
    [anon_sym_module] = ACTIONS(258),
    [anon_sym_static] = ACTIONS(258),
    [anon_sym_package] = ACTIONS(258),
    [anon_sym_import] = ACTIONS(258),
    [anon_sym_enum] = ACTIONS(258),
    [anon_sym_public] = ACTIONS(258),
    [anon_sym_protected] = ACTIONS(258),
    [anon_sym_private] = ACTIONS(258),
    [anon_sym_abstract] = ACTIONS(258),
    [anon_sym_final] = ACTIONS(258),
    [anon_sym_strictfp] = ACTIONS(258),
    [anon_sym_native] = ACTIONS(258),
    [anon_sym_transient] = ACTIONS(258),
    [anon_sym_volatile] = ACTIONS(258),
    [anon_sym_sealed] = ACTIONS(258),
    [anon_sym_non_DASHsealed] = ACTIONS(256),
    [anon_sym_ATinterface] = ACTIONS(256),
    [anon_sym_interface] = ACTIONS(258),
    [anon_sym_byte] = ACTIONS(258),
    [anon_sym_short] = ACTIONS(258),
    [anon_sym_int] = ACTIONS(258),
    [anon_sym_long] = ACTIONS(258),
    [anon_sym_char] = ACTIONS(258),
    [anon_sym_float] = ACTIONS(258),
    [anon_sym_double] = ACTIONS(258),
    [sym_boolean_type] = ACTIONS(258),
    [sym_void_type] = ACTIONS(258),
    [sym_this] = ACTIONS(258),
    [sym_super] = ACTIONS(258),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(260),
    [sym_identifier] = ACTIONS(262),
    [sym_decimal_integer_literal] = ACTIONS(262),
    [sym_hex_integer_literal] = ACTIONS(262),
    [sym_octal_integer_literal] = ACTIONS(260),
    [sym_binary_integer_literal] = ACTIONS(260),
    [sym_decimal_floating_point_literal] = ACTIONS(260),
    [sym_hex_floating_point_literal] = ACTIONS(262),
    [sym_true] = ACTIONS(262),
    [sym_false] = ACTIONS(262),
    [sym_character_literal] = ACTIONS(260),
    [sym_string_literal] = ACTIONS(262),
    [sym_text_block] = ACTIONS(260),
    [sym_null_literal] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(262),
    [anon_sym_RPAREN] = ACTIONS(260),
    [anon_sym_GT] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(262),
    [anon_sym_GT_EQ] = ACTIONS(260),
    [anon_sym_LT_EQ] = ACTIONS(260),
    [anon_sym_EQ_EQ] = ACTIONS(260),
    [anon_sym_BANG_EQ] = ACTIONS(260),
    [anon_sym_AMP_AMP] = ACTIONS(260),
    [anon_sym_PIPE_PIPE] = ACTIONS(260),
    [anon_sym_PLUS] = ACTIONS(262),
    [anon_sym_DASH] = ACTIONS(262),
    [anon_sym_STAR] = ACTIONS(260),
    [anon_sym_SLASH] = ACTIONS(262),
    [anon_sym_PIPE] = ACTIONS(262),
    [anon_sym_CARET] = ACTIONS(260),
    [anon_sym_PERCENT] = ACTIONS(260),
    [anon_sym_LT_LT] = ACTIONS(260),
    [anon_sym_GT_GT] = ACTIONS(262),
    [anon_sym_GT_GT_GT] = ACTIONS(260),
    [anon_sym_instanceof] = ACTIONS(262),
    [anon_sym_DASH_GT] = ACTIONS(260),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_QMARK] = ACTIONS(260),
    [anon_sym_COLON] = ACTIONS(260),
    [anon_sym_BANG] = ACTIONS(262),
    [anon_sym_TILDE] = ACTIONS(260),
    [anon_sym_PLUS_PLUS] = ACTIONS(260),
    [anon_sym_DASH_DASH] = ACTIONS(260),
    [anon_sym_new] = ACTIONS(262),
    [anon_sym_RBRACK] = ACTIONS(260),
    [anon_sym_class] = ACTIONS(262),
    [anon_sym_switch] = ACTIONS(262),
    [anon_sym_LBRACE] = ACTIONS(260),
    [anon_sym_RBRACE] = ACTIONS(260),
    [anon_sym_case] = ACTIONS(262),
    [anon_sym_default] = ACTIONS(262),
    [anon_sym_SEMI] = ACTIONS(260),
    [anon_sym_assert] = ACTIONS(262),
    [anon_sym_do] = ACTIONS(262),
    [anon_sym_while] = ACTIONS(262),
    [anon_sym_break] = ACTIONS(262),
    [anon_sym_continue] = ACTIONS(262),
    [anon_sym_return] = ACTIONS(262),
    [anon_sym_yield] = ACTIONS(262),
    [anon_sym_synchronized] = ACTIONS(262),
    [anon_sym_throw] = ACTIONS(262),
    [anon_sym_try] = ACTIONS(262),
    [anon_sym_if] = ACTIONS(262),
    [anon_sym_else] = ACTIONS(262),
    [anon_sym_for] = ACTIONS(262),
    [anon_sym_AT] = ACTIONS(262),
    [anon_sym_open] = ACTIONS(262),
    [anon_sym_module] = ACTIONS(262),
    [anon_sym_static] = ACTIONS(262),
    [anon_sym_package] = ACTIONS(262),
    [anon_sym_import] = ACTIONS(262),
    [anon_sym_enum] = ACTIONS(262),
    [anon_sym_public] = ACTIONS(262),
    [anon_sym_protected] = ACTIONS(262),
    [anon_sym_private] = ACTIONS(262),
    [anon_sym_abstract] = ACTIONS(262),
    [anon_sym_final] = ACTIONS(262),
    [anon_sym_strictfp] = ACTIONS(262),
    [anon_sym_native] = ACTIONS(262),
    [anon_sym_transient] = ACTIONS(262),
    [anon_sym_volatile] = ACTIONS(262),
    [anon_sym_sealed] = ACTIONS(262),
    [anon_sym_non_DASHsealed] = ACTIONS(260),
    [anon_sym_ATinterface] = ACTIONS(260),
    [anon_sym_interface] = ACTIONS(262),
    [anon_sym_byte] = ACTIONS(262),
    [anon_sym_short] = ACTIONS(262),
    [anon_sym_int] = ACTIONS(262),
    [anon_sym_long] = ACTIONS(262),
    [anon_sym_char] = ACTIONS(262),
    [anon_sym_float] = ACTIONS(262),
    [anon_sym_double] = ACTIONS(262),
    [sym_boolean_type] = ACTIONS(262),
    [sym_void_type] = ACTIONS(262),
    [sym_this] = ACTIONS(262),
    [sym_super] = ACTIONS(262),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_identifier] = ACTIONS(264),
    [sym_decimal_integer_literal] = ACTIONS(264),
    [sym_hex_integer_literal] = ACTIONS(264),
    [sym_octal_integer_literal] = ACTIONS(266),
    [sym_binary_integer_literal] = ACTIONS(266),
    [sym_decimal_floating_point_literal] = ACTIONS(266),
    [sym_hex_floating_point_literal] = ACTIONS(264),
    [sym_true] = ACTIONS(264),
    [sym_false] = ACTIONS(264),
    [sym_character_literal] = ACTIONS(266),
    [sym_string_literal] = ACTIONS(264),
    [sym_text_block] = ACTIONS(266),
    [sym_null_literal] = ACTIONS(264),
    [anon_sym_LPAREN] = ACTIONS(266),
    [anon_sym_AMP] = ACTIONS(264),
    [anon_sym_RPAREN] = ACTIONS(266),
    [anon_sym_GT] = ACTIONS(264),
    [anon_sym_LT] = ACTIONS(264),
    [anon_sym_GT_EQ] = ACTIONS(266),
    [anon_sym_LT_EQ] = ACTIONS(266),
    [anon_sym_EQ_EQ] = ACTIONS(266),
    [anon_sym_BANG_EQ] = ACTIONS(266),
    [anon_sym_AMP_AMP] = ACTIONS(266),
    [anon_sym_PIPE_PIPE] = ACTIONS(266),
    [anon_sym_PLUS] = ACTIONS(264),
    [anon_sym_DASH] = ACTIONS(264),
    [anon_sym_STAR] = ACTIONS(266),
    [anon_sym_SLASH] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(264),
    [anon_sym_CARET] = ACTIONS(266),
    [anon_sym_PERCENT] = ACTIONS(266),
    [anon_sym_LT_LT] = ACTIONS(266),
    [anon_sym_GT_GT] = ACTIONS(264),
    [anon_sym_GT_GT_GT] = ACTIONS(266),
    [anon_sym_instanceof] = ACTIONS(264),
    [anon_sym_DASH_GT] = ACTIONS(266),
    [anon_sym_COMMA] = ACTIONS(266),
    [anon_sym_QMARK] = ACTIONS(266),
    [anon_sym_COLON] = ACTIONS(264),
    [anon_sym_BANG] = ACTIONS(264),
    [anon_sym_TILDE] = ACTIONS(266),
    [anon_sym_PLUS_PLUS] = ACTIONS(266),
    [anon_sym_DASH_DASH] = ACTIONS(266),
    [anon_sym_new] = ACTIONS(264),
    [anon_sym_LBRACK] = ACTIONS(266),
    [anon_sym_RBRACK] = ACTIONS(266),
    [anon_sym_DOT] = ACTIONS(264),
    [anon_sym_class] = ACTIONS(264),
    [anon_sym_COLON_COLON] = ACTIONS(266),
    [anon_sym_switch] = ACTIONS(264),
    [anon_sym_LBRACE] = ACTIONS(266),
    [anon_sym_RBRACE] = ACTIONS(266),
    [anon_sym_default] = ACTIONS(264),
    [anon_sym_SEMI] = ACTIONS(266),
    [anon_sym_assert] = ACTIONS(264),
    [anon_sym_do] = ACTIONS(264),
    [anon_sym_while] = ACTIONS(264),
    [anon_sym_break] = ACTIONS(264),
    [anon_sym_continue] = ACTIONS(264),
    [anon_sym_return] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(264),
    [anon_sym_synchronized] = ACTIONS(264),
    [anon_sym_throw] = ACTIONS(264),
    [anon_sym_try] = ACTIONS(264),
    [anon_sym_if] = ACTIONS(264),
    [anon_sym_for] = ACTIONS(264),
    [anon_sym_AT] = ACTIONS(264),
    [anon_sym_open] = ACTIONS(264),
    [anon_sym_module] = ACTIONS(264),
    [anon_sym_static] = ACTIONS(264),
    [anon_sym_package] = ACTIONS(264),
    [anon_sym_import] = ACTIONS(264),
    [anon_sym_enum] = ACTIONS(264),
    [anon_sym_public] = ACTIONS(264),
    [anon_sym_protected] = ACTIONS(264),
    [anon_sym_private] = ACTIONS(264),
    [anon_sym_abstract] = ACTIONS(264),
    [anon_sym_final] = ACTIONS(264),
    [anon_sym_strictfp] = ACTIONS(264),
    [anon_sym_native] = ACTIONS(264),
    [anon_sym_transient] = ACTIONS(264),
    [anon_sym_volatile] = ACTIONS(264),
    [anon_sym_sealed] = ACTIONS(264),
    [anon_sym_non_DASHsealed] = ACTIONS(266),
    [anon_sym_ATinterface] = ACTIONS(266),
    [anon_sym_interface] = ACTIONS(264),
    [anon_sym_byte] = ACTIONS(264),
    [anon_sym_short] = ACTIONS(264),
    [anon_sym_int] = ACTIONS(264),
    [anon_sym_long] = ACTIONS(264),
    [anon_sym_char] = ACTIONS(264),
    [anon_sym_float] = ACTIONS(264),
    [anon_sym_double] = ACTIONS(264),
    [sym_boolean_type] = ACTIONS(264),
    [sym_void_type] = ACTIONS(264),
    [sym_this] = ACTIONS(264),
    [sym_super] = ACTIONS(264),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(268),
    [sym_identifier] = ACTIONS(270),
    [sym_decimal_integer_literal] = ACTIONS(270),
    [sym_hex_integer_literal] = ACTIONS(270),
    [sym_octal_integer_literal] = ACTIONS(268),
    [sym_binary_integer_literal] = ACTIONS(268),
    [sym_decimal_floating_point_literal] = ACTIONS(268),
    [sym_hex_floating_point_literal] = ACTIONS(270),
    [sym_true] = ACTIONS(270),
    [sym_false] = ACTIONS(270),
    [sym_character_literal] = ACTIONS(268),
    [sym_string_literal] = ACTIONS(270),
    [sym_text_block] = ACTIONS(268),
    [sym_null_literal] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(268),
    [anon_sym_AMP] = ACTIONS(272),
    [anon_sym_GT] = ACTIONS(272),
    [anon_sym_LT] = ACTIONS(272),
    [anon_sym_GT_EQ] = ACTIONS(274),
    [anon_sym_LT_EQ] = ACTIONS(274),
    [anon_sym_EQ_EQ] = ACTIONS(274),
    [anon_sym_BANG_EQ] = ACTIONS(274),
    [anon_sym_AMP_AMP] = ACTIONS(274),
    [anon_sym_PIPE_PIPE] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(272),
    [anon_sym_STAR] = ACTIONS(274),
    [anon_sym_SLASH] = ACTIONS(272),
    [anon_sym_PIPE] = ACTIONS(272),
    [anon_sym_CARET] = ACTIONS(274),
    [anon_sym_PERCENT] = ACTIONS(274),
    [anon_sym_LT_LT] = ACTIONS(274),
    [anon_sym_GT_GT] = ACTIONS(272),
    [anon_sym_GT_GT_GT] = ACTIONS(274),
    [anon_sym_instanceof] = ACTIONS(272),
    [anon_sym_QMARK] = ACTIONS(274),
    [anon_sym_BANG] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(268),
    [anon_sym_PLUS_PLUS] = ACTIONS(274),
    [anon_sym_DASH_DASH] = ACTIONS(274),
    [anon_sym_new] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(270),
    [anon_sym_switch] = ACTIONS(270),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_RBRACE] = ACTIONS(268),
    [anon_sym_case] = ACTIONS(270),
    [anon_sym_default] = ACTIONS(270),
    [anon_sym_SEMI] = ACTIONS(274),
    [anon_sym_assert] = ACTIONS(270),
    [anon_sym_do] = ACTIONS(270),
    [anon_sym_while] = ACTIONS(270),
    [anon_sym_break] = ACTIONS(270),
    [anon_sym_continue] = ACTIONS(270),
    [anon_sym_return] = ACTIONS(270),
    [anon_sym_yield] = ACTIONS(270),
    [anon_sym_synchronized] = ACTIONS(270),
    [anon_sym_throw] = ACTIONS(270),
    [anon_sym_try] = ACTIONS(270),
    [anon_sym_if] = ACTIONS(270),
    [anon_sym_else] = ACTIONS(270),
    [anon_sym_for] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(270),
    [anon_sym_open] = ACTIONS(270),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_static] = ACTIONS(270),
    [anon_sym_package] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_enum] = ACTIONS(270),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_abstract] = ACTIONS(270),
    [anon_sym_final] = ACTIONS(270),
    [anon_sym_strictfp] = ACTIONS(270),
    [anon_sym_native] = ACTIONS(270),
    [anon_sym_transient] = ACTIONS(270),
    [anon_sym_volatile] = ACTIONS(270),
    [anon_sym_sealed] = ACTIONS(270),
    [anon_sym_non_DASHsealed] = ACTIONS(268),
    [anon_sym_ATinterface] = ACTIONS(268),
    [anon_sym_interface] = ACTIONS(270),
    [anon_sym_byte] = ACTIONS(270),
    [anon_sym_short] = ACTIONS(270),
    [anon_sym_int] = ACTIONS(270),
    [anon_sym_long] = ACTIONS(270),
    [anon_sym_char] = ACTIONS(270),
    [anon_sym_float] = ACTIONS(270),
    [anon_sym_double] = ACTIONS(270),
    [sym_boolean_type] = ACTIONS(270),
    [sym_void_type] = ACTIONS(270),
    [sym_this] = ACTIONS(270),
    [sym_super] = ACTIONS(270),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [54] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(536),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(526),
    [sym_marker_annotation] = STATE(526),
    [sym_annotation] = STATE(526),
    [sym_modifiers] = STATE(601),
    [sym__type] = STATE(820),
    [sym__unannotated_type] = STATE(592),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_formal_parameter] = STATE(950),
    [sym_receiver_parameter] = STATE(335),
    [sym_spread_parameter] = STATE(950),
    [aux_sym_dimensions_expr_repeat1] = STATE(573),
    [aux_sym_modifiers_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(276),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(278),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(280),
    [anon_sym_synchronized] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(282),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_static] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_abstract] = ACTIONS(280),
    [anon_sym_final] = ACTIONS(280),
    [anon_sym_strictfp] = ACTIONS(280),
    [anon_sym_native] = ACTIONS(280),
    [anon_sym_transient] = ACTIONS(280),
    [anon_sym_volatile] = ACTIONS(280),
    [anon_sym_sealed] = ACTIONS(280),
    [anon_sym_non_DASHsealed] = ACTIONS(286),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [55] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(536),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(526),
    [sym_marker_annotation] = STATE(526),
    [sym_annotation] = STATE(526),
    [sym_modifiers] = STATE(601),
    [sym__type] = STATE(845),
    [sym__unannotated_type] = STATE(592),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_formal_parameter] = STATE(950),
    [sym_receiver_parameter] = STATE(335),
    [sym_spread_parameter] = STATE(950),
    [aux_sym_dimensions_expr_repeat1] = STATE(573),
    [aux_sym_modifiers_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(276),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(278),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(280),
    [anon_sym_synchronized] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(282),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_static] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_abstract] = ACTIONS(280),
    [anon_sym_final] = ACTIONS(280),
    [anon_sym_strictfp] = ACTIONS(280),
    [anon_sym_native] = ACTIONS(280),
    [anon_sym_transient] = ACTIONS(280),
    [anon_sym_volatile] = ACTIONS(280),
    [anon_sym_sealed] = ACTIONS(280),
    [anon_sym_non_DASHsealed] = ACTIONS(286),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [56] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(480),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(526),
    [sym_marker_annotation] = STATE(526),
    [sym_annotation] = STATE(526),
    [sym_modifiers] = STATE(604),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(603),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [sym_local_variable_declaration] = STATE(233),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [aux_sym_modifiers_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_default] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(290),
    [anon_sym_synchronized] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(282),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_static] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_abstract] = ACTIONS(280),
    [anon_sym_final] = ACTIONS(280),
    [anon_sym_strictfp] = ACTIONS(280),
    [anon_sym_native] = ACTIONS(280),
    [anon_sym_transient] = ACTIONS(280),
    [anon_sym_volatile] = ACTIONS(280),
    [anon_sym_sealed] = ACTIONS(280),
    [anon_sym_non_DASHsealed] = ACTIONS(286),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_catch_clause] = STATE(60),
    [sym_finally_clause] = STATE(191),
    [aux_sym_try_statement_repeat1] = STATE(60),
    [ts_builtin_sym_end] = ACTIONS(292),
    [sym_identifier] = ACTIONS(294),
    [sym_decimal_integer_literal] = ACTIONS(294),
    [sym_hex_integer_literal] = ACTIONS(294),
    [sym_octal_integer_literal] = ACTIONS(292),
    [sym_binary_integer_literal] = ACTIONS(292),
    [sym_decimal_floating_point_literal] = ACTIONS(292),
    [sym_hex_floating_point_literal] = ACTIONS(294),
    [sym_true] = ACTIONS(294),
    [sym_false] = ACTIONS(294),
    [sym_character_literal] = ACTIONS(292),
    [sym_string_literal] = ACTIONS(294),
    [sym_text_block] = ACTIONS(292),
    [sym_null_literal] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(292),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(292),
    [anon_sym_TILDE] = ACTIONS(292),
    [anon_sym_PLUS_PLUS] = ACTIONS(292),
    [anon_sym_DASH_DASH] = ACTIONS(292),
    [anon_sym_new] = ACTIONS(294),
    [anon_sym_class] = ACTIONS(294),
    [anon_sym_switch] = ACTIONS(294),
    [anon_sym_LBRACE] = ACTIONS(292),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_case] = ACTIONS(294),
    [anon_sym_default] = ACTIONS(294),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_assert] = ACTIONS(294),
    [anon_sym_do] = ACTIONS(294),
    [anon_sym_while] = ACTIONS(294),
    [anon_sym_break] = ACTIONS(294),
    [anon_sym_continue] = ACTIONS(294),
    [anon_sym_return] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(294),
    [anon_sym_synchronized] = ACTIONS(294),
    [anon_sym_throw] = ACTIONS(294),
    [anon_sym_try] = ACTIONS(294),
    [anon_sym_catch] = ACTIONS(296),
    [anon_sym_finally] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_else] = ACTIONS(294),
    [anon_sym_for] = ACTIONS(294),
    [anon_sym_AT] = ACTIONS(294),
    [anon_sym_open] = ACTIONS(294),
    [anon_sym_module] = ACTIONS(294),
    [anon_sym_static] = ACTIONS(294),
    [anon_sym_package] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(294),
    [anon_sym_enum] = ACTIONS(294),
    [anon_sym_public] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(294),
    [anon_sym_private] = ACTIONS(294),
    [anon_sym_abstract] = ACTIONS(294),
    [anon_sym_final] = ACTIONS(294),
    [anon_sym_strictfp] = ACTIONS(294),
    [anon_sym_native] = ACTIONS(294),
    [anon_sym_transient] = ACTIONS(294),
    [anon_sym_volatile] = ACTIONS(294),
    [anon_sym_sealed] = ACTIONS(294),
    [anon_sym_non_DASHsealed] = ACTIONS(292),
    [anon_sym_ATinterface] = ACTIONS(292),
    [anon_sym_interface] = ACTIONS(294),
    [anon_sym_byte] = ACTIONS(294),
    [anon_sym_short] = ACTIONS(294),
    [anon_sym_int] = ACTIONS(294),
    [anon_sym_long] = ACTIONS(294),
    [anon_sym_char] = ACTIONS(294),
    [anon_sym_float] = ACTIONS(294),
    [anon_sym_double] = ACTIONS(294),
    [sym_boolean_type] = ACTIONS(294),
    [sym_void_type] = ACTIONS(294),
    [sym_this] = ACTIONS(294),
    [sym_super] = ACTIONS(294),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_catch_clause] = STATE(60),
    [sym_finally_clause] = STATE(146),
    [aux_sym_try_statement_repeat1] = STATE(60),
    [ts_builtin_sym_end] = ACTIONS(300),
    [sym_identifier] = ACTIONS(302),
    [sym_decimal_integer_literal] = ACTIONS(302),
    [sym_hex_integer_literal] = ACTIONS(302),
    [sym_octal_integer_literal] = ACTIONS(300),
    [sym_binary_integer_literal] = ACTIONS(300),
    [sym_decimal_floating_point_literal] = ACTIONS(300),
    [sym_hex_floating_point_literal] = ACTIONS(302),
    [sym_true] = ACTIONS(302),
    [sym_false] = ACTIONS(302),
    [sym_character_literal] = ACTIONS(300),
    [sym_string_literal] = ACTIONS(302),
    [sym_text_block] = ACTIONS(300),
    [sym_null_literal] = ACTIONS(302),
    [anon_sym_LPAREN] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(302),
    [anon_sym_DASH] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(300),
    [anon_sym_DASH_DASH] = ACTIONS(300),
    [anon_sym_new] = ACTIONS(302),
    [anon_sym_class] = ACTIONS(302),
    [anon_sym_switch] = ACTIONS(302),
    [anon_sym_LBRACE] = ACTIONS(300),
    [anon_sym_RBRACE] = ACTIONS(300),
    [anon_sym_case] = ACTIONS(302),
    [anon_sym_default] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_assert] = ACTIONS(302),
    [anon_sym_do] = ACTIONS(302),
    [anon_sym_while] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(302),
    [anon_sym_continue] = ACTIONS(302),
    [anon_sym_return] = ACTIONS(302),
    [anon_sym_yield] = ACTIONS(302),
    [anon_sym_synchronized] = ACTIONS(302),
    [anon_sym_throw] = ACTIONS(302),
    [anon_sym_try] = ACTIONS(302),
    [anon_sym_catch] = ACTIONS(296),
    [anon_sym_finally] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_else] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_AT] = ACTIONS(302),
    [anon_sym_open] = ACTIONS(302),
    [anon_sym_module] = ACTIONS(302),
    [anon_sym_static] = ACTIONS(302),
    [anon_sym_package] = ACTIONS(302),
    [anon_sym_import] = ACTIONS(302),
    [anon_sym_enum] = ACTIONS(302),
    [anon_sym_public] = ACTIONS(302),
    [anon_sym_protected] = ACTIONS(302),
    [anon_sym_private] = ACTIONS(302),
    [anon_sym_abstract] = ACTIONS(302),
    [anon_sym_final] = ACTIONS(302),
    [anon_sym_strictfp] = ACTIONS(302),
    [anon_sym_native] = ACTIONS(302),
    [anon_sym_transient] = ACTIONS(302),
    [anon_sym_volatile] = ACTIONS(302),
    [anon_sym_sealed] = ACTIONS(302),
    [anon_sym_non_DASHsealed] = ACTIONS(300),
    [anon_sym_ATinterface] = ACTIONS(300),
    [anon_sym_interface] = ACTIONS(302),
    [anon_sym_byte] = ACTIONS(302),
    [anon_sym_short] = ACTIONS(302),
    [anon_sym_int] = ACTIONS(302),
    [anon_sym_long] = ACTIONS(302),
    [anon_sym_char] = ACTIONS(302),
    [anon_sym_float] = ACTIONS(302),
    [anon_sym_double] = ACTIONS(302),
    [sym_boolean_type] = ACTIONS(302),
    [sym_void_type] = ACTIONS(302),
    [sym_this] = ACTIONS(302),
    [sym_super] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_catch_clause] = STATE(57),
    [sym_finally_clause] = STATE(147),
    [aux_sym_try_statement_repeat1] = STATE(57),
    [ts_builtin_sym_end] = ACTIONS(304),
    [sym_identifier] = ACTIONS(306),
    [sym_decimal_integer_literal] = ACTIONS(306),
    [sym_hex_integer_literal] = ACTIONS(306),
    [sym_octal_integer_literal] = ACTIONS(304),
    [sym_binary_integer_literal] = ACTIONS(304),
    [sym_decimal_floating_point_literal] = ACTIONS(304),
    [sym_hex_floating_point_literal] = ACTIONS(306),
    [sym_true] = ACTIONS(306),
    [sym_false] = ACTIONS(306),
    [sym_character_literal] = ACTIONS(304),
    [sym_string_literal] = ACTIONS(306),
    [sym_text_block] = ACTIONS(304),
    [sym_null_literal] = ACTIONS(306),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_PLUS] = ACTIONS(306),
    [anon_sym_DASH] = ACTIONS(306),
    [anon_sym_BANG] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(304),
    [anon_sym_PLUS_PLUS] = ACTIONS(304),
    [anon_sym_DASH_DASH] = ACTIONS(304),
    [anon_sym_new] = ACTIONS(306),
    [anon_sym_class] = ACTIONS(306),
    [anon_sym_switch] = ACTIONS(306),
    [anon_sym_LBRACE] = ACTIONS(304),
    [anon_sym_RBRACE] = ACTIONS(304),
    [anon_sym_case] = ACTIONS(306),
    [anon_sym_default] = ACTIONS(306),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_assert] = ACTIONS(306),
    [anon_sym_do] = ACTIONS(306),
    [anon_sym_while] = ACTIONS(306),
    [anon_sym_break] = ACTIONS(306),
    [anon_sym_continue] = ACTIONS(306),
    [anon_sym_return] = ACTIONS(306),
    [anon_sym_yield] = ACTIONS(306),
    [anon_sym_synchronized] = ACTIONS(306),
    [anon_sym_throw] = ACTIONS(306),
    [anon_sym_try] = ACTIONS(306),
    [anon_sym_catch] = ACTIONS(296),
    [anon_sym_finally] = ACTIONS(298),
    [anon_sym_if] = ACTIONS(306),
    [anon_sym_else] = ACTIONS(306),
    [anon_sym_for] = ACTIONS(306),
    [anon_sym_AT] = ACTIONS(306),
    [anon_sym_open] = ACTIONS(306),
    [anon_sym_module] = ACTIONS(306),
    [anon_sym_static] = ACTIONS(306),
    [anon_sym_package] = ACTIONS(306),
    [anon_sym_import] = ACTIONS(306),
    [anon_sym_enum] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(306),
    [anon_sym_protected] = ACTIONS(306),
    [anon_sym_private] = ACTIONS(306),
    [anon_sym_abstract] = ACTIONS(306),
    [anon_sym_final] = ACTIONS(306),
    [anon_sym_strictfp] = ACTIONS(306),
    [anon_sym_native] = ACTIONS(306),
    [anon_sym_transient] = ACTIONS(306),
    [anon_sym_volatile] = ACTIONS(306),
    [anon_sym_sealed] = ACTIONS(306),
    [anon_sym_non_DASHsealed] = ACTIONS(304),
    [anon_sym_ATinterface] = ACTIONS(304),
    [anon_sym_interface] = ACTIONS(306),
    [anon_sym_byte] = ACTIONS(306),
    [anon_sym_short] = ACTIONS(306),
    [anon_sym_int] = ACTIONS(306),
    [anon_sym_long] = ACTIONS(306),
    [anon_sym_char] = ACTIONS(306),
    [anon_sym_float] = ACTIONS(306),
    [anon_sym_double] = ACTIONS(306),
    [sym_boolean_type] = ACTIONS(306),
    [sym_void_type] = ACTIONS(306),
    [sym_this] = ACTIONS(306),
    [sym_super] = ACTIONS(306),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_catch_clause] = STATE(60),
    [aux_sym_try_statement_repeat1] = STATE(60),
    [ts_builtin_sym_end] = ACTIONS(308),
    [sym_identifier] = ACTIONS(310),
    [sym_decimal_integer_literal] = ACTIONS(310),
    [sym_hex_integer_literal] = ACTIONS(310),
    [sym_octal_integer_literal] = ACTIONS(308),
    [sym_binary_integer_literal] = ACTIONS(308),
    [sym_decimal_floating_point_literal] = ACTIONS(308),
    [sym_hex_floating_point_literal] = ACTIONS(310),
    [sym_true] = ACTIONS(310),
    [sym_false] = ACTIONS(310),
    [sym_character_literal] = ACTIONS(308),
    [sym_string_literal] = ACTIONS(310),
    [sym_text_block] = ACTIONS(308),
    [sym_null_literal] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_PLUS] = ACTIONS(310),
    [anon_sym_DASH] = ACTIONS(310),
    [anon_sym_BANG] = ACTIONS(308),
    [anon_sym_TILDE] = ACTIONS(308),
    [anon_sym_PLUS_PLUS] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(310),
    [anon_sym_class] = ACTIONS(310),
    [anon_sym_switch] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(308),
    [anon_sym_RBRACE] = ACTIONS(308),
    [anon_sym_case] = ACTIONS(310),
    [anon_sym_default] = ACTIONS(310),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_assert] = ACTIONS(310),
    [anon_sym_do] = ACTIONS(310),
    [anon_sym_while] = ACTIONS(310),
    [anon_sym_break] = ACTIONS(310),
    [anon_sym_continue] = ACTIONS(310),
    [anon_sym_return] = ACTIONS(310),
    [anon_sym_yield] = ACTIONS(310),
    [anon_sym_synchronized] = ACTIONS(310),
    [anon_sym_throw] = ACTIONS(310),
    [anon_sym_try] = ACTIONS(310),
    [anon_sym_catch] = ACTIONS(312),
    [anon_sym_finally] = ACTIONS(310),
    [anon_sym_if] = ACTIONS(310),
    [anon_sym_else] = ACTIONS(310),
    [anon_sym_for] = ACTIONS(310),
    [anon_sym_AT] = ACTIONS(310),
    [anon_sym_open] = ACTIONS(310),
    [anon_sym_module] = ACTIONS(310),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_package] = ACTIONS(310),
    [anon_sym_import] = ACTIONS(310),
    [anon_sym_enum] = ACTIONS(310),
    [anon_sym_public] = ACTIONS(310),
    [anon_sym_protected] = ACTIONS(310),
    [anon_sym_private] = ACTIONS(310),
    [anon_sym_abstract] = ACTIONS(310),
    [anon_sym_final] = ACTIONS(310),
    [anon_sym_strictfp] = ACTIONS(310),
    [anon_sym_native] = ACTIONS(310),
    [anon_sym_transient] = ACTIONS(310),
    [anon_sym_volatile] = ACTIONS(310),
    [anon_sym_sealed] = ACTIONS(310),
    [anon_sym_non_DASHsealed] = ACTIONS(308),
    [anon_sym_ATinterface] = ACTIONS(308),
    [anon_sym_interface] = ACTIONS(310),
    [anon_sym_byte] = ACTIONS(310),
    [anon_sym_short] = ACTIONS(310),
    [anon_sym_int] = ACTIONS(310),
    [anon_sym_long] = ACTIONS(310),
    [anon_sym_char] = ACTIONS(310),
    [anon_sym_float] = ACTIONS(310),
    [anon_sym_double] = ACTIONS(310),
    [sym_boolean_type] = ACTIONS(310),
    [sym_void_type] = ACTIONS(310),
    [sym_this] = ACTIONS(310),
    [sym_super] = ACTIONS(310),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [61] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym_element_value_pair] = STATE(951),
    [sym__element_value] = STATE(1080),
    [sym_element_value_array_initializer] = STATE(1080),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(315),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(317),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym_element_value_pair] = STATE(876),
    [sym__element_value] = STATE(1136),
    [sym_element_value_array_initializer] = STATE(1136),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(315),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(323),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [63] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym_element_value_pair] = STATE(884),
    [sym__element_value] = STATE(1129),
    [sym_element_value_array_initializer] = STATE(1129),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(315),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(325),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [64] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(530),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym_block] = STATE(936),
    [sym_expression_statement] = STATE(936),
    [sym_throw_statement] = STATE(936),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_throw] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [65] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym__element_value] = STATE(854),
    [sym_element_value_array_initializer] = STATE(854),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(327),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_RBRACE] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(331),
    [sym_identifier] = ACTIONS(333),
    [sym_decimal_integer_literal] = ACTIONS(333),
    [sym_hex_integer_literal] = ACTIONS(333),
    [sym_octal_integer_literal] = ACTIONS(331),
    [sym_binary_integer_literal] = ACTIONS(331),
    [sym_decimal_floating_point_literal] = ACTIONS(331),
    [sym_hex_floating_point_literal] = ACTIONS(333),
    [sym_true] = ACTIONS(333),
    [sym_false] = ACTIONS(333),
    [sym_character_literal] = ACTIONS(331),
    [sym_string_literal] = ACTIONS(333),
    [sym_text_block] = ACTIONS(331),
    [sym_null_literal] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(331),
    [anon_sym_LT] = ACTIONS(331),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_BANG] = ACTIONS(331),
    [anon_sym_TILDE] = ACTIONS(331),
    [anon_sym_PLUS_PLUS] = ACTIONS(331),
    [anon_sym_DASH_DASH] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(333),
    [anon_sym_class] = ACTIONS(333),
    [anon_sym_switch] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(331),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_case] = ACTIONS(333),
    [anon_sym_default] = ACTIONS(333),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_assert] = ACTIONS(333),
    [anon_sym_do] = ACTIONS(333),
    [anon_sym_while] = ACTIONS(333),
    [anon_sym_break] = ACTIONS(333),
    [anon_sym_continue] = ACTIONS(333),
    [anon_sym_return] = ACTIONS(333),
    [anon_sym_yield] = ACTIONS(333),
    [anon_sym_synchronized] = ACTIONS(333),
    [anon_sym_throw] = ACTIONS(333),
    [anon_sym_try] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_open] = ACTIONS(333),
    [anon_sym_module] = ACTIONS(333),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_package] = ACTIONS(333),
    [anon_sym_import] = ACTIONS(333),
    [anon_sym_enum] = ACTIONS(333),
    [anon_sym_public] = ACTIONS(333),
    [anon_sym_protected] = ACTIONS(333),
    [anon_sym_private] = ACTIONS(333),
    [anon_sym_abstract] = ACTIONS(333),
    [anon_sym_final] = ACTIONS(333),
    [anon_sym_strictfp] = ACTIONS(333),
    [anon_sym_native] = ACTIONS(333),
    [anon_sym_transient] = ACTIONS(333),
    [anon_sym_volatile] = ACTIONS(333),
    [anon_sym_sealed] = ACTIONS(333),
    [anon_sym_non_DASHsealed] = ACTIONS(331),
    [anon_sym_record] = ACTIONS(333),
    [anon_sym_ATinterface] = ACTIONS(331),
    [anon_sym_interface] = ACTIONS(333),
    [anon_sym_byte] = ACTIONS(333),
    [anon_sym_short] = ACTIONS(333),
    [anon_sym_int] = ACTIONS(333),
    [anon_sym_long] = ACTIONS(333),
    [anon_sym_char] = ACTIONS(333),
    [anon_sym_float] = ACTIONS(333),
    [anon_sym_double] = ACTIONS(333),
    [sym_boolean_type] = ACTIONS(333),
    [sym_void_type] = ACTIONS(333),
    [sym_this] = ACTIONS(333),
    [sym_super] = ACTIONS(333),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(335),
    [sym_identifier] = ACTIONS(337),
    [sym_decimal_integer_literal] = ACTIONS(337),
    [sym_hex_integer_literal] = ACTIONS(337),
    [sym_octal_integer_literal] = ACTIONS(335),
    [sym_binary_integer_literal] = ACTIONS(335),
    [sym_decimal_floating_point_literal] = ACTIONS(335),
    [sym_hex_floating_point_literal] = ACTIONS(337),
    [sym_true] = ACTIONS(337),
    [sym_false] = ACTIONS(337),
    [sym_character_literal] = ACTIONS(335),
    [sym_string_literal] = ACTIONS(337),
    [sym_text_block] = ACTIONS(335),
    [sym_null_literal] = ACTIONS(337),
    [anon_sym_LPAREN] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(337),
    [anon_sym_DASH] = ACTIONS(337),
    [anon_sym_BANG] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(335),
    [anon_sym_PLUS_PLUS] = ACTIONS(335),
    [anon_sym_DASH_DASH] = ACTIONS(335),
    [anon_sym_new] = ACTIONS(337),
    [anon_sym_class] = ACTIONS(337),
    [anon_sym_switch] = ACTIONS(337),
    [anon_sym_LBRACE] = ACTIONS(335),
    [anon_sym_RBRACE] = ACTIONS(335),
    [anon_sym_case] = ACTIONS(337),
    [anon_sym_default] = ACTIONS(337),
    [anon_sym_SEMI] = ACTIONS(335),
    [anon_sym_assert] = ACTIONS(337),
    [anon_sym_do] = ACTIONS(337),
    [anon_sym_while] = ACTIONS(337),
    [anon_sym_break] = ACTIONS(337),
    [anon_sym_continue] = ACTIONS(337),
    [anon_sym_return] = ACTIONS(337),
    [anon_sym_yield] = ACTIONS(337),
    [anon_sym_synchronized] = ACTIONS(337),
    [anon_sym_throw] = ACTIONS(337),
    [anon_sym_try] = ACTIONS(337),
    [anon_sym_if] = ACTIONS(337),
    [anon_sym_else] = ACTIONS(337),
    [anon_sym_for] = ACTIONS(337),
    [anon_sym_AT] = ACTIONS(337),
    [anon_sym_open] = ACTIONS(337),
    [anon_sym_module] = ACTIONS(337),
    [anon_sym_static] = ACTIONS(337),
    [anon_sym_package] = ACTIONS(337),
    [anon_sym_import] = ACTIONS(337),
    [anon_sym_enum] = ACTIONS(337),
    [anon_sym_public] = ACTIONS(337),
    [anon_sym_protected] = ACTIONS(337),
    [anon_sym_private] = ACTIONS(337),
    [anon_sym_abstract] = ACTIONS(337),
    [anon_sym_final] = ACTIONS(337),
    [anon_sym_strictfp] = ACTIONS(337),
    [anon_sym_native] = ACTIONS(337),
    [anon_sym_transient] = ACTIONS(337),
    [anon_sym_volatile] = ACTIONS(337),
    [anon_sym_sealed] = ACTIONS(337),
    [anon_sym_non_DASHsealed] = ACTIONS(335),
    [anon_sym_record] = ACTIONS(337),
    [anon_sym_ATinterface] = ACTIONS(335),
    [anon_sym_interface] = ACTIONS(337),
    [anon_sym_byte] = ACTIONS(337),
    [anon_sym_short] = ACTIONS(337),
    [anon_sym_int] = ACTIONS(337),
    [anon_sym_long] = ACTIONS(337),
    [anon_sym_char] = ACTIONS(337),
    [anon_sym_float] = ACTIONS(337),
    [anon_sym_double] = ACTIONS(337),
    [sym_boolean_type] = ACTIONS(337),
    [sym_void_type] = ACTIONS(337),
    [sym_this] = ACTIONS(337),
    [sym_super] = ACTIONS(337),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(339),
    [sym_identifier] = ACTIONS(341),
    [sym_decimal_integer_literal] = ACTIONS(341),
    [sym_hex_integer_literal] = ACTIONS(341),
    [sym_octal_integer_literal] = ACTIONS(339),
    [sym_binary_integer_literal] = ACTIONS(339),
    [sym_decimal_floating_point_literal] = ACTIONS(339),
    [sym_hex_floating_point_literal] = ACTIONS(341),
    [sym_true] = ACTIONS(341),
    [sym_false] = ACTIONS(341),
    [sym_character_literal] = ACTIONS(339),
    [sym_string_literal] = ACTIONS(341),
    [sym_text_block] = ACTIONS(339),
    [sym_null_literal] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_LT] = ACTIONS(339),
    [anon_sym_PLUS] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(341),
    [anon_sym_BANG] = ACTIONS(339),
    [anon_sym_TILDE] = ACTIONS(339),
    [anon_sym_PLUS_PLUS] = ACTIONS(339),
    [anon_sym_DASH_DASH] = ACTIONS(339),
    [anon_sym_new] = ACTIONS(341),
    [anon_sym_class] = ACTIONS(341),
    [anon_sym_switch] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(339),
    [anon_sym_RBRACE] = ACTIONS(339),
    [anon_sym_case] = ACTIONS(341),
    [anon_sym_default] = ACTIONS(341),
    [anon_sym_SEMI] = ACTIONS(339),
    [anon_sym_assert] = ACTIONS(341),
    [anon_sym_do] = ACTIONS(341),
    [anon_sym_while] = ACTIONS(341),
    [anon_sym_break] = ACTIONS(341),
    [anon_sym_continue] = ACTIONS(341),
    [anon_sym_return] = ACTIONS(341),
    [anon_sym_yield] = ACTIONS(341),
    [anon_sym_synchronized] = ACTIONS(341),
    [anon_sym_throw] = ACTIONS(341),
    [anon_sym_try] = ACTIONS(341),
    [anon_sym_if] = ACTIONS(341),
    [anon_sym_else] = ACTIONS(341),
    [anon_sym_for] = ACTIONS(341),
    [anon_sym_AT] = ACTIONS(341),
    [anon_sym_open] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(341),
    [anon_sym_static] = ACTIONS(341),
    [anon_sym_package] = ACTIONS(341),
    [anon_sym_import] = ACTIONS(341),
    [anon_sym_enum] = ACTIONS(341),
    [anon_sym_public] = ACTIONS(341),
    [anon_sym_protected] = ACTIONS(341),
    [anon_sym_private] = ACTIONS(341),
    [anon_sym_abstract] = ACTIONS(341),
    [anon_sym_final] = ACTIONS(341),
    [anon_sym_strictfp] = ACTIONS(341),
    [anon_sym_native] = ACTIONS(341),
    [anon_sym_transient] = ACTIONS(341),
    [anon_sym_volatile] = ACTIONS(341),
    [anon_sym_sealed] = ACTIONS(341),
    [anon_sym_non_DASHsealed] = ACTIONS(339),
    [anon_sym_record] = ACTIONS(341),
    [anon_sym_ATinterface] = ACTIONS(339),
    [anon_sym_interface] = ACTIONS(341),
    [anon_sym_byte] = ACTIONS(341),
    [anon_sym_short] = ACTIONS(341),
    [anon_sym_int] = ACTIONS(341),
    [anon_sym_long] = ACTIONS(341),
    [anon_sym_char] = ACTIONS(341),
    [anon_sym_float] = ACTIONS(341),
    [anon_sym_double] = ACTIONS(341),
    [sym_boolean_type] = ACTIONS(341),
    [sym_void_type] = ACTIONS(341),
    [sym_this] = ACTIONS(341),
    [sym_super] = ACTIONS(341),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(343),
    [sym_identifier] = ACTIONS(345),
    [sym_decimal_integer_literal] = ACTIONS(345),
    [sym_hex_integer_literal] = ACTIONS(345),
    [sym_octal_integer_literal] = ACTIONS(343),
    [sym_binary_integer_literal] = ACTIONS(343),
    [sym_decimal_floating_point_literal] = ACTIONS(343),
    [sym_hex_floating_point_literal] = ACTIONS(345),
    [sym_true] = ACTIONS(345),
    [sym_false] = ACTIONS(345),
    [sym_character_literal] = ACTIONS(343),
    [sym_string_literal] = ACTIONS(345),
    [sym_text_block] = ACTIONS(343),
    [sym_null_literal] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_LT] = ACTIONS(343),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_BANG] = ACTIONS(343),
    [anon_sym_TILDE] = ACTIONS(343),
    [anon_sym_PLUS_PLUS] = ACTIONS(343),
    [anon_sym_DASH_DASH] = ACTIONS(343),
    [anon_sym_new] = ACTIONS(345),
    [anon_sym_class] = ACTIONS(345),
    [anon_sym_switch] = ACTIONS(345),
    [anon_sym_LBRACE] = ACTIONS(343),
    [anon_sym_RBRACE] = ACTIONS(343),
    [anon_sym_case] = ACTIONS(345),
    [anon_sym_default] = ACTIONS(345),
    [anon_sym_SEMI] = ACTIONS(343),
    [anon_sym_assert] = ACTIONS(345),
    [anon_sym_do] = ACTIONS(345),
    [anon_sym_while] = ACTIONS(345),
    [anon_sym_break] = ACTIONS(345),
    [anon_sym_continue] = ACTIONS(345),
    [anon_sym_return] = ACTIONS(345),
    [anon_sym_yield] = ACTIONS(345),
    [anon_sym_synchronized] = ACTIONS(345),
    [anon_sym_throw] = ACTIONS(345),
    [anon_sym_try] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_else] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(345),
    [anon_sym_AT] = ACTIONS(345),
    [anon_sym_open] = ACTIONS(345),
    [anon_sym_module] = ACTIONS(345),
    [anon_sym_static] = ACTIONS(345),
    [anon_sym_package] = ACTIONS(345),
    [anon_sym_import] = ACTIONS(345),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_public] = ACTIONS(345),
    [anon_sym_protected] = ACTIONS(345),
    [anon_sym_private] = ACTIONS(345),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_final] = ACTIONS(345),
    [anon_sym_strictfp] = ACTIONS(345),
    [anon_sym_native] = ACTIONS(345),
    [anon_sym_transient] = ACTIONS(345),
    [anon_sym_volatile] = ACTIONS(345),
    [anon_sym_sealed] = ACTIONS(345),
    [anon_sym_non_DASHsealed] = ACTIONS(343),
    [anon_sym_record] = ACTIONS(345),
    [anon_sym_ATinterface] = ACTIONS(343),
    [anon_sym_interface] = ACTIONS(345),
    [anon_sym_byte] = ACTIONS(345),
    [anon_sym_short] = ACTIONS(345),
    [anon_sym_int] = ACTIONS(345),
    [anon_sym_long] = ACTIONS(345),
    [anon_sym_char] = ACTIONS(345),
    [anon_sym_float] = ACTIONS(345),
    [anon_sym_double] = ACTIONS(345),
    [sym_boolean_type] = ACTIONS(345),
    [sym_void_type] = ACTIONS(345),
    [sym_this] = ACTIONS(345),
    [sym_super] = ACTIONS(345),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(347),
    [sym_identifier] = ACTIONS(349),
    [sym_decimal_integer_literal] = ACTIONS(349),
    [sym_hex_integer_literal] = ACTIONS(349),
    [sym_octal_integer_literal] = ACTIONS(347),
    [sym_binary_integer_literal] = ACTIONS(347),
    [sym_decimal_floating_point_literal] = ACTIONS(347),
    [sym_hex_floating_point_literal] = ACTIONS(349),
    [sym_true] = ACTIONS(349),
    [sym_false] = ACTIONS(349),
    [sym_character_literal] = ACTIONS(347),
    [sym_string_literal] = ACTIONS(349),
    [sym_text_block] = ACTIONS(347),
    [sym_null_literal] = ACTIONS(349),
    [anon_sym_LPAREN] = ACTIONS(347),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_PLUS] = ACTIONS(349),
    [anon_sym_DASH] = ACTIONS(349),
    [anon_sym_BANG] = ACTIONS(347),
    [anon_sym_TILDE] = ACTIONS(347),
    [anon_sym_PLUS_PLUS] = ACTIONS(347),
    [anon_sym_DASH_DASH] = ACTIONS(347),
    [anon_sym_new] = ACTIONS(349),
    [anon_sym_class] = ACTIONS(349),
    [anon_sym_switch] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(347),
    [anon_sym_RBRACE] = ACTIONS(347),
    [anon_sym_case] = ACTIONS(349),
    [anon_sym_default] = ACTIONS(349),
    [anon_sym_SEMI] = ACTIONS(347),
    [anon_sym_assert] = ACTIONS(349),
    [anon_sym_do] = ACTIONS(349),
    [anon_sym_while] = ACTIONS(349),
    [anon_sym_break] = ACTIONS(349),
    [anon_sym_continue] = ACTIONS(349),
    [anon_sym_return] = ACTIONS(349),
    [anon_sym_yield] = ACTIONS(349),
    [anon_sym_synchronized] = ACTIONS(349),
    [anon_sym_throw] = ACTIONS(349),
    [anon_sym_try] = ACTIONS(349),
    [anon_sym_if] = ACTIONS(349),
    [anon_sym_else] = ACTIONS(349),
    [anon_sym_for] = ACTIONS(349),
    [anon_sym_AT] = ACTIONS(349),
    [anon_sym_open] = ACTIONS(349),
    [anon_sym_module] = ACTIONS(349),
    [anon_sym_static] = ACTIONS(349),
    [anon_sym_package] = ACTIONS(349),
    [anon_sym_import] = ACTIONS(349),
    [anon_sym_enum] = ACTIONS(349),
    [anon_sym_public] = ACTIONS(349),
    [anon_sym_protected] = ACTIONS(349),
    [anon_sym_private] = ACTIONS(349),
    [anon_sym_abstract] = ACTIONS(349),
    [anon_sym_final] = ACTIONS(349),
    [anon_sym_strictfp] = ACTIONS(349),
    [anon_sym_native] = ACTIONS(349),
    [anon_sym_transient] = ACTIONS(349),
    [anon_sym_volatile] = ACTIONS(349),
    [anon_sym_sealed] = ACTIONS(349),
    [anon_sym_non_DASHsealed] = ACTIONS(347),
    [anon_sym_record] = ACTIONS(349),
    [anon_sym_ATinterface] = ACTIONS(347),
    [anon_sym_interface] = ACTIONS(349),
    [anon_sym_byte] = ACTIONS(349),
    [anon_sym_short] = ACTIONS(349),
    [anon_sym_int] = ACTIONS(349),
    [anon_sym_long] = ACTIONS(349),
    [anon_sym_char] = ACTIONS(349),
    [anon_sym_float] = ACTIONS(349),
    [anon_sym_double] = ACTIONS(349),
    [sym_boolean_type] = ACTIONS(349),
    [sym_void_type] = ACTIONS(349),
    [sym_this] = ACTIONS(349),
    [sym_super] = ACTIONS(349),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(351),
    [sym_identifier] = ACTIONS(353),
    [sym_decimal_integer_literal] = ACTIONS(353),
    [sym_hex_integer_literal] = ACTIONS(353),
    [sym_octal_integer_literal] = ACTIONS(351),
    [sym_binary_integer_literal] = ACTIONS(351),
    [sym_decimal_floating_point_literal] = ACTIONS(351),
    [sym_hex_floating_point_literal] = ACTIONS(353),
    [sym_true] = ACTIONS(353),
    [sym_false] = ACTIONS(353),
    [sym_character_literal] = ACTIONS(351),
    [sym_string_literal] = ACTIONS(353),
    [sym_text_block] = ACTIONS(351),
    [sym_null_literal] = ACTIONS(353),
    [anon_sym_LPAREN] = ACTIONS(351),
    [anon_sym_LT] = ACTIONS(351),
    [anon_sym_PLUS] = ACTIONS(353),
    [anon_sym_DASH] = ACTIONS(353),
    [anon_sym_BANG] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_PLUS_PLUS] = ACTIONS(351),
    [anon_sym_DASH_DASH] = ACTIONS(351),
    [anon_sym_new] = ACTIONS(353),
    [anon_sym_class] = ACTIONS(353),
    [anon_sym_switch] = ACTIONS(353),
    [anon_sym_LBRACE] = ACTIONS(351),
    [anon_sym_RBRACE] = ACTIONS(351),
    [anon_sym_case] = ACTIONS(353),
    [anon_sym_default] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(351),
    [anon_sym_assert] = ACTIONS(353),
    [anon_sym_do] = ACTIONS(353),
    [anon_sym_while] = ACTIONS(353),
    [anon_sym_break] = ACTIONS(353),
    [anon_sym_continue] = ACTIONS(353),
    [anon_sym_return] = ACTIONS(353),
    [anon_sym_yield] = ACTIONS(353),
    [anon_sym_synchronized] = ACTIONS(353),
    [anon_sym_throw] = ACTIONS(353),
    [anon_sym_try] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(353),
    [anon_sym_else] = ACTIONS(353),
    [anon_sym_for] = ACTIONS(353),
    [anon_sym_AT] = ACTIONS(353),
    [anon_sym_open] = ACTIONS(353),
    [anon_sym_module] = ACTIONS(353),
    [anon_sym_static] = ACTIONS(353),
    [anon_sym_package] = ACTIONS(353),
    [anon_sym_import] = ACTIONS(353),
    [anon_sym_enum] = ACTIONS(353),
    [anon_sym_public] = ACTIONS(353),
    [anon_sym_protected] = ACTIONS(353),
    [anon_sym_private] = ACTIONS(353),
    [anon_sym_abstract] = ACTIONS(353),
    [anon_sym_final] = ACTIONS(353),
    [anon_sym_strictfp] = ACTIONS(353),
    [anon_sym_native] = ACTIONS(353),
    [anon_sym_transient] = ACTIONS(353),
    [anon_sym_volatile] = ACTIONS(353),
    [anon_sym_sealed] = ACTIONS(353),
    [anon_sym_non_DASHsealed] = ACTIONS(351),
    [anon_sym_record] = ACTIONS(353),
    [anon_sym_ATinterface] = ACTIONS(351),
    [anon_sym_interface] = ACTIONS(353),
    [anon_sym_byte] = ACTIONS(353),
    [anon_sym_short] = ACTIONS(353),
    [anon_sym_int] = ACTIONS(353),
    [anon_sym_long] = ACTIONS(353),
    [anon_sym_char] = ACTIONS(353),
    [anon_sym_float] = ACTIONS(353),
    [anon_sym_double] = ACTIONS(353),
    [sym_boolean_type] = ACTIONS(353),
    [sym_void_type] = ACTIONS(353),
    [sym_this] = ACTIONS(353),
    [sym_super] = ACTIONS(353),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_decimal_integer_literal] = ACTIONS(357),
    [sym_hex_integer_literal] = ACTIONS(357),
    [sym_octal_integer_literal] = ACTIONS(355),
    [sym_binary_integer_literal] = ACTIONS(355),
    [sym_decimal_floating_point_literal] = ACTIONS(355),
    [sym_hex_floating_point_literal] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_character_literal] = ACTIONS(355),
    [sym_string_literal] = ACTIONS(357),
    [sym_text_block] = ACTIONS(355),
    [sym_null_literal] = ACTIONS(357),
    [anon_sym_LPAREN] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_PLUS] = ACTIONS(357),
    [anon_sym_DASH] = ACTIONS(357),
    [anon_sym_BANG] = ACTIONS(355),
    [anon_sym_TILDE] = ACTIONS(355),
    [anon_sym_PLUS_PLUS] = ACTIONS(355),
    [anon_sym_DASH_DASH] = ACTIONS(355),
    [anon_sym_new] = ACTIONS(357),
    [anon_sym_class] = ACTIONS(357),
    [anon_sym_switch] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(355),
    [anon_sym_RBRACE] = ACTIONS(355),
    [anon_sym_case] = ACTIONS(357),
    [anon_sym_default] = ACTIONS(357),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_assert] = ACTIONS(357),
    [anon_sym_do] = ACTIONS(357),
    [anon_sym_while] = ACTIONS(357),
    [anon_sym_break] = ACTIONS(357),
    [anon_sym_continue] = ACTIONS(357),
    [anon_sym_return] = ACTIONS(357),
    [anon_sym_yield] = ACTIONS(357),
    [anon_sym_synchronized] = ACTIONS(357),
    [anon_sym_throw] = ACTIONS(357),
    [anon_sym_try] = ACTIONS(357),
    [anon_sym_if] = ACTIONS(357),
    [anon_sym_else] = ACTIONS(357),
    [anon_sym_for] = ACTIONS(357),
    [anon_sym_AT] = ACTIONS(357),
    [anon_sym_open] = ACTIONS(357),
    [anon_sym_module] = ACTIONS(357),
    [anon_sym_static] = ACTIONS(357),
    [anon_sym_package] = ACTIONS(357),
    [anon_sym_import] = ACTIONS(357),
    [anon_sym_enum] = ACTIONS(357),
    [anon_sym_public] = ACTIONS(357),
    [anon_sym_protected] = ACTIONS(357),
    [anon_sym_private] = ACTIONS(357),
    [anon_sym_abstract] = ACTIONS(357),
    [anon_sym_final] = ACTIONS(357),
    [anon_sym_strictfp] = ACTIONS(357),
    [anon_sym_native] = ACTIONS(357),
    [anon_sym_transient] = ACTIONS(357),
    [anon_sym_volatile] = ACTIONS(357),
    [anon_sym_sealed] = ACTIONS(357),
    [anon_sym_non_DASHsealed] = ACTIONS(355),
    [anon_sym_record] = ACTIONS(357),
    [anon_sym_ATinterface] = ACTIONS(355),
    [anon_sym_interface] = ACTIONS(357),
    [anon_sym_byte] = ACTIONS(357),
    [anon_sym_short] = ACTIONS(357),
    [anon_sym_int] = ACTIONS(357),
    [anon_sym_long] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_float] = ACTIONS(357),
    [anon_sym_double] = ACTIONS(357),
    [sym_boolean_type] = ACTIONS(357),
    [sym_void_type] = ACTIONS(357),
    [sym_this] = ACTIONS(357),
    [sym_super] = ACTIONS(357),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [73] = {
    [ts_builtin_sym_end] = ACTIONS(359),
    [sym_identifier] = ACTIONS(361),
    [sym_decimal_integer_literal] = ACTIONS(361),
    [sym_hex_integer_literal] = ACTIONS(361),
    [sym_octal_integer_literal] = ACTIONS(359),
    [sym_binary_integer_literal] = ACTIONS(359),
    [sym_decimal_floating_point_literal] = ACTIONS(359),
    [sym_hex_floating_point_literal] = ACTIONS(361),
    [sym_true] = ACTIONS(361),
    [sym_false] = ACTIONS(361),
    [sym_character_literal] = ACTIONS(359),
    [sym_string_literal] = ACTIONS(361),
    [sym_text_block] = ACTIONS(359),
    [sym_null_literal] = ACTIONS(361),
    [anon_sym_LPAREN] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(361),
    [anon_sym_DASH] = ACTIONS(361),
    [anon_sym_BANG] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(359),
    [anon_sym_DASH_DASH] = ACTIONS(359),
    [anon_sym_new] = ACTIONS(361),
    [anon_sym_class] = ACTIONS(361),
    [anon_sym_switch] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(359),
    [anon_sym_RBRACE] = ACTIONS(359),
    [anon_sym_case] = ACTIONS(361),
    [anon_sym_default] = ACTIONS(361),
    [anon_sym_SEMI] = ACTIONS(359),
    [anon_sym_assert] = ACTIONS(361),
    [anon_sym_do] = ACTIONS(361),
    [anon_sym_while] = ACTIONS(361),
    [anon_sym_break] = ACTIONS(361),
    [anon_sym_continue] = ACTIONS(361),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_yield] = ACTIONS(361),
    [anon_sym_synchronized] = ACTIONS(361),
    [anon_sym_throw] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(361),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_else] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(361),
    [anon_sym_AT] = ACTIONS(361),
    [anon_sym_open] = ACTIONS(361),
    [anon_sym_module] = ACTIONS(361),
    [anon_sym_static] = ACTIONS(361),
    [anon_sym_package] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(361),
    [anon_sym_enum] = ACTIONS(361),
    [anon_sym_public] = ACTIONS(361),
    [anon_sym_protected] = ACTIONS(361),
    [anon_sym_private] = ACTIONS(361),
    [anon_sym_abstract] = ACTIONS(361),
    [anon_sym_final] = ACTIONS(361),
    [anon_sym_strictfp] = ACTIONS(361),
    [anon_sym_native] = ACTIONS(361),
    [anon_sym_transient] = ACTIONS(361),
    [anon_sym_volatile] = ACTIONS(361),
    [anon_sym_sealed] = ACTIONS(361),
    [anon_sym_non_DASHsealed] = ACTIONS(359),
    [anon_sym_record] = ACTIONS(361),
    [anon_sym_ATinterface] = ACTIONS(359),
    [anon_sym_interface] = ACTIONS(361),
    [anon_sym_byte] = ACTIONS(361),
    [anon_sym_short] = ACTIONS(361),
    [anon_sym_int] = ACTIONS(361),
    [anon_sym_long] = ACTIONS(361),
    [anon_sym_char] = ACTIONS(361),
    [anon_sym_float] = ACTIONS(361),
    [anon_sym_double] = ACTIONS(361),
    [sym_boolean_type] = ACTIONS(361),
    [sym_void_type] = ACTIONS(361),
    [sym_this] = ACTIONS(361),
    [sym_super] = ACTIONS(361),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [74] = {
    [ts_builtin_sym_end] = ACTIONS(363),
    [sym_identifier] = ACTIONS(365),
    [sym_decimal_integer_literal] = ACTIONS(365),
    [sym_hex_integer_literal] = ACTIONS(365),
    [sym_octal_integer_literal] = ACTIONS(363),
    [sym_binary_integer_literal] = ACTIONS(363),
    [sym_decimal_floating_point_literal] = ACTIONS(363),
    [sym_hex_floating_point_literal] = ACTIONS(365),
    [sym_true] = ACTIONS(365),
    [sym_false] = ACTIONS(365),
    [sym_character_literal] = ACTIONS(363),
    [sym_string_literal] = ACTIONS(365),
    [sym_text_block] = ACTIONS(363),
    [sym_null_literal] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(365),
    [anon_sym_DASH] = ACTIONS(365),
    [anon_sym_BANG] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(363),
    [anon_sym_PLUS_PLUS] = ACTIONS(363),
    [anon_sym_DASH_DASH] = ACTIONS(363),
    [anon_sym_new] = ACTIONS(365),
    [anon_sym_class] = ACTIONS(365),
    [anon_sym_switch] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_case] = ACTIONS(365),
    [anon_sym_default] = ACTIONS(365),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_assert] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_break] = ACTIONS(365),
    [anon_sym_continue] = ACTIONS(365),
    [anon_sym_return] = ACTIONS(365),
    [anon_sym_yield] = ACTIONS(365),
    [anon_sym_synchronized] = ACTIONS(365),
    [anon_sym_throw] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(365),
    [anon_sym_if] = ACTIONS(365),
    [anon_sym_else] = ACTIONS(365),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_AT] = ACTIONS(365),
    [anon_sym_open] = ACTIONS(365),
    [anon_sym_module] = ACTIONS(365),
    [anon_sym_static] = ACTIONS(365),
    [anon_sym_package] = ACTIONS(365),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_enum] = ACTIONS(365),
    [anon_sym_public] = ACTIONS(365),
    [anon_sym_protected] = ACTIONS(365),
    [anon_sym_private] = ACTIONS(365),
    [anon_sym_abstract] = ACTIONS(365),
    [anon_sym_final] = ACTIONS(365),
    [anon_sym_strictfp] = ACTIONS(365),
    [anon_sym_native] = ACTIONS(365),
    [anon_sym_transient] = ACTIONS(365),
    [anon_sym_volatile] = ACTIONS(365),
    [anon_sym_sealed] = ACTIONS(365),
    [anon_sym_non_DASHsealed] = ACTIONS(363),
    [anon_sym_record] = ACTIONS(365),
    [anon_sym_ATinterface] = ACTIONS(363),
    [anon_sym_interface] = ACTIONS(365),
    [anon_sym_byte] = ACTIONS(365),
    [anon_sym_short] = ACTIONS(365),
    [anon_sym_int] = ACTIONS(365),
    [anon_sym_long] = ACTIONS(365),
    [anon_sym_char] = ACTIONS(365),
    [anon_sym_float] = ACTIONS(365),
    [anon_sym_double] = ACTIONS(365),
    [sym_boolean_type] = ACTIONS(365),
    [sym_void_type] = ACTIONS(365),
    [sym_this] = ACTIONS(365),
    [sym_super] = ACTIONS(365),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [75] = {
    [ts_builtin_sym_end] = ACTIONS(367),
    [sym_identifier] = ACTIONS(369),
    [sym_decimal_integer_literal] = ACTIONS(369),
    [sym_hex_integer_literal] = ACTIONS(369),
    [sym_octal_integer_literal] = ACTIONS(367),
    [sym_binary_integer_literal] = ACTIONS(367),
    [sym_decimal_floating_point_literal] = ACTIONS(367),
    [sym_hex_floating_point_literal] = ACTIONS(369),
    [sym_true] = ACTIONS(369),
    [sym_false] = ACTIONS(369),
    [sym_character_literal] = ACTIONS(367),
    [sym_string_literal] = ACTIONS(369),
    [sym_text_block] = ACTIONS(367),
    [sym_null_literal] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_LT] = ACTIONS(367),
    [anon_sym_PLUS] = ACTIONS(369),
    [anon_sym_DASH] = ACTIONS(369),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_TILDE] = ACTIONS(367),
    [anon_sym_PLUS_PLUS] = ACTIONS(367),
    [anon_sym_DASH_DASH] = ACTIONS(367),
    [anon_sym_new] = ACTIONS(369),
    [anon_sym_class] = ACTIONS(369),
    [anon_sym_switch] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_case] = ACTIONS(369),
    [anon_sym_default] = ACTIONS(369),
    [anon_sym_SEMI] = ACTIONS(367),
    [anon_sym_assert] = ACTIONS(369),
    [anon_sym_do] = ACTIONS(369),
    [anon_sym_while] = ACTIONS(369),
    [anon_sym_break] = ACTIONS(369),
    [anon_sym_continue] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(369),
    [anon_sym_synchronized] = ACTIONS(369),
    [anon_sym_throw] = ACTIONS(369),
    [anon_sym_try] = ACTIONS(369),
    [anon_sym_if] = ACTIONS(369),
    [anon_sym_else] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(369),
    [anon_sym_AT] = ACTIONS(369),
    [anon_sym_open] = ACTIONS(369),
    [anon_sym_module] = ACTIONS(369),
    [anon_sym_static] = ACTIONS(369),
    [anon_sym_package] = ACTIONS(369),
    [anon_sym_import] = ACTIONS(369),
    [anon_sym_enum] = ACTIONS(369),
    [anon_sym_public] = ACTIONS(369),
    [anon_sym_protected] = ACTIONS(369),
    [anon_sym_private] = ACTIONS(369),
    [anon_sym_abstract] = ACTIONS(369),
    [anon_sym_final] = ACTIONS(369),
    [anon_sym_strictfp] = ACTIONS(369),
    [anon_sym_native] = ACTIONS(369),
    [anon_sym_transient] = ACTIONS(369),
    [anon_sym_volatile] = ACTIONS(369),
    [anon_sym_sealed] = ACTIONS(369),
    [anon_sym_non_DASHsealed] = ACTIONS(367),
    [anon_sym_record] = ACTIONS(369),
    [anon_sym_ATinterface] = ACTIONS(367),
    [anon_sym_interface] = ACTIONS(369),
    [anon_sym_byte] = ACTIONS(369),
    [anon_sym_short] = ACTIONS(369),
    [anon_sym_int] = ACTIONS(369),
    [anon_sym_long] = ACTIONS(369),
    [anon_sym_char] = ACTIONS(369),
    [anon_sym_float] = ACTIONS(369),
    [anon_sym_double] = ACTIONS(369),
    [sym_boolean_type] = ACTIONS(369),
    [sym_void_type] = ACTIONS(369),
    [sym_this] = ACTIONS(369),
    [sym_super] = ACTIONS(369),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(371),
    [sym_identifier] = ACTIONS(373),
    [sym_decimal_integer_literal] = ACTIONS(373),
    [sym_hex_integer_literal] = ACTIONS(373),
    [sym_octal_integer_literal] = ACTIONS(371),
    [sym_binary_integer_literal] = ACTIONS(371),
    [sym_decimal_floating_point_literal] = ACTIONS(371),
    [sym_hex_floating_point_literal] = ACTIONS(373),
    [sym_true] = ACTIONS(373),
    [sym_false] = ACTIONS(373),
    [sym_character_literal] = ACTIONS(371),
    [sym_string_literal] = ACTIONS(373),
    [sym_text_block] = ACTIONS(371),
    [sym_null_literal] = ACTIONS(373),
    [anon_sym_LPAREN] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(373),
    [anon_sym_DASH] = ACTIONS(373),
    [anon_sym_BANG] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(371),
    [anon_sym_PLUS_PLUS] = ACTIONS(371),
    [anon_sym_DASH_DASH] = ACTIONS(371),
    [anon_sym_new] = ACTIONS(373),
    [anon_sym_class] = ACTIONS(373),
    [anon_sym_switch] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(371),
    [anon_sym_RBRACE] = ACTIONS(371),
    [anon_sym_case] = ACTIONS(373),
    [anon_sym_default] = ACTIONS(373),
    [anon_sym_SEMI] = ACTIONS(371),
    [anon_sym_assert] = ACTIONS(373),
    [anon_sym_do] = ACTIONS(373),
    [anon_sym_while] = ACTIONS(373),
    [anon_sym_break] = ACTIONS(373),
    [anon_sym_continue] = ACTIONS(373),
    [anon_sym_return] = ACTIONS(373),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_synchronized] = ACTIONS(373),
    [anon_sym_throw] = ACTIONS(373),
    [anon_sym_try] = ACTIONS(373),
    [anon_sym_if] = ACTIONS(373),
    [anon_sym_else] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(373),
    [anon_sym_AT] = ACTIONS(373),
    [anon_sym_open] = ACTIONS(373),
    [anon_sym_module] = ACTIONS(373),
    [anon_sym_static] = ACTIONS(373),
    [anon_sym_package] = ACTIONS(373),
    [anon_sym_import] = ACTIONS(373),
    [anon_sym_enum] = ACTIONS(373),
    [anon_sym_public] = ACTIONS(373),
    [anon_sym_protected] = ACTIONS(373),
    [anon_sym_private] = ACTIONS(373),
    [anon_sym_abstract] = ACTIONS(373),
    [anon_sym_final] = ACTIONS(373),
    [anon_sym_strictfp] = ACTIONS(373),
    [anon_sym_native] = ACTIONS(373),
    [anon_sym_transient] = ACTIONS(373),
    [anon_sym_volatile] = ACTIONS(373),
    [anon_sym_sealed] = ACTIONS(373),
    [anon_sym_non_DASHsealed] = ACTIONS(371),
    [anon_sym_record] = ACTIONS(373),
    [anon_sym_ATinterface] = ACTIONS(371),
    [anon_sym_interface] = ACTIONS(373),
    [anon_sym_byte] = ACTIONS(373),
    [anon_sym_short] = ACTIONS(373),
    [anon_sym_int] = ACTIONS(373),
    [anon_sym_long] = ACTIONS(373),
    [anon_sym_char] = ACTIONS(373),
    [anon_sym_float] = ACTIONS(373),
    [anon_sym_double] = ACTIONS(373),
    [sym_boolean_type] = ACTIONS(373),
    [sym_void_type] = ACTIONS(373),
    [sym_this] = ACTIONS(373),
    [sym_super] = ACTIONS(373),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(375),
    [sym_identifier] = ACTIONS(377),
    [sym_decimal_integer_literal] = ACTIONS(377),
    [sym_hex_integer_literal] = ACTIONS(377),
    [sym_octal_integer_literal] = ACTIONS(375),
    [sym_binary_integer_literal] = ACTIONS(375),
    [sym_decimal_floating_point_literal] = ACTIONS(375),
    [sym_hex_floating_point_literal] = ACTIONS(377),
    [sym_true] = ACTIONS(377),
    [sym_false] = ACTIONS(377),
    [sym_character_literal] = ACTIONS(375),
    [sym_string_literal] = ACTIONS(377),
    [sym_text_block] = ACTIONS(375),
    [sym_null_literal] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(377),
    [anon_sym_DASH] = ACTIONS(377),
    [anon_sym_BANG] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(375),
    [anon_sym_PLUS_PLUS] = ACTIONS(375),
    [anon_sym_DASH_DASH] = ACTIONS(375),
    [anon_sym_new] = ACTIONS(377),
    [anon_sym_class] = ACTIONS(377),
    [anon_sym_switch] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(375),
    [anon_sym_RBRACE] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(377),
    [anon_sym_default] = ACTIONS(377),
    [anon_sym_SEMI] = ACTIONS(375),
    [anon_sym_assert] = ACTIONS(377),
    [anon_sym_do] = ACTIONS(377),
    [anon_sym_while] = ACTIONS(377),
    [anon_sym_break] = ACTIONS(377),
    [anon_sym_continue] = ACTIONS(377),
    [anon_sym_return] = ACTIONS(377),
    [anon_sym_yield] = ACTIONS(377),
    [anon_sym_synchronized] = ACTIONS(377),
    [anon_sym_throw] = ACTIONS(377),
    [anon_sym_try] = ACTIONS(377),
    [anon_sym_if] = ACTIONS(377),
    [anon_sym_else] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(377),
    [anon_sym_AT] = ACTIONS(377),
    [anon_sym_open] = ACTIONS(377),
    [anon_sym_module] = ACTIONS(377),
    [anon_sym_static] = ACTIONS(377),
    [anon_sym_package] = ACTIONS(377),
    [anon_sym_import] = ACTIONS(377),
    [anon_sym_enum] = ACTIONS(377),
    [anon_sym_public] = ACTIONS(377),
    [anon_sym_protected] = ACTIONS(377),
    [anon_sym_private] = ACTIONS(377),
    [anon_sym_abstract] = ACTIONS(377),
    [anon_sym_final] = ACTIONS(377),
    [anon_sym_strictfp] = ACTIONS(377),
    [anon_sym_native] = ACTIONS(377),
    [anon_sym_transient] = ACTIONS(377),
    [anon_sym_volatile] = ACTIONS(377),
    [anon_sym_sealed] = ACTIONS(377),
    [anon_sym_non_DASHsealed] = ACTIONS(375),
    [anon_sym_record] = ACTIONS(377),
    [anon_sym_ATinterface] = ACTIONS(375),
    [anon_sym_interface] = ACTIONS(377),
    [anon_sym_byte] = ACTIONS(377),
    [anon_sym_short] = ACTIONS(377),
    [anon_sym_int] = ACTIONS(377),
    [anon_sym_long] = ACTIONS(377),
    [anon_sym_char] = ACTIONS(377),
    [anon_sym_float] = ACTIONS(377),
    [anon_sym_double] = ACTIONS(377),
    [sym_boolean_type] = ACTIONS(377),
    [sym_void_type] = ACTIONS(377),
    [sym_this] = ACTIONS(377),
    [sym_super] = ACTIONS(377),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(379),
    [sym_identifier] = ACTIONS(381),
    [sym_decimal_integer_literal] = ACTIONS(381),
    [sym_hex_integer_literal] = ACTIONS(381),
    [sym_octal_integer_literal] = ACTIONS(379),
    [sym_binary_integer_literal] = ACTIONS(379),
    [sym_decimal_floating_point_literal] = ACTIONS(379),
    [sym_hex_floating_point_literal] = ACTIONS(381),
    [sym_true] = ACTIONS(381),
    [sym_false] = ACTIONS(381),
    [sym_character_literal] = ACTIONS(379),
    [sym_string_literal] = ACTIONS(381),
    [sym_text_block] = ACTIONS(379),
    [sym_null_literal] = ACTIONS(381),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_LT] = ACTIONS(379),
    [anon_sym_PLUS] = ACTIONS(381),
    [anon_sym_DASH] = ACTIONS(381),
    [anon_sym_BANG] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(379),
    [anon_sym_PLUS_PLUS] = ACTIONS(379),
    [anon_sym_DASH_DASH] = ACTIONS(379),
    [anon_sym_new] = ACTIONS(381),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_switch] = ACTIONS(381),
    [anon_sym_LBRACE] = ACTIONS(379),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_case] = ACTIONS(381),
    [anon_sym_default] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(379),
    [anon_sym_assert] = ACTIONS(381),
    [anon_sym_do] = ACTIONS(381),
    [anon_sym_while] = ACTIONS(381),
    [anon_sym_break] = ACTIONS(381),
    [anon_sym_continue] = ACTIONS(381),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(381),
    [anon_sym_synchronized] = ACTIONS(381),
    [anon_sym_throw] = ACTIONS(381),
    [anon_sym_try] = ACTIONS(381),
    [anon_sym_if] = ACTIONS(381),
    [anon_sym_else] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(381),
    [anon_sym_AT] = ACTIONS(381),
    [anon_sym_open] = ACTIONS(381),
    [anon_sym_module] = ACTIONS(381),
    [anon_sym_static] = ACTIONS(381),
    [anon_sym_package] = ACTIONS(381),
    [anon_sym_import] = ACTIONS(381),
    [anon_sym_enum] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(381),
    [anon_sym_protected] = ACTIONS(381),
    [anon_sym_private] = ACTIONS(381),
    [anon_sym_abstract] = ACTIONS(381),
    [anon_sym_final] = ACTIONS(381),
    [anon_sym_strictfp] = ACTIONS(381),
    [anon_sym_native] = ACTIONS(381),
    [anon_sym_transient] = ACTIONS(381),
    [anon_sym_volatile] = ACTIONS(381),
    [anon_sym_sealed] = ACTIONS(381),
    [anon_sym_non_DASHsealed] = ACTIONS(379),
    [anon_sym_record] = ACTIONS(381),
    [anon_sym_ATinterface] = ACTIONS(379),
    [anon_sym_interface] = ACTIONS(381),
    [anon_sym_byte] = ACTIONS(381),
    [anon_sym_short] = ACTIONS(381),
    [anon_sym_int] = ACTIONS(381),
    [anon_sym_long] = ACTIONS(381),
    [anon_sym_char] = ACTIONS(381),
    [anon_sym_float] = ACTIONS(381),
    [anon_sym_double] = ACTIONS(381),
    [sym_boolean_type] = ACTIONS(381),
    [sym_void_type] = ACTIONS(381),
    [sym_this] = ACTIONS(381),
    [sym_super] = ACTIONS(381),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(383),
    [sym_identifier] = ACTIONS(385),
    [sym_decimal_integer_literal] = ACTIONS(385),
    [sym_hex_integer_literal] = ACTIONS(385),
    [sym_octal_integer_literal] = ACTIONS(383),
    [sym_binary_integer_literal] = ACTIONS(383),
    [sym_decimal_floating_point_literal] = ACTIONS(383),
    [sym_hex_floating_point_literal] = ACTIONS(385),
    [sym_true] = ACTIONS(385),
    [sym_false] = ACTIONS(385),
    [sym_character_literal] = ACTIONS(383),
    [sym_string_literal] = ACTIONS(385),
    [sym_text_block] = ACTIONS(383),
    [sym_null_literal] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(383),
    [anon_sym_PLUS] = ACTIONS(385),
    [anon_sym_DASH] = ACTIONS(385),
    [anon_sym_BANG] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(383),
    [anon_sym_DASH_DASH] = ACTIONS(383),
    [anon_sym_new] = ACTIONS(385),
    [anon_sym_class] = ACTIONS(385),
    [anon_sym_switch] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(383),
    [anon_sym_RBRACE] = ACTIONS(383),
    [anon_sym_case] = ACTIONS(385),
    [anon_sym_default] = ACTIONS(385),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_assert] = ACTIONS(385),
    [anon_sym_do] = ACTIONS(385),
    [anon_sym_while] = ACTIONS(385),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_continue] = ACTIONS(385),
    [anon_sym_return] = ACTIONS(385),
    [anon_sym_yield] = ACTIONS(385),
    [anon_sym_synchronized] = ACTIONS(385),
    [anon_sym_throw] = ACTIONS(385),
    [anon_sym_try] = ACTIONS(385),
    [anon_sym_if] = ACTIONS(385),
    [anon_sym_else] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(385),
    [anon_sym_AT] = ACTIONS(385),
    [anon_sym_open] = ACTIONS(385),
    [anon_sym_module] = ACTIONS(385),
    [anon_sym_static] = ACTIONS(385),
    [anon_sym_package] = ACTIONS(385),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_enum] = ACTIONS(385),
    [anon_sym_public] = ACTIONS(385),
    [anon_sym_protected] = ACTIONS(385),
    [anon_sym_private] = ACTIONS(385),
    [anon_sym_abstract] = ACTIONS(385),
    [anon_sym_final] = ACTIONS(385),
    [anon_sym_strictfp] = ACTIONS(385),
    [anon_sym_native] = ACTIONS(385),
    [anon_sym_transient] = ACTIONS(385),
    [anon_sym_volatile] = ACTIONS(385),
    [anon_sym_sealed] = ACTIONS(385),
    [anon_sym_non_DASHsealed] = ACTIONS(383),
    [anon_sym_record] = ACTIONS(385),
    [anon_sym_ATinterface] = ACTIONS(383),
    [anon_sym_interface] = ACTIONS(385),
    [anon_sym_byte] = ACTIONS(385),
    [anon_sym_short] = ACTIONS(385),
    [anon_sym_int] = ACTIONS(385),
    [anon_sym_long] = ACTIONS(385),
    [anon_sym_char] = ACTIONS(385),
    [anon_sym_float] = ACTIONS(385),
    [anon_sym_double] = ACTIONS(385),
    [sym_boolean_type] = ACTIONS(385),
    [sym_void_type] = ACTIONS(385),
    [sym_this] = ACTIONS(385),
    [sym_super] = ACTIONS(385),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [80] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym__element_value] = STATE(975),
    [sym_element_value_array_initializer] = STATE(975),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_identifier] = ACTIONS(391),
    [sym_decimal_integer_literal] = ACTIONS(391),
    [sym_hex_integer_literal] = ACTIONS(391),
    [sym_octal_integer_literal] = ACTIONS(389),
    [sym_binary_integer_literal] = ACTIONS(389),
    [sym_decimal_floating_point_literal] = ACTIONS(389),
    [sym_hex_floating_point_literal] = ACTIONS(391),
    [sym_true] = ACTIONS(391),
    [sym_false] = ACTIONS(391),
    [sym_character_literal] = ACTIONS(389),
    [sym_string_literal] = ACTIONS(391),
    [sym_text_block] = ACTIONS(389),
    [sym_null_literal] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_TILDE] = ACTIONS(389),
    [anon_sym_PLUS_PLUS] = ACTIONS(389),
    [anon_sym_DASH_DASH] = ACTIONS(389),
    [anon_sym_new] = ACTIONS(391),
    [anon_sym_class] = ACTIONS(391),
    [anon_sym_switch] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_case] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_assert] = ACTIONS(391),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(391),
    [anon_sym_break] = ACTIONS(391),
    [anon_sym_continue] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(391),
    [anon_sym_yield] = ACTIONS(391),
    [anon_sym_synchronized] = ACTIONS(391),
    [anon_sym_throw] = ACTIONS(391),
    [anon_sym_try] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_else] = ACTIONS(391),
    [anon_sym_for] = ACTIONS(391),
    [anon_sym_AT] = ACTIONS(391),
    [anon_sym_open] = ACTIONS(391),
    [anon_sym_module] = ACTIONS(391),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_package] = ACTIONS(391),
    [anon_sym_import] = ACTIONS(391),
    [anon_sym_enum] = ACTIONS(391),
    [anon_sym_public] = ACTIONS(391),
    [anon_sym_protected] = ACTIONS(391),
    [anon_sym_private] = ACTIONS(391),
    [anon_sym_abstract] = ACTIONS(391),
    [anon_sym_final] = ACTIONS(391),
    [anon_sym_strictfp] = ACTIONS(391),
    [anon_sym_native] = ACTIONS(391),
    [anon_sym_transient] = ACTIONS(391),
    [anon_sym_volatile] = ACTIONS(391),
    [anon_sym_sealed] = ACTIONS(391),
    [anon_sym_non_DASHsealed] = ACTIONS(389),
    [anon_sym_record] = ACTIONS(391),
    [anon_sym_ATinterface] = ACTIONS(389),
    [anon_sym_interface] = ACTIONS(391),
    [anon_sym_byte] = ACTIONS(391),
    [anon_sym_short] = ACTIONS(391),
    [anon_sym_int] = ACTIONS(391),
    [anon_sym_long] = ACTIONS(391),
    [anon_sym_char] = ACTIONS(391),
    [anon_sym_float] = ACTIONS(391),
    [anon_sym_double] = ACTIONS(391),
    [sym_boolean_type] = ACTIONS(391),
    [sym_void_type] = ACTIONS(391),
    [sym_this] = ACTIONS(391),
    [sym_super] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(393),
    [sym_identifier] = ACTIONS(395),
    [sym_decimal_integer_literal] = ACTIONS(395),
    [sym_hex_integer_literal] = ACTIONS(395),
    [sym_octal_integer_literal] = ACTIONS(393),
    [sym_binary_integer_literal] = ACTIONS(393),
    [sym_decimal_floating_point_literal] = ACTIONS(393),
    [sym_hex_floating_point_literal] = ACTIONS(395),
    [sym_true] = ACTIONS(395),
    [sym_false] = ACTIONS(395),
    [sym_character_literal] = ACTIONS(393),
    [sym_string_literal] = ACTIONS(395),
    [sym_text_block] = ACTIONS(393),
    [sym_null_literal] = ACTIONS(395),
    [anon_sym_LPAREN] = ACTIONS(393),
    [anon_sym_LT] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(395),
    [anon_sym_DASH] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_PLUS_PLUS] = ACTIONS(393),
    [anon_sym_DASH_DASH] = ACTIONS(393),
    [anon_sym_new] = ACTIONS(395),
    [anon_sym_class] = ACTIONS(395),
    [anon_sym_switch] = ACTIONS(395),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_case] = ACTIONS(395),
    [anon_sym_default] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(393),
    [anon_sym_assert] = ACTIONS(395),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_while] = ACTIONS(395),
    [anon_sym_break] = ACTIONS(395),
    [anon_sym_continue] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(395),
    [anon_sym_yield] = ACTIONS(395),
    [anon_sym_synchronized] = ACTIONS(395),
    [anon_sym_throw] = ACTIONS(395),
    [anon_sym_try] = ACTIONS(395),
    [anon_sym_if] = ACTIONS(395),
    [anon_sym_else] = ACTIONS(395),
    [anon_sym_for] = ACTIONS(395),
    [anon_sym_AT] = ACTIONS(395),
    [anon_sym_open] = ACTIONS(395),
    [anon_sym_module] = ACTIONS(395),
    [anon_sym_static] = ACTIONS(395),
    [anon_sym_package] = ACTIONS(395),
    [anon_sym_import] = ACTIONS(395),
    [anon_sym_enum] = ACTIONS(395),
    [anon_sym_public] = ACTIONS(395),
    [anon_sym_protected] = ACTIONS(395),
    [anon_sym_private] = ACTIONS(395),
    [anon_sym_abstract] = ACTIONS(395),
    [anon_sym_final] = ACTIONS(395),
    [anon_sym_strictfp] = ACTIONS(395),
    [anon_sym_native] = ACTIONS(395),
    [anon_sym_transient] = ACTIONS(395),
    [anon_sym_volatile] = ACTIONS(395),
    [anon_sym_sealed] = ACTIONS(395),
    [anon_sym_non_DASHsealed] = ACTIONS(393),
    [anon_sym_record] = ACTIONS(395),
    [anon_sym_ATinterface] = ACTIONS(393),
    [anon_sym_interface] = ACTIONS(395),
    [anon_sym_byte] = ACTIONS(395),
    [anon_sym_short] = ACTIONS(395),
    [anon_sym_int] = ACTIONS(395),
    [anon_sym_long] = ACTIONS(395),
    [anon_sym_char] = ACTIONS(395),
    [anon_sym_float] = ACTIONS(395),
    [anon_sym_double] = ACTIONS(395),
    [sym_boolean_type] = ACTIONS(395),
    [sym_void_type] = ACTIONS(395),
    [sym_this] = ACTIONS(395),
    [sym_super] = ACTIONS(395),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(397),
    [sym_identifier] = ACTIONS(399),
    [sym_decimal_integer_literal] = ACTIONS(399),
    [sym_hex_integer_literal] = ACTIONS(399),
    [sym_octal_integer_literal] = ACTIONS(397),
    [sym_binary_integer_literal] = ACTIONS(397),
    [sym_decimal_floating_point_literal] = ACTIONS(397),
    [sym_hex_floating_point_literal] = ACTIONS(399),
    [sym_true] = ACTIONS(399),
    [sym_false] = ACTIONS(399),
    [sym_character_literal] = ACTIONS(397),
    [sym_string_literal] = ACTIONS(399),
    [sym_text_block] = ACTIONS(397),
    [sym_null_literal] = ACTIONS(399),
    [anon_sym_LPAREN] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(397),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_new] = ACTIONS(399),
    [anon_sym_class] = ACTIONS(399),
    [anon_sym_switch] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_case] = ACTIONS(399),
    [anon_sym_default] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(397),
    [anon_sym_assert] = ACTIONS(399),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_while] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(399),
    [anon_sym_continue] = ACTIONS(399),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_yield] = ACTIONS(399),
    [anon_sym_synchronized] = ACTIONS(399),
    [anon_sym_throw] = ACTIONS(399),
    [anon_sym_try] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(399),
    [anon_sym_for] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_open] = ACTIONS(399),
    [anon_sym_module] = ACTIONS(399),
    [anon_sym_static] = ACTIONS(399),
    [anon_sym_package] = ACTIONS(399),
    [anon_sym_import] = ACTIONS(399),
    [anon_sym_enum] = ACTIONS(399),
    [anon_sym_public] = ACTIONS(399),
    [anon_sym_protected] = ACTIONS(399),
    [anon_sym_private] = ACTIONS(399),
    [anon_sym_abstract] = ACTIONS(399),
    [anon_sym_final] = ACTIONS(399),
    [anon_sym_strictfp] = ACTIONS(399),
    [anon_sym_native] = ACTIONS(399),
    [anon_sym_transient] = ACTIONS(399),
    [anon_sym_volatile] = ACTIONS(399),
    [anon_sym_sealed] = ACTIONS(399),
    [anon_sym_non_DASHsealed] = ACTIONS(397),
    [anon_sym_record] = ACTIONS(399),
    [anon_sym_ATinterface] = ACTIONS(397),
    [anon_sym_interface] = ACTIONS(399),
    [anon_sym_byte] = ACTIONS(399),
    [anon_sym_short] = ACTIONS(399),
    [anon_sym_int] = ACTIONS(399),
    [anon_sym_long] = ACTIONS(399),
    [anon_sym_char] = ACTIONS(399),
    [anon_sym_float] = ACTIONS(399),
    [anon_sym_double] = ACTIONS(399),
    [sym_boolean_type] = ACTIONS(399),
    [sym_void_type] = ACTIONS(399),
    [sym_this] = ACTIONS(399),
    [sym_super] = ACTIONS(399),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(401),
    [sym_identifier] = ACTIONS(403),
    [sym_decimal_integer_literal] = ACTIONS(403),
    [sym_hex_integer_literal] = ACTIONS(403),
    [sym_octal_integer_literal] = ACTIONS(401),
    [sym_binary_integer_literal] = ACTIONS(401),
    [sym_decimal_floating_point_literal] = ACTIONS(401),
    [sym_hex_floating_point_literal] = ACTIONS(403),
    [sym_true] = ACTIONS(403),
    [sym_false] = ACTIONS(403),
    [sym_character_literal] = ACTIONS(401),
    [sym_string_literal] = ACTIONS(403),
    [sym_text_block] = ACTIONS(401),
    [sym_null_literal] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_PLUS_PLUS] = ACTIONS(401),
    [anon_sym_DASH_DASH] = ACTIONS(401),
    [anon_sym_new] = ACTIONS(403),
    [anon_sym_class] = ACTIONS(403),
    [anon_sym_switch] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(401),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_case] = ACTIONS(403),
    [anon_sym_default] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_assert] = ACTIONS(403),
    [anon_sym_do] = ACTIONS(403),
    [anon_sym_while] = ACTIONS(403),
    [anon_sym_break] = ACTIONS(403),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(403),
    [anon_sym_yield] = ACTIONS(403),
    [anon_sym_synchronized] = ACTIONS(403),
    [anon_sym_throw] = ACTIONS(403),
    [anon_sym_try] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_else] = ACTIONS(403),
    [anon_sym_for] = ACTIONS(403),
    [anon_sym_AT] = ACTIONS(403),
    [anon_sym_open] = ACTIONS(403),
    [anon_sym_module] = ACTIONS(403),
    [anon_sym_static] = ACTIONS(403),
    [anon_sym_package] = ACTIONS(403),
    [anon_sym_import] = ACTIONS(403),
    [anon_sym_enum] = ACTIONS(403),
    [anon_sym_public] = ACTIONS(403),
    [anon_sym_protected] = ACTIONS(403),
    [anon_sym_private] = ACTIONS(403),
    [anon_sym_abstract] = ACTIONS(403),
    [anon_sym_final] = ACTIONS(403),
    [anon_sym_strictfp] = ACTIONS(403),
    [anon_sym_native] = ACTIONS(403),
    [anon_sym_transient] = ACTIONS(403),
    [anon_sym_volatile] = ACTIONS(403),
    [anon_sym_sealed] = ACTIONS(403),
    [anon_sym_non_DASHsealed] = ACTIONS(401),
    [anon_sym_record] = ACTIONS(403),
    [anon_sym_ATinterface] = ACTIONS(401),
    [anon_sym_interface] = ACTIONS(403),
    [anon_sym_byte] = ACTIONS(403),
    [anon_sym_short] = ACTIONS(403),
    [anon_sym_int] = ACTIONS(403),
    [anon_sym_long] = ACTIONS(403),
    [anon_sym_char] = ACTIONS(403),
    [anon_sym_float] = ACTIONS(403),
    [anon_sym_double] = ACTIONS(403),
    [sym_boolean_type] = ACTIONS(403),
    [sym_void_type] = ACTIONS(403),
    [sym_this] = ACTIONS(403),
    [sym_super] = ACTIONS(403),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_identifier] = ACTIONS(246),
    [sym_decimal_integer_literal] = ACTIONS(246),
    [sym_hex_integer_literal] = ACTIONS(246),
    [sym_octal_integer_literal] = ACTIONS(244),
    [sym_binary_integer_literal] = ACTIONS(244),
    [sym_decimal_floating_point_literal] = ACTIONS(244),
    [sym_hex_floating_point_literal] = ACTIONS(246),
    [sym_true] = ACTIONS(246),
    [sym_false] = ACTIONS(246),
    [sym_character_literal] = ACTIONS(244),
    [sym_string_literal] = ACTIONS(246),
    [sym_text_block] = ACTIONS(244),
    [sym_null_literal] = ACTIONS(246),
    [anon_sym_LPAREN] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(246),
    [anon_sym_DASH] = ACTIONS(246),
    [anon_sym_BANG] = ACTIONS(244),
    [anon_sym_TILDE] = ACTIONS(244),
    [anon_sym_PLUS_PLUS] = ACTIONS(244),
    [anon_sym_DASH_DASH] = ACTIONS(244),
    [anon_sym_new] = ACTIONS(246),
    [anon_sym_class] = ACTIONS(246),
    [anon_sym_switch] = ACTIONS(246),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_case] = ACTIONS(246),
    [anon_sym_default] = ACTIONS(246),
    [anon_sym_SEMI] = ACTIONS(244),
    [anon_sym_assert] = ACTIONS(246),
    [anon_sym_do] = ACTIONS(246),
    [anon_sym_while] = ACTIONS(246),
    [anon_sym_break] = ACTIONS(246),
    [anon_sym_continue] = ACTIONS(246),
    [anon_sym_return] = ACTIONS(246),
    [anon_sym_yield] = ACTIONS(246),
    [anon_sym_synchronized] = ACTIONS(246),
    [anon_sym_throw] = ACTIONS(246),
    [anon_sym_try] = ACTIONS(246),
    [anon_sym_catch] = ACTIONS(246),
    [anon_sym_finally] = ACTIONS(246),
    [anon_sym_if] = ACTIONS(246),
    [anon_sym_else] = ACTIONS(246),
    [anon_sym_for] = ACTIONS(246),
    [anon_sym_AT] = ACTIONS(246),
    [anon_sym_open] = ACTIONS(246),
    [anon_sym_module] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(246),
    [anon_sym_package] = ACTIONS(246),
    [anon_sym_import] = ACTIONS(246),
    [anon_sym_enum] = ACTIONS(246),
    [anon_sym_public] = ACTIONS(246),
    [anon_sym_protected] = ACTIONS(246),
    [anon_sym_private] = ACTIONS(246),
    [anon_sym_abstract] = ACTIONS(246),
    [anon_sym_final] = ACTIONS(246),
    [anon_sym_strictfp] = ACTIONS(246),
    [anon_sym_native] = ACTIONS(246),
    [anon_sym_transient] = ACTIONS(246),
    [anon_sym_volatile] = ACTIONS(246),
    [anon_sym_sealed] = ACTIONS(246),
    [anon_sym_non_DASHsealed] = ACTIONS(244),
    [anon_sym_ATinterface] = ACTIONS(244),
    [anon_sym_interface] = ACTIONS(246),
    [anon_sym_byte] = ACTIONS(246),
    [anon_sym_short] = ACTIONS(246),
    [anon_sym_int] = ACTIONS(246),
    [anon_sym_long] = ACTIONS(246),
    [anon_sym_char] = ACTIONS(246),
    [anon_sym_float] = ACTIONS(246),
    [anon_sym_double] = ACTIONS(246),
    [sym_boolean_type] = ACTIONS(246),
    [sym_void_type] = ACTIONS(246),
    [sym_this] = ACTIONS(246),
    [sym_super] = ACTIONS(246),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(405),
    [sym_identifier] = ACTIONS(407),
    [sym_decimal_integer_literal] = ACTIONS(407),
    [sym_hex_integer_literal] = ACTIONS(407),
    [sym_octal_integer_literal] = ACTIONS(405),
    [sym_binary_integer_literal] = ACTIONS(405),
    [sym_decimal_floating_point_literal] = ACTIONS(405),
    [sym_hex_floating_point_literal] = ACTIONS(407),
    [sym_true] = ACTIONS(407),
    [sym_false] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(405),
    [sym_string_literal] = ACTIONS(407),
    [sym_text_block] = ACTIONS(405),
    [sym_null_literal] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_TILDE] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_class] = ACTIONS(407),
    [anon_sym_switch] = ACTIONS(407),
    [anon_sym_LBRACE] = ACTIONS(405),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_case] = ACTIONS(407),
    [anon_sym_default] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_assert] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(407),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_continue] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(407),
    [anon_sym_yield] = ACTIONS(407),
    [anon_sym_synchronized] = ACTIONS(407),
    [anon_sym_throw] = ACTIONS(407),
    [anon_sym_try] = ACTIONS(407),
    [anon_sym_if] = ACTIONS(407),
    [anon_sym_else] = ACTIONS(407),
    [anon_sym_for] = ACTIONS(407),
    [anon_sym_AT] = ACTIONS(407),
    [anon_sym_open] = ACTIONS(407),
    [anon_sym_module] = ACTIONS(407),
    [anon_sym_static] = ACTIONS(407),
    [anon_sym_package] = ACTIONS(407),
    [anon_sym_import] = ACTIONS(407),
    [anon_sym_enum] = ACTIONS(407),
    [anon_sym_public] = ACTIONS(407),
    [anon_sym_protected] = ACTIONS(407),
    [anon_sym_private] = ACTIONS(407),
    [anon_sym_abstract] = ACTIONS(407),
    [anon_sym_final] = ACTIONS(407),
    [anon_sym_strictfp] = ACTIONS(407),
    [anon_sym_native] = ACTIONS(407),
    [anon_sym_transient] = ACTIONS(407),
    [anon_sym_volatile] = ACTIONS(407),
    [anon_sym_sealed] = ACTIONS(407),
    [anon_sym_non_DASHsealed] = ACTIONS(405),
    [anon_sym_record] = ACTIONS(407),
    [anon_sym_ATinterface] = ACTIONS(405),
    [anon_sym_interface] = ACTIONS(407),
    [anon_sym_byte] = ACTIONS(407),
    [anon_sym_short] = ACTIONS(407),
    [anon_sym_int] = ACTIONS(407),
    [anon_sym_long] = ACTIONS(407),
    [anon_sym_char] = ACTIONS(407),
    [anon_sym_float] = ACTIONS(407),
    [anon_sym_double] = ACTIONS(407),
    [sym_boolean_type] = ACTIONS(407),
    [sym_void_type] = ACTIONS(407),
    [sym_this] = ACTIONS(407),
    [sym_super] = ACTIONS(407),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(409),
    [sym_identifier] = ACTIONS(411),
    [sym_decimal_integer_literal] = ACTIONS(411),
    [sym_hex_integer_literal] = ACTIONS(411),
    [sym_octal_integer_literal] = ACTIONS(409),
    [sym_binary_integer_literal] = ACTIONS(409),
    [sym_decimal_floating_point_literal] = ACTIONS(409),
    [sym_hex_floating_point_literal] = ACTIONS(411),
    [sym_true] = ACTIONS(411),
    [sym_false] = ACTIONS(411),
    [sym_character_literal] = ACTIONS(409),
    [sym_string_literal] = ACTIONS(411),
    [sym_text_block] = ACTIONS(409),
    [sym_null_literal] = ACTIONS(411),
    [anon_sym_LPAREN] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(411),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_TILDE] = ACTIONS(409),
    [anon_sym_PLUS_PLUS] = ACTIONS(409),
    [anon_sym_DASH_DASH] = ACTIONS(409),
    [anon_sym_new] = ACTIONS(411),
    [anon_sym_class] = ACTIONS(411),
    [anon_sym_switch] = ACTIONS(411),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_RBRACE] = ACTIONS(409),
    [anon_sym_case] = ACTIONS(411),
    [anon_sym_default] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_assert] = ACTIONS(411),
    [anon_sym_do] = ACTIONS(411),
    [anon_sym_while] = ACTIONS(411),
    [anon_sym_break] = ACTIONS(411),
    [anon_sym_continue] = ACTIONS(411),
    [anon_sym_return] = ACTIONS(411),
    [anon_sym_yield] = ACTIONS(411),
    [anon_sym_synchronized] = ACTIONS(411),
    [anon_sym_throw] = ACTIONS(411),
    [anon_sym_try] = ACTIONS(411),
    [anon_sym_if] = ACTIONS(411),
    [anon_sym_else] = ACTIONS(411),
    [anon_sym_for] = ACTIONS(411),
    [anon_sym_AT] = ACTIONS(411),
    [anon_sym_open] = ACTIONS(411),
    [anon_sym_module] = ACTIONS(411),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_package] = ACTIONS(411),
    [anon_sym_import] = ACTIONS(411),
    [anon_sym_enum] = ACTIONS(411),
    [anon_sym_public] = ACTIONS(411),
    [anon_sym_protected] = ACTIONS(411),
    [anon_sym_private] = ACTIONS(411),
    [anon_sym_abstract] = ACTIONS(411),
    [anon_sym_final] = ACTIONS(411),
    [anon_sym_strictfp] = ACTIONS(411),
    [anon_sym_native] = ACTIONS(411),
    [anon_sym_transient] = ACTIONS(411),
    [anon_sym_volatile] = ACTIONS(411),
    [anon_sym_sealed] = ACTIONS(411),
    [anon_sym_non_DASHsealed] = ACTIONS(409),
    [anon_sym_record] = ACTIONS(411),
    [anon_sym_ATinterface] = ACTIONS(409),
    [anon_sym_interface] = ACTIONS(411),
    [anon_sym_byte] = ACTIONS(411),
    [anon_sym_short] = ACTIONS(411),
    [anon_sym_int] = ACTIONS(411),
    [anon_sym_long] = ACTIONS(411),
    [anon_sym_char] = ACTIONS(411),
    [anon_sym_float] = ACTIONS(411),
    [anon_sym_double] = ACTIONS(411),
    [sym_boolean_type] = ACTIONS(411),
    [sym_void_type] = ACTIONS(411),
    [sym_this] = ACTIONS(411),
    [sym_super] = ACTIONS(411),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [88] = {
    [ts_builtin_sym_end] = ACTIONS(413),
    [sym_identifier] = ACTIONS(415),
    [sym_decimal_integer_literal] = ACTIONS(415),
    [sym_hex_integer_literal] = ACTIONS(415),
    [sym_octal_integer_literal] = ACTIONS(413),
    [sym_binary_integer_literal] = ACTIONS(413),
    [sym_decimal_floating_point_literal] = ACTIONS(413),
    [sym_hex_floating_point_literal] = ACTIONS(415),
    [sym_true] = ACTIONS(415),
    [sym_false] = ACTIONS(415),
    [sym_character_literal] = ACTIONS(413),
    [sym_string_literal] = ACTIONS(415),
    [sym_text_block] = ACTIONS(413),
    [sym_null_literal] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_LT] = ACTIONS(413),
    [anon_sym_PLUS] = ACTIONS(415),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_BANG] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(413),
    [anon_sym_DASH_DASH] = ACTIONS(413),
    [anon_sym_new] = ACTIONS(415),
    [anon_sym_class] = ACTIONS(415),
    [anon_sym_switch] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(413),
    [anon_sym_RBRACE] = ACTIONS(413),
    [anon_sym_case] = ACTIONS(415),
    [anon_sym_default] = ACTIONS(415),
    [anon_sym_SEMI] = ACTIONS(413),
    [anon_sym_assert] = ACTIONS(415),
    [anon_sym_do] = ACTIONS(415),
    [anon_sym_while] = ACTIONS(415),
    [anon_sym_break] = ACTIONS(415),
    [anon_sym_continue] = ACTIONS(415),
    [anon_sym_return] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(415),
    [anon_sym_synchronized] = ACTIONS(415),
    [anon_sym_throw] = ACTIONS(415),
    [anon_sym_try] = ACTIONS(415),
    [anon_sym_if] = ACTIONS(415),
    [anon_sym_else] = ACTIONS(415),
    [anon_sym_for] = ACTIONS(415),
    [anon_sym_AT] = ACTIONS(415),
    [anon_sym_open] = ACTIONS(415),
    [anon_sym_module] = ACTIONS(415),
    [anon_sym_static] = ACTIONS(415),
    [anon_sym_package] = ACTIONS(415),
    [anon_sym_import] = ACTIONS(415),
    [anon_sym_enum] = ACTIONS(415),
    [anon_sym_public] = ACTIONS(415),
    [anon_sym_protected] = ACTIONS(415),
    [anon_sym_private] = ACTIONS(415),
    [anon_sym_abstract] = ACTIONS(415),
    [anon_sym_final] = ACTIONS(415),
    [anon_sym_strictfp] = ACTIONS(415),
    [anon_sym_native] = ACTIONS(415),
    [anon_sym_transient] = ACTIONS(415),
    [anon_sym_volatile] = ACTIONS(415),
    [anon_sym_sealed] = ACTIONS(415),
    [anon_sym_non_DASHsealed] = ACTIONS(413),
    [anon_sym_record] = ACTIONS(415),
    [anon_sym_ATinterface] = ACTIONS(413),
    [anon_sym_interface] = ACTIONS(415),
    [anon_sym_byte] = ACTIONS(415),
    [anon_sym_short] = ACTIONS(415),
    [anon_sym_int] = ACTIONS(415),
    [anon_sym_long] = ACTIONS(415),
    [anon_sym_char] = ACTIONS(415),
    [anon_sym_float] = ACTIONS(415),
    [anon_sym_double] = ACTIONS(415),
    [sym_boolean_type] = ACTIONS(415),
    [sym_void_type] = ACTIONS(415),
    [sym_this] = ACTIONS(415),
    [sym_super] = ACTIONS(415),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [89] = {
    [ts_builtin_sym_end] = ACTIONS(417),
    [sym_identifier] = ACTIONS(419),
    [sym_decimal_integer_literal] = ACTIONS(419),
    [sym_hex_integer_literal] = ACTIONS(419),
    [sym_octal_integer_literal] = ACTIONS(417),
    [sym_binary_integer_literal] = ACTIONS(417),
    [sym_decimal_floating_point_literal] = ACTIONS(417),
    [sym_hex_floating_point_literal] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_character_literal] = ACTIONS(417),
    [sym_string_literal] = ACTIONS(419),
    [sym_text_block] = ACTIONS(417),
    [sym_null_literal] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(417),
    [anon_sym_PLUS_PLUS] = ACTIONS(417),
    [anon_sym_DASH_DASH] = ACTIONS(417),
    [anon_sym_new] = ACTIONS(419),
    [anon_sym_class] = ACTIONS(419),
    [anon_sym_switch] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(419),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_assert] = ACTIONS(419),
    [anon_sym_do] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(419),
    [anon_sym_yield] = ACTIONS(419),
    [anon_sym_synchronized] = ACTIONS(419),
    [anon_sym_throw] = ACTIONS(419),
    [anon_sym_try] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_AT] = ACTIONS(419),
    [anon_sym_open] = ACTIONS(419),
    [anon_sym_module] = ACTIONS(419),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_package] = ACTIONS(419),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_enum] = ACTIONS(419),
    [anon_sym_public] = ACTIONS(419),
    [anon_sym_protected] = ACTIONS(419),
    [anon_sym_private] = ACTIONS(419),
    [anon_sym_abstract] = ACTIONS(419),
    [anon_sym_final] = ACTIONS(419),
    [anon_sym_strictfp] = ACTIONS(419),
    [anon_sym_native] = ACTIONS(419),
    [anon_sym_transient] = ACTIONS(419),
    [anon_sym_volatile] = ACTIONS(419),
    [anon_sym_sealed] = ACTIONS(419),
    [anon_sym_non_DASHsealed] = ACTIONS(417),
    [anon_sym_record] = ACTIONS(419),
    [anon_sym_ATinterface] = ACTIONS(417),
    [anon_sym_interface] = ACTIONS(419),
    [anon_sym_byte] = ACTIONS(419),
    [anon_sym_short] = ACTIONS(419),
    [anon_sym_int] = ACTIONS(419),
    [anon_sym_long] = ACTIONS(419),
    [anon_sym_char] = ACTIONS(419),
    [anon_sym_float] = ACTIONS(419),
    [anon_sym_double] = ACTIONS(419),
    [sym_boolean_type] = ACTIONS(419),
    [sym_void_type] = ACTIONS(419),
    [sym_this] = ACTIONS(419),
    [sym_super] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [90] = {
    [ts_builtin_sym_end] = ACTIONS(421),
    [sym_identifier] = ACTIONS(423),
    [sym_decimal_integer_literal] = ACTIONS(423),
    [sym_hex_integer_literal] = ACTIONS(423),
    [sym_octal_integer_literal] = ACTIONS(421),
    [sym_binary_integer_literal] = ACTIONS(421),
    [sym_decimal_floating_point_literal] = ACTIONS(421),
    [sym_hex_floating_point_literal] = ACTIONS(423),
    [sym_true] = ACTIONS(423),
    [sym_false] = ACTIONS(423),
    [sym_character_literal] = ACTIONS(421),
    [sym_string_literal] = ACTIONS(423),
    [sym_text_block] = ACTIONS(421),
    [sym_null_literal] = ACTIONS(423),
    [anon_sym_LPAREN] = ACTIONS(421),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(423),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_BANG] = ACTIONS(421),
    [anon_sym_TILDE] = ACTIONS(421),
    [anon_sym_PLUS_PLUS] = ACTIONS(421),
    [anon_sym_DASH_DASH] = ACTIONS(421),
    [anon_sym_new] = ACTIONS(423),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_switch] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(421),
    [anon_sym_RBRACE] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(423),
    [anon_sym_default] = ACTIONS(423),
    [anon_sym_SEMI] = ACTIONS(421),
    [anon_sym_assert] = ACTIONS(423),
    [anon_sym_do] = ACTIONS(423),
    [anon_sym_while] = ACTIONS(423),
    [anon_sym_break] = ACTIONS(423),
    [anon_sym_continue] = ACTIONS(423),
    [anon_sym_return] = ACTIONS(423),
    [anon_sym_yield] = ACTIONS(423),
    [anon_sym_synchronized] = ACTIONS(423),
    [anon_sym_throw] = ACTIONS(423),
    [anon_sym_try] = ACTIONS(423),
    [anon_sym_if] = ACTIONS(423),
    [anon_sym_else] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(423),
    [anon_sym_AT] = ACTIONS(423),
    [anon_sym_open] = ACTIONS(423),
    [anon_sym_module] = ACTIONS(423),
    [anon_sym_static] = ACTIONS(423),
    [anon_sym_package] = ACTIONS(423),
    [anon_sym_import] = ACTIONS(423),
    [anon_sym_enum] = ACTIONS(423),
    [anon_sym_public] = ACTIONS(423),
    [anon_sym_protected] = ACTIONS(423),
    [anon_sym_private] = ACTIONS(423),
    [anon_sym_abstract] = ACTIONS(423),
    [anon_sym_final] = ACTIONS(423),
    [anon_sym_strictfp] = ACTIONS(423),
    [anon_sym_native] = ACTIONS(423),
    [anon_sym_transient] = ACTIONS(423),
    [anon_sym_volatile] = ACTIONS(423),
    [anon_sym_sealed] = ACTIONS(423),
    [anon_sym_non_DASHsealed] = ACTIONS(421),
    [anon_sym_record] = ACTIONS(423),
    [anon_sym_ATinterface] = ACTIONS(421),
    [anon_sym_interface] = ACTIONS(423),
    [anon_sym_byte] = ACTIONS(423),
    [anon_sym_short] = ACTIONS(423),
    [anon_sym_int] = ACTIONS(423),
    [anon_sym_long] = ACTIONS(423),
    [anon_sym_char] = ACTIONS(423),
    [anon_sym_float] = ACTIONS(423),
    [anon_sym_double] = ACTIONS(423),
    [sym_boolean_type] = ACTIONS(423),
    [sym_void_type] = ACTIONS(423),
    [sym_this] = ACTIONS(423),
    [sym_super] = ACTIONS(423),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [91] = {
    [ts_builtin_sym_end] = ACTIONS(425),
    [sym_identifier] = ACTIONS(427),
    [sym_decimal_integer_literal] = ACTIONS(427),
    [sym_hex_integer_literal] = ACTIONS(427),
    [sym_octal_integer_literal] = ACTIONS(425),
    [sym_binary_integer_literal] = ACTIONS(425),
    [sym_decimal_floating_point_literal] = ACTIONS(425),
    [sym_hex_floating_point_literal] = ACTIONS(427),
    [sym_true] = ACTIONS(427),
    [sym_false] = ACTIONS(427),
    [sym_character_literal] = ACTIONS(425),
    [sym_string_literal] = ACTIONS(427),
    [sym_text_block] = ACTIONS(425),
    [sym_null_literal] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(425),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_BANG] = ACTIONS(425),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(425),
    [anon_sym_DASH_DASH] = ACTIONS(425),
    [anon_sym_new] = ACTIONS(427),
    [anon_sym_class] = ACTIONS(427),
    [anon_sym_switch] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(427),
    [anon_sym_default] = ACTIONS(427),
    [anon_sym_SEMI] = ACTIONS(425),
    [anon_sym_assert] = ACTIONS(427),
    [anon_sym_do] = ACTIONS(427),
    [anon_sym_while] = ACTIONS(427),
    [anon_sym_break] = ACTIONS(427),
    [anon_sym_continue] = ACTIONS(427),
    [anon_sym_return] = ACTIONS(427),
    [anon_sym_yield] = ACTIONS(427),
    [anon_sym_synchronized] = ACTIONS(427),
    [anon_sym_throw] = ACTIONS(427),
    [anon_sym_try] = ACTIONS(427),
    [anon_sym_if] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(427),
    [anon_sym_AT] = ACTIONS(427),
    [anon_sym_open] = ACTIONS(427),
    [anon_sym_module] = ACTIONS(427),
    [anon_sym_static] = ACTIONS(427),
    [anon_sym_package] = ACTIONS(427),
    [anon_sym_import] = ACTIONS(427),
    [anon_sym_enum] = ACTIONS(427),
    [anon_sym_public] = ACTIONS(427),
    [anon_sym_protected] = ACTIONS(427),
    [anon_sym_private] = ACTIONS(427),
    [anon_sym_abstract] = ACTIONS(427),
    [anon_sym_final] = ACTIONS(427),
    [anon_sym_strictfp] = ACTIONS(427),
    [anon_sym_native] = ACTIONS(427),
    [anon_sym_transient] = ACTIONS(427),
    [anon_sym_volatile] = ACTIONS(427),
    [anon_sym_sealed] = ACTIONS(427),
    [anon_sym_non_DASHsealed] = ACTIONS(425),
    [anon_sym_record] = ACTIONS(427),
    [anon_sym_ATinterface] = ACTIONS(425),
    [anon_sym_interface] = ACTIONS(427),
    [anon_sym_byte] = ACTIONS(427),
    [anon_sym_short] = ACTIONS(427),
    [anon_sym_int] = ACTIONS(427),
    [anon_sym_long] = ACTIONS(427),
    [anon_sym_char] = ACTIONS(427),
    [anon_sym_float] = ACTIONS(427),
    [anon_sym_double] = ACTIONS(427),
    [sym_boolean_type] = ACTIONS(427),
    [sym_void_type] = ACTIONS(427),
    [sym_this] = ACTIONS(427),
    [sym_super] = ACTIONS(427),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [92] = {
    [ts_builtin_sym_end] = ACTIONS(429),
    [sym_identifier] = ACTIONS(431),
    [sym_decimal_integer_literal] = ACTIONS(431),
    [sym_hex_integer_literal] = ACTIONS(431),
    [sym_octal_integer_literal] = ACTIONS(429),
    [sym_binary_integer_literal] = ACTIONS(429),
    [sym_decimal_floating_point_literal] = ACTIONS(429),
    [sym_hex_floating_point_literal] = ACTIONS(431),
    [sym_true] = ACTIONS(431),
    [sym_false] = ACTIONS(431),
    [sym_character_literal] = ACTIONS(429),
    [sym_string_literal] = ACTIONS(431),
    [sym_text_block] = ACTIONS(429),
    [sym_null_literal] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_PLUS] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(431),
    [anon_sym_BANG] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(429),
    [anon_sym_PLUS_PLUS] = ACTIONS(429),
    [anon_sym_DASH_DASH] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(431),
    [anon_sym_class] = ACTIONS(431),
    [anon_sym_switch] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(429),
    [anon_sym_RBRACE] = ACTIONS(429),
    [anon_sym_case] = ACTIONS(431),
    [anon_sym_default] = ACTIONS(431),
    [anon_sym_SEMI] = ACTIONS(429),
    [anon_sym_assert] = ACTIONS(431),
    [anon_sym_do] = ACTIONS(431),
    [anon_sym_while] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(431),
    [anon_sym_continue] = ACTIONS(431),
    [anon_sym_return] = ACTIONS(431),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_synchronized] = ACTIONS(431),
    [anon_sym_throw] = ACTIONS(431),
    [anon_sym_try] = ACTIONS(431),
    [anon_sym_if] = ACTIONS(431),
    [anon_sym_else] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(431),
    [anon_sym_AT] = ACTIONS(431),
    [anon_sym_open] = ACTIONS(431),
    [anon_sym_module] = ACTIONS(431),
    [anon_sym_static] = ACTIONS(431),
    [anon_sym_package] = ACTIONS(431),
    [anon_sym_import] = ACTIONS(431),
    [anon_sym_enum] = ACTIONS(431),
    [anon_sym_public] = ACTIONS(431),
    [anon_sym_protected] = ACTIONS(431),
    [anon_sym_private] = ACTIONS(431),
    [anon_sym_abstract] = ACTIONS(431),
    [anon_sym_final] = ACTIONS(431),
    [anon_sym_strictfp] = ACTIONS(431),
    [anon_sym_native] = ACTIONS(431),
    [anon_sym_transient] = ACTIONS(431),
    [anon_sym_volatile] = ACTIONS(431),
    [anon_sym_sealed] = ACTIONS(431),
    [anon_sym_non_DASHsealed] = ACTIONS(429),
    [anon_sym_record] = ACTIONS(431),
    [anon_sym_ATinterface] = ACTIONS(429),
    [anon_sym_interface] = ACTIONS(431),
    [anon_sym_byte] = ACTIONS(431),
    [anon_sym_short] = ACTIONS(431),
    [anon_sym_int] = ACTIONS(431),
    [anon_sym_long] = ACTIONS(431),
    [anon_sym_char] = ACTIONS(431),
    [anon_sym_float] = ACTIONS(431),
    [anon_sym_double] = ACTIONS(431),
    [sym_boolean_type] = ACTIONS(431),
    [sym_void_type] = ACTIONS(431),
    [sym_this] = ACTIONS(431),
    [sym_super] = ACTIONS(431),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [93] = {
    [ts_builtin_sym_end] = ACTIONS(248),
    [sym_identifier] = ACTIONS(250),
    [sym_decimal_integer_literal] = ACTIONS(250),
    [sym_hex_integer_literal] = ACTIONS(250),
    [sym_octal_integer_literal] = ACTIONS(248),
    [sym_binary_integer_literal] = ACTIONS(248),
    [sym_decimal_floating_point_literal] = ACTIONS(248),
    [sym_hex_floating_point_literal] = ACTIONS(250),
    [sym_true] = ACTIONS(250),
    [sym_false] = ACTIONS(250),
    [sym_character_literal] = ACTIONS(248),
    [sym_string_literal] = ACTIONS(250),
    [sym_text_block] = ACTIONS(248),
    [sym_null_literal] = ACTIONS(250),
    [anon_sym_LPAREN] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(250),
    [anon_sym_DASH] = ACTIONS(250),
    [anon_sym_BANG] = ACTIONS(248),
    [anon_sym_TILDE] = ACTIONS(248),
    [anon_sym_PLUS_PLUS] = ACTIONS(248),
    [anon_sym_DASH_DASH] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(250),
    [anon_sym_class] = ACTIONS(250),
    [anon_sym_switch] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(248),
    [anon_sym_RBRACE] = ACTIONS(248),
    [anon_sym_case] = ACTIONS(250),
    [anon_sym_default] = ACTIONS(250),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_assert] = ACTIONS(250),
    [anon_sym_do] = ACTIONS(250),
    [anon_sym_while] = ACTIONS(250),
    [anon_sym_break] = ACTIONS(250),
    [anon_sym_continue] = ACTIONS(250),
    [anon_sym_return] = ACTIONS(250),
    [anon_sym_yield] = ACTIONS(250),
    [anon_sym_synchronized] = ACTIONS(250),
    [anon_sym_throw] = ACTIONS(250),
    [anon_sym_try] = ACTIONS(250),
    [anon_sym_catch] = ACTIONS(250),
    [anon_sym_finally] = ACTIONS(250),
    [anon_sym_if] = ACTIONS(250),
    [anon_sym_else] = ACTIONS(250),
    [anon_sym_for] = ACTIONS(250),
    [anon_sym_AT] = ACTIONS(250),
    [anon_sym_open] = ACTIONS(250),
    [anon_sym_module] = ACTIONS(250),
    [anon_sym_static] = ACTIONS(250),
    [anon_sym_package] = ACTIONS(250),
    [anon_sym_import] = ACTIONS(250),
    [anon_sym_enum] = ACTIONS(250),
    [anon_sym_public] = ACTIONS(250),
    [anon_sym_protected] = ACTIONS(250),
    [anon_sym_private] = ACTIONS(250),
    [anon_sym_abstract] = ACTIONS(250),
    [anon_sym_final] = ACTIONS(250),
    [anon_sym_strictfp] = ACTIONS(250),
    [anon_sym_native] = ACTIONS(250),
    [anon_sym_transient] = ACTIONS(250),
    [anon_sym_volatile] = ACTIONS(250),
    [anon_sym_sealed] = ACTIONS(250),
    [anon_sym_non_DASHsealed] = ACTIONS(248),
    [anon_sym_ATinterface] = ACTIONS(248),
    [anon_sym_interface] = ACTIONS(250),
    [anon_sym_byte] = ACTIONS(250),
    [anon_sym_short] = ACTIONS(250),
    [anon_sym_int] = ACTIONS(250),
    [anon_sym_long] = ACTIONS(250),
    [anon_sym_char] = ACTIONS(250),
    [anon_sym_float] = ACTIONS(250),
    [anon_sym_double] = ACTIONS(250),
    [sym_boolean_type] = ACTIONS(250),
    [sym_void_type] = ACTIONS(250),
    [sym_this] = ACTIONS(250),
    [sym_super] = ACTIONS(250),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [94] = {
    [ts_builtin_sym_end] = ACTIONS(433),
    [sym_identifier] = ACTIONS(435),
    [sym_decimal_integer_literal] = ACTIONS(435),
    [sym_hex_integer_literal] = ACTIONS(435),
    [sym_octal_integer_literal] = ACTIONS(433),
    [sym_binary_integer_literal] = ACTIONS(433),
    [sym_decimal_floating_point_literal] = ACTIONS(433),
    [sym_hex_floating_point_literal] = ACTIONS(435),
    [sym_true] = ACTIONS(435),
    [sym_false] = ACTIONS(435),
    [sym_character_literal] = ACTIONS(433),
    [sym_string_literal] = ACTIONS(435),
    [sym_text_block] = ACTIONS(433),
    [sym_null_literal] = ACTIONS(435),
    [anon_sym_LPAREN] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(433),
    [anon_sym_PLUS] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(433),
    [anon_sym_PLUS_PLUS] = ACTIONS(433),
    [anon_sym_DASH_DASH] = ACTIONS(433),
    [anon_sym_new] = ACTIONS(435),
    [anon_sym_class] = ACTIONS(435),
    [anon_sym_switch] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(433),
    [anon_sym_RBRACE] = ACTIONS(433),
    [anon_sym_case] = ACTIONS(435),
    [anon_sym_default] = ACTIONS(435),
    [anon_sym_SEMI] = ACTIONS(433),
    [anon_sym_assert] = ACTIONS(435),
    [anon_sym_do] = ACTIONS(435),
    [anon_sym_while] = ACTIONS(435),
    [anon_sym_break] = ACTIONS(435),
    [anon_sym_continue] = ACTIONS(435),
    [anon_sym_return] = ACTIONS(435),
    [anon_sym_yield] = ACTIONS(435),
    [anon_sym_synchronized] = ACTIONS(435),
    [anon_sym_throw] = ACTIONS(435),
    [anon_sym_try] = ACTIONS(435),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_else] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(435),
    [anon_sym_AT] = ACTIONS(435),
    [anon_sym_open] = ACTIONS(435),
    [anon_sym_module] = ACTIONS(435),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_package] = ACTIONS(435),
    [anon_sym_import] = ACTIONS(435),
    [anon_sym_enum] = ACTIONS(435),
    [anon_sym_public] = ACTIONS(435),
    [anon_sym_protected] = ACTIONS(435),
    [anon_sym_private] = ACTIONS(435),
    [anon_sym_abstract] = ACTIONS(435),
    [anon_sym_final] = ACTIONS(435),
    [anon_sym_strictfp] = ACTIONS(435),
    [anon_sym_native] = ACTIONS(435),
    [anon_sym_transient] = ACTIONS(435),
    [anon_sym_volatile] = ACTIONS(435),
    [anon_sym_sealed] = ACTIONS(435),
    [anon_sym_non_DASHsealed] = ACTIONS(433),
    [anon_sym_record] = ACTIONS(435),
    [anon_sym_ATinterface] = ACTIONS(433),
    [anon_sym_interface] = ACTIONS(435),
    [anon_sym_byte] = ACTIONS(435),
    [anon_sym_short] = ACTIONS(435),
    [anon_sym_int] = ACTIONS(435),
    [anon_sym_long] = ACTIONS(435),
    [anon_sym_char] = ACTIONS(435),
    [anon_sym_float] = ACTIONS(435),
    [anon_sym_double] = ACTIONS(435),
    [sym_boolean_type] = ACTIONS(435),
    [sym_void_type] = ACTIONS(435),
    [sym_this] = ACTIONS(435),
    [sym_super] = ACTIONS(435),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [95] = {
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym_identifier] = ACTIONS(439),
    [sym_decimal_integer_literal] = ACTIONS(439),
    [sym_hex_integer_literal] = ACTIONS(439),
    [sym_octal_integer_literal] = ACTIONS(437),
    [sym_binary_integer_literal] = ACTIONS(437),
    [sym_decimal_floating_point_literal] = ACTIONS(437),
    [sym_hex_floating_point_literal] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_character_literal] = ACTIONS(437),
    [sym_string_literal] = ACTIONS(439),
    [sym_text_block] = ACTIONS(437),
    [sym_null_literal] = ACTIONS(439),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(437),
    [anon_sym_DASH_DASH] = ACTIONS(437),
    [anon_sym_new] = ACTIONS(439),
    [anon_sym_class] = ACTIONS(439),
    [anon_sym_switch] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_case] = ACTIONS(439),
    [anon_sym_default] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_assert] = ACTIONS(439),
    [anon_sym_do] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_continue] = ACTIONS(439),
    [anon_sym_return] = ACTIONS(439),
    [anon_sym_yield] = ACTIONS(439),
    [anon_sym_synchronized] = ACTIONS(439),
    [anon_sym_throw] = ACTIONS(439),
    [anon_sym_try] = ACTIONS(439),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_AT] = ACTIONS(439),
    [anon_sym_open] = ACTIONS(439),
    [anon_sym_module] = ACTIONS(439),
    [anon_sym_static] = ACTIONS(439),
    [anon_sym_package] = ACTIONS(439),
    [anon_sym_import] = ACTIONS(439),
    [anon_sym_enum] = ACTIONS(439),
    [anon_sym_public] = ACTIONS(439),
    [anon_sym_protected] = ACTIONS(439),
    [anon_sym_private] = ACTIONS(439),
    [anon_sym_abstract] = ACTIONS(439),
    [anon_sym_final] = ACTIONS(439),
    [anon_sym_strictfp] = ACTIONS(439),
    [anon_sym_native] = ACTIONS(439),
    [anon_sym_transient] = ACTIONS(439),
    [anon_sym_volatile] = ACTIONS(439),
    [anon_sym_sealed] = ACTIONS(439),
    [anon_sym_non_DASHsealed] = ACTIONS(437),
    [anon_sym_record] = ACTIONS(439),
    [anon_sym_ATinterface] = ACTIONS(437),
    [anon_sym_interface] = ACTIONS(439),
    [anon_sym_byte] = ACTIONS(439),
    [anon_sym_short] = ACTIONS(439),
    [anon_sym_int] = ACTIONS(439),
    [anon_sym_long] = ACTIONS(439),
    [anon_sym_char] = ACTIONS(439),
    [anon_sym_float] = ACTIONS(439),
    [anon_sym_double] = ACTIONS(439),
    [sym_boolean_type] = ACTIONS(439),
    [sym_void_type] = ACTIONS(439),
    [sym_this] = ACTIONS(439),
    [sym_super] = ACTIONS(439),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [96] = {
    [ts_builtin_sym_end] = ACTIONS(441),
    [sym_identifier] = ACTIONS(443),
    [sym_decimal_integer_literal] = ACTIONS(443),
    [sym_hex_integer_literal] = ACTIONS(443),
    [sym_octal_integer_literal] = ACTIONS(441),
    [sym_binary_integer_literal] = ACTIONS(441),
    [sym_decimal_floating_point_literal] = ACTIONS(441),
    [sym_hex_floating_point_literal] = ACTIONS(443),
    [sym_true] = ACTIONS(443),
    [sym_false] = ACTIONS(443),
    [sym_character_literal] = ACTIONS(441),
    [sym_string_literal] = ACTIONS(443),
    [sym_text_block] = ACTIONS(441),
    [sym_null_literal] = ACTIONS(443),
    [anon_sym_LPAREN] = ACTIONS(441),
    [anon_sym_LT] = ACTIONS(441),
    [anon_sym_PLUS] = ACTIONS(443),
    [anon_sym_DASH] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(441),
    [anon_sym_PLUS_PLUS] = ACTIONS(441),
    [anon_sym_DASH_DASH] = ACTIONS(441),
    [anon_sym_new] = ACTIONS(443),
    [anon_sym_class] = ACTIONS(443),
    [anon_sym_switch] = ACTIONS(443),
    [anon_sym_LBRACE] = ACTIONS(441),
    [anon_sym_RBRACE] = ACTIONS(441),
    [anon_sym_case] = ACTIONS(443),
    [anon_sym_default] = ACTIONS(443),
    [anon_sym_SEMI] = ACTIONS(441),
    [anon_sym_assert] = ACTIONS(443),
    [anon_sym_do] = ACTIONS(443),
    [anon_sym_while] = ACTIONS(443),
    [anon_sym_break] = ACTIONS(443),
    [anon_sym_continue] = ACTIONS(443),
    [anon_sym_return] = ACTIONS(443),
    [anon_sym_yield] = ACTIONS(443),
    [anon_sym_synchronized] = ACTIONS(443),
    [anon_sym_throw] = ACTIONS(443),
    [anon_sym_try] = ACTIONS(443),
    [anon_sym_if] = ACTIONS(443),
    [anon_sym_else] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(443),
    [anon_sym_AT] = ACTIONS(443),
    [anon_sym_open] = ACTIONS(443),
    [anon_sym_module] = ACTIONS(443),
    [anon_sym_static] = ACTIONS(443),
    [anon_sym_package] = ACTIONS(443),
    [anon_sym_import] = ACTIONS(443),
    [anon_sym_enum] = ACTIONS(443),
    [anon_sym_public] = ACTIONS(443),
    [anon_sym_protected] = ACTIONS(443),
    [anon_sym_private] = ACTIONS(443),
    [anon_sym_abstract] = ACTIONS(443),
    [anon_sym_final] = ACTIONS(443),
    [anon_sym_strictfp] = ACTIONS(443),
    [anon_sym_native] = ACTIONS(443),
    [anon_sym_transient] = ACTIONS(443),
    [anon_sym_volatile] = ACTIONS(443),
    [anon_sym_sealed] = ACTIONS(443),
    [anon_sym_non_DASHsealed] = ACTIONS(441),
    [anon_sym_record] = ACTIONS(443),
    [anon_sym_ATinterface] = ACTIONS(441),
    [anon_sym_interface] = ACTIONS(443),
    [anon_sym_byte] = ACTIONS(443),
    [anon_sym_short] = ACTIONS(443),
    [anon_sym_int] = ACTIONS(443),
    [anon_sym_long] = ACTIONS(443),
    [anon_sym_char] = ACTIONS(443),
    [anon_sym_float] = ACTIONS(443),
    [anon_sym_double] = ACTIONS(443),
    [sym_boolean_type] = ACTIONS(443),
    [sym_void_type] = ACTIONS(443),
    [sym_this] = ACTIONS(443),
    [sym_super] = ACTIONS(443),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [97] = {
    [ts_builtin_sym_end] = ACTIONS(445),
    [sym_identifier] = ACTIONS(447),
    [sym_decimal_integer_literal] = ACTIONS(447),
    [sym_hex_integer_literal] = ACTIONS(447),
    [sym_octal_integer_literal] = ACTIONS(445),
    [sym_binary_integer_literal] = ACTIONS(445),
    [sym_decimal_floating_point_literal] = ACTIONS(445),
    [sym_hex_floating_point_literal] = ACTIONS(447),
    [sym_true] = ACTIONS(447),
    [sym_false] = ACTIONS(447),
    [sym_character_literal] = ACTIONS(445),
    [sym_string_literal] = ACTIONS(447),
    [sym_text_block] = ACTIONS(445),
    [sym_null_literal] = ACTIONS(447),
    [anon_sym_LPAREN] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_PLUS] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(445),
    [anon_sym_DASH_DASH] = ACTIONS(445),
    [anon_sym_new] = ACTIONS(447),
    [anon_sym_class] = ACTIONS(447),
    [anon_sym_switch] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(445),
    [anon_sym_RBRACE] = ACTIONS(445),
    [anon_sym_case] = ACTIONS(447),
    [anon_sym_default] = ACTIONS(447),
    [anon_sym_SEMI] = ACTIONS(445),
    [anon_sym_assert] = ACTIONS(447),
    [anon_sym_do] = ACTIONS(447),
    [anon_sym_while] = ACTIONS(447),
    [anon_sym_break] = ACTIONS(447),
    [anon_sym_continue] = ACTIONS(447),
    [anon_sym_return] = ACTIONS(447),
    [anon_sym_yield] = ACTIONS(447),
    [anon_sym_synchronized] = ACTIONS(447),
    [anon_sym_throw] = ACTIONS(447),
    [anon_sym_try] = ACTIONS(447),
    [anon_sym_if] = ACTIONS(447),
    [anon_sym_else] = ACTIONS(447),
    [anon_sym_for] = ACTIONS(447),
    [anon_sym_AT] = ACTIONS(447),
    [anon_sym_open] = ACTIONS(447),
    [anon_sym_module] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(447),
    [anon_sym_package] = ACTIONS(447),
    [anon_sym_import] = ACTIONS(447),
    [anon_sym_enum] = ACTIONS(447),
    [anon_sym_public] = ACTIONS(447),
    [anon_sym_protected] = ACTIONS(447),
    [anon_sym_private] = ACTIONS(447),
    [anon_sym_abstract] = ACTIONS(447),
    [anon_sym_final] = ACTIONS(447),
    [anon_sym_strictfp] = ACTIONS(447),
    [anon_sym_native] = ACTIONS(447),
    [anon_sym_transient] = ACTIONS(447),
    [anon_sym_volatile] = ACTIONS(447),
    [anon_sym_sealed] = ACTIONS(447),
    [anon_sym_non_DASHsealed] = ACTIONS(445),
    [anon_sym_record] = ACTIONS(447),
    [anon_sym_ATinterface] = ACTIONS(445),
    [anon_sym_interface] = ACTIONS(447),
    [anon_sym_byte] = ACTIONS(447),
    [anon_sym_short] = ACTIONS(447),
    [anon_sym_int] = ACTIONS(447),
    [anon_sym_long] = ACTIONS(447),
    [anon_sym_char] = ACTIONS(447),
    [anon_sym_float] = ACTIONS(447),
    [anon_sym_double] = ACTIONS(447),
    [sym_boolean_type] = ACTIONS(447),
    [sym_void_type] = ACTIONS(447),
    [sym_this] = ACTIONS(447),
    [sym_super] = ACTIONS(447),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(449),
    [sym_identifier] = ACTIONS(451),
    [sym_decimal_integer_literal] = ACTIONS(451),
    [sym_hex_integer_literal] = ACTIONS(451),
    [sym_octal_integer_literal] = ACTIONS(449),
    [sym_binary_integer_literal] = ACTIONS(449),
    [sym_decimal_floating_point_literal] = ACTIONS(449),
    [sym_hex_floating_point_literal] = ACTIONS(451),
    [sym_true] = ACTIONS(451),
    [sym_false] = ACTIONS(451),
    [sym_character_literal] = ACTIONS(449),
    [sym_string_literal] = ACTIONS(451),
    [sym_text_block] = ACTIONS(449),
    [sym_null_literal] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_PLUS] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(451),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(449),
    [anon_sym_DASH_DASH] = ACTIONS(449),
    [anon_sym_new] = ACTIONS(451),
    [anon_sym_class] = ACTIONS(451),
    [anon_sym_switch] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_case] = ACTIONS(451),
    [anon_sym_default] = ACTIONS(451),
    [anon_sym_SEMI] = ACTIONS(449),
    [anon_sym_assert] = ACTIONS(451),
    [anon_sym_do] = ACTIONS(451),
    [anon_sym_while] = ACTIONS(451),
    [anon_sym_break] = ACTIONS(451),
    [anon_sym_continue] = ACTIONS(451),
    [anon_sym_return] = ACTIONS(451),
    [anon_sym_yield] = ACTIONS(451),
    [anon_sym_synchronized] = ACTIONS(451),
    [anon_sym_throw] = ACTIONS(451),
    [anon_sym_try] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(451),
    [anon_sym_else] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(451),
    [anon_sym_AT] = ACTIONS(451),
    [anon_sym_open] = ACTIONS(451),
    [anon_sym_module] = ACTIONS(451),
    [anon_sym_static] = ACTIONS(451),
    [anon_sym_package] = ACTIONS(451),
    [anon_sym_import] = ACTIONS(451),
    [anon_sym_enum] = ACTIONS(451),
    [anon_sym_public] = ACTIONS(451),
    [anon_sym_protected] = ACTIONS(451),
    [anon_sym_private] = ACTIONS(451),
    [anon_sym_abstract] = ACTIONS(451),
    [anon_sym_final] = ACTIONS(451),
    [anon_sym_strictfp] = ACTIONS(451),
    [anon_sym_native] = ACTIONS(451),
    [anon_sym_transient] = ACTIONS(451),
    [anon_sym_volatile] = ACTIONS(451),
    [anon_sym_sealed] = ACTIONS(451),
    [anon_sym_non_DASHsealed] = ACTIONS(449),
    [anon_sym_record] = ACTIONS(451),
    [anon_sym_ATinterface] = ACTIONS(449),
    [anon_sym_interface] = ACTIONS(451),
    [anon_sym_byte] = ACTIONS(451),
    [anon_sym_short] = ACTIONS(451),
    [anon_sym_int] = ACTIONS(451),
    [anon_sym_long] = ACTIONS(451),
    [anon_sym_char] = ACTIONS(451),
    [anon_sym_float] = ACTIONS(451),
    [anon_sym_double] = ACTIONS(451),
    [sym_boolean_type] = ACTIONS(451),
    [sym_void_type] = ACTIONS(451),
    [sym_this] = ACTIONS(451),
    [sym_super] = ACTIONS(451),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [99] = {
    [ts_builtin_sym_end] = ACTIONS(453),
    [sym_identifier] = ACTIONS(455),
    [sym_decimal_integer_literal] = ACTIONS(455),
    [sym_hex_integer_literal] = ACTIONS(455),
    [sym_octal_integer_literal] = ACTIONS(453),
    [sym_binary_integer_literal] = ACTIONS(453),
    [sym_decimal_floating_point_literal] = ACTIONS(453),
    [sym_hex_floating_point_literal] = ACTIONS(455),
    [sym_true] = ACTIONS(455),
    [sym_false] = ACTIONS(455),
    [sym_character_literal] = ACTIONS(453),
    [sym_string_literal] = ACTIONS(455),
    [sym_text_block] = ACTIONS(453),
    [sym_null_literal] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(453),
    [anon_sym_PLUS] = ACTIONS(455),
    [anon_sym_DASH] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(453),
    [anon_sym_TILDE] = ACTIONS(453),
    [anon_sym_PLUS_PLUS] = ACTIONS(453),
    [anon_sym_DASH_DASH] = ACTIONS(453),
    [anon_sym_new] = ACTIONS(455),
    [anon_sym_class] = ACTIONS(455),
    [anon_sym_switch] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(453),
    [anon_sym_case] = ACTIONS(455),
    [anon_sym_default] = ACTIONS(455),
    [anon_sym_SEMI] = ACTIONS(453),
    [anon_sym_assert] = ACTIONS(455),
    [anon_sym_do] = ACTIONS(455),
    [anon_sym_while] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(455),
    [anon_sym_continue] = ACTIONS(455),
    [anon_sym_return] = ACTIONS(455),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_synchronized] = ACTIONS(455),
    [anon_sym_throw] = ACTIONS(455),
    [anon_sym_try] = ACTIONS(455),
    [anon_sym_if] = ACTIONS(455),
    [anon_sym_else] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(455),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_open] = ACTIONS(455),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(455),
    [anon_sym_package] = ACTIONS(455),
    [anon_sym_import] = ACTIONS(455),
    [anon_sym_enum] = ACTIONS(455),
    [anon_sym_public] = ACTIONS(455),
    [anon_sym_protected] = ACTIONS(455),
    [anon_sym_private] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(455),
    [anon_sym_final] = ACTIONS(455),
    [anon_sym_strictfp] = ACTIONS(455),
    [anon_sym_native] = ACTIONS(455),
    [anon_sym_transient] = ACTIONS(455),
    [anon_sym_volatile] = ACTIONS(455),
    [anon_sym_sealed] = ACTIONS(455),
    [anon_sym_non_DASHsealed] = ACTIONS(453),
    [anon_sym_record] = ACTIONS(455),
    [anon_sym_ATinterface] = ACTIONS(453),
    [anon_sym_interface] = ACTIONS(455),
    [anon_sym_byte] = ACTIONS(455),
    [anon_sym_short] = ACTIONS(455),
    [anon_sym_int] = ACTIONS(455),
    [anon_sym_long] = ACTIONS(455),
    [anon_sym_char] = ACTIONS(455),
    [anon_sym_float] = ACTIONS(455),
    [anon_sym_double] = ACTIONS(455),
    [sym_boolean_type] = ACTIONS(455),
    [sym_void_type] = ACTIONS(455),
    [sym_this] = ACTIONS(455),
    [sym_super] = ACTIONS(455),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [100] = {
    [ts_builtin_sym_end] = ACTIONS(457),
    [sym_identifier] = ACTIONS(459),
    [sym_decimal_integer_literal] = ACTIONS(459),
    [sym_hex_integer_literal] = ACTIONS(459),
    [sym_octal_integer_literal] = ACTIONS(457),
    [sym_binary_integer_literal] = ACTIONS(457),
    [sym_decimal_floating_point_literal] = ACTIONS(457),
    [sym_hex_floating_point_literal] = ACTIONS(459),
    [sym_true] = ACTIONS(459),
    [sym_false] = ACTIONS(459),
    [sym_character_literal] = ACTIONS(457),
    [sym_string_literal] = ACTIONS(459),
    [sym_text_block] = ACTIONS(457),
    [sym_null_literal] = ACTIONS(459),
    [anon_sym_LPAREN] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(457),
    [anon_sym_TILDE] = ACTIONS(457),
    [anon_sym_PLUS_PLUS] = ACTIONS(457),
    [anon_sym_DASH_DASH] = ACTIONS(457),
    [anon_sym_new] = ACTIONS(459),
    [anon_sym_class] = ACTIONS(459),
    [anon_sym_switch] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(457),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_case] = ACTIONS(459),
    [anon_sym_default] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_assert] = ACTIONS(459),
    [anon_sym_do] = ACTIONS(459),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(459),
    [anon_sym_synchronized] = ACTIONS(459),
    [anon_sym_throw] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(459),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(459),
    [anon_sym_open] = ACTIONS(459),
    [anon_sym_module] = ACTIONS(459),
    [anon_sym_static] = ACTIONS(459),
    [anon_sym_package] = ACTIONS(459),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_enum] = ACTIONS(459),
    [anon_sym_public] = ACTIONS(459),
    [anon_sym_protected] = ACTIONS(459),
    [anon_sym_private] = ACTIONS(459),
    [anon_sym_abstract] = ACTIONS(459),
    [anon_sym_final] = ACTIONS(459),
    [anon_sym_strictfp] = ACTIONS(459),
    [anon_sym_native] = ACTIONS(459),
    [anon_sym_transient] = ACTIONS(459),
    [anon_sym_volatile] = ACTIONS(459),
    [anon_sym_sealed] = ACTIONS(459),
    [anon_sym_non_DASHsealed] = ACTIONS(457),
    [anon_sym_record] = ACTIONS(459),
    [anon_sym_ATinterface] = ACTIONS(457),
    [anon_sym_interface] = ACTIONS(459),
    [anon_sym_byte] = ACTIONS(459),
    [anon_sym_short] = ACTIONS(459),
    [anon_sym_int] = ACTIONS(459),
    [anon_sym_long] = ACTIONS(459),
    [anon_sym_char] = ACTIONS(459),
    [anon_sym_float] = ACTIONS(459),
    [anon_sym_double] = ACTIONS(459),
    [sym_boolean_type] = ACTIONS(459),
    [sym_void_type] = ACTIONS(459),
    [sym_this] = ACTIONS(459),
    [sym_super] = ACTIONS(459),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [101] = {
    [ts_builtin_sym_end] = ACTIONS(461),
    [sym_identifier] = ACTIONS(463),
    [sym_decimal_integer_literal] = ACTIONS(463),
    [sym_hex_integer_literal] = ACTIONS(463),
    [sym_octal_integer_literal] = ACTIONS(461),
    [sym_binary_integer_literal] = ACTIONS(461),
    [sym_decimal_floating_point_literal] = ACTIONS(461),
    [sym_hex_floating_point_literal] = ACTIONS(463),
    [sym_true] = ACTIONS(463),
    [sym_false] = ACTIONS(463),
    [sym_character_literal] = ACTIONS(461),
    [sym_string_literal] = ACTIONS(463),
    [sym_text_block] = ACTIONS(461),
    [sym_null_literal] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(463),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_TILDE] = ACTIONS(461),
    [anon_sym_PLUS_PLUS] = ACTIONS(461),
    [anon_sym_DASH_DASH] = ACTIONS(461),
    [anon_sym_new] = ACTIONS(463),
    [anon_sym_class] = ACTIONS(463),
    [anon_sym_switch] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(461),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_case] = ACTIONS(463),
    [anon_sym_default] = ACTIONS(463),
    [anon_sym_SEMI] = ACTIONS(461),
    [anon_sym_assert] = ACTIONS(463),
    [anon_sym_do] = ACTIONS(463),
    [anon_sym_while] = ACTIONS(463),
    [anon_sym_break] = ACTIONS(463),
    [anon_sym_continue] = ACTIONS(463),
    [anon_sym_return] = ACTIONS(463),
    [anon_sym_yield] = ACTIONS(463),
    [anon_sym_synchronized] = ACTIONS(463),
    [anon_sym_throw] = ACTIONS(463),
    [anon_sym_try] = ACTIONS(463),
    [anon_sym_if] = ACTIONS(463),
    [anon_sym_else] = ACTIONS(463),
    [anon_sym_for] = ACTIONS(463),
    [anon_sym_AT] = ACTIONS(463),
    [anon_sym_open] = ACTIONS(463),
    [anon_sym_module] = ACTIONS(463),
    [anon_sym_static] = ACTIONS(463),
    [anon_sym_package] = ACTIONS(463),
    [anon_sym_import] = ACTIONS(463),
    [anon_sym_enum] = ACTIONS(463),
    [anon_sym_public] = ACTIONS(463),
    [anon_sym_protected] = ACTIONS(463),
    [anon_sym_private] = ACTIONS(463),
    [anon_sym_abstract] = ACTIONS(463),
    [anon_sym_final] = ACTIONS(463),
    [anon_sym_strictfp] = ACTIONS(463),
    [anon_sym_native] = ACTIONS(463),
    [anon_sym_transient] = ACTIONS(463),
    [anon_sym_volatile] = ACTIONS(463),
    [anon_sym_sealed] = ACTIONS(463),
    [anon_sym_non_DASHsealed] = ACTIONS(461),
    [anon_sym_record] = ACTIONS(463),
    [anon_sym_ATinterface] = ACTIONS(461),
    [anon_sym_interface] = ACTIONS(463),
    [anon_sym_byte] = ACTIONS(463),
    [anon_sym_short] = ACTIONS(463),
    [anon_sym_int] = ACTIONS(463),
    [anon_sym_long] = ACTIONS(463),
    [anon_sym_char] = ACTIONS(463),
    [anon_sym_float] = ACTIONS(463),
    [anon_sym_double] = ACTIONS(463),
    [sym_boolean_type] = ACTIONS(463),
    [sym_void_type] = ACTIONS(463),
    [sym_this] = ACTIONS(463),
    [sym_super] = ACTIONS(463),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [102] = {
    [ts_builtin_sym_end] = ACTIONS(465),
    [sym_identifier] = ACTIONS(467),
    [sym_decimal_integer_literal] = ACTIONS(467),
    [sym_hex_integer_literal] = ACTIONS(467),
    [sym_octal_integer_literal] = ACTIONS(465),
    [sym_binary_integer_literal] = ACTIONS(465),
    [sym_decimal_floating_point_literal] = ACTIONS(465),
    [sym_hex_floating_point_literal] = ACTIONS(467),
    [sym_true] = ACTIONS(467),
    [sym_false] = ACTIONS(467),
    [sym_character_literal] = ACTIONS(465),
    [sym_string_literal] = ACTIONS(467),
    [sym_text_block] = ACTIONS(465),
    [sym_null_literal] = ACTIONS(467),
    [anon_sym_LPAREN] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_PLUS] = ACTIONS(467),
    [anon_sym_DASH] = ACTIONS(467),
    [anon_sym_BANG] = ACTIONS(465),
    [anon_sym_TILDE] = ACTIONS(465),
    [anon_sym_PLUS_PLUS] = ACTIONS(465),
    [anon_sym_DASH_DASH] = ACTIONS(465),
    [anon_sym_new] = ACTIONS(467),
    [anon_sym_class] = ACTIONS(467),
    [anon_sym_switch] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_case] = ACTIONS(467),
    [anon_sym_default] = ACTIONS(467),
    [anon_sym_SEMI] = ACTIONS(465),
    [anon_sym_assert] = ACTIONS(467),
    [anon_sym_do] = ACTIONS(467),
    [anon_sym_while] = ACTIONS(467),
    [anon_sym_break] = ACTIONS(467),
    [anon_sym_continue] = ACTIONS(467),
    [anon_sym_return] = ACTIONS(467),
    [anon_sym_yield] = ACTIONS(467),
    [anon_sym_synchronized] = ACTIONS(467),
    [anon_sym_throw] = ACTIONS(467),
    [anon_sym_try] = ACTIONS(467),
    [anon_sym_if] = ACTIONS(467),
    [anon_sym_else] = ACTIONS(467),
    [anon_sym_for] = ACTIONS(467),
    [anon_sym_AT] = ACTIONS(467),
    [anon_sym_open] = ACTIONS(467),
    [anon_sym_module] = ACTIONS(467),
    [anon_sym_static] = ACTIONS(467),
    [anon_sym_package] = ACTIONS(467),
    [anon_sym_import] = ACTIONS(467),
    [anon_sym_enum] = ACTIONS(467),
    [anon_sym_public] = ACTIONS(467),
    [anon_sym_protected] = ACTIONS(467),
    [anon_sym_private] = ACTIONS(467),
    [anon_sym_abstract] = ACTIONS(467),
    [anon_sym_final] = ACTIONS(467),
    [anon_sym_strictfp] = ACTIONS(467),
    [anon_sym_native] = ACTIONS(467),
    [anon_sym_transient] = ACTIONS(467),
    [anon_sym_volatile] = ACTIONS(467),
    [anon_sym_sealed] = ACTIONS(467),
    [anon_sym_non_DASHsealed] = ACTIONS(465),
    [anon_sym_record] = ACTIONS(467),
    [anon_sym_ATinterface] = ACTIONS(465),
    [anon_sym_interface] = ACTIONS(467),
    [anon_sym_byte] = ACTIONS(467),
    [anon_sym_short] = ACTIONS(467),
    [anon_sym_int] = ACTIONS(467),
    [anon_sym_long] = ACTIONS(467),
    [anon_sym_char] = ACTIONS(467),
    [anon_sym_float] = ACTIONS(467),
    [anon_sym_double] = ACTIONS(467),
    [sym_boolean_type] = ACTIONS(467),
    [sym_void_type] = ACTIONS(467),
    [sym_this] = ACTIONS(467),
    [sym_super] = ACTIONS(467),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [103] = {
    [ts_builtin_sym_end] = ACTIONS(469),
    [sym_identifier] = ACTIONS(471),
    [sym_decimal_integer_literal] = ACTIONS(471),
    [sym_hex_integer_literal] = ACTIONS(471),
    [sym_octal_integer_literal] = ACTIONS(469),
    [sym_binary_integer_literal] = ACTIONS(469),
    [sym_decimal_floating_point_literal] = ACTIONS(469),
    [sym_hex_floating_point_literal] = ACTIONS(471),
    [sym_true] = ACTIONS(471),
    [sym_false] = ACTIONS(471),
    [sym_character_literal] = ACTIONS(469),
    [sym_string_literal] = ACTIONS(471),
    [sym_text_block] = ACTIONS(469),
    [sym_null_literal] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_PLUS] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(469),
    [anon_sym_PLUS_PLUS] = ACTIONS(469),
    [anon_sym_DASH_DASH] = ACTIONS(469),
    [anon_sym_new] = ACTIONS(471),
    [anon_sym_class] = ACTIONS(471),
    [anon_sym_switch] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_case] = ACTIONS(471),
    [anon_sym_default] = ACTIONS(471),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_assert] = ACTIONS(471),
    [anon_sym_do] = ACTIONS(471),
    [anon_sym_while] = ACTIONS(471),
    [anon_sym_break] = ACTIONS(471),
    [anon_sym_continue] = ACTIONS(471),
    [anon_sym_return] = ACTIONS(471),
    [anon_sym_yield] = ACTIONS(471),
    [anon_sym_synchronized] = ACTIONS(471),
    [anon_sym_throw] = ACTIONS(471),
    [anon_sym_try] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(471),
    [anon_sym_else] = ACTIONS(471),
    [anon_sym_for] = ACTIONS(471),
    [anon_sym_AT] = ACTIONS(471),
    [anon_sym_open] = ACTIONS(471),
    [anon_sym_module] = ACTIONS(471),
    [anon_sym_static] = ACTIONS(471),
    [anon_sym_package] = ACTIONS(471),
    [anon_sym_import] = ACTIONS(471),
    [anon_sym_enum] = ACTIONS(471),
    [anon_sym_public] = ACTIONS(471),
    [anon_sym_protected] = ACTIONS(471),
    [anon_sym_private] = ACTIONS(471),
    [anon_sym_abstract] = ACTIONS(471),
    [anon_sym_final] = ACTIONS(471),
    [anon_sym_strictfp] = ACTIONS(471),
    [anon_sym_native] = ACTIONS(471),
    [anon_sym_transient] = ACTIONS(471),
    [anon_sym_volatile] = ACTIONS(471),
    [anon_sym_sealed] = ACTIONS(471),
    [anon_sym_non_DASHsealed] = ACTIONS(469),
    [anon_sym_record] = ACTIONS(471),
    [anon_sym_ATinterface] = ACTIONS(469),
    [anon_sym_interface] = ACTIONS(471),
    [anon_sym_byte] = ACTIONS(471),
    [anon_sym_short] = ACTIONS(471),
    [anon_sym_int] = ACTIONS(471),
    [anon_sym_long] = ACTIONS(471),
    [anon_sym_char] = ACTIONS(471),
    [anon_sym_float] = ACTIONS(471),
    [anon_sym_double] = ACTIONS(471),
    [sym_boolean_type] = ACTIONS(471),
    [sym_void_type] = ACTIONS(471),
    [sym_this] = ACTIONS(471),
    [sym_super] = ACTIONS(471),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [104] = {
    [ts_builtin_sym_end] = ACTIONS(473),
    [sym_identifier] = ACTIONS(475),
    [sym_decimal_integer_literal] = ACTIONS(475),
    [sym_hex_integer_literal] = ACTIONS(475),
    [sym_octal_integer_literal] = ACTIONS(473),
    [sym_binary_integer_literal] = ACTIONS(473),
    [sym_decimal_floating_point_literal] = ACTIONS(473),
    [sym_hex_floating_point_literal] = ACTIONS(475),
    [sym_true] = ACTIONS(475),
    [sym_false] = ACTIONS(475),
    [sym_character_literal] = ACTIONS(473),
    [sym_string_literal] = ACTIONS(475),
    [sym_text_block] = ACTIONS(473),
    [sym_null_literal] = ACTIONS(475),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(475),
    [anon_sym_DASH] = ACTIONS(475),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_TILDE] = ACTIONS(473),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_new] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(475),
    [anon_sym_switch] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_case] = ACTIONS(475),
    [anon_sym_default] = ACTIONS(475),
    [anon_sym_SEMI] = ACTIONS(473),
    [anon_sym_assert] = ACTIONS(475),
    [anon_sym_do] = ACTIONS(475),
    [anon_sym_while] = ACTIONS(475),
    [anon_sym_break] = ACTIONS(475),
    [anon_sym_continue] = ACTIONS(475),
    [anon_sym_return] = ACTIONS(475),
    [anon_sym_yield] = ACTIONS(475),
    [anon_sym_synchronized] = ACTIONS(475),
    [anon_sym_throw] = ACTIONS(475),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_if] = ACTIONS(475),
    [anon_sym_else] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(475),
    [anon_sym_AT] = ACTIONS(475),
    [anon_sym_open] = ACTIONS(475),
    [anon_sym_module] = ACTIONS(475),
    [anon_sym_static] = ACTIONS(475),
    [anon_sym_package] = ACTIONS(475),
    [anon_sym_import] = ACTIONS(475),
    [anon_sym_enum] = ACTIONS(475),
    [anon_sym_public] = ACTIONS(475),
    [anon_sym_protected] = ACTIONS(475),
    [anon_sym_private] = ACTIONS(475),
    [anon_sym_abstract] = ACTIONS(475),
    [anon_sym_final] = ACTIONS(475),
    [anon_sym_strictfp] = ACTIONS(475),
    [anon_sym_native] = ACTIONS(475),
    [anon_sym_transient] = ACTIONS(475),
    [anon_sym_volatile] = ACTIONS(475),
    [anon_sym_sealed] = ACTIONS(475),
    [anon_sym_non_DASHsealed] = ACTIONS(473),
    [anon_sym_record] = ACTIONS(475),
    [anon_sym_ATinterface] = ACTIONS(473),
    [anon_sym_interface] = ACTIONS(475),
    [anon_sym_byte] = ACTIONS(475),
    [anon_sym_short] = ACTIONS(475),
    [anon_sym_int] = ACTIONS(475),
    [anon_sym_long] = ACTIONS(475),
    [anon_sym_char] = ACTIONS(475),
    [anon_sym_float] = ACTIONS(475),
    [anon_sym_double] = ACTIONS(475),
    [sym_boolean_type] = ACTIONS(475),
    [sym_void_type] = ACTIONS(475),
    [sym_this] = ACTIONS(475),
    [sym_super] = ACTIONS(475),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [105] = {
    [ts_builtin_sym_end] = ACTIONS(477),
    [sym_identifier] = ACTIONS(479),
    [sym_decimal_integer_literal] = ACTIONS(479),
    [sym_hex_integer_literal] = ACTIONS(479),
    [sym_octal_integer_literal] = ACTIONS(477),
    [sym_binary_integer_literal] = ACTIONS(477),
    [sym_decimal_floating_point_literal] = ACTIONS(477),
    [sym_hex_floating_point_literal] = ACTIONS(479),
    [sym_true] = ACTIONS(479),
    [sym_false] = ACTIONS(479),
    [sym_character_literal] = ACTIONS(477),
    [sym_string_literal] = ACTIONS(479),
    [sym_text_block] = ACTIONS(477),
    [sym_null_literal] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(477),
    [anon_sym_LT] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_BANG] = ACTIONS(477),
    [anon_sym_TILDE] = ACTIONS(477),
    [anon_sym_PLUS_PLUS] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(477),
    [anon_sym_new] = ACTIONS(479),
    [anon_sym_class] = ACTIONS(479),
    [anon_sym_switch] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_case] = ACTIONS(479),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_assert] = ACTIONS(479),
    [anon_sym_do] = ACTIONS(479),
    [anon_sym_while] = ACTIONS(479),
    [anon_sym_break] = ACTIONS(479),
    [anon_sym_continue] = ACTIONS(479),
    [anon_sym_return] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(479),
    [anon_sym_synchronized] = ACTIONS(479),
    [anon_sym_throw] = ACTIONS(479),
    [anon_sym_try] = ACTIONS(479),
    [anon_sym_if] = ACTIONS(479),
    [anon_sym_else] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(479),
    [anon_sym_open] = ACTIONS(479),
    [anon_sym_module] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(479),
    [anon_sym_package] = ACTIONS(479),
    [anon_sym_import] = ACTIONS(479),
    [anon_sym_enum] = ACTIONS(479),
    [anon_sym_public] = ACTIONS(479),
    [anon_sym_protected] = ACTIONS(479),
    [anon_sym_private] = ACTIONS(479),
    [anon_sym_abstract] = ACTIONS(479),
    [anon_sym_final] = ACTIONS(479),
    [anon_sym_strictfp] = ACTIONS(479),
    [anon_sym_native] = ACTIONS(479),
    [anon_sym_transient] = ACTIONS(479),
    [anon_sym_volatile] = ACTIONS(479),
    [anon_sym_sealed] = ACTIONS(479),
    [anon_sym_non_DASHsealed] = ACTIONS(477),
    [anon_sym_record] = ACTIONS(479),
    [anon_sym_ATinterface] = ACTIONS(477),
    [anon_sym_interface] = ACTIONS(479),
    [anon_sym_byte] = ACTIONS(479),
    [anon_sym_short] = ACTIONS(479),
    [anon_sym_int] = ACTIONS(479),
    [anon_sym_long] = ACTIONS(479),
    [anon_sym_char] = ACTIONS(479),
    [anon_sym_float] = ACTIONS(479),
    [anon_sym_double] = ACTIONS(479),
    [sym_boolean_type] = ACTIONS(479),
    [sym_void_type] = ACTIONS(479),
    [sym_this] = ACTIONS(479),
    [sym_super] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [106] = {
    [ts_builtin_sym_end] = ACTIONS(481),
    [sym_identifier] = ACTIONS(483),
    [sym_decimal_integer_literal] = ACTIONS(483),
    [sym_hex_integer_literal] = ACTIONS(483),
    [sym_octal_integer_literal] = ACTIONS(481),
    [sym_binary_integer_literal] = ACTIONS(481),
    [sym_decimal_floating_point_literal] = ACTIONS(481),
    [sym_hex_floating_point_literal] = ACTIONS(483),
    [sym_true] = ACTIONS(483),
    [sym_false] = ACTIONS(483),
    [sym_character_literal] = ACTIONS(481),
    [sym_string_literal] = ACTIONS(483),
    [sym_text_block] = ACTIONS(481),
    [sym_null_literal] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_PLUS] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(481),
    [anon_sym_TILDE] = ACTIONS(481),
    [anon_sym_PLUS_PLUS] = ACTIONS(481),
    [anon_sym_DASH_DASH] = ACTIONS(481),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_class] = ACTIONS(483),
    [anon_sym_switch] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(481),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_case] = ACTIONS(483),
    [anon_sym_default] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_assert] = ACTIONS(483),
    [anon_sym_do] = ACTIONS(483),
    [anon_sym_while] = ACTIONS(483),
    [anon_sym_break] = ACTIONS(483),
    [anon_sym_continue] = ACTIONS(483),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_yield] = ACTIONS(483),
    [anon_sym_synchronized] = ACTIONS(483),
    [anon_sym_throw] = ACTIONS(483),
    [anon_sym_try] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(483),
    [anon_sym_else] = ACTIONS(483),
    [anon_sym_for] = ACTIONS(483),
    [anon_sym_AT] = ACTIONS(483),
    [anon_sym_open] = ACTIONS(483),
    [anon_sym_module] = ACTIONS(483),
    [anon_sym_static] = ACTIONS(483),
    [anon_sym_package] = ACTIONS(483),
    [anon_sym_import] = ACTIONS(483),
    [anon_sym_enum] = ACTIONS(483),
    [anon_sym_public] = ACTIONS(483),
    [anon_sym_protected] = ACTIONS(483),
    [anon_sym_private] = ACTIONS(483),
    [anon_sym_abstract] = ACTIONS(483),
    [anon_sym_final] = ACTIONS(483),
    [anon_sym_strictfp] = ACTIONS(483),
    [anon_sym_native] = ACTIONS(483),
    [anon_sym_transient] = ACTIONS(483),
    [anon_sym_volatile] = ACTIONS(483),
    [anon_sym_sealed] = ACTIONS(483),
    [anon_sym_non_DASHsealed] = ACTIONS(481),
    [anon_sym_record] = ACTIONS(483),
    [anon_sym_ATinterface] = ACTIONS(481),
    [anon_sym_interface] = ACTIONS(483),
    [anon_sym_byte] = ACTIONS(483),
    [anon_sym_short] = ACTIONS(483),
    [anon_sym_int] = ACTIONS(483),
    [anon_sym_long] = ACTIONS(483),
    [anon_sym_char] = ACTIONS(483),
    [anon_sym_float] = ACTIONS(483),
    [anon_sym_double] = ACTIONS(483),
    [sym_boolean_type] = ACTIONS(483),
    [sym_void_type] = ACTIONS(483),
    [sym_this] = ACTIONS(483),
    [sym_super] = ACTIONS(483),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [107] = {
    [ts_builtin_sym_end] = ACTIONS(485),
    [sym_identifier] = ACTIONS(487),
    [sym_decimal_integer_literal] = ACTIONS(487),
    [sym_hex_integer_literal] = ACTIONS(487),
    [sym_octal_integer_literal] = ACTIONS(485),
    [sym_binary_integer_literal] = ACTIONS(485),
    [sym_decimal_floating_point_literal] = ACTIONS(485),
    [sym_hex_floating_point_literal] = ACTIONS(487),
    [sym_true] = ACTIONS(487),
    [sym_false] = ACTIONS(487),
    [sym_character_literal] = ACTIONS(485),
    [sym_string_literal] = ACTIONS(487),
    [sym_text_block] = ACTIONS(485),
    [sym_null_literal] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_DASH] = ACTIONS(487),
    [anon_sym_BANG] = ACTIONS(485),
    [anon_sym_TILDE] = ACTIONS(485),
    [anon_sym_PLUS_PLUS] = ACTIONS(485),
    [anon_sym_DASH_DASH] = ACTIONS(485),
    [anon_sym_new] = ACTIONS(487),
    [anon_sym_class] = ACTIONS(487),
    [anon_sym_switch] = ACTIONS(487),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_case] = ACTIONS(487),
    [anon_sym_default] = ACTIONS(487),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_assert] = ACTIONS(487),
    [anon_sym_do] = ACTIONS(487),
    [anon_sym_while] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(487),
    [anon_sym_continue] = ACTIONS(487),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_synchronized] = ACTIONS(487),
    [anon_sym_throw] = ACTIONS(487),
    [anon_sym_try] = ACTIONS(487),
    [anon_sym_catch] = ACTIONS(487),
    [anon_sym_finally] = ACTIONS(487),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_else] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(487),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_open] = ACTIONS(487),
    [anon_sym_module] = ACTIONS(487),
    [anon_sym_static] = ACTIONS(487),
    [anon_sym_package] = ACTIONS(487),
    [anon_sym_import] = ACTIONS(487),
    [anon_sym_enum] = ACTIONS(487),
    [anon_sym_public] = ACTIONS(487),
    [anon_sym_protected] = ACTIONS(487),
    [anon_sym_private] = ACTIONS(487),
    [anon_sym_abstract] = ACTIONS(487),
    [anon_sym_final] = ACTIONS(487),
    [anon_sym_strictfp] = ACTIONS(487),
    [anon_sym_native] = ACTIONS(487),
    [anon_sym_transient] = ACTIONS(487),
    [anon_sym_volatile] = ACTIONS(487),
    [anon_sym_sealed] = ACTIONS(487),
    [anon_sym_non_DASHsealed] = ACTIONS(485),
    [anon_sym_ATinterface] = ACTIONS(485),
    [anon_sym_interface] = ACTIONS(487),
    [anon_sym_byte] = ACTIONS(487),
    [anon_sym_short] = ACTIONS(487),
    [anon_sym_int] = ACTIONS(487),
    [anon_sym_long] = ACTIONS(487),
    [anon_sym_char] = ACTIONS(487),
    [anon_sym_float] = ACTIONS(487),
    [anon_sym_double] = ACTIONS(487),
    [sym_boolean_type] = ACTIONS(487),
    [sym_void_type] = ACTIONS(487),
    [sym_this] = ACTIONS(487),
    [sym_super] = ACTIONS(487),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [108] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(514),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym_array_initializer] = STATE(933),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [109] = {
    [ts_builtin_sym_end] = ACTIONS(495),
    [sym_identifier] = ACTIONS(497),
    [sym_decimal_integer_literal] = ACTIONS(497),
    [sym_hex_integer_literal] = ACTIONS(497),
    [sym_octal_integer_literal] = ACTIONS(495),
    [sym_binary_integer_literal] = ACTIONS(495),
    [sym_decimal_floating_point_literal] = ACTIONS(495),
    [sym_hex_floating_point_literal] = ACTIONS(497),
    [sym_true] = ACTIONS(497),
    [sym_false] = ACTIONS(497),
    [sym_character_literal] = ACTIONS(495),
    [sym_string_literal] = ACTIONS(497),
    [sym_text_block] = ACTIONS(495),
    [sym_null_literal] = ACTIONS(497),
    [anon_sym_LPAREN] = ACTIONS(495),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(497),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_TILDE] = ACTIONS(495),
    [anon_sym_PLUS_PLUS] = ACTIONS(495),
    [anon_sym_DASH_DASH] = ACTIONS(495),
    [anon_sym_new] = ACTIONS(497),
    [anon_sym_class] = ACTIONS(497),
    [anon_sym_switch] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_case] = ACTIONS(497),
    [anon_sym_default] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(495),
    [anon_sym_assert] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(497),
    [anon_sym_while] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_yield] = ACTIONS(497),
    [anon_sym_synchronized] = ACTIONS(497),
    [anon_sym_throw] = ACTIONS(497),
    [anon_sym_try] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(497),
    [anon_sym_else] = ACTIONS(497),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_AT] = ACTIONS(497),
    [anon_sym_open] = ACTIONS(497),
    [anon_sym_module] = ACTIONS(497),
    [anon_sym_static] = ACTIONS(497),
    [anon_sym_package] = ACTIONS(497),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_enum] = ACTIONS(497),
    [anon_sym_public] = ACTIONS(497),
    [anon_sym_protected] = ACTIONS(497),
    [anon_sym_private] = ACTIONS(497),
    [anon_sym_abstract] = ACTIONS(497),
    [anon_sym_final] = ACTIONS(497),
    [anon_sym_strictfp] = ACTIONS(497),
    [anon_sym_native] = ACTIONS(497),
    [anon_sym_transient] = ACTIONS(497),
    [anon_sym_volatile] = ACTIONS(497),
    [anon_sym_sealed] = ACTIONS(497),
    [anon_sym_non_DASHsealed] = ACTIONS(495),
    [anon_sym_record] = ACTIONS(497),
    [anon_sym_ATinterface] = ACTIONS(495),
    [anon_sym_interface] = ACTIONS(497),
    [anon_sym_byte] = ACTIONS(497),
    [anon_sym_short] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_long] = ACTIONS(497),
    [anon_sym_char] = ACTIONS(497),
    [anon_sym_float] = ACTIONS(497),
    [anon_sym_double] = ACTIONS(497),
    [sym_boolean_type] = ACTIONS(497),
    [sym_void_type] = ACTIONS(497),
    [sym_this] = ACTIONS(497),
    [sym_super] = ACTIONS(497),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [110] = {
    [ts_builtin_sym_end] = ACTIONS(499),
    [sym_identifier] = ACTIONS(501),
    [sym_decimal_integer_literal] = ACTIONS(501),
    [sym_hex_integer_literal] = ACTIONS(501),
    [sym_octal_integer_literal] = ACTIONS(499),
    [sym_binary_integer_literal] = ACTIONS(499),
    [sym_decimal_floating_point_literal] = ACTIONS(499),
    [sym_hex_floating_point_literal] = ACTIONS(501),
    [sym_true] = ACTIONS(501),
    [sym_false] = ACTIONS(501),
    [sym_character_literal] = ACTIONS(499),
    [sym_string_literal] = ACTIONS(501),
    [sym_text_block] = ACTIONS(499),
    [sym_null_literal] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_new] = ACTIONS(501),
    [anon_sym_class] = ACTIONS(501),
    [anon_sym_switch] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_case] = ACTIONS(501),
    [anon_sym_default] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(499),
    [anon_sym_assert] = ACTIONS(501),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(501),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(501),
    [anon_sym_yield] = ACTIONS(501),
    [anon_sym_synchronized] = ACTIONS(501),
    [anon_sym_throw] = ACTIONS(501),
    [anon_sym_try] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_AT] = ACTIONS(501),
    [anon_sym_open] = ACTIONS(501),
    [anon_sym_module] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(501),
    [anon_sym_package] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(501),
    [anon_sym_enum] = ACTIONS(501),
    [anon_sym_public] = ACTIONS(501),
    [anon_sym_protected] = ACTIONS(501),
    [anon_sym_private] = ACTIONS(501),
    [anon_sym_abstract] = ACTIONS(501),
    [anon_sym_final] = ACTIONS(501),
    [anon_sym_strictfp] = ACTIONS(501),
    [anon_sym_native] = ACTIONS(501),
    [anon_sym_transient] = ACTIONS(501),
    [anon_sym_volatile] = ACTIONS(501),
    [anon_sym_sealed] = ACTIONS(501),
    [anon_sym_non_DASHsealed] = ACTIONS(499),
    [anon_sym_record] = ACTIONS(501),
    [anon_sym_ATinterface] = ACTIONS(499),
    [anon_sym_interface] = ACTIONS(501),
    [anon_sym_byte] = ACTIONS(501),
    [anon_sym_short] = ACTIONS(501),
    [anon_sym_int] = ACTIONS(501),
    [anon_sym_long] = ACTIONS(501),
    [anon_sym_char] = ACTIONS(501),
    [anon_sym_float] = ACTIONS(501),
    [anon_sym_double] = ACTIONS(501),
    [sym_boolean_type] = ACTIONS(501),
    [sym_void_type] = ACTIONS(501),
    [sym_this] = ACTIONS(501),
    [sym_super] = ACTIONS(501),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [111] = {
    [ts_builtin_sym_end] = ACTIONS(503),
    [sym_identifier] = ACTIONS(505),
    [sym_decimal_integer_literal] = ACTIONS(505),
    [sym_hex_integer_literal] = ACTIONS(505),
    [sym_octal_integer_literal] = ACTIONS(503),
    [sym_binary_integer_literal] = ACTIONS(503),
    [sym_decimal_floating_point_literal] = ACTIONS(503),
    [sym_hex_floating_point_literal] = ACTIONS(505),
    [sym_true] = ACTIONS(505),
    [sym_false] = ACTIONS(505),
    [sym_character_literal] = ACTIONS(503),
    [sym_string_literal] = ACTIONS(505),
    [sym_text_block] = ACTIONS(503),
    [sym_null_literal] = ACTIONS(505),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_PLUS] = ACTIONS(505),
    [anon_sym_DASH] = ACTIONS(505),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_new] = ACTIONS(505),
    [anon_sym_class] = ACTIONS(505),
    [anon_sym_switch] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_case] = ACTIONS(505),
    [anon_sym_default] = ACTIONS(505),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_assert] = ACTIONS(505),
    [anon_sym_do] = ACTIONS(505),
    [anon_sym_while] = ACTIONS(505),
    [anon_sym_break] = ACTIONS(505),
    [anon_sym_continue] = ACTIONS(505),
    [anon_sym_return] = ACTIONS(505),
    [anon_sym_yield] = ACTIONS(505),
    [anon_sym_synchronized] = ACTIONS(505),
    [anon_sym_throw] = ACTIONS(505),
    [anon_sym_try] = ACTIONS(505),
    [anon_sym_if] = ACTIONS(505),
    [anon_sym_else] = ACTIONS(505),
    [anon_sym_for] = ACTIONS(505),
    [anon_sym_AT] = ACTIONS(505),
    [anon_sym_open] = ACTIONS(505),
    [anon_sym_module] = ACTIONS(505),
    [anon_sym_static] = ACTIONS(505),
    [anon_sym_package] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(505),
    [anon_sym_enum] = ACTIONS(505),
    [anon_sym_public] = ACTIONS(505),
    [anon_sym_protected] = ACTIONS(505),
    [anon_sym_private] = ACTIONS(505),
    [anon_sym_abstract] = ACTIONS(505),
    [anon_sym_final] = ACTIONS(505),
    [anon_sym_strictfp] = ACTIONS(505),
    [anon_sym_native] = ACTIONS(505),
    [anon_sym_transient] = ACTIONS(505),
    [anon_sym_volatile] = ACTIONS(505),
    [anon_sym_sealed] = ACTIONS(505),
    [anon_sym_non_DASHsealed] = ACTIONS(503),
    [anon_sym_record] = ACTIONS(505),
    [anon_sym_ATinterface] = ACTIONS(503),
    [anon_sym_interface] = ACTIONS(505),
    [anon_sym_byte] = ACTIONS(505),
    [anon_sym_short] = ACTIONS(505),
    [anon_sym_int] = ACTIONS(505),
    [anon_sym_long] = ACTIONS(505),
    [anon_sym_char] = ACTIONS(505),
    [anon_sym_float] = ACTIONS(505),
    [anon_sym_double] = ACTIONS(505),
    [sym_boolean_type] = ACTIONS(505),
    [sym_void_type] = ACTIONS(505),
    [sym_this] = ACTIONS(505),
    [sym_super] = ACTIONS(505),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [112] = {
    [ts_builtin_sym_end] = ACTIONS(507),
    [sym_identifier] = ACTIONS(509),
    [sym_decimal_integer_literal] = ACTIONS(509),
    [sym_hex_integer_literal] = ACTIONS(509),
    [sym_octal_integer_literal] = ACTIONS(507),
    [sym_binary_integer_literal] = ACTIONS(507),
    [sym_decimal_floating_point_literal] = ACTIONS(507),
    [sym_hex_floating_point_literal] = ACTIONS(509),
    [sym_true] = ACTIONS(509),
    [sym_false] = ACTIONS(509),
    [sym_character_literal] = ACTIONS(507),
    [sym_string_literal] = ACTIONS(509),
    [sym_text_block] = ACTIONS(507),
    [sym_null_literal] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(507),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(509),
    [anon_sym_DASH] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(507),
    [anon_sym_PLUS_PLUS] = ACTIONS(507),
    [anon_sym_DASH_DASH] = ACTIONS(507),
    [anon_sym_new] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(509),
    [anon_sym_switch] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_case] = ACTIONS(509),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(507),
    [anon_sym_assert] = ACTIONS(509),
    [anon_sym_do] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(509),
    [anon_sym_break] = ACTIONS(509),
    [anon_sym_continue] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_yield] = ACTIONS(509),
    [anon_sym_synchronized] = ACTIONS(509),
    [anon_sym_throw] = ACTIONS(509),
    [anon_sym_try] = ACTIONS(509),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_else] = ACTIONS(509),
    [anon_sym_for] = ACTIONS(509),
    [anon_sym_AT] = ACTIONS(509),
    [anon_sym_open] = ACTIONS(509),
    [anon_sym_module] = ACTIONS(509),
    [anon_sym_static] = ACTIONS(509),
    [anon_sym_package] = ACTIONS(509),
    [anon_sym_import] = ACTIONS(509),
    [anon_sym_enum] = ACTIONS(509),
    [anon_sym_public] = ACTIONS(509),
    [anon_sym_protected] = ACTIONS(509),
    [anon_sym_private] = ACTIONS(509),
    [anon_sym_abstract] = ACTIONS(509),
    [anon_sym_final] = ACTIONS(509),
    [anon_sym_strictfp] = ACTIONS(509),
    [anon_sym_native] = ACTIONS(509),
    [anon_sym_transient] = ACTIONS(509),
    [anon_sym_volatile] = ACTIONS(509),
    [anon_sym_sealed] = ACTIONS(509),
    [anon_sym_non_DASHsealed] = ACTIONS(507),
    [anon_sym_record] = ACTIONS(509),
    [anon_sym_ATinterface] = ACTIONS(507),
    [anon_sym_interface] = ACTIONS(509),
    [anon_sym_byte] = ACTIONS(509),
    [anon_sym_short] = ACTIONS(509),
    [anon_sym_int] = ACTIONS(509),
    [anon_sym_long] = ACTIONS(509),
    [anon_sym_char] = ACTIONS(509),
    [anon_sym_float] = ACTIONS(509),
    [anon_sym_double] = ACTIONS(509),
    [sym_boolean_type] = ACTIONS(509),
    [sym_void_type] = ACTIONS(509),
    [sym_this] = ACTIONS(509),
    [sym_super] = ACTIONS(509),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(511),
    [sym_identifier] = ACTIONS(513),
    [sym_decimal_integer_literal] = ACTIONS(513),
    [sym_hex_integer_literal] = ACTIONS(513),
    [sym_octal_integer_literal] = ACTIONS(511),
    [sym_binary_integer_literal] = ACTIONS(511),
    [sym_decimal_floating_point_literal] = ACTIONS(511),
    [sym_hex_floating_point_literal] = ACTIONS(513),
    [sym_true] = ACTIONS(513),
    [sym_false] = ACTIONS(513),
    [sym_character_literal] = ACTIONS(511),
    [sym_string_literal] = ACTIONS(513),
    [sym_text_block] = ACTIONS(511),
    [sym_null_literal] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_LT] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_DASH] = ACTIONS(513),
    [anon_sym_BANG] = ACTIONS(511),
    [anon_sym_TILDE] = ACTIONS(511),
    [anon_sym_PLUS_PLUS] = ACTIONS(511),
    [anon_sym_DASH_DASH] = ACTIONS(511),
    [anon_sym_new] = ACTIONS(513),
    [anon_sym_class] = ACTIONS(513),
    [anon_sym_switch] = ACTIONS(513),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_case] = ACTIONS(513),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_assert] = ACTIONS(513),
    [anon_sym_do] = ACTIONS(513),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_continue] = ACTIONS(513),
    [anon_sym_return] = ACTIONS(513),
    [anon_sym_yield] = ACTIONS(513),
    [anon_sym_synchronized] = ACTIONS(513),
    [anon_sym_throw] = ACTIONS(513),
    [anon_sym_try] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(513),
    [anon_sym_else] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_AT] = ACTIONS(513),
    [anon_sym_open] = ACTIONS(513),
    [anon_sym_module] = ACTIONS(513),
    [anon_sym_static] = ACTIONS(513),
    [anon_sym_package] = ACTIONS(513),
    [anon_sym_import] = ACTIONS(513),
    [anon_sym_enum] = ACTIONS(513),
    [anon_sym_public] = ACTIONS(513),
    [anon_sym_protected] = ACTIONS(513),
    [anon_sym_private] = ACTIONS(513),
    [anon_sym_abstract] = ACTIONS(513),
    [anon_sym_final] = ACTIONS(513),
    [anon_sym_strictfp] = ACTIONS(513),
    [anon_sym_native] = ACTIONS(513),
    [anon_sym_transient] = ACTIONS(513),
    [anon_sym_volatile] = ACTIONS(513),
    [anon_sym_sealed] = ACTIONS(513),
    [anon_sym_non_DASHsealed] = ACTIONS(511),
    [anon_sym_record] = ACTIONS(513),
    [anon_sym_ATinterface] = ACTIONS(511),
    [anon_sym_interface] = ACTIONS(513),
    [anon_sym_byte] = ACTIONS(513),
    [anon_sym_short] = ACTIONS(513),
    [anon_sym_int] = ACTIONS(513),
    [anon_sym_long] = ACTIONS(513),
    [anon_sym_char] = ACTIONS(513),
    [anon_sym_float] = ACTIONS(513),
    [anon_sym_double] = ACTIONS(513),
    [sym_boolean_type] = ACTIONS(513),
    [sym_void_type] = ACTIONS(513),
    [sym_this] = ACTIONS(513),
    [sym_super] = ACTIONS(513),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [114] = {
    [ts_builtin_sym_end] = ACTIONS(515),
    [sym_identifier] = ACTIONS(517),
    [sym_decimal_integer_literal] = ACTIONS(517),
    [sym_hex_integer_literal] = ACTIONS(517),
    [sym_octal_integer_literal] = ACTIONS(515),
    [sym_binary_integer_literal] = ACTIONS(515),
    [sym_decimal_floating_point_literal] = ACTIONS(515),
    [sym_hex_floating_point_literal] = ACTIONS(517),
    [sym_true] = ACTIONS(517),
    [sym_false] = ACTIONS(517),
    [sym_character_literal] = ACTIONS(515),
    [sym_string_literal] = ACTIONS(517),
    [sym_text_block] = ACTIONS(515),
    [sym_null_literal] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_LT] = ACTIONS(515),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_BANG] = ACTIONS(515),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [anon_sym_new] = ACTIONS(517),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_switch] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_case] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_assert] = ACTIONS(517),
    [anon_sym_do] = ACTIONS(517),
    [anon_sym_while] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(517),
    [anon_sym_continue] = ACTIONS(517),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_synchronized] = ACTIONS(517),
    [anon_sym_throw] = ACTIONS(517),
    [anon_sym_try] = ACTIONS(517),
    [anon_sym_if] = ACTIONS(517),
    [anon_sym_else] = ACTIONS(517),
    [anon_sym_for] = ACTIONS(517),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_open] = ACTIONS(517),
    [anon_sym_module] = ACTIONS(517),
    [anon_sym_static] = ACTIONS(517),
    [anon_sym_package] = ACTIONS(517),
    [anon_sym_import] = ACTIONS(517),
    [anon_sym_enum] = ACTIONS(517),
    [anon_sym_public] = ACTIONS(517),
    [anon_sym_protected] = ACTIONS(517),
    [anon_sym_private] = ACTIONS(517),
    [anon_sym_abstract] = ACTIONS(517),
    [anon_sym_final] = ACTIONS(517),
    [anon_sym_strictfp] = ACTIONS(517),
    [anon_sym_native] = ACTIONS(517),
    [anon_sym_transient] = ACTIONS(517),
    [anon_sym_volatile] = ACTIONS(517),
    [anon_sym_sealed] = ACTIONS(517),
    [anon_sym_non_DASHsealed] = ACTIONS(515),
    [anon_sym_record] = ACTIONS(517),
    [anon_sym_ATinterface] = ACTIONS(515),
    [anon_sym_interface] = ACTIONS(517),
    [anon_sym_byte] = ACTIONS(517),
    [anon_sym_short] = ACTIONS(517),
    [anon_sym_int] = ACTIONS(517),
    [anon_sym_long] = ACTIONS(517),
    [anon_sym_char] = ACTIONS(517),
    [anon_sym_float] = ACTIONS(517),
    [anon_sym_double] = ACTIONS(517),
    [sym_boolean_type] = ACTIONS(517),
    [sym_void_type] = ACTIONS(517),
    [sym_this] = ACTIONS(517),
    [sym_super] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [115] = {
    [ts_builtin_sym_end] = ACTIONS(519),
    [sym_identifier] = ACTIONS(521),
    [sym_decimal_integer_literal] = ACTIONS(521),
    [sym_hex_integer_literal] = ACTIONS(521),
    [sym_octal_integer_literal] = ACTIONS(519),
    [sym_binary_integer_literal] = ACTIONS(519),
    [sym_decimal_floating_point_literal] = ACTIONS(519),
    [sym_hex_floating_point_literal] = ACTIONS(521),
    [sym_true] = ACTIONS(521),
    [sym_false] = ACTIONS(521),
    [sym_character_literal] = ACTIONS(519),
    [sym_string_literal] = ACTIONS(521),
    [sym_text_block] = ACTIONS(519),
    [sym_null_literal] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(519),
    [anon_sym_LT] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_BANG] = ACTIONS(519),
    [anon_sym_TILDE] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(519),
    [anon_sym_DASH_DASH] = ACTIONS(519),
    [anon_sym_new] = ACTIONS(521),
    [anon_sym_class] = ACTIONS(521),
    [anon_sym_switch] = ACTIONS(521),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_case] = ACTIONS(521),
    [anon_sym_default] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_assert] = ACTIONS(521),
    [anon_sym_do] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(521),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_yield] = ACTIONS(521),
    [anon_sym_synchronized] = ACTIONS(521),
    [anon_sym_throw] = ACTIONS(521),
    [anon_sym_try] = ACTIONS(521),
    [anon_sym_if] = ACTIONS(521),
    [anon_sym_else] = ACTIONS(521),
    [anon_sym_for] = ACTIONS(521),
    [anon_sym_AT] = ACTIONS(521),
    [anon_sym_open] = ACTIONS(521),
    [anon_sym_module] = ACTIONS(521),
    [anon_sym_static] = ACTIONS(521),
    [anon_sym_package] = ACTIONS(521),
    [anon_sym_import] = ACTIONS(521),
    [anon_sym_enum] = ACTIONS(521),
    [anon_sym_public] = ACTIONS(521),
    [anon_sym_protected] = ACTIONS(521),
    [anon_sym_private] = ACTIONS(521),
    [anon_sym_abstract] = ACTIONS(521),
    [anon_sym_final] = ACTIONS(521),
    [anon_sym_strictfp] = ACTIONS(521),
    [anon_sym_native] = ACTIONS(521),
    [anon_sym_transient] = ACTIONS(521),
    [anon_sym_volatile] = ACTIONS(521),
    [anon_sym_sealed] = ACTIONS(521),
    [anon_sym_non_DASHsealed] = ACTIONS(519),
    [anon_sym_record] = ACTIONS(521),
    [anon_sym_ATinterface] = ACTIONS(519),
    [anon_sym_interface] = ACTIONS(521),
    [anon_sym_byte] = ACTIONS(521),
    [anon_sym_short] = ACTIONS(521),
    [anon_sym_int] = ACTIONS(521),
    [anon_sym_long] = ACTIONS(521),
    [anon_sym_char] = ACTIONS(521),
    [anon_sym_float] = ACTIONS(521),
    [anon_sym_double] = ACTIONS(521),
    [sym_boolean_type] = ACTIONS(521),
    [sym_void_type] = ACTIONS(521),
    [sym_this] = ACTIONS(521),
    [sym_super] = ACTIONS(521),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [116] = {
    [ts_builtin_sym_end] = ACTIONS(523),
    [sym_identifier] = ACTIONS(525),
    [sym_decimal_integer_literal] = ACTIONS(525),
    [sym_hex_integer_literal] = ACTIONS(525),
    [sym_octal_integer_literal] = ACTIONS(523),
    [sym_binary_integer_literal] = ACTIONS(523),
    [sym_decimal_floating_point_literal] = ACTIONS(523),
    [sym_hex_floating_point_literal] = ACTIONS(525),
    [sym_true] = ACTIONS(525),
    [sym_false] = ACTIONS(525),
    [sym_character_literal] = ACTIONS(523),
    [sym_string_literal] = ACTIONS(525),
    [sym_text_block] = ACTIONS(523),
    [sym_null_literal] = ACTIONS(525),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(525),
    [anon_sym_DASH] = ACTIONS(525),
    [anon_sym_BANG] = ACTIONS(523),
    [anon_sym_TILDE] = ACTIONS(523),
    [anon_sym_PLUS_PLUS] = ACTIONS(523),
    [anon_sym_DASH_DASH] = ACTIONS(523),
    [anon_sym_new] = ACTIONS(525),
    [anon_sym_class] = ACTIONS(525),
    [anon_sym_switch] = ACTIONS(525),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_case] = ACTIONS(525),
    [anon_sym_default] = ACTIONS(525),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_assert] = ACTIONS(525),
    [anon_sym_do] = ACTIONS(525),
    [anon_sym_while] = ACTIONS(525),
    [anon_sym_break] = ACTIONS(525),
    [anon_sym_continue] = ACTIONS(525),
    [anon_sym_return] = ACTIONS(525),
    [anon_sym_yield] = ACTIONS(525),
    [anon_sym_synchronized] = ACTIONS(525),
    [anon_sym_throw] = ACTIONS(525),
    [anon_sym_try] = ACTIONS(525),
    [anon_sym_if] = ACTIONS(525),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_for] = ACTIONS(525),
    [anon_sym_AT] = ACTIONS(525),
    [anon_sym_open] = ACTIONS(525),
    [anon_sym_module] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_package] = ACTIONS(525),
    [anon_sym_import] = ACTIONS(525),
    [anon_sym_enum] = ACTIONS(525),
    [anon_sym_public] = ACTIONS(525),
    [anon_sym_protected] = ACTIONS(525),
    [anon_sym_private] = ACTIONS(525),
    [anon_sym_abstract] = ACTIONS(525),
    [anon_sym_final] = ACTIONS(525),
    [anon_sym_strictfp] = ACTIONS(525),
    [anon_sym_native] = ACTIONS(525),
    [anon_sym_transient] = ACTIONS(525),
    [anon_sym_volatile] = ACTIONS(525),
    [anon_sym_sealed] = ACTIONS(525),
    [anon_sym_non_DASHsealed] = ACTIONS(523),
    [anon_sym_record] = ACTIONS(525),
    [anon_sym_ATinterface] = ACTIONS(523),
    [anon_sym_interface] = ACTIONS(525),
    [anon_sym_byte] = ACTIONS(525),
    [anon_sym_short] = ACTIONS(525),
    [anon_sym_int] = ACTIONS(525),
    [anon_sym_long] = ACTIONS(525),
    [anon_sym_char] = ACTIONS(525),
    [anon_sym_float] = ACTIONS(525),
    [anon_sym_double] = ACTIONS(525),
    [sym_boolean_type] = ACTIONS(525),
    [sym_void_type] = ACTIONS(525),
    [sym_this] = ACTIONS(525),
    [sym_super] = ACTIONS(525),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [117] = {
    [ts_builtin_sym_end] = ACTIONS(527),
    [sym_identifier] = ACTIONS(529),
    [sym_decimal_integer_literal] = ACTIONS(529),
    [sym_hex_integer_literal] = ACTIONS(529),
    [sym_octal_integer_literal] = ACTIONS(527),
    [sym_binary_integer_literal] = ACTIONS(527),
    [sym_decimal_floating_point_literal] = ACTIONS(527),
    [sym_hex_floating_point_literal] = ACTIONS(529),
    [sym_true] = ACTIONS(529),
    [sym_false] = ACTIONS(529),
    [sym_character_literal] = ACTIONS(527),
    [sym_string_literal] = ACTIONS(529),
    [sym_text_block] = ACTIONS(527),
    [sym_null_literal] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(527),
    [anon_sym_new] = ACTIONS(529),
    [anon_sym_class] = ACTIONS(529),
    [anon_sym_switch] = ACTIONS(529),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_case] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_SEMI] = ACTIONS(527),
    [anon_sym_assert] = ACTIONS(529),
    [anon_sym_do] = ACTIONS(529),
    [anon_sym_while] = ACTIONS(529),
    [anon_sym_break] = ACTIONS(529),
    [anon_sym_continue] = ACTIONS(529),
    [anon_sym_return] = ACTIONS(529),
    [anon_sym_yield] = ACTIONS(529),
    [anon_sym_synchronized] = ACTIONS(529),
    [anon_sym_throw] = ACTIONS(529),
    [anon_sym_try] = ACTIONS(529),
    [anon_sym_if] = ACTIONS(529),
    [anon_sym_else] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(529),
    [anon_sym_AT] = ACTIONS(529),
    [anon_sym_open] = ACTIONS(529),
    [anon_sym_module] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_package] = ACTIONS(529),
    [anon_sym_import] = ACTIONS(529),
    [anon_sym_enum] = ACTIONS(529),
    [anon_sym_public] = ACTIONS(529),
    [anon_sym_protected] = ACTIONS(529),
    [anon_sym_private] = ACTIONS(529),
    [anon_sym_abstract] = ACTIONS(529),
    [anon_sym_final] = ACTIONS(529),
    [anon_sym_strictfp] = ACTIONS(529),
    [anon_sym_native] = ACTIONS(529),
    [anon_sym_transient] = ACTIONS(529),
    [anon_sym_volatile] = ACTIONS(529),
    [anon_sym_sealed] = ACTIONS(529),
    [anon_sym_non_DASHsealed] = ACTIONS(527),
    [anon_sym_record] = ACTIONS(529),
    [anon_sym_ATinterface] = ACTIONS(527),
    [anon_sym_interface] = ACTIONS(529),
    [anon_sym_byte] = ACTIONS(529),
    [anon_sym_short] = ACTIONS(529),
    [anon_sym_int] = ACTIONS(529),
    [anon_sym_long] = ACTIONS(529),
    [anon_sym_char] = ACTIONS(529),
    [anon_sym_float] = ACTIONS(529),
    [anon_sym_double] = ACTIONS(529),
    [sym_boolean_type] = ACTIONS(529),
    [sym_void_type] = ACTIONS(529),
    [sym_this] = ACTIONS(529),
    [sym_super] = ACTIONS(529),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [118] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym__element_value] = STATE(975),
    [sym_element_value_array_initializer] = STATE(975),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(533),
    [sym_identifier] = ACTIONS(535),
    [sym_decimal_integer_literal] = ACTIONS(535),
    [sym_hex_integer_literal] = ACTIONS(535),
    [sym_octal_integer_literal] = ACTIONS(533),
    [sym_binary_integer_literal] = ACTIONS(533),
    [sym_decimal_floating_point_literal] = ACTIONS(533),
    [sym_hex_floating_point_literal] = ACTIONS(535),
    [sym_true] = ACTIONS(535),
    [sym_false] = ACTIONS(535),
    [sym_character_literal] = ACTIONS(533),
    [sym_string_literal] = ACTIONS(535),
    [sym_text_block] = ACTIONS(533),
    [sym_null_literal] = ACTIONS(535),
    [anon_sym_LPAREN] = ACTIONS(533),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_TILDE] = ACTIONS(533),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_new] = ACTIONS(535),
    [anon_sym_class] = ACTIONS(535),
    [anon_sym_switch] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(533),
    [anon_sym_RBRACE] = ACTIONS(533),
    [anon_sym_case] = ACTIONS(535),
    [anon_sym_default] = ACTIONS(535),
    [anon_sym_SEMI] = ACTIONS(533),
    [anon_sym_assert] = ACTIONS(535),
    [anon_sym_do] = ACTIONS(535),
    [anon_sym_while] = ACTIONS(535),
    [anon_sym_break] = ACTIONS(535),
    [anon_sym_continue] = ACTIONS(535),
    [anon_sym_return] = ACTIONS(535),
    [anon_sym_yield] = ACTIONS(535),
    [anon_sym_synchronized] = ACTIONS(535),
    [anon_sym_throw] = ACTIONS(535),
    [anon_sym_try] = ACTIONS(535),
    [anon_sym_if] = ACTIONS(535),
    [anon_sym_else] = ACTIONS(535),
    [anon_sym_for] = ACTIONS(535),
    [anon_sym_AT] = ACTIONS(535),
    [anon_sym_open] = ACTIONS(535),
    [anon_sym_module] = ACTIONS(535),
    [anon_sym_static] = ACTIONS(535),
    [anon_sym_package] = ACTIONS(535),
    [anon_sym_import] = ACTIONS(535),
    [anon_sym_enum] = ACTIONS(535),
    [anon_sym_public] = ACTIONS(535),
    [anon_sym_protected] = ACTIONS(535),
    [anon_sym_private] = ACTIONS(535),
    [anon_sym_abstract] = ACTIONS(535),
    [anon_sym_final] = ACTIONS(535),
    [anon_sym_strictfp] = ACTIONS(535),
    [anon_sym_native] = ACTIONS(535),
    [anon_sym_transient] = ACTIONS(535),
    [anon_sym_volatile] = ACTIONS(535),
    [anon_sym_sealed] = ACTIONS(535),
    [anon_sym_non_DASHsealed] = ACTIONS(533),
    [anon_sym_record] = ACTIONS(535),
    [anon_sym_ATinterface] = ACTIONS(533),
    [anon_sym_interface] = ACTIONS(535),
    [anon_sym_byte] = ACTIONS(535),
    [anon_sym_short] = ACTIONS(535),
    [anon_sym_int] = ACTIONS(535),
    [anon_sym_long] = ACTIONS(535),
    [anon_sym_char] = ACTIONS(535),
    [anon_sym_float] = ACTIONS(535),
    [anon_sym_double] = ACTIONS(535),
    [sym_boolean_type] = ACTIONS(535),
    [sym_void_type] = ACTIONS(535),
    [sym_this] = ACTIONS(535),
    [sym_super] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [120] = {
    [ts_builtin_sym_end] = ACTIONS(537),
    [sym_identifier] = ACTIONS(539),
    [sym_decimal_integer_literal] = ACTIONS(539),
    [sym_hex_integer_literal] = ACTIONS(539),
    [sym_octal_integer_literal] = ACTIONS(537),
    [sym_binary_integer_literal] = ACTIONS(537),
    [sym_decimal_floating_point_literal] = ACTIONS(537),
    [sym_hex_floating_point_literal] = ACTIONS(539),
    [sym_true] = ACTIONS(539),
    [sym_false] = ACTIONS(539),
    [sym_character_literal] = ACTIONS(537),
    [sym_string_literal] = ACTIONS(539),
    [sym_text_block] = ACTIONS(537),
    [sym_null_literal] = ACTIONS(539),
    [anon_sym_LPAREN] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_PLUS] = ACTIONS(539),
    [anon_sym_DASH] = ACTIONS(539),
    [anon_sym_BANG] = ACTIONS(537),
    [anon_sym_TILDE] = ACTIONS(537),
    [anon_sym_PLUS_PLUS] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(537),
    [anon_sym_new] = ACTIONS(539),
    [anon_sym_class] = ACTIONS(539),
    [anon_sym_switch] = ACTIONS(539),
    [anon_sym_LBRACE] = ACTIONS(537),
    [anon_sym_RBRACE] = ACTIONS(537),
    [anon_sym_case] = ACTIONS(539),
    [anon_sym_default] = ACTIONS(539),
    [anon_sym_SEMI] = ACTIONS(537),
    [anon_sym_assert] = ACTIONS(539),
    [anon_sym_do] = ACTIONS(539),
    [anon_sym_while] = ACTIONS(539),
    [anon_sym_break] = ACTIONS(539),
    [anon_sym_continue] = ACTIONS(539),
    [anon_sym_return] = ACTIONS(539),
    [anon_sym_yield] = ACTIONS(539),
    [anon_sym_synchronized] = ACTIONS(539),
    [anon_sym_throw] = ACTIONS(539),
    [anon_sym_try] = ACTIONS(539),
    [anon_sym_if] = ACTIONS(539),
    [anon_sym_else] = ACTIONS(539),
    [anon_sym_for] = ACTIONS(539),
    [anon_sym_AT] = ACTIONS(539),
    [anon_sym_open] = ACTIONS(539),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_static] = ACTIONS(539),
    [anon_sym_package] = ACTIONS(539),
    [anon_sym_import] = ACTIONS(539),
    [anon_sym_enum] = ACTIONS(539),
    [anon_sym_public] = ACTIONS(539),
    [anon_sym_protected] = ACTIONS(539),
    [anon_sym_private] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(539),
    [anon_sym_final] = ACTIONS(539),
    [anon_sym_strictfp] = ACTIONS(539),
    [anon_sym_native] = ACTIONS(539),
    [anon_sym_transient] = ACTIONS(539),
    [anon_sym_volatile] = ACTIONS(539),
    [anon_sym_sealed] = ACTIONS(539),
    [anon_sym_non_DASHsealed] = ACTIONS(537),
    [anon_sym_record] = ACTIONS(539),
    [anon_sym_ATinterface] = ACTIONS(537),
    [anon_sym_interface] = ACTIONS(539),
    [anon_sym_byte] = ACTIONS(539),
    [anon_sym_short] = ACTIONS(539),
    [anon_sym_int] = ACTIONS(539),
    [anon_sym_long] = ACTIONS(539),
    [anon_sym_char] = ACTIONS(539),
    [anon_sym_float] = ACTIONS(539),
    [anon_sym_double] = ACTIONS(539),
    [sym_boolean_type] = ACTIONS(539),
    [sym_void_type] = ACTIONS(539),
    [sym_this] = ACTIONS(539),
    [sym_super] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [121] = {
    [ts_builtin_sym_end] = ACTIONS(541),
    [sym_identifier] = ACTIONS(543),
    [sym_decimal_integer_literal] = ACTIONS(543),
    [sym_hex_integer_literal] = ACTIONS(543),
    [sym_octal_integer_literal] = ACTIONS(541),
    [sym_binary_integer_literal] = ACTIONS(541),
    [sym_decimal_floating_point_literal] = ACTIONS(541),
    [sym_hex_floating_point_literal] = ACTIONS(543),
    [sym_true] = ACTIONS(543),
    [sym_false] = ACTIONS(543),
    [sym_character_literal] = ACTIONS(541),
    [sym_string_literal] = ACTIONS(543),
    [sym_text_block] = ACTIONS(541),
    [sym_null_literal] = ACTIONS(543),
    [anon_sym_LPAREN] = ACTIONS(541),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(543),
    [anon_sym_BANG] = ACTIONS(541),
    [anon_sym_TILDE] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(541),
    [anon_sym_DASH_DASH] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(543),
    [anon_sym_class] = ACTIONS(543),
    [anon_sym_switch] = ACTIONS(543),
    [anon_sym_LBRACE] = ACTIONS(541),
    [anon_sym_RBRACE] = ACTIONS(541),
    [anon_sym_case] = ACTIONS(543),
    [anon_sym_default] = ACTIONS(543),
    [anon_sym_SEMI] = ACTIONS(541),
    [anon_sym_assert] = ACTIONS(543),
    [anon_sym_do] = ACTIONS(543),
    [anon_sym_while] = ACTIONS(543),
    [anon_sym_break] = ACTIONS(543),
    [anon_sym_continue] = ACTIONS(543),
    [anon_sym_return] = ACTIONS(543),
    [anon_sym_yield] = ACTIONS(543),
    [anon_sym_synchronized] = ACTIONS(543),
    [anon_sym_throw] = ACTIONS(543),
    [anon_sym_try] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(543),
    [anon_sym_else] = ACTIONS(543),
    [anon_sym_for] = ACTIONS(543),
    [anon_sym_AT] = ACTIONS(543),
    [anon_sym_open] = ACTIONS(543),
    [anon_sym_module] = ACTIONS(543),
    [anon_sym_static] = ACTIONS(543),
    [anon_sym_package] = ACTIONS(543),
    [anon_sym_import] = ACTIONS(543),
    [anon_sym_enum] = ACTIONS(543),
    [anon_sym_public] = ACTIONS(543),
    [anon_sym_protected] = ACTIONS(543),
    [anon_sym_private] = ACTIONS(543),
    [anon_sym_abstract] = ACTIONS(543),
    [anon_sym_final] = ACTIONS(543),
    [anon_sym_strictfp] = ACTIONS(543),
    [anon_sym_native] = ACTIONS(543),
    [anon_sym_transient] = ACTIONS(543),
    [anon_sym_volatile] = ACTIONS(543),
    [anon_sym_sealed] = ACTIONS(543),
    [anon_sym_non_DASHsealed] = ACTIONS(541),
    [anon_sym_record] = ACTIONS(543),
    [anon_sym_ATinterface] = ACTIONS(541),
    [anon_sym_interface] = ACTIONS(543),
    [anon_sym_byte] = ACTIONS(543),
    [anon_sym_short] = ACTIONS(543),
    [anon_sym_int] = ACTIONS(543),
    [anon_sym_long] = ACTIONS(543),
    [anon_sym_char] = ACTIONS(543),
    [anon_sym_float] = ACTIONS(543),
    [anon_sym_double] = ACTIONS(543),
    [sym_boolean_type] = ACTIONS(543),
    [sym_void_type] = ACTIONS(543),
    [sym_this] = ACTIONS(543),
    [sym_super] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [122] = {
    [ts_builtin_sym_end] = ACTIONS(545),
    [sym_identifier] = ACTIONS(547),
    [sym_decimal_integer_literal] = ACTIONS(547),
    [sym_hex_integer_literal] = ACTIONS(547),
    [sym_octal_integer_literal] = ACTIONS(545),
    [sym_binary_integer_literal] = ACTIONS(545),
    [sym_decimal_floating_point_literal] = ACTIONS(545),
    [sym_hex_floating_point_literal] = ACTIONS(547),
    [sym_true] = ACTIONS(547),
    [sym_false] = ACTIONS(547),
    [sym_character_literal] = ACTIONS(545),
    [sym_string_literal] = ACTIONS(547),
    [sym_text_block] = ACTIONS(545),
    [sym_null_literal] = ACTIONS(547),
    [anon_sym_LPAREN] = ACTIONS(545),
    [anon_sym_LT] = ACTIONS(545),
    [anon_sym_PLUS] = ACTIONS(547),
    [anon_sym_DASH] = ACTIONS(547),
    [anon_sym_BANG] = ACTIONS(545),
    [anon_sym_TILDE] = ACTIONS(545),
    [anon_sym_PLUS_PLUS] = ACTIONS(545),
    [anon_sym_DASH_DASH] = ACTIONS(545),
    [anon_sym_new] = ACTIONS(547),
    [anon_sym_class] = ACTIONS(547),
    [anon_sym_switch] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(545),
    [anon_sym_RBRACE] = ACTIONS(545),
    [anon_sym_case] = ACTIONS(547),
    [anon_sym_default] = ACTIONS(547),
    [anon_sym_SEMI] = ACTIONS(545),
    [anon_sym_assert] = ACTIONS(547),
    [anon_sym_do] = ACTIONS(547),
    [anon_sym_while] = ACTIONS(547),
    [anon_sym_break] = ACTIONS(547),
    [anon_sym_continue] = ACTIONS(547),
    [anon_sym_return] = ACTIONS(547),
    [anon_sym_yield] = ACTIONS(547),
    [anon_sym_synchronized] = ACTIONS(547),
    [anon_sym_throw] = ACTIONS(547),
    [anon_sym_try] = ACTIONS(547),
    [anon_sym_if] = ACTIONS(547),
    [anon_sym_else] = ACTIONS(547),
    [anon_sym_for] = ACTIONS(547),
    [anon_sym_AT] = ACTIONS(547),
    [anon_sym_open] = ACTIONS(547),
    [anon_sym_module] = ACTIONS(547),
    [anon_sym_static] = ACTIONS(547),
    [anon_sym_package] = ACTIONS(547),
    [anon_sym_import] = ACTIONS(547),
    [anon_sym_enum] = ACTIONS(547),
    [anon_sym_public] = ACTIONS(547),
    [anon_sym_protected] = ACTIONS(547),
    [anon_sym_private] = ACTIONS(547),
    [anon_sym_abstract] = ACTIONS(547),
    [anon_sym_final] = ACTIONS(547),
    [anon_sym_strictfp] = ACTIONS(547),
    [anon_sym_native] = ACTIONS(547),
    [anon_sym_transient] = ACTIONS(547),
    [anon_sym_volatile] = ACTIONS(547),
    [anon_sym_sealed] = ACTIONS(547),
    [anon_sym_non_DASHsealed] = ACTIONS(545),
    [anon_sym_record] = ACTIONS(547),
    [anon_sym_ATinterface] = ACTIONS(545),
    [anon_sym_interface] = ACTIONS(547),
    [anon_sym_byte] = ACTIONS(547),
    [anon_sym_short] = ACTIONS(547),
    [anon_sym_int] = ACTIONS(547),
    [anon_sym_long] = ACTIONS(547),
    [anon_sym_char] = ACTIONS(547),
    [anon_sym_float] = ACTIONS(547),
    [anon_sym_double] = ACTIONS(547),
    [sym_boolean_type] = ACTIONS(547),
    [sym_void_type] = ACTIONS(547),
    [sym_this] = ACTIONS(547),
    [sym_super] = ACTIONS(547),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [123] = {
    [ts_builtin_sym_end] = ACTIONS(549),
    [sym_identifier] = ACTIONS(551),
    [sym_decimal_integer_literal] = ACTIONS(551),
    [sym_hex_integer_literal] = ACTIONS(551),
    [sym_octal_integer_literal] = ACTIONS(549),
    [sym_binary_integer_literal] = ACTIONS(549),
    [sym_decimal_floating_point_literal] = ACTIONS(549),
    [sym_hex_floating_point_literal] = ACTIONS(551),
    [sym_true] = ACTIONS(551),
    [sym_false] = ACTIONS(551),
    [sym_character_literal] = ACTIONS(549),
    [sym_string_literal] = ACTIONS(551),
    [sym_text_block] = ACTIONS(549),
    [sym_null_literal] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(549),
    [anon_sym_LT] = ACTIONS(549),
    [anon_sym_PLUS] = ACTIONS(551),
    [anon_sym_DASH] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_PLUS_PLUS] = ACTIONS(549),
    [anon_sym_DASH_DASH] = ACTIONS(549),
    [anon_sym_new] = ACTIONS(551),
    [anon_sym_class] = ACTIONS(551),
    [anon_sym_switch] = ACTIONS(551),
    [anon_sym_LBRACE] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(549),
    [anon_sym_case] = ACTIONS(551),
    [anon_sym_default] = ACTIONS(551),
    [anon_sym_SEMI] = ACTIONS(549),
    [anon_sym_assert] = ACTIONS(551),
    [anon_sym_do] = ACTIONS(551),
    [anon_sym_while] = ACTIONS(551),
    [anon_sym_break] = ACTIONS(551),
    [anon_sym_continue] = ACTIONS(551),
    [anon_sym_return] = ACTIONS(551),
    [anon_sym_yield] = ACTIONS(551),
    [anon_sym_synchronized] = ACTIONS(551),
    [anon_sym_throw] = ACTIONS(551),
    [anon_sym_try] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(551),
    [anon_sym_else] = ACTIONS(551),
    [anon_sym_for] = ACTIONS(551),
    [anon_sym_AT] = ACTIONS(551),
    [anon_sym_open] = ACTIONS(551),
    [anon_sym_module] = ACTIONS(551),
    [anon_sym_static] = ACTIONS(551),
    [anon_sym_package] = ACTIONS(551),
    [anon_sym_import] = ACTIONS(551),
    [anon_sym_enum] = ACTIONS(551),
    [anon_sym_public] = ACTIONS(551),
    [anon_sym_protected] = ACTIONS(551),
    [anon_sym_private] = ACTIONS(551),
    [anon_sym_abstract] = ACTIONS(551),
    [anon_sym_final] = ACTIONS(551),
    [anon_sym_strictfp] = ACTIONS(551),
    [anon_sym_native] = ACTIONS(551),
    [anon_sym_transient] = ACTIONS(551),
    [anon_sym_volatile] = ACTIONS(551),
    [anon_sym_sealed] = ACTIONS(551),
    [anon_sym_non_DASHsealed] = ACTIONS(549),
    [anon_sym_record] = ACTIONS(551),
    [anon_sym_ATinterface] = ACTIONS(549),
    [anon_sym_interface] = ACTIONS(551),
    [anon_sym_byte] = ACTIONS(551),
    [anon_sym_short] = ACTIONS(551),
    [anon_sym_int] = ACTIONS(551),
    [anon_sym_long] = ACTIONS(551),
    [anon_sym_char] = ACTIONS(551),
    [anon_sym_float] = ACTIONS(551),
    [anon_sym_double] = ACTIONS(551),
    [sym_boolean_type] = ACTIONS(551),
    [sym_void_type] = ACTIONS(551),
    [sym_this] = ACTIONS(551),
    [sym_super] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [124] = {
    [ts_builtin_sym_end] = ACTIONS(553),
    [sym_identifier] = ACTIONS(555),
    [sym_decimal_integer_literal] = ACTIONS(555),
    [sym_hex_integer_literal] = ACTIONS(555),
    [sym_octal_integer_literal] = ACTIONS(553),
    [sym_binary_integer_literal] = ACTIONS(553),
    [sym_decimal_floating_point_literal] = ACTIONS(553),
    [sym_hex_floating_point_literal] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_character_literal] = ACTIONS(553),
    [sym_string_literal] = ACTIONS(555),
    [sym_text_block] = ACTIONS(553),
    [sym_null_literal] = ACTIONS(555),
    [anon_sym_LPAREN] = ACTIONS(553),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_PLUS] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(555),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(553),
    [anon_sym_PLUS_PLUS] = ACTIONS(553),
    [anon_sym_DASH_DASH] = ACTIONS(553),
    [anon_sym_new] = ACTIONS(555),
    [anon_sym_class] = ACTIONS(555),
    [anon_sym_switch] = ACTIONS(555),
    [anon_sym_LBRACE] = ACTIONS(553),
    [anon_sym_RBRACE] = ACTIONS(553),
    [anon_sym_case] = ACTIONS(555),
    [anon_sym_default] = ACTIONS(555),
    [anon_sym_SEMI] = ACTIONS(553),
    [anon_sym_assert] = ACTIONS(555),
    [anon_sym_do] = ACTIONS(555),
    [anon_sym_while] = ACTIONS(555),
    [anon_sym_break] = ACTIONS(555),
    [anon_sym_continue] = ACTIONS(555),
    [anon_sym_return] = ACTIONS(555),
    [anon_sym_yield] = ACTIONS(555),
    [anon_sym_synchronized] = ACTIONS(555),
    [anon_sym_throw] = ACTIONS(555),
    [anon_sym_try] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(555),
    [anon_sym_else] = ACTIONS(555),
    [anon_sym_for] = ACTIONS(555),
    [anon_sym_AT] = ACTIONS(555),
    [anon_sym_open] = ACTIONS(555),
    [anon_sym_module] = ACTIONS(555),
    [anon_sym_static] = ACTIONS(555),
    [anon_sym_package] = ACTIONS(555),
    [anon_sym_import] = ACTIONS(555),
    [anon_sym_enum] = ACTIONS(555),
    [anon_sym_public] = ACTIONS(555),
    [anon_sym_protected] = ACTIONS(555),
    [anon_sym_private] = ACTIONS(555),
    [anon_sym_abstract] = ACTIONS(555),
    [anon_sym_final] = ACTIONS(555),
    [anon_sym_strictfp] = ACTIONS(555),
    [anon_sym_native] = ACTIONS(555),
    [anon_sym_transient] = ACTIONS(555),
    [anon_sym_volatile] = ACTIONS(555),
    [anon_sym_sealed] = ACTIONS(555),
    [anon_sym_non_DASHsealed] = ACTIONS(553),
    [anon_sym_record] = ACTIONS(555),
    [anon_sym_ATinterface] = ACTIONS(553),
    [anon_sym_interface] = ACTIONS(555),
    [anon_sym_byte] = ACTIONS(555),
    [anon_sym_short] = ACTIONS(555),
    [anon_sym_int] = ACTIONS(555),
    [anon_sym_long] = ACTIONS(555),
    [anon_sym_char] = ACTIONS(555),
    [anon_sym_float] = ACTIONS(555),
    [anon_sym_double] = ACTIONS(555),
    [sym_boolean_type] = ACTIONS(555),
    [sym_void_type] = ACTIONS(555),
    [sym_this] = ACTIONS(555),
    [sym_super] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [125] = {
    [ts_builtin_sym_end] = ACTIONS(557),
    [sym_identifier] = ACTIONS(559),
    [sym_decimal_integer_literal] = ACTIONS(559),
    [sym_hex_integer_literal] = ACTIONS(559),
    [sym_octal_integer_literal] = ACTIONS(557),
    [sym_binary_integer_literal] = ACTIONS(557),
    [sym_decimal_floating_point_literal] = ACTIONS(557),
    [sym_hex_floating_point_literal] = ACTIONS(559),
    [sym_true] = ACTIONS(559),
    [sym_false] = ACTIONS(559),
    [sym_character_literal] = ACTIONS(557),
    [sym_string_literal] = ACTIONS(559),
    [sym_text_block] = ACTIONS(557),
    [sym_null_literal] = ACTIONS(559),
    [anon_sym_LPAREN] = ACTIONS(557),
    [anon_sym_LT] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_DASH] = ACTIONS(559),
    [anon_sym_BANG] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [anon_sym_PLUS_PLUS] = ACTIONS(557),
    [anon_sym_DASH_DASH] = ACTIONS(557),
    [anon_sym_new] = ACTIONS(559),
    [anon_sym_class] = ACTIONS(559),
    [anon_sym_switch] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_RBRACE] = ACTIONS(557),
    [anon_sym_case] = ACTIONS(559),
    [anon_sym_default] = ACTIONS(559),
    [anon_sym_SEMI] = ACTIONS(557),
    [anon_sym_assert] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_break] = ACTIONS(559),
    [anon_sym_continue] = ACTIONS(559),
    [anon_sym_return] = ACTIONS(559),
    [anon_sym_yield] = ACTIONS(559),
    [anon_sym_synchronized] = ACTIONS(559),
    [anon_sym_throw] = ACTIONS(559),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(559),
    [anon_sym_open] = ACTIONS(559),
    [anon_sym_module] = ACTIONS(559),
    [anon_sym_static] = ACTIONS(559),
    [anon_sym_package] = ACTIONS(559),
    [anon_sym_import] = ACTIONS(559),
    [anon_sym_enum] = ACTIONS(559),
    [anon_sym_public] = ACTIONS(559),
    [anon_sym_protected] = ACTIONS(559),
    [anon_sym_private] = ACTIONS(559),
    [anon_sym_abstract] = ACTIONS(559),
    [anon_sym_final] = ACTIONS(559),
    [anon_sym_strictfp] = ACTIONS(559),
    [anon_sym_native] = ACTIONS(559),
    [anon_sym_transient] = ACTIONS(559),
    [anon_sym_volatile] = ACTIONS(559),
    [anon_sym_sealed] = ACTIONS(559),
    [anon_sym_non_DASHsealed] = ACTIONS(557),
    [anon_sym_record] = ACTIONS(559),
    [anon_sym_ATinterface] = ACTIONS(557),
    [anon_sym_interface] = ACTIONS(559),
    [anon_sym_byte] = ACTIONS(559),
    [anon_sym_short] = ACTIONS(559),
    [anon_sym_int] = ACTIONS(559),
    [anon_sym_long] = ACTIONS(559),
    [anon_sym_char] = ACTIONS(559),
    [anon_sym_float] = ACTIONS(559),
    [anon_sym_double] = ACTIONS(559),
    [sym_boolean_type] = ACTIONS(559),
    [sym_void_type] = ACTIONS(559),
    [sym_this] = ACTIONS(559),
    [sym_super] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [126] = {
    [ts_builtin_sym_end] = ACTIONS(561),
    [sym_identifier] = ACTIONS(563),
    [sym_decimal_integer_literal] = ACTIONS(563),
    [sym_hex_integer_literal] = ACTIONS(563),
    [sym_octal_integer_literal] = ACTIONS(561),
    [sym_binary_integer_literal] = ACTIONS(561),
    [sym_decimal_floating_point_literal] = ACTIONS(561),
    [sym_hex_floating_point_literal] = ACTIONS(563),
    [sym_true] = ACTIONS(563),
    [sym_false] = ACTIONS(563),
    [sym_character_literal] = ACTIONS(561),
    [sym_string_literal] = ACTIONS(563),
    [sym_text_block] = ACTIONS(561),
    [sym_null_literal] = ACTIONS(563),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(563),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_BANG] = ACTIONS(561),
    [anon_sym_TILDE] = ACTIONS(561),
    [anon_sym_PLUS_PLUS] = ACTIONS(561),
    [anon_sym_DASH_DASH] = ACTIONS(561),
    [anon_sym_new] = ACTIONS(563),
    [anon_sym_class] = ACTIONS(563),
    [anon_sym_switch] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(561),
    [anon_sym_RBRACE] = ACTIONS(561),
    [anon_sym_case] = ACTIONS(563),
    [anon_sym_default] = ACTIONS(563),
    [anon_sym_SEMI] = ACTIONS(561),
    [anon_sym_assert] = ACTIONS(563),
    [anon_sym_do] = ACTIONS(563),
    [anon_sym_while] = ACTIONS(563),
    [anon_sym_break] = ACTIONS(563),
    [anon_sym_continue] = ACTIONS(563),
    [anon_sym_return] = ACTIONS(563),
    [anon_sym_yield] = ACTIONS(563),
    [anon_sym_synchronized] = ACTIONS(563),
    [anon_sym_throw] = ACTIONS(563),
    [anon_sym_try] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(563),
    [anon_sym_else] = ACTIONS(563),
    [anon_sym_for] = ACTIONS(563),
    [anon_sym_AT] = ACTIONS(563),
    [anon_sym_open] = ACTIONS(563),
    [anon_sym_module] = ACTIONS(563),
    [anon_sym_static] = ACTIONS(563),
    [anon_sym_package] = ACTIONS(563),
    [anon_sym_import] = ACTIONS(563),
    [anon_sym_enum] = ACTIONS(563),
    [anon_sym_public] = ACTIONS(563),
    [anon_sym_protected] = ACTIONS(563),
    [anon_sym_private] = ACTIONS(563),
    [anon_sym_abstract] = ACTIONS(563),
    [anon_sym_final] = ACTIONS(563),
    [anon_sym_strictfp] = ACTIONS(563),
    [anon_sym_native] = ACTIONS(563),
    [anon_sym_transient] = ACTIONS(563),
    [anon_sym_volatile] = ACTIONS(563),
    [anon_sym_sealed] = ACTIONS(563),
    [anon_sym_non_DASHsealed] = ACTIONS(561),
    [anon_sym_record] = ACTIONS(563),
    [anon_sym_ATinterface] = ACTIONS(561),
    [anon_sym_interface] = ACTIONS(563),
    [anon_sym_byte] = ACTIONS(563),
    [anon_sym_short] = ACTIONS(563),
    [anon_sym_int] = ACTIONS(563),
    [anon_sym_long] = ACTIONS(563),
    [anon_sym_char] = ACTIONS(563),
    [anon_sym_float] = ACTIONS(563),
    [anon_sym_double] = ACTIONS(563),
    [sym_boolean_type] = ACTIONS(563),
    [sym_void_type] = ACTIONS(563),
    [sym_this] = ACTIONS(563),
    [sym_super] = ACTIONS(563),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [127] = {
    [ts_builtin_sym_end] = ACTIONS(565),
    [sym_identifier] = ACTIONS(567),
    [sym_decimal_integer_literal] = ACTIONS(567),
    [sym_hex_integer_literal] = ACTIONS(567),
    [sym_octal_integer_literal] = ACTIONS(565),
    [sym_binary_integer_literal] = ACTIONS(565),
    [sym_decimal_floating_point_literal] = ACTIONS(565),
    [sym_hex_floating_point_literal] = ACTIONS(567),
    [sym_true] = ACTIONS(567),
    [sym_false] = ACTIONS(567),
    [sym_character_literal] = ACTIONS(565),
    [sym_string_literal] = ACTIONS(567),
    [sym_text_block] = ACTIONS(565),
    [sym_null_literal] = ACTIONS(567),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_LT] = ACTIONS(565),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_DASH] = ACTIONS(567),
    [anon_sym_BANG] = ACTIONS(565),
    [anon_sym_TILDE] = ACTIONS(565),
    [anon_sym_PLUS_PLUS] = ACTIONS(565),
    [anon_sym_DASH_DASH] = ACTIONS(565),
    [anon_sym_new] = ACTIONS(567),
    [anon_sym_class] = ACTIONS(567),
    [anon_sym_switch] = ACTIONS(567),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_default] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_assert] = ACTIONS(567),
    [anon_sym_do] = ACTIONS(567),
    [anon_sym_while] = ACTIONS(567),
    [anon_sym_break] = ACTIONS(567),
    [anon_sym_continue] = ACTIONS(567),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_yield] = ACTIONS(567),
    [anon_sym_synchronized] = ACTIONS(567),
    [anon_sym_throw] = ACTIONS(567),
    [anon_sym_try] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_else] = ACTIONS(567),
    [anon_sym_for] = ACTIONS(567),
    [anon_sym_AT] = ACTIONS(567),
    [anon_sym_open] = ACTIONS(567),
    [anon_sym_module] = ACTIONS(567),
    [anon_sym_static] = ACTIONS(567),
    [anon_sym_package] = ACTIONS(567),
    [anon_sym_import] = ACTIONS(567),
    [anon_sym_enum] = ACTIONS(567),
    [anon_sym_public] = ACTIONS(567),
    [anon_sym_protected] = ACTIONS(567),
    [anon_sym_private] = ACTIONS(567),
    [anon_sym_abstract] = ACTIONS(567),
    [anon_sym_final] = ACTIONS(567),
    [anon_sym_strictfp] = ACTIONS(567),
    [anon_sym_native] = ACTIONS(567),
    [anon_sym_transient] = ACTIONS(567),
    [anon_sym_volatile] = ACTIONS(567),
    [anon_sym_sealed] = ACTIONS(567),
    [anon_sym_non_DASHsealed] = ACTIONS(565),
    [anon_sym_record] = ACTIONS(567),
    [anon_sym_ATinterface] = ACTIONS(565),
    [anon_sym_interface] = ACTIONS(567),
    [anon_sym_byte] = ACTIONS(567),
    [anon_sym_short] = ACTIONS(567),
    [anon_sym_int] = ACTIONS(567),
    [anon_sym_long] = ACTIONS(567),
    [anon_sym_char] = ACTIONS(567),
    [anon_sym_float] = ACTIONS(567),
    [anon_sym_double] = ACTIONS(567),
    [sym_boolean_type] = ACTIONS(567),
    [sym_void_type] = ACTIONS(567),
    [sym_this] = ACTIONS(567),
    [sym_super] = ACTIONS(567),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [128] = {
    [ts_builtin_sym_end] = ACTIONS(569),
    [sym_identifier] = ACTIONS(571),
    [sym_decimal_integer_literal] = ACTIONS(571),
    [sym_hex_integer_literal] = ACTIONS(571),
    [sym_octal_integer_literal] = ACTIONS(569),
    [sym_binary_integer_literal] = ACTIONS(569),
    [sym_decimal_floating_point_literal] = ACTIONS(569),
    [sym_hex_floating_point_literal] = ACTIONS(571),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_character_literal] = ACTIONS(569),
    [sym_string_literal] = ACTIONS(571),
    [sym_text_block] = ACTIONS(569),
    [sym_null_literal] = ACTIONS(571),
    [anon_sym_LPAREN] = ACTIONS(569),
    [anon_sym_LT] = ACTIONS(569),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_DASH] = ACTIONS(571),
    [anon_sym_BANG] = ACTIONS(569),
    [anon_sym_TILDE] = ACTIONS(569),
    [anon_sym_PLUS_PLUS] = ACTIONS(569),
    [anon_sym_DASH_DASH] = ACTIONS(569),
    [anon_sym_new] = ACTIONS(571),
    [anon_sym_class] = ACTIONS(571),
    [anon_sym_switch] = ACTIONS(571),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_case] = ACTIONS(571),
    [anon_sym_default] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_assert] = ACTIONS(571),
    [anon_sym_do] = ACTIONS(571),
    [anon_sym_while] = ACTIONS(571),
    [anon_sym_break] = ACTIONS(571),
    [anon_sym_continue] = ACTIONS(571),
    [anon_sym_return] = ACTIONS(571),
    [anon_sym_yield] = ACTIONS(571),
    [anon_sym_synchronized] = ACTIONS(571),
    [anon_sym_throw] = ACTIONS(571),
    [anon_sym_try] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(571),
    [anon_sym_else] = ACTIONS(571),
    [anon_sym_for] = ACTIONS(571),
    [anon_sym_AT] = ACTIONS(571),
    [anon_sym_open] = ACTIONS(571),
    [anon_sym_module] = ACTIONS(571),
    [anon_sym_static] = ACTIONS(571),
    [anon_sym_package] = ACTIONS(571),
    [anon_sym_import] = ACTIONS(571),
    [anon_sym_enum] = ACTIONS(571),
    [anon_sym_public] = ACTIONS(571),
    [anon_sym_protected] = ACTIONS(571),
    [anon_sym_private] = ACTIONS(571),
    [anon_sym_abstract] = ACTIONS(571),
    [anon_sym_final] = ACTIONS(571),
    [anon_sym_strictfp] = ACTIONS(571),
    [anon_sym_native] = ACTIONS(571),
    [anon_sym_transient] = ACTIONS(571),
    [anon_sym_volatile] = ACTIONS(571),
    [anon_sym_sealed] = ACTIONS(571),
    [anon_sym_non_DASHsealed] = ACTIONS(569),
    [anon_sym_record] = ACTIONS(571),
    [anon_sym_ATinterface] = ACTIONS(569),
    [anon_sym_interface] = ACTIONS(571),
    [anon_sym_byte] = ACTIONS(571),
    [anon_sym_short] = ACTIONS(571),
    [anon_sym_int] = ACTIONS(571),
    [anon_sym_long] = ACTIONS(571),
    [anon_sym_char] = ACTIONS(571),
    [anon_sym_float] = ACTIONS(571),
    [anon_sym_double] = ACTIONS(571),
    [sym_boolean_type] = ACTIONS(571),
    [sym_void_type] = ACTIONS(571),
    [sym_this] = ACTIONS(571),
    [sym_super] = ACTIONS(571),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [129] = {
    [ts_builtin_sym_end] = ACTIONS(573),
    [sym_identifier] = ACTIONS(575),
    [sym_decimal_integer_literal] = ACTIONS(575),
    [sym_hex_integer_literal] = ACTIONS(575),
    [sym_octal_integer_literal] = ACTIONS(573),
    [sym_binary_integer_literal] = ACTIONS(573),
    [sym_decimal_floating_point_literal] = ACTIONS(573),
    [sym_hex_floating_point_literal] = ACTIONS(575),
    [sym_true] = ACTIONS(575),
    [sym_false] = ACTIONS(575),
    [sym_character_literal] = ACTIONS(573),
    [sym_string_literal] = ACTIONS(575),
    [sym_text_block] = ACTIONS(573),
    [sym_null_literal] = ACTIONS(575),
    [anon_sym_LPAREN] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(573),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(575),
    [anon_sym_BANG] = ACTIONS(573),
    [anon_sym_TILDE] = ACTIONS(573),
    [anon_sym_PLUS_PLUS] = ACTIONS(573),
    [anon_sym_DASH_DASH] = ACTIONS(573),
    [anon_sym_new] = ACTIONS(575),
    [anon_sym_class] = ACTIONS(575),
    [anon_sym_switch] = ACTIONS(575),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_case] = ACTIONS(575),
    [anon_sym_default] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_assert] = ACTIONS(575),
    [anon_sym_do] = ACTIONS(575),
    [anon_sym_while] = ACTIONS(575),
    [anon_sym_break] = ACTIONS(575),
    [anon_sym_continue] = ACTIONS(575),
    [anon_sym_return] = ACTIONS(575),
    [anon_sym_yield] = ACTIONS(575),
    [anon_sym_synchronized] = ACTIONS(575),
    [anon_sym_throw] = ACTIONS(575),
    [anon_sym_try] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(575),
    [anon_sym_else] = ACTIONS(575),
    [anon_sym_for] = ACTIONS(575),
    [anon_sym_AT] = ACTIONS(575),
    [anon_sym_open] = ACTIONS(575),
    [anon_sym_module] = ACTIONS(575),
    [anon_sym_static] = ACTIONS(575),
    [anon_sym_package] = ACTIONS(575),
    [anon_sym_import] = ACTIONS(575),
    [anon_sym_enum] = ACTIONS(575),
    [anon_sym_public] = ACTIONS(575),
    [anon_sym_protected] = ACTIONS(575),
    [anon_sym_private] = ACTIONS(575),
    [anon_sym_abstract] = ACTIONS(575),
    [anon_sym_final] = ACTIONS(575),
    [anon_sym_strictfp] = ACTIONS(575),
    [anon_sym_native] = ACTIONS(575),
    [anon_sym_transient] = ACTIONS(575),
    [anon_sym_volatile] = ACTIONS(575),
    [anon_sym_sealed] = ACTIONS(575),
    [anon_sym_non_DASHsealed] = ACTIONS(573),
    [anon_sym_record] = ACTIONS(575),
    [anon_sym_ATinterface] = ACTIONS(573),
    [anon_sym_interface] = ACTIONS(575),
    [anon_sym_byte] = ACTIONS(575),
    [anon_sym_short] = ACTIONS(575),
    [anon_sym_int] = ACTIONS(575),
    [anon_sym_long] = ACTIONS(575),
    [anon_sym_char] = ACTIONS(575),
    [anon_sym_float] = ACTIONS(575),
    [anon_sym_double] = ACTIONS(575),
    [sym_boolean_type] = ACTIONS(575),
    [sym_void_type] = ACTIONS(575),
    [sym_this] = ACTIONS(575),
    [sym_super] = ACTIONS(575),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [130] = {
    [ts_builtin_sym_end] = ACTIONS(577),
    [sym_identifier] = ACTIONS(579),
    [sym_decimal_integer_literal] = ACTIONS(579),
    [sym_hex_integer_literal] = ACTIONS(579),
    [sym_octal_integer_literal] = ACTIONS(577),
    [sym_binary_integer_literal] = ACTIONS(577),
    [sym_decimal_floating_point_literal] = ACTIONS(577),
    [sym_hex_floating_point_literal] = ACTIONS(579),
    [sym_true] = ACTIONS(579),
    [sym_false] = ACTIONS(579),
    [sym_character_literal] = ACTIONS(577),
    [sym_string_literal] = ACTIONS(579),
    [sym_text_block] = ACTIONS(577),
    [sym_null_literal] = ACTIONS(579),
    [anon_sym_LPAREN] = ACTIONS(577),
    [anon_sym_LT] = ACTIONS(577),
    [anon_sym_PLUS] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(579),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_TILDE] = ACTIONS(577),
    [anon_sym_PLUS_PLUS] = ACTIONS(577),
    [anon_sym_DASH_DASH] = ACTIONS(577),
    [anon_sym_new] = ACTIONS(579),
    [anon_sym_class] = ACTIONS(579),
    [anon_sym_switch] = ACTIONS(579),
    [anon_sym_LBRACE] = ACTIONS(577),
    [anon_sym_RBRACE] = ACTIONS(577),
    [anon_sym_case] = ACTIONS(579),
    [anon_sym_default] = ACTIONS(579),
    [anon_sym_SEMI] = ACTIONS(577),
    [anon_sym_assert] = ACTIONS(579),
    [anon_sym_do] = ACTIONS(579),
    [anon_sym_while] = ACTIONS(579),
    [anon_sym_break] = ACTIONS(579),
    [anon_sym_continue] = ACTIONS(579),
    [anon_sym_return] = ACTIONS(579),
    [anon_sym_yield] = ACTIONS(579),
    [anon_sym_synchronized] = ACTIONS(579),
    [anon_sym_throw] = ACTIONS(579),
    [anon_sym_try] = ACTIONS(579),
    [anon_sym_if] = ACTIONS(579),
    [anon_sym_else] = ACTIONS(579),
    [anon_sym_for] = ACTIONS(579),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_open] = ACTIONS(579),
    [anon_sym_module] = ACTIONS(579),
    [anon_sym_static] = ACTIONS(579),
    [anon_sym_package] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(579),
    [anon_sym_enum] = ACTIONS(579),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_protected] = ACTIONS(579),
    [anon_sym_private] = ACTIONS(579),
    [anon_sym_abstract] = ACTIONS(579),
    [anon_sym_final] = ACTIONS(579),
    [anon_sym_strictfp] = ACTIONS(579),
    [anon_sym_native] = ACTIONS(579),
    [anon_sym_transient] = ACTIONS(579),
    [anon_sym_volatile] = ACTIONS(579),
    [anon_sym_sealed] = ACTIONS(579),
    [anon_sym_non_DASHsealed] = ACTIONS(577),
    [anon_sym_record] = ACTIONS(579),
    [anon_sym_ATinterface] = ACTIONS(577),
    [anon_sym_interface] = ACTIONS(579),
    [anon_sym_byte] = ACTIONS(579),
    [anon_sym_short] = ACTIONS(579),
    [anon_sym_int] = ACTIONS(579),
    [anon_sym_long] = ACTIONS(579),
    [anon_sym_char] = ACTIONS(579),
    [anon_sym_float] = ACTIONS(579),
    [anon_sym_double] = ACTIONS(579),
    [sym_boolean_type] = ACTIONS(579),
    [sym_void_type] = ACTIONS(579),
    [sym_this] = ACTIONS(579),
    [sym_super] = ACTIONS(579),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [131] = {
    [ts_builtin_sym_end] = ACTIONS(581),
    [sym_identifier] = ACTIONS(583),
    [sym_decimal_integer_literal] = ACTIONS(583),
    [sym_hex_integer_literal] = ACTIONS(583),
    [sym_octal_integer_literal] = ACTIONS(581),
    [sym_binary_integer_literal] = ACTIONS(581),
    [sym_decimal_floating_point_literal] = ACTIONS(581),
    [sym_hex_floating_point_literal] = ACTIONS(583),
    [sym_true] = ACTIONS(583),
    [sym_false] = ACTIONS(583),
    [sym_character_literal] = ACTIONS(581),
    [sym_string_literal] = ACTIONS(583),
    [sym_text_block] = ACTIONS(581),
    [sym_null_literal] = ACTIONS(583),
    [anon_sym_LPAREN] = ACTIONS(581),
    [anon_sym_LT] = ACTIONS(581),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_BANG] = ACTIONS(581),
    [anon_sym_TILDE] = ACTIONS(581),
    [anon_sym_PLUS_PLUS] = ACTIONS(581),
    [anon_sym_DASH_DASH] = ACTIONS(581),
    [anon_sym_new] = ACTIONS(583),
    [anon_sym_class] = ACTIONS(583),
    [anon_sym_switch] = ACTIONS(583),
    [anon_sym_LBRACE] = ACTIONS(581),
    [anon_sym_RBRACE] = ACTIONS(581),
    [anon_sym_case] = ACTIONS(583),
    [anon_sym_default] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(581),
    [anon_sym_assert] = ACTIONS(583),
    [anon_sym_do] = ACTIONS(583),
    [anon_sym_while] = ACTIONS(583),
    [anon_sym_break] = ACTIONS(583),
    [anon_sym_continue] = ACTIONS(583),
    [anon_sym_return] = ACTIONS(583),
    [anon_sym_yield] = ACTIONS(583),
    [anon_sym_synchronized] = ACTIONS(583),
    [anon_sym_throw] = ACTIONS(583),
    [anon_sym_try] = ACTIONS(583),
    [anon_sym_if] = ACTIONS(583),
    [anon_sym_else] = ACTIONS(583),
    [anon_sym_for] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(583),
    [anon_sym_open] = ACTIONS(583),
    [anon_sym_module] = ACTIONS(583),
    [anon_sym_static] = ACTIONS(583),
    [anon_sym_package] = ACTIONS(583),
    [anon_sym_import] = ACTIONS(583),
    [anon_sym_enum] = ACTIONS(583),
    [anon_sym_public] = ACTIONS(583),
    [anon_sym_protected] = ACTIONS(583),
    [anon_sym_private] = ACTIONS(583),
    [anon_sym_abstract] = ACTIONS(583),
    [anon_sym_final] = ACTIONS(583),
    [anon_sym_strictfp] = ACTIONS(583),
    [anon_sym_native] = ACTIONS(583),
    [anon_sym_transient] = ACTIONS(583),
    [anon_sym_volatile] = ACTIONS(583),
    [anon_sym_sealed] = ACTIONS(583),
    [anon_sym_non_DASHsealed] = ACTIONS(581),
    [anon_sym_record] = ACTIONS(583),
    [anon_sym_ATinterface] = ACTIONS(581),
    [anon_sym_interface] = ACTIONS(583),
    [anon_sym_byte] = ACTIONS(583),
    [anon_sym_short] = ACTIONS(583),
    [anon_sym_int] = ACTIONS(583),
    [anon_sym_long] = ACTIONS(583),
    [anon_sym_char] = ACTIONS(583),
    [anon_sym_float] = ACTIONS(583),
    [anon_sym_double] = ACTIONS(583),
    [sym_boolean_type] = ACTIONS(583),
    [sym_void_type] = ACTIONS(583),
    [sym_this] = ACTIONS(583),
    [sym_super] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(585),
    [sym_identifier] = ACTIONS(587),
    [sym_decimal_integer_literal] = ACTIONS(587),
    [sym_hex_integer_literal] = ACTIONS(587),
    [sym_octal_integer_literal] = ACTIONS(585),
    [sym_binary_integer_literal] = ACTIONS(585),
    [sym_decimal_floating_point_literal] = ACTIONS(585),
    [sym_hex_floating_point_literal] = ACTIONS(587),
    [sym_true] = ACTIONS(587),
    [sym_false] = ACTIONS(587),
    [sym_character_literal] = ACTIONS(585),
    [sym_string_literal] = ACTIONS(587),
    [sym_text_block] = ACTIONS(585),
    [sym_null_literal] = ACTIONS(587),
    [anon_sym_LPAREN] = ACTIONS(585),
    [anon_sym_LT] = ACTIONS(585),
    [anon_sym_PLUS] = ACTIONS(587),
    [anon_sym_DASH] = ACTIONS(587),
    [anon_sym_BANG] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(585),
    [anon_sym_PLUS_PLUS] = ACTIONS(585),
    [anon_sym_DASH_DASH] = ACTIONS(585),
    [anon_sym_new] = ACTIONS(587),
    [anon_sym_class] = ACTIONS(587),
    [anon_sym_switch] = ACTIONS(587),
    [anon_sym_LBRACE] = ACTIONS(585),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_case] = ACTIONS(587),
    [anon_sym_default] = ACTIONS(587),
    [anon_sym_SEMI] = ACTIONS(585),
    [anon_sym_assert] = ACTIONS(587),
    [anon_sym_do] = ACTIONS(587),
    [anon_sym_while] = ACTIONS(587),
    [anon_sym_break] = ACTIONS(587),
    [anon_sym_continue] = ACTIONS(587),
    [anon_sym_return] = ACTIONS(587),
    [anon_sym_yield] = ACTIONS(587),
    [anon_sym_synchronized] = ACTIONS(587),
    [anon_sym_throw] = ACTIONS(587),
    [anon_sym_try] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(587),
    [anon_sym_else] = ACTIONS(587),
    [anon_sym_for] = ACTIONS(587),
    [anon_sym_AT] = ACTIONS(587),
    [anon_sym_open] = ACTIONS(587),
    [anon_sym_module] = ACTIONS(587),
    [anon_sym_static] = ACTIONS(587),
    [anon_sym_package] = ACTIONS(587),
    [anon_sym_import] = ACTIONS(587),
    [anon_sym_enum] = ACTIONS(587),
    [anon_sym_public] = ACTIONS(587),
    [anon_sym_protected] = ACTIONS(587),
    [anon_sym_private] = ACTIONS(587),
    [anon_sym_abstract] = ACTIONS(587),
    [anon_sym_final] = ACTIONS(587),
    [anon_sym_strictfp] = ACTIONS(587),
    [anon_sym_native] = ACTIONS(587),
    [anon_sym_transient] = ACTIONS(587),
    [anon_sym_volatile] = ACTIONS(587),
    [anon_sym_sealed] = ACTIONS(587),
    [anon_sym_non_DASHsealed] = ACTIONS(585),
    [anon_sym_record] = ACTIONS(587),
    [anon_sym_ATinterface] = ACTIONS(585),
    [anon_sym_interface] = ACTIONS(587),
    [anon_sym_byte] = ACTIONS(587),
    [anon_sym_short] = ACTIONS(587),
    [anon_sym_int] = ACTIONS(587),
    [anon_sym_long] = ACTIONS(587),
    [anon_sym_char] = ACTIONS(587),
    [anon_sym_float] = ACTIONS(587),
    [anon_sym_double] = ACTIONS(587),
    [sym_boolean_type] = ACTIONS(587),
    [sym_void_type] = ACTIONS(587),
    [sym_this] = ACTIONS(587),
    [sym_super] = ACTIONS(587),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(589),
    [sym_identifier] = ACTIONS(591),
    [sym_decimal_integer_literal] = ACTIONS(591),
    [sym_hex_integer_literal] = ACTIONS(591),
    [sym_octal_integer_literal] = ACTIONS(589),
    [sym_binary_integer_literal] = ACTIONS(589),
    [sym_decimal_floating_point_literal] = ACTIONS(589),
    [sym_hex_floating_point_literal] = ACTIONS(591),
    [sym_true] = ACTIONS(591),
    [sym_false] = ACTIONS(591),
    [sym_character_literal] = ACTIONS(589),
    [sym_string_literal] = ACTIONS(591),
    [sym_text_block] = ACTIONS(589),
    [sym_null_literal] = ACTIONS(591),
    [anon_sym_LPAREN] = ACTIONS(589),
    [anon_sym_LT] = ACTIONS(589),
    [anon_sym_PLUS] = ACTIONS(591),
    [anon_sym_DASH] = ACTIONS(591),
    [anon_sym_BANG] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(589),
    [anon_sym_PLUS_PLUS] = ACTIONS(589),
    [anon_sym_DASH_DASH] = ACTIONS(589),
    [anon_sym_new] = ACTIONS(591),
    [anon_sym_class] = ACTIONS(591),
    [anon_sym_switch] = ACTIONS(591),
    [anon_sym_LBRACE] = ACTIONS(589),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_case] = ACTIONS(591),
    [anon_sym_default] = ACTIONS(591),
    [anon_sym_SEMI] = ACTIONS(589),
    [anon_sym_assert] = ACTIONS(591),
    [anon_sym_do] = ACTIONS(591),
    [anon_sym_while] = ACTIONS(591),
    [anon_sym_break] = ACTIONS(591),
    [anon_sym_continue] = ACTIONS(591),
    [anon_sym_return] = ACTIONS(591),
    [anon_sym_yield] = ACTIONS(591),
    [anon_sym_synchronized] = ACTIONS(591),
    [anon_sym_throw] = ACTIONS(591),
    [anon_sym_try] = ACTIONS(591),
    [anon_sym_if] = ACTIONS(591),
    [anon_sym_else] = ACTIONS(591),
    [anon_sym_for] = ACTIONS(591),
    [anon_sym_AT] = ACTIONS(591),
    [anon_sym_open] = ACTIONS(591),
    [anon_sym_module] = ACTIONS(591),
    [anon_sym_static] = ACTIONS(591),
    [anon_sym_package] = ACTIONS(591),
    [anon_sym_import] = ACTIONS(591),
    [anon_sym_enum] = ACTIONS(591),
    [anon_sym_public] = ACTIONS(591),
    [anon_sym_protected] = ACTIONS(591),
    [anon_sym_private] = ACTIONS(591),
    [anon_sym_abstract] = ACTIONS(591),
    [anon_sym_final] = ACTIONS(591),
    [anon_sym_strictfp] = ACTIONS(591),
    [anon_sym_native] = ACTIONS(591),
    [anon_sym_transient] = ACTIONS(591),
    [anon_sym_volatile] = ACTIONS(591),
    [anon_sym_sealed] = ACTIONS(591),
    [anon_sym_non_DASHsealed] = ACTIONS(589),
    [anon_sym_record] = ACTIONS(591),
    [anon_sym_ATinterface] = ACTIONS(589),
    [anon_sym_interface] = ACTIONS(591),
    [anon_sym_byte] = ACTIONS(591),
    [anon_sym_short] = ACTIONS(591),
    [anon_sym_int] = ACTIONS(591),
    [anon_sym_long] = ACTIONS(591),
    [anon_sym_char] = ACTIONS(591),
    [anon_sym_float] = ACTIONS(591),
    [anon_sym_double] = ACTIONS(591),
    [sym_boolean_type] = ACTIONS(591),
    [sym_void_type] = ACTIONS(591),
    [sym_this] = ACTIONS(591),
    [sym_super] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(593),
    [sym_identifier] = ACTIONS(595),
    [sym_decimal_integer_literal] = ACTIONS(595),
    [sym_hex_integer_literal] = ACTIONS(595),
    [sym_octal_integer_literal] = ACTIONS(593),
    [sym_binary_integer_literal] = ACTIONS(593),
    [sym_decimal_floating_point_literal] = ACTIONS(593),
    [sym_hex_floating_point_literal] = ACTIONS(595),
    [sym_true] = ACTIONS(595),
    [sym_false] = ACTIONS(595),
    [sym_character_literal] = ACTIONS(593),
    [sym_string_literal] = ACTIONS(595),
    [sym_text_block] = ACTIONS(593),
    [sym_null_literal] = ACTIONS(595),
    [anon_sym_LPAREN] = ACTIONS(593),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_PLUS] = ACTIONS(595),
    [anon_sym_DASH] = ACTIONS(595),
    [anon_sym_BANG] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(593),
    [anon_sym_PLUS_PLUS] = ACTIONS(593),
    [anon_sym_DASH_DASH] = ACTIONS(593),
    [anon_sym_new] = ACTIONS(595),
    [anon_sym_class] = ACTIONS(595),
    [anon_sym_switch] = ACTIONS(595),
    [anon_sym_LBRACE] = ACTIONS(593),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_case] = ACTIONS(595),
    [anon_sym_default] = ACTIONS(595),
    [anon_sym_SEMI] = ACTIONS(593),
    [anon_sym_assert] = ACTIONS(595),
    [anon_sym_do] = ACTIONS(595),
    [anon_sym_while] = ACTIONS(595),
    [anon_sym_break] = ACTIONS(595),
    [anon_sym_continue] = ACTIONS(595),
    [anon_sym_return] = ACTIONS(595),
    [anon_sym_yield] = ACTIONS(595),
    [anon_sym_synchronized] = ACTIONS(595),
    [anon_sym_throw] = ACTIONS(595),
    [anon_sym_try] = ACTIONS(595),
    [anon_sym_if] = ACTIONS(595),
    [anon_sym_else] = ACTIONS(595),
    [anon_sym_for] = ACTIONS(595),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_open] = ACTIONS(595),
    [anon_sym_module] = ACTIONS(595),
    [anon_sym_static] = ACTIONS(595),
    [anon_sym_package] = ACTIONS(595),
    [anon_sym_import] = ACTIONS(595),
    [anon_sym_enum] = ACTIONS(595),
    [anon_sym_public] = ACTIONS(595),
    [anon_sym_protected] = ACTIONS(595),
    [anon_sym_private] = ACTIONS(595),
    [anon_sym_abstract] = ACTIONS(595),
    [anon_sym_final] = ACTIONS(595),
    [anon_sym_strictfp] = ACTIONS(595),
    [anon_sym_native] = ACTIONS(595),
    [anon_sym_transient] = ACTIONS(595),
    [anon_sym_volatile] = ACTIONS(595),
    [anon_sym_sealed] = ACTIONS(595),
    [anon_sym_non_DASHsealed] = ACTIONS(593),
    [anon_sym_record] = ACTIONS(595),
    [anon_sym_ATinterface] = ACTIONS(593),
    [anon_sym_interface] = ACTIONS(595),
    [anon_sym_byte] = ACTIONS(595),
    [anon_sym_short] = ACTIONS(595),
    [anon_sym_int] = ACTIONS(595),
    [anon_sym_long] = ACTIONS(595),
    [anon_sym_char] = ACTIONS(595),
    [anon_sym_float] = ACTIONS(595),
    [anon_sym_double] = ACTIONS(595),
    [sym_boolean_type] = ACTIONS(595),
    [sym_void_type] = ACTIONS(595),
    [sym_this] = ACTIONS(595),
    [sym_super] = ACTIONS(595),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [135] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym__element_value] = STATE(975),
    [sym_element_value_array_initializer] = STATE(975),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [136] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym__element_value] = STATE(1108),
    [sym_element_value_array_initializer] = STATE(1108),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [137] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(474),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym__element_value] = STATE(1018),
    [sym_element_value_array_initializer] = STATE(1018),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [138] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(525),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(609),
    [sym_marker_annotation] = STATE(609),
    [sym_annotation] = STATE(609),
    [sym__element_value] = STATE(1018),
    [sym_element_value_array_initializer] = STATE(1018),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(319),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [139] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(522),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym_array_initializer] = STATE(986),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [140] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(522),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym_array_initializer] = STATE(986),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(601),
    [sym_identifier] = ACTIONS(603),
    [sym_decimal_integer_literal] = ACTIONS(603),
    [sym_hex_integer_literal] = ACTIONS(603),
    [sym_octal_integer_literal] = ACTIONS(601),
    [sym_binary_integer_literal] = ACTIONS(601),
    [sym_decimal_floating_point_literal] = ACTIONS(601),
    [sym_hex_floating_point_literal] = ACTIONS(603),
    [sym_true] = ACTIONS(603),
    [sym_false] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(601),
    [sym_string_literal] = ACTIONS(603),
    [sym_text_block] = ACTIONS(601),
    [sym_null_literal] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(601),
    [anon_sym_PLUS] = ACTIONS(603),
    [anon_sym_DASH] = ACTIONS(603),
    [anon_sym_BANG] = ACTIONS(601),
    [anon_sym_TILDE] = ACTIONS(601),
    [anon_sym_PLUS_PLUS] = ACTIONS(601),
    [anon_sym_DASH_DASH] = ACTIONS(601),
    [anon_sym_new] = ACTIONS(603),
    [anon_sym_class] = ACTIONS(603),
    [anon_sym_switch] = ACTIONS(603),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(601),
    [anon_sym_case] = ACTIONS(603),
    [anon_sym_default] = ACTIONS(603),
    [anon_sym_SEMI] = ACTIONS(601),
    [anon_sym_assert] = ACTIONS(603),
    [anon_sym_do] = ACTIONS(603),
    [anon_sym_while] = ACTIONS(603),
    [anon_sym_break] = ACTIONS(603),
    [anon_sym_continue] = ACTIONS(603),
    [anon_sym_return] = ACTIONS(603),
    [anon_sym_yield] = ACTIONS(603),
    [anon_sym_synchronized] = ACTIONS(603),
    [anon_sym_throw] = ACTIONS(603),
    [anon_sym_try] = ACTIONS(603),
    [anon_sym_if] = ACTIONS(603),
    [anon_sym_else] = ACTIONS(603),
    [anon_sym_for] = ACTIONS(603),
    [anon_sym_AT] = ACTIONS(603),
    [anon_sym_open] = ACTIONS(603),
    [anon_sym_module] = ACTIONS(603),
    [anon_sym_static] = ACTIONS(603),
    [anon_sym_package] = ACTIONS(603),
    [anon_sym_import] = ACTIONS(603),
    [anon_sym_enum] = ACTIONS(603),
    [anon_sym_public] = ACTIONS(603),
    [anon_sym_protected] = ACTIONS(603),
    [anon_sym_private] = ACTIONS(603),
    [anon_sym_abstract] = ACTIONS(603),
    [anon_sym_final] = ACTIONS(603),
    [anon_sym_strictfp] = ACTIONS(603),
    [anon_sym_native] = ACTIONS(603),
    [anon_sym_transient] = ACTIONS(603),
    [anon_sym_volatile] = ACTIONS(603),
    [anon_sym_sealed] = ACTIONS(603),
    [anon_sym_non_DASHsealed] = ACTIONS(601),
    [anon_sym_ATinterface] = ACTIONS(601),
    [anon_sym_interface] = ACTIONS(603),
    [anon_sym_byte] = ACTIONS(603),
    [anon_sym_short] = ACTIONS(603),
    [anon_sym_int] = ACTIONS(603),
    [anon_sym_long] = ACTIONS(603),
    [anon_sym_char] = ACTIONS(603),
    [anon_sym_float] = ACTIONS(603),
    [anon_sym_double] = ACTIONS(603),
    [sym_boolean_type] = ACTIONS(603),
    [sym_void_type] = ACTIONS(603),
    [sym_this] = ACTIONS(603),
    [sym_super] = ACTIONS(603),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(605),
    [sym_identifier] = ACTIONS(607),
    [sym_decimal_integer_literal] = ACTIONS(607),
    [sym_hex_integer_literal] = ACTIONS(607),
    [sym_octal_integer_literal] = ACTIONS(605),
    [sym_binary_integer_literal] = ACTIONS(605),
    [sym_decimal_floating_point_literal] = ACTIONS(605),
    [sym_hex_floating_point_literal] = ACTIONS(607),
    [sym_true] = ACTIONS(607),
    [sym_false] = ACTIONS(607),
    [sym_character_literal] = ACTIONS(605),
    [sym_string_literal] = ACTIONS(607),
    [sym_text_block] = ACTIONS(605),
    [sym_null_literal] = ACTIONS(607),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_PLUS] = ACTIONS(607),
    [anon_sym_DASH] = ACTIONS(607),
    [anon_sym_BANG] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(605),
    [anon_sym_PLUS_PLUS] = ACTIONS(605),
    [anon_sym_DASH_DASH] = ACTIONS(605),
    [anon_sym_new] = ACTIONS(607),
    [anon_sym_class] = ACTIONS(607),
    [anon_sym_switch] = ACTIONS(607),
    [anon_sym_LBRACE] = ACTIONS(605),
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_case] = ACTIONS(607),
    [anon_sym_default] = ACTIONS(607),
    [anon_sym_SEMI] = ACTIONS(605),
    [anon_sym_assert] = ACTIONS(607),
    [anon_sym_do] = ACTIONS(607),
    [anon_sym_while] = ACTIONS(607),
    [anon_sym_break] = ACTIONS(607),
    [anon_sym_continue] = ACTIONS(607),
    [anon_sym_return] = ACTIONS(607),
    [anon_sym_yield] = ACTIONS(607),
    [anon_sym_synchronized] = ACTIONS(607),
    [anon_sym_throw] = ACTIONS(607),
    [anon_sym_try] = ACTIONS(607),
    [anon_sym_if] = ACTIONS(607),
    [anon_sym_else] = ACTIONS(607),
    [anon_sym_for] = ACTIONS(607),
    [anon_sym_AT] = ACTIONS(607),
    [anon_sym_open] = ACTIONS(607),
    [anon_sym_module] = ACTIONS(607),
    [anon_sym_static] = ACTIONS(607),
    [anon_sym_package] = ACTIONS(607),
    [anon_sym_import] = ACTIONS(607),
    [anon_sym_enum] = ACTIONS(607),
    [anon_sym_public] = ACTIONS(607),
    [anon_sym_protected] = ACTIONS(607),
    [anon_sym_private] = ACTIONS(607),
    [anon_sym_abstract] = ACTIONS(607),
    [anon_sym_final] = ACTIONS(607),
    [anon_sym_strictfp] = ACTIONS(607),
    [anon_sym_native] = ACTIONS(607),
    [anon_sym_transient] = ACTIONS(607),
    [anon_sym_volatile] = ACTIONS(607),
    [anon_sym_sealed] = ACTIONS(607),
    [anon_sym_non_DASHsealed] = ACTIONS(605),
    [anon_sym_ATinterface] = ACTIONS(605),
    [anon_sym_interface] = ACTIONS(607),
    [anon_sym_byte] = ACTIONS(607),
    [anon_sym_short] = ACTIONS(607),
    [anon_sym_int] = ACTIONS(607),
    [anon_sym_long] = ACTIONS(607),
    [anon_sym_char] = ACTIONS(607),
    [anon_sym_float] = ACTIONS(607),
    [anon_sym_double] = ACTIONS(607),
    [sym_boolean_type] = ACTIONS(607),
    [sym_void_type] = ACTIONS(607),
    [sym_this] = ACTIONS(607),
    [sym_super] = ACTIONS(607),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(609),
    [sym_identifier] = ACTIONS(611),
    [sym_decimal_integer_literal] = ACTIONS(611),
    [sym_hex_integer_literal] = ACTIONS(611),
    [sym_octal_integer_literal] = ACTIONS(609),
    [sym_binary_integer_literal] = ACTIONS(609),
    [sym_decimal_floating_point_literal] = ACTIONS(609),
    [sym_hex_floating_point_literal] = ACTIONS(611),
    [sym_true] = ACTIONS(611),
    [sym_false] = ACTIONS(611),
    [sym_character_literal] = ACTIONS(609),
    [sym_string_literal] = ACTIONS(611),
    [sym_text_block] = ACTIONS(609),
    [sym_null_literal] = ACTIONS(611),
    [anon_sym_LPAREN] = ACTIONS(609),
    [anon_sym_PLUS] = ACTIONS(611),
    [anon_sym_DASH] = ACTIONS(611),
    [anon_sym_BANG] = ACTIONS(609),
    [anon_sym_TILDE] = ACTIONS(609),
    [anon_sym_PLUS_PLUS] = ACTIONS(609),
    [anon_sym_DASH_DASH] = ACTIONS(609),
    [anon_sym_new] = ACTIONS(611),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_switch] = ACTIONS(611),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_case] = ACTIONS(611),
    [anon_sym_default] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(609),
    [anon_sym_assert] = ACTIONS(611),
    [anon_sym_do] = ACTIONS(611),
    [anon_sym_while] = ACTIONS(611),
    [anon_sym_break] = ACTIONS(611),
    [anon_sym_continue] = ACTIONS(611),
    [anon_sym_return] = ACTIONS(611),
    [anon_sym_yield] = ACTIONS(611),
    [anon_sym_synchronized] = ACTIONS(611),
    [anon_sym_throw] = ACTIONS(611),
    [anon_sym_try] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(611),
    [anon_sym_else] = ACTIONS(611),
    [anon_sym_for] = ACTIONS(611),
    [anon_sym_AT] = ACTIONS(611),
    [anon_sym_open] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(611),
    [anon_sym_static] = ACTIONS(611),
    [anon_sym_package] = ACTIONS(611),
    [anon_sym_import] = ACTIONS(611),
    [anon_sym_enum] = ACTIONS(611),
    [anon_sym_public] = ACTIONS(611),
    [anon_sym_protected] = ACTIONS(611),
    [anon_sym_private] = ACTIONS(611),
    [anon_sym_abstract] = ACTIONS(611),
    [anon_sym_final] = ACTIONS(611),
    [anon_sym_strictfp] = ACTIONS(611),
    [anon_sym_native] = ACTIONS(611),
    [anon_sym_transient] = ACTIONS(611),
    [anon_sym_volatile] = ACTIONS(611),
    [anon_sym_sealed] = ACTIONS(611),
    [anon_sym_non_DASHsealed] = ACTIONS(609),
    [anon_sym_ATinterface] = ACTIONS(609),
    [anon_sym_interface] = ACTIONS(611),
    [anon_sym_byte] = ACTIONS(611),
    [anon_sym_short] = ACTIONS(611),
    [anon_sym_int] = ACTIONS(611),
    [anon_sym_long] = ACTIONS(611),
    [anon_sym_char] = ACTIONS(611),
    [anon_sym_float] = ACTIONS(611),
    [anon_sym_double] = ACTIONS(611),
    [sym_boolean_type] = ACTIONS(611),
    [sym_void_type] = ACTIONS(611),
    [sym_this] = ACTIONS(611),
    [sym_super] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(613),
    [sym_identifier] = ACTIONS(615),
    [sym_decimal_integer_literal] = ACTIONS(615),
    [sym_hex_integer_literal] = ACTIONS(615),
    [sym_octal_integer_literal] = ACTIONS(613),
    [sym_binary_integer_literal] = ACTIONS(613),
    [sym_decimal_floating_point_literal] = ACTIONS(613),
    [sym_hex_floating_point_literal] = ACTIONS(615),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_character_literal] = ACTIONS(613),
    [sym_string_literal] = ACTIONS(615),
    [sym_text_block] = ACTIONS(613),
    [sym_null_literal] = ACTIONS(615),
    [anon_sym_LPAREN] = ACTIONS(613),
    [anon_sym_PLUS] = ACTIONS(615),
    [anon_sym_DASH] = ACTIONS(615),
    [anon_sym_BANG] = ACTIONS(613),
    [anon_sym_TILDE] = ACTIONS(613),
    [anon_sym_PLUS_PLUS] = ACTIONS(613),
    [anon_sym_DASH_DASH] = ACTIONS(613),
    [anon_sym_new] = ACTIONS(615),
    [anon_sym_class] = ACTIONS(615),
    [anon_sym_switch] = ACTIONS(615),
    [anon_sym_LBRACE] = ACTIONS(613),
    [anon_sym_RBRACE] = ACTIONS(613),
    [anon_sym_case] = ACTIONS(615),
    [anon_sym_default] = ACTIONS(615),
    [anon_sym_SEMI] = ACTIONS(613),
    [anon_sym_assert] = ACTIONS(615),
    [anon_sym_do] = ACTIONS(615),
    [anon_sym_while] = ACTIONS(615),
    [anon_sym_break] = ACTIONS(615),
    [anon_sym_continue] = ACTIONS(615),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(615),
    [anon_sym_synchronized] = ACTIONS(615),
    [anon_sym_throw] = ACTIONS(615),
    [anon_sym_try] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(615),
    [anon_sym_else] = ACTIONS(615),
    [anon_sym_for] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(615),
    [anon_sym_open] = ACTIONS(615),
    [anon_sym_module] = ACTIONS(615),
    [anon_sym_static] = ACTIONS(615),
    [anon_sym_package] = ACTIONS(615),
    [anon_sym_import] = ACTIONS(615),
    [anon_sym_enum] = ACTIONS(615),
    [anon_sym_public] = ACTIONS(615),
    [anon_sym_protected] = ACTIONS(615),
    [anon_sym_private] = ACTIONS(615),
    [anon_sym_abstract] = ACTIONS(615),
    [anon_sym_final] = ACTIONS(615),
    [anon_sym_strictfp] = ACTIONS(615),
    [anon_sym_native] = ACTIONS(615),
    [anon_sym_transient] = ACTIONS(615),
    [anon_sym_volatile] = ACTIONS(615),
    [anon_sym_sealed] = ACTIONS(615),
    [anon_sym_non_DASHsealed] = ACTIONS(613),
    [anon_sym_ATinterface] = ACTIONS(613),
    [anon_sym_interface] = ACTIONS(615),
    [anon_sym_byte] = ACTIONS(615),
    [anon_sym_short] = ACTIONS(615),
    [anon_sym_int] = ACTIONS(615),
    [anon_sym_long] = ACTIONS(615),
    [anon_sym_char] = ACTIONS(615),
    [anon_sym_float] = ACTIONS(615),
    [anon_sym_double] = ACTIONS(615),
    [sym_boolean_type] = ACTIONS(615),
    [sym_void_type] = ACTIONS(615),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(615),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(617),
    [sym_identifier] = ACTIONS(619),
    [sym_decimal_integer_literal] = ACTIONS(619),
    [sym_hex_integer_literal] = ACTIONS(619),
    [sym_octal_integer_literal] = ACTIONS(617),
    [sym_binary_integer_literal] = ACTIONS(617),
    [sym_decimal_floating_point_literal] = ACTIONS(617),
    [sym_hex_floating_point_literal] = ACTIONS(619),
    [sym_true] = ACTIONS(619),
    [sym_false] = ACTIONS(619),
    [sym_character_literal] = ACTIONS(617),
    [sym_string_literal] = ACTIONS(619),
    [sym_text_block] = ACTIONS(617),
    [sym_null_literal] = ACTIONS(619),
    [anon_sym_LPAREN] = ACTIONS(617),
    [anon_sym_PLUS] = ACTIONS(619),
    [anon_sym_DASH] = ACTIONS(619),
    [anon_sym_BANG] = ACTIONS(617),
    [anon_sym_TILDE] = ACTIONS(617),
    [anon_sym_PLUS_PLUS] = ACTIONS(617),
    [anon_sym_DASH_DASH] = ACTIONS(617),
    [anon_sym_new] = ACTIONS(619),
    [anon_sym_class] = ACTIONS(619),
    [anon_sym_switch] = ACTIONS(619),
    [anon_sym_LBRACE] = ACTIONS(617),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_case] = ACTIONS(619),
    [anon_sym_default] = ACTIONS(619),
    [anon_sym_SEMI] = ACTIONS(617),
    [anon_sym_assert] = ACTIONS(619),
    [anon_sym_do] = ACTIONS(619),
    [anon_sym_while] = ACTIONS(619),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_continue] = ACTIONS(619),
    [anon_sym_return] = ACTIONS(619),
    [anon_sym_yield] = ACTIONS(619),
    [anon_sym_synchronized] = ACTIONS(619),
    [anon_sym_throw] = ACTIONS(619),
    [anon_sym_try] = ACTIONS(619),
    [anon_sym_if] = ACTIONS(619),
    [anon_sym_else] = ACTIONS(619),
    [anon_sym_for] = ACTIONS(619),
    [anon_sym_AT] = ACTIONS(619),
    [anon_sym_open] = ACTIONS(619),
    [anon_sym_module] = ACTIONS(619),
    [anon_sym_static] = ACTIONS(619),
    [anon_sym_package] = ACTIONS(619),
    [anon_sym_import] = ACTIONS(619),
    [anon_sym_enum] = ACTIONS(619),
    [anon_sym_public] = ACTIONS(619),
    [anon_sym_protected] = ACTIONS(619),
    [anon_sym_private] = ACTIONS(619),
    [anon_sym_abstract] = ACTIONS(619),
    [anon_sym_final] = ACTIONS(619),
    [anon_sym_strictfp] = ACTIONS(619),
    [anon_sym_native] = ACTIONS(619),
    [anon_sym_transient] = ACTIONS(619),
    [anon_sym_volatile] = ACTIONS(619),
    [anon_sym_sealed] = ACTIONS(619),
    [anon_sym_non_DASHsealed] = ACTIONS(617),
    [anon_sym_ATinterface] = ACTIONS(617),
    [anon_sym_interface] = ACTIONS(619),
    [anon_sym_byte] = ACTIONS(619),
    [anon_sym_short] = ACTIONS(619),
    [anon_sym_int] = ACTIONS(619),
    [anon_sym_long] = ACTIONS(619),
    [anon_sym_char] = ACTIONS(619),
    [anon_sym_float] = ACTIONS(619),
    [anon_sym_double] = ACTIONS(619),
    [sym_boolean_type] = ACTIONS(619),
    [sym_void_type] = ACTIONS(619),
    [sym_this] = ACTIONS(619),
    [sym_super] = ACTIONS(619),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(621),
    [sym_identifier] = ACTIONS(623),
    [sym_decimal_integer_literal] = ACTIONS(623),
    [sym_hex_integer_literal] = ACTIONS(623),
    [sym_octal_integer_literal] = ACTIONS(621),
    [sym_binary_integer_literal] = ACTIONS(621),
    [sym_decimal_floating_point_literal] = ACTIONS(621),
    [sym_hex_floating_point_literal] = ACTIONS(623),
    [sym_true] = ACTIONS(623),
    [sym_false] = ACTIONS(623),
    [sym_character_literal] = ACTIONS(621),
    [sym_string_literal] = ACTIONS(623),
    [sym_text_block] = ACTIONS(621),
    [sym_null_literal] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(621),
    [anon_sym_PLUS] = ACTIONS(623),
    [anon_sym_DASH] = ACTIONS(623),
    [anon_sym_BANG] = ACTIONS(621),
    [anon_sym_TILDE] = ACTIONS(621),
    [anon_sym_PLUS_PLUS] = ACTIONS(621),
    [anon_sym_DASH_DASH] = ACTIONS(621),
    [anon_sym_new] = ACTIONS(623),
    [anon_sym_class] = ACTIONS(623),
    [anon_sym_switch] = ACTIONS(623),
    [anon_sym_LBRACE] = ACTIONS(621),
    [anon_sym_RBRACE] = ACTIONS(621),
    [anon_sym_case] = ACTIONS(623),
    [anon_sym_default] = ACTIONS(623),
    [anon_sym_SEMI] = ACTIONS(621),
    [anon_sym_assert] = ACTIONS(623),
    [anon_sym_do] = ACTIONS(623),
    [anon_sym_while] = ACTIONS(623),
    [anon_sym_break] = ACTIONS(623),
    [anon_sym_continue] = ACTIONS(623),
    [anon_sym_return] = ACTIONS(623),
    [anon_sym_yield] = ACTIONS(623),
    [anon_sym_synchronized] = ACTIONS(623),
    [anon_sym_throw] = ACTIONS(623),
    [anon_sym_try] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(623),
    [anon_sym_else] = ACTIONS(623),
    [anon_sym_for] = ACTIONS(623),
    [anon_sym_AT] = ACTIONS(623),
    [anon_sym_open] = ACTIONS(623),
    [anon_sym_module] = ACTIONS(623),
    [anon_sym_static] = ACTIONS(623),
    [anon_sym_package] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(623),
    [anon_sym_enum] = ACTIONS(623),
    [anon_sym_public] = ACTIONS(623),
    [anon_sym_protected] = ACTIONS(623),
    [anon_sym_private] = ACTIONS(623),
    [anon_sym_abstract] = ACTIONS(623),
    [anon_sym_final] = ACTIONS(623),
    [anon_sym_strictfp] = ACTIONS(623),
    [anon_sym_native] = ACTIONS(623),
    [anon_sym_transient] = ACTIONS(623),
    [anon_sym_volatile] = ACTIONS(623),
    [anon_sym_sealed] = ACTIONS(623),
    [anon_sym_non_DASHsealed] = ACTIONS(621),
    [anon_sym_ATinterface] = ACTIONS(621),
    [anon_sym_interface] = ACTIONS(623),
    [anon_sym_byte] = ACTIONS(623),
    [anon_sym_short] = ACTIONS(623),
    [anon_sym_int] = ACTIONS(623),
    [anon_sym_long] = ACTIONS(623),
    [anon_sym_char] = ACTIONS(623),
    [anon_sym_float] = ACTIONS(623),
    [anon_sym_double] = ACTIONS(623),
    [sym_boolean_type] = ACTIONS(623),
    [sym_void_type] = ACTIONS(623),
    [sym_this] = ACTIONS(623),
    [sym_super] = ACTIONS(623),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(292),
    [sym_identifier] = ACTIONS(294),
    [sym_decimal_integer_literal] = ACTIONS(294),
    [sym_hex_integer_literal] = ACTIONS(294),
    [sym_octal_integer_literal] = ACTIONS(292),
    [sym_binary_integer_literal] = ACTIONS(292),
    [sym_decimal_floating_point_literal] = ACTIONS(292),
    [sym_hex_floating_point_literal] = ACTIONS(294),
    [sym_true] = ACTIONS(294),
    [sym_false] = ACTIONS(294),
    [sym_character_literal] = ACTIONS(292),
    [sym_string_literal] = ACTIONS(294),
    [sym_text_block] = ACTIONS(292),
    [sym_null_literal] = ACTIONS(294),
    [anon_sym_LPAREN] = ACTIONS(292),
    [anon_sym_PLUS] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(292),
    [anon_sym_TILDE] = ACTIONS(292),
    [anon_sym_PLUS_PLUS] = ACTIONS(292),
    [anon_sym_DASH_DASH] = ACTIONS(292),
    [anon_sym_new] = ACTIONS(294),
    [anon_sym_class] = ACTIONS(294),
    [anon_sym_switch] = ACTIONS(294),
    [anon_sym_LBRACE] = ACTIONS(292),
    [anon_sym_RBRACE] = ACTIONS(292),
    [anon_sym_case] = ACTIONS(294),
    [anon_sym_default] = ACTIONS(294),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_assert] = ACTIONS(294),
    [anon_sym_do] = ACTIONS(294),
    [anon_sym_while] = ACTIONS(294),
    [anon_sym_break] = ACTIONS(294),
    [anon_sym_continue] = ACTIONS(294),
    [anon_sym_return] = ACTIONS(294),
    [anon_sym_yield] = ACTIONS(294),
    [anon_sym_synchronized] = ACTIONS(294),
    [anon_sym_throw] = ACTIONS(294),
    [anon_sym_try] = ACTIONS(294),
    [anon_sym_if] = ACTIONS(294),
    [anon_sym_else] = ACTIONS(294),
    [anon_sym_for] = ACTIONS(294),
    [anon_sym_AT] = ACTIONS(294),
    [anon_sym_open] = ACTIONS(294),
    [anon_sym_module] = ACTIONS(294),
    [anon_sym_static] = ACTIONS(294),
    [anon_sym_package] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(294),
    [anon_sym_enum] = ACTIONS(294),
    [anon_sym_public] = ACTIONS(294),
    [anon_sym_protected] = ACTIONS(294),
    [anon_sym_private] = ACTIONS(294),
    [anon_sym_abstract] = ACTIONS(294),
    [anon_sym_final] = ACTIONS(294),
    [anon_sym_strictfp] = ACTIONS(294),
    [anon_sym_native] = ACTIONS(294),
    [anon_sym_transient] = ACTIONS(294),
    [anon_sym_volatile] = ACTIONS(294),
    [anon_sym_sealed] = ACTIONS(294),
    [anon_sym_non_DASHsealed] = ACTIONS(292),
    [anon_sym_ATinterface] = ACTIONS(292),
    [anon_sym_interface] = ACTIONS(294),
    [anon_sym_byte] = ACTIONS(294),
    [anon_sym_short] = ACTIONS(294),
    [anon_sym_int] = ACTIONS(294),
    [anon_sym_long] = ACTIONS(294),
    [anon_sym_char] = ACTIONS(294),
    [anon_sym_float] = ACTIONS(294),
    [anon_sym_double] = ACTIONS(294),
    [sym_boolean_type] = ACTIONS(294),
    [sym_void_type] = ACTIONS(294),
    [sym_this] = ACTIONS(294),
    [sym_super] = ACTIONS(294),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(625),
    [sym_identifier] = ACTIONS(627),
    [sym_decimal_integer_literal] = ACTIONS(627),
    [sym_hex_integer_literal] = ACTIONS(627),
    [sym_octal_integer_literal] = ACTIONS(625),
    [sym_binary_integer_literal] = ACTIONS(625),
    [sym_decimal_floating_point_literal] = ACTIONS(625),
    [sym_hex_floating_point_literal] = ACTIONS(627),
    [sym_true] = ACTIONS(627),
    [sym_false] = ACTIONS(627),
    [sym_character_literal] = ACTIONS(625),
    [sym_string_literal] = ACTIONS(627),
    [sym_text_block] = ACTIONS(625),
    [sym_null_literal] = ACTIONS(627),
    [anon_sym_LPAREN] = ACTIONS(625),
    [anon_sym_PLUS] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(627),
    [anon_sym_BANG] = ACTIONS(625),
    [anon_sym_TILDE] = ACTIONS(625),
    [anon_sym_PLUS_PLUS] = ACTIONS(625),
    [anon_sym_DASH_DASH] = ACTIONS(625),
    [anon_sym_new] = ACTIONS(627),
    [anon_sym_class] = ACTIONS(627),
    [anon_sym_switch] = ACTIONS(627),
    [anon_sym_LBRACE] = ACTIONS(625),
    [anon_sym_RBRACE] = ACTIONS(625),
    [anon_sym_case] = ACTIONS(627),
    [anon_sym_default] = ACTIONS(627),
    [anon_sym_SEMI] = ACTIONS(625),
    [anon_sym_assert] = ACTIONS(627),
    [anon_sym_do] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(627),
    [anon_sym_break] = ACTIONS(627),
    [anon_sym_continue] = ACTIONS(627),
    [anon_sym_return] = ACTIONS(627),
    [anon_sym_yield] = ACTIONS(627),
    [anon_sym_synchronized] = ACTIONS(627),
    [anon_sym_throw] = ACTIONS(627),
    [anon_sym_try] = ACTIONS(627),
    [anon_sym_if] = ACTIONS(627),
    [anon_sym_else] = ACTIONS(627),
    [anon_sym_for] = ACTIONS(627),
    [anon_sym_AT] = ACTIONS(627),
    [anon_sym_open] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(627),
    [anon_sym_static] = ACTIONS(627),
    [anon_sym_package] = ACTIONS(627),
    [anon_sym_import] = ACTIONS(627),
    [anon_sym_enum] = ACTIONS(627),
    [anon_sym_public] = ACTIONS(627),
    [anon_sym_protected] = ACTIONS(627),
    [anon_sym_private] = ACTIONS(627),
    [anon_sym_abstract] = ACTIONS(627),
    [anon_sym_final] = ACTIONS(627),
    [anon_sym_strictfp] = ACTIONS(627),
    [anon_sym_native] = ACTIONS(627),
    [anon_sym_transient] = ACTIONS(627),
    [anon_sym_volatile] = ACTIONS(627),
    [anon_sym_sealed] = ACTIONS(627),
    [anon_sym_non_DASHsealed] = ACTIONS(625),
    [anon_sym_ATinterface] = ACTIONS(625),
    [anon_sym_interface] = ACTIONS(627),
    [anon_sym_byte] = ACTIONS(627),
    [anon_sym_short] = ACTIONS(627),
    [anon_sym_int] = ACTIONS(627),
    [anon_sym_long] = ACTIONS(627),
    [anon_sym_char] = ACTIONS(627),
    [anon_sym_float] = ACTIONS(627),
    [anon_sym_double] = ACTIONS(627),
    [sym_boolean_type] = ACTIONS(627),
    [sym_void_type] = ACTIONS(627),
    [sym_this] = ACTIONS(627),
    [sym_super] = ACTIONS(627),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [sym_decimal_integer_literal] = ACTIONS(631),
    [sym_hex_integer_literal] = ACTIONS(631),
    [sym_octal_integer_literal] = ACTIONS(629),
    [sym_binary_integer_literal] = ACTIONS(629),
    [sym_decimal_floating_point_literal] = ACTIONS(629),
    [sym_hex_floating_point_literal] = ACTIONS(631),
    [sym_true] = ACTIONS(631),
    [sym_false] = ACTIONS(631),
    [sym_character_literal] = ACTIONS(629),
    [sym_string_literal] = ACTIONS(631),
    [sym_text_block] = ACTIONS(629),
    [sym_null_literal] = ACTIONS(631),
    [anon_sym_LPAREN] = ACTIONS(629),
    [anon_sym_PLUS] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_TILDE] = ACTIONS(629),
    [anon_sym_PLUS_PLUS] = ACTIONS(629),
    [anon_sym_DASH_DASH] = ACTIONS(629),
    [anon_sym_new] = ACTIONS(631),
    [anon_sym_class] = ACTIONS(631),
    [anon_sym_switch] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(629),
    [anon_sym_RBRACE] = ACTIONS(629),
    [anon_sym_case] = ACTIONS(631),
    [anon_sym_default] = ACTIONS(631),
    [anon_sym_SEMI] = ACTIONS(629),
    [anon_sym_assert] = ACTIONS(631),
    [anon_sym_do] = ACTIONS(631),
    [anon_sym_while] = ACTIONS(631),
    [anon_sym_break] = ACTIONS(631),
    [anon_sym_continue] = ACTIONS(631),
    [anon_sym_return] = ACTIONS(631),
    [anon_sym_yield] = ACTIONS(631),
    [anon_sym_synchronized] = ACTIONS(631),
    [anon_sym_throw] = ACTIONS(631),
    [anon_sym_try] = ACTIONS(631),
    [anon_sym_if] = ACTIONS(631),
    [anon_sym_else] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_AT] = ACTIONS(631),
    [anon_sym_open] = ACTIONS(631),
    [anon_sym_module] = ACTIONS(631),
    [anon_sym_static] = ACTIONS(631),
    [anon_sym_package] = ACTIONS(631),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_enum] = ACTIONS(631),
    [anon_sym_public] = ACTIONS(631),
    [anon_sym_protected] = ACTIONS(631),
    [anon_sym_private] = ACTIONS(631),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_final] = ACTIONS(631),
    [anon_sym_strictfp] = ACTIONS(631),
    [anon_sym_native] = ACTIONS(631),
    [anon_sym_transient] = ACTIONS(631),
    [anon_sym_volatile] = ACTIONS(631),
    [anon_sym_sealed] = ACTIONS(631),
    [anon_sym_non_DASHsealed] = ACTIONS(629),
    [anon_sym_ATinterface] = ACTIONS(629),
    [anon_sym_interface] = ACTIONS(631),
    [anon_sym_byte] = ACTIONS(631),
    [anon_sym_short] = ACTIONS(631),
    [anon_sym_int] = ACTIONS(631),
    [anon_sym_long] = ACTIONS(631),
    [anon_sym_char] = ACTIONS(631),
    [anon_sym_float] = ACTIONS(631),
    [anon_sym_double] = ACTIONS(631),
    [sym_boolean_type] = ACTIONS(631),
    [sym_void_type] = ACTIONS(631),
    [sym_this] = ACTIONS(631),
    [sym_super] = ACTIONS(631),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(633),
    [sym_identifier] = ACTIONS(635),
    [sym_decimal_integer_literal] = ACTIONS(635),
    [sym_hex_integer_literal] = ACTIONS(635),
    [sym_octal_integer_literal] = ACTIONS(633),
    [sym_binary_integer_literal] = ACTIONS(633),
    [sym_decimal_floating_point_literal] = ACTIONS(633),
    [sym_hex_floating_point_literal] = ACTIONS(635),
    [sym_true] = ACTIONS(635),
    [sym_false] = ACTIONS(635),
    [sym_character_literal] = ACTIONS(633),
    [sym_string_literal] = ACTIONS(635),
    [sym_text_block] = ACTIONS(633),
    [sym_null_literal] = ACTIONS(635),
    [anon_sym_LPAREN] = ACTIONS(633),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_BANG] = ACTIONS(633),
    [anon_sym_TILDE] = ACTIONS(633),
    [anon_sym_PLUS_PLUS] = ACTIONS(633),
    [anon_sym_DASH_DASH] = ACTIONS(633),
    [anon_sym_new] = ACTIONS(635),
    [anon_sym_class] = ACTIONS(635),
    [anon_sym_switch] = ACTIONS(635),
    [anon_sym_LBRACE] = ACTIONS(633),
    [anon_sym_RBRACE] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_default] = ACTIONS(635),
    [anon_sym_SEMI] = ACTIONS(633),
    [anon_sym_assert] = ACTIONS(635),
    [anon_sym_do] = ACTIONS(635),
    [anon_sym_while] = ACTIONS(635),
    [anon_sym_break] = ACTIONS(635),
    [anon_sym_continue] = ACTIONS(635),
    [anon_sym_return] = ACTIONS(635),
    [anon_sym_yield] = ACTIONS(635),
    [anon_sym_synchronized] = ACTIONS(635),
    [anon_sym_throw] = ACTIONS(635),
    [anon_sym_try] = ACTIONS(635),
    [anon_sym_if] = ACTIONS(635),
    [anon_sym_else] = ACTIONS(635),
    [anon_sym_for] = ACTIONS(635),
    [anon_sym_AT] = ACTIONS(635),
    [anon_sym_open] = ACTIONS(635),
    [anon_sym_module] = ACTIONS(635),
    [anon_sym_static] = ACTIONS(635),
    [anon_sym_package] = ACTIONS(635),
    [anon_sym_import] = ACTIONS(635),
    [anon_sym_enum] = ACTIONS(635),
    [anon_sym_public] = ACTIONS(635),
    [anon_sym_protected] = ACTIONS(635),
    [anon_sym_private] = ACTIONS(635),
    [anon_sym_abstract] = ACTIONS(635),
    [anon_sym_final] = ACTIONS(635),
    [anon_sym_strictfp] = ACTIONS(635),
    [anon_sym_native] = ACTIONS(635),
    [anon_sym_transient] = ACTIONS(635),
    [anon_sym_volatile] = ACTIONS(635),
    [anon_sym_sealed] = ACTIONS(635),
    [anon_sym_non_DASHsealed] = ACTIONS(633),
    [anon_sym_ATinterface] = ACTIONS(633),
    [anon_sym_interface] = ACTIONS(635),
    [anon_sym_byte] = ACTIONS(635),
    [anon_sym_short] = ACTIONS(635),
    [anon_sym_int] = ACTIONS(635),
    [anon_sym_long] = ACTIONS(635),
    [anon_sym_char] = ACTIONS(635),
    [anon_sym_float] = ACTIONS(635),
    [anon_sym_double] = ACTIONS(635),
    [sym_boolean_type] = ACTIONS(635),
    [sym_void_type] = ACTIONS(635),
    [sym_this] = ACTIONS(635),
    [sym_super] = ACTIONS(635),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(637),
    [sym_identifier] = ACTIONS(639),
    [sym_decimal_integer_literal] = ACTIONS(639),
    [sym_hex_integer_literal] = ACTIONS(639),
    [sym_octal_integer_literal] = ACTIONS(637),
    [sym_binary_integer_literal] = ACTIONS(637),
    [sym_decimal_floating_point_literal] = ACTIONS(637),
    [sym_hex_floating_point_literal] = ACTIONS(639),
    [sym_true] = ACTIONS(639),
    [sym_false] = ACTIONS(639),
    [sym_character_literal] = ACTIONS(637),
    [sym_string_literal] = ACTIONS(639),
    [sym_text_block] = ACTIONS(637),
    [sym_null_literal] = ACTIONS(639),
    [anon_sym_LPAREN] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(639),
    [anon_sym_DASH] = ACTIONS(639),
    [anon_sym_BANG] = ACTIONS(637),
    [anon_sym_TILDE] = ACTIONS(637),
    [anon_sym_PLUS_PLUS] = ACTIONS(637),
    [anon_sym_DASH_DASH] = ACTIONS(637),
    [anon_sym_new] = ACTIONS(639),
    [anon_sym_class] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(639),
    [anon_sym_LBRACE] = ACTIONS(637),
    [anon_sym_RBRACE] = ACTIONS(637),
    [anon_sym_case] = ACTIONS(639),
    [anon_sym_default] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(637),
    [anon_sym_assert] = ACTIONS(639),
    [anon_sym_do] = ACTIONS(639),
    [anon_sym_while] = ACTIONS(639),
    [anon_sym_break] = ACTIONS(639),
    [anon_sym_continue] = ACTIONS(639),
    [anon_sym_return] = ACTIONS(639),
    [anon_sym_yield] = ACTIONS(639),
    [anon_sym_synchronized] = ACTIONS(639),
    [anon_sym_throw] = ACTIONS(639),
    [anon_sym_try] = ACTIONS(639),
    [anon_sym_if] = ACTIONS(639),
    [anon_sym_else] = ACTIONS(639),
    [anon_sym_for] = ACTIONS(639),
    [anon_sym_AT] = ACTIONS(639),
    [anon_sym_open] = ACTIONS(639),
    [anon_sym_module] = ACTIONS(639),
    [anon_sym_static] = ACTIONS(639),
    [anon_sym_package] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(639),
    [anon_sym_enum] = ACTIONS(639),
    [anon_sym_public] = ACTIONS(639),
    [anon_sym_protected] = ACTIONS(639),
    [anon_sym_private] = ACTIONS(639),
    [anon_sym_abstract] = ACTIONS(639),
    [anon_sym_final] = ACTIONS(639),
    [anon_sym_strictfp] = ACTIONS(639),
    [anon_sym_native] = ACTIONS(639),
    [anon_sym_transient] = ACTIONS(639),
    [anon_sym_volatile] = ACTIONS(639),
    [anon_sym_sealed] = ACTIONS(639),
    [anon_sym_non_DASHsealed] = ACTIONS(637),
    [anon_sym_ATinterface] = ACTIONS(637),
    [anon_sym_interface] = ACTIONS(639),
    [anon_sym_byte] = ACTIONS(639),
    [anon_sym_short] = ACTIONS(639),
    [anon_sym_int] = ACTIONS(639),
    [anon_sym_long] = ACTIONS(639),
    [anon_sym_char] = ACTIONS(639),
    [anon_sym_float] = ACTIONS(639),
    [anon_sym_double] = ACTIONS(639),
    [sym_boolean_type] = ACTIONS(639),
    [sym_void_type] = ACTIONS(639),
    [sym_this] = ACTIONS(639),
    [sym_super] = ACTIONS(639),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [sym_identifier] = ACTIONS(643),
    [sym_decimal_integer_literal] = ACTIONS(643),
    [sym_hex_integer_literal] = ACTIONS(643),
    [sym_octal_integer_literal] = ACTIONS(641),
    [sym_binary_integer_literal] = ACTIONS(641),
    [sym_decimal_floating_point_literal] = ACTIONS(641),
    [sym_hex_floating_point_literal] = ACTIONS(643),
    [sym_true] = ACTIONS(643),
    [sym_false] = ACTIONS(643),
    [sym_character_literal] = ACTIONS(641),
    [sym_string_literal] = ACTIONS(643),
    [sym_text_block] = ACTIONS(641),
    [sym_null_literal] = ACTIONS(643),
    [anon_sym_LPAREN] = ACTIONS(641),
    [anon_sym_PLUS] = ACTIONS(643),
    [anon_sym_DASH] = ACTIONS(643),
    [anon_sym_BANG] = ACTIONS(641),
    [anon_sym_TILDE] = ACTIONS(641),
    [anon_sym_PLUS_PLUS] = ACTIONS(641),
    [anon_sym_DASH_DASH] = ACTIONS(641),
    [anon_sym_new] = ACTIONS(643),
    [anon_sym_class] = ACTIONS(643),
    [anon_sym_switch] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(641),
    [anon_sym_RBRACE] = ACTIONS(641),
    [anon_sym_case] = ACTIONS(643),
    [anon_sym_default] = ACTIONS(643),
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_assert] = ACTIONS(643),
    [anon_sym_do] = ACTIONS(643),
    [anon_sym_while] = ACTIONS(643),
    [anon_sym_break] = ACTIONS(643),
    [anon_sym_continue] = ACTIONS(643),
    [anon_sym_return] = ACTIONS(643),
    [anon_sym_yield] = ACTIONS(643),
    [anon_sym_synchronized] = ACTIONS(643),
    [anon_sym_throw] = ACTIONS(643),
    [anon_sym_try] = ACTIONS(643),
    [anon_sym_if] = ACTIONS(643),
    [anon_sym_else] = ACTIONS(643),
    [anon_sym_for] = ACTIONS(643),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_open] = ACTIONS(643),
    [anon_sym_module] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(643),
    [anon_sym_package] = ACTIONS(643),
    [anon_sym_import] = ACTIONS(643),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_public] = ACTIONS(643),
    [anon_sym_protected] = ACTIONS(643),
    [anon_sym_private] = ACTIONS(643),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_final] = ACTIONS(643),
    [anon_sym_strictfp] = ACTIONS(643),
    [anon_sym_native] = ACTIONS(643),
    [anon_sym_transient] = ACTIONS(643),
    [anon_sym_volatile] = ACTIONS(643),
    [anon_sym_sealed] = ACTIONS(643),
    [anon_sym_non_DASHsealed] = ACTIONS(641),
    [anon_sym_ATinterface] = ACTIONS(641),
    [anon_sym_interface] = ACTIONS(643),
    [anon_sym_byte] = ACTIONS(643),
    [anon_sym_short] = ACTIONS(643),
    [anon_sym_int] = ACTIONS(643),
    [anon_sym_long] = ACTIONS(643),
    [anon_sym_char] = ACTIONS(643),
    [anon_sym_float] = ACTIONS(643),
    [anon_sym_double] = ACTIONS(643),
    [sym_boolean_type] = ACTIONS(643),
    [sym_void_type] = ACTIONS(643),
    [sym_this] = ACTIONS(643),
    [sym_super] = ACTIONS(643),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [153] = {
    [ts_builtin_sym_end] = ACTIONS(645),
    [sym_identifier] = ACTIONS(647),
    [sym_decimal_integer_literal] = ACTIONS(647),
    [sym_hex_integer_literal] = ACTIONS(647),
    [sym_octal_integer_literal] = ACTIONS(645),
    [sym_binary_integer_literal] = ACTIONS(645),
    [sym_decimal_floating_point_literal] = ACTIONS(645),
    [sym_hex_floating_point_literal] = ACTIONS(647),
    [sym_true] = ACTIONS(647),
    [sym_false] = ACTIONS(647),
    [sym_character_literal] = ACTIONS(645),
    [sym_string_literal] = ACTIONS(647),
    [sym_text_block] = ACTIONS(645),
    [sym_null_literal] = ACTIONS(647),
    [anon_sym_LPAREN] = ACTIONS(645),
    [anon_sym_PLUS] = ACTIONS(647),
    [anon_sym_DASH] = ACTIONS(647),
    [anon_sym_BANG] = ACTIONS(645),
    [anon_sym_TILDE] = ACTIONS(645),
    [anon_sym_PLUS_PLUS] = ACTIONS(645),
    [anon_sym_DASH_DASH] = ACTIONS(645),
    [anon_sym_new] = ACTIONS(647),
    [anon_sym_class] = ACTIONS(647),
    [anon_sym_switch] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(645),
    [anon_sym_RBRACE] = ACTIONS(645),
    [anon_sym_case] = ACTIONS(647),
    [anon_sym_default] = ACTIONS(647),
    [anon_sym_SEMI] = ACTIONS(645),
    [anon_sym_assert] = ACTIONS(647),
    [anon_sym_do] = ACTIONS(647),
    [anon_sym_while] = ACTIONS(647),
    [anon_sym_break] = ACTIONS(647),
    [anon_sym_continue] = ACTIONS(647),
    [anon_sym_return] = ACTIONS(647),
    [anon_sym_yield] = ACTIONS(647),
    [anon_sym_synchronized] = ACTIONS(647),
    [anon_sym_throw] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(647),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_else] = ACTIONS(647),
    [anon_sym_for] = ACTIONS(647),
    [anon_sym_AT] = ACTIONS(647),
    [anon_sym_open] = ACTIONS(647),
    [anon_sym_module] = ACTIONS(647),
    [anon_sym_static] = ACTIONS(647),
    [anon_sym_package] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(647),
    [anon_sym_public] = ACTIONS(647),
    [anon_sym_protected] = ACTIONS(647),
    [anon_sym_private] = ACTIONS(647),
    [anon_sym_abstract] = ACTIONS(647),
    [anon_sym_final] = ACTIONS(647),
    [anon_sym_strictfp] = ACTIONS(647),
    [anon_sym_native] = ACTIONS(647),
    [anon_sym_transient] = ACTIONS(647),
    [anon_sym_volatile] = ACTIONS(647),
    [anon_sym_sealed] = ACTIONS(647),
    [anon_sym_non_DASHsealed] = ACTIONS(645),
    [anon_sym_ATinterface] = ACTIONS(645),
    [anon_sym_interface] = ACTIONS(647),
    [anon_sym_byte] = ACTIONS(647),
    [anon_sym_short] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_long] = ACTIONS(647),
    [anon_sym_char] = ACTIONS(647),
    [anon_sym_float] = ACTIONS(647),
    [anon_sym_double] = ACTIONS(647),
    [sym_boolean_type] = ACTIONS(647),
    [sym_void_type] = ACTIONS(647),
    [sym_this] = ACTIONS(647),
    [sym_super] = ACTIONS(647),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [sym_identifier] = ACTIONS(651),
    [sym_decimal_integer_literal] = ACTIONS(651),
    [sym_hex_integer_literal] = ACTIONS(651),
    [sym_octal_integer_literal] = ACTIONS(649),
    [sym_binary_integer_literal] = ACTIONS(649),
    [sym_decimal_floating_point_literal] = ACTIONS(649),
    [sym_hex_floating_point_literal] = ACTIONS(651),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_character_literal] = ACTIONS(649),
    [sym_string_literal] = ACTIONS(651),
    [sym_text_block] = ACTIONS(649),
    [sym_null_literal] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(649),
    [anon_sym_PLUS] = ACTIONS(651),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_BANG] = ACTIONS(649),
    [anon_sym_TILDE] = ACTIONS(649),
    [anon_sym_PLUS_PLUS] = ACTIONS(649),
    [anon_sym_DASH_DASH] = ACTIONS(649),
    [anon_sym_new] = ACTIONS(651),
    [anon_sym_class] = ACTIONS(651),
    [anon_sym_switch] = ACTIONS(651),
    [anon_sym_LBRACE] = ACTIONS(649),
    [anon_sym_RBRACE] = ACTIONS(649),
    [anon_sym_case] = ACTIONS(651),
    [anon_sym_default] = ACTIONS(651),
    [anon_sym_SEMI] = ACTIONS(649),
    [anon_sym_assert] = ACTIONS(651),
    [anon_sym_do] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(651),
    [anon_sym_break] = ACTIONS(651),
    [anon_sym_continue] = ACTIONS(651),
    [anon_sym_return] = ACTIONS(651),
    [anon_sym_yield] = ACTIONS(651),
    [anon_sym_synchronized] = ACTIONS(651),
    [anon_sym_throw] = ACTIONS(651),
    [anon_sym_try] = ACTIONS(651),
    [anon_sym_if] = ACTIONS(651),
    [anon_sym_else] = ACTIONS(651),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(651),
    [anon_sym_open] = ACTIONS(651),
    [anon_sym_module] = ACTIONS(651),
    [anon_sym_static] = ACTIONS(651),
    [anon_sym_package] = ACTIONS(651),
    [anon_sym_import] = ACTIONS(651),
    [anon_sym_enum] = ACTIONS(651),
    [anon_sym_public] = ACTIONS(651),
    [anon_sym_protected] = ACTIONS(651),
    [anon_sym_private] = ACTIONS(651),
    [anon_sym_abstract] = ACTIONS(651),
    [anon_sym_final] = ACTIONS(651),
    [anon_sym_strictfp] = ACTIONS(651),
    [anon_sym_native] = ACTIONS(651),
    [anon_sym_transient] = ACTIONS(651),
    [anon_sym_volatile] = ACTIONS(651),
    [anon_sym_sealed] = ACTIONS(651),
    [anon_sym_non_DASHsealed] = ACTIONS(649),
    [anon_sym_ATinterface] = ACTIONS(649),
    [anon_sym_interface] = ACTIONS(651),
    [anon_sym_byte] = ACTIONS(651),
    [anon_sym_short] = ACTIONS(651),
    [anon_sym_int] = ACTIONS(651),
    [anon_sym_long] = ACTIONS(651),
    [anon_sym_char] = ACTIONS(651),
    [anon_sym_float] = ACTIONS(651),
    [anon_sym_double] = ACTIONS(651),
    [sym_boolean_type] = ACTIONS(651),
    [sym_void_type] = ACTIONS(651),
    [sym_this] = ACTIONS(651),
    [sym_super] = ACTIONS(651),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(653),
    [sym_identifier] = ACTIONS(655),
    [sym_decimal_integer_literal] = ACTIONS(655),
    [sym_hex_integer_literal] = ACTIONS(655),
    [sym_octal_integer_literal] = ACTIONS(653),
    [sym_binary_integer_literal] = ACTIONS(653),
    [sym_decimal_floating_point_literal] = ACTIONS(653),
    [sym_hex_floating_point_literal] = ACTIONS(655),
    [sym_true] = ACTIONS(655),
    [sym_false] = ACTIONS(655),
    [sym_character_literal] = ACTIONS(653),
    [sym_string_literal] = ACTIONS(655),
    [sym_text_block] = ACTIONS(653),
    [sym_null_literal] = ACTIONS(655),
    [anon_sym_LPAREN] = ACTIONS(653),
    [anon_sym_PLUS] = ACTIONS(655),
    [anon_sym_DASH] = ACTIONS(655),
    [anon_sym_BANG] = ACTIONS(653),
    [anon_sym_TILDE] = ACTIONS(653),
    [anon_sym_PLUS_PLUS] = ACTIONS(653),
    [anon_sym_DASH_DASH] = ACTIONS(653),
    [anon_sym_new] = ACTIONS(655),
    [anon_sym_class] = ACTIONS(655),
    [anon_sym_switch] = ACTIONS(655),
    [anon_sym_LBRACE] = ACTIONS(653),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_case] = ACTIONS(655),
    [anon_sym_default] = ACTIONS(655),
    [anon_sym_SEMI] = ACTIONS(653),
    [anon_sym_assert] = ACTIONS(655),
    [anon_sym_do] = ACTIONS(655),
    [anon_sym_while] = ACTIONS(655),
    [anon_sym_break] = ACTIONS(655),
    [anon_sym_continue] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(655),
    [anon_sym_yield] = ACTIONS(655),
    [anon_sym_synchronized] = ACTIONS(655),
    [anon_sym_throw] = ACTIONS(655),
    [anon_sym_try] = ACTIONS(655),
    [anon_sym_if] = ACTIONS(655),
    [anon_sym_else] = ACTIONS(655),
    [anon_sym_for] = ACTIONS(655),
    [anon_sym_AT] = ACTIONS(655),
    [anon_sym_open] = ACTIONS(655),
    [anon_sym_module] = ACTIONS(655),
    [anon_sym_static] = ACTIONS(655),
    [anon_sym_package] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(655),
    [anon_sym_enum] = ACTIONS(655),
    [anon_sym_public] = ACTIONS(655),
    [anon_sym_protected] = ACTIONS(655),
    [anon_sym_private] = ACTIONS(655),
    [anon_sym_abstract] = ACTIONS(655),
    [anon_sym_final] = ACTIONS(655),
    [anon_sym_strictfp] = ACTIONS(655),
    [anon_sym_native] = ACTIONS(655),
    [anon_sym_transient] = ACTIONS(655),
    [anon_sym_volatile] = ACTIONS(655),
    [anon_sym_sealed] = ACTIONS(655),
    [anon_sym_non_DASHsealed] = ACTIONS(653),
    [anon_sym_ATinterface] = ACTIONS(653),
    [anon_sym_interface] = ACTIONS(655),
    [anon_sym_byte] = ACTIONS(655),
    [anon_sym_short] = ACTIONS(655),
    [anon_sym_int] = ACTIONS(655),
    [anon_sym_long] = ACTIONS(655),
    [anon_sym_char] = ACTIONS(655),
    [anon_sym_float] = ACTIONS(655),
    [anon_sym_double] = ACTIONS(655),
    [sym_boolean_type] = ACTIONS(655),
    [sym_void_type] = ACTIONS(655),
    [sym_this] = ACTIONS(655),
    [sym_super] = ACTIONS(655),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(657),
    [sym_identifier] = ACTIONS(659),
    [sym_decimal_integer_literal] = ACTIONS(659),
    [sym_hex_integer_literal] = ACTIONS(659),
    [sym_octal_integer_literal] = ACTIONS(657),
    [sym_binary_integer_literal] = ACTIONS(657),
    [sym_decimal_floating_point_literal] = ACTIONS(657),
    [sym_hex_floating_point_literal] = ACTIONS(659),
    [sym_true] = ACTIONS(659),
    [sym_false] = ACTIONS(659),
    [sym_character_literal] = ACTIONS(657),
    [sym_string_literal] = ACTIONS(659),
    [sym_text_block] = ACTIONS(657),
    [sym_null_literal] = ACTIONS(659),
    [anon_sym_LPAREN] = ACTIONS(657),
    [anon_sym_PLUS] = ACTIONS(659),
    [anon_sym_DASH] = ACTIONS(659),
    [anon_sym_BANG] = ACTIONS(657),
    [anon_sym_TILDE] = ACTIONS(657),
    [anon_sym_PLUS_PLUS] = ACTIONS(657),
    [anon_sym_DASH_DASH] = ACTIONS(657),
    [anon_sym_new] = ACTIONS(659),
    [anon_sym_class] = ACTIONS(659),
    [anon_sym_switch] = ACTIONS(659),
    [anon_sym_LBRACE] = ACTIONS(657),
    [anon_sym_RBRACE] = ACTIONS(657),
    [anon_sym_case] = ACTIONS(659),
    [anon_sym_default] = ACTIONS(659),
    [anon_sym_SEMI] = ACTIONS(657),
    [anon_sym_assert] = ACTIONS(659),
    [anon_sym_do] = ACTIONS(659),
    [anon_sym_while] = ACTIONS(659),
    [anon_sym_break] = ACTIONS(659),
    [anon_sym_continue] = ACTIONS(659),
    [anon_sym_return] = ACTIONS(659),
    [anon_sym_yield] = ACTIONS(659),
    [anon_sym_synchronized] = ACTIONS(659),
    [anon_sym_throw] = ACTIONS(659),
    [anon_sym_try] = ACTIONS(659),
    [anon_sym_if] = ACTIONS(659),
    [anon_sym_else] = ACTIONS(659),
    [anon_sym_for] = ACTIONS(659),
    [anon_sym_AT] = ACTIONS(659),
    [anon_sym_open] = ACTIONS(659),
    [anon_sym_module] = ACTIONS(659),
    [anon_sym_static] = ACTIONS(659),
    [anon_sym_package] = ACTIONS(659),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_enum] = ACTIONS(659),
    [anon_sym_public] = ACTIONS(659),
    [anon_sym_protected] = ACTIONS(659),
    [anon_sym_private] = ACTIONS(659),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_final] = ACTIONS(659),
    [anon_sym_strictfp] = ACTIONS(659),
    [anon_sym_native] = ACTIONS(659),
    [anon_sym_transient] = ACTIONS(659),
    [anon_sym_volatile] = ACTIONS(659),
    [anon_sym_sealed] = ACTIONS(659),
    [anon_sym_non_DASHsealed] = ACTIONS(657),
    [anon_sym_ATinterface] = ACTIONS(657),
    [anon_sym_interface] = ACTIONS(659),
    [anon_sym_byte] = ACTIONS(659),
    [anon_sym_short] = ACTIONS(659),
    [anon_sym_int] = ACTIONS(659),
    [anon_sym_long] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_float] = ACTIONS(659),
    [anon_sym_double] = ACTIONS(659),
    [sym_boolean_type] = ACTIONS(659),
    [sym_void_type] = ACTIONS(659),
    [sym_this] = ACTIONS(659),
    [sym_super] = ACTIONS(659),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(661),
    [sym_identifier] = ACTIONS(663),
    [sym_decimal_integer_literal] = ACTIONS(663),
    [sym_hex_integer_literal] = ACTIONS(663),
    [sym_octal_integer_literal] = ACTIONS(661),
    [sym_binary_integer_literal] = ACTIONS(661),
    [sym_decimal_floating_point_literal] = ACTIONS(661),
    [sym_hex_floating_point_literal] = ACTIONS(663),
    [sym_true] = ACTIONS(663),
    [sym_false] = ACTIONS(663),
    [sym_character_literal] = ACTIONS(661),
    [sym_string_literal] = ACTIONS(663),
    [sym_text_block] = ACTIONS(661),
    [sym_null_literal] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(661),
    [anon_sym_PLUS] = ACTIONS(663),
    [anon_sym_DASH] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(661),
    [anon_sym_TILDE] = ACTIONS(661),
    [anon_sym_PLUS_PLUS] = ACTIONS(661),
    [anon_sym_DASH_DASH] = ACTIONS(661),
    [anon_sym_new] = ACTIONS(663),
    [anon_sym_class] = ACTIONS(663),
    [anon_sym_switch] = ACTIONS(663),
    [anon_sym_LBRACE] = ACTIONS(661),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_case] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_SEMI] = ACTIONS(661),
    [anon_sym_assert] = ACTIONS(663),
    [anon_sym_do] = ACTIONS(663),
    [anon_sym_while] = ACTIONS(663),
    [anon_sym_break] = ACTIONS(663),
    [anon_sym_continue] = ACTIONS(663),
    [anon_sym_return] = ACTIONS(663),
    [anon_sym_yield] = ACTIONS(663),
    [anon_sym_synchronized] = ACTIONS(663),
    [anon_sym_throw] = ACTIONS(663),
    [anon_sym_try] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(663),
    [anon_sym_else] = ACTIONS(663),
    [anon_sym_for] = ACTIONS(663),
    [anon_sym_AT] = ACTIONS(663),
    [anon_sym_open] = ACTIONS(663),
    [anon_sym_module] = ACTIONS(663),
    [anon_sym_static] = ACTIONS(663),
    [anon_sym_package] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_enum] = ACTIONS(663),
    [anon_sym_public] = ACTIONS(663),
    [anon_sym_protected] = ACTIONS(663),
    [anon_sym_private] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(663),
    [anon_sym_final] = ACTIONS(663),
    [anon_sym_strictfp] = ACTIONS(663),
    [anon_sym_native] = ACTIONS(663),
    [anon_sym_transient] = ACTIONS(663),
    [anon_sym_volatile] = ACTIONS(663),
    [anon_sym_sealed] = ACTIONS(663),
    [anon_sym_non_DASHsealed] = ACTIONS(661),
    [anon_sym_ATinterface] = ACTIONS(661),
    [anon_sym_interface] = ACTIONS(663),
    [anon_sym_byte] = ACTIONS(663),
    [anon_sym_short] = ACTIONS(663),
    [anon_sym_int] = ACTIONS(663),
    [anon_sym_long] = ACTIONS(663),
    [anon_sym_char] = ACTIONS(663),
    [anon_sym_float] = ACTIONS(663),
    [anon_sym_double] = ACTIONS(663),
    [sym_boolean_type] = ACTIONS(663),
    [sym_void_type] = ACTIONS(663),
    [sym_this] = ACTIONS(663),
    [sym_super] = ACTIONS(663),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(665),
    [sym_identifier] = ACTIONS(667),
    [sym_decimal_integer_literal] = ACTIONS(667),
    [sym_hex_integer_literal] = ACTIONS(667),
    [sym_octal_integer_literal] = ACTIONS(665),
    [sym_binary_integer_literal] = ACTIONS(665),
    [sym_decimal_floating_point_literal] = ACTIONS(665),
    [sym_hex_floating_point_literal] = ACTIONS(667),
    [sym_true] = ACTIONS(667),
    [sym_false] = ACTIONS(667),
    [sym_character_literal] = ACTIONS(665),
    [sym_string_literal] = ACTIONS(667),
    [sym_text_block] = ACTIONS(665),
    [sym_null_literal] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_PLUS] = ACTIONS(667),
    [anon_sym_DASH] = ACTIONS(667),
    [anon_sym_BANG] = ACTIONS(665),
    [anon_sym_TILDE] = ACTIONS(665),
    [anon_sym_PLUS_PLUS] = ACTIONS(665),
    [anon_sym_DASH_DASH] = ACTIONS(665),
    [anon_sym_new] = ACTIONS(667),
    [anon_sym_class] = ACTIONS(667),
    [anon_sym_switch] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(665),
    [anon_sym_RBRACE] = ACTIONS(665),
    [anon_sym_case] = ACTIONS(667),
    [anon_sym_default] = ACTIONS(667),
    [anon_sym_SEMI] = ACTIONS(665),
    [anon_sym_assert] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(667),
    [anon_sym_while] = ACTIONS(667),
    [anon_sym_break] = ACTIONS(667),
    [anon_sym_continue] = ACTIONS(667),
    [anon_sym_return] = ACTIONS(667),
    [anon_sym_yield] = ACTIONS(667),
    [anon_sym_synchronized] = ACTIONS(667),
    [anon_sym_throw] = ACTIONS(667),
    [anon_sym_try] = ACTIONS(667),
    [anon_sym_if] = ACTIONS(667),
    [anon_sym_else] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(667),
    [anon_sym_AT] = ACTIONS(667),
    [anon_sym_open] = ACTIONS(667),
    [anon_sym_module] = ACTIONS(667),
    [anon_sym_static] = ACTIONS(667),
    [anon_sym_package] = ACTIONS(667),
    [anon_sym_import] = ACTIONS(667),
    [anon_sym_enum] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(667),
    [anon_sym_protected] = ACTIONS(667),
    [anon_sym_private] = ACTIONS(667),
    [anon_sym_abstract] = ACTIONS(667),
    [anon_sym_final] = ACTIONS(667),
    [anon_sym_strictfp] = ACTIONS(667),
    [anon_sym_native] = ACTIONS(667),
    [anon_sym_transient] = ACTIONS(667),
    [anon_sym_volatile] = ACTIONS(667),
    [anon_sym_sealed] = ACTIONS(667),
    [anon_sym_non_DASHsealed] = ACTIONS(665),
    [anon_sym_ATinterface] = ACTIONS(665),
    [anon_sym_interface] = ACTIONS(667),
    [anon_sym_byte] = ACTIONS(667),
    [anon_sym_short] = ACTIONS(667),
    [anon_sym_int] = ACTIONS(667),
    [anon_sym_long] = ACTIONS(667),
    [anon_sym_char] = ACTIONS(667),
    [anon_sym_float] = ACTIONS(667),
    [anon_sym_double] = ACTIONS(667),
    [sym_boolean_type] = ACTIONS(667),
    [sym_void_type] = ACTIONS(667),
    [sym_this] = ACTIONS(667),
    [sym_super] = ACTIONS(667),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(669),
    [sym_identifier] = ACTIONS(671),
    [sym_decimal_integer_literal] = ACTIONS(671),
    [sym_hex_integer_literal] = ACTIONS(671),
    [sym_octal_integer_literal] = ACTIONS(669),
    [sym_binary_integer_literal] = ACTIONS(669),
    [sym_decimal_floating_point_literal] = ACTIONS(669),
    [sym_hex_floating_point_literal] = ACTIONS(671),
    [sym_true] = ACTIONS(671),
    [sym_false] = ACTIONS(671),
    [sym_character_literal] = ACTIONS(669),
    [sym_string_literal] = ACTIONS(671),
    [sym_text_block] = ACTIONS(669),
    [sym_null_literal] = ACTIONS(671),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_PLUS] = ACTIONS(671),
    [anon_sym_DASH] = ACTIONS(671),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_new] = ACTIONS(671),
    [anon_sym_class] = ACTIONS(671),
    [anon_sym_switch] = ACTIONS(671),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_case] = ACTIONS(671),
    [anon_sym_default] = ACTIONS(671),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_assert] = ACTIONS(671),
    [anon_sym_do] = ACTIONS(671),
    [anon_sym_while] = ACTIONS(671),
    [anon_sym_break] = ACTIONS(671),
    [anon_sym_continue] = ACTIONS(671),
    [anon_sym_return] = ACTIONS(671),
    [anon_sym_yield] = ACTIONS(671),
    [anon_sym_synchronized] = ACTIONS(671),
    [anon_sym_throw] = ACTIONS(671),
    [anon_sym_try] = ACTIONS(671),
    [anon_sym_if] = ACTIONS(671),
    [anon_sym_else] = ACTIONS(671),
    [anon_sym_for] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(671),
    [anon_sym_open] = ACTIONS(671),
    [anon_sym_module] = ACTIONS(671),
    [anon_sym_static] = ACTIONS(671),
    [anon_sym_package] = ACTIONS(671),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_enum] = ACTIONS(671),
    [anon_sym_public] = ACTIONS(671),
    [anon_sym_protected] = ACTIONS(671),
    [anon_sym_private] = ACTIONS(671),
    [anon_sym_abstract] = ACTIONS(671),
    [anon_sym_final] = ACTIONS(671),
    [anon_sym_strictfp] = ACTIONS(671),
    [anon_sym_native] = ACTIONS(671),
    [anon_sym_transient] = ACTIONS(671),
    [anon_sym_volatile] = ACTIONS(671),
    [anon_sym_sealed] = ACTIONS(671),
    [anon_sym_non_DASHsealed] = ACTIONS(669),
    [anon_sym_ATinterface] = ACTIONS(669),
    [anon_sym_interface] = ACTIONS(671),
    [anon_sym_byte] = ACTIONS(671),
    [anon_sym_short] = ACTIONS(671),
    [anon_sym_int] = ACTIONS(671),
    [anon_sym_long] = ACTIONS(671),
    [anon_sym_char] = ACTIONS(671),
    [anon_sym_float] = ACTIONS(671),
    [anon_sym_double] = ACTIONS(671),
    [sym_boolean_type] = ACTIONS(671),
    [sym_void_type] = ACTIONS(671),
    [sym_this] = ACTIONS(671),
    [sym_super] = ACTIONS(671),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(673),
    [sym_identifier] = ACTIONS(675),
    [sym_decimal_integer_literal] = ACTIONS(675),
    [sym_hex_integer_literal] = ACTIONS(675),
    [sym_octal_integer_literal] = ACTIONS(673),
    [sym_binary_integer_literal] = ACTIONS(673),
    [sym_decimal_floating_point_literal] = ACTIONS(673),
    [sym_hex_floating_point_literal] = ACTIONS(675),
    [sym_true] = ACTIONS(675),
    [sym_false] = ACTIONS(675),
    [sym_character_literal] = ACTIONS(673),
    [sym_string_literal] = ACTIONS(675),
    [sym_text_block] = ACTIONS(673),
    [sym_null_literal] = ACTIONS(675),
    [anon_sym_LPAREN] = ACTIONS(673),
    [anon_sym_PLUS] = ACTIONS(675),
    [anon_sym_DASH] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_TILDE] = ACTIONS(673),
    [anon_sym_PLUS_PLUS] = ACTIONS(673),
    [anon_sym_DASH_DASH] = ACTIONS(673),
    [anon_sym_new] = ACTIONS(675),
    [anon_sym_class] = ACTIONS(675),
    [anon_sym_switch] = ACTIONS(675),
    [anon_sym_LBRACE] = ACTIONS(673),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_case] = ACTIONS(675),
    [anon_sym_default] = ACTIONS(675),
    [anon_sym_SEMI] = ACTIONS(673),
    [anon_sym_assert] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(675),
    [anon_sym_while] = ACTIONS(675),
    [anon_sym_break] = ACTIONS(675),
    [anon_sym_continue] = ACTIONS(675),
    [anon_sym_return] = ACTIONS(675),
    [anon_sym_yield] = ACTIONS(675),
    [anon_sym_synchronized] = ACTIONS(675),
    [anon_sym_throw] = ACTIONS(675),
    [anon_sym_try] = ACTIONS(675),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_else] = ACTIONS(675),
    [anon_sym_for] = ACTIONS(675),
    [anon_sym_AT] = ACTIONS(675),
    [anon_sym_open] = ACTIONS(675),
    [anon_sym_module] = ACTIONS(675),
    [anon_sym_static] = ACTIONS(675),
    [anon_sym_package] = ACTIONS(675),
    [anon_sym_import] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_public] = ACTIONS(675),
    [anon_sym_protected] = ACTIONS(675),
    [anon_sym_private] = ACTIONS(675),
    [anon_sym_abstract] = ACTIONS(675),
    [anon_sym_final] = ACTIONS(675),
    [anon_sym_strictfp] = ACTIONS(675),
    [anon_sym_native] = ACTIONS(675),
    [anon_sym_transient] = ACTIONS(675),
    [anon_sym_volatile] = ACTIONS(675),
    [anon_sym_sealed] = ACTIONS(675),
    [anon_sym_non_DASHsealed] = ACTIONS(673),
    [anon_sym_ATinterface] = ACTIONS(673),
    [anon_sym_interface] = ACTIONS(675),
    [anon_sym_byte] = ACTIONS(675),
    [anon_sym_short] = ACTIONS(675),
    [anon_sym_int] = ACTIONS(675),
    [anon_sym_long] = ACTIONS(675),
    [anon_sym_char] = ACTIONS(675),
    [anon_sym_float] = ACTIONS(675),
    [anon_sym_double] = ACTIONS(675),
    [sym_boolean_type] = ACTIONS(675),
    [sym_void_type] = ACTIONS(675),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(675),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(677),
    [sym_identifier] = ACTIONS(679),
    [sym_decimal_integer_literal] = ACTIONS(679),
    [sym_hex_integer_literal] = ACTIONS(679),
    [sym_octal_integer_literal] = ACTIONS(677),
    [sym_binary_integer_literal] = ACTIONS(677),
    [sym_decimal_floating_point_literal] = ACTIONS(677),
    [sym_hex_floating_point_literal] = ACTIONS(679),
    [sym_true] = ACTIONS(679),
    [sym_false] = ACTIONS(679),
    [sym_character_literal] = ACTIONS(677),
    [sym_string_literal] = ACTIONS(679),
    [sym_text_block] = ACTIONS(677),
    [sym_null_literal] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(677),
    [anon_sym_PLUS] = ACTIONS(679),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_TILDE] = ACTIONS(677),
    [anon_sym_PLUS_PLUS] = ACTIONS(677),
    [anon_sym_DASH_DASH] = ACTIONS(677),
    [anon_sym_new] = ACTIONS(679),
    [anon_sym_class] = ACTIONS(679),
    [anon_sym_switch] = ACTIONS(679),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_RBRACE] = ACTIONS(677),
    [anon_sym_case] = ACTIONS(679),
    [anon_sym_default] = ACTIONS(679),
    [anon_sym_SEMI] = ACTIONS(677),
    [anon_sym_assert] = ACTIONS(679),
    [anon_sym_do] = ACTIONS(679),
    [anon_sym_while] = ACTIONS(679),
    [anon_sym_break] = ACTIONS(679),
    [anon_sym_continue] = ACTIONS(679),
    [anon_sym_return] = ACTIONS(679),
    [anon_sym_yield] = ACTIONS(679),
    [anon_sym_synchronized] = ACTIONS(679),
    [anon_sym_throw] = ACTIONS(679),
    [anon_sym_try] = ACTIONS(679),
    [anon_sym_if] = ACTIONS(679),
    [anon_sym_else] = ACTIONS(679),
    [anon_sym_for] = ACTIONS(679),
    [anon_sym_AT] = ACTIONS(679),
    [anon_sym_open] = ACTIONS(679),
    [anon_sym_module] = ACTIONS(679),
    [anon_sym_static] = ACTIONS(679),
    [anon_sym_package] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(679),
    [anon_sym_enum] = ACTIONS(679),
    [anon_sym_public] = ACTIONS(679),
    [anon_sym_protected] = ACTIONS(679),
    [anon_sym_private] = ACTIONS(679),
    [anon_sym_abstract] = ACTIONS(679),
    [anon_sym_final] = ACTIONS(679),
    [anon_sym_strictfp] = ACTIONS(679),
    [anon_sym_native] = ACTIONS(679),
    [anon_sym_transient] = ACTIONS(679),
    [anon_sym_volatile] = ACTIONS(679),
    [anon_sym_sealed] = ACTIONS(679),
    [anon_sym_non_DASHsealed] = ACTIONS(677),
    [anon_sym_ATinterface] = ACTIONS(677),
    [anon_sym_interface] = ACTIONS(679),
    [anon_sym_byte] = ACTIONS(679),
    [anon_sym_short] = ACTIONS(679),
    [anon_sym_int] = ACTIONS(679),
    [anon_sym_long] = ACTIONS(679),
    [anon_sym_char] = ACTIONS(679),
    [anon_sym_float] = ACTIONS(679),
    [anon_sym_double] = ACTIONS(679),
    [sym_boolean_type] = ACTIONS(679),
    [sym_void_type] = ACTIONS(679),
    [sym_this] = ACTIONS(679),
    [sym_super] = ACTIONS(679),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(681),
    [sym_identifier] = ACTIONS(683),
    [sym_decimal_integer_literal] = ACTIONS(683),
    [sym_hex_integer_literal] = ACTIONS(683),
    [sym_octal_integer_literal] = ACTIONS(681),
    [sym_binary_integer_literal] = ACTIONS(681),
    [sym_decimal_floating_point_literal] = ACTIONS(681),
    [sym_hex_floating_point_literal] = ACTIONS(683),
    [sym_true] = ACTIONS(683),
    [sym_false] = ACTIONS(683),
    [sym_character_literal] = ACTIONS(681),
    [sym_string_literal] = ACTIONS(683),
    [sym_text_block] = ACTIONS(681),
    [sym_null_literal] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(681),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(681),
    [anon_sym_TILDE] = ACTIONS(681),
    [anon_sym_PLUS_PLUS] = ACTIONS(681),
    [anon_sym_DASH_DASH] = ACTIONS(681),
    [anon_sym_new] = ACTIONS(683),
    [anon_sym_class] = ACTIONS(683),
    [anon_sym_switch] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(681),
    [anon_sym_RBRACE] = ACTIONS(681),
    [anon_sym_case] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(681),
    [anon_sym_assert] = ACTIONS(683),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_while] = ACTIONS(683),
    [anon_sym_break] = ACTIONS(683),
    [anon_sym_continue] = ACTIONS(683),
    [anon_sym_return] = ACTIONS(683),
    [anon_sym_yield] = ACTIONS(683),
    [anon_sym_synchronized] = ACTIONS(683),
    [anon_sym_throw] = ACTIONS(683),
    [anon_sym_try] = ACTIONS(683),
    [anon_sym_if] = ACTIONS(683),
    [anon_sym_else] = ACTIONS(683),
    [anon_sym_for] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_open] = ACTIONS(683),
    [anon_sym_module] = ACTIONS(683),
    [anon_sym_static] = ACTIONS(683),
    [anon_sym_package] = ACTIONS(683),
    [anon_sym_import] = ACTIONS(683),
    [anon_sym_enum] = ACTIONS(683),
    [anon_sym_public] = ACTIONS(683),
    [anon_sym_protected] = ACTIONS(683),
    [anon_sym_private] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(683),
    [anon_sym_final] = ACTIONS(683),
    [anon_sym_strictfp] = ACTIONS(683),
    [anon_sym_native] = ACTIONS(683),
    [anon_sym_transient] = ACTIONS(683),
    [anon_sym_volatile] = ACTIONS(683),
    [anon_sym_sealed] = ACTIONS(683),
    [anon_sym_non_DASHsealed] = ACTIONS(681),
    [anon_sym_ATinterface] = ACTIONS(681),
    [anon_sym_interface] = ACTIONS(683),
    [anon_sym_byte] = ACTIONS(683),
    [anon_sym_short] = ACTIONS(683),
    [anon_sym_int] = ACTIONS(683),
    [anon_sym_long] = ACTIONS(683),
    [anon_sym_char] = ACTIONS(683),
    [anon_sym_float] = ACTIONS(683),
    [anon_sym_double] = ACTIONS(683),
    [sym_boolean_type] = ACTIONS(683),
    [sym_void_type] = ACTIONS(683),
    [sym_this] = ACTIONS(683),
    [sym_super] = ACTIONS(683),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_identifier] = ACTIONS(687),
    [sym_decimal_integer_literal] = ACTIONS(687),
    [sym_hex_integer_literal] = ACTIONS(687),
    [sym_octal_integer_literal] = ACTIONS(685),
    [sym_binary_integer_literal] = ACTIONS(685),
    [sym_decimal_floating_point_literal] = ACTIONS(685),
    [sym_hex_floating_point_literal] = ACTIONS(687),
    [sym_true] = ACTIONS(687),
    [sym_false] = ACTIONS(687),
    [sym_character_literal] = ACTIONS(685),
    [sym_string_literal] = ACTIONS(687),
    [sym_text_block] = ACTIONS(685),
    [sym_null_literal] = ACTIONS(687),
    [anon_sym_LPAREN] = ACTIONS(685),
    [anon_sym_PLUS] = ACTIONS(687),
    [anon_sym_DASH] = ACTIONS(687),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_TILDE] = ACTIONS(685),
    [anon_sym_PLUS_PLUS] = ACTIONS(685),
    [anon_sym_DASH_DASH] = ACTIONS(685),
    [anon_sym_new] = ACTIONS(687),
    [anon_sym_class] = ACTIONS(687),
    [anon_sym_switch] = ACTIONS(687),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_case] = ACTIONS(687),
    [anon_sym_default] = ACTIONS(687),
    [anon_sym_SEMI] = ACTIONS(685),
    [anon_sym_assert] = ACTIONS(687),
    [anon_sym_do] = ACTIONS(687),
    [anon_sym_while] = ACTIONS(687),
    [anon_sym_break] = ACTIONS(687),
    [anon_sym_continue] = ACTIONS(687),
    [anon_sym_return] = ACTIONS(687),
    [anon_sym_yield] = ACTIONS(687),
    [anon_sym_synchronized] = ACTIONS(687),
    [anon_sym_throw] = ACTIONS(687),
    [anon_sym_try] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(687),
    [anon_sym_else] = ACTIONS(687),
    [anon_sym_for] = ACTIONS(687),
    [anon_sym_AT] = ACTIONS(687),
    [anon_sym_open] = ACTIONS(687),
    [anon_sym_module] = ACTIONS(687),
    [anon_sym_static] = ACTIONS(687),
    [anon_sym_package] = ACTIONS(687),
    [anon_sym_import] = ACTIONS(687),
    [anon_sym_enum] = ACTIONS(687),
    [anon_sym_public] = ACTIONS(687),
    [anon_sym_protected] = ACTIONS(687),
    [anon_sym_private] = ACTIONS(687),
    [anon_sym_abstract] = ACTIONS(687),
    [anon_sym_final] = ACTIONS(687),
    [anon_sym_strictfp] = ACTIONS(687),
    [anon_sym_native] = ACTIONS(687),
    [anon_sym_transient] = ACTIONS(687),
    [anon_sym_volatile] = ACTIONS(687),
    [anon_sym_sealed] = ACTIONS(687),
    [anon_sym_non_DASHsealed] = ACTIONS(685),
    [anon_sym_ATinterface] = ACTIONS(685),
    [anon_sym_interface] = ACTIONS(687),
    [anon_sym_byte] = ACTIONS(687),
    [anon_sym_short] = ACTIONS(687),
    [anon_sym_int] = ACTIONS(687),
    [anon_sym_long] = ACTIONS(687),
    [anon_sym_char] = ACTIONS(687),
    [anon_sym_float] = ACTIONS(687),
    [anon_sym_double] = ACTIONS(687),
    [sym_boolean_type] = ACTIONS(687),
    [sym_void_type] = ACTIONS(687),
    [sym_this] = ACTIONS(687),
    [sym_super] = ACTIONS(687),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(689),
    [sym_identifier] = ACTIONS(691),
    [sym_decimal_integer_literal] = ACTIONS(691),
    [sym_hex_integer_literal] = ACTIONS(691),
    [sym_octal_integer_literal] = ACTIONS(689),
    [sym_binary_integer_literal] = ACTIONS(689),
    [sym_decimal_floating_point_literal] = ACTIONS(689),
    [sym_hex_floating_point_literal] = ACTIONS(691),
    [sym_true] = ACTIONS(691),
    [sym_false] = ACTIONS(691),
    [sym_character_literal] = ACTIONS(689),
    [sym_string_literal] = ACTIONS(691),
    [sym_text_block] = ACTIONS(689),
    [sym_null_literal] = ACTIONS(691),
    [anon_sym_LPAREN] = ACTIONS(689),
    [anon_sym_PLUS] = ACTIONS(691),
    [anon_sym_DASH] = ACTIONS(691),
    [anon_sym_BANG] = ACTIONS(689),
    [anon_sym_TILDE] = ACTIONS(689),
    [anon_sym_PLUS_PLUS] = ACTIONS(689),
    [anon_sym_DASH_DASH] = ACTIONS(689),
    [anon_sym_new] = ACTIONS(691),
    [anon_sym_class] = ACTIONS(691),
    [anon_sym_switch] = ACTIONS(691),
    [anon_sym_LBRACE] = ACTIONS(689),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_case] = ACTIONS(691),
    [anon_sym_default] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(689),
    [anon_sym_assert] = ACTIONS(691),
    [anon_sym_do] = ACTIONS(691),
    [anon_sym_while] = ACTIONS(691),
    [anon_sym_break] = ACTIONS(691),
    [anon_sym_continue] = ACTIONS(691),
    [anon_sym_return] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(691),
    [anon_sym_synchronized] = ACTIONS(691),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_try] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(691),
    [anon_sym_else] = ACTIONS(691),
    [anon_sym_for] = ACTIONS(691),
    [anon_sym_AT] = ACTIONS(691),
    [anon_sym_open] = ACTIONS(691),
    [anon_sym_module] = ACTIONS(691),
    [anon_sym_static] = ACTIONS(691),
    [anon_sym_package] = ACTIONS(691),
    [anon_sym_import] = ACTIONS(691),
    [anon_sym_enum] = ACTIONS(691),
    [anon_sym_public] = ACTIONS(691),
    [anon_sym_protected] = ACTIONS(691),
    [anon_sym_private] = ACTIONS(691),
    [anon_sym_abstract] = ACTIONS(691),
    [anon_sym_final] = ACTIONS(691),
    [anon_sym_strictfp] = ACTIONS(691),
    [anon_sym_native] = ACTIONS(691),
    [anon_sym_transient] = ACTIONS(691),
    [anon_sym_volatile] = ACTIONS(691),
    [anon_sym_sealed] = ACTIONS(691),
    [anon_sym_non_DASHsealed] = ACTIONS(689),
    [anon_sym_ATinterface] = ACTIONS(689),
    [anon_sym_interface] = ACTIONS(691),
    [anon_sym_byte] = ACTIONS(691),
    [anon_sym_short] = ACTIONS(691),
    [anon_sym_int] = ACTIONS(691),
    [anon_sym_long] = ACTIONS(691),
    [anon_sym_char] = ACTIONS(691),
    [anon_sym_float] = ACTIONS(691),
    [anon_sym_double] = ACTIONS(691),
    [sym_boolean_type] = ACTIONS(691),
    [sym_void_type] = ACTIONS(691),
    [sym_this] = ACTIONS(691),
    [sym_super] = ACTIONS(691),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_switch_label] = STATE(1084),
    [aux_sym_switch_block_statement_group_repeat1] = STATE(165),
    [sym_identifier] = ACTIONS(693),
    [sym_decimal_integer_literal] = ACTIONS(693),
    [sym_hex_integer_literal] = ACTIONS(693),
    [sym_octal_integer_literal] = ACTIONS(695),
    [sym_binary_integer_literal] = ACTIONS(695),
    [sym_decimal_floating_point_literal] = ACTIONS(695),
    [sym_hex_floating_point_literal] = ACTIONS(693),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [sym_string_literal] = ACTIONS(693),
    [sym_text_block] = ACTIONS(695),
    [sym_null_literal] = ACTIONS(693),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_TILDE] = ACTIONS(695),
    [anon_sym_PLUS_PLUS] = ACTIONS(695),
    [anon_sym_DASH_DASH] = ACTIONS(695),
    [anon_sym_new] = ACTIONS(693),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_switch] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_case] = ACTIONS(697),
    [anon_sym_default] = ACTIONS(700),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_assert] = ACTIONS(693),
    [anon_sym_do] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_yield] = ACTIONS(693),
    [anon_sym_synchronized] = ACTIONS(693),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_open] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_package] = ACTIONS(693),
    [anon_sym_import] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_abstract] = ACTIONS(693),
    [anon_sym_final] = ACTIONS(693),
    [anon_sym_strictfp] = ACTIONS(693),
    [anon_sym_native] = ACTIONS(693),
    [anon_sym_transient] = ACTIONS(693),
    [anon_sym_volatile] = ACTIONS(693),
    [anon_sym_sealed] = ACTIONS(693),
    [anon_sym_non_DASHsealed] = ACTIONS(695),
    [anon_sym_ATinterface] = ACTIONS(695),
    [anon_sym_interface] = ACTIONS(693),
    [anon_sym_byte] = ACTIONS(693),
    [anon_sym_short] = ACTIONS(693),
    [anon_sym_int] = ACTIONS(693),
    [anon_sym_long] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_float] = ACTIONS(693),
    [anon_sym_double] = ACTIONS(693),
    [sym_boolean_type] = ACTIONS(693),
    [sym_void_type] = ACTIONS(693),
    [sym_this] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(703),
    [sym_identifier] = ACTIONS(705),
    [sym_decimal_integer_literal] = ACTIONS(705),
    [sym_hex_integer_literal] = ACTIONS(705),
    [sym_octal_integer_literal] = ACTIONS(703),
    [sym_binary_integer_literal] = ACTIONS(703),
    [sym_decimal_floating_point_literal] = ACTIONS(703),
    [sym_hex_floating_point_literal] = ACTIONS(705),
    [sym_true] = ACTIONS(705),
    [sym_false] = ACTIONS(705),
    [sym_character_literal] = ACTIONS(703),
    [sym_string_literal] = ACTIONS(705),
    [sym_text_block] = ACTIONS(703),
    [sym_null_literal] = ACTIONS(705),
    [anon_sym_LPAREN] = ACTIONS(703),
    [anon_sym_PLUS] = ACTIONS(705),
    [anon_sym_DASH] = ACTIONS(705),
    [anon_sym_BANG] = ACTIONS(703),
    [anon_sym_TILDE] = ACTIONS(703),
    [anon_sym_PLUS_PLUS] = ACTIONS(703),
    [anon_sym_DASH_DASH] = ACTIONS(703),
    [anon_sym_new] = ACTIONS(705),
    [anon_sym_class] = ACTIONS(705),
    [anon_sym_switch] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_case] = ACTIONS(705),
    [anon_sym_default] = ACTIONS(705),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_assert] = ACTIONS(705),
    [anon_sym_do] = ACTIONS(705),
    [anon_sym_while] = ACTIONS(705),
    [anon_sym_break] = ACTIONS(705),
    [anon_sym_continue] = ACTIONS(705),
    [anon_sym_return] = ACTIONS(705),
    [anon_sym_yield] = ACTIONS(705),
    [anon_sym_synchronized] = ACTIONS(705),
    [anon_sym_throw] = ACTIONS(705),
    [anon_sym_try] = ACTIONS(705),
    [anon_sym_if] = ACTIONS(705),
    [anon_sym_else] = ACTIONS(705),
    [anon_sym_for] = ACTIONS(705),
    [anon_sym_AT] = ACTIONS(705),
    [anon_sym_open] = ACTIONS(705),
    [anon_sym_module] = ACTIONS(705),
    [anon_sym_static] = ACTIONS(705),
    [anon_sym_package] = ACTIONS(705),
    [anon_sym_import] = ACTIONS(705),
    [anon_sym_enum] = ACTIONS(705),
    [anon_sym_public] = ACTIONS(705),
    [anon_sym_protected] = ACTIONS(705),
    [anon_sym_private] = ACTIONS(705),
    [anon_sym_abstract] = ACTIONS(705),
    [anon_sym_final] = ACTIONS(705),
    [anon_sym_strictfp] = ACTIONS(705),
    [anon_sym_native] = ACTIONS(705),
    [anon_sym_transient] = ACTIONS(705),
    [anon_sym_volatile] = ACTIONS(705),
    [anon_sym_sealed] = ACTIONS(705),
    [anon_sym_non_DASHsealed] = ACTIONS(703),
    [anon_sym_ATinterface] = ACTIONS(703),
    [anon_sym_interface] = ACTIONS(705),
    [anon_sym_byte] = ACTIONS(705),
    [anon_sym_short] = ACTIONS(705),
    [anon_sym_int] = ACTIONS(705),
    [anon_sym_long] = ACTIONS(705),
    [anon_sym_char] = ACTIONS(705),
    [anon_sym_float] = ACTIONS(705),
    [anon_sym_double] = ACTIONS(705),
    [sym_boolean_type] = ACTIONS(705),
    [sym_void_type] = ACTIONS(705),
    [sym_this] = ACTIONS(705),
    [sym_super] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(707),
    [sym_identifier] = ACTIONS(709),
    [sym_decimal_integer_literal] = ACTIONS(709),
    [sym_hex_integer_literal] = ACTIONS(709),
    [sym_octal_integer_literal] = ACTIONS(707),
    [sym_binary_integer_literal] = ACTIONS(707),
    [sym_decimal_floating_point_literal] = ACTIONS(707),
    [sym_hex_floating_point_literal] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [sym_false] = ACTIONS(709),
    [sym_character_literal] = ACTIONS(707),
    [sym_string_literal] = ACTIONS(709),
    [sym_text_block] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(707),
    [anon_sym_PLUS] = ACTIONS(709),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(707),
    [anon_sym_TILDE] = ACTIONS(707),
    [anon_sym_PLUS_PLUS] = ACTIONS(707),
    [anon_sym_DASH_DASH] = ACTIONS(707),
    [anon_sym_new] = ACTIONS(709),
    [anon_sym_class] = ACTIONS(709),
    [anon_sym_switch] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(707),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym_case] = ACTIONS(709),
    [anon_sym_default] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(707),
    [anon_sym_assert] = ACTIONS(709),
    [anon_sym_do] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_break] = ACTIONS(709),
    [anon_sym_continue] = ACTIONS(709),
    [anon_sym_return] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(709),
    [anon_sym_synchronized] = ACTIONS(709),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_try] = ACTIONS(709),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_else] = ACTIONS(709),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(709),
    [anon_sym_open] = ACTIONS(709),
    [anon_sym_module] = ACTIONS(709),
    [anon_sym_static] = ACTIONS(709),
    [anon_sym_package] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(709),
    [anon_sym_enum] = ACTIONS(709),
    [anon_sym_public] = ACTIONS(709),
    [anon_sym_protected] = ACTIONS(709),
    [anon_sym_private] = ACTIONS(709),
    [anon_sym_abstract] = ACTIONS(709),
    [anon_sym_final] = ACTIONS(709),
    [anon_sym_strictfp] = ACTIONS(709),
    [anon_sym_native] = ACTIONS(709),
    [anon_sym_transient] = ACTIONS(709),
    [anon_sym_volatile] = ACTIONS(709),
    [anon_sym_sealed] = ACTIONS(709),
    [anon_sym_non_DASHsealed] = ACTIONS(707),
    [anon_sym_ATinterface] = ACTIONS(707),
    [anon_sym_interface] = ACTIONS(709),
    [anon_sym_byte] = ACTIONS(709),
    [anon_sym_short] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_long] = ACTIONS(709),
    [anon_sym_char] = ACTIONS(709),
    [anon_sym_float] = ACTIONS(709),
    [anon_sym_double] = ACTIONS(709),
    [sym_boolean_type] = ACTIONS(709),
    [sym_void_type] = ACTIONS(709),
    [sym_this] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [168] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(522),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym_array_initializer] = STATE(986),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(711),
    [sym_identifier] = ACTIONS(713),
    [sym_decimal_integer_literal] = ACTIONS(713),
    [sym_hex_integer_literal] = ACTIONS(713),
    [sym_octal_integer_literal] = ACTIONS(711),
    [sym_binary_integer_literal] = ACTIONS(711),
    [sym_decimal_floating_point_literal] = ACTIONS(711),
    [sym_hex_floating_point_literal] = ACTIONS(713),
    [sym_true] = ACTIONS(713),
    [sym_false] = ACTIONS(713),
    [sym_character_literal] = ACTIONS(711),
    [sym_string_literal] = ACTIONS(713),
    [sym_text_block] = ACTIONS(711),
    [sym_null_literal] = ACTIONS(713),
    [anon_sym_LPAREN] = ACTIONS(711),
    [anon_sym_PLUS] = ACTIONS(713),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_BANG] = ACTIONS(711),
    [anon_sym_TILDE] = ACTIONS(711),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_new] = ACTIONS(713),
    [anon_sym_class] = ACTIONS(713),
    [anon_sym_switch] = ACTIONS(713),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(713),
    [anon_sym_default] = ACTIONS(713),
    [anon_sym_SEMI] = ACTIONS(711),
    [anon_sym_assert] = ACTIONS(713),
    [anon_sym_do] = ACTIONS(713),
    [anon_sym_while] = ACTIONS(713),
    [anon_sym_break] = ACTIONS(713),
    [anon_sym_continue] = ACTIONS(713),
    [anon_sym_return] = ACTIONS(713),
    [anon_sym_yield] = ACTIONS(713),
    [anon_sym_synchronized] = ACTIONS(713),
    [anon_sym_throw] = ACTIONS(713),
    [anon_sym_try] = ACTIONS(713),
    [anon_sym_if] = ACTIONS(713),
    [anon_sym_else] = ACTIONS(713),
    [anon_sym_for] = ACTIONS(713),
    [anon_sym_AT] = ACTIONS(713),
    [anon_sym_open] = ACTIONS(713),
    [anon_sym_module] = ACTIONS(713),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_package] = ACTIONS(713),
    [anon_sym_import] = ACTIONS(713),
    [anon_sym_enum] = ACTIONS(713),
    [anon_sym_public] = ACTIONS(713),
    [anon_sym_protected] = ACTIONS(713),
    [anon_sym_private] = ACTIONS(713),
    [anon_sym_abstract] = ACTIONS(713),
    [anon_sym_final] = ACTIONS(713),
    [anon_sym_strictfp] = ACTIONS(713),
    [anon_sym_native] = ACTIONS(713),
    [anon_sym_transient] = ACTIONS(713),
    [anon_sym_volatile] = ACTIONS(713),
    [anon_sym_sealed] = ACTIONS(713),
    [anon_sym_non_DASHsealed] = ACTIONS(711),
    [anon_sym_ATinterface] = ACTIONS(711),
    [anon_sym_interface] = ACTIONS(713),
    [anon_sym_byte] = ACTIONS(713),
    [anon_sym_short] = ACTIONS(713),
    [anon_sym_int] = ACTIONS(713),
    [anon_sym_long] = ACTIONS(713),
    [anon_sym_char] = ACTIONS(713),
    [anon_sym_float] = ACTIONS(713),
    [anon_sym_double] = ACTIONS(713),
    [sym_boolean_type] = ACTIONS(713),
    [sym_void_type] = ACTIONS(713),
    [sym_this] = ACTIONS(713),
    [sym_super] = ACTIONS(713),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(715),
    [sym_identifier] = ACTIONS(717),
    [sym_decimal_integer_literal] = ACTIONS(717),
    [sym_hex_integer_literal] = ACTIONS(717),
    [sym_octal_integer_literal] = ACTIONS(715),
    [sym_binary_integer_literal] = ACTIONS(715),
    [sym_decimal_floating_point_literal] = ACTIONS(715),
    [sym_hex_floating_point_literal] = ACTIONS(717),
    [sym_true] = ACTIONS(717),
    [sym_false] = ACTIONS(717),
    [sym_character_literal] = ACTIONS(715),
    [sym_string_literal] = ACTIONS(717),
    [sym_text_block] = ACTIONS(715),
    [sym_null_literal] = ACTIONS(717),
    [anon_sym_LPAREN] = ACTIONS(715),
    [anon_sym_PLUS] = ACTIONS(717),
    [anon_sym_DASH] = ACTIONS(717),
    [anon_sym_BANG] = ACTIONS(715),
    [anon_sym_TILDE] = ACTIONS(715),
    [anon_sym_PLUS_PLUS] = ACTIONS(715),
    [anon_sym_DASH_DASH] = ACTIONS(715),
    [anon_sym_new] = ACTIONS(717),
    [anon_sym_class] = ACTIONS(717),
    [anon_sym_switch] = ACTIONS(717),
    [anon_sym_LBRACE] = ACTIONS(715),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_case] = ACTIONS(717),
    [anon_sym_default] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_assert] = ACTIONS(717),
    [anon_sym_do] = ACTIONS(717),
    [anon_sym_while] = ACTIONS(717),
    [anon_sym_break] = ACTIONS(717),
    [anon_sym_continue] = ACTIONS(717),
    [anon_sym_return] = ACTIONS(717),
    [anon_sym_yield] = ACTIONS(717),
    [anon_sym_synchronized] = ACTIONS(717),
    [anon_sym_throw] = ACTIONS(717),
    [anon_sym_try] = ACTIONS(717),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_else] = ACTIONS(717),
    [anon_sym_for] = ACTIONS(717),
    [anon_sym_AT] = ACTIONS(717),
    [anon_sym_open] = ACTIONS(717),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_static] = ACTIONS(717),
    [anon_sym_package] = ACTIONS(717),
    [anon_sym_import] = ACTIONS(717),
    [anon_sym_enum] = ACTIONS(717),
    [anon_sym_public] = ACTIONS(717),
    [anon_sym_protected] = ACTIONS(717),
    [anon_sym_private] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(717),
    [anon_sym_final] = ACTIONS(717),
    [anon_sym_strictfp] = ACTIONS(717),
    [anon_sym_native] = ACTIONS(717),
    [anon_sym_transient] = ACTIONS(717),
    [anon_sym_volatile] = ACTIONS(717),
    [anon_sym_sealed] = ACTIONS(717),
    [anon_sym_non_DASHsealed] = ACTIONS(715),
    [anon_sym_ATinterface] = ACTIONS(715),
    [anon_sym_interface] = ACTIONS(717),
    [anon_sym_byte] = ACTIONS(717),
    [anon_sym_short] = ACTIONS(717),
    [anon_sym_int] = ACTIONS(717),
    [anon_sym_long] = ACTIONS(717),
    [anon_sym_char] = ACTIONS(717),
    [anon_sym_float] = ACTIONS(717),
    [anon_sym_double] = ACTIONS(717),
    [sym_boolean_type] = ACTIONS(717),
    [sym_void_type] = ACTIONS(717),
    [sym_this] = ACTIONS(717),
    [sym_super] = ACTIONS(717),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(719),
    [sym_identifier] = ACTIONS(721),
    [sym_decimal_integer_literal] = ACTIONS(721),
    [sym_hex_integer_literal] = ACTIONS(721),
    [sym_octal_integer_literal] = ACTIONS(719),
    [sym_binary_integer_literal] = ACTIONS(719),
    [sym_decimal_floating_point_literal] = ACTIONS(719),
    [sym_hex_floating_point_literal] = ACTIONS(721),
    [sym_true] = ACTIONS(721),
    [sym_false] = ACTIONS(721),
    [sym_character_literal] = ACTIONS(719),
    [sym_string_literal] = ACTIONS(721),
    [sym_text_block] = ACTIONS(719),
    [sym_null_literal] = ACTIONS(721),
    [anon_sym_LPAREN] = ACTIONS(719),
    [anon_sym_PLUS] = ACTIONS(721),
    [anon_sym_DASH] = ACTIONS(721),
    [anon_sym_BANG] = ACTIONS(719),
    [anon_sym_TILDE] = ACTIONS(719),
    [anon_sym_PLUS_PLUS] = ACTIONS(719),
    [anon_sym_DASH_DASH] = ACTIONS(719),
    [anon_sym_new] = ACTIONS(721),
    [anon_sym_class] = ACTIONS(721),
    [anon_sym_switch] = ACTIONS(721),
    [anon_sym_LBRACE] = ACTIONS(719),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_case] = ACTIONS(721),
    [anon_sym_default] = ACTIONS(721),
    [anon_sym_SEMI] = ACTIONS(719),
    [anon_sym_assert] = ACTIONS(721),
    [anon_sym_do] = ACTIONS(721),
    [anon_sym_while] = ACTIONS(721),
    [anon_sym_break] = ACTIONS(721),
    [anon_sym_continue] = ACTIONS(721),
    [anon_sym_return] = ACTIONS(721),
    [anon_sym_yield] = ACTIONS(721),
    [anon_sym_synchronized] = ACTIONS(721),
    [anon_sym_throw] = ACTIONS(721),
    [anon_sym_try] = ACTIONS(721),
    [anon_sym_if] = ACTIONS(721),
    [anon_sym_else] = ACTIONS(721),
    [anon_sym_for] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(721),
    [anon_sym_open] = ACTIONS(721),
    [anon_sym_module] = ACTIONS(721),
    [anon_sym_static] = ACTIONS(721),
    [anon_sym_package] = ACTIONS(721),
    [anon_sym_import] = ACTIONS(721),
    [anon_sym_enum] = ACTIONS(721),
    [anon_sym_public] = ACTIONS(721),
    [anon_sym_protected] = ACTIONS(721),
    [anon_sym_private] = ACTIONS(721),
    [anon_sym_abstract] = ACTIONS(721),
    [anon_sym_final] = ACTIONS(721),
    [anon_sym_strictfp] = ACTIONS(721),
    [anon_sym_native] = ACTIONS(721),
    [anon_sym_transient] = ACTIONS(721),
    [anon_sym_volatile] = ACTIONS(721),
    [anon_sym_sealed] = ACTIONS(721),
    [anon_sym_non_DASHsealed] = ACTIONS(719),
    [anon_sym_ATinterface] = ACTIONS(719),
    [anon_sym_interface] = ACTIONS(721),
    [anon_sym_byte] = ACTIONS(721),
    [anon_sym_short] = ACTIONS(721),
    [anon_sym_int] = ACTIONS(721),
    [anon_sym_long] = ACTIONS(721),
    [anon_sym_char] = ACTIONS(721),
    [anon_sym_float] = ACTIONS(721),
    [anon_sym_double] = ACTIONS(721),
    [sym_boolean_type] = ACTIONS(721),
    [sym_void_type] = ACTIONS(721),
    [sym_this] = ACTIONS(721),
    [sym_super] = ACTIONS(721),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(723),
    [sym_identifier] = ACTIONS(725),
    [sym_decimal_integer_literal] = ACTIONS(725),
    [sym_hex_integer_literal] = ACTIONS(725),
    [sym_octal_integer_literal] = ACTIONS(723),
    [sym_binary_integer_literal] = ACTIONS(723),
    [sym_decimal_floating_point_literal] = ACTIONS(723),
    [sym_hex_floating_point_literal] = ACTIONS(725),
    [sym_true] = ACTIONS(725),
    [sym_false] = ACTIONS(725),
    [sym_character_literal] = ACTIONS(723),
    [sym_string_literal] = ACTIONS(725),
    [sym_text_block] = ACTIONS(723),
    [sym_null_literal] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(723),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(723),
    [anon_sym_TILDE] = ACTIONS(723),
    [anon_sym_PLUS_PLUS] = ACTIONS(723),
    [anon_sym_DASH_DASH] = ACTIONS(723),
    [anon_sym_new] = ACTIONS(725),
    [anon_sym_class] = ACTIONS(725),
    [anon_sym_switch] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(723),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_case] = ACTIONS(725),
    [anon_sym_default] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_assert] = ACTIONS(725),
    [anon_sym_do] = ACTIONS(725),
    [anon_sym_while] = ACTIONS(725),
    [anon_sym_break] = ACTIONS(725),
    [anon_sym_continue] = ACTIONS(725),
    [anon_sym_return] = ACTIONS(725),
    [anon_sym_yield] = ACTIONS(725),
    [anon_sym_synchronized] = ACTIONS(725),
    [anon_sym_throw] = ACTIONS(725),
    [anon_sym_try] = ACTIONS(725),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_else] = ACTIONS(725),
    [anon_sym_for] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_open] = ACTIONS(725),
    [anon_sym_module] = ACTIONS(725),
    [anon_sym_static] = ACTIONS(725),
    [anon_sym_package] = ACTIONS(725),
    [anon_sym_import] = ACTIONS(725),
    [anon_sym_enum] = ACTIONS(725),
    [anon_sym_public] = ACTIONS(725),
    [anon_sym_protected] = ACTIONS(725),
    [anon_sym_private] = ACTIONS(725),
    [anon_sym_abstract] = ACTIONS(725),
    [anon_sym_final] = ACTIONS(725),
    [anon_sym_strictfp] = ACTIONS(725),
    [anon_sym_native] = ACTIONS(725),
    [anon_sym_transient] = ACTIONS(725),
    [anon_sym_volatile] = ACTIONS(725),
    [anon_sym_sealed] = ACTIONS(725),
    [anon_sym_non_DASHsealed] = ACTIONS(723),
    [anon_sym_ATinterface] = ACTIONS(723),
    [anon_sym_interface] = ACTIONS(725),
    [anon_sym_byte] = ACTIONS(725),
    [anon_sym_short] = ACTIONS(725),
    [anon_sym_int] = ACTIONS(725),
    [anon_sym_long] = ACTIONS(725),
    [anon_sym_char] = ACTIONS(725),
    [anon_sym_float] = ACTIONS(725),
    [anon_sym_double] = ACTIONS(725),
    [sym_boolean_type] = ACTIONS(725),
    [sym_void_type] = ACTIONS(725),
    [sym_this] = ACTIONS(725),
    [sym_super] = ACTIONS(725),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(727),
    [sym_identifier] = ACTIONS(729),
    [sym_decimal_integer_literal] = ACTIONS(729),
    [sym_hex_integer_literal] = ACTIONS(729),
    [sym_octal_integer_literal] = ACTIONS(727),
    [sym_binary_integer_literal] = ACTIONS(727),
    [sym_decimal_floating_point_literal] = ACTIONS(727),
    [sym_hex_floating_point_literal] = ACTIONS(729),
    [sym_true] = ACTIONS(729),
    [sym_false] = ACTIONS(729),
    [sym_character_literal] = ACTIONS(727),
    [sym_string_literal] = ACTIONS(729),
    [sym_text_block] = ACTIONS(727),
    [sym_null_literal] = ACTIONS(729),
    [anon_sym_LPAREN] = ACTIONS(727),
    [anon_sym_PLUS] = ACTIONS(729),
    [anon_sym_DASH] = ACTIONS(729),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_TILDE] = ACTIONS(727),
    [anon_sym_PLUS_PLUS] = ACTIONS(727),
    [anon_sym_DASH_DASH] = ACTIONS(727),
    [anon_sym_new] = ACTIONS(729),
    [anon_sym_class] = ACTIONS(729),
    [anon_sym_switch] = ACTIONS(729),
    [anon_sym_LBRACE] = ACTIONS(727),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_case] = ACTIONS(729),
    [anon_sym_default] = ACTIONS(729),
    [anon_sym_SEMI] = ACTIONS(727),
    [anon_sym_assert] = ACTIONS(729),
    [anon_sym_do] = ACTIONS(729),
    [anon_sym_while] = ACTIONS(729),
    [anon_sym_break] = ACTIONS(729),
    [anon_sym_continue] = ACTIONS(729),
    [anon_sym_return] = ACTIONS(729),
    [anon_sym_yield] = ACTIONS(729),
    [anon_sym_synchronized] = ACTIONS(729),
    [anon_sym_throw] = ACTIONS(729),
    [anon_sym_try] = ACTIONS(729),
    [anon_sym_if] = ACTIONS(729),
    [anon_sym_else] = ACTIONS(729),
    [anon_sym_for] = ACTIONS(729),
    [anon_sym_AT] = ACTIONS(729),
    [anon_sym_open] = ACTIONS(729),
    [anon_sym_module] = ACTIONS(729),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_package] = ACTIONS(729),
    [anon_sym_import] = ACTIONS(729),
    [anon_sym_enum] = ACTIONS(729),
    [anon_sym_public] = ACTIONS(729),
    [anon_sym_protected] = ACTIONS(729),
    [anon_sym_private] = ACTIONS(729),
    [anon_sym_abstract] = ACTIONS(729),
    [anon_sym_final] = ACTIONS(729),
    [anon_sym_strictfp] = ACTIONS(729),
    [anon_sym_native] = ACTIONS(729),
    [anon_sym_transient] = ACTIONS(729),
    [anon_sym_volatile] = ACTIONS(729),
    [anon_sym_sealed] = ACTIONS(729),
    [anon_sym_non_DASHsealed] = ACTIONS(727),
    [anon_sym_ATinterface] = ACTIONS(727),
    [anon_sym_interface] = ACTIONS(729),
    [anon_sym_byte] = ACTIONS(729),
    [anon_sym_short] = ACTIONS(729),
    [anon_sym_int] = ACTIONS(729),
    [anon_sym_long] = ACTIONS(729),
    [anon_sym_char] = ACTIONS(729),
    [anon_sym_float] = ACTIONS(729),
    [anon_sym_double] = ACTIONS(729),
    [sym_boolean_type] = ACTIONS(729),
    [sym_void_type] = ACTIONS(729),
    [sym_this] = ACTIONS(729),
    [sym_super] = ACTIONS(729),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(731),
    [sym_identifier] = ACTIONS(733),
    [sym_decimal_integer_literal] = ACTIONS(733),
    [sym_hex_integer_literal] = ACTIONS(733),
    [sym_octal_integer_literal] = ACTIONS(731),
    [sym_binary_integer_literal] = ACTIONS(731),
    [sym_decimal_floating_point_literal] = ACTIONS(731),
    [sym_hex_floating_point_literal] = ACTIONS(733),
    [sym_true] = ACTIONS(733),
    [sym_false] = ACTIONS(733),
    [sym_character_literal] = ACTIONS(731),
    [sym_string_literal] = ACTIONS(733),
    [sym_text_block] = ACTIONS(731),
    [sym_null_literal] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(731),
    [anon_sym_PLUS] = ACTIONS(733),
    [anon_sym_DASH] = ACTIONS(733),
    [anon_sym_BANG] = ACTIONS(731),
    [anon_sym_TILDE] = ACTIONS(731),
    [anon_sym_PLUS_PLUS] = ACTIONS(731),
    [anon_sym_DASH_DASH] = ACTIONS(731),
    [anon_sym_new] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(733),
    [anon_sym_switch] = ACTIONS(733),
    [anon_sym_LBRACE] = ACTIONS(731),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_case] = ACTIONS(733),
    [anon_sym_default] = ACTIONS(733),
    [anon_sym_SEMI] = ACTIONS(731),
    [anon_sym_assert] = ACTIONS(733),
    [anon_sym_do] = ACTIONS(733),
    [anon_sym_while] = ACTIONS(733),
    [anon_sym_break] = ACTIONS(733),
    [anon_sym_continue] = ACTIONS(733),
    [anon_sym_return] = ACTIONS(733),
    [anon_sym_yield] = ACTIONS(733),
    [anon_sym_synchronized] = ACTIONS(733),
    [anon_sym_throw] = ACTIONS(733),
    [anon_sym_try] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(733),
    [anon_sym_else] = ACTIONS(733),
    [anon_sym_for] = ACTIONS(733),
    [anon_sym_AT] = ACTIONS(733),
    [anon_sym_open] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(733),
    [anon_sym_static] = ACTIONS(733),
    [anon_sym_package] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(733),
    [anon_sym_enum] = ACTIONS(733),
    [anon_sym_public] = ACTIONS(733),
    [anon_sym_protected] = ACTIONS(733),
    [anon_sym_private] = ACTIONS(733),
    [anon_sym_abstract] = ACTIONS(733),
    [anon_sym_final] = ACTIONS(733),
    [anon_sym_strictfp] = ACTIONS(733),
    [anon_sym_native] = ACTIONS(733),
    [anon_sym_transient] = ACTIONS(733),
    [anon_sym_volatile] = ACTIONS(733),
    [anon_sym_sealed] = ACTIONS(733),
    [anon_sym_non_DASHsealed] = ACTIONS(731),
    [anon_sym_ATinterface] = ACTIONS(731),
    [anon_sym_interface] = ACTIONS(733),
    [anon_sym_byte] = ACTIONS(733),
    [anon_sym_short] = ACTIONS(733),
    [anon_sym_int] = ACTIONS(733),
    [anon_sym_long] = ACTIONS(733),
    [anon_sym_char] = ACTIONS(733),
    [anon_sym_float] = ACTIONS(733),
    [anon_sym_double] = ACTIONS(733),
    [sym_boolean_type] = ACTIONS(733),
    [sym_void_type] = ACTIONS(733),
    [sym_this] = ACTIONS(733),
    [sym_super] = ACTIONS(733),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(735),
    [sym_identifier] = ACTIONS(737),
    [sym_decimal_integer_literal] = ACTIONS(737),
    [sym_hex_integer_literal] = ACTIONS(737),
    [sym_octal_integer_literal] = ACTIONS(735),
    [sym_binary_integer_literal] = ACTIONS(735),
    [sym_decimal_floating_point_literal] = ACTIONS(735),
    [sym_hex_floating_point_literal] = ACTIONS(737),
    [sym_true] = ACTIONS(737),
    [sym_false] = ACTIONS(737),
    [sym_character_literal] = ACTIONS(735),
    [sym_string_literal] = ACTIONS(737),
    [sym_text_block] = ACTIONS(735),
    [sym_null_literal] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_DASH] = ACTIONS(737),
    [anon_sym_BANG] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_PLUS_PLUS] = ACTIONS(735),
    [anon_sym_DASH_DASH] = ACTIONS(735),
    [anon_sym_new] = ACTIONS(737),
    [anon_sym_class] = ACTIONS(737),
    [anon_sym_switch] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(735),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_case] = ACTIONS(737),
    [anon_sym_default] = ACTIONS(737),
    [anon_sym_SEMI] = ACTIONS(735),
    [anon_sym_assert] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_break] = ACTIONS(737),
    [anon_sym_continue] = ACTIONS(737),
    [anon_sym_return] = ACTIONS(737),
    [anon_sym_yield] = ACTIONS(737),
    [anon_sym_synchronized] = ACTIONS(737),
    [anon_sym_throw] = ACTIONS(737),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(737),
    [anon_sym_AT] = ACTIONS(737),
    [anon_sym_open] = ACTIONS(737),
    [anon_sym_module] = ACTIONS(737),
    [anon_sym_static] = ACTIONS(737),
    [anon_sym_package] = ACTIONS(737),
    [anon_sym_import] = ACTIONS(737),
    [anon_sym_enum] = ACTIONS(737),
    [anon_sym_public] = ACTIONS(737),
    [anon_sym_protected] = ACTIONS(737),
    [anon_sym_private] = ACTIONS(737),
    [anon_sym_abstract] = ACTIONS(737),
    [anon_sym_final] = ACTIONS(737),
    [anon_sym_strictfp] = ACTIONS(737),
    [anon_sym_native] = ACTIONS(737),
    [anon_sym_transient] = ACTIONS(737),
    [anon_sym_volatile] = ACTIONS(737),
    [anon_sym_sealed] = ACTIONS(737),
    [anon_sym_non_DASHsealed] = ACTIONS(735),
    [anon_sym_ATinterface] = ACTIONS(735),
    [anon_sym_interface] = ACTIONS(737),
    [anon_sym_byte] = ACTIONS(737),
    [anon_sym_short] = ACTIONS(737),
    [anon_sym_int] = ACTIONS(737),
    [anon_sym_long] = ACTIONS(737),
    [anon_sym_char] = ACTIONS(737),
    [anon_sym_float] = ACTIONS(737),
    [anon_sym_double] = ACTIONS(737),
    [sym_boolean_type] = ACTIONS(737),
    [sym_void_type] = ACTIONS(737),
    [sym_this] = ACTIONS(737),
    [sym_super] = ACTIONS(737),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(739),
    [sym_identifier] = ACTIONS(741),
    [sym_decimal_integer_literal] = ACTIONS(741),
    [sym_hex_integer_literal] = ACTIONS(741),
    [sym_octal_integer_literal] = ACTIONS(739),
    [sym_binary_integer_literal] = ACTIONS(739),
    [sym_decimal_floating_point_literal] = ACTIONS(739),
    [sym_hex_floating_point_literal] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_character_literal] = ACTIONS(739),
    [sym_string_literal] = ACTIONS(741),
    [sym_text_block] = ACTIONS(739),
    [sym_null_literal] = ACTIONS(741),
    [anon_sym_LPAREN] = ACTIONS(739),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_DASH] = ACTIONS(741),
    [anon_sym_BANG] = ACTIONS(739),
    [anon_sym_TILDE] = ACTIONS(739),
    [anon_sym_PLUS_PLUS] = ACTIONS(739),
    [anon_sym_DASH_DASH] = ACTIONS(739),
    [anon_sym_new] = ACTIONS(741),
    [anon_sym_class] = ACTIONS(741),
    [anon_sym_switch] = ACTIONS(741),
    [anon_sym_LBRACE] = ACTIONS(739),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_case] = ACTIONS(741),
    [anon_sym_default] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_assert] = ACTIONS(741),
    [anon_sym_do] = ACTIONS(741),
    [anon_sym_while] = ACTIONS(741),
    [anon_sym_break] = ACTIONS(741),
    [anon_sym_continue] = ACTIONS(741),
    [anon_sym_return] = ACTIONS(741),
    [anon_sym_yield] = ACTIONS(741),
    [anon_sym_synchronized] = ACTIONS(741),
    [anon_sym_throw] = ACTIONS(741),
    [anon_sym_try] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(741),
    [anon_sym_else] = ACTIONS(741),
    [anon_sym_for] = ACTIONS(741),
    [anon_sym_AT] = ACTIONS(741),
    [anon_sym_open] = ACTIONS(741),
    [anon_sym_module] = ACTIONS(741),
    [anon_sym_static] = ACTIONS(741),
    [anon_sym_package] = ACTIONS(741),
    [anon_sym_import] = ACTIONS(741),
    [anon_sym_enum] = ACTIONS(741),
    [anon_sym_public] = ACTIONS(741),
    [anon_sym_protected] = ACTIONS(741),
    [anon_sym_private] = ACTIONS(741),
    [anon_sym_abstract] = ACTIONS(741),
    [anon_sym_final] = ACTIONS(741),
    [anon_sym_strictfp] = ACTIONS(741),
    [anon_sym_native] = ACTIONS(741),
    [anon_sym_transient] = ACTIONS(741),
    [anon_sym_volatile] = ACTIONS(741),
    [anon_sym_sealed] = ACTIONS(741),
    [anon_sym_non_DASHsealed] = ACTIONS(739),
    [anon_sym_ATinterface] = ACTIONS(739),
    [anon_sym_interface] = ACTIONS(741),
    [anon_sym_byte] = ACTIONS(741),
    [anon_sym_short] = ACTIONS(741),
    [anon_sym_int] = ACTIONS(741),
    [anon_sym_long] = ACTIONS(741),
    [anon_sym_char] = ACTIONS(741),
    [anon_sym_float] = ACTIONS(741),
    [anon_sym_double] = ACTIONS(741),
    [sym_boolean_type] = ACTIONS(741),
    [sym_void_type] = ACTIONS(741),
    [sym_this] = ACTIONS(741),
    [sym_super] = ACTIONS(741),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [177] = {
    [ts_builtin_sym_end] = ACTIONS(743),
    [sym_identifier] = ACTIONS(745),
    [sym_decimal_integer_literal] = ACTIONS(745),
    [sym_hex_integer_literal] = ACTIONS(745),
    [sym_octal_integer_literal] = ACTIONS(743),
    [sym_binary_integer_literal] = ACTIONS(743),
    [sym_decimal_floating_point_literal] = ACTIONS(743),
    [sym_hex_floating_point_literal] = ACTIONS(745),
    [sym_true] = ACTIONS(745),
    [sym_false] = ACTIONS(745),
    [sym_character_literal] = ACTIONS(743),
    [sym_string_literal] = ACTIONS(745),
    [sym_text_block] = ACTIONS(743),
    [sym_null_literal] = ACTIONS(745),
    [anon_sym_LPAREN] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(745),
    [anon_sym_BANG] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(743),
    [anon_sym_PLUS_PLUS] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(743),
    [anon_sym_new] = ACTIONS(745),
    [anon_sym_class] = ACTIONS(745),
    [anon_sym_switch] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_case] = ACTIONS(745),
    [anon_sym_default] = ACTIONS(745),
    [anon_sym_SEMI] = ACTIONS(743),
    [anon_sym_assert] = ACTIONS(745),
    [anon_sym_do] = ACTIONS(745),
    [anon_sym_while] = ACTIONS(745),
    [anon_sym_break] = ACTIONS(745),
    [anon_sym_continue] = ACTIONS(745),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_yield] = ACTIONS(745),
    [anon_sym_synchronized] = ACTIONS(745),
    [anon_sym_throw] = ACTIONS(745),
    [anon_sym_try] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(745),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_open] = ACTIONS(745),
    [anon_sym_module] = ACTIONS(745),
    [anon_sym_static] = ACTIONS(745),
    [anon_sym_package] = ACTIONS(745),
    [anon_sym_import] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_public] = ACTIONS(745),
    [anon_sym_protected] = ACTIONS(745),
    [anon_sym_private] = ACTIONS(745),
    [anon_sym_abstract] = ACTIONS(745),
    [anon_sym_final] = ACTIONS(745),
    [anon_sym_strictfp] = ACTIONS(745),
    [anon_sym_native] = ACTIONS(745),
    [anon_sym_transient] = ACTIONS(745),
    [anon_sym_volatile] = ACTIONS(745),
    [anon_sym_sealed] = ACTIONS(745),
    [anon_sym_non_DASHsealed] = ACTIONS(743),
    [anon_sym_ATinterface] = ACTIONS(743),
    [anon_sym_interface] = ACTIONS(745),
    [anon_sym_byte] = ACTIONS(745),
    [anon_sym_short] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_long] = ACTIONS(745),
    [anon_sym_char] = ACTIONS(745),
    [anon_sym_float] = ACTIONS(745),
    [anon_sym_double] = ACTIONS(745),
    [sym_boolean_type] = ACTIONS(745),
    [sym_void_type] = ACTIONS(745),
    [sym_this] = ACTIONS(745),
    [sym_super] = ACTIONS(745),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(268),
    [sym_identifier] = ACTIONS(270),
    [sym_decimal_integer_literal] = ACTIONS(270),
    [sym_hex_integer_literal] = ACTIONS(270),
    [sym_octal_integer_literal] = ACTIONS(268),
    [sym_binary_integer_literal] = ACTIONS(268),
    [sym_decimal_floating_point_literal] = ACTIONS(268),
    [sym_hex_floating_point_literal] = ACTIONS(270),
    [sym_true] = ACTIONS(270),
    [sym_false] = ACTIONS(270),
    [sym_character_literal] = ACTIONS(268),
    [sym_string_literal] = ACTIONS(270),
    [sym_text_block] = ACTIONS(268),
    [sym_null_literal] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(268),
    [anon_sym_PLUS] = ACTIONS(270),
    [anon_sym_DASH] = ACTIONS(270),
    [anon_sym_BANG] = ACTIONS(268),
    [anon_sym_TILDE] = ACTIONS(268),
    [anon_sym_PLUS_PLUS] = ACTIONS(268),
    [anon_sym_DASH_DASH] = ACTIONS(268),
    [anon_sym_new] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(270),
    [anon_sym_switch] = ACTIONS(270),
    [anon_sym_LBRACE] = ACTIONS(268),
    [anon_sym_RBRACE] = ACTIONS(268),
    [anon_sym_case] = ACTIONS(270),
    [anon_sym_default] = ACTIONS(270),
    [anon_sym_SEMI] = ACTIONS(268),
    [anon_sym_assert] = ACTIONS(270),
    [anon_sym_do] = ACTIONS(270),
    [anon_sym_while] = ACTIONS(270),
    [anon_sym_break] = ACTIONS(270),
    [anon_sym_continue] = ACTIONS(270),
    [anon_sym_return] = ACTIONS(270),
    [anon_sym_yield] = ACTIONS(270),
    [anon_sym_synchronized] = ACTIONS(270),
    [anon_sym_throw] = ACTIONS(270),
    [anon_sym_try] = ACTIONS(270),
    [anon_sym_if] = ACTIONS(270),
    [anon_sym_else] = ACTIONS(270),
    [anon_sym_for] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(270),
    [anon_sym_open] = ACTIONS(270),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_static] = ACTIONS(270),
    [anon_sym_package] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_enum] = ACTIONS(270),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_abstract] = ACTIONS(270),
    [anon_sym_final] = ACTIONS(270),
    [anon_sym_strictfp] = ACTIONS(270),
    [anon_sym_native] = ACTIONS(270),
    [anon_sym_transient] = ACTIONS(270),
    [anon_sym_volatile] = ACTIONS(270),
    [anon_sym_sealed] = ACTIONS(270),
    [anon_sym_non_DASHsealed] = ACTIONS(268),
    [anon_sym_ATinterface] = ACTIONS(268),
    [anon_sym_interface] = ACTIONS(270),
    [anon_sym_byte] = ACTIONS(270),
    [anon_sym_short] = ACTIONS(270),
    [anon_sym_int] = ACTIONS(270),
    [anon_sym_long] = ACTIONS(270),
    [anon_sym_char] = ACTIONS(270),
    [anon_sym_float] = ACTIONS(270),
    [anon_sym_double] = ACTIONS(270),
    [sym_boolean_type] = ACTIONS(270),
    [sym_void_type] = ACTIONS(270),
    [sym_this] = ACTIONS(270),
    [sym_super] = ACTIONS(270),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(747),
    [sym_identifier] = ACTIONS(749),
    [sym_decimal_integer_literal] = ACTIONS(749),
    [sym_hex_integer_literal] = ACTIONS(749),
    [sym_octal_integer_literal] = ACTIONS(747),
    [sym_binary_integer_literal] = ACTIONS(747),
    [sym_decimal_floating_point_literal] = ACTIONS(747),
    [sym_hex_floating_point_literal] = ACTIONS(749),
    [sym_true] = ACTIONS(749),
    [sym_false] = ACTIONS(749),
    [sym_character_literal] = ACTIONS(747),
    [sym_string_literal] = ACTIONS(749),
    [sym_text_block] = ACTIONS(747),
    [sym_null_literal] = ACTIONS(749),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_PLUS] = ACTIONS(749),
    [anon_sym_DASH] = ACTIONS(749),
    [anon_sym_BANG] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(747),
    [anon_sym_PLUS_PLUS] = ACTIONS(747),
    [anon_sym_DASH_DASH] = ACTIONS(747),
    [anon_sym_new] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(749),
    [anon_sym_switch] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym_case] = ACTIONS(749),
    [anon_sym_default] = ACTIONS(749),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_assert] = ACTIONS(749),
    [anon_sym_do] = ACTIONS(749),
    [anon_sym_while] = ACTIONS(749),
    [anon_sym_break] = ACTIONS(749),
    [anon_sym_continue] = ACTIONS(749),
    [anon_sym_return] = ACTIONS(749),
    [anon_sym_yield] = ACTIONS(749),
    [anon_sym_synchronized] = ACTIONS(749),
    [anon_sym_throw] = ACTIONS(749),
    [anon_sym_try] = ACTIONS(749),
    [anon_sym_if] = ACTIONS(749),
    [anon_sym_else] = ACTIONS(749),
    [anon_sym_for] = ACTIONS(749),
    [anon_sym_AT] = ACTIONS(749),
    [anon_sym_open] = ACTIONS(749),
    [anon_sym_module] = ACTIONS(749),
    [anon_sym_static] = ACTIONS(749),
    [anon_sym_package] = ACTIONS(749),
    [anon_sym_import] = ACTIONS(749),
    [anon_sym_enum] = ACTIONS(749),
    [anon_sym_public] = ACTIONS(749),
    [anon_sym_protected] = ACTIONS(749),
    [anon_sym_private] = ACTIONS(749),
    [anon_sym_abstract] = ACTIONS(749),
    [anon_sym_final] = ACTIONS(749),
    [anon_sym_strictfp] = ACTIONS(749),
    [anon_sym_native] = ACTIONS(749),
    [anon_sym_transient] = ACTIONS(749),
    [anon_sym_volatile] = ACTIONS(749),
    [anon_sym_sealed] = ACTIONS(749),
    [anon_sym_non_DASHsealed] = ACTIONS(747),
    [anon_sym_ATinterface] = ACTIONS(747),
    [anon_sym_interface] = ACTIONS(749),
    [anon_sym_byte] = ACTIONS(749),
    [anon_sym_short] = ACTIONS(749),
    [anon_sym_int] = ACTIONS(749),
    [anon_sym_long] = ACTIONS(749),
    [anon_sym_char] = ACTIONS(749),
    [anon_sym_float] = ACTIONS(749),
    [anon_sym_double] = ACTIONS(749),
    [sym_boolean_type] = ACTIONS(749),
    [sym_void_type] = ACTIONS(749),
    [sym_this] = ACTIONS(749),
    [sym_super] = ACTIONS(749),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(751),
    [sym_identifier] = ACTIONS(753),
    [sym_decimal_integer_literal] = ACTIONS(753),
    [sym_hex_integer_literal] = ACTIONS(753),
    [sym_octal_integer_literal] = ACTIONS(751),
    [sym_binary_integer_literal] = ACTIONS(751),
    [sym_decimal_floating_point_literal] = ACTIONS(751),
    [sym_hex_floating_point_literal] = ACTIONS(753),
    [sym_true] = ACTIONS(753),
    [sym_false] = ACTIONS(753),
    [sym_character_literal] = ACTIONS(751),
    [sym_string_literal] = ACTIONS(753),
    [sym_text_block] = ACTIONS(751),
    [sym_null_literal] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(751),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_DASH] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_TILDE] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(751),
    [anon_sym_DASH_DASH] = ACTIONS(751),
    [anon_sym_new] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(753),
    [anon_sym_switch] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_case] = ACTIONS(753),
    [anon_sym_default] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(751),
    [anon_sym_assert] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_while] = ACTIONS(753),
    [anon_sym_break] = ACTIONS(753),
    [anon_sym_continue] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(753),
    [anon_sym_synchronized] = ACTIONS(753),
    [anon_sym_throw] = ACTIONS(753),
    [anon_sym_try] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(753),
    [anon_sym_open] = ACTIONS(753),
    [anon_sym_module] = ACTIONS(753),
    [anon_sym_static] = ACTIONS(753),
    [anon_sym_package] = ACTIONS(753),
    [anon_sym_import] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(753),
    [anon_sym_public] = ACTIONS(753),
    [anon_sym_protected] = ACTIONS(753),
    [anon_sym_private] = ACTIONS(753),
    [anon_sym_abstract] = ACTIONS(753),
    [anon_sym_final] = ACTIONS(753),
    [anon_sym_strictfp] = ACTIONS(753),
    [anon_sym_native] = ACTIONS(753),
    [anon_sym_transient] = ACTIONS(753),
    [anon_sym_volatile] = ACTIONS(753),
    [anon_sym_sealed] = ACTIONS(753),
    [anon_sym_non_DASHsealed] = ACTIONS(751),
    [anon_sym_ATinterface] = ACTIONS(751),
    [anon_sym_interface] = ACTIONS(753),
    [anon_sym_byte] = ACTIONS(753),
    [anon_sym_short] = ACTIONS(753),
    [anon_sym_int] = ACTIONS(753),
    [anon_sym_long] = ACTIONS(753),
    [anon_sym_char] = ACTIONS(753),
    [anon_sym_float] = ACTIONS(753),
    [anon_sym_double] = ACTIONS(753),
    [sym_boolean_type] = ACTIONS(753),
    [sym_void_type] = ACTIONS(753),
    [sym_this] = ACTIONS(753),
    [sym_super] = ACTIONS(753),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(755),
    [sym_identifier] = ACTIONS(757),
    [sym_decimal_integer_literal] = ACTIONS(757),
    [sym_hex_integer_literal] = ACTIONS(757),
    [sym_octal_integer_literal] = ACTIONS(755),
    [sym_binary_integer_literal] = ACTIONS(755),
    [sym_decimal_floating_point_literal] = ACTIONS(755),
    [sym_hex_floating_point_literal] = ACTIONS(757),
    [sym_true] = ACTIONS(757),
    [sym_false] = ACTIONS(757),
    [sym_character_literal] = ACTIONS(755),
    [sym_string_literal] = ACTIONS(757),
    [sym_text_block] = ACTIONS(755),
    [sym_null_literal] = ACTIONS(757),
    [anon_sym_LPAREN] = ACTIONS(755),
    [anon_sym_PLUS] = ACTIONS(757),
    [anon_sym_DASH] = ACTIONS(757),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_new] = ACTIONS(757),
    [anon_sym_class] = ACTIONS(757),
    [anon_sym_switch] = ACTIONS(757),
    [anon_sym_LBRACE] = ACTIONS(755),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(757),
    [anon_sym_default] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(755),
    [anon_sym_assert] = ACTIONS(757),
    [anon_sym_do] = ACTIONS(757),
    [anon_sym_while] = ACTIONS(757),
    [anon_sym_break] = ACTIONS(757),
    [anon_sym_continue] = ACTIONS(757),
    [anon_sym_return] = ACTIONS(757),
    [anon_sym_yield] = ACTIONS(757),
    [anon_sym_synchronized] = ACTIONS(757),
    [anon_sym_throw] = ACTIONS(757),
    [anon_sym_try] = ACTIONS(757),
    [anon_sym_if] = ACTIONS(757),
    [anon_sym_else] = ACTIONS(757),
    [anon_sym_for] = ACTIONS(757),
    [anon_sym_AT] = ACTIONS(757),
    [anon_sym_open] = ACTIONS(757),
    [anon_sym_module] = ACTIONS(757),
    [anon_sym_static] = ACTIONS(757),
    [anon_sym_package] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(757),
    [anon_sym_enum] = ACTIONS(757),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_protected] = ACTIONS(757),
    [anon_sym_private] = ACTIONS(757),
    [anon_sym_abstract] = ACTIONS(757),
    [anon_sym_final] = ACTIONS(757),
    [anon_sym_strictfp] = ACTIONS(757),
    [anon_sym_native] = ACTIONS(757),
    [anon_sym_transient] = ACTIONS(757),
    [anon_sym_volatile] = ACTIONS(757),
    [anon_sym_sealed] = ACTIONS(757),
    [anon_sym_non_DASHsealed] = ACTIONS(755),
    [anon_sym_ATinterface] = ACTIONS(755),
    [anon_sym_interface] = ACTIONS(757),
    [anon_sym_byte] = ACTIONS(757),
    [anon_sym_short] = ACTIONS(757),
    [anon_sym_int] = ACTIONS(757),
    [anon_sym_long] = ACTIONS(757),
    [anon_sym_char] = ACTIONS(757),
    [anon_sym_float] = ACTIONS(757),
    [anon_sym_double] = ACTIONS(757),
    [sym_boolean_type] = ACTIONS(757),
    [sym_void_type] = ACTIONS(757),
    [sym_this] = ACTIONS(757),
    [sym_super] = ACTIONS(757),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [182] = {
    [ts_builtin_sym_end] = ACTIONS(759),
    [sym_identifier] = ACTIONS(761),
    [sym_decimal_integer_literal] = ACTIONS(761),
    [sym_hex_integer_literal] = ACTIONS(761),
    [sym_octal_integer_literal] = ACTIONS(759),
    [sym_binary_integer_literal] = ACTIONS(759),
    [sym_decimal_floating_point_literal] = ACTIONS(759),
    [sym_hex_floating_point_literal] = ACTIONS(761),
    [sym_true] = ACTIONS(761),
    [sym_false] = ACTIONS(761),
    [sym_character_literal] = ACTIONS(759),
    [sym_string_literal] = ACTIONS(761),
    [sym_text_block] = ACTIONS(759),
    [sym_null_literal] = ACTIONS(761),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_PLUS] = ACTIONS(761),
    [anon_sym_DASH] = ACTIONS(761),
    [anon_sym_BANG] = ACTIONS(759),
    [anon_sym_TILDE] = ACTIONS(759),
    [anon_sym_PLUS_PLUS] = ACTIONS(759),
    [anon_sym_DASH_DASH] = ACTIONS(759),
    [anon_sym_new] = ACTIONS(761),
    [anon_sym_class] = ACTIONS(761),
    [anon_sym_switch] = ACTIONS(761),
    [anon_sym_LBRACE] = ACTIONS(759),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_case] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(761),
    [anon_sym_SEMI] = ACTIONS(759),
    [anon_sym_assert] = ACTIONS(761),
    [anon_sym_do] = ACTIONS(761),
    [anon_sym_while] = ACTIONS(761),
    [anon_sym_break] = ACTIONS(761),
    [anon_sym_continue] = ACTIONS(761),
    [anon_sym_return] = ACTIONS(761),
    [anon_sym_yield] = ACTIONS(761),
    [anon_sym_synchronized] = ACTIONS(761),
    [anon_sym_throw] = ACTIONS(761),
    [anon_sym_try] = ACTIONS(761),
    [anon_sym_if] = ACTIONS(761),
    [anon_sym_else] = ACTIONS(761),
    [anon_sym_for] = ACTIONS(761),
    [anon_sym_AT] = ACTIONS(761),
    [anon_sym_open] = ACTIONS(761),
    [anon_sym_module] = ACTIONS(761),
    [anon_sym_static] = ACTIONS(761),
    [anon_sym_package] = ACTIONS(761),
    [anon_sym_import] = ACTIONS(761),
    [anon_sym_enum] = ACTIONS(761),
    [anon_sym_public] = ACTIONS(761),
    [anon_sym_protected] = ACTIONS(761),
    [anon_sym_private] = ACTIONS(761),
    [anon_sym_abstract] = ACTIONS(761),
    [anon_sym_final] = ACTIONS(761),
    [anon_sym_strictfp] = ACTIONS(761),
    [anon_sym_native] = ACTIONS(761),
    [anon_sym_transient] = ACTIONS(761),
    [anon_sym_volatile] = ACTIONS(761),
    [anon_sym_sealed] = ACTIONS(761),
    [anon_sym_non_DASHsealed] = ACTIONS(759),
    [anon_sym_ATinterface] = ACTIONS(759),
    [anon_sym_interface] = ACTIONS(761),
    [anon_sym_byte] = ACTIONS(761),
    [anon_sym_short] = ACTIONS(761),
    [anon_sym_int] = ACTIONS(761),
    [anon_sym_long] = ACTIONS(761),
    [anon_sym_char] = ACTIONS(761),
    [anon_sym_float] = ACTIONS(761),
    [anon_sym_double] = ACTIONS(761),
    [sym_boolean_type] = ACTIONS(761),
    [sym_void_type] = ACTIONS(761),
    [sym_this] = ACTIONS(761),
    [sym_super] = ACTIONS(761),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [183] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(457),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym_block] = STATE(443),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(763),
    [sym_identifier] = ACTIONS(765),
    [sym_decimal_integer_literal] = ACTIONS(765),
    [sym_hex_integer_literal] = ACTIONS(765),
    [sym_octal_integer_literal] = ACTIONS(763),
    [sym_binary_integer_literal] = ACTIONS(763),
    [sym_decimal_floating_point_literal] = ACTIONS(763),
    [sym_hex_floating_point_literal] = ACTIONS(765),
    [sym_true] = ACTIONS(765),
    [sym_false] = ACTIONS(765),
    [sym_character_literal] = ACTIONS(763),
    [sym_string_literal] = ACTIONS(765),
    [sym_text_block] = ACTIONS(763),
    [sym_null_literal] = ACTIONS(765),
    [anon_sym_LPAREN] = ACTIONS(763),
    [anon_sym_PLUS] = ACTIONS(765),
    [anon_sym_DASH] = ACTIONS(765),
    [anon_sym_BANG] = ACTIONS(763),
    [anon_sym_TILDE] = ACTIONS(763),
    [anon_sym_PLUS_PLUS] = ACTIONS(763),
    [anon_sym_DASH_DASH] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(765),
    [anon_sym_class] = ACTIONS(765),
    [anon_sym_switch] = ACTIONS(765),
    [anon_sym_LBRACE] = ACTIONS(763),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym_case] = ACTIONS(765),
    [anon_sym_default] = ACTIONS(765),
    [anon_sym_SEMI] = ACTIONS(763),
    [anon_sym_assert] = ACTIONS(765),
    [anon_sym_do] = ACTIONS(765),
    [anon_sym_while] = ACTIONS(765),
    [anon_sym_break] = ACTIONS(765),
    [anon_sym_continue] = ACTIONS(765),
    [anon_sym_return] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(765),
    [anon_sym_synchronized] = ACTIONS(765),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_try] = ACTIONS(765),
    [anon_sym_if] = ACTIONS(765),
    [anon_sym_else] = ACTIONS(765),
    [anon_sym_for] = ACTIONS(765),
    [anon_sym_AT] = ACTIONS(765),
    [anon_sym_open] = ACTIONS(765),
    [anon_sym_module] = ACTIONS(765),
    [anon_sym_static] = ACTIONS(765),
    [anon_sym_package] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(765),
    [anon_sym_enum] = ACTIONS(765),
    [anon_sym_public] = ACTIONS(765),
    [anon_sym_protected] = ACTIONS(765),
    [anon_sym_private] = ACTIONS(765),
    [anon_sym_abstract] = ACTIONS(765),
    [anon_sym_final] = ACTIONS(765),
    [anon_sym_strictfp] = ACTIONS(765),
    [anon_sym_native] = ACTIONS(765),
    [anon_sym_transient] = ACTIONS(765),
    [anon_sym_volatile] = ACTIONS(765),
    [anon_sym_sealed] = ACTIONS(765),
    [anon_sym_non_DASHsealed] = ACTIONS(763),
    [anon_sym_ATinterface] = ACTIONS(763),
    [anon_sym_interface] = ACTIONS(765),
    [anon_sym_byte] = ACTIONS(765),
    [anon_sym_short] = ACTIONS(765),
    [anon_sym_int] = ACTIONS(765),
    [anon_sym_long] = ACTIONS(765),
    [anon_sym_char] = ACTIONS(765),
    [anon_sym_float] = ACTIONS(765),
    [anon_sym_double] = ACTIONS(765),
    [sym_boolean_type] = ACTIONS(765),
    [sym_void_type] = ACTIONS(765),
    [sym_this] = ACTIONS(765),
    [sym_super] = ACTIONS(765),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(769),
    [sym_decimal_integer_literal] = ACTIONS(769),
    [sym_hex_integer_literal] = ACTIONS(769),
    [sym_octal_integer_literal] = ACTIONS(767),
    [sym_binary_integer_literal] = ACTIONS(767),
    [sym_decimal_floating_point_literal] = ACTIONS(767),
    [sym_hex_floating_point_literal] = ACTIONS(769),
    [sym_true] = ACTIONS(769),
    [sym_false] = ACTIONS(769),
    [sym_character_literal] = ACTIONS(767),
    [sym_string_literal] = ACTIONS(769),
    [sym_text_block] = ACTIONS(767),
    [sym_null_literal] = ACTIONS(769),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(769),
    [anon_sym_DASH] = ACTIONS(769),
    [anon_sym_BANG] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_PLUS_PLUS] = ACTIONS(767),
    [anon_sym_DASH_DASH] = ACTIONS(767),
    [anon_sym_new] = ACTIONS(769),
    [anon_sym_class] = ACTIONS(769),
    [anon_sym_switch] = ACTIONS(769),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_case] = ACTIONS(769),
    [anon_sym_default] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_assert] = ACTIONS(769),
    [anon_sym_do] = ACTIONS(769),
    [anon_sym_while] = ACTIONS(769),
    [anon_sym_break] = ACTIONS(769),
    [anon_sym_continue] = ACTIONS(769),
    [anon_sym_return] = ACTIONS(769),
    [anon_sym_yield] = ACTIONS(769),
    [anon_sym_synchronized] = ACTIONS(769),
    [anon_sym_throw] = ACTIONS(769),
    [anon_sym_try] = ACTIONS(769),
    [anon_sym_if] = ACTIONS(769),
    [anon_sym_else] = ACTIONS(769),
    [anon_sym_for] = ACTIONS(769),
    [anon_sym_AT] = ACTIONS(769),
    [anon_sym_open] = ACTIONS(769),
    [anon_sym_module] = ACTIONS(769),
    [anon_sym_static] = ACTIONS(769),
    [anon_sym_package] = ACTIONS(769),
    [anon_sym_import] = ACTIONS(769),
    [anon_sym_enum] = ACTIONS(769),
    [anon_sym_public] = ACTIONS(769),
    [anon_sym_protected] = ACTIONS(769),
    [anon_sym_private] = ACTIONS(769),
    [anon_sym_abstract] = ACTIONS(769),
    [anon_sym_final] = ACTIONS(769),
    [anon_sym_strictfp] = ACTIONS(769),
    [anon_sym_native] = ACTIONS(769),
    [anon_sym_transient] = ACTIONS(769),
    [anon_sym_volatile] = ACTIONS(769),
    [anon_sym_sealed] = ACTIONS(769),
    [anon_sym_non_DASHsealed] = ACTIONS(767),
    [anon_sym_ATinterface] = ACTIONS(767),
    [anon_sym_interface] = ACTIONS(769),
    [anon_sym_byte] = ACTIONS(769),
    [anon_sym_short] = ACTIONS(769),
    [anon_sym_int] = ACTIONS(769),
    [anon_sym_long] = ACTIONS(769),
    [anon_sym_char] = ACTIONS(769),
    [anon_sym_float] = ACTIONS(769),
    [anon_sym_double] = ACTIONS(769),
    [sym_boolean_type] = ACTIONS(769),
    [sym_void_type] = ACTIONS(769),
    [sym_this] = ACTIONS(769),
    [sym_super] = ACTIONS(769),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(771),
    [sym_identifier] = ACTIONS(773),
    [sym_decimal_integer_literal] = ACTIONS(773),
    [sym_hex_integer_literal] = ACTIONS(773),
    [sym_octal_integer_literal] = ACTIONS(771),
    [sym_binary_integer_literal] = ACTIONS(771),
    [sym_decimal_floating_point_literal] = ACTIONS(771),
    [sym_hex_floating_point_literal] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_character_literal] = ACTIONS(771),
    [sym_string_literal] = ACTIONS(773),
    [sym_text_block] = ACTIONS(771),
    [sym_null_literal] = ACTIONS(773),
    [anon_sym_LPAREN] = ACTIONS(771),
    [anon_sym_PLUS] = ACTIONS(773),
    [anon_sym_DASH] = ACTIONS(773),
    [anon_sym_BANG] = ACTIONS(771),
    [anon_sym_TILDE] = ACTIONS(771),
    [anon_sym_PLUS_PLUS] = ACTIONS(771),
    [anon_sym_DASH_DASH] = ACTIONS(771),
    [anon_sym_new] = ACTIONS(773),
    [anon_sym_class] = ACTIONS(773),
    [anon_sym_switch] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(771),
    [anon_sym_RBRACE] = ACTIONS(771),
    [anon_sym_case] = ACTIONS(773),
    [anon_sym_default] = ACTIONS(773),
    [anon_sym_SEMI] = ACTIONS(771),
    [anon_sym_assert] = ACTIONS(773),
    [anon_sym_do] = ACTIONS(773),
    [anon_sym_while] = ACTIONS(773),
    [anon_sym_break] = ACTIONS(773),
    [anon_sym_continue] = ACTIONS(773),
    [anon_sym_return] = ACTIONS(773),
    [anon_sym_yield] = ACTIONS(773),
    [anon_sym_synchronized] = ACTIONS(773),
    [anon_sym_throw] = ACTIONS(773),
    [anon_sym_try] = ACTIONS(773),
    [anon_sym_if] = ACTIONS(773),
    [anon_sym_else] = ACTIONS(773),
    [anon_sym_for] = ACTIONS(773),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_open] = ACTIONS(773),
    [anon_sym_module] = ACTIONS(773),
    [anon_sym_static] = ACTIONS(773),
    [anon_sym_package] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(773),
    [anon_sym_enum] = ACTIONS(773),
    [anon_sym_public] = ACTIONS(773),
    [anon_sym_protected] = ACTIONS(773),
    [anon_sym_private] = ACTIONS(773),
    [anon_sym_abstract] = ACTIONS(773),
    [anon_sym_final] = ACTIONS(773),
    [anon_sym_strictfp] = ACTIONS(773),
    [anon_sym_native] = ACTIONS(773),
    [anon_sym_transient] = ACTIONS(773),
    [anon_sym_volatile] = ACTIONS(773),
    [anon_sym_sealed] = ACTIONS(773),
    [anon_sym_non_DASHsealed] = ACTIONS(771),
    [anon_sym_ATinterface] = ACTIONS(771),
    [anon_sym_interface] = ACTIONS(773),
    [anon_sym_byte] = ACTIONS(773),
    [anon_sym_short] = ACTIONS(773),
    [anon_sym_int] = ACTIONS(773),
    [anon_sym_long] = ACTIONS(773),
    [anon_sym_char] = ACTIONS(773),
    [anon_sym_float] = ACTIONS(773),
    [anon_sym_double] = ACTIONS(773),
    [sym_boolean_type] = ACTIONS(773),
    [sym_void_type] = ACTIONS(773),
    [sym_this] = ACTIONS(773),
    [sym_super] = ACTIONS(773),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [187] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(496),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym_array_initializer] = STATE(909),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(775),
    [sym_identifier] = ACTIONS(777),
    [sym_decimal_integer_literal] = ACTIONS(777),
    [sym_hex_integer_literal] = ACTIONS(777),
    [sym_octal_integer_literal] = ACTIONS(775),
    [sym_binary_integer_literal] = ACTIONS(775),
    [sym_decimal_floating_point_literal] = ACTIONS(775),
    [sym_hex_floating_point_literal] = ACTIONS(777),
    [sym_true] = ACTIONS(777),
    [sym_false] = ACTIONS(777),
    [sym_character_literal] = ACTIONS(775),
    [sym_string_literal] = ACTIONS(777),
    [sym_text_block] = ACTIONS(775),
    [sym_null_literal] = ACTIONS(777),
    [anon_sym_LPAREN] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(777),
    [anon_sym_DASH] = ACTIONS(777),
    [anon_sym_BANG] = ACTIONS(775),
    [anon_sym_TILDE] = ACTIONS(775),
    [anon_sym_PLUS_PLUS] = ACTIONS(775),
    [anon_sym_DASH_DASH] = ACTIONS(775),
    [anon_sym_new] = ACTIONS(777),
    [anon_sym_class] = ACTIONS(777),
    [anon_sym_switch] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(777),
    [anon_sym_default] = ACTIONS(777),
    [anon_sym_SEMI] = ACTIONS(775),
    [anon_sym_assert] = ACTIONS(777),
    [anon_sym_do] = ACTIONS(777),
    [anon_sym_while] = ACTIONS(777),
    [anon_sym_break] = ACTIONS(777),
    [anon_sym_continue] = ACTIONS(777),
    [anon_sym_return] = ACTIONS(777),
    [anon_sym_yield] = ACTIONS(777),
    [anon_sym_synchronized] = ACTIONS(777),
    [anon_sym_throw] = ACTIONS(777),
    [anon_sym_try] = ACTIONS(777),
    [anon_sym_if] = ACTIONS(777),
    [anon_sym_else] = ACTIONS(777),
    [anon_sym_for] = ACTIONS(777),
    [anon_sym_AT] = ACTIONS(777),
    [anon_sym_open] = ACTIONS(777),
    [anon_sym_module] = ACTIONS(777),
    [anon_sym_static] = ACTIONS(777),
    [anon_sym_package] = ACTIONS(777),
    [anon_sym_import] = ACTIONS(777),
    [anon_sym_enum] = ACTIONS(777),
    [anon_sym_public] = ACTIONS(777),
    [anon_sym_protected] = ACTIONS(777),
    [anon_sym_private] = ACTIONS(777),
    [anon_sym_abstract] = ACTIONS(777),
    [anon_sym_final] = ACTIONS(777),
    [anon_sym_strictfp] = ACTIONS(777),
    [anon_sym_native] = ACTIONS(777),
    [anon_sym_transient] = ACTIONS(777),
    [anon_sym_volatile] = ACTIONS(777),
    [anon_sym_sealed] = ACTIONS(777),
    [anon_sym_non_DASHsealed] = ACTIONS(775),
    [anon_sym_ATinterface] = ACTIONS(775),
    [anon_sym_interface] = ACTIONS(777),
    [anon_sym_byte] = ACTIONS(777),
    [anon_sym_short] = ACTIONS(777),
    [anon_sym_int] = ACTIONS(777),
    [anon_sym_long] = ACTIONS(777),
    [anon_sym_char] = ACTIONS(777),
    [anon_sym_float] = ACTIONS(777),
    [anon_sym_double] = ACTIONS(777),
    [sym_boolean_type] = ACTIONS(777),
    [sym_void_type] = ACTIONS(777),
    [sym_this] = ACTIONS(777),
    [sym_super] = ACTIONS(777),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(779),
    [sym_identifier] = ACTIONS(781),
    [sym_decimal_integer_literal] = ACTIONS(781),
    [sym_hex_integer_literal] = ACTIONS(781),
    [sym_octal_integer_literal] = ACTIONS(779),
    [sym_binary_integer_literal] = ACTIONS(779),
    [sym_decimal_floating_point_literal] = ACTIONS(779),
    [sym_hex_floating_point_literal] = ACTIONS(781),
    [sym_true] = ACTIONS(781),
    [sym_false] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(779),
    [sym_string_literal] = ACTIONS(781),
    [sym_text_block] = ACTIONS(779),
    [sym_null_literal] = ACTIONS(781),
    [anon_sym_LPAREN] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_BANG] = ACTIONS(779),
    [anon_sym_TILDE] = ACTIONS(779),
    [anon_sym_PLUS_PLUS] = ACTIONS(779),
    [anon_sym_DASH_DASH] = ACTIONS(779),
    [anon_sym_new] = ACTIONS(781),
    [anon_sym_class] = ACTIONS(781),
    [anon_sym_switch] = ACTIONS(781),
    [anon_sym_LBRACE] = ACTIONS(779),
    [anon_sym_RBRACE] = ACTIONS(779),
    [anon_sym_case] = ACTIONS(781),
    [anon_sym_default] = ACTIONS(781),
    [anon_sym_SEMI] = ACTIONS(779),
    [anon_sym_assert] = ACTIONS(781),
    [anon_sym_do] = ACTIONS(781),
    [anon_sym_while] = ACTIONS(781),
    [anon_sym_break] = ACTIONS(781),
    [anon_sym_continue] = ACTIONS(781),
    [anon_sym_return] = ACTIONS(781),
    [anon_sym_yield] = ACTIONS(781),
    [anon_sym_synchronized] = ACTIONS(781),
    [anon_sym_throw] = ACTIONS(781),
    [anon_sym_try] = ACTIONS(781),
    [anon_sym_if] = ACTIONS(781),
    [anon_sym_else] = ACTIONS(781),
    [anon_sym_for] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(781),
    [anon_sym_open] = ACTIONS(781),
    [anon_sym_module] = ACTIONS(781),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_package] = ACTIONS(781),
    [anon_sym_import] = ACTIONS(781),
    [anon_sym_enum] = ACTIONS(781),
    [anon_sym_public] = ACTIONS(781),
    [anon_sym_protected] = ACTIONS(781),
    [anon_sym_private] = ACTIONS(781),
    [anon_sym_abstract] = ACTIONS(781),
    [anon_sym_final] = ACTIONS(781),
    [anon_sym_strictfp] = ACTIONS(781),
    [anon_sym_native] = ACTIONS(781),
    [anon_sym_transient] = ACTIONS(781),
    [anon_sym_volatile] = ACTIONS(781),
    [anon_sym_sealed] = ACTIONS(781),
    [anon_sym_non_DASHsealed] = ACTIONS(779),
    [anon_sym_ATinterface] = ACTIONS(779),
    [anon_sym_interface] = ACTIONS(781),
    [anon_sym_byte] = ACTIONS(781),
    [anon_sym_short] = ACTIONS(781),
    [anon_sym_int] = ACTIONS(781),
    [anon_sym_long] = ACTIONS(781),
    [anon_sym_char] = ACTIONS(781),
    [anon_sym_float] = ACTIONS(781),
    [anon_sym_double] = ACTIONS(781),
    [sym_boolean_type] = ACTIONS(781),
    [sym_void_type] = ACTIONS(781),
    [sym_this] = ACTIONS(781),
    [sym_super] = ACTIONS(781),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(783),
    [sym_identifier] = ACTIONS(785),
    [sym_decimal_integer_literal] = ACTIONS(785),
    [sym_hex_integer_literal] = ACTIONS(785),
    [sym_octal_integer_literal] = ACTIONS(783),
    [sym_binary_integer_literal] = ACTIONS(783),
    [sym_decimal_floating_point_literal] = ACTIONS(783),
    [sym_hex_floating_point_literal] = ACTIONS(785),
    [sym_true] = ACTIONS(785),
    [sym_false] = ACTIONS(785),
    [sym_character_literal] = ACTIONS(783),
    [sym_string_literal] = ACTIONS(785),
    [sym_text_block] = ACTIONS(783),
    [sym_null_literal] = ACTIONS(785),
    [anon_sym_LPAREN] = ACTIONS(783),
    [anon_sym_PLUS] = ACTIONS(785),
    [anon_sym_DASH] = ACTIONS(785),
    [anon_sym_BANG] = ACTIONS(783),
    [anon_sym_TILDE] = ACTIONS(783),
    [anon_sym_PLUS_PLUS] = ACTIONS(783),
    [anon_sym_DASH_DASH] = ACTIONS(783),
    [anon_sym_new] = ACTIONS(785),
    [anon_sym_class] = ACTIONS(785),
    [anon_sym_switch] = ACTIONS(785),
    [anon_sym_LBRACE] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym_case] = ACTIONS(785),
    [anon_sym_default] = ACTIONS(785),
    [anon_sym_SEMI] = ACTIONS(783),
    [anon_sym_assert] = ACTIONS(785),
    [anon_sym_do] = ACTIONS(785),
    [anon_sym_while] = ACTIONS(785),
    [anon_sym_break] = ACTIONS(785),
    [anon_sym_continue] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(785),
    [anon_sym_yield] = ACTIONS(785),
    [anon_sym_synchronized] = ACTIONS(785),
    [anon_sym_throw] = ACTIONS(785),
    [anon_sym_try] = ACTIONS(785),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_else] = ACTIONS(785),
    [anon_sym_for] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(785),
    [anon_sym_open] = ACTIONS(785),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_static] = ACTIONS(785),
    [anon_sym_package] = ACTIONS(785),
    [anon_sym_import] = ACTIONS(785),
    [anon_sym_enum] = ACTIONS(785),
    [anon_sym_public] = ACTIONS(785),
    [anon_sym_protected] = ACTIONS(785),
    [anon_sym_private] = ACTIONS(785),
    [anon_sym_abstract] = ACTIONS(785),
    [anon_sym_final] = ACTIONS(785),
    [anon_sym_strictfp] = ACTIONS(785),
    [anon_sym_native] = ACTIONS(785),
    [anon_sym_transient] = ACTIONS(785),
    [anon_sym_volatile] = ACTIONS(785),
    [anon_sym_sealed] = ACTIONS(785),
    [anon_sym_non_DASHsealed] = ACTIONS(783),
    [anon_sym_ATinterface] = ACTIONS(783),
    [anon_sym_interface] = ACTIONS(785),
    [anon_sym_byte] = ACTIONS(785),
    [anon_sym_short] = ACTIONS(785),
    [anon_sym_int] = ACTIONS(785),
    [anon_sym_long] = ACTIONS(785),
    [anon_sym_char] = ACTIONS(785),
    [anon_sym_float] = ACTIONS(785),
    [anon_sym_double] = ACTIONS(785),
    [sym_boolean_type] = ACTIONS(785),
    [sym_void_type] = ACTIONS(785),
    [sym_this] = ACTIONS(785),
    [sym_super] = ACTIONS(785),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(787),
    [sym_identifier] = ACTIONS(789),
    [sym_decimal_integer_literal] = ACTIONS(789),
    [sym_hex_integer_literal] = ACTIONS(789),
    [sym_octal_integer_literal] = ACTIONS(787),
    [sym_binary_integer_literal] = ACTIONS(787),
    [sym_decimal_floating_point_literal] = ACTIONS(787),
    [sym_hex_floating_point_literal] = ACTIONS(789),
    [sym_true] = ACTIONS(789),
    [sym_false] = ACTIONS(789),
    [sym_character_literal] = ACTIONS(787),
    [sym_string_literal] = ACTIONS(789),
    [sym_text_block] = ACTIONS(787),
    [sym_null_literal] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(787),
    [anon_sym_PLUS] = ACTIONS(789),
    [anon_sym_DASH] = ACTIONS(789),
    [anon_sym_BANG] = ACTIONS(787),
    [anon_sym_TILDE] = ACTIONS(787),
    [anon_sym_PLUS_PLUS] = ACTIONS(787),
    [anon_sym_DASH_DASH] = ACTIONS(787),
    [anon_sym_new] = ACTIONS(789),
    [anon_sym_class] = ACTIONS(789),
    [anon_sym_switch] = ACTIONS(789),
    [anon_sym_LBRACE] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym_case] = ACTIONS(789),
    [anon_sym_default] = ACTIONS(789),
    [anon_sym_SEMI] = ACTIONS(787),
    [anon_sym_assert] = ACTIONS(789),
    [anon_sym_do] = ACTIONS(789),
    [anon_sym_while] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(789),
    [anon_sym_continue] = ACTIONS(789),
    [anon_sym_return] = ACTIONS(789),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_synchronized] = ACTIONS(789),
    [anon_sym_throw] = ACTIONS(789),
    [anon_sym_try] = ACTIONS(789),
    [anon_sym_if] = ACTIONS(789),
    [anon_sym_else] = ACTIONS(789),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(789),
    [anon_sym_open] = ACTIONS(789),
    [anon_sym_module] = ACTIONS(789),
    [anon_sym_static] = ACTIONS(789),
    [anon_sym_package] = ACTIONS(789),
    [anon_sym_import] = ACTIONS(789),
    [anon_sym_enum] = ACTIONS(789),
    [anon_sym_public] = ACTIONS(789),
    [anon_sym_protected] = ACTIONS(789),
    [anon_sym_private] = ACTIONS(789),
    [anon_sym_abstract] = ACTIONS(789),
    [anon_sym_final] = ACTIONS(789),
    [anon_sym_strictfp] = ACTIONS(789),
    [anon_sym_native] = ACTIONS(789),
    [anon_sym_transient] = ACTIONS(789),
    [anon_sym_volatile] = ACTIONS(789),
    [anon_sym_sealed] = ACTIONS(789),
    [anon_sym_non_DASHsealed] = ACTIONS(787),
    [anon_sym_ATinterface] = ACTIONS(787),
    [anon_sym_interface] = ACTIONS(789),
    [anon_sym_byte] = ACTIONS(789),
    [anon_sym_short] = ACTIONS(789),
    [anon_sym_int] = ACTIONS(789),
    [anon_sym_long] = ACTIONS(789),
    [anon_sym_char] = ACTIONS(789),
    [anon_sym_float] = ACTIONS(789),
    [anon_sym_double] = ACTIONS(789),
    [sym_boolean_type] = ACTIONS(789),
    [sym_void_type] = ACTIONS(789),
    [sym_this] = ACTIONS(789),
    [sym_super] = ACTIONS(789),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(791),
    [sym_identifier] = ACTIONS(793),
    [sym_decimal_integer_literal] = ACTIONS(793),
    [sym_hex_integer_literal] = ACTIONS(793),
    [sym_octal_integer_literal] = ACTIONS(791),
    [sym_binary_integer_literal] = ACTIONS(791),
    [sym_decimal_floating_point_literal] = ACTIONS(791),
    [sym_hex_floating_point_literal] = ACTIONS(793),
    [sym_true] = ACTIONS(793),
    [sym_false] = ACTIONS(793),
    [sym_character_literal] = ACTIONS(791),
    [sym_string_literal] = ACTIONS(793),
    [sym_text_block] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(793),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_PLUS] = ACTIONS(793),
    [anon_sym_DASH] = ACTIONS(793),
    [anon_sym_BANG] = ACTIONS(791),
    [anon_sym_TILDE] = ACTIONS(791),
    [anon_sym_PLUS_PLUS] = ACTIONS(791),
    [anon_sym_DASH_DASH] = ACTIONS(791),
    [anon_sym_new] = ACTIONS(793),
    [anon_sym_class] = ACTIONS(793),
    [anon_sym_switch] = ACTIONS(793),
    [anon_sym_LBRACE] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym_case] = ACTIONS(793),
    [anon_sym_default] = ACTIONS(793),
    [anon_sym_SEMI] = ACTIONS(791),
    [anon_sym_assert] = ACTIONS(793),
    [anon_sym_do] = ACTIONS(793),
    [anon_sym_while] = ACTIONS(793),
    [anon_sym_break] = ACTIONS(793),
    [anon_sym_continue] = ACTIONS(793),
    [anon_sym_return] = ACTIONS(793),
    [anon_sym_yield] = ACTIONS(793),
    [anon_sym_synchronized] = ACTIONS(793),
    [anon_sym_throw] = ACTIONS(793),
    [anon_sym_try] = ACTIONS(793),
    [anon_sym_if] = ACTIONS(793),
    [anon_sym_else] = ACTIONS(793),
    [anon_sym_for] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(793),
    [anon_sym_open] = ACTIONS(793),
    [anon_sym_module] = ACTIONS(793),
    [anon_sym_static] = ACTIONS(793),
    [anon_sym_package] = ACTIONS(793),
    [anon_sym_import] = ACTIONS(793),
    [anon_sym_enum] = ACTIONS(793),
    [anon_sym_public] = ACTIONS(793),
    [anon_sym_protected] = ACTIONS(793),
    [anon_sym_private] = ACTIONS(793),
    [anon_sym_abstract] = ACTIONS(793),
    [anon_sym_final] = ACTIONS(793),
    [anon_sym_strictfp] = ACTIONS(793),
    [anon_sym_native] = ACTIONS(793),
    [anon_sym_transient] = ACTIONS(793),
    [anon_sym_volatile] = ACTIONS(793),
    [anon_sym_sealed] = ACTIONS(793),
    [anon_sym_non_DASHsealed] = ACTIONS(791),
    [anon_sym_ATinterface] = ACTIONS(791),
    [anon_sym_interface] = ACTIONS(793),
    [anon_sym_byte] = ACTIONS(793),
    [anon_sym_short] = ACTIONS(793),
    [anon_sym_int] = ACTIONS(793),
    [anon_sym_long] = ACTIONS(793),
    [anon_sym_char] = ACTIONS(793),
    [anon_sym_float] = ACTIONS(793),
    [anon_sym_double] = ACTIONS(793),
    [sym_boolean_type] = ACTIONS(793),
    [sym_void_type] = ACTIONS(793),
    [sym_this] = ACTIONS(793),
    [sym_super] = ACTIONS(793),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [193] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(484),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym_block] = STATE(443),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_LBRACE] = ACTIONS(27),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [194] = {
    [ts_builtin_sym_end] = ACTIONS(807),
    [sym_identifier] = ACTIONS(809),
    [sym_decimal_integer_literal] = ACTIONS(809),
    [sym_hex_integer_literal] = ACTIONS(809),
    [sym_octal_integer_literal] = ACTIONS(807),
    [sym_binary_integer_literal] = ACTIONS(807),
    [sym_decimal_floating_point_literal] = ACTIONS(807),
    [sym_hex_floating_point_literal] = ACTIONS(809),
    [sym_true] = ACTIONS(809),
    [sym_false] = ACTIONS(809),
    [sym_character_literal] = ACTIONS(807),
    [sym_string_literal] = ACTIONS(809),
    [sym_text_block] = ACTIONS(807),
    [sym_null_literal] = ACTIONS(809),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(807),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(809),
    [anon_sym_switch] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_case] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(809),
    [anon_sym_SEMI] = ACTIONS(807),
    [anon_sym_assert] = ACTIONS(809),
    [anon_sym_do] = ACTIONS(809),
    [anon_sym_while] = ACTIONS(809),
    [anon_sym_break] = ACTIONS(809),
    [anon_sym_continue] = ACTIONS(809),
    [anon_sym_return] = ACTIONS(809),
    [anon_sym_yield] = ACTIONS(809),
    [anon_sym_synchronized] = ACTIONS(809),
    [anon_sym_throw] = ACTIONS(809),
    [anon_sym_try] = ACTIONS(809),
    [anon_sym_if] = ACTIONS(809),
    [anon_sym_else] = ACTIONS(809),
    [anon_sym_for] = ACTIONS(809),
    [anon_sym_AT] = ACTIONS(809),
    [anon_sym_open] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_static] = ACTIONS(809),
    [anon_sym_package] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(809),
    [anon_sym_enum] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_abstract] = ACTIONS(809),
    [anon_sym_final] = ACTIONS(809),
    [anon_sym_strictfp] = ACTIONS(809),
    [anon_sym_native] = ACTIONS(809),
    [anon_sym_transient] = ACTIONS(809),
    [anon_sym_volatile] = ACTIONS(809),
    [anon_sym_sealed] = ACTIONS(809),
    [anon_sym_non_DASHsealed] = ACTIONS(807),
    [anon_sym_ATinterface] = ACTIONS(807),
    [anon_sym_interface] = ACTIONS(809),
    [anon_sym_byte] = ACTIONS(809),
    [anon_sym_short] = ACTIONS(809),
    [anon_sym_int] = ACTIONS(809),
    [anon_sym_long] = ACTIONS(809),
    [anon_sym_char] = ACTIONS(809),
    [anon_sym_float] = ACTIONS(809),
    [anon_sym_double] = ACTIONS(809),
    [sym_boolean_type] = ACTIONS(809),
    [sym_void_type] = ACTIONS(809),
    [sym_this] = ACTIONS(809),
    [sym_super] = ACTIONS(809),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [195] = {
    [ts_builtin_sym_end] = ACTIONS(811),
    [sym_identifier] = ACTIONS(813),
    [sym_decimal_integer_literal] = ACTIONS(813),
    [sym_hex_integer_literal] = ACTIONS(813),
    [sym_octal_integer_literal] = ACTIONS(811),
    [sym_binary_integer_literal] = ACTIONS(811),
    [sym_decimal_floating_point_literal] = ACTIONS(811),
    [sym_hex_floating_point_literal] = ACTIONS(813),
    [sym_true] = ACTIONS(813),
    [sym_false] = ACTIONS(813),
    [sym_character_literal] = ACTIONS(811),
    [sym_string_literal] = ACTIONS(813),
    [sym_text_block] = ACTIONS(811),
    [sym_null_literal] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(811),
    [anon_sym_PLUS] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(811),
    [anon_sym_PLUS_PLUS] = ACTIONS(811),
    [anon_sym_DASH_DASH] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_class] = ACTIONS(813),
    [anon_sym_switch] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_case] = ACTIONS(813),
    [anon_sym_default] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_assert] = ACTIONS(813),
    [anon_sym_do] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(813),
    [anon_sym_break] = ACTIONS(813),
    [anon_sym_continue] = ACTIONS(813),
    [anon_sym_return] = ACTIONS(813),
    [anon_sym_yield] = ACTIONS(813),
    [anon_sym_synchronized] = ACTIONS(813),
    [anon_sym_throw] = ACTIONS(813),
    [anon_sym_try] = ACTIONS(813),
    [anon_sym_if] = ACTIONS(813),
    [anon_sym_else] = ACTIONS(813),
    [anon_sym_for] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(813),
    [anon_sym_open] = ACTIONS(813),
    [anon_sym_module] = ACTIONS(813),
    [anon_sym_static] = ACTIONS(813),
    [anon_sym_package] = ACTIONS(813),
    [anon_sym_import] = ACTIONS(813),
    [anon_sym_enum] = ACTIONS(813),
    [anon_sym_public] = ACTIONS(813),
    [anon_sym_protected] = ACTIONS(813),
    [anon_sym_private] = ACTIONS(813),
    [anon_sym_abstract] = ACTIONS(813),
    [anon_sym_final] = ACTIONS(813),
    [anon_sym_strictfp] = ACTIONS(813),
    [anon_sym_native] = ACTIONS(813),
    [anon_sym_transient] = ACTIONS(813),
    [anon_sym_volatile] = ACTIONS(813),
    [anon_sym_sealed] = ACTIONS(813),
    [anon_sym_non_DASHsealed] = ACTIONS(811),
    [anon_sym_ATinterface] = ACTIONS(811),
    [anon_sym_interface] = ACTIONS(813),
    [anon_sym_byte] = ACTIONS(813),
    [anon_sym_short] = ACTIONS(813),
    [anon_sym_int] = ACTIONS(813),
    [anon_sym_long] = ACTIONS(813),
    [anon_sym_char] = ACTIONS(813),
    [anon_sym_float] = ACTIONS(813),
    [anon_sym_double] = ACTIONS(813),
    [sym_boolean_type] = ACTIONS(813),
    [sym_void_type] = ACTIONS(813),
    [sym_this] = ACTIONS(813),
    [sym_super] = ACTIONS(813),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [196] = {
    [ts_builtin_sym_end] = ACTIONS(815),
    [sym_identifier] = ACTIONS(817),
    [sym_decimal_integer_literal] = ACTIONS(817),
    [sym_hex_integer_literal] = ACTIONS(817),
    [sym_octal_integer_literal] = ACTIONS(815),
    [sym_binary_integer_literal] = ACTIONS(815),
    [sym_decimal_floating_point_literal] = ACTIONS(815),
    [sym_hex_floating_point_literal] = ACTIONS(817),
    [sym_true] = ACTIONS(817),
    [sym_false] = ACTIONS(817),
    [sym_character_literal] = ACTIONS(815),
    [sym_string_literal] = ACTIONS(817),
    [sym_text_block] = ACTIONS(815),
    [sym_null_literal] = ACTIONS(817),
    [anon_sym_LPAREN] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(817),
    [anon_sym_DASH] = ACTIONS(817),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_TILDE] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(817),
    [anon_sym_class] = ACTIONS(817),
    [anon_sym_switch] = ACTIONS(817),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(817),
    [anon_sym_default] = ACTIONS(817),
    [anon_sym_SEMI] = ACTIONS(815),
    [anon_sym_assert] = ACTIONS(817),
    [anon_sym_do] = ACTIONS(817),
    [anon_sym_while] = ACTIONS(817),
    [anon_sym_break] = ACTIONS(817),
    [anon_sym_continue] = ACTIONS(817),
    [anon_sym_return] = ACTIONS(817),
    [anon_sym_yield] = ACTIONS(817),
    [anon_sym_synchronized] = ACTIONS(817),
    [anon_sym_throw] = ACTIONS(817),
    [anon_sym_try] = ACTIONS(817),
    [anon_sym_if] = ACTIONS(817),
    [anon_sym_else] = ACTIONS(819),
    [anon_sym_for] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(817),
    [anon_sym_open] = ACTIONS(817),
    [anon_sym_module] = ACTIONS(817),
    [anon_sym_static] = ACTIONS(817),
    [anon_sym_package] = ACTIONS(817),
    [anon_sym_import] = ACTIONS(817),
    [anon_sym_enum] = ACTIONS(817),
    [anon_sym_public] = ACTIONS(817),
    [anon_sym_protected] = ACTIONS(817),
    [anon_sym_private] = ACTIONS(817),
    [anon_sym_abstract] = ACTIONS(817),
    [anon_sym_final] = ACTIONS(817),
    [anon_sym_strictfp] = ACTIONS(817),
    [anon_sym_native] = ACTIONS(817),
    [anon_sym_transient] = ACTIONS(817),
    [anon_sym_volatile] = ACTIONS(817),
    [anon_sym_sealed] = ACTIONS(817),
    [anon_sym_non_DASHsealed] = ACTIONS(815),
    [anon_sym_ATinterface] = ACTIONS(815),
    [anon_sym_interface] = ACTIONS(817),
    [anon_sym_byte] = ACTIONS(817),
    [anon_sym_short] = ACTIONS(817),
    [anon_sym_int] = ACTIONS(817),
    [anon_sym_long] = ACTIONS(817),
    [anon_sym_char] = ACTIONS(817),
    [anon_sym_float] = ACTIONS(817),
    [anon_sym_double] = ACTIONS(817),
    [sym_boolean_type] = ACTIONS(817),
    [sym_void_type] = ACTIONS(817),
    [sym_this] = ACTIONS(817),
    [sym_super] = ACTIONS(817),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [197] = {
    [ts_builtin_sym_end] = ACTIONS(821),
    [sym_identifier] = ACTIONS(823),
    [sym_decimal_integer_literal] = ACTIONS(823),
    [sym_hex_integer_literal] = ACTIONS(823),
    [sym_octal_integer_literal] = ACTIONS(821),
    [sym_binary_integer_literal] = ACTIONS(821),
    [sym_decimal_floating_point_literal] = ACTIONS(821),
    [sym_hex_floating_point_literal] = ACTIONS(823),
    [sym_true] = ACTIONS(823),
    [sym_false] = ACTIONS(823),
    [sym_character_literal] = ACTIONS(821),
    [sym_string_literal] = ACTIONS(823),
    [sym_text_block] = ACTIONS(821),
    [sym_null_literal] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(821),
    [anon_sym_PLUS] = ACTIONS(823),
    [anon_sym_DASH] = ACTIONS(823),
    [anon_sym_BANG] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(821),
    [anon_sym_PLUS_PLUS] = ACTIONS(821),
    [anon_sym_DASH_DASH] = ACTIONS(821),
    [anon_sym_new] = ACTIONS(823),
    [anon_sym_class] = ACTIONS(823),
    [anon_sym_switch] = ACTIONS(823),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_case] = ACTIONS(823),
    [anon_sym_default] = ACTIONS(823),
    [anon_sym_SEMI] = ACTIONS(821),
    [anon_sym_assert] = ACTIONS(823),
    [anon_sym_do] = ACTIONS(823),
    [anon_sym_while] = ACTIONS(823),
    [anon_sym_break] = ACTIONS(823),
    [anon_sym_continue] = ACTIONS(823),
    [anon_sym_return] = ACTIONS(823),
    [anon_sym_yield] = ACTIONS(823),
    [anon_sym_synchronized] = ACTIONS(823),
    [anon_sym_throw] = ACTIONS(823),
    [anon_sym_try] = ACTIONS(823),
    [anon_sym_if] = ACTIONS(823),
    [anon_sym_else] = ACTIONS(823),
    [anon_sym_for] = ACTIONS(823),
    [anon_sym_AT] = ACTIONS(823),
    [anon_sym_open] = ACTIONS(823),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_static] = ACTIONS(823),
    [anon_sym_package] = ACTIONS(823),
    [anon_sym_import] = ACTIONS(823),
    [anon_sym_enum] = ACTIONS(823),
    [anon_sym_public] = ACTIONS(823),
    [anon_sym_protected] = ACTIONS(823),
    [anon_sym_private] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(823),
    [anon_sym_final] = ACTIONS(823),
    [anon_sym_strictfp] = ACTIONS(823),
    [anon_sym_native] = ACTIONS(823),
    [anon_sym_transient] = ACTIONS(823),
    [anon_sym_volatile] = ACTIONS(823),
    [anon_sym_sealed] = ACTIONS(823),
    [anon_sym_non_DASHsealed] = ACTIONS(821),
    [anon_sym_ATinterface] = ACTIONS(821),
    [anon_sym_interface] = ACTIONS(823),
    [anon_sym_byte] = ACTIONS(823),
    [anon_sym_short] = ACTIONS(823),
    [anon_sym_int] = ACTIONS(823),
    [anon_sym_long] = ACTIONS(823),
    [anon_sym_char] = ACTIONS(823),
    [anon_sym_float] = ACTIONS(823),
    [anon_sym_double] = ACTIONS(823),
    [sym_boolean_type] = ACTIONS(823),
    [sym_void_type] = ACTIONS(823),
    [sym_this] = ACTIONS(823),
    [sym_super] = ACTIONS(823),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [198] = {
    [ts_builtin_sym_end] = ACTIONS(825),
    [sym_identifier] = ACTIONS(827),
    [sym_decimal_integer_literal] = ACTIONS(827),
    [sym_hex_integer_literal] = ACTIONS(827),
    [sym_octal_integer_literal] = ACTIONS(825),
    [sym_binary_integer_literal] = ACTIONS(825),
    [sym_decimal_floating_point_literal] = ACTIONS(825),
    [sym_hex_floating_point_literal] = ACTIONS(827),
    [sym_true] = ACTIONS(827),
    [sym_false] = ACTIONS(827),
    [sym_character_literal] = ACTIONS(825),
    [sym_string_literal] = ACTIONS(827),
    [sym_text_block] = ACTIONS(825),
    [sym_null_literal] = ACTIONS(827),
    [anon_sym_LPAREN] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(827),
    [anon_sym_DASH] = ACTIONS(827),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(825),
    [anon_sym_DASH_DASH] = ACTIONS(825),
    [anon_sym_new] = ACTIONS(827),
    [anon_sym_class] = ACTIONS(827),
    [anon_sym_switch] = ACTIONS(827),
    [anon_sym_LBRACE] = ACTIONS(825),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_case] = ACTIONS(827),
    [anon_sym_default] = ACTIONS(827),
    [anon_sym_SEMI] = ACTIONS(825),
    [anon_sym_assert] = ACTIONS(827),
    [anon_sym_do] = ACTIONS(827),
    [anon_sym_while] = ACTIONS(827),
    [anon_sym_break] = ACTIONS(827),
    [anon_sym_continue] = ACTIONS(827),
    [anon_sym_return] = ACTIONS(827),
    [anon_sym_yield] = ACTIONS(827),
    [anon_sym_synchronized] = ACTIONS(827),
    [anon_sym_throw] = ACTIONS(827),
    [anon_sym_try] = ACTIONS(827),
    [anon_sym_if] = ACTIONS(827),
    [anon_sym_else] = ACTIONS(827),
    [anon_sym_for] = ACTIONS(827),
    [anon_sym_AT] = ACTIONS(827),
    [anon_sym_open] = ACTIONS(827),
    [anon_sym_module] = ACTIONS(827),
    [anon_sym_static] = ACTIONS(827),
    [anon_sym_package] = ACTIONS(827),
    [anon_sym_import] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_public] = ACTIONS(827),
    [anon_sym_protected] = ACTIONS(827),
    [anon_sym_private] = ACTIONS(827),
    [anon_sym_abstract] = ACTIONS(827),
    [anon_sym_final] = ACTIONS(827),
    [anon_sym_strictfp] = ACTIONS(827),
    [anon_sym_native] = ACTIONS(827),
    [anon_sym_transient] = ACTIONS(827),
    [anon_sym_volatile] = ACTIONS(827),
    [anon_sym_sealed] = ACTIONS(827),
    [anon_sym_non_DASHsealed] = ACTIONS(825),
    [anon_sym_ATinterface] = ACTIONS(825),
    [anon_sym_interface] = ACTIONS(827),
    [anon_sym_byte] = ACTIONS(827),
    [anon_sym_short] = ACTIONS(827),
    [anon_sym_int] = ACTIONS(827),
    [anon_sym_long] = ACTIONS(827),
    [anon_sym_char] = ACTIONS(827),
    [anon_sym_float] = ACTIONS(827),
    [anon_sym_double] = ACTIONS(827),
    [sym_boolean_type] = ACTIONS(827),
    [sym_void_type] = ACTIONS(827),
    [sym_this] = ACTIONS(827),
    [sym_super] = ACTIONS(827),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [199] = {
    [ts_builtin_sym_end] = ACTIONS(829),
    [sym_identifier] = ACTIONS(831),
    [sym_decimal_integer_literal] = ACTIONS(831),
    [sym_hex_integer_literal] = ACTIONS(831),
    [sym_octal_integer_literal] = ACTIONS(829),
    [sym_binary_integer_literal] = ACTIONS(829),
    [sym_decimal_floating_point_literal] = ACTIONS(829),
    [sym_hex_floating_point_literal] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_character_literal] = ACTIONS(829),
    [sym_string_literal] = ACTIONS(831),
    [sym_text_block] = ACTIONS(829),
    [sym_null_literal] = ACTIONS(831),
    [anon_sym_LPAREN] = ACTIONS(829),
    [anon_sym_PLUS] = ACTIONS(831),
    [anon_sym_DASH] = ACTIONS(831),
    [anon_sym_BANG] = ACTIONS(829),
    [anon_sym_TILDE] = ACTIONS(829),
    [anon_sym_PLUS_PLUS] = ACTIONS(829),
    [anon_sym_DASH_DASH] = ACTIONS(829),
    [anon_sym_new] = ACTIONS(831),
    [anon_sym_class] = ACTIONS(831),
    [anon_sym_switch] = ACTIONS(831),
    [anon_sym_LBRACE] = ACTIONS(829),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_case] = ACTIONS(831),
    [anon_sym_default] = ACTIONS(831),
    [anon_sym_SEMI] = ACTIONS(829),
    [anon_sym_assert] = ACTIONS(831),
    [anon_sym_do] = ACTIONS(831),
    [anon_sym_while] = ACTIONS(831),
    [anon_sym_break] = ACTIONS(831),
    [anon_sym_continue] = ACTIONS(831),
    [anon_sym_return] = ACTIONS(831),
    [anon_sym_yield] = ACTIONS(831),
    [anon_sym_synchronized] = ACTIONS(831),
    [anon_sym_throw] = ACTIONS(831),
    [anon_sym_try] = ACTIONS(831),
    [anon_sym_if] = ACTIONS(831),
    [anon_sym_else] = ACTIONS(831),
    [anon_sym_for] = ACTIONS(831),
    [anon_sym_AT] = ACTIONS(831),
    [anon_sym_open] = ACTIONS(831),
    [anon_sym_module] = ACTIONS(831),
    [anon_sym_static] = ACTIONS(831),
    [anon_sym_package] = ACTIONS(831),
    [anon_sym_import] = ACTIONS(831),
    [anon_sym_enum] = ACTIONS(831),
    [anon_sym_public] = ACTIONS(831),
    [anon_sym_protected] = ACTIONS(831),
    [anon_sym_private] = ACTIONS(831),
    [anon_sym_abstract] = ACTIONS(831),
    [anon_sym_final] = ACTIONS(831),
    [anon_sym_strictfp] = ACTIONS(831),
    [anon_sym_native] = ACTIONS(831),
    [anon_sym_transient] = ACTIONS(831),
    [anon_sym_volatile] = ACTIONS(831),
    [anon_sym_sealed] = ACTIONS(831),
    [anon_sym_non_DASHsealed] = ACTIONS(829),
    [anon_sym_ATinterface] = ACTIONS(829),
    [anon_sym_interface] = ACTIONS(831),
    [anon_sym_byte] = ACTIONS(831),
    [anon_sym_short] = ACTIONS(831),
    [anon_sym_int] = ACTIONS(831),
    [anon_sym_long] = ACTIONS(831),
    [anon_sym_char] = ACTIONS(831),
    [anon_sym_float] = ACTIONS(831),
    [anon_sym_double] = ACTIONS(831),
    [sym_boolean_type] = ACTIONS(831),
    [sym_void_type] = ACTIONS(831),
    [sym_this] = ACTIONS(831),
    [sym_super] = ACTIONS(831),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [200] = {
    [ts_builtin_sym_end] = ACTIONS(833),
    [sym_identifier] = ACTIONS(835),
    [sym_decimal_integer_literal] = ACTIONS(835),
    [sym_hex_integer_literal] = ACTIONS(835),
    [sym_octal_integer_literal] = ACTIONS(833),
    [sym_binary_integer_literal] = ACTIONS(833),
    [sym_decimal_floating_point_literal] = ACTIONS(833),
    [sym_hex_floating_point_literal] = ACTIONS(835),
    [sym_true] = ACTIONS(835),
    [sym_false] = ACTIONS(835),
    [sym_character_literal] = ACTIONS(833),
    [sym_string_literal] = ACTIONS(835),
    [sym_text_block] = ACTIONS(833),
    [sym_null_literal] = ACTIONS(835),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_PLUS] = ACTIONS(835),
    [anon_sym_DASH] = ACTIONS(835),
    [anon_sym_BANG] = ACTIONS(833),
    [anon_sym_TILDE] = ACTIONS(833),
    [anon_sym_PLUS_PLUS] = ACTIONS(833),
    [anon_sym_DASH_DASH] = ACTIONS(833),
    [anon_sym_new] = ACTIONS(835),
    [anon_sym_class] = ACTIONS(835),
    [anon_sym_switch] = ACTIONS(835),
    [anon_sym_LBRACE] = ACTIONS(833),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_case] = ACTIONS(835),
    [anon_sym_default] = ACTIONS(835),
    [anon_sym_SEMI] = ACTIONS(833),
    [anon_sym_assert] = ACTIONS(835),
    [anon_sym_do] = ACTIONS(835),
    [anon_sym_while] = ACTIONS(835),
    [anon_sym_break] = ACTIONS(835),
    [anon_sym_continue] = ACTIONS(835),
    [anon_sym_return] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(835),
    [anon_sym_synchronized] = ACTIONS(835),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_try] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(835),
    [anon_sym_else] = ACTIONS(835),
    [anon_sym_for] = ACTIONS(835),
    [anon_sym_AT] = ACTIONS(835),
    [anon_sym_open] = ACTIONS(835),
    [anon_sym_module] = ACTIONS(835),
    [anon_sym_static] = ACTIONS(835),
    [anon_sym_package] = ACTIONS(835),
    [anon_sym_import] = ACTIONS(835),
    [anon_sym_enum] = ACTIONS(835),
    [anon_sym_public] = ACTIONS(835),
    [anon_sym_protected] = ACTIONS(835),
    [anon_sym_private] = ACTIONS(835),
    [anon_sym_abstract] = ACTIONS(835),
    [anon_sym_final] = ACTIONS(835),
    [anon_sym_strictfp] = ACTIONS(835),
    [anon_sym_native] = ACTIONS(835),
    [anon_sym_transient] = ACTIONS(835),
    [anon_sym_volatile] = ACTIONS(835),
    [anon_sym_sealed] = ACTIONS(835),
    [anon_sym_non_DASHsealed] = ACTIONS(833),
    [anon_sym_ATinterface] = ACTIONS(833),
    [anon_sym_interface] = ACTIONS(835),
    [anon_sym_byte] = ACTIONS(835),
    [anon_sym_short] = ACTIONS(835),
    [anon_sym_int] = ACTIONS(835),
    [anon_sym_long] = ACTIONS(835),
    [anon_sym_char] = ACTIONS(835),
    [anon_sym_float] = ACTIONS(835),
    [anon_sym_double] = ACTIONS(835),
    [sym_boolean_type] = ACTIONS(835),
    [sym_void_type] = ACTIONS(835),
    [sym_this] = ACTIONS(835),
    [sym_super] = ACTIONS(835),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [201] = {
    [ts_builtin_sym_end] = ACTIONS(837),
    [sym_identifier] = ACTIONS(839),
    [sym_decimal_integer_literal] = ACTIONS(839),
    [sym_hex_integer_literal] = ACTIONS(839),
    [sym_octal_integer_literal] = ACTIONS(837),
    [sym_binary_integer_literal] = ACTIONS(837),
    [sym_decimal_floating_point_literal] = ACTIONS(837),
    [sym_hex_floating_point_literal] = ACTIONS(839),
    [sym_true] = ACTIONS(839),
    [sym_false] = ACTIONS(839),
    [sym_character_literal] = ACTIONS(837),
    [sym_string_literal] = ACTIONS(839),
    [sym_text_block] = ACTIONS(837),
    [sym_null_literal] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(837),
    [anon_sym_TILDE] = ACTIONS(837),
    [anon_sym_PLUS_PLUS] = ACTIONS(837),
    [anon_sym_DASH_DASH] = ACTIONS(837),
    [anon_sym_new] = ACTIONS(839),
    [anon_sym_class] = ACTIONS(839),
    [anon_sym_switch] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_case] = ACTIONS(839),
    [anon_sym_default] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(837),
    [anon_sym_assert] = ACTIONS(839),
    [anon_sym_do] = ACTIONS(839),
    [anon_sym_while] = ACTIONS(839),
    [anon_sym_break] = ACTIONS(839),
    [anon_sym_continue] = ACTIONS(839),
    [anon_sym_return] = ACTIONS(839),
    [anon_sym_yield] = ACTIONS(839),
    [anon_sym_synchronized] = ACTIONS(839),
    [anon_sym_throw] = ACTIONS(839),
    [anon_sym_try] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(839),
    [anon_sym_else] = ACTIONS(839),
    [anon_sym_for] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(839),
    [anon_sym_open] = ACTIONS(839),
    [anon_sym_module] = ACTIONS(839),
    [anon_sym_static] = ACTIONS(839),
    [anon_sym_package] = ACTIONS(839),
    [anon_sym_import] = ACTIONS(839),
    [anon_sym_enum] = ACTIONS(839),
    [anon_sym_public] = ACTIONS(839),
    [anon_sym_protected] = ACTIONS(839),
    [anon_sym_private] = ACTIONS(839),
    [anon_sym_abstract] = ACTIONS(839),
    [anon_sym_final] = ACTIONS(839),
    [anon_sym_strictfp] = ACTIONS(839),
    [anon_sym_native] = ACTIONS(839),
    [anon_sym_transient] = ACTIONS(839),
    [anon_sym_volatile] = ACTIONS(839),
    [anon_sym_sealed] = ACTIONS(839),
    [anon_sym_non_DASHsealed] = ACTIONS(837),
    [anon_sym_ATinterface] = ACTIONS(837),
    [anon_sym_interface] = ACTIONS(839),
    [anon_sym_byte] = ACTIONS(839),
    [anon_sym_short] = ACTIONS(839),
    [anon_sym_int] = ACTIONS(839),
    [anon_sym_long] = ACTIONS(839),
    [anon_sym_char] = ACTIONS(839),
    [anon_sym_float] = ACTIONS(839),
    [anon_sym_double] = ACTIONS(839),
    [sym_boolean_type] = ACTIONS(839),
    [sym_void_type] = ACTIONS(839),
    [sym_this] = ACTIONS(839),
    [sym_super] = ACTIONS(839),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [202] = {
    [ts_builtin_sym_end] = ACTIONS(841),
    [sym_identifier] = ACTIONS(843),
    [sym_decimal_integer_literal] = ACTIONS(843),
    [sym_hex_integer_literal] = ACTIONS(843),
    [sym_octal_integer_literal] = ACTIONS(841),
    [sym_binary_integer_literal] = ACTIONS(841),
    [sym_decimal_floating_point_literal] = ACTIONS(841),
    [sym_hex_floating_point_literal] = ACTIONS(843),
    [sym_true] = ACTIONS(843),
    [sym_false] = ACTIONS(843),
    [sym_character_literal] = ACTIONS(841),
    [sym_string_literal] = ACTIONS(843),
    [sym_text_block] = ACTIONS(841),
    [sym_null_literal] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_DASH] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_TILDE] = ACTIONS(841),
    [anon_sym_PLUS_PLUS] = ACTIONS(841),
    [anon_sym_DASH_DASH] = ACTIONS(841),
    [anon_sym_new] = ACTIONS(843),
    [anon_sym_class] = ACTIONS(843),
    [anon_sym_switch] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_case] = ACTIONS(843),
    [anon_sym_default] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_assert] = ACTIONS(843),
    [anon_sym_do] = ACTIONS(843),
    [anon_sym_while] = ACTIONS(843),
    [anon_sym_break] = ACTIONS(843),
    [anon_sym_continue] = ACTIONS(843),
    [anon_sym_return] = ACTIONS(843),
    [anon_sym_yield] = ACTIONS(843),
    [anon_sym_synchronized] = ACTIONS(843),
    [anon_sym_throw] = ACTIONS(843),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(843),
    [anon_sym_else] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(843),
    [anon_sym_AT] = ACTIONS(843),
    [anon_sym_open] = ACTIONS(843),
    [anon_sym_module] = ACTIONS(843),
    [anon_sym_static] = ACTIONS(843),
    [anon_sym_package] = ACTIONS(843),
    [anon_sym_import] = ACTIONS(843),
    [anon_sym_enum] = ACTIONS(843),
    [anon_sym_public] = ACTIONS(843),
    [anon_sym_protected] = ACTIONS(843),
    [anon_sym_private] = ACTIONS(843),
    [anon_sym_abstract] = ACTIONS(843),
    [anon_sym_final] = ACTIONS(843),
    [anon_sym_strictfp] = ACTIONS(843),
    [anon_sym_native] = ACTIONS(843),
    [anon_sym_transient] = ACTIONS(843),
    [anon_sym_volatile] = ACTIONS(843),
    [anon_sym_sealed] = ACTIONS(843),
    [anon_sym_non_DASHsealed] = ACTIONS(841),
    [anon_sym_ATinterface] = ACTIONS(841),
    [anon_sym_interface] = ACTIONS(843),
    [anon_sym_byte] = ACTIONS(843),
    [anon_sym_short] = ACTIONS(843),
    [anon_sym_int] = ACTIONS(843),
    [anon_sym_long] = ACTIONS(843),
    [anon_sym_char] = ACTIONS(843),
    [anon_sym_float] = ACTIONS(843),
    [anon_sym_double] = ACTIONS(843),
    [sym_boolean_type] = ACTIONS(843),
    [sym_void_type] = ACTIONS(843),
    [sym_this] = ACTIONS(843),
    [sym_super] = ACTIONS(843),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [203] = {
    [ts_builtin_sym_end] = ACTIONS(845),
    [sym_identifier] = ACTIONS(847),
    [sym_decimal_integer_literal] = ACTIONS(847),
    [sym_hex_integer_literal] = ACTIONS(847),
    [sym_octal_integer_literal] = ACTIONS(845),
    [sym_binary_integer_literal] = ACTIONS(845),
    [sym_decimal_floating_point_literal] = ACTIONS(845),
    [sym_hex_floating_point_literal] = ACTIONS(847),
    [sym_true] = ACTIONS(847),
    [sym_false] = ACTIONS(847),
    [sym_character_literal] = ACTIONS(845),
    [sym_string_literal] = ACTIONS(847),
    [sym_text_block] = ACTIONS(845),
    [sym_null_literal] = ACTIONS(847),
    [anon_sym_LPAREN] = ACTIONS(845),
    [anon_sym_PLUS] = ACTIONS(847),
    [anon_sym_DASH] = ACTIONS(847),
    [anon_sym_BANG] = ACTIONS(845),
    [anon_sym_TILDE] = ACTIONS(845),
    [anon_sym_PLUS_PLUS] = ACTIONS(845),
    [anon_sym_DASH_DASH] = ACTIONS(845),
    [anon_sym_new] = ACTIONS(847),
    [anon_sym_class] = ACTIONS(847),
    [anon_sym_switch] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(845),
    [anon_sym_case] = ACTIONS(847),
    [anon_sym_default] = ACTIONS(847),
    [anon_sym_SEMI] = ACTIONS(845),
    [anon_sym_assert] = ACTIONS(847),
    [anon_sym_do] = ACTIONS(847),
    [anon_sym_while] = ACTIONS(847),
    [anon_sym_break] = ACTIONS(847),
    [anon_sym_continue] = ACTIONS(847),
    [anon_sym_return] = ACTIONS(847),
    [anon_sym_yield] = ACTIONS(847),
    [anon_sym_synchronized] = ACTIONS(847),
    [anon_sym_throw] = ACTIONS(847),
    [anon_sym_try] = ACTIONS(847),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_else] = ACTIONS(847),
    [anon_sym_for] = ACTIONS(847),
    [anon_sym_AT] = ACTIONS(847),
    [anon_sym_open] = ACTIONS(847),
    [anon_sym_module] = ACTIONS(847),
    [anon_sym_static] = ACTIONS(847),
    [anon_sym_package] = ACTIONS(847),
    [anon_sym_import] = ACTIONS(847),
    [anon_sym_enum] = ACTIONS(847),
    [anon_sym_public] = ACTIONS(847),
    [anon_sym_protected] = ACTIONS(847),
    [anon_sym_private] = ACTIONS(847),
    [anon_sym_abstract] = ACTIONS(847),
    [anon_sym_final] = ACTIONS(847),
    [anon_sym_strictfp] = ACTIONS(847),
    [anon_sym_native] = ACTIONS(847),
    [anon_sym_transient] = ACTIONS(847),
    [anon_sym_volatile] = ACTIONS(847),
    [anon_sym_sealed] = ACTIONS(847),
    [anon_sym_non_DASHsealed] = ACTIONS(845),
    [anon_sym_ATinterface] = ACTIONS(845),
    [anon_sym_interface] = ACTIONS(847),
    [anon_sym_byte] = ACTIONS(847),
    [anon_sym_short] = ACTIONS(847),
    [anon_sym_int] = ACTIONS(847),
    [anon_sym_long] = ACTIONS(847),
    [anon_sym_char] = ACTIONS(847),
    [anon_sym_float] = ACTIONS(847),
    [anon_sym_double] = ACTIONS(847),
    [sym_boolean_type] = ACTIONS(847),
    [sym_void_type] = ACTIONS(847),
    [sym_this] = ACTIONS(847),
    [sym_super] = ACTIONS(847),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [204] = {
    [ts_builtin_sym_end] = ACTIONS(300),
    [sym_identifier] = ACTIONS(302),
    [sym_decimal_integer_literal] = ACTIONS(302),
    [sym_hex_integer_literal] = ACTIONS(302),
    [sym_octal_integer_literal] = ACTIONS(300),
    [sym_binary_integer_literal] = ACTIONS(300),
    [sym_decimal_floating_point_literal] = ACTIONS(300),
    [sym_hex_floating_point_literal] = ACTIONS(302),
    [sym_true] = ACTIONS(302),
    [sym_false] = ACTIONS(302),
    [sym_character_literal] = ACTIONS(300),
    [sym_string_literal] = ACTIONS(302),
    [sym_text_block] = ACTIONS(300),
    [sym_null_literal] = ACTIONS(302),
    [anon_sym_LPAREN] = ACTIONS(300),
    [anon_sym_PLUS] = ACTIONS(302),
    [anon_sym_DASH] = ACTIONS(302),
    [anon_sym_BANG] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(300),
    [anon_sym_PLUS_PLUS] = ACTIONS(300),
    [anon_sym_DASH_DASH] = ACTIONS(300),
    [anon_sym_new] = ACTIONS(302),
    [anon_sym_class] = ACTIONS(302),
    [anon_sym_switch] = ACTIONS(302),
    [anon_sym_LBRACE] = ACTIONS(300),
    [anon_sym_RBRACE] = ACTIONS(300),
    [anon_sym_case] = ACTIONS(302),
    [anon_sym_default] = ACTIONS(302),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_assert] = ACTIONS(302),
    [anon_sym_do] = ACTIONS(302),
    [anon_sym_while] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(302),
    [anon_sym_continue] = ACTIONS(302),
    [anon_sym_return] = ACTIONS(302),
    [anon_sym_yield] = ACTIONS(302),
    [anon_sym_synchronized] = ACTIONS(302),
    [anon_sym_throw] = ACTIONS(302),
    [anon_sym_try] = ACTIONS(302),
    [anon_sym_if] = ACTIONS(302),
    [anon_sym_else] = ACTIONS(302),
    [anon_sym_for] = ACTIONS(302),
    [anon_sym_AT] = ACTIONS(302),
    [anon_sym_open] = ACTIONS(302),
    [anon_sym_module] = ACTIONS(302),
    [anon_sym_static] = ACTIONS(302),
    [anon_sym_package] = ACTIONS(302),
    [anon_sym_import] = ACTIONS(302),
    [anon_sym_enum] = ACTIONS(302),
    [anon_sym_public] = ACTIONS(302),
    [anon_sym_protected] = ACTIONS(302),
    [anon_sym_private] = ACTIONS(302),
    [anon_sym_abstract] = ACTIONS(302),
    [anon_sym_final] = ACTIONS(302),
    [anon_sym_strictfp] = ACTIONS(302),
    [anon_sym_native] = ACTIONS(302),
    [anon_sym_transient] = ACTIONS(302),
    [anon_sym_volatile] = ACTIONS(302),
    [anon_sym_sealed] = ACTIONS(302),
    [anon_sym_non_DASHsealed] = ACTIONS(300),
    [anon_sym_ATinterface] = ACTIONS(300),
    [anon_sym_interface] = ACTIONS(302),
    [anon_sym_byte] = ACTIONS(302),
    [anon_sym_short] = ACTIONS(302),
    [anon_sym_int] = ACTIONS(302),
    [anon_sym_long] = ACTIONS(302),
    [anon_sym_char] = ACTIONS(302),
    [anon_sym_float] = ACTIONS(302),
    [anon_sym_double] = ACTIONS(302),
    [sym_boolean_type] = ACTIONS(302),
    [sym_void_type] = ACTIONS(302),
    [sym_this] = ACTIONS(302),
    [sym_super] = ACTIONS(302),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [205] = {
    [ts_builtin_sym_end] = ACTIONS(849),
    [sym_identifier] = ACTIONS(851),
    [sym_decimal_integer_literal] = ACTIONS(851),
    [sym_hex_integer_literal] = ACTIONS(851),
    [sym_octal_integer_literal] = ACTIONS(849),
    [sym_binary_integer_literal] = ACTIONS(849),
    [sym_decimal_floating_point_literal] = ACTIONS(849),
    [sym_hex_floating_point_literal] = ACTIONS(851),
    [sym_true] = ACTIONS(851),
    [sym_false] = ACTIONS(851),
    [sym_character_literal] = ACTIONS(849),
    [sym_string_literal] = ACTIONS(851),
    [sym_text_block] = ACTIONS(849),
    [sym_null_literal] = ACTIONS(851),
    [anon_sym_LPAREN] = ACTIONS(849),
    [anon_sym_PLUS] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(851),
    [anon_sym_BANG] = ACTIONS(849),
    [anon_sym_TILDE] = ACTIONS(849),
    [anon_sym_PLUS_PLUS] = ACTIONS(849),
    [anon_sym_DASH_DASH] = ACTIONS(849),
    [anon_sym_new] = ACTIONS(851),
    [anon_sym_class] = ACTIONS(851),
    [anon_sym_switch] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(849),
    [anon_sym_RBRACE] = ACTIONS(849),
    [anon_sym_case] = ACTIONS(851),
    [anon_sym_default] = ACTIONS(851),
    [anon_sym_SEMI] = ACTIONS(849),
    [anon_sym_assert] = ACTIONS(851),
    [anon_sym_do] = ACTIONS(851),
    [anon_sym_while] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(851),
    [anon_sym_continue] = ACTIONS(851),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_yield] = ACTIONS(851),
    [anon_sym_synchronized] = ACTIONS(851),
    [anon_sym_throw] = ACTIONS(851),
    [anon_sym_try] = ACTIONS(851),
    [anon_sym_if] = ACTIONS(851),
    [anon_sym_else] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(851),
    [anon_sym_AT] = ACTIONS(851),
    [anon_sym_open] = ACTIONS(851),
    [anon_sym_module] = ACTIONS(851),
    [anon_sym_static] = ACTIONS(851),
    [anon_sym_package] = ACTIONS(851),
    [anon_sym_import] = ACTIONS(851),
    [anon_sym_enum] = ACTIONS(851),
    [anon_sym_public] = ACTIONS(851),
    [anon_sym_protected] = ACTIONS(851),
    [anon_sym_private] = ACTIONS(851),
    [anon_sym_abstract] = ACTIONS(851),
    [anon_sym_final] = ACTIONS(851),
    [anon_sym_strictfp] = ACTIONS(851),
    [anon_sym_native] = ACTIONS(851),
    [anon_sym_transient] = ACTIONS(851),
    [anon_sym_volatile] = ACTIONS(851),
    [anon_sym_sealed] = ACTIONS(851),
    [anon_sym_non_DASHsealed] = ACTIONS(849),
    [anon_sym_ATinterface] = ACTIONS(849),
    [anon_sym_interface] = ACTIONS(851),
    [anon_sym_byte] = ACTIONS(851),
    [anon_sym_short] = ACTIONS(851),
    [anon_sym_int] = ACTIONS(851),
    [anon_sym_long] = ACTIONS(851),
    [anon_sym_char] = ACTIONS(851),
    [anon_sym_float] = ACTIONS(851),
    [anon_sym_double] = ACTIONS(851),
    [sym_boolean_type] = ACTIONS(851),
    [sym_void_type] = ACTIONS(851),
    [sym_this] = ACTIONS(851),
    [sym_super] = ACTIONS(851),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [206] = {
    [ts_builtin_sym_end] = ACTIONS(853),
    [sym_identifier] = ACTIONS(855),
    [sym_decimal_integer_literal] = ACTIONS(855),
    [sym_hex_integer_literal] = ACTIONS(855),
    [sym_octal_integer_literal] = ACTIONS(853),
    [sym_binary_integer_literal] = ACTIONS(853),
    [sym_decimal_floating_point_literal] = ACTIONS(853),
    [sym_hex_floating_point_literal] = ACTIONS(855),
    [sym_true] = ACTIONS(855),
    [sym_false] = ACTIONS(855),
    [sym_character_literal] = ACTIONS(853),
    [sym_string_literal] = ACTIONS(855),
    [sym_text_block] = ACTIONS(853),
    [sym_null_literal] = ACTIONS(855),
    [anon_sym_LPAREN] = ACTIONS(853),
    [anon_sym_PLUS] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(855),
    [anon_sym_BANG] = ACTIONS(853),
    [anon_sym_TILDE] = ACTIONS(853),
    [anon_sym_PLUS_PLUS] = ACTIONS(853),
    [anon_sym_DASH_DASH] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(855),
    [anon_sym_class] = ACTIONS(855),
    [anon_sym_switch] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_case] = ACTIONS(855),
    [anon_sym_default] = ACTIONS(855),
    [anon_sym_SEMI] = ACTIONS(853),
    [anon_sym_assert] = ACTIONS(855),
    [anon_sym_do] = ACTIONS(855),
    [anon_sym_while] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(855),
    [anon_sym_continue] = ACTIONS(855),
    [anon_sym_return] = ACTIONS(855),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_synchronized] = ACTIONS(855),
    [anon_sym_throw] = ACTIONS(855),
    [anon_sym_try] = ACTIONS(855),
    [anon_sym_if] = ACTIONS(855),
    [anon_sym_else] = ACTIONS(855),
    [anon_sym_for] = ACTIONS(855),
    [anon_sym_AT] = ACTIONS(855),
    [anon_sym_open] = ACTIONS(855),
    [anon_sym_module] = ACTIONS(855),
    [anon_sym_static] = ACTIONS(855),
    [anon_sym_package] = ACTIONS(855),
    [anon_sym_import] = ACTIONS(855),
    [anon_sym_enum] = ACTIONS(855),
    [anon_sym_public] = ACTIONS(855),
    [anon_sym_protected] = ACTIONS(855),
    [anon_sym_private] = ACTIONS(855),
    [anon_sym_abstract] = ACTIONS(855),
    [anon_sym_final] = ACTIONS(855),
    [anon_sym_strictfp] = ACTIONS(855),
    [anon_sym_native] = ACTIONS(855),
    [anon_sym_transient] = ACTIONS(855),
    [anon_sym_volatile] = ACTIONS(855),
    [anon_sym_sealed] = ACTIONS(855),
    [anon_sym_non_DASHsealed] = ACTIONS(853),
    [anon_sym_ATinterface] = ACTIONS(853),
    [anon_sym_interface] = ACTIONS(855),
    [anon_sym_byte] = ACTIONS(855),
    [anon_sym_short] = ACTIONS(855),
    [anon_sym_int] = ACTIONS(855),
    [anon_sym_long] = ACTIONS(855),
    [anon_sym_char] = ACTIONS(855),
    [anon_sym_float] = ACTIONS(855),
    [anon_sym_double] = ACTIONS(855),
    [sym_boolean_type] = ACTIONS(855),
    [sym_void_type] = ACTIONS(855),
    [sym_this] = ACTIONS(855),
    [sym_super] = ACTIONS(855),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [207] = {
    [ts_builtin_sym_end] = ACTIONS(857),
    [sym_identifier] = ACTIONS(859),
    [sym_decimal_integer_literal] = ACTIONS(859),
    [sym_hex_integer_literal] = ACTIONS(859),
    [sym_octal_integer_literal] = ACTIONS(857),
    [sym_binary_integer_literal] = ACTIONS(857),
    [sym_decimal_floating_point_literal] = ACTIONS(857),
    [sym_hex_floating_point_literal] = ACTIONS(859),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_character_literal] = ACTIONS(857),
    [sym_string_literal] = ACTIONS(859),
    [sym_text_block] = ACTIONS(857),
    [sym_null_literal] = ACTIONS(859),
    [anon_sym_LPAREN] = ACTIONS(857),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_new] = ACTIONS(859),
    [anon_sym_class] = ACTIONS(859),
    [anon_sym_switch] = ACTIONS(859),
    [anon_sym_LBRACE] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(857),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_default] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_assert] = ACTIONS(859),
    [anon_sym_do] = ACTIONS(859),
    [anon_sym_while] = ACTIONS(859),
    [anon_sym_break] = ACTIONS(859),
    [anon_sym_continue] = ACTIONS(859),
    [anon_sym_return] = ACTIONS(859),
    [anon_sym_yield] = ACTIONS(859),
    [anon_sym_synchronized] = ACTIONS(859),
    [anon_sym_throw] = ACTIONS(859),
    [anon_sym_try] = ACTIONS(859),
    [anon_sym_if] = ACTIONS(859),
    [anon_sym_else] = ACTIONS(859),
    [anon_sym_for] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(859),
    [anon_sym_open] = ACTIONS(859),
    [anon_sym_module] = ACTIONS(859),
    [anon_sym_static] = ACTIONS(859),
    [anon_sym_package] = ACTIONS(859),
    [anon_sym_import] = ACTIONS(859),
    [anon_sym_enum] = ACTIONS(859),
    [anon_sym_public] = ACTIONS(859),
    [anon_sym_protected] = ACTIONS(859),
    [anon_sym_private] = ACTIONS(859),
    [anon_sym_abstract] = ACTIONS(859),
    [anon_sym_final] = ACTIONS(859),
    [anon_sym_strictfp] = ACTIONS(859),
    [anon_sym_native] = ACTIONS(859),
    [anon_sym_transient] = ACTIONS(859),
    [anon_sym_volatile] = ACTIONS(859),
    [anon_sym_sealed] = ACTIONS(859),
    [anon_sym_non_DASHsealed] = ACTIONS(857),
    [anon_sym_ATinterface] = ACTIONS(857),
    [anon_sym_interface] = ACTIONS(859),
    [anon_sym_byte] = ACTIONS(859),
    [anon_sym_short] = ACTIONS(859),
    [anon_sym_int] = ACTIONS(859),
    [anon_sym_long] = ACTIONS(859),
    [anon_sym_char] = ACTIONS(859),
    [anon_sym_float] = ACTIONS(859),
    [anon_sym_double] = ACTIONS(859),
    [sym_boolean_type] = ACTIONS(859),
    [sym_void_type] = ACTIONS(859),
    [sym_this] = ACTIONS(859),
    [sym_super] = ACTIONS(859),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [208] = {
    [ts_builtin_sym_end] = ACTIONS(861),
    [sym_identifier] = ACTIONS(863),
    [sym_decimal_integer_literal] = ACTIONS(863),
    [sym_hex_integer_literal] = ACTIONS(863),
    [sym_octal_integer_literal] = ACTIONS(861),
    [sym_binary_integer_literal] = ACTIONS(861),
    [sym_decimal_floating_point_literal] = ACTIONS(861),
    [sym_hex_floating_point_literal] = ACTIONS(863),
    [sym_true] = ACTIONS(863),
    [sym_false] = ACTIONS(863),
    [sym_character_literal] = ACTIONS(861),
    [sym_string_literal] = ACTIONS(863),
    [sym_text_block] = ACTIONS(861),
    [sym_null_literal] = ACTIONS(863),
    [anon_sym_LPAREN] = ACTIONS(861),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(863),
    [anon_sym_BANG] = ACTIONS(861),
    [anon_sym_TILDE] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_new] = ACTIONS(863),
    [anon_sym_class] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(863),
    [anon_sym_LBRACE] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(861),
    [anon_sym_case] = ACTIONS(863),
    [anon_sym_default] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_assert] = ACTIONS(863),
    [anon_sym_do] = ACTIONS(863),
    [anon_sym_while] = ACTIONS(863),
    [anon_sym_break] = ACTIONS(863),
    [anon_sym_continue] = ACTIONS(863),
    [anon_sym_return] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(863),
    [anon_sym_synchronized] = ACTIONS(863),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_try] = ACTIONS(863),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_else] = ACTIONS(863),
    [anon_sym_for] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(863),
    [anon_sym_open] = ACTIONS(863),
    [anon_sym_module] = ACTIONS(863),
    [anon_sym_static] = ACTIONS(863),
    [anon_sym_package] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(863),
    [anon_sym_enum] = ACTIONS(863),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_protected] = ACTIONS(863),
    [anon_sym_private] = ACTIONS(863),
    [anon_sym_abstract] = ACTIONS(863),
    [anon_sym_final] = ACTIONS(863),
    [anon_sym_strictfp] = ACTIONS(863),
    [anon_sym_native] = ACTIONS(863),
    [anon_sym_transient] = ACTIONS(863),
    [anon_sym_volatile] = ACTIONS(863),
    [anon_sym_sealed] = ACTIONS(863),
    [anon_sym_non_DASHsealed] = ACTIONS(861),
    [anon_sym_ATinterface] = ACTIONS(861),
    [anon_sym_interface] = ACTIONS(863),
    [anon_sym_byte] = ACTIONS(863),
    [anon_sym_short] = ACTIONS(863),
    [anon_sym_int] = ACTIONS(863),
    [anon_sym_long] = ACTIONS(863),
    [anon_sym_char] = ACTIONS(863),
    [anon_sym_float] = ACTIONS(863),
    [anon_sym_double] = ACTIONS(863),
    [sym_boolean_type] = ACTIONS(863),
    [sym_void_type] = ACTIONS(863),
    [sym_this] = ACTIONS(863),
    [sym_super] = ACTIONS(863),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [209] = {
    [ts_builtin_sym_end] = ACTIONS(865),
    [sym_identifier] = ACTIONS(867),
    [sym_decimal_integer_literal] = ACTIONS(867),
    [sym_hex_integer_literal] = ACTIONS(867),
    [sym_octal_integer_literal] = ACTIONS(865),
    [sym_binary_integer_literal] = ACTIONS(865),
    [sym_decimal_floating_point_literal] = ACTIONS(865),
    [sym_hex_floating_point_literal] = ACTIONS(867),
    [sym_true] = ACTIONS(867),
    [sym_false] = ACTIONS(867),
    [sym_character_literal] = ACTIONS(865),
    [sym_string_literal] = ACTIONS(867),
    [sym_text_block] = ACTIONS(865),
    [sym_null_literal] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(865),
    [anon_sym_TILDE] = ACTIONS(865),
    [anon_sym_PLUS_PLUS] = ACTIONS(865),
    [anon_sym_DASH_DASH] = ACTIONS(865),
    [anon_sym_new] = ACTIONS(867),
    [anon_sym_class] = ACTIONS(867),
    [anon_sym_switch] = ACTIONS(867),
    [anon_sym_LBRACE] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(865),
    [anon_sym_case] = ACTIONS(867),
    [anon_sym_default] = ACTIONS(867),
    [anon_sym_SEMI] = ACTIONS(865),
    [anon_sym_assert] = ACTIONS(867),
    [anon_sym_do] = ACTIONS(867),
    [anon_sym_while] = ACTIONS(867),
    [anon_sym_break] = ACTIONS(867),
    [anon_sym_continue] = ACTIONS(867),
    [anon_sym_return] = ACTIONS(867),
    [anon_sym_yield] = ACTIONS(867),
    [anon_sym_synchronized] = ACTIONS(867),
    [anon_sym_throw] = ACTIONS(867),
    [anon_sym_try] = ACTIONS(867),
    [anon_sym_if] = ACTIONS(867),
    [anon_sym_else] = ACTIONS(867),
    [anon_sym_for] = ACTIONS(867),
    [anon_sym_AT] = ACTIONS(867),
    [anon_sym_open] = ACTIONS(867),
    [anon_sym_module] = ACTIONS(867),
    [anon_sym_static] = ACTIONS(867),
    [anon_sym_package] = ACTIONS(867),
    [anon_sym_import] = ACTIONS(867),
    [anon_sym_enum] = ACTIONS(867),
    [anon_sym_public] = ACTIONS(867),
    [anon_sym_protected] = ACTIONS(867),
    [anon_sym_private] = ACTIONS(867),
    [anon_sym_abstract] = ACTIONS(867),
    [anon_sym_final] = ACTIONS(867),
    [anon_sym_strictfp] = ACTIONS(867),
    [anon_sym_native] = ACTIONS(867),
    [anon_sym_transient] = ACTIONS(867),
    [anon_sym_volatile] = ACTIONS(867),
    [anon_sym_sealed] = ACTIONS(867),
    [anon_sym_non_DASHsealed] = ACTIONS(865),
    [anon_sym_ATinterface] = ACTIONS(865),
    [anon_sym_interface] = ACTIONS(867),
    [anon_sym_byte] = ACTIONS(867),
    [anon_sym_short] = ACTIONS(867),
    [anon_sym_int] = ACTIONS(867),
    [anon_sym_long] = ACTIONS(867),
    [anon_sym_char] = ACTIONS(867),
    [anon_sym_float] = ACTIONS(867),
    [anon_sym_double] = ACTIONS(867),
    [sym_boolean_type] = ACTIONS(867),
    [sym_void_type] = ACTIONS(867),
    [sym_this] = ACTIONS(867),
    [sym_super] = ACTIONS(867),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [210] = {
    [ts_builtin_sym_end] = ACTIONS(869),
    [sym_identifier] = ACTIONS(871),
    [sym_decimal_integer_literal] = ACTIONS(871),
    [sym_hex_integer_literal] = ACTIONS(871),
    [sym_octal_integer_literal] = ACTIONS(869),
    [sym_binary_integer_literal] = ACTIONS(869),
    [sym_decimal_floating_point_literal] = ACTIONS(869),
    [sym_hex_floating_point_literal] = ACTIONS(871),
    [sym_true] = ACTIONS(871),
    [sym_false] = ACTIONS(871),
    [sym_character_literal] = ACTIONS(869),
    [sym_string_literal] = ACTIONS(871),
    [sym_text_block] = ACTIONS(869),
    [sym_null_literal] = ACTIONS(871),
    [anon_sym_LPAREN] = ACTIONS(869),
    [anon_sym_PLUS] = ACTIONS(871),
    [anon_sym_DASH] = ACTIONS(871),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_new] = ACTIONS(871),
    [anon_sym_class] = ACTIONS(871),
    [anon_sym_switch] = ACTIONS(871),
    [anon_sym_LBRACE] = ACTIONS(869),
    [anon_sym_RBRACE] = ACTIONS(869),
    [anon_sym_case] = ACTIONS(871),
    [anon_sym_default] = ACTIONS(871),
    [anon_sym_SEMI] = ACTIONS(869),
    [anon_sym_assert] = ACTIONS(871),
    [anon_sym_do] = ACTIONS(871),
    [anon_sym_while] = ACTIONS(871),
    [anon_sym_break] = ACTIONS(871),
    [anon_sym_continue] = ACTIONS(871),
    [anon_sym_return] = ACTIONS(871),
    [anon_sym_yield] = ACTIONS(871),
    [anon_sym_synchronized] = ACTIONS(871),
    [anon_sym_throw] = ACTIONS(871),
    [anon_sym_try] = ACTIONS(871),
    [anon_sym_if] = ACTIONS(871),
    [anon_sym_else] = ACTIONS(871),
    [anon_sym_for] = ACTIONS(871),
    [anon_sym_AT] = ACTIONS(871),
    [anon_sym_open] = ACTIONS(871),
    [anon_sym_module] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(871),
    [anon_sym_package] = ACTIONS(871),
    [anon_sym_import] = ACTIONS(871),
    [anon_sym_enum] = ACTIONS(871),
    [anon_sym_public] = ACTIONS(871),
    [anon_sym_protected] = ACTIONS(871),
    [anon_sym_private] = ACTIONS(871),
    [anon_sym_abstract] = ACTIONS(871),
    [anon_sym_final] = ACTIONS(871),
    [anon_sym_strictfp] = ACTIONS(871),
    [anon_sym_native] = ACTIONS(871),
    [anon_sym_transient] = ACTIONS(871),
    [anon_sym_volatile] = ACTIONS(871),
    [anon_sym_sealed] = ACTIONS(871),
    [anon_sym_non_DASHsealed] = ACTIONS(869),
    [anon_sym_ATinterface] = ACTIONS(869),
    [anon_sym_interface] = ACTIONS(871),
    [anon_sym_byte] = ACTIONS(871),
    [anon_sym_short] = ACTIONS(871),
    [anon_sym_int] = ACTIONS(871),
    [anon_sym_long] = ACTIONS(871),
    [anon_sym_char] = ACTIONS(871),
    [anon_sym_float] = ACTIONS(871),
    [anon_sym_double] = ACTIONS(871),
    [sym_boolean_type] = ACTIONS(871),
    [sym_void_type] = ACTIONS(871),
    [sym_this] = ACTIONS(871),
    [sym_super] = ACTIONS(871),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [211] = {
    [ts_builtin_sym_end] = ACTIONS(873),
    [sym_identifier] = ACTIONS(875),
    [sym_decimal_integer_literal] = ACTIONS(875),
    [sym_hex_integer_literal] = ACTIONS(875),
    [sym_octal_integer_literal] = ACTIONS(873),
    [sym_binary_integer_literal] = ACTIONS(873),
    [sym_decimal_floating_point_literal] = ACTIONS(873),
    [sym_hex_floating_point_literal] = ACTIONS(875),
    [sym_true] = ACTIONS(875),
    [sym_false] = ACTIONS(875),
    [sym_character_literal] = ACTIONS(873),
    [sym_string_literal] = ACTIONS(875),
    [sym_text_block] = ACTIONS(873),
    [sym_null_literal] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(873),
    [anon_sym_PLUS] = ACTIONS(875),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_BANG] = ACTIONS(873),
    [anon_sym_TILDE] = ACTIONS(873),
    [anon_sym_PLUS_PLUS] = ACTIONS(873),
    [anon_sym_DASH_DASH] = ACTIONS(873),
    [anon_sym_new] = ACTIONS(875),
    [anon_sym_class] = ACTIONS(875),
    [anon_sym_switch] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(873),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_case] = ACTIONS(875),
    [anon_sym_default] = ACTIONS(875),
    [anon_sym_SEMI] = ACTIONS(873),
    [anon_sym_assert] = ACTIONS(875),
    [anon_sym_do] = ACTIONS(875),
    [anon_sym_while] = ACTIONS(875),
    [anon_sym_break] = ACTIONS(875),
    [anon_sym_continue] = ACTIONS(875),
    [anon_sym_return] = ACTIONS(875),
    [anon_sym_yield] = ACTIONS(875),
    [anon_sym_synchronized] = ACTIONS(875),
    [anon_sym_throw] = ACTIONS(875),
    [anon_sym_try] = ACTIONS(875),
    [anon_sym_if] = ACTIONS(875),
    [anon_sym_else] = ACTIONS(875),
    [anon_sym_for] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(875),
    [anon_sym_open] = ACTIONS(875),
    [anon_sym_module] = ACTIONS(875),
    [anon_sym_static] = ACTIONS(875),
    [anon_sym_package] = ACTIONS(875),
    [anon_sym_import] = ACTIONS(875),
    [anon_sym_enum] = ACTIONS(875),
    [anon_sym_public] = ACTIONS(875),
    [anon_sym_protected] = ACTIONS(875),
    [anon_sym_private] = ACTIONS(875),
    [anon_sym_abstract] = ACTIONS(875),
    [anon_sym_final] = ACTIONS(875),
    [anon_sym_strictfp] = ACTIONS(875),
    [anon_sym_native] = ACTIONS(875),
    [anon_sym_transient] = ACTIONS(875),
    [anon_sym_volatile] = ACTIONS(875),
    [anon_sym_sealed] = ACTIONS(875),
    [anon_sym_non_DASHsealed] = ACTIONS(873),
    [anon_sym_ATinterface] = ACTIONS(873),
    [anon_sym_interface] = ACTIONS(875),
    [anon_sym_byte] = ACTIONS(875),
    [anon_sym_short] = ACTIONS(875),
    [anon_sym_int] = ACTIONS(875),
    [anon_sym_long] = ACTIONS(875),
    [anon_sym_char] = ACTIONS(875),
    [anon_sym_float] = ACTIONS(875),
    [anon_sym_double] = ACTIONS(875),
    [sym_boolean_type] = ACTIONS(875),
    [sym_void_type] = ACTIONS(875),
    [sym_this] = ACTIONS(875),
    [sym_super] = ACTIONS(875),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [212] = {
    [ts_builtin_sym_end] = ACTIONS(877),
    [sym_identifier] = ACTIONS(879),
    [sym_decimal_integer_literal] = ACTIONS(879),
    [sym_hex_integer_literal] = ACTIONS(879),
    [sym_octal_integer_literal] = ACTIONS(877),
    [sym_binary_integer_literal] = ACTIONS(877),
    [sym_decimal_floating_point_literal] = ACTIONS(877),
    [sym_hex_floating_point_literal] = ACTIONS(879),
    [sym_true] = ACTIONS(879),
    [sym_false] = ACTIONS(879),
    [sym_character_literal] = ACTIONS(877),
    [sym_string_literal] = ACTIONS(879),
    [sym_text_block] = ACTIONS(877),
    [sym_null_literal] = ACTIONS(879),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_TILDE] = ACTIONS(877),
    [anon_sym_PLUS_PLUS] = ACTIONS(877),
    [anon_sym_DASH_DASH] = ACTIONS(877),
    [anon_sym_new] = ACTIONS(879),
    [anon_sym_class] = ACTIONS(879),
    [anon_sym_switch] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(877),
    [anon_sym_RBRACE] = ACTIONS(877),
    [anon_sym_case] = ACTIONS(879),
    [anon_sym_default] = ACTIONS(879),
    [anon_sym_SEMI] = ACTIONS(877),
    [anon_sym_assert] = ACTIONS(879),
    [anon_sym_do] = ACTIONS(879),
    [anon_sym_while] = ACTIONS(879),
    [anon_sym_break] = ACTIONS(879),
    [anon_sym_continue] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(879),
    [anon_sym_yield] = ACTIONS(879),
    [anon_sym_synchronized] = ACTIONS(879),
    [anon_sym_throw] = ACTIONS(879),
    [anon_sym_try] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_else] = ACTIONS(879),
    [anon_sym_for] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_open] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_static] = ACTIONS(879),
    [anon_sym_package] = ACTIONS(879),
    [anon_sym_import] = ACTIONS(879),
    [anon_sym_enum] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_abstract] = ACTIONS(879),
    [anon_sym_final] = ACTIONS(879),
    [anon_sym_strictfp] = ACTIONS(879),
    [anon_sym_native] = ACTIONS(879),
    [anon_sym_transient] = ACTIONS(879),
    [anon_sym_volatile] = ACTIONS(879),
    [anon_sym_sealed] = ACTIONS(879),
    [anon_sym_non_DASHsealed] = ACTIONS(877),
    [anon_sym_ATinterface] = ACTIONS(877),
    [anon_sym_interface] = ACTIONS(879),
    [anon_sym_byte] = ACTIONS(879),
    [anon_sym_short] = ACTIONS(879),
    [anon_sym_int] = ACTIONS(879),
    [anon_sym_long] = ACTIONS(879),
    [anon_sym_char] = ACTIONS(879),
    [anon_sym_float] = ACTIONS(879),
    [anon_sym_double] = ACTIONS(879),
    [sym_boolean_type] = ACTIONS(879),
    [sym_void_type] = ACTIONS(879),
    [sym_this] = ACTIONS(879),
    [sym_super] = ACTIONS(879),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [213] = {
    [ts_builtin_sym_end] = ACTIONS(881),
    [sym_identifier] = ACTIONS(883),
    [sym_decimal_integer_literal] = ACTIONS(883),
    [sym_hex_integer_literal] = ACTIONS(883),
    [sym_octal_integer_literal] = ACTIONS(881),
    [sym_binary_integer_literal] = ACTIONS(881),
    [sym_decimal_floating_point_literal] = ACTIONS(881),
    [sym_hex_floating_point_literal] = ACTIONS(883),
    [sym_true] = ACTIONS(883),
    [sym_false] = ACTIONS(883),
    [sym_character_literal] = ACTIONS(881),
    [sym_string_literal] = ACTIONS(883),
    [sym_text_block] = ACTIONS(881),
    [sym_null_literal] = ACTIONS(883),
    [anon_sym_LPAREN] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(883),
    [anon_sym_DASH] = ACTIONS(883),
    [anon_sym_BANG] = ACTIONS(881),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_PLUS_PLUS] = ACTIONS(881),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [anon_sym_new] = ACTIONS(883),
    [anon_sym_class] = ACTIONS(883),
    [anon_sym_switch] = ACTIONS(883),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(883),
    [anon_sym_default] = ACTIONS(883),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_assert] = ACTIONS(883),
    [anon_sym_do] = ACTIONS(883),
    [anon_sym_while] = ACTIONS(883),
    [anon_sym_break] = ACTIONS(883),
    [anon_sym_continue] = ACTIONS(883),
    [anon_sym_return] = ACTIONS(883),
    [anon_sym_yield] = ACTIONS(883),
    [anon_sym_synchronized] = ACTIONS(883),
    [anon_sym_throw] = ACTIONS(883),
    [anon_sym_try] = ACTIONS(883),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_for] = ACTIONS(883),
    [anon_sym_AT] = ACTIONS(883),
    [anon_sym_open] = ACTIONS(883),
    [anon_sym_module] = ACTIONS(883),
    [anon_sym_static] = ACTIONS(883),
    [anon_sym_package] = ACTIONS(883),
    [anon_sym_import] = ACTIONS(883),
    [anon_sym_enum] = ACTIONS(883),
    [anon_sym_public] = ACTIONS(883),
    [anon_sym_protected] = ACTIONS(883),
    [anon_sym_private] = ACTIONS(883),
    [anon_sym_abstract] = ACTIONS(883),
    [anon_sym_final] = ACTIONS(883),
    [anon_sym_strictfp] = ACTIONS(883),
    [anon_sym_native] = ACTIONS(883),
    [anon_sym_transient] = ACTIONS(883),
    [anon_sym_volatile] = ACTIONS(883),
    [anon_sym_sealed] = ACTIONS(883),
    [anon_sym_non_DASHsealed] = ACTIONS(881),
    [anon_sym_ATinterface] = ACTIONS(881),
    [anon_sym_interface] = ACTIONS(883),
    [anon_sym_byte] = ACTIONS(883),
    [anon_sym_short] = ACTIONS(883),
    [anon_sym_int] = ACTIONS(883),
    [anon_sym_long] = ACTIONS(883),
    [anon_sym_char] = ACTIONS(883),
    [anon_sym_float] = ACTIONS(883),
    [anon_sym_double] = ACTIONS(883),
    [sym_boolean_type] = ACTIONS(883),
    [sym_void_type] = ACTIONS(883),
    [sym_this] = ACTIONS(883),
    [sym_super] = ACTIONS(883),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [214] = {
    [ts_builtin_sym_end] = ACTIONS(885),
    [sym_identifier] = ACTIONS(887),
    [sym_decimal_integer_literal] = ACTIONS(887),
    [sym_hex_integer_literal] = ACTIONS(887),
    [sym_octal_integer_literal] = ACTIONS(885),
    [sym_binary_integer_literal] = ACTIONS(885),
    [sym_decimal_floating_point_literal] = ACTIONS(885),
    [sym_hex_floating_point_literal] = ACTIONS(887),
    [sym_true] = ACTIONS(887),
    [sym_false] = ACTIONS(887),
    [sym_character_literal] = ACTIONS(885),
    [sym_string_literal] = ACTIONS(887),
    [sym_text_block] = ACTIONS(885),
    [sym_null_literal] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_PLUS] = ACTIONS(887),
    [anon_sym_DASH] = ACTIONS(887),
    [anon_sym_BANG] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_PLUS_PLUS] = ACTIONS(885),
    [anon_sym_DASH_DASH] = ACTIONS(885),
    [anon_sym_new] = ACTIONS(887),
    [anon_sym_class] = ACTIONS(887),
    [anon_sym_switch] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(885),
    [anon_sym_RBRACE] = ACTIONS(885),
    [anon_sym_case] = ACTIONS(887),
    [anon_sym_default] = ACTIONS(887),
    [anon_sym_SEMI] = ACTIONS(885),
    [anon_sym_assert] = ACTIONS(887),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_break] = ACTIONS(887),
    [anon_sym_continue] = ACTIONS(887),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(887),
    [anon_sym_synchronized] = ACTIONS(887),
    [anon_sym_throw] = ACTIONS(887),
    [anon_sym_try] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(887),
    [anon_sym_open] = ACTIONS(887),
    [anon_sym_module] = ACTIONS(887),
    [anon_sym_static] = ACTIONS(887),
    [anon_sym_package] = ACTIONS(887),
    [anon_sym_import] = ACTIONS(887),
    [anon_sym_enum] = ACTIONS(887),
    [anon_sym_public] = ACTIONS(887),
    [anon_sym_protected] = ACTIONS(887),
    [anon_sym_private] = ACTIONS(887),
    [anon_sym_abstract] = ACTIONS(887),
    [anon_sym_final] = ACTIONS(887),
    [anon_sym_strictfp] = ACTIONS(887),
    [anon_sym_native] = ACTIONS(887),
    [anon_sym_transient] = ACTIONS(887),
    [anon_sym_volatile] = ACTIONS(887),
    [anon_sym_sealed] = ACTIONS(887),
    [anon_sym_non_DASHsealed] = ACTIONS(885),
    [anon_sym_ATinterface] = ACTIONS(885),
    [anon_sym_interface] = ACTIONS(887),
    [anon_sym_byte] = ACTIONS(887),
    [anon_sym_short] = ACTIONS(887),
    [anon_sym_int] = ACTIONS(887),
    [anon_sym_long] = ACTIONS(887),
    [anon_sym_char] = ACTIONS(887),
    [anon_sym_float] = ACTIONS(887),
    [anon_sym_double] = ACTIONS(887),
    [sym_boolean_type] = ACTIONS(887),
    [sym_void_type] = ACTIONS(887),
    [sym_this] = ACTIONS(887),
    [sym_super] = ACTIONS(887),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [215] = {
    [ts_builtin_sym_end] = ACTIONS(889),
    [sym_identifier] = ACTIONS(891),
    [sym_decimal_integer_literal] = ACTIONS(891),
    [sym_hex_integer_literal] = ACTIONS(891),
    [sym_octal_integer_literal] = ACTIONS(889),
    [sym_binary_integer_literal] = ACTIONS(889),
    [sym_decimal_floating_point_literal] = ACTIONS(889),
    [sym_hex_floating_point_literal] = ACTIONS(891),
    [sym_true] = ACTIONS(891),
    [sym_false] = ACTIONS(891),
    [sym_character_literal] = ACTIONS(889),
    [sym_string_literal] = ACTIONS(891),
    [sym_text_block] = ACTIONS(889),
    [sym_null_literal] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(889),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_BANG] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(889),
    [anon_sym_PLUS_PLUS] = ACTIONS(889),
    [anon_sym_DASH_DASH] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(891),
    [anon_sym_class] = ACTIONS(891),
    [anon_sym_switch] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(889),
    [anon_sym_case] = ACTIONS(891),
    [anon_sym_default] = ACTIONS(891),
    [anon_sym_SEMI] = ACTIONS(889),
    [anon_sym_assert] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_break] = ACTIONS(891),
    [anon_sym_continue] = ACTIONS(891),
    [anon_sym_return] = ACTIONS(891),
    [anon_sym_yield] = ACTIONS(891),
    [anon_sym_synchronized] = ACTIONS(891),
    [anon_sym_throw] = ACTIONS(891),
    [anon_sym_try] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_for] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(891),
    [anon_sym_open] = ACTIONS(891),
    [anon_sym_module] = ACTIONS(891),
    [anon_sym_static] = ACTIONS(891),
    [anon_sym_package] = ACTIONS(891),
    [anon_sym_import] = ACTIONS(891),
    [anon_sym_enum] = ACTIONS(891),
    [anon_sym_public] = ACTIONS(891),
    [anon_sym_protected] = ACTIONS(891),
    [anon_sym_private] = ACTIONS(891),
    [anon_sym_abstract] = ACTIONS(891),
    [anon_sym_final] = ACTIONS(891),
    [anon_sym_strictfp] = ACTIONS(891),
    [anon_sym_native] = ACTIONS(891),
    [anon_sym_transient] = ACTIONS(891),
    [anon_sym_volatile] = ACTIONS(891),
    [anon_sym_sealed] = ACTIONS(891),
    [anon_sym_non_DASHsealed] = ACTIONS(889),
    [anon_sym_ATinterface] = ACTIONS(889),
    [anon_sym_interface] = ACTIONS(891),
    [anon_sym_byte] = ACTIONS(891),
    [anon_sym_short] = ACTIONS(891),
    [anon_sym_int] = ACTIONS(891),
    [anon_sym_long] = ACTIONS(891),
    [anon_sym_char] = ACTIONS(891),
    [anon_sym_float] = ACTIONS(891),
    [anon_sym_double] = ACTIONS(891),
    [sym_boolean_type] = ACTIONS(891),
    [sym_void_type] = ACTIONS(891),
    [sym_this] = ACTIONS(891),
    [sym_super] = ACTIONS(891),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [216] = {
    [ts_builtin_sym_end] = ACTIONS(893),
    [sym_identifier] = ACTIONS(895),
    [sym_decimal_integer_literal] = ACTIONS(895),
    [sym_hex_integer_literal] = ACTIONS(895),
    [sym_octal_integer_literal] = ACTIONS(893),
    [sym_binary_integer_literal] = ACTIONS(893),
    [sym_decimal_floating_point_literal] = ACTIONS(893),
    [sym_hex_floating_point_literal] = ACTIONS(895),
    [sym_true] = ACTIONS(895),
    [sym_false] = ACTIONS(895),
    [sym_character_literal] = ACTIONS(893),
    [sym_string_literal] = ACTIONS(895),
    [sym_text_block] = ACTIONS(893),
    [sym_null_literal] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(893),
    [anon_sym_DASH_DASH] = ACTIONS(893),
    [anon_sym_new] = ACTIONS(895),
    [anon_sym_class] = ACTIONS(895),
    [anon_sym_switch] = ACTIONS(895),
    [anon_sym_LBRACE] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(893),
    [anon_sym_case] = ACTIONS(895),
    [anon_sym_default] = ACTIONS(895),
    [anon_sym_SEMI] = ACTIONS(893),
    [anon_sym_assert] = ACTIONS(895),
    [anon_sym_do] = ACTIONS(895),
    [anon_sym_while] = ACTIONS(895),
    [anon_sym_break] = ACTIONS(895),
    [anon_sym_continue] = ACTIONS(895),
    [anon_sym_return] = ACTIONS(895),
    [anon_sym_yield] = ACTIONS(895),
    [anon_sym_synchronized] = ACTIONS(895),
    [anon_sym_throw] = ACTIONS(895),
    [anon_sym_try] = ACTIONS(895),
    [anon_sym_if] = ACTIONS(895),
    [anon_sym_else] = ACTIONS(895),
    [anon_sym_for] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(895),
    [anon_sym_open] = ACTIONS(895),
    [anon_sym_module] = ACTIONS(895),
    [anon_sym_static] = ACTIONS(895),
    [anon_sym_package] = ACTIONS(895),
    [anon_sym_import] = ACTIONS(895),
    [anon_sym_enum] = ACTIONS(895),
    [anon_sym_public] = ACTIONS(895),
    [anon_sym_protected] = ACTIONS(895),
    [anon_sym_private] = ACTIONS(895),
    [anon_sym_abstract] = ACTIONS(895),
    [anon_sym_final] = ACTIONS(895),
    [anon_sym_strictfp] = ACTIONS(895),
    [anon_sym_native] = ACTIONS(895),
    [anon_sym_transient] = ACTIONS(895),
    [anon_sym_volatile] = ACTIONS(895),
    [anon_sym_sealed] = ACTIONS(895),
    [anon_sym_non_DASHsealed] = ACTIONS(893),
    [anon_sym_ATinterface] = ACTIONS(893),
    [anon_sym_interface] = ACTIONS(895),
    [anon_sym_byte] = ACTIONS(895),
    [anon_sym_short] = ACTIONS(895),
    [anon_sym_int] = ACTIONS(895),
    [anon_sym_long] = ACTIONS(895),
    [anon_sym_char] = ACTIONS(895),
    [anon_sym_float] = ACTIONS(895),
    [anon_sym_double] = ACTIONS(895),
    [sym_boolean_type] = ACTIONS(895),
    [sym_void_type] = ACTIONS(895),
    [sym_this] = ACTIONS(895),
    [sym_super] = ACTIONS(895),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [217] = {
    [ts_builtin_sym_end] = ACTIONS(897),
    [sym_identifier] = ACTIONS(899),
    [sym_decimal_integer_literal] = ACTIONS(899),
    [sym_hex_integer_literal] = ACTIONS(899),
    [sym_octal_integer_literal] = ACTIONS(897),
    [sym_binary_integer_literal] = ACTIONS(897),
    [sym_decimal_floating_point_literal] = ACTIONS(897),
    [sym_hex_floating_point_literal] = ACTIONS(899),
    [sym_true] = ACTIONS(899),
    [sym_false] = ACTIONS(899),
    [sym_character_literal] = ACTIONS(897),
    [sym_string_literal] = ACTIONS(899),
    [sym_text_block] = ACTIONS(897),
    [sym_null_literal] = ACTIONS(899),
    [anon_sym_LPAREN] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_BANG] = ACTIONS(897),
    [anon_sym_TILDE] = ACTIONS(897),
    [anon_sym_PLUS_PLUS] = ACTIONS(897),
    [anon_sym_DASH_DASH] = ACTIONS(897),
    [anon_sym_new] = ACTIONS(899),
    [anon_sym_class] = ACTIONS(899),
    [anon_sym_switch] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_case] = ACTIONS(899),
    [anon_sym_default] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_assert] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(899),
    [anon_sym_while] = ACTIONS(899),
    [anon_sym_break] = ACTIONS(899),
    [anon_sym_continue] = ACTIONS(899),
    [anon_sym_return] = ACTIONS(899),
    [anon_sym_yield] = ACTIONS(899),
    [anon_sym_synchronized] = ACTIONS(899),
    [anon_sym_throw] = ACTIONS(899),
    [anon_sym_try] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(899),
    [anon_sym_else] = ACTIONS(899),
    [anon_sym_for] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(899),
    [anon_sym_open] = ACTIONS(899),
    [anon_sym_module] = ACTIONS(899),
    [anon_sym_static] = ACTIONS(899),
    [anon_sym_package] = ACTIONS(899),
    [anon_sym_import] = ACTIONS(899),
    [anon_sym_enum] = ACTIONS(899),
    [anon_sym_public] = ACTIONS(899),
    [anon_sym_protected] = ACTIONS(899),
    [anon_sym_private] = ACTIONS(899),
    [anon_sym_abstract] = ACTIONS(899),
    [anon_sym_final] = ACTIONS(899),
    [anon_sym_strictfp] = ACTIONS(899),
    [anon_sym_native] = ACTIONS(899),
    [anon_sym_transient] = ACTIONS(899),
    [anon_sym_volatile] = ACTIONS(899),
    [anon_sym_sealed] = ACTIONS(899),
    [anon_sym_non_DASHsealed] = ACTIONS(897),
    [anon_sym_ATinterface] = ACTIONS(897),
    [anon_sym_interface] = ACTIONS(899),
    [anon_sym_byte] = ACTIONS(899),
    [anon_sym_short] = ACTIONS(899),
    [anon_sym_int] = ACTIONS(899),
    [anon_sym_long] = ACTIONS(899),
    [anon_sym_char] = ACTIONS(899),
    [anon_sym_float] = ACTIONS(899),
    [anon_sym_double] = ACTIONS(899),
    [sym_boolean_type] = ACTIONS(899),
    [sym_void_type] = ACTIONS(899),
    [sym_this] = ACTIONS(899),
    [sym_super] = ACTIONS(899),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(509),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(532),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(504),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(549),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(501),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(487),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(488),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(913),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [225] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(489),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(915),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [226] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(499),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(917),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [227] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(490),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(919),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [228] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(548),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(921),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [229] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(544),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(923),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [230] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(531),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(925),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [231] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(508),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [232] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(548),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(929),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [233] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(529),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [234] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(531),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_RBRACK] = ACTIONS(933),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [235] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(534),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [236] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(435),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [237] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(535),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [238] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(510),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [239] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(495),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [240] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(519),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [241] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(494),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [242] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(431),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [243] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(460),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [244] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(543),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [245] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(516),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [246] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(518),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [247] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(456),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [248] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(497),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [249] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(444),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [250] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(445),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [251] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(455),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [252] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(454),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [253] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(435),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [254] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(541),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [255] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(540),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [256] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(453),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [257] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(512),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [258] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(479),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [259] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(536),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [260] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(432),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [261] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(433),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [262] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(481),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [263] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(547),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [264] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(482),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [265] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(446),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [266] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(431),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [267] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(483),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [268] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(439),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [269] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(485),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [270] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(517),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [271] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(486),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_identifier] = ACTIONS(693),
    [sym_decimal_integer_literal] = ACTIONS(693),
    [sym_hex_integer_literal] = ACTIONS(693),
    [sym_octal_integer_literal] = ACTIONS(695),
    [sym_binary_integer_literal] = ACTIONS(695),
    [sym_decimal_floating_point_literal] = ACTIONS(695),
    [sym_hex_floating_point_literal] = ACTIONS(693),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [sym_string_literal] = ACTIONS(693),
    [sym_text_block] = ACTIONS(695),
    [sym_null_literal] = ACTIONS(693),
    [anon_sym_LPAREN] = ACTIONS(695),
    [anon_sym_PLUS] = ACTIONS(693),
    [anon_sym_DASH] = ACTIONS(693),
    [anon_sym_BANG] = ACTIONS(695),
    [anon_sym_TILDE] = ACTIONS(695),
    [anon_sym_PLUS_PLUS] = ACTIONS(695),
    [anon_sym_DASH_DASH] = ACTIONS(695),
    [anon_sym_new] = ACTIONS(693),
    [anon_sym_class] = ACTIONS(693),
    [anon_sym_switch] = ACTIONS(693),
    [anon_sym_LBRACE] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym_case] = ACTIONS(693),
    [anon_sym_default] = ACTIONS(693),
    [anon_sym_SEMI] = ACTIONS(695),
    [anon_sym_assert] = ACTIONS(693),
    [anon_sym_do] = ACTIONS(693),
    [anon_sym_while] = ACTIONS(693),
    [anon_sym_break] = ACTIONS(693),
    [anon_sym_continue] = ACTIONS(693),
    [anon_sym_return] = ACTIONS(693),
    [anon_sym_yield] = ACTIONS(693),
    [anon_sym_synchronized] = ACTIONS(693),
    [anon_sym_throw] = ACTIONS(693),
    [anon_sym_try] = ACTIONS(693),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_for] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(693),
    [anon_sym_open] = ACTIONS(693),
    [anon_sym_module] = ACTIONS(693),
    [anon_sym_static] = ACTIONS(693),
    [anon_sym_package] = ACTIONS(693),
    [anon_sym_import] = ACTIONS(693),
    [anon_sym_enum] = ACTIONS(693),
    [anon_sym_public] = ACTIONS(693),
    [anon_sym_protected] = ACTIONS(693),
    [anon_sym_private] = ACTIONS(693),
    [anon_sym_abstract] = ACTIONS(693),
    [anon_sym_final] = ACTIONS(693),
    [anon_sym_strictfp] = ACTIONS(693),
    [anon_sym_native] = ACTIONS(693),
    [anon_sym_transient] = ACTIONS(693),
    [anon_sym_volatile] = ACTIONS(693),
    [anon_sym_sealed] = ACTIONS(693),
    [anon_sym_non_DASHsealed] = ACTIONS(695),
    [anon_sym_ATinterface] = ACTIONS(695),
    [anon_sym_interface] = ACTIONS(693),
    [anon_sym_byte] = ACTIONS(693),
    [anon_sym_short] = ACTIONS(693),
    [anon_sym_int] = ACTIONS(693),
    [anon_sym_long] = ACTIONS(693),
    [anon_sym_char] = ACTIONS(693),
    [anon_sym_float] = ACTIONS(693),
    [anon_sym_double] = ACTIONS(693),
    [sym_boolean_type] = ACTIONS(693),
    [sym_void_type] = ACTIONS(693),
    [sym_this] = ACTIONS(693),
    [sym_super] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [273] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(542),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [274] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(521),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [275] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(466),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [276] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(506),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [277] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(491),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [278] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(523),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [279] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(546),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [280] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(538),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [281] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(439),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [282] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(448),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [283] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(548),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [284] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(513),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [285] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(432),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [286] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(531),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [287] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(433),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [288] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(450),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [289] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(452),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1073),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(323),
    [sym_array_access] = STATE(323),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1073),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(288),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_BANG] = ACTIONS(17),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_PLUS_PLUS] = ACTIONS(19),
    [anon_sym_DASH_DASH] = ACTIONS(19),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(284),
    [anon_sym_module] = ACTIONS(284),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [290] = {
    [sym__literal] = STATE(381),
    [sym_expression] = STATE(475),
    [sym_cast_expression] = STATE(437),
    [sym_assignment_expression] = STATE(437),
    [sym_binary_expression] = STATE(437),
    [sym_instanceof_expression] = STATE(437),
    [sym_lambda_expression] = STATE(437),
    [sym_inferred_parameters] = STATE(1102),
    [sym_ternary_expression] = STATE(437),
    [sym_unary_expression] = STATE(437),
    [sym_update_expression] = STATE(437),
    [sym_primary_expression] = STATE(407),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(329),
    [sym_array_access] = STATE(329),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_switch_expression] = STATE(441),
    [sym__annotation] = STATE(572),
    [sym_marker_annotation] = STATE(572),
    [sym_annotation] = STATE(572),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(657),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [sym_formal_parameters] = STATE(1102),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [sym_identifier] = ACTIONS(795),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(797),
    [anon_sym_PLUS] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(803),
    [anon_sym_DASH_DASH] = ACTIONS(803),
    [anon_sym_new] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(25),
    [anon_sym_AT] = ACTIONS(321),
    [anon_sym_open] = ACTIONS(805),
    [anon_sym_module] = ACTIONS(805),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [291] = {
    [sym__literal] = STATE(381),
    [sym_primary_expression] = STATE(874),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(752),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_resource] = STATE(1028),
    [sym__annotation] = STATE(526),
    [sym_marker_annotation] = STATE(526),
    [sym_annotation] = STATE(526),
    [sym_modifiers] = STATE(605),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(620),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [aux_sym_modifiers_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(937),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(280),
    [anon_sym_synchronized] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(282),
    [anon_sym_open] = ACTIONS(945),
    [anon_sym_module] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_abstract] = ACTIONS(280),
    [anon_sym_final] = ACTIONS(280),
    [anon_sym_strictfp] = ACTIONS(280),
    [anon_sym_native] = ACTIONS(280),
    [anon_sym_transient] = ACTIONS(280),
    [anon_sym_volatile] = ACTIONS(280),
    [anon_sym_sealed] = ACTIONS(280),
    [anon_sym_non_DASHsealed] = ACTIONS(286),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_identifier] = ACTIONS(947),
    [sym_decimal_integer_literal] = ACTIONS(947),
    [sym_hex_integer_literal] = ACTIONS(947),
    [sym_octal_integer_literal] = ACTIONS(949),
    [sym_binary_integer_literal] = ACTIONS(949),
    [sym_decimal_floating_point_literal] = ACTIONS(949),
    [sym_hex_floating_point_literal] = ACTIONS(947),
    [sym_true] = ACTIONS(947),
    [sym_false] = ACTIONS(947),
    [sym_character_literal] = ACTIONS(949),
    [sym_string_literal] = ACTIONS(947),
    [sym_text_block] = ACTIONS(949),
    [sym_null_literal] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(949),
    [anon_sym_PLUS] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_TILDE] = ACTIONS(949),
    [anon_sym_PLUS_PLUS] = ACTIONS(949),
    [anon_sym_DASH_DASH] = ACTIONS(949),
    [anon_sym_new] = ACTIONS(947),
    [anon_sym_class] = ACTIONS(947),
    [anon_sym_switch] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym_default] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(949),
    [anon_sym_assert] = ACTIONS(947),
    [anon_sym_do] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(947),
    [anon_sym_break] = ACTIONS(947),
    [anon_sym_continue] = ACTIONS(947),
    [anon_sym_return] = ACTIONS(947),
    [anon_sym_yield] = ACTIONS(947),
    [anon_sym_synchronized] = ACTIONS(947),
    [anon_sym_throw] = ACTIONS(947),
    [anon_sym_try] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(947),
    [anon_sym_open] = ACTIONS(947),
    [anon_sym_module] = ACTIONS(947),
    [anon_sym_static] = ACTIONS(947),
    [anon_sym_package] = ACTIONS(947),
    [anon_sym_import] = ACTIONS(947),
    [anon_sym_enum] = ACTIONS(947),
    [anon_sym_public] = ACTIONS(947),
    [anon_sym_protected] = ACTIONS(947),
    [anon_sym_private] = ACTIONS(947),
    [anon_sym_abstract] = ACTIONS(947),
    [anon_sym_final] = ACTIONS(947),
    [anon_sym_strictfp] = ACTIONS(947),
    [anon_sym_native] = ACTIONS(947),
    [anon_sym_transient] = ACTIONS(947),
    [anon_sym_volatile] = ACTIONS(947),
    [anon_sym_sealed] = ACTIONS(947),
    [anon_sym_non_DASHsealed] = ACTIONS(949),
    [anon_sym_ATinterface] = ACTIONS(949),
    [anon_sym_interface] = ACTIONS(947),
    [anon_sym_byte] = ACTIONS(947),
    [anon_sym_short] = ACTIONS(947),
    [anon_sym_int] = ACTIONS(947),
    [anon_sym_long] = ACTIONS(947),
    [anon_sym_char] = ACTIONS(947),
    [anon_sym_float] = ACTIONS(947),
    [anon_sym_double] = ACTIONS(947),
    [sym_boolean_type] = ACTIONS(947),
    [sym_void_type] = ACTIONS(947),
    [sym_this] = ACTIONS(947),
    [sym_super] = ACTIONS(947),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_identifier] = ACTIONS(951),
    [sym_decimal_integer_literal] = ACTIONS(951),
    [sym_hex_integer_literal] = ACTIONS(951),
    [sym_octal_integer_literal] = ACTIONS(953),
    [sym_binary_integer_literal] = ACTIONS(953),
    [sym_decimal_floating_point_literal] = ACTIONS(953),
    [sym_hex_floating_point_literal] = ACTIONS(951),
    [sym_true] = ACTIONS(951),
    [sym_false] = ACTIONS(951),
    [sym_character_literal] = ACTIONS(953),
    [sym_string_literal] = ACTIONS(951),
    [sym_text_block] = ACTIONS(953),
    [sym_null_literal] = ACTIONS(951),
    [anon_sym_LPAREN] = ACTIONS(953),
    [anon_sym_PLUS] = ACTIONS(951),
    [anon_sym_DASH] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(953),
    [anon_sym_TILDE] = ACTIONS(953),
    [anon_sym_PLUS_PLUS] = ACTIONS(953),
    [anon_sym_DASH_DASH] = ACTIONS(953),
    [anon_sym_new] = ACTIONS(951),
    [anon_sym_class] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(953),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym_default] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(953),
    [anon_sym_assert] = ACTIONS(951),
    [anon_sym_do] = ACTIONS(951),
    [anon_sym_while] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(951),
    [anon_sym_continue] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_synchronized] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(951),
    [anon_sym_try] = ACTIONS(951),
    [anon_sym_if] = ACTIONS(951),
    [anon_sym_for] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(951),
    [anon_sym_open] = ACTIONS(951),
    [anon_sym_module] = ACTIONS(951),
    [anon_sym_static] = ACTIONS(951),
    [anon_sym_package] = ACTIONS(951),
    [anon_sym_import] = ACTIONS(951),
    [anon_sym_enum] = ACTIONS(951),
    [anon_sym_public] = ACTIONS(951),
    [anon_sym_protected] = ACTIONS(951),
    [anon_sym_private] = ACTIONS(951),
    [anon_sym_abstract] = ACTIONS(951),
    [anon_sym_final] = ACTIONS(951),
    [anon_sym_strictfp] = ACTIONS(951),
    [anon_sym_native] = ACTIONS(951),
    [anon_sym_transient] = ACTIONS(951),
    [anon_sym_volatile] = ACTIONS(951),
    [anon_sym_sealed] = ACTIONS(951),
    [anon_sym_non_DASHsealed] = ACTIONS(953),
    [anon_sym_ATinterface] = ACTIONS(953),
    [anon_sym_interface] = ACTIONS(951),
    [anon_sym_byte] = ACTIONS(951),
    [anon_sym_short] = ACTIONS(951),
    [anon_sym_int] = ACTIONS(951),
    [anon_sym_long] = ACTIONS(951),
    [anon_sym_char] = ACTIONS(951),
    [anon_sym_float] = ACTIONS(951),
    [anon_sym_double] = ACTIONS(951),
    [sym_boolean_type] = ACTIONS(951),
    [sym_void_type] = ACTIONS(951),
    [sym_this] = ACTIONS(951),
    [sym_super] = ACTIONS(951),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [294] = {
    [sym__literal] = STATE(381),
    [sym_primary_expression] = STATE(874),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(752),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_resource] = STATE(1028),
    [sym__annotation] = STATE(526),
    [sym_marker_annotation] = STATE(526),
    [sym_annotation] = STATE(526),
    [sym_modifiers] = STATE(605),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(620),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [aux_sym_modifiers_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(937),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(280),
    [anon_sym_synchronized] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(282),
    [anon_sym_open] = ACTIONS(945),
    [anon_sym_module] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_abstract] = ACTIONS(280),
    [anon_sym_final] = ACTIONS(280),
    [anon_sym_strictfp] = ACTIONS(280),
    [anon_sym_native] = ACTIONS(280),
    [anon_sym_transient] = ACTIONS(280),
    [anon_sym_volatile] = ACTIONS(280),
    [anon_sym_sealed] = ACTIONS(280),
    [anon_sym_non_DASHsealed] = ACTIONS(286),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_identifier] = ACTIONS(957),
    [sym_decimal_integer_literal] = ACTIONS(957),
    [sym_hex_integer_literal] = ACTIONS(957),
    [sym_octal_integer_literal] = ACTIONS(959),
    [sym_binary_integer_literal] = ACTIONS(959),
    [sym_decimal_floating_point_literal] = ACTIONS(959),
    [sym_hex_floating_point_literal] = ACTIONS(957),
    [sym_true] = ACTIONS(957),
    [sym_false] = ACTIONS(957),
    [sym_character_literal] = ACTIONS(959),
    [sym_string_literal] = ACTIONS(957),
    [sym_text_block] = ACTIONS(959),
    [sym_null_literal] = ACTIONS(957),
    [anon_sym_LPAREN] = ACTIONS(959),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_DASH] = ACTIONS(957),
    [anon_sym_BANG] = ACTIONS(959),
    [anon_sym_TILDE] = ACTIONS(959),
    [anon_sym_PLUS_PLUS] = ACTIONS(959),
    [anon_sym_DASH_DASH] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(957),
    [anon_sym_class] = ACTIONS(957),
    [anon_sym_switch] = ACTIONS(957),
    [anon_sym_LBRACE] = ACTIONS(959),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym_default] = ACTIONS(957),
    [anon_sym_SEMI] = ACTIONS(959),
    [anon_sym_assert] = ACTIONS(957),
    [anon_sym_do] = ACTIONS(957),
    [anon_sym_while] = ACTIONS(957),
    [anon_sym_break] = ACTIONS(957),
    [anon_sym_continue] = ACTIONS(957),
    [anon_sym_return] = ACTIONS(957),
    [anon_sym_yield] = ACTIONS(957),
    [anon_sym_synchronized] = ACTIONS(957),
    [anon_sym_throw] = ACTIONS(957),
    [anon_sym_try] = ACTIONS(957),
    [anon_sym_if] = ACTIONS(957),
    [anon_sym_for] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(957),
    [anon_sym_open] = ACTIONS(957),
    [anon_sym_module] = ACTIONS(957),
    [anon_sym_static] = ACTIONS(957),
    [anon_sym_package] = ACTIONS(957),
    [anon_sym_import] = ACTIONS(957),
    [anon_sym_enum] = ACTIONS(957),
    [anon_sym_public] = ACTIONS(957),
    [anon_sym_protected] = ACTIONS(957),
    [anon_sym_private] = ACTIONS(957),
    [anon_sym_abstract] = ACTIONS(957),
    [anon_sym_final] = ACTIONS(957),
    [anon_sym_strictfp] = ACTIONS(957),
    [anon_sym_native] = ACTIONS(957),
    [anon_sym_transient] = ACTIONS(957),
    [anon_sym_volatile] = ACTIONS(957),
    [anon_sym_sealed] = ACTIONS(957),
    [anon_sym_non_DASHsealed] = ACTIONS(959),
    [anon_sym_ATinterface] = ACTIONS(959),
    [anon_sym_interface] = ACTIONS(957),
    [anon_sym_byte] = ACTIONS(957),
    [anon_sym_short] = ACTIONS(957),
    [anon_sym_int] = ACTIONS(957),
    [anon_sym_long] = ACTIONS(957),
    [anon_sym_char] = ACTIONS(957),
    [anon_sym_float] = ACTIONS(957),
    [anon_sym_double] = ACTIONS(957),
    [sym_boolean_type] = ACTIONS(957),
    [sym_void_type] = ACTIONS(957),
    [sym_this] = ACTIONS(957),
    [sym_super] = ACTIONS(957),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_identifier] = ACTIONS(961),
    [sym_decimal_integer_literal] = ACTIONS(961),
    [sym_hex_integer_literal] = ACTIONS(961),
    [sym_octal_integer_literal] = ACTIONS(963),
    [sym_binary_integer_literal] = ACTIONS(963),
    [sym_decimal_floating_point_literal] = ACTIONS(963),
    [sym_hex_floating_point_literal] = ACTIONS(961),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_character_literal] = ACTIONS(963),
    [sym_string_literal] = ACTIONS(961),
    [sym_text_block] = ACTIONS(963),
    [sym_null_literal] = ACTIONS(961),
    [anon_sym_LPAREN] = ACTIONS(963),
    [anon_sym_PLUS] = ACTIONS(961),
    [anon_sym_DASH] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [anon_sym_PLUS_PLUS] = ACTIONS(963),
    [anon_sym_DASH_DASH] = ACTIONS(963),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_class] = ACTIONS(961),
    [anon_sym_switch] = ACTIONS(961),
    [anon_sym_LBRACE] = ACTIONS(963),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym_default] = ACTIONS(961),
    [anon_sym_SEMI] = ACTIONS(963),
    [anon_sym_assert] = ACTIONS(961),
    [anon_sym_do] = ACTIONS(961),
    [anon_sym_while] = ACTIONS(961),
    [anon_sym_break] = ACTIONS(961),
    [anon_sym_continue] = ACTIONS(961),
    [anon_sym_return] = ACTIONS(961),
    [anon_sym_yield] = ACTIONS(961),
    [anon_sym_synchronized] = ACTIONS(961),
    [anon_sym_throw] = ACTIONS(961),
    [anon_sym_try] = ACTIONS(961),
    [anon_sym_if] = ACTIONS(961),
    [anon_sym_for] = ACTIONS(961),
    [anon_sym_AT] = ACTIONS(961),
    [anon_sym_open] = ACTIONS(961),
    [anon_sym_module] = ACTIONS(961),
    [anon_sym_static] = ACTIONS(961),
    [anon_sym_package] = ACTIONS(961),
    [anon_sym_import] = ACTIONS(961),
    [anon_sym_enum] = ACTIONS(961),
    [anon_sym_public] = ACTIONS(961),
    [anon_sym_protected] = ACTIONS(961),
    [anon_sym_private] = ACTIONS(961),
    [anon_sym_abstract] = ACTIONS(961),
    [anon_sym_final] = ACTIONS(961),
    [anon_sym_strictfp] = ACTIONS(961),
    [anon_sym_native] = ACTIONS(961),
    [anon_sym_transient] = ACTIONS(961),
    [anon_sym_volatile] = ACTIONS(961),
    [anon_sym_sealed] = ACTIONS(961),
    [anon_sym_non_DASHsealed] = ACTIONS(963),
    [anon_sym_ATinterface] = ACTIONS(963),
    [anon_sym_interface] = ACTIONS(961),
    [anon_sym_byte] = ACTIONS(961),
    [anon_sym_short] = ACTIONS(961),
    [anon_sym_int] = ACTIONS(961),
    [anon_sym_long] = ACTIONS(961),
    [anon_sym_char] = ACTIONS(961),
    [anon_sym_float] = ACTIONS(961),
    [anon_sym_double] = ACTIONS(961),
    [sym_boolean_type] = ACTIONS(961),
    [sym_void_type] = ACTIONS(961),
    [sym_this] = ACTIONS(961),
    [sym_super] = ACTIONS(961),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [297] = {
    [sym__literal] = STATE(381),
    [sym_primary_expression] = STATE(874),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(752),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_resource] = STATE(877),
    [sym__annotation] = STATE(526),
    [sym_marker_annotation] = STATE(526),
    [sym_annotation] = STATE(526),
    [sym_modifiers] = STATE(605),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(620),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [aux_sym_modifiers_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(937),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(280),
    [anon_sym_synchronized] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(282),
    [anon_sym_open] = ACTIONS(945),
    [anon_sym_module] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_abstract] = ACTIONS(280),
    [anon_sym_final] = ACTIONS(280),
    [anon_sym_strictfp] = ACTIONS(280),
    [anon_sym_native] = ACTIONS(280),
    [anon_sym_transient] = ACTIONS(280),
    [anon_sym_volatile] = ACTIONS(280),
    [anon_sym_sealed] = ACTIONS(280),
    [anon_sym_non_DASHsealed] = ACTIONS(286),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
  [298] = {
    [sym__literal] = STATE(381),
    [sym_primary_expression] = STATE(874),
    [sym_array_creation_expression] = STATE(381),
    [sym_parenthesized_expression] = STATE(381),
    [sym_class_literal] = STATE(381),
    [sym_object_creation_expression] = STATE(381),
    [sym__unqualified_object_creation_expression] = STATE(382),
    [sym_field_access] = STATE(752),
    [sym_array_access] = STATE(381),
    [sym_method_invocation] = STATE(381),
    [sym_method_reference] = STATE(381),
    [sym_resource] = STATE(1028),
    [sym__annotation] = STATE(526),
    [sym_marker_annotation] = STATE(526),
    [sym_annotation] = STATE(526),
    [sym_modifiers] = STATE(605),
    [sym__type] = STATE(1068),
    [sym__unannotated_type] = STATE(620),
    [sym_annotated_type] = STATE(666),
    [sym_scoped_type_identifier] = STATE(626),
    [sym_generic_type] = STATE(656),
    [sym_array_type] = STATE(593),
    [sym_integral_type] = STATE(593),
    [sym_floating_point_type] = STATE(593),
    [aux_sym_dimensions_expr_repeat1] = STATE(572),
    [aux_sym_modifiers_repeat1] = STATE(461),
    [sym_identifier] = ACTIONS(937),
    [sym_decimal_integer_literal] = ACTIONS(9),
    [sym_hex_integer_literal] = ACTIONS(9),
    [sym_octal_integer_literal] = ACTIONS(11),
    [sym_binary_integer_literal] = ACTIONS(11),
    [sym_decimal_floating_point_literal] = ACTIONS(11),
    [sym_hex_floating_point_literal] = ACTIONS(9),
    [sym_true] = ACTIONS(9),
    [sym_false] = ACTIONS(9),
    [sym_character_literal] = ACTIONS(11),
    [sym_string_literal] = ACTIONS(9),
    [sym_text_block] = ACTIONS(11),
    [sym_null_literal] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(280),
    [anon_sym_synchronized] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(282),
    [anon_sym_open] = ACTIONS(945),
    [anon_sym_module] = ACTIONS(945),
    [anon_sym_static] = ACTIONS(280),
    [anon_sym_public] = ACTIONS(280),
    [anon_sym_protected] = ACTIONS(280),
    [anon_sym_private] = ACTIONS(280),
    [anon_sym_abstract] = ACTIONS(280),
    [anon_sym_final] = ACTIONS(280),
    [anon_sym_strictfp] = ACTIONS(280),
    [anon_sym_native] = ACTIONS(280),
    [anon_sym_transient] = ACTIONS(280),
    [anon_sym_volatile] = ACTIONS(280),
    [anon_sym_sealed] = ACTIONS(280),
    [anon_sym_non_DASHsealed] = ACTIONS(286),
    [anon_sym_byte] = ACTIONS(75),
    [anon_sym_short] = ACTIONS(75),
    [anon_sym_int] = ACTIONS(75),
    [anon_sym_long] = ACTIONS(75),
    [anon_sym_char] = ACTIONS(75),
    [anon_sym_float] = ACTIONS(77),
    [anon_sym_double] = ACTIONS(77),
    [sym_boolean_type] = ACTIONS(79),
    [sym_void_type] = ACTIONS(79),
    [sym_this] = ACTIONS(81),
    [sym_super] = ACTIONS(83),
    [sym_line_comment] = ACTIONS(3),
    [sym_block_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 28,
    ACTIONS(965), 1,
      sym_identifier,
    ACTIONS(968), 1,
      anon_sym_LT,
    ACTIONS(971), 1,
      anon_sym_class,
    ACTIONS(974), 1,
      anon_sym_LBRACE,
    ACTIONS(977), 1,
      anon_sym_RBRACE,
    ACTIONS(982), 1,
      anon_sym_SEMI,
    ACTIONS(985), 1,
      anon_sym_AT,
    ACTIONS(988), 1,
      anon_sym_static,
    ACTIONS(991), 1,
      anon_sym_enum,
    ACTIONS(994), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(997), 1,
      anon_sym_record,
    ACTIONS(1000), 1,
      anon_sym_ATinterface,
    ACTIONS(1003), 1,
      anon_sym_interface,
    STATE(520), 1,
      sym_modifiers,
    STATE(569), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(608), 1,
      sym__unannotated_type,
    STATE(777), 1,
      sym__constructor_declarator,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1009), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1012), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1006), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(299), 11,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(979), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [118] = 28,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1019), 1,
      anon_sym_RBRACE,
    ACTIONS(1021), 1,
      anon_sym_SEMI,
    ACTIONS(1023), 1,
      anon_sym_static,
    ACTIONS(1025), 1,
      anon_sym_record,
    STATE(520), 1,
      sym_modifiers,
    STATE(569), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(608), 1,
      sym__unannotated_type,
    STATE(777), 1,
      sym__constructor_declarator,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(299), 11,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(29), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [236] = 28,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1023), 1,
      anon_sym_static,
    ACTIONS(1025), 1,
      anon_sym_record,
    ACTIONS(1027), 1,
      anon_sym_RBRACE,
    ACTIONS(1029), 1,
      anon_sym_SEMI,
    STATE(520), 1,
      sym_modifiers,
    STATE(569), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(608), 1,
      sym__unannotated_type,
    STATE(777), 1,
      sym__constructor_declarator,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(300), 11,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(29), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [354] = 28,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1021), 1,
      anon_sym_SEMI,
    ACTIONS(1023), 1,
      anon_sym_static,
    ACTIONS(1025), 1,
      anon_sym_record,
    ACTIONS(1031), 1,
      anon_sym_RBRACE,
    STATE(520), 1,
      sym_modifiers,
    STATE(569), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(608), 1,
      sym__unannotated_type,
    STATE(777), 1,
      sym__constructor_declarator,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(299), 11,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(29), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [472] = 28,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1023), 1,
      anon_sym_static,
    ACTIONS(1025), 1,
      anon_sym_record,
    ACTIONS(1033), 1,
      anon_sym_RBRACE,
    ACTIONS(1035), 1,
      anon_sym_SEMI,
    STATE(520), 1,
      sym_modifiers,
    STATE(569), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(608), 1,
      sym__unannotated_type,
    STATE(777), 1,
      sym__constructor_declarator,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(302), 11,
      sym_block,
      sym_enum_declaration,
      sym_class_declaration,
      sym_static_initializer,
      sym_constructor_declaration,
      sym_field_declaration,
      sym_record_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_method_declaration,
      aux_sym_enum_body_declarations_repeat1,
    ACTIONS(29), 12,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [590] = 24,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1039), 1,
      anon_sym_RBRACE,
    ACTIONS(1041), 1,
      anon_sym_SEMI,
    STATE(552), 1,
      sym_modifiers,
    STATE(567), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(614), 1,
      sym__unannotated_type,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(307), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(29), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [693] = 14,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1051), 1,
      anon_sym_EQ,
    ACTIONS(1055), 1,
      anon_sym_LT,
    ACTIONS(1058), 1,
      anon_sym_DASH_GT,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1067), 1,
      anon_sym_AT,
    STATE(401), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1060), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1043), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    ACTIONS(1053), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1047), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COLON,
    ACTIONS(1049), 14,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [776] = 24,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(67), 1,
      anon_sym_enum,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1069), 1,
      anon_sym_RBRACE,
    ACTIONS(1071), 1,
      anon_sym_SEMI,
    STATE(552), 1,
      sym_modifiers,
    STATE(567), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(614), 1,
      sym__unannotated_type,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(304), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(29), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [879] = 24,
    ACTIONS(1073), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_LT,
    ACTIONS(1079), 1,
      anon_sym_class,
    ACTIONS(1082), 1,
      anon_sym_RBRACE,
    ACTIONS(1087), 1,
      anon_sym_SEMI,
    ACTIONS(1090), 1,
      anon_sym_AT,
    ACTIONS(1093), 1,
      anon_sym_enum,
    ACTIONS(1096), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1099), 1,
      anon_sym_ATinterface,
    ACTIONS(1102), 1,
      anon_sym_interface,
    STATE(552), 1,
      sym_modifiers,
    STATE(567), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(614), 1,
      sym__unannotated_type,
    STATE(873), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1108), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1111), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1105), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(307), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      sym_method_declaration,
      aux_sym_interface_body_repeat1,
    ACTIONS(1084), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [982] = 18,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1051), 1,
      anon_sym_EQ,
    ACTIONS(1055), 1,
      anon_sym_LT,
    ACTIONS(1058), 1,
      anon_sym_DASH_GT,
    ACTIONS(1114), 1,
      anon_sym_AMP,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
    ACTIONS(1121), 1,
      anon_sym_COMMA,
    ACTIONS(1123), 1,
      anon_sym_DOT,
    STATE(401), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    STATE(899), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1060), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1067), 2,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1043), 4,
      anon_sym_open,
      anon_sym_module,
      sym_this,
      sym_identifier,
    ACTIONS(1049), 9,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1053), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1047), 12,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1072] = 15,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1051), 1,
      anon_sym_EQ,
    ACTIONS(1055), 1,
      anon_sym_LT,
    ACTIONS(1058), 1,
      anon_sym_DASH_GT,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1067), 1,
      anon_sym_AT,
    ACTIONS(1127), 1,
      anon_sym_COLON,
    STATE(401), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1060), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1043), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    ACTIONS(1049), 10,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
    ACTIONS(1053), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1047), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1153] = 5,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(419), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1129), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1131), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1213] = 5,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(408), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1133), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1135), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1273] = 5,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(411), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1137), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1139), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1333] = 5,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(417), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1141), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1143), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1393] = 7,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_EQ,
    STATE(402), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1151), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1145), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1147), 18,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1456] = 19,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1153), 1,
      anon_sym_RBRACE,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(589), 1,
      sym_modifiers,
    STATE(595), 1,
      sym_generic_type,
    STATE(624), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(316), 6,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(29), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1543] = 19,
    ACTIONS(23), 1,
      anon_sym_class,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(69), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(71), 1,
      anon_sym_ATinterface,
    ACTIONS(73), 1,
      anon_sym_interface,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(589), 1,
      sym_modifiers,
    STATE(595), 1,
      sym_generic_type,
    STATE(624), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(317), 6,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(29), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1630] = 19,
    ACTIONS(1157), 1,
      sym_identifier,
    ACTIONS(1160), 1,
      anon_sym_class,
    ACTIONS(1163), 1,
      anon_sym_RBRACE,
    ACTIONS(1168), 1,
      anon_sym_AT,
    ACTIONS(1171), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1174), 1,
      anon_sym_ATinterface,
    ACTIONS(1177), 1,
      anon_sym_interface,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(589), 1,
      sym_modifiers,
    STATE(595), 1,
      sym_generic_type,
    STATE(624), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1183), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1186), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(348), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1180), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    STATE(317), 6,
      sym_class_declaration,
      sym_annotation_type_declaration,
      sym_annotation_type_element_declaration,
      sym_interface_declaration,
      sym_constant_declaration,
      aux_sym_annotation_type_body_repeat1,
    ACTIONS(1165), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [1717] = 13,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1055), 1,
      anon_sym_LT,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1067), 1,
      anon_sym_AT,
    ACTIONS(1189), 1,
      anon_sym_EQ,
    ACTIONS(1193), 1,
      anon_sym_DASH_GT,
    STATE(401), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1060), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1049), 11,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1191), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1047), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
  [1791] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1141), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1143), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1845] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1137), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1139), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [1899] = 10,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_EQ,
    ACTIONS(1196), 1,
      sym_identifier,
    STATE(402), 1,
      sym_argument_list,
    STATE(904), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1198), 2,
      anon_sym_open,
      anon_sym_module,
    ACTIONS(1151), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1147), 13,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
    ACTIONS(1145), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
  [1967] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1200), 15,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1202), 30,
      anon_sym_RPAREN,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2021] = 5,
    ACTIONS(1051), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1053), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1047), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1049), 18,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2078] = 13,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1055), 1,
      anon_sym_LT,
    ACTIONS(1058), 1,
      anon_sym_DASH_GT,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1067), 1,
      anon_sym_AT,
    ACTIONS(1204), 1,
      anon_sym_EQ,
    STATE(401), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1060), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(1049), 11,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1053), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1047), 12,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
  [2151] = 7,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1206), 1,
      anon_sym_EQ,
    STATE(402), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1208), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1145), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1147), 15,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [2211] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1214), 1,
      anon_sym_LBRACK,
    STATE(334), 1,
      aux_sym_dimensions_repeat1,
    STATE(413), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(333), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(702), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1210), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1212), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2274] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1214), 1,
      anon_sym_LBRACK,
    STATE(334), 1,
      aux_sym_dimensions_repeat1,
    STATE(385), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(333), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(702), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1216), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1218), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2337] = 8,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_EQ,
    ACTIONS(1220), 1,
      anon_sym_module,
    STATE(402), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1151), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1145), 13,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(1147), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [2398] = 5,
    ACTIONS(1189), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1191), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
    ACTIONS(1047), 14,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_COLON,
    ACTIONS(1049), 15,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [2452] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1224), 8,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1222), 33,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_to,
      anon_sym_with,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [2502] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1228), 8,
      anon_sym_LPAREN,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1226), 33,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_to,
      anon_sym_with,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [2552] = 19,
    ACTIONS(278), 1,
      anon_sym_RPAREN,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(335), 1,
      sym_receiver_parameter,
    STATE(461), 1,
      aux_sym_modifiers_repeat1,
    STATE(571), 1,
      aux_sym_dimensions_expr_repeat1,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(601), 1,
      sym_modifiers,
    STATE(625), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(950), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(526), 3,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [2634] = 7,
    ACTIONS(1234), 1,
      anon_sym_LBRACK,
    ACTIONS(1237), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(333), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(727), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1230), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1232), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2691] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1244), 1,
      anon_sym_LBRACK,
    STATE(336), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(719), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1240), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1242), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2747] = 16,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1246), 1,
      anon_sym_RPAREN,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(601), 1,
      sym_modifiers,
    STATE(632), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(885), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(461), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [2821] = 7,
    ACTIONS(1252), 1,
      anon_sym_LBRACK,
    ACTIONS(1255), 1,
      anon_sym_AT,
    STATE(336), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(719), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1248), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1250), 23,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2877] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1244), 1,
      anon_sym_LBRACK,
    STATE(334), 1,
      aux_sym_dimensions_repeat1,
    STATE(428), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(719), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1258), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1260), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [2934] = 15,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(601), 1,
      sym_modifiers,
    STATE(632), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(1059), 2,
      sym_formal_parameter,
      sym_spread_parameter,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(461), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3005] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1244), 1,
      anon_sym_LBRACK,
    STATE(334), 1,
      aux_sym_dimensions_repeat1,
    STATE(428), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(719), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1262), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1264), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3062] = 16,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(597), 1,
      sym_modifiers,
    STATE(627), 1,
      sym__unannotated_type,
    STATE(843), 1,
      sym_catch_type,
    STATE(1079), 1,
      sym_catch_formal_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(461), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [3135] = 6,
    ACTIONS(1268), 1,
      anon_sym_LPAREN,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    STATE(361), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1270), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1266), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3187] = 6,
    ACTIONS(1268), 1,
      anon_sym_LPAREN,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    STATE(360), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1276), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1274), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3239] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(759), 12,
      sym_octal_integer_literal,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      sym_text_block,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(761), 25,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_switch,
      anon_sym_open,
      anon_sym_module,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [3285] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(735), 12,
      sym_octal_integer_literal,
      sym_binary_integer_literal,
      sym_decimal_floating_point_literal,
      sym_character_literal,
      sym_text_block,
      anon_sym_LPAREN,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(737), 25,
      sym_decimal_integer_literal,
      sym_hex_integer_literal,
      sym_hex_floating_point_literal,
      sym_true,
      sym_false,
      sym_string_literal,
      sym_null_literal,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_new,
      anon_sym_switch,
      anon_sym_open,
      anon_sym_module,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [3331] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(396), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1280), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1282), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3379] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(395), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1286), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1288), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3427] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(405), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1290), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1292), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3475] = 7,
    ACTIONS(57), 1,
      anon_sym_AT,
    ACTIONS(1300), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1296), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(350), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1298), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    ACTIONS(1294), 14,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3527] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(418), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1302), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1304), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [3575] = 7,
    ACTIONS(1313), 1,
      anon_sym_AT,
    ACTIONS(1316), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1308), 2,
      anon_sym_LT,
      anon_sym_ATinterface,
    STATE(350), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1310), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
    ACTIONS(1306), 14,
      anon_sym_class,
      anon_sym_enum,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3627] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1321), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1319), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3670] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1325), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1323), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3713] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1329), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1327), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3756] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1333), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1331), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3799] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1337), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1335), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3842] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1341), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1339), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3885] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1345), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1343), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3928] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1349), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1347), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [3971] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1351), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1353), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4014] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1357), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1355), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4057] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1361), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1359), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4100] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1363), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1365), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4143] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1248), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1250), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4186] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1369), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1367), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4229] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1373), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1371), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4272] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1375), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1377), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4315] = 6,
    ACTIONS(1379), 1,
      anon_sym_LT,
    ACTIONS(1382), 1,
      anon_sym_DOT,
    STATE(414), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1043), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1067), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4364] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1384), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1386), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4407] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1390), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1388), 31,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_static,
      anon_sym_package,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4450] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1394), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1392), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4493] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1398), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1396), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4536] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1402), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1400), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4579] = 6,
    ACTIONS(1408), 1,
      anon_sym_LT,
    ACTIONS(1411), 1,
      anon_sym_DOT,
    STATE(392), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1406), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4628] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1415), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1413), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4671] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1419), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1417), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4714] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1423), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1421), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4757] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1427), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1425), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4800] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1429), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1431), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4843] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1435), 6,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1433), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [4886] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1437), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1439), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [4929] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1047), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1049), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [4971] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1441), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1443), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5013] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1445), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1447), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5055] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1449), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1451), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5097] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1453), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1455), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5139] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1457), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1459), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5181] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1461), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1463), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5223] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1465), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1467), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5265] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1469), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1471), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5307] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1473), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1475), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5349] = 4,
    ACTIONS(1411), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1406), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5393] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1477), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1479), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5435] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1481), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1483), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5477] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1485), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1487), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5519] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1489), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1491), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5561] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1493), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1495), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5603] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1497), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1499), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5645] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1501), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1503), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5687] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1505), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1507), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5729] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1509), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1511), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5771] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1513), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1515), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5813] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1517), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1519), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5855] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1521), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1523), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [5897] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1525), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1527), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5939] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1529), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1531), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [5981] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1533), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1535), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6023] = 6,
    ACTIONS(1537), 1,
      anon_sym_LBRACK,
    ACTIONS(1539), 1,
      anon_sym_DOT,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(272), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(274), 21,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6071] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1543), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1545), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6113] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1547), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1549), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6155] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1551), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1553), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6197] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1555), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1557), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6239] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1559), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1561), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6281] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1563), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1565), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6323] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1567), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1569), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6365] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1571), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1573), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6407] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1575), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1577), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6449] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1579), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1581), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6491] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1583), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1585), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6533] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1587), 9,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
      anon_sym_COLON,
    ACTIONS(1589), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [6575] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1591), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1593), 25,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6617] = 5,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(375), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1597), 3,
      anon_sym_LT,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1595), 28,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_record,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6663] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1599), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1601), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6704] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1605), 5,
      anon_sym_LT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1603), 27,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6745] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1609), 5,
      anon_sym_LT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1607), 27,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6786] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1611), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1613), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6827] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1406), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6868] = 5,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1597), 2,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1618), 3,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
    ACTIONS(1615), 11,
      anon_sym_AT,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1595), 16,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
  [6913] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1620), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1622), 24,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
  [6954] = 5,
    ACTIONS(939), 1,
      anon_sym_LPAREN,
    STATE(1024), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1597), 2,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1595), 27,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_enum,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [6998] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1624), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1626), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7037] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1628), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1630), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7078] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1624), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1626), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7117] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1634), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1636), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7156] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1471), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1469), 18,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7195] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1638), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1640), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7236] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1463), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1461), 18,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7275] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(272), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(274), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7314] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1258), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1260), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7353] = 4,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1642), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1644), 20,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7394] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1646), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1648), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7433] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(272), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(274), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7472] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1523), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1521), 18,
      anon_sym_new,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_this,
      sym_super,
      sym_identifier,
  [7511] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1650), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1652), 22,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7550] = 9,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1642), 4,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
    ACTIONS(1644), 15,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7600] = 12,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1642), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1644), 12,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7656] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1672), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7724] = 6,
    ACTIONS(1689), 1,
      anon_sym_AT,
    ACTIONS(1692), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(447), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1306), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1686), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [7768] = 7,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1642), 5,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1644), 17,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7814] = 5,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(1118), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1047), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1049), 19,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_SEMI,
  [7856] = 14,
    ACTIONS(1642), 1,
      anon_sym_PIPE,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1644), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [7916] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1697), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1695), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [7954] = 15,
    ACTIONS(1642), 1,
      anon_sym_PIPE,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1644), 9,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8016] = 6,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1642), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1644), 17,
      anon_sym_RPAREN,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8060] = 16,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1644), 8,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8124] = 15,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1644), 9,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8186] = 13,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1642), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1644), 10,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8244] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1652), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8312] = 6,
    ACTIONS(1699), 1,
      anon_sym_LPAREN,
    ACTIONS(1701), 1,
      anon_sym_DOT,
    STATE(511), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1270), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1266), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8356] = 6,
    ACTIONS(1699), 1,
      anon_sym_LPAREN,
    ACTIONS(1703), 1,
      anon_sym_DOT,
    STATE(477), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1276), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1274), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8400] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1705), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8468] = 6,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1709), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(447), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(1294), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1707), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [8512] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1713), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1711), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8550] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1717), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1715), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8588] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1721), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1719), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8626] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1725), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1723), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8664] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1727), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [8732] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1731), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1729), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8770] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1735), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1733), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8808] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1739), 3,
      anon_sym_RBRACE,
      anon_sym_non_DASHsealed,
      anon_sym_ATinterface,
    ACTIONS(1737), 26,
      anon_sym_class,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_AT,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_interface,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8846] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1228), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1226), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8883] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1224), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1222), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [8920] = 6,
    ACTIONS(1537), 1,
      anon_sym_LBRACK,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1741), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(272), 8,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(274), 16,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_STAR,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_SEMI,
  [8962] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    STATE(476), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1240), 10,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1242), 10,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
  [9006] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1745), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [9072] = 20,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(1775), 1,
      anon_sym_COMMA,
    ACTIONS(1777), 1,
      anon_sym_QMARK,
    STATE(770), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1773), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [9142] = 7,
    ACTIONS(1255), 1,
      anon_sym_AT,
    ACTIONS(1779), 1,
      anon_sym_LBRACK,
    STATE(476), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1248), 10,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1250), 10,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_DOT_DOT_DOT,
  [9186] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1357), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1355), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [9221] = 12,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1784), 1,
      anon_sym_COMMA,
    ACTIONS(1786), 1,
      anon_sym_RBRACE,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    STATE(761), 1,
      sym_enum_constant,
    STATE(1141), 1,
      sym_modifiers,
    STATE(1142), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [9274] = 12,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1642), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1644), 9,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [9327] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1790), 1,
      anon_sym_COMMA,
    ACTIONS(1792), 1,
      anon_sym_SEMI,
    STATE(931), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9396] = 15,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1644), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [9455] = 16,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1644), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [9516] = 6,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1642), 7,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1644), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [9557] = 18,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(1777), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1652), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [9622] = 15,
    ACTIONS(1642), 1,
      anon_sym_PIPE,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1644), 6,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [9681] = 14,
    ACTIONS(1642), 1,
      anon_sym_PIPE,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1644), 7,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [9738] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1794), 1,
      anon_sym_RPAREN,
    ACTIONS(1796), 1,
      anon_sym_COMMA,
    STATE(948), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9807] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1798), 1,
      anon_sym_RPAREN,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    STATE(907), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9876] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1802), 1,
      anon_sym_RPAREN,
    STATE(910), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9945] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1804), 1,
      anon_sym_RPAREN,
    STATE(872), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10014] = 7,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1642), 5,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_GT_GT,
    ACTIONS(1644), 14,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [10057] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1808), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1806), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10092] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1373), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1371), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10127] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1810), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [10192] = 18,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(1777), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1705), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [10257] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1812), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [10322] = 13,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1642), 2,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1644), 7,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [10377] = 15,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1814), 1,
      anon_sym_GT,
    ACTIONS(1816), 1,
      anon_sym_QMARK,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(861), 2,
      sym_wildcard,
      sym__type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(564), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10436] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1818), 1,
      anon_sym_RPAREN,
    STATE(918), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10505] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1822), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1820), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10540] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1824), 1,
      anon_sym_RPAREN,
    STATE(858), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10609] = 15,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1816), 1,
      anon_sym_QMARK,
    ACTIONS(1826), 1,
      anon_sym_GT,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(921), 2,
      sym_wildcard,
      sym__type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(564), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [10668] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1830), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1828), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10703] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1832), 1,
      anon_sym_RPAREN,
    STATE(927), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10772] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1369), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1367), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10807] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1773), 1,
      anon_sym_COLON,
    ACTIONS(1796), 1,
      anon_sym_COMMA,
    STATE(952), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10876] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1390), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1388), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [10911] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1834), 1,
      anon_sym_RPAREN,
    STATE(864), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [10980] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(1836), 1,
      anon_sym_RPAREN,
    STATE(857), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11049] = 18,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(1777), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1727), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [11114] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1361), 3,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1359), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11149] = 9,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1642), 4,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
    ACTIONS(1644), 12,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_instanceof,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_COLON,
  [11196] = 18,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(1777), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1810), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [11261] = 20,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1838), 1,
      anon_sym_COMMA,
    ACTIONS(1840), 1,
      anon_sym_RBRACE,
    STATE(949), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11330] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1844), 3,
      anon_sym_RPAREN,
      anon_sym_AT,
      anon_sym_non_DASHsealed,
    ACTIONS(1842), 23,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [11365] = 18,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1747), 1,
      anon_sym_AMP,
    ACTIONS(1755), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1757), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1763), 1,
      anon_sym_SLASH,
    ACTIONS(1765), 1,
      anon_sym_PIPE,
    ACTIONS(1767), 1,
      anon_sym_CARET,
    ACTIONS(1771), 1,
      anon_sym_GT_GT,
    ACTIONS(1777), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1749), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1751), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1753), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1759), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1761), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1769), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1672), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_COLON,
  [11430] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1846), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [11494] = 19,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1848), 1,
      anon_sym_COLON,
    ACTIONS(1850), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [11560] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1852), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [11624] = 18,
    ACTIONS(1015), 1,
      sym_identifier,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1854), 1,
      anon_sym_class,
    ACTIONS(1856), 1,
      anon_sym_enum,
    ACTIONS(1858), 1,
      anon_sym_record,
    ACTIONS(1860), 1,
      anon_sym_ATinterface,
    ACTIONS(1862), 1,
      anon_sym_interface,
    STATE(569), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(615), 1,
      sym__unannotated_type,
    STATE(826), 1,
      sym__constructor_declarator,
    STATE(940), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11688] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1864), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [11752] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [11816] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1868), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [11880] = 14,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1816), 1,
      anon_sym_QMARK,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(988), 2,
      sym_wildcard,
      sym__type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(564), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [11936] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1745), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [12000] = 5,
    ACTIONS(1597), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1870), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1615), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
    ACTIONS(1595), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [12038] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    ACTIONS(1873), 1,
      anon_sym_RBRACE,
    STATE(898), 1,
      sym_enum_constant,
    STATE(1121), 1,
      sym_enum_body_declarations,
    STATE(1141), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [12088] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    ACTIONS(1875), 1,
      anon_sym_RBRACE,
    STATE(898), 1,
      sym_enum_constant,
    STATE(1094), 1,
      sym_enum_body_declarations,
    STATE(1141), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [12138] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1877), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12201] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1879), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12264] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1881), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12327] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1883), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12390] = 14,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(846), 1,
      sym__type,
    STATE(1027), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12445] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1885), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12508] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12571] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12634] = 14,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1891), 1,
      anon_sym_open,
    ACTIONS(1893), 1,
      anon_sym_module,
    ACTIONS(1895), 1,
      anon_sym_package,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(596), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12689] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1897), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12752] = 14,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(846), 1,
      sym__type,
    STATE(1086), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [12807] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1899), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12870] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1901), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12933] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1903), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [12996] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1905), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13059] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1907), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13122] = 14,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(846), 1,
      sym__type,
    STATE(956), 1,
      sym_type_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13177] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1909), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13240] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13303] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1913), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13366] = 18,
    ACTIONS(1658), 1,
      anon_sym_SLASH,
    ACTIONS(1662), 1,
      anon_sym_GT_GT,
    ACTIONS(1668), 1,
      anon_sym_instanceof,
    ACTIONS(1670), 1,
      anon_sym_AMP,
    ACTIONS(1676), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1678), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1680), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_CARET,
    ACTIONS(1684), 1,
      anon_sym_QMARK,
    ACTIONS(1915), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1632), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1654), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1656), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(1660), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT_GT,
    ACTIONS(1664), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(1666), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(1674), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [13429] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(823), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13481] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(1056), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13533] = 16,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1854), 1,
      anon_sym_class,
    ACTIONS(1856), 1,
      anon_sym_enum,
    ACTIONS(1860), 1,
      anon_sym_ATinterface,
    ACTIONS(1862), 1,
      anon_sym_interface,
    STATE(567), 1,
      sym_type_parameters,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(612), 1,
      sym__unannotated_type,
    STATE(940), 1,
      sym__method_header,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13591] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(982), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13643] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(829), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13695] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(837), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13747] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1917), 1,
      sym_identifier,
    STATE(337), 1,
      sym__unannotated_type,
    STATE(373), 1,
      sym_scoped_type_identifier,
    STATE(391), 1,
      sym_generic_type,
    STATE(438), 1,
      sym_annotated_type,
    STATE(440), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1921), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1923), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(426), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(570), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1919), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13799] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(887), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13851] = 13,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(602), 1,
      sym__unannotated_type,
    STATE(666), 1,
      sym_annotated_type,
    STATE(896), 1,
      sym__type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(572), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [13903] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(286), 1,
      anon_sym_non_DASHsealed,
    ACTIONS(1782), 1,
      sym_identifier,
    STATE(898), 1,
      sym_enum_constant,
    STATE(1141), 1,
      sym_modifiers,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(461), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_modifiers_repeat1,
    ACTIONS(280), 13,
      anon_sym_default,
      anon_sym_synchronized,
      anon_sym_static,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_abstract,
      anon_sym_final,
      anon_sym_strictfp,
      anon_sym_native,
      anon_sym_transient,
      anon_sym_volatile,
      anon_sym_sealed,
  [13944] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1429), 10,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1431), 12,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [13975] = 6,
    ACTIONS(1925), 1,
      anon_sym_LPAREN,
    ACTIONS(1927), 1,
      anon_sym_DOT,
    STATE(582), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1270), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1266), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14012] = 6,
    ACTIONS(1925), 1,
      anon_sym_LPAREN,
    ACTIONS(1929), 1,
      anon_sym_DOT,
    STATE(581), 1,
      sym_annotation_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1276), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1274), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14049] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1248), 10,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_throws,
      sym_this,
      sym_identifier,
    ACTIONS(1250), 12,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14080] = 12,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1931), 1,
      anon_sym_QMARK,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(596), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14129] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1228), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1226), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14159] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1224), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_DOT,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1222), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14189] = 11,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(646), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(568), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14235] = 11,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(647), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14281] = 11,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1933), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(646), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(568), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14327] = 11,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1917), 1,
      sym_identifier,
    STATE(339), 1,
      sym__unannotated_type,
    STATE(373), 1,
      sym_scoped_type_identifier,
    STATE(391), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1921), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1923), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(426), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1919), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14373] = 11,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(658), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14419] = 11,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(596), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14465] = 11,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(628), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14511] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1533), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1535), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14540] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1559), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1561), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14569] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1935), 1,
      anon_sym_DOT,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1043), 6,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1067), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14604] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1591), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1593), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14633] = 13,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1854), 1,
      anon_sym_class,
    ACTIONS(1856), 1,
      anon_sym_enum,
    ACTIONS(1860), 1,
      anon_sym_ATinterface,
    ACTIONS(1862), 1,
      anon_sym_interface,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(621), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [14682] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1937), 1,
      anon_sym_DOT,
    STATE(587), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 6,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1406), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14717] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1465), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1467), 13,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14746] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1357), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1355), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14774] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1361), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1359), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14802] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1373), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1371), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14830] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1599), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1601), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14858] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1390), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1388), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14886] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1611), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1613), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14914] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1477), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1479), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [14942] = 5,
    ACTIONS(1941), 1,
      anon_sym_QMARK,
    ACTIONS(1943), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1939), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [14974] = 12,
    ACTIONS(1037), 1,
      sym_identifier,
    ACTIONS(1854), 1,
      anon_sym_class,
    ACTIONS(1860), 1,
      anon_sym_ATinterface,
    ACTIONS(1862), 1,
      anon_sym_interface,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(623), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15020] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1369), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
    ACTIONS(1367), 13,
      anon_sym_open,
      anon_sym_module,
      anon_sym_package,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [15048] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1567), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1569), 12,
      anon_sym_LPAREN,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [15076] = 13,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1946), 1,
      sym_identifier,
    ACTIONS(1948), 1,
      anon_sym_DOT,
    ACTIONS(1952), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1954), 1,
      sym_this,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(970), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    ACTIONS(1260), 3,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15123] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1406), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [15150] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1620), 7,
      anon_sym_DOT,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1622), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [15177] = 4,
    ACTIONS(1937), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 6,
      anon_sym_open,
      anon_sym_module,
      anon_sym_implements,
      anon_sym_permits,
      sym_this,
      sym_identifier,
    ACTIONS(1406), 11,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [15206] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1264), 9,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [15240] = 10,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(627), 1,
      sym__unannotated_type,
    STATE(806), 1,
      sym_catch_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15280] = 13,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1126), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15325] = 10,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1960), 1,
      sym_identifier,
    STATE(611), 1,
      sym_scoped_type_identifier,
    STATE(622), 1,
      sym_type_arguments,
    STATE(637), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1962), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(645), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15364] = 10,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1964), 1,
      sym_identifier,
    STATE(618), 1,
      sym_scoped_type_identifier,
    STATE(622), 1,
      sym_type_arguments,
    STATE(629), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1966), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(642), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15403] = 9,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(636), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15440] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(1260), 8,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [15473] = 13,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(776), 1,
      sym__variable_declarator_id,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1110), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15518] = 9,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(619), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15555] = 9,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(649), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15592] = 10,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1968), 1,
      sym_identifier,
    STATE(622), 1,
      sym_type_arguments,
    STATE(747), 1,
      sym_scoped_type_identifier,
    STATE(892), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1970), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(964), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15631] = 9,
    ACTIONS(1037), 1,
      sym_identifier,
    STATE(579), 1,
      sym_scoped_type_identifier,
    STATE(595), 1,
      sym_generic_type,
    STATE(643), 1,
      sym__unannotated_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(79), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(593), 3,
      sym_array_type,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [15668] = 12,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1972), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(832), 1,
      sym__method_declarator,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1097), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1974), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15710] = 4,
    ACTIONS(1976), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1745), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1618), 10,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [15736] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1980), 2,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(1978), 13,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [15760] = 12,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(349), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(587), 1,
      sym_type_arguments,
    STATE(976), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(326), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15802] = 12,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1972), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(832), 1,
      sym__method_declarator,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1095), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1974), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15844] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1988), 2,
      anon_sym_LBRACE,
      anon_sym_AT,
    ACTIONS(1986), 13,
      anon_sym_extends,
      anon_sym_implements,
      anon_sym_permits,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
      anon_sym_float,
      anon_sym_double,
      sym_boolean_type,
      sym_void_type,
      sym_identifier,
  [15868] = 12,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1972), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(832), 1,
      sym__method_declarator,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1065), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1974), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15910] = 12,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1972), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(832), 1,
      sym__method_declarator,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1074), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1974), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15952] = 12,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    ACTIONS(1990), 1,
      anon_sym_DOT,
    STATE(347), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(591), 1,
      sym_type_arguments,
    STATE(977), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(650), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [15994] = 12,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    ACTIONS(1990), 1,
      anon_sym_DOT,
    STATE(347), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(591), 1,
      sym_type_arguments,
    STATE(977), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(327), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16036] = 12,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(349), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(587), 1,
      sym_type_arguments,
    STATE(976), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(641), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16078] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(839), 1,
      sym__variable_declarator_id,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1123), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16117] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(1111), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16156] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1072), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16195] = 8,
    ACTIONS(1992), 1,
      sym_identifier,
    STATE(760), 1,
      sym_scoped_type_identifier,
    STATE(863), 1,
      sym_generic_type,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(77), 2,
      anon_sym_float,
      anon_sym_double,
    ACTIONS(1994), 2,
      sym_boolean_type,
      sym_void_type,
    STATE(978), 2,
      sym_integral_type,
      sym_floating_point_type,
    ACTIONS(75), 5,
      anon_sym_byte,
      anon_sym_short,
      anon_sym_int,
      anon_sym_long,
      anon_sym_char,
  [16228] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1996), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1095), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16267] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1998), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(913), 1,
      sym_variable_declarator,
    STATE(1065), 1,
      sym__variable_declarator_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16306] = 11,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1946), 1,
      sym_identifier,
    ACTIONS(1952), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1954), 1,
      sym_this,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(970), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16345] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(2000), 1,
      anon_sym_DOT,
    STATE(587), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 4,
      anon_sym_open,
      anon_sym_module,
      sym_this,
      sym_identifier,
    ACTIONS(1406), 6,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [16373] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2005), 1,
      anon_sym_PIPE,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(750), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2003), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16407] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2007), 1,
      sym_identifier,
    ACTIONS(2009), 1,
      sym_this,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1264), 3,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_COLON_COLON,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16441] = 10,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(349), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(976), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(641), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16477] = 9,
    ACTIONS(2011), 1,
      anon_sym_RBRACE,
    ACTIONS(2013), 1,
      anon_sym_requires,
    ACTIONS(2015), 1,
      anon_sym_exports,
    ACTIONS(2017), 1,
      anon_sym_opens,
    ACTIONS(2019), 1,
      anon_sym_uses,
    ACTIONS(2021), 1,
      anon_sym_provides,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(640), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(701), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [16511] = 10,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1067), 1,
      anon_sym_AT,
    STATE(401), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1060), 2,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
    ACTIONS(2023), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1043), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [16547] = 10,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1952), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(970), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16583] = 9,
    ACTIONS(2025), 1,
      anon_sym_RBRACE,
    ACTIONS(2027), 1,
      anon_sym_requires,
    ACTIONS(2030), 1,
      anon_sym_exports,
    ACTIONS(2033), 1,
      anon_sym_opens,
    ACTIONS(2036), 1,
      anon_sym_uses,
    ACTIONS(2039), 1,
      anon_sym_provides,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(633), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(701), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [16617] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(653), 1,
      sym_formal_parameters,
    STATE(768), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2044), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16651] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(654), 1,
      sym_formal_parameters,
    STATE(766), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2046), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16685] = 10,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      sym_identifier,
    ACTIONS(2048), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(1055), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16721] = 10,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(349), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(976), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(326), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16757] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(766), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(2046), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [16787] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(768), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
    ACTIONS(2044), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [16817] = 9,
    ACTIONS(2013), 1,
      anon_sym_requires,
    ACTIONS(2015), 1,
      anon_sym_exports,
    ACTIONS(2017), 1,
      anon_sym_opens,
    ACTIONS(2019), 1,
      anon_sym_uses,
    ACTIONS(2021), 1,
      anon_sym_provides,
    ACTIONS(2050), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(633), 2,
      sym_module_directive,
      aux_sym_module_body_repeat1,
    STATE(701), 5,
      sym_requires_module_directive,
      sym_exports_module_directive,
      sym_opens_module_directive,
      sym_uses_module_directive,
      sym_provides_module_directive,
  [16851] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    STATE(413), 1,
      sym_dimensions,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1212), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(333), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16882] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    STATE(349), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(976), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(641), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16915] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2054), 1,
      anon_sym_PIPE,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2052), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16946] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2056), 1,
      anon_sym_LPAREN,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(768), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2044), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [16977] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    STATE(349), 1,
      sym_argument_list,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(976), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(326), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17010] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2058), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(831), 1,
      sym__method_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2060), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17043] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2058), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(822), 1,
      sym__method_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2060), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17076] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2062), 1,
      anon_sym_LPAREN,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(768), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2044), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17107] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    STATE(1076), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17140] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1982), 1,
      anon_sym_LBRACK,
    STATE(385), 1,
      sym_dimensions,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1218), 2,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
    STATE(333), 2,
      sym_dimensions_expr,
      aux_sym_array_creation_expression_repeat1,
    STATE(691), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17171] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2064), 1,
      anon_sym_default,
    ACTIONS(2066), 1,
      anon_sym_SEMI,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(947), 1,
      sym_dimensions,
    STATE(1140), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17203] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2068), 1,
      anon_sym_DOT,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(768), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2044), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17233] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(866), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2070), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17261] = 7,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(865), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2072), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17289] = 9,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2064), 1,
      anon_sym_default,
    ACTIONS(2074), 1,
      anon_sym_SEMI,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(890), 1,
      sym_dimensions,
    STATE(1113), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17321] = 4,
    ACTIONS(2000), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1404), 4,
      anon_sym_open,
      anon_sym_module,
      sym_this,
      sym_identifier,
    ACTIONS(1406), 6,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON_COLON,
      anon_sym_AT,
      anon_sym_DOT_DOT_DOT,
  [17343] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(1958), 1,
      anon_sym_DOT,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17372] = 8,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(1743), 1,
      anon_sym_LBRACK,
    ACTIONS(2007), 1,
      sym_identifier,
    ACTIONS(2009), 1,
      sym_this,
    STATE(473), 1,
      aux_sym_dimensions_repeat1,
    STATE(594), 1,
      sym_dimensions,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(721), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17401] = 8,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1990), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(591), 1,
      sym_type_arguments,
    STATE(999), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1067), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1043), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [17430] = 8,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1990), 1,
      anon_sym_DOT,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(591), 1,
      sym_type_arguments,
    STATE(1036), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1067), 2,
      anon_sym_LBRACK,
      anon_sym_AT,
    ACTIONS(1043), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [17459] = 11,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      anon_sym_extends,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(134), 1,
      sym_class_body,
    STATE(672), 1,
      sym_type_parameters,
    STATE(714), 1,
      sym_superclass,
    STATE(787), 1,
      sym_super_interfaces,
    STATE(965), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [17494] = 11,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      anon_sym_extends,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(104), 1,
      sym_class_body,
    STATE(667), 1,
      sym_type_parameters,
    STATE(708), 1,
      sym_superclass,
    STATE(828), 1,
      sym_super_interfaces,
    STATE(980), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [17529] = 9,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2084), 1,
      anon_sym_new,
    ACTIONS(2088), 1,
      sym_this,
    ACTIONS(2090), 1,
      sym_super,
    STATE(394), 1,
      sym__unqualified_object_creation_expression,
    STATE(778), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2086), 2,
      anon_sym_open,
      anon_sym_module,
  [17559] = 8,
    ACTIONS(2092), 1,
      anon_sym_RBRACE,
    ACTIONS(2094), 1,
      anon_sym_case,
    ACTIONS(2096), 1,
      anon_sym_default,
    STATE(3), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1004), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(673), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
    STATE(706), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [17587] = 9,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2084), 1,
      anon_sym_new,
    ACTIONS(2088), 1,
      sym_this,
    ACTIONS(2098), 1,
      sym_super,
    STATE(394), 1,
      sym__unqualified_object_creation_expression,
    STATE(929), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2086), 2,
      anon_sym_open,
      anon_sym_module,
  [17617] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1260), 9,
      anon_sym_AMP,
      anon_sym_RPAREN,
      anon_sym_GT,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_implements,
      anon_sym_permits,
  [17633] = 9,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      anon_sym_extends,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(113), 1,
      sym_class_body,
    STATE(696), 1,
      sym_superclass,
    STATE(841), 1,
      sym_super_interfaces,
    STATE(1026), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [17662] = 7,
    ACTIONS(2100), 1,
      sym_identifier,
    STATE(671), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(762), 1,
      sym_requires_modifier,
    STATE(1047), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2102), 2,
      anon_sym_open,
      anon_sym_module,
    ACTIONS(2104), 2,
      anon_sym_transitive,
      anon_sym_static,
  [17687] = 9,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2106), 1,
      anon_sym_extends,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(129), 1,
      sym_interface_body,
    STATE(699), 1,
      sym_type_parameters,
    STATE(782), 1,
      sym_extends_interfaces,
    STATE(969), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [17716] = 9,
    ACTIONS(1017), 1,
      anon_sym_LT,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2106), 1,
      anon_sym_extends,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(73), 1,
      sym_interface_body,
    STATE(738), 1,
      sym_type_parameters,
    STATE(803), 1,
      sym_extends_interfaces,
    STATE(1020), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [17745] = 8,
    ACTIONS(2110), 1,
      sym_identifier,
    ACTIONS(2112), 1,
      anon_sym_open,
    ACTIONS(2114), 1,
      anon_sym_module,
    STATE(676), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(762), 1,
      sym_requires_modifier,
    STATE(1010), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2104), 2,
      anon_sym_transitive,
      anon_sym_static,
  [17772] = 9,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      anon_sym_extends,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(86), 1,
      sym_class_body,
    STATE(697), 1,
      sym_superclass,
    STATE(796), 1,
      sym_super_interfaces,
    STATE(1050), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [17801] = 7,
    ACTIONS(2096), 1,
      anon_sym_default,
    ACTIONS(2116), 1,
      anon_sym_RBRACE,
    ACTIONS(2118), 1,
      anon_sym_case,
    STATE(3), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1084), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(680), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
  [17825] = 6,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(756), 1,
      sym_argument_list,
    STATE(895), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2120), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [17847] = 7,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(2082), 1,
      sym_identifier,
    ACTIONS(2088), 1,
      sym_this,
    ACTIONS(2098), 1,
      sym_super,
    STATE(929), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2086), 2,
      anon_sym_open,
      anon_sym_module,
  [17871] = 5,
    STATE(676), 1,
      aux_sym_requires_module_directive_repeat1,
    STATE(762), 1,
      sym_requires_modifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2124), 2,
      anon_sym_transitive,
      anon_sym_static,
    ACTIONS(2122), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [17891] = 6,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(764), 1,
      sym_argument_list,
    STATE(869), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2127), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [17913] = 5,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2129), 1,
      sym_identifier,
    STATE(1042), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(740), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17933] = 5,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2129), 1,
      sym_identifier,
    STATE(851), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(740), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [17953] = 7,
    ACTIONS(2131), 1,
      anon_sym_RBRACE,
    ACTIONS(2133), 1,
      anon_sym_case,
    ACTIONS(2136), 1,
      anon_sym_default,
    STATE(3), 1,
      aux_sym_switch_block_statement_group_repeat1,
    STATE(1084), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(680), 2,
      sym_switch_block_statement_group,
      aux_sym_switch_block_repeat1,
  [17977] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2139), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [17990] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2141), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18007] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2143), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18024] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2139), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18037] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2145), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18050] = 6,
    ACTIONS(2147), 1,
      anon_sym_RBRACE,
    ACTIONS(2149), 1,
      anon_sym_case,
    ACTIONS(2152), 1,
      anon_sym_default,
    STATE(1083), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(686), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [18071] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2145), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18084] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2155), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18097] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2157), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(722), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18114] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2159), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18127] = 4,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(2161), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(734), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18144] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2163), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18157] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2165), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18170] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2167), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18183] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2169), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18196] = 7,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(115), 1,
      sym_class_body,
    STATE(836), 1,
      sym_super_interfaces,
    STATE(1006), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [18219] = 7,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(87), 1,
      sym_class_body,
    STATE(795), 1,
      sym_super_interfaces,
    STATE(995), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [18242] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2171), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18255] = 7,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2106), 1,
      anon_sym_extends,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(75), 1,
      sym_interface_body,
    STATE(842), 1,
      sym_extends_interfaces,
    STATE(1046), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [18278] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2173), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18295] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2175), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18308] = 4,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(2177), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(734), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18325] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2179), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18338] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2181), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18351] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2183), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18364] = 6,
    ACTIONS(2094), 1,
      anon_sym_case,
    ACTIONS(2096), 1,
      anon_sym_default,
    ACTIONS(2116), 1,
      anon_sym_RBRACE,
    STATE(1083), 1,
      sym_switch_label,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(686), 2,
      sym_switch_rule,
      aux_sym_switch_block_repeat2,
  [18385] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2185), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18398] = 7,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(116), 1,
      sym_class_body,
    STATE(840), 1,
      sym_super_interfaces,
    STATE(1021), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [18421] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2187), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18434] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2189), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18447] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2191), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18460] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2193), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18473] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2195), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18486] = 7,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(82), 1,
      sym_class_body,
    STATE(779), 1,
      sym_super_interfaces,
    STATE(1049), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [18509] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2197), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18522] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2199), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18535] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2201), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(683), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18552] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2203), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18565] = 4,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(2205), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(734), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18582] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2207), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18595] = 4,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(2209), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(734), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18612] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2211), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18629] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(2213), 1,
      sym_identifier,
    ACTIONS(2217), 1,
      sym_this,
    STATE(878), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2215), 2,
      anon_sym_open,
      anon_sym_module,
  [18650] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2219), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18663] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2221), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18676] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2223), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(682), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18693] = 4,
    ACTIONS(282), 1,
      anon_sym_AT,
    ACTIONS(2225), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(734), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18710] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2227), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18723] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2229), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18736] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2231), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18749] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2233), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(700), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18766] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2235), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18779] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2237), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18792] = 4,
    ACTIONS(1941), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(734), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18809] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2242), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18822] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2244), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18835] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2246), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18848] = 7,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2106), 1,
      anon_sym_extends,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(119), 1,
      sym_interface_body,
    STATE(814), 1,
      sym_extends_interfaces,
    STATE(957), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [18871] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2248), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18884] = 4,
    ACTIONS(321), 1,
      anon_sym_AT,
    ACTIONS(2250), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(588), 4,
      sym__annotation,
      sym_marker_annotation,
      sym_annotation,
      aux_sym_dimensions_expr_repeat1,
  [18901] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2252), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_throws,
  [18914] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2254), 6,
      anon_sym_RBRACE,
      anon_sym_requires,
      anon_sym_exports,
      anon_sym_opens,
      anon_sym_uses,
      anon_sym_provides,
  [18927] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2256), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_throws,
  [18940] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2258), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_throws,
  [18953] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2260), 6,
      anon_sym_DASH_GT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_throws,
  [18966] = 6,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    ACTIONS(1875), 1,
      anon_sym_RBRACE,
    ACTIONS(2262), 1,
      anon_sym_COMMA,
    STATE(783), 1,
      aux_sym_enum_body_repeat1,
    STATE(1094), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [18986] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(349), 1,
      sym_argument_list,
    STATE(587), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19006] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1990), 1,
      anon_sym_DOT,
    STATE(347), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19026] = 5,
    ACTIONS(2264), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      anon_sym_static,
    STATE(1001), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2266), 2,
      anon_sym_open,
      anon_sym_module,
  [19044] = 4,
    ACTIONS(2005), 1,
      anon_sym_PIPE,
    STATE(759), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2270), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [19060] = 4,
    STATE(1032), 1,
      sym__wildcard_bounds,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2272), 2,
      anon_sym_GT,
      anon_sym_COMMA,
    ACTIONS(2274), 2,
      anon_sym_extends,
      sym_super,
  [19076] = 3,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2023), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(1049), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [19090] = 4,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(402), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1147), 3,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
  [19106] = 4,
    ACTIONS(2276), 1,
      anon_sym_COMMA,
    STATE(754), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2279), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_permits,
  [19122] = 5,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(1057), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
  [19140] = 4,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(883), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2281), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [19156] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2283), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_transitive,
      anon_sym_static,
      sym_identifier,
  [19168] = 5,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(973), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
  [19186] = 4,
    ACTIONS(2285), 1,
      anon_sym_PIPE,
    STATE(759), 1,
      aux_sym_catch_type_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2052), 3,
      anon_sym_open,
      anon_sym_module,
      sym_identifier,
  [19202] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(345), 1,
      sym_argument_list,
    STATE(587), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19222] = 6,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    ACTIONS(2288), 1,
      anon_sym_COMMA,
    ACTIONS(2290), 1,
      anon_sym_RBRACE,
    STATE(746), 1,
      aux_sym_enum_body_repeat1,
    STATE(1067), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19242] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2292), 5,
      anon_sym_open,
      anon_sym_module,
      anon_sym_transitive,
      anon_sym_static,
      sym_identifier,
  [19254] = 6,
    ACTIONS(85), 1,
      anon_sym_LT,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1990), 1,
      anon_sym_DOT,
    STATE(346), 1,
      sym_argument_list,
    STATE(591), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19274] = 4,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(901), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2294), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [19290] = 4,
    STATE(992), 1,
      sym__wildcard_bounds,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2274), 2,
      anon_sym_extends,
      sym_super,
    ACTIONS(2296), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [19306] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2298), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [19318] = 5,
    ACTIONS(2300), 1,
      anon_sym_catch,
    ACTIONS(2302), 1,
      anon_sym_finally,
    STATE(204), 1,
      sym_finally_clause,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    STATE(58), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [19336] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2304), 5,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_SEMI,
  [19348] = 5,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(791), 1,
      sym__variable_declarator_id,
    STATE(971), 1,
      sym_variable_declarator,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
  [19366] = 4,
    ACTIONS(1775), 1,
      anon_sym_COMMA,
    STATE(847), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2306), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [19381] = 4,
    ACTIONS(2308), 1,
      sym_identifier,
    STATE(810), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2310), 2,
      anon_sym_open,
      anon_sym_module,
  [19396] = 4,
    ACTIONS(2312), 1,
      sym_identifier,
    STATE(812), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2314), 2,
      anon_sym_open,
      anon_sym_module,
  [19411] = 4,
    ACTIONS(2316), 1,
      sym_identifier,
    STATE(817), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2318), 2,
      anon_sym_open,
      anon_sym_module,
  [19426] = 4,
    ACTIONS(2320), 1,
      sym_identifier,
    STATE(805), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2322), 2,
      anon_sym_open,
      anon_sym_module,
  [19441] = 4,
    ACTIONS(2324), 1,
      sym_identifier,
    STATE(800), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2326), 2,
      anon_sym_open,
      anon_sym_module,
  [19456] = 4,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2332), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2330), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [19471] = 5,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_throws,
    STATE(379), 1,
      sym_constructor_body,
    STATE(1002), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19488] = 4,
    ACTIONS(2338), 1,
      sym_identifier,
    ACTIONS(2342), 1,
      sym_super,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2340), 2,
      anon_sym_open,
      anon_sym_module,
  [19503] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(92), 1,
      sym_class_body,
    STATE(990), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19520] = 4,
    ACTIONS(2344), 1,
      sym_identifier,
    STATE(809), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2346), 2,
      anon_sym_open,
      anon_sym_module,
  [19535] = 4,
    ACTIONS(2348), 1,
      anon_sym_AMP,
    STATE(781), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2351), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [19550] = 5,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(103), 1,
      sym_interface_body,
    STATE(1045), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19567] = 4,
    ACTIONS(2353), 1,
      anon_sym_COMMA,
    STATE(783), 1,
      aux_sym_enum_body_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2356), 2,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [19582] = 4,
    ACTIONS(2358), 1,
      sym_identifier,
    STATE(1052), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2360), 2,
      anon_sym_open,
      anon_sym_module,
  [19597] = 4,
    ACTIONS(2362), 1,
      sym_identifier,
    STATE(1060), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2364), 2,
      anon_sym_open,
      anon_sym_module,
  [19612] = 4,
    ACTIONS(2366), 1,
      sym_identifier,
    STATE(914), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2368), 2,
      anon_sym_open,
      anon_sym_module,
  [19627] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(81), 1,
      sym_class_body,
    STATE(1048), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19644] = 4,
    ACTIONS(2370), 1,
      sym_identifier,
    STATE(979), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2372), 2,
      anon_sym_open,
      anon_sym_module,
  [19659] = 4,
    ACTIONS(2374), 1,
      sym_identifier,
    STATE(902), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2376), 2,
      anon_sym_open,
      anon_sym_module,
  [19674] = 4,
    ACTIONS(2378), 1,
      sym_identifier,
    STATE(1061), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2380), 2,
      anon_sym_open,
      anon_sym_module,
  [19689] = 3,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2330), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [19702] = 5,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2382), 1,
      anon_sym_LBRACE,
    STATE(77), 1,
      sym_enum_body,
    STATE(1058), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19719] = 4,
    ACTIONS(2384), 1,
      sym_identifier,
    STATE(915), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2386), 2,
      anon_sym_open,
      anon_sym_module,
  [19734] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2388), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [19745] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(123), 1,
      sym_class_body,
    STATE(972), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19762] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(88), 1,
      sym_class_body,
    STATE(991), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19779] = 4,
    ACTIONS(2390), 1,
      sym_identifier,
    STATE(944), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2392), 2,
      anon_sym_open,
      anon_sym_module,
  [19794] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2394), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [19805] = 4,
    ACTIONS(2396), 1,
      sym_identifier,
    STATE(860), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2398), 2,
      anon_sym_open,
      anon_sym_module,
  [19820] = 5,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2402), 1,
      anon_sym_SEMI,
    STATE(943), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19837] = 5,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2406), 1,
      anon_sym_LBRACE,
    STATE(767), 1,
      sym_block,
    STATE(1015), 1,
      sym_resource_specification,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19854] = 4,
    ACTIONS(2408), 1,
      sym_identifier,
    STATE(561), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2410), 2,
      anon_sym_open,
      anon_sym_module,
  [19869] = 5,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(68), 1,
      sym_interface_body,
    STATE(959), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19886] = 5,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2412), 1,
      anon_sym_SEMI,
    STATE(941), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19903] = 5,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2414), 1,
      anon_sym_SEMI,
    STATE(939), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19920] = 4,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(1125), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
  [19935] = 4,
    ACTIONS(2416), 1,
      sym_identifier,
    STATE(875), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2418), 2,
      anon_sym_open,
      anon_sym_module,
  [19950] = 5,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2420), 1,
      anon_sym_SEMI,
    STATE(937), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19967] = 5,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2424), 1,
      anon_sym_SEMI,
    STATE(922), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [19984] = 5,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2426), 1,
      anon_sym_SEMI,
    STATE(934), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20001] = 5,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2428), 1,
      anon_sym_SEMI,
    STATE(932), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20018] = 5,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2430), 1,
      anon_sym_SEMI,
    STATE(930), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20035] = 5,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2432), 1,
      anon_sym_SEMI,
    STATE(928), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20052] = 5,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(91), 1,
      sym_interface_body,
    STATE(1054), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20069] = 4,
    ACTIONS(2434), 1,
      anon_sym_AMP,
    STATE(781), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2436), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [20084] = 4,
    ACTIONS(2438), 1,
      anon_sym_COMMA,
    STATE(816), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1810), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [20099] = 5,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2441), 1,
      anon_sym_SEMI,
    STATE(926), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20116] = 5,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2443), 1,
      anon_sym_SEMI,
    STATE(924), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20133] = 4,
    ACTIONS(2447), 1,
      anon_sym_extends,
    STATE(1041), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2445), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [20148] = 5,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2449), 1,
      anon_sym_AMP,
    ACTIONS(2451), 1,
      anon_sym_RPAREN,
    STATE(923), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20165] = 4,
    ACTIONS(2453), 1,
      sym_identifier,
    STATE(341), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2455), 2,
      anon_sym_open,
      anon_sym_module,
  [20180] = 4,
    ACTIONS(2336), 1,
      anon_sym_throws,
    STATE(967), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2457), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [20195] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2279), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_permits,
  [20206] = 4,
    ACTIONS(2459), 1,
      sym_identifier,
    STATE(458), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2461), 2,
      anon_sym_open,
      anon_sym_module,
  [20221] = 4,
    ACTIONS(2463), 1,
      sym_identifier,
    STATE(1008), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2465), 2,
      anon_sym_open,
      anon_sym_module,
  [20236] = 5,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    ACTIONS(2336), 1,
      anon_sym_throws,
    STATE(352), 1,
      sym_constructor_body,
    STATE(1038), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20253] = 4,
    ACTIONS(2467), 1,
      anon_sym_COMMA,
    STATE(754), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2469), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [20268] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(117), 1,
      sym_class_body,
    STATE(955), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20285] = 4,
    ACTIONS(2467), 1,
      anon_sym_COMMA,
    STATE(827), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2471), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [20300] = 5,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2473), 1,
      anon_sym_DOT,
    STATE(1118), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20317] = 4,
    ACTIONS(2336), 1,
      anon_sym_throws,
    STATE(983), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2475), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [20332] = 4,
    ACTIONS(2336), 1,
      anon_sym_throws,
    STATE(1019), 1,
      sym_throws,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2477), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [20347] = 4,
    ACTIONS(2447), 1,
      anon_sym_extends,
    STATE(993), 1,
      sym_type_bound,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2479), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [20362] = 4,
    ACTIONS(2467), 1,
      anon_sym_COMMA,
    STATE(754), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2481), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [20377] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2483), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [20388] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(69), 1,
      sym_class_body,
    STATE(1030), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20405] = 4,
    ACTIONS(2434), 1,
      anon_sym_AMP,
    STATE(815), 1,
      aux_sym_type_bound_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2485), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [20420] = 5,
    ACTIONS(2078), 1,
      anon_sym_implements,
    ACTIONS(2382), 1,
      anon_sym_LBRACE,
    STATE(132), 1,
      sym_enum_body,
    STATE(968), 1,
      sym_super_interfaces,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20437] = 4,
    ACTIONS(2328), 1,
      anon_sym_EQ,
    ACTIONS(2487), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2330), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20452] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(111), 1,
      sym_class_body,
    STATE(1023), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20469] = 5,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    ACTIONS(2080), 1,
      anon_sym_permits,
    STATE(114), 1,
      sym_class_body,
    STATE(1017), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20486] = 5,
    ACTIONS(2080), 1,
      anon_sym_permits,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(97), 1,
      sym_interface_body,
    STATE(987), 1,
      sym_permits,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20503] = 4,
    ACTIONS(1956), 1,
      sym_identifier,
    STATE(1091), 1,
      sym__variable_declarator_id,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1950), 2,
      anon_sym_open,
      anon_sym_module,
  [20518] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2489), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [20529] = 5,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2449), 1,
      anon_sym_AMP,
    ACTIONS(2491), 1,
      anon_sym_RPAREN,
    STATE(894), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20546] = 4,
    ACTIONS(2467), 1,
      anon_sym_COMMA,
    STATE(834), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2493), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [20561] = 4,
    ACTIONS(2495), 1,
      anon_sym_COMMA,
    STATE(847), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1810), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [20576] = 4,
    ACTIONS(85), 1,
      anon_sym_LT,
    STATE(1022), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2498), 2,
      anon_sym_new,
      sym_identifier,
  [20591] = 5,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2500), 1,
      anon_sym_SEMI,
    STATE(920), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20608] = 4,
    ACTIONS(2502), 1,
      anon_sym_RPAREN,
    ACTIONS(2504), 1,
      anon_sym_SEMI,
    STATE(850), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20622] = 4,
    ACTIONS(2507), 1,
      anon_sym_GT,
    ACTIONS(2509), 1,
      anon_sym_COMMA,
    STATE(935), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20636] = 4,
    ACTIONS(2511), 1,
      anon_sym_RPAREN,
    ACTIONS(2513), 1,
      anon_sym_COMMA,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20650] = 4,
    ACTIONS(2516), 1,
      anon_sym_COMMA,
    ACTIONS(2519), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20664] = 4,
    ACTIONS(2521), 1,
      anon_sym_COMMA,
    ACTIONS(2523), 1,
      anon_sym_RBRACE,
    STATE(912), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20678] = 4,
    ACTIONS(2525), 1,
      anon_sym_RPAREN,
    ACTIONS(2527), 1,
      anon_sym_COMMA,
    STATE(855), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20692] = 4,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    ACTIONS(2290), 1,
      anon_sym_RBRACE,
    STATE(1067), 1,
      sym_enum_body_declarations,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20706] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2530), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20720] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2532), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20734] = 4,
    ACTIONS(2534), 1,
      anon_sym_RPAREN,
    ACTIONS(2536), 1,
      anon_sym_COMMA,
    STATE(906), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20748] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2538), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20760] = 4,
    ACTIONS(2540), 1,
      anon_sym_GT,
    ACTIONS(2542), 1,
      anon_sym_COMMA,
    STATE(889), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20774] = 4,
    ACTIONS(2544), 1,
      anon_sym_COMMA,
    ACTIONS(2547), 1,
      anon_sym_RBRACE,
    STATE(862), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20788] = 4,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20802] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2549), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20816] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2551), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
  [20826] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2553), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_throws,
  [20836] = 4,
    ACTIONS(2555), 1,
      anon_sym_COMMA,
    ACTIONS(2558), 1,
      anon_sym_SEMI,
    STATE(867), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20850] = 4,
    ACTIONS(2560), 1,
      anon_sym_AMP,
    ACTIONS(2563), 1,
      anon_sym_RPAREN,
    STATE(868), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20864] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2565), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [20874] = 4,
    ACTIONS(1866), 1,
      anon_sym_RBRACE,
    ACTIONS(2567), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20888] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2570), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20900] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2572), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20914] = 4,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(2574), 1,
      anon_sym_SEMI,
    STATE(376), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20928] = 4,
    ACTIONS(1537), 1,
      anon_sym_LBRACK,
    ACTIONS(1539), 1,
      anon_sym_DOT,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20942] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2576), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20954] = 4,
    ACTIONS(2536), 1,
      anon_sym_COMMA,
    ACTIONS(2578), 1,
      anon_sym_RPAREN,
    STATE(942), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20968] = 4,
    ACTIONS(2580), 1,
      anon_sym_RPAREN,
    ACTIONS(2582), 1,
      anon_sym_SEMI,
    STATE(938), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [20982] = 3,
    ACTIONS(2584), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2586), 2,
      anon_sym_open,
      anon_sym_module,
  [20994] = 4,
    ACTIONS(2588), 1,
      anon_sym_COMMA,
    ACTIONS(2591), 1,
      anon_sym_SEMI,
    STATE(879), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21008] = 4,
    ACTIONS(2536), 1,
      anon_sym_COMMA,
    ACTIONS(2593), 1,
      anon_sym_RPAREN,
    STATE(906), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21022] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2595), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [21034] = 4,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_STAR,
    STATE(1063), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21048] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2601), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [21058] = 4,
    ACTIONS(2536), 1,
      anon_sym_COMMA,
    ACTIONS(2603), 1,
      anon_sym_RPAREN,
    STATE(880), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21072] = 4,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(891), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21086] = 4,
    ACTIONS(2609), 1,
      anon_sym_RPAREN,
    ACTIONS(2611), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21100] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2614), 3,
      anon_sym_LBRACE,
      anon_sym_implements,
      anon_sym_permits,
  [21110] = 4,
    ACTIONS(2599), 1,
      anon_sym_STAR,
    ACTIONS(2616), 1,
      sym_identifier,
    STATE(1064), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21124] = 4,
    ACTIONS(2542), 1,
      anon_sym_COMMA,
    ACTIONS(2618), 1,
      anon_sym_GT,
    STATE(925), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21138] = 4,
    ACTIONS(2064), 1,
      anon_sym_default,
    ACTIONS(2620), 1,
      anon_sym_SEMI,
    STATE(1096), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21152] = 4,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    ACTIONS(2622), 1,
      anon_sym_RPAREN,
    STATE(886), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21166] = 4,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1984), 1,
      anon_sym_DOT,
    STATE(349), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21180] = 4,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    STATE(208), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21194] = 4,
    ACTIONS(2449), 1,
      anon_sym_AMP,
    ACTIONS(2626), 1,
      anon_sym_RPAREN,
    STATE(868), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21208] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2628), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [21218] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2351), 3,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_COMMA,
  [21228] = 4,
    ACTIONS(2542), 1,
      anon_sym_COMMA,
    ACTIONS(2630), 1,
      anon_sym_GT,
    STATE(925), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21242] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2356), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [21252] = 4,
    ACTIONS(1121), 1,
      anon_sym_COMMA,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
    STATE(855), 1,
      aux_sym_inferred_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21266] = 4,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(2634), 1,
      anon_sym_DOT,
    STATE(1138), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21280] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2636), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [21290] = 4,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    STATE(209), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21304] = 4,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21318] = 4,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    STATE(171), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21332] = 4,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    STATE(172), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21346] = 4,
    ACTIONS(2638), 1,
      anon_sym_RPAREN,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    STATE(906), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21360] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2643), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21374] = 4,
    ACTIONS(2645), 1,
      anon_sym_COMMA,
    ACTIONS(2648), 1,
      anon_sym_SEMI,
    STATE(908), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21388] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1812), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [21398] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2650), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21412] = 4,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    STATE(143), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21426] = 4,
    ACTIONS(387), 1,
      anon_sym_RBRACE,
    ACTIONS(2652), 1,
      anon_sym_COMMA,
    STATE(862), 1,
      aux_sym_element_value_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21440] = 4,
    ACTIONS(2654), 1,
      anon_sym_COMMA,
    ACTIONS(2656), 1,
      anon_sym_SEMI,
    STATE(953), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21454] = 4,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2624), 1,
      anon_sym_LBRACE,
    STATE(144), 1,
      sym_module_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21468] = 4,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2658), 1,
      anon_sym_SEMI,
    ACTIONS(2660), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21482] = 4,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2662), 1,
      anon_sym_SEMI,
    ACTIONS(2664), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21496] = 4,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym_STAR,
    STATE(1144), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21510] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2666), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21524] = 4,
    ACTIONS(2599), 1,
      anon_sym_STAR,
    ACTIONS(2616), 1,
      sym_identifier,
    STATE(1145), 1,
      sym_asterisk,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21538] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2668), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21552] = 4,
    ACTIONS(2542), 1,
      anon_sym_COMMA,
    ACTIONS(2670), 1,
      anon_sym_GT,
    STATE(897), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21566] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2672), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21580] = 4,
    ACTIONS(2449), 1,
      anon_sym_AMP,
    ACTIONS(2674), 1,
      anon_sym_RPAREN,
    STATE(868), 1,
      aux_sym_cast_expression_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21594] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2676), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21608] = 4,
    ACTIONS(2678), 1,
      anon_sym_GT,
    ACTIONS(2680), 1,
      anon_sym_COMMA,
    STATE(925), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21622] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2683), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21636] = 4,
    ACTIONS(1800), 1,
      anon_sym_COMMA,
    ACTIONS(2685), 1,
      anon_sym_RPAREN,
    STATE(852), 1,
      aux_sym_for_statement_repeat2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21650] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2687), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21664] = 3,
    ACTIONS(2338), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2340), 2,
      anon_sym_open,
      anon_sym_module,
  [21676] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2689), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21690] = 4,
    ACTIONS(1790), 1,
      anon_sym_COMMA,
    ACTIONS(2691), 1,
      anon_sym_SEMI,
    STATE(867), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21704] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2693), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21718] = 4,
    ACTIONS(1838), 1,
      anon_sym_COMMA,
    ACTIONS(1840), 1,
      anon_sym_RBRACE,
    STATE(949), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21732] = 4,
    ACTIONS(2422), 1,
      anon_sym_COMMA,
    ACTIONS(2695), 1,
      anon_sym_SEMI,
    STATE(853), 1,
      aux_sym_exports_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21746] = 4,
    ACTIONS(2509), 1,
      anon_sym_COMMA,
    ACTIONS(2697), 1,
      anon_sym_GT,
    STATE(946), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21760] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2699), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [21770] = 4,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2701), 1,
      anon_sym_SEMI,
    STATE(879), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21784] = 4,
    ACTIONS(941), 1,
      anon_sym_RPAREN,
    ACTIONS(2703), 1,
      anon_sym_SEMI,
    STATE(850), 1,
      aux_sym_resource_specification_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21798] = 4,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2705), 1,
      anon_sym_SEMI,
    STATE(879), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21812] = 4,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    ACTIONS(2707), 1,
      anon_sym_SEMI,
    STATE(372), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21826] = 4,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2709), 1,
      anon_sym_SEMI,
    STATE(879), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21840] = 4,
    ACTIONS(2536), 1,
      anon_sym_COMMA,
    ACTIONS(2711), 1,
      anon_sym_RPAREN,
    STATE(906), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21854] = 4,
    ACTIONS(2400), 1,
      anon_sym_COMMA,
    ACTIONS(2713), 1,
      anon_sym_SEMI,
    STATE(879), 1,
      aux_sym_provides_module_directive_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21868] = 4,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2715), 1,
      anon_sym_SEMI,
    ACTIONS(2717), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21882] = 4,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2719), 1,
      anon_sym_SEMI,
    ACTIONS(2721), 1,
      anon_sym_to,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21896] = 4,
    ACTIONS(2723), 1,
      anon_sym_GT,
    ACTIONS(2725), 1,
      anon_sym_COMMA,
    STATE(946), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21910] = 4,
    ACTIONS(2064), 1,
      anon_sym_default,
    ACTIONS(2728), 1,
      anon_sym_SEMI,
    STATE(1107), 1,
      sym__default_value,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21924] = 4,
    ACTIONS(1796), 1,
      anon_sym_COMMA,
    ACTIONS(2730), 1,
      anon_sym_RPAREN,
    STATE(816), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21938] = 4,
    ACTIONS(599), 1,
      anon_sym_RBRACE,
    ACTIONS(2732), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      aux_sym_array_initializer_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21952] = 4,
    ACTIONS(1246), 1,
      anon_sym_RPAREN,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(903), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21966] = 4,
    ACTIONS(2536), 1,
      anon_sym_COMMA,
    ACTIONS(2734), 1,
      anon_sym_RPAREN,
    STATE(859), 1,
      aux_sym_annotation_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21980] = 4,
    ACTIONS(1796), 1,
      anon_sym_COMMA,
    ACTIONS(2306), 1,
      anon_sym_COLON,
    STATE(816), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [21994] = 4,
    ACTIONS(2654), 1,
      anon_sym_COMMA,
    ACTIONS(2736), 1,
      anon_sym_SEMI,
    STATE(908), 1,
      aux_sym__variable_declarator_list_repeat1,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22008] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2738), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22019] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(109), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22030] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2740), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [22039] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(98), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22050] = 3,
    ACTIONS(939), 1,
      anon_sym_LPAREN,
    STATE(1031), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22061] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(90), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22072] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(1106), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22083] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(383), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22094] = 3,
    ACTIONS(939), 1,
      anon_sym_LPAREN,
    STATE(40), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22105] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(398), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22116] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(349), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22127] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(79), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22138] = 3,
    ACTIONS(2742), 1,
      sym_identifier,
    ACTIONS(2744), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22149] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2746), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [22158] = 3,
    ACTIONS(2382), 1,
      anon_sym_LBRACE,
    STATE(78), 1,
      sym_enum_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22169] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(74), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22180] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2748), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [22189] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2750), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [22198] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(131), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22209] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2752), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [22218] = 3,
    ACTIONS(2754), 1,
      sym_identifier,
    ACTIONS(2756), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22229] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2547), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [22238] = 3,
    ACTIONS(491), 1,
      anon_sym_LBRACE,
    STATE(416), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22249] = 3,
    ACTIONS(491), 1,
      anon_sym_LBRACE,
    STATE(400), 1,
      sym_array_initializer,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22260] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(345), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22271] = 3,
    ACTIONS(2758), 1,
      anon_sym_DOT,
    ACTIONS(2760), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22282] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(120), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22293] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(1103), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22304] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2762), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22313] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2764), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [22322] = 3,
    ACTIONS(939), 1,
      anon_sym_LPAREN,
    STATE(1114), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22333] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(354), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22344] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(1866), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [22353] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(127), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22364] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2678), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22373] = 3,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(145), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22384] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(126), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22395] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(125), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22406] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2766), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22415] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2768), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22424] = 3,
    ACTIONS(939), 1,
      anon_sym_LPAREN,
    STATE(42), 1,
      sym_parenthesized_expression,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22435] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(124), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22446] = 3,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(1040), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22457] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(397), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22468] = 3,
    ACTIONS(2770), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_annotation_type_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22479] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2772), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [22488] = 3,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    STATE(399), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22499] = 3,
    ACTIONS(2774), 1,
      anon_sym_DOT,
    ACTIONS(2776), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22510] = 3,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    STATE(371), 1,
      sym_constructor_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22521] = 3,
    ACTIONS(2778), 1,
      anon_sym_DOT,
    ACTIONS(2780), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22532] = 3,
    ACTIONS(2782), 1,
      anon_sym_DASH_GT,
    ACTIONS(2784), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22543] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2786), 2,
      anon_sym_DASH_GT,
      anon_sym_COLON,
  [22552] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(70), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22563] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2788), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22574] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2790), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22585] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2792), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22596] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2794), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22607] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2796), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22618] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2798), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22629] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2800), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22640] = 3,
    ACTIONS(2802), 1,
      anon_sym_DOT,
    ACTIONS(2804), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22651] = 3,
    ACTIONS(2406), 1,
      anon_sym_LBRACE,
    STATE(59), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22662] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2638), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [22671] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(66), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22682] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2806), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [22691] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2808), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [22700] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(105), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22711] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(110), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22722] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2810), 2,
      anon_sym_new,
      sym_identifier,
  [22731] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(71), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22742] = 3,
    ACTIONS(27), 1,
      anon_sym_LBRACE,
    STATE(212), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22753] = 3,
    ACTIONS(2406), 1,
      anon_sym_LBRACE,
    STATE(107), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22764] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(112), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22775] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2812), 2,
      anon_sym_LBRACE,
      anon_sym_permits,
  [22784] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2502), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [22793] = 3,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2473), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22804] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(106), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22815] = 3,
    ACTIONS(2814), 1,
      anon_sym_LBRACE,
    STATE(49), 1,
      sym_switch_block,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22826] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2296), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22835] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2816), 2,
      sym_this,
      sym_super,
  [22844] = 3,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(653), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22855] = 3,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(654), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22866] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2818), 2,
      anon_sym_LBRACE,
      anon_sym_throws,
  [22875] = 3,
    ACTIONS(2820), 1,
      sym_identifier,
    STATE(1016), 1,
      sym_element_value_pair,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22886] = 3,
    ACTIONS(2334), 1,
      anon_sym_LBRACE,
    STATE(357), 1,
      sym_constructor_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22897] = 3,
    ACTIONS(2042), 1,
      anon_sym_LPAREN,
    STATE(985), 1,
      sym_formal_parameters,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22908] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(358), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22919] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2822), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22928] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2723), 2,
      anon_sym_GT,
      anon_sym_COMMA,
  [22937] = 3,
    ACTIONS(2770), 1,
      anon_sym_LBRACE,
    STATE(101), 1,
      sym_annotation_type_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22948] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2824), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22959] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(100), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22970] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(96), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22981] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2826), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [22992] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(95), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23003] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(94), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23014] = 3,
    ACTIONS(1284), 1,
      anon_sym_LBRACE,
    STATE(89), 1,
      sym_class_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23025] = 3,
    ACTIONS(1278), 1,
      anon_sym_DOT,
    ACTIONS(2828), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23036] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2830), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23047] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2525), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [23056] = 3,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    STATE(84), 1,
      sym_interface_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23067] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2832), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [23076] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2834), 2,
      anon_sym_AMP,
      anon_sym_RPAREN,
  [23085] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2836), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [23094] = 3,
    ACTIONS(2382), 1,
      anon_sym_LBRACE,
    STATE(121), 1,
      sym_enum_body,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23105] = 2,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
    ACTIONS(2609), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [23114] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2838), 1,
      anon_sym_with,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23125] = 3,
    ACTIONS(1272), 1,
      anon_sym_DOT,
    ACTIONS(2840), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23136] = 2,
    ACTIONS(2597), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23144] = 2,
    ACTIONS(2842), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23152] = 2,
    ACTIONS(2844), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23160] = 2,
    ACTIONS(2846), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23168] = 2,
    ACTIONS(2848), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23176] = 2,
    ACTIONS(1875), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23184] = 2,
    ACTIONS(1541), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23192] = 2,
    ACTIONS(2850), 1,
      anon_sym_module,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23200] = 2,
    ACTIONS(933), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23208] = 2,
    ACTIONS(2852), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23216] = 2,
    ACTIONS(2854), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23224] = 2,
    ACTIONS(1058), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23232] = 2,
    ACTIONS(2856), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23240] = 2,
    ACTIONS(2858), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23248] = 2,
    ACTIONS(2860), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23256] = 2,
    ACTIONS(2523), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23264] = 2,
    ACTIONS(2862), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23272] = 2,
    ACTIONS(2864), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23280] = 2,
    ACTIONS(2734), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23288] = 2,
    ACTIONS(2866), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23296] = 2,
    ACTIONS(2868), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23304] = 2,
    ACTIONS(2782), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23312] = 2,
    ACTIONS(2784), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23320] = 2,
    ACTIONS(2870), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23328] = 2,
    ACTIONS(2872), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23336] = 2,
    ACTIONS(2874), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23344] = 2,
    ACTIONS(2876), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23352] = 2,
    ACTIONS(2878), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23360] = 2,
    ACTIONS(2880), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23368] = 2,
    ACTIONS(2882), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23376] = 2,
    ACTIONS(2634), 1,
      anon_sym_DOT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23384] = 2,
    ACTIONS(2884), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23392] = 2,
    ACTIONS(1873), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23400] = 2,
    ACTIONS(2886), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23408] = 2,
    ACTIONS(2888), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23416] = 2,
    ACTIONS(2890), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23424] = 2,
    ACTIONS(2892), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23432] = 2,
    ACTIONS(2894), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23440] = 2,
    ACTIONS(2896), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23448] = 2,
    ACTIONS(2898), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23456] = 2,
    ACTIONS(2900), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23464] = 2,
    ACTIONS(2902), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23472] = 2,
    ACTIONS(2904), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23480] = 2,
    ACTIONS(2906), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23488] = 2,
    ACTIONS(2908), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23496] = 2,
    ACTIONS(2910), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23504] = 2,
    ACTIONS(2912), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23512] = 2,
    ACTIONS(921), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23520] = 2,
    ACTIONS(2914), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23528] = 2,
    ACTIONS(2916), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23536] = 2,
    ACTIONS(1840), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23544] = 2,
    ACTIONS(2918), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23552] = 2,
    ACTIONS(2920), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23560] = 2,
    ACTIONS(2616), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23568] = 2,
    ACTIONS(2922), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23576] = 2,
    ACTIONS(2924), 1,
      sym_this,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23584] = 2,
    ACTIONS(2926), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23592] = 2,
    ACTIONS(2928), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23600] = 2,
    ACTIONS(2930), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23608] = 2,
    ACTIONS(2932), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23616] = 2,
    ACTIONS(2934), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23624] = 2,
    ACTIONS(2936), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23632] = 2,
    ACTIONS(925), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23640] = 2,
    ACTIONS(2938), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23648] = 2,
    ACTIONS(2940), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23656] = 2,
    ACTIONS(929), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23664] = 2,
    ACTIONS(2942), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23672] = 2,
    ACTIONS(2603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23680] = 2,
    ACTIONS(2944), 1,
      anon_sym_class,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23688] = 2,
    ACTIONS(2946), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23696] = 2,
    ACTIONS(2948), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23704] = 2,
    ACTIONS(2950), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23712] = 2,
    ACTIONS(2952), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23720] = 2,
    ACTIONS(2954), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23728] = 2,
    ACTIONS(2578), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23736] = 2,
    ACTIONS(2956), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23744] = 2,
    ACTIONS(2958), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23752] = 2,
    ACTIONS(2960), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23760] = 2,
    ACTIONS(2962), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23768] = 2,
    ACTIONS(2964), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23776] = 2,
    ACTIONS(2290), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23784] = 2,
    ACTIONS(2966), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23792] = 2,
    ACTIONS(2968), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23800] = 2,
    ACTIONS(2970), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
  [23808] = 2,
    ACTIONS(2972), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_line_comment,
      sym_block_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(299)] = 0,
  [SMALL_STATE(300)] = 118,
  [SMALL_STATE(301)] = 236,
  [SMALL_STATE(302)] = 354,
  [SMALL_STATE(303)] = 472,
  [SMALL_STATE(304)] = 590,
  [SMALL_STATE(305)] = 693,
  [SMALL_STATE(306)] = 776,
  [SMALL_STATE(307)] = 879,
  [SMALL_STATE(308)] = 982,
  [SMALL_STATE(309)] = 1072,
  [SMALL_STATE(310)] = 1153,
  [SMALL_STATE(311)] = 1213,
  [SMALL_STATE(312)] = 1273,
  [SMALL_STATE(313)] = 1333,
  [SMALL_STATE(314)] = 1393,
  [SMALL_STATE(315)] = 1456,
  [SMALL_STATE(316)] = 1543,
  [SMALL_STATE(317)] = 1630,
  [SMALL_STATE(318)] = 1717,
  [SMALL_STATE(319)] = 1791,
  [SMALL_STATE(320)] = 1845,
  [SMALL_STATE(321)] = 1899,
  [SMALL_STATE(322)] = 1967,
  [SMALL_STATE(323)] = 2021,
  [SMALL_STATE(324)] = 2078,
  [SMALL_STATE(325)] = 2151,
  [SMALL_STATE(326)] = 2211,
  [SMALL_STATE(327)] = 2274,
  [SMALL_STATE(328)] = 2337,
  [SMALL_STATE(329)] = 2398,
  [SMALL_STATE(330)] = 2452,
  [SMALL_STATE(331)] = 2502,
  [SMALL_STATE(332)] = 2552,
  [SMALL_STATE(333)] = 2634,
  [SMALL_STATE(334)] = 2691,
  [SMALL_STATE(335)] = 2747,
  [SMALL_STATE(336)] = 2821,
  [SMALL_STATE(337)] = 2877,
  [SMALL_STATE(338)] = 2934,
  [SMALL_STATE(339)] = 3005,
  [SMALL_STATE(340)] = 3062,
  [SMALL_STATE(341)] = 3135,
  [SMALL_STATE(342)] = 3187,
  [SMALL_STATE(343)] = 3239,
  [SMALL_STATE(344)] = 3285,
  [SMALL_STATE(345)] = 3331,
  [SMALL_STATE(346)] = 3379,
  [SMALL_STATE(347)] = 3427,
  [SMALL_STATE(348)] = 3475,
  [SMALL_STATE(349)] = 3527,
  [SMALL_STATE(350)] = 3575,
  [SMALL_STATE(351)] = 3627,
  [SMALL_STATE(352)] = 3670,
  [SMALL_STATE(353)] = 3713,
  [SMALL_STATE(354)] = 3756,
  [SMALL_STATE(355)] = 3799,
  [SMALL_STATE(356)] = 3842,
  [SMALL_STATE(357)] = 3885,
  [SMALL_STATE(358)] = 3928,
  [SMALL_STATE(359)] = 3971,
  [SMALL_STATE(360)] = 4014,
  [SMALL_STATE(361)] = 4057,
  [SMALL_STATE(362)] = 4100,
  [SMALL_STATE(363)] = 4143,
  [SMALL_STATE(364)] = 4186,
  [SMALL_STATE(365)] = 4229,
  [SMALL_STATE(366)] = 4272,
  [SMALL_STATE(367)] = 4315,
  [SMALL_STATE(368)] = 4364,
  [SMALL_STATE(369)] = 4407,
  [SMALL_STATE(370)] = 4450,
  [SMALL_STATE(371)] = 4493,
  [SMALL_STATE(372)] = 4536,
  [SMALL_STATE(373)] = 4579,
  [SMALL_STATE(374)] = 4628,
  [SMALL_STATE(375)] = 4671,
  [SMALL_STATE(376)] = 4714,
  [SMALL_STATE(377)] = 4757,
  [SMALL_STATE(378)] = 4800,
  [SMALL_STATE(379)] = 4843,
  [SMALL_STATE(380)] = 4886,
  [SMALL_STATE(381)] = 4929,
  [SMALL_STATE(382)] = 4971,
  [SMALL_STATE(383)] = 5013,
  [SMALL_STATE(384)] = 5055,
  [SMALL_STATE(385)] = 5097,
  [SMALL_STATE(386)] = 5139,
  [SMALL_STATE(387)] = 5181,
  [SMALL_STATE(388)] = 5223,
  [SMALL_STATE(389)] = 5265,
  [SMALL_STATE(390)] = 5307,
  [SMALL_STATE(391)] = 5349,
  [SMALL_STATE(392)] = 5393,
  [SMALL_STATE(393)] = 5435,
  [SMALL_STATE(394)] = 5477,
  [SMALL_STATE(395)] = 5519,
  [SMALL_STATE(396)] = 5561,
  [SMALL_STATE(397)] = 5603,
  [SMALL_STATE(398)] = 5645,
  [SMALL_STATE(399)] = 5687,
  [SMALL_STATE(400)] = 5729,
  [SMALL_STATE(401)] = 5771,
  [SMALL_STATE(402)] = 5813,
  [SMALL_STATE(403)] = 5855,
  [SMALL_STATE(404)] = 5897,
  [SMALL_STATE(405)] = 5939,
  [SMALL_STATE(406)] = 5981,
  [SMALL_STATE(407)] = 6023,
  [SMALL_STATE(408)] = 6071,
  [SMALL_STATE(409)] = 6113,
  [SMALL_STATE(410)] = 6155,
  [SMALL_STATE(411)] = 6197,
  [SMALL_STATE(412)] = 6239,
  [SMALL_STATE(413)] = 6281,
  [SMALL_STATE(414)] = 6323,
  [SMALL_STATE(415)] = 6365,
  [SMALL_STATE(416)] = 6407,
  [SMALL_STATE(417)] = 6449,
  [SMALL_STATE(418)] = 6491,
  [SMALL_STATE(419)] = 6533,
  [SMALL_STATE(420)] = 6575,
  [SMALL_STATE(421)] = 6617,
  [SMALL_STATE(422)] = 6663,
  [SMALL_STATE(423)] = 6704,
  [SMALL_STATE(424)] = 6745,
  [SMALL_STATE(425)] = 6786,
  [SMALL_STATE(426)] = 6827,
  [SMALL_STATE(427)] = 6868,
  [SMALL_STATE(428)] = 6913,
  [SMALL_STATE(429)] = 6954,
  [SMALL_STATE(430)] = 6998,
  [SMALL_STATE(431)] = 7037,
  [SMALL_STATE(432)] = 7078,
  [SMALL_STATE(433)] = 7117,
  [SMALL_STATE(434)] = 7156,
  [SMALL_STATE(435)] = 7195,
  [SMALL_STATE(436)] = 7236,
  [SMALL_STATE(437)] = 7275,
  [SMALL_STATE(438)] = 7314,
  [SMALL_STATE(439)] = 7353,
  [SMALL_STATE(440)] = 7394,
  [SMALL_STATE(441)] = 7433,
  [SMALL_STATE(442)] = 7472,
  [SMALL_STATE(443)] = 7511,
  [SMALL_STATE(444)] = 7550,
  [SMALL_STATE(445)] = 7600,
  [SMALL_STATE(446)] = 7656,
  [SMALL_STATE(447)] = 7724,
  [SMALL_STATE(448)] = 7768,
  [SMALL_STATE(449)] = 7814,
  [SMALL_STATE(450)] = 7856,
  [SMALL_STATE(451)] = 7916,
  [SMALL_STATE(452)] = 7954,
  [SMALL_STATE(453)] = 8016,
  [SMALL_STATE(454)] = 8060,
  [SMALL_STATE(455)] = 8124,
  [SMALL_STATE(456)] = 8186,
  [SMALL_STATE(457)] = 8244,
  [SMALL_STATE(458)] = 8312,
  [SMALL_STATE(459)] = 8356,
  [SMALL_STATE(460)] = 8400,
  [SMALL_STATE(461)] = 8468,
  [SMALL_STATE(462)] = 8512,
  [SMALL_STATE(463)] = 8550,
  [SMALL_STATE(464)] = 8588,
  [SMALL_STATE(465)] = 8626,
  [SMALL_STATE(466)] = 8664,
  [SMALL_STATE(467)] = 8732,
  [SMALL_STATE(468)] = 8770,
  [SMALL_STATE(469)] = 8808,
  [SMALL_STATE(470)] = 8846,
  [SMALL_STATE(471)] = 8883,
  [SMALL_STATE(472)] = 8920,
  [SMALL_STATE(473)] = 8962,
  [SMALL_STATE(474)] = 9006,
  [SMALL_STATE(475)] = 9072,
  [SMALL_STATE(476)] = 9142,
  [SMALL_STATE(477)] = 9186,
  [SMALL_STATE(478)] = 9221,
  [SMALL_STATE(479)] = 9274,
  [SMALL_STATE(480)] = 9327,
  [SMALL_STATE(481)] = 9396,
  [SMALL_STATE(482)] = 9455,
  [SMALL_STATE(483)] = 9516,
  [SMALL_STATE(484)] = 9557,
  [SMALL_STATE(485)] = 9622,
  [SMALL_STATE(486)] = 9681,
  [SMALL_STATE(487)] = 9738,
  [SMALL_STATE(488)] = 9807,
  [SMALL_STATE(489)] = 9876,
  [SMALL_STATE(490)] = 9945,
  [SMALL_STATE(491)] = 10014,
  [SMALL_STATE(492)] = 10057,
  [SMALL_STATE(493)] = 10092,
  [SMALL_STATE(494)] = 10127,
  [SMALL_STATE(495)] = 10192,
  [SMALL_STATE(496)] = 10257,
  [SMALL_STATE(497)] = 10322,
  [SMALL_STATE(498)] = 10377,
  [SMALL_STATE(499)] = 10436,
  [SMALL_STATE(500)] = 10505,
  [SMALL_STATE(501)] = 10540,
  [SMALL_STATE(502)] = 10609,
  [SMALL_STATE(503)] = 10668,
  [SMALL_STATE(504)] = 10703,
  [SMALL_STATE(505)] = 10772,
  [SMALL_STATE(506)] = 10807,
  [SMALL_STATE(507)] = 10876,
  [SMALL_STATE(508)] = 10911,
  [SMALL_STATE(509)] = 10980,
  [SMALL_STATE(510)] = 11049,
  [SMALL_STATE(511)] = 11114,
  [SMALL_STATE(512)] = 11149,
  [SMALL_STATE(513)] = 11196,
  [SMALL_STATE(514)] = 11261,
  [SMALL_STATE(515)] = 11330,
  [SMALL_STATE(516)] = 11365,
  [SMALL_STATE(517)] = 11430,
  [SMALL_STATE(518)] = 11494,
  [SMALL_STATE(519)] = 11560,
  [SMALL_STATE(520)] = 11624,
  [SMALL_STATE(521)] = 11688,
  [SMALL_STATE(522)] = 11752,
  [SMALL_STATE(523)] = 11816,
  [SMALL_STATE(524)] = 11880,
  [SMALL_STATE(525)] = 11936,
  [SMALL_STATE(526)] = 12000,
  [SMALL_STATE(527)] = 12038,
  [SMALL_STATE(528)] = 12088,
  [SMALL_STATE(529)] = 12138,
  [SMALL_STATE(530)] = 12201,
  [SMALL_STATE(531)] = 12264,
  [SMALL_STATE(532)] = 12327,
  [SMALL_STATE(533)] = 12390,
  [SMALL_STATE(534)] = 12445,
  [SMALL_STATE(535)] = 12508,
  [SMALL_STATE(536)] = 12571,
  [SMALL_STATE(537)] = 12634,
  [SMALL_STATE(538)] = 12689,
  [SMALL_STATE(539)] = 12752,
  [SMALL_STATE(540)] = 12807,
  [SMALL_STATE(541)] = 12870,
  [SMALL_STATE(542)] = 12933,
  [SMALL_STATE(543)] = 12996,
  [SMALL_STATE(544)] = 13059,
  [SMALL_STATE(545)] = 13122,
  [SMALL_STATE(546)] = 13177,
  [SMALL_STATE(547)] = 13240,
  [SMALL_STATE(548)] = 13303,
  [SMALL_STATE(549)] = 13366,
  [SMALL_STATE(550)] = 13429,
  [SMALL_STATE(551)] = 13481,
  [SMALL_STATE(552)] = 13533,
  [SMALL_STATE(553)] = 13591,
  [SMALL_STATE(554)] = 13643,
  [SMALL_STATE(555)] = 13695,
  [SMALL_STATE(556)] = 13747,
  [SMALL_STATE(557)] = 13799,
  [SMALL_STATE(558)] = 13851,
  [SMALL_STATE(559)] = 13903,
  [SMALL_STATE(560)] = 13944,
  [SMALL_STATE(561)] = 13975,
  [SMALL_STATE(562)] = 14012,
  [SMALL_STATE(563)] = 14049,
  [SMALL_STATE(564)] = 14080,
  [SMALL_STATE(565)] = 14129,
  [SMALL_STATE(566)] = 14159,
  [SMALL_STATE(567)] = 14189,
  [SMALL_STATE(568)] = 14235,
  [SMALL_STATE(569)] = 14281,
  [SMALL_STATE(570)] = 14327,
  [SMALL_STATE(571)] = 14373,
  [SMALL_STATE(572)] = 14419,
  [SMALL_STATE(573)] = 14465,
  [SMALL_STATE(574)] = 14511,
  [SMALL_STATE(575)] = 14540,
  [SMALL_STATE(576)] = 14569,
  [SMALL_STATE(577)] = 14604,
  [SMALL_STATE(578)] = 14633,
  [SMALL_STATE(579)] = 14682,
  [SMALL_STATE(580)] = 14717,
  [SMALL_STATE(581)] = 14746,
  [SMALL_STATE(582)] = 14774,
  [SMALL_STATE(583)] = 14802,
  [SMALL_STATE(584)] = 14830,
  [SMALL_STATE(585)] = 14858,
  [SMALL_STATE(586)] = 14886,
  [SMALL_STATE(587)] = 14914,
  [SMALL_STATE(588)] = 14942,
  [SMALL_STATE(589)] = 14974,
  [SMALL_STATE(590)] = 15020,
  [SMALL_STATE(591)] = 15048,
  [SMALL_STATE(592)] = 15076,
  [SMALL_STATE(593)] = 15123,
  [SMALL_STATE(594)] = 15150,
  [SMALL_STATE(595)] = 15177,
  [SMALL_STATE(596)] = 15206,
  [SMALL_STATE(597)] = 15240,
  [SMALL_STATE(598)] = 15280,
  [SMALL_STATE(599)] = 15325,
  [SMALL_STATE(600)] = 15364,
  [SMALL_STATE(601)] = 15403,
  [SMALL_STATE(602)] = 15440,
  [SMALL_STATE(603)] = 15473,
  [SMALL_STATE(604)] = 15518,
  [SMALL_STATE(605)] = 15555,
  [SMALL_STATE(606)] = 15592,
  [SMALL_STATE(607)] = 15631,
  [SMALL_STATE(608)] = 15668,
  [SMALL_STATE(609)] = 15710,
  [SMALL_STATE(610)] = 15736,
  [SMALL_STATE(611)] = 15760,
  [SMALL_STATE(612)] = 15802,
  [SMALL_STATE(613)] = 15844,
  [SMALL_STATE(614)] = 15868,
  [SMALL_STATE(615)] = 15910,
  [SMALL_STATE(616)] = 15952,
  [SMALL_STATE(617)] = 15994,
  [SMALL_STATE(618)] = 16036,
  [SMALL_STATE(619)] = 16078,
  [SMALL_STATE(620)] = 16117,
  [SMALL_STATE(621)] = 16156,
  [SMALL_STATE(622)] = 16195,
  [SMALL_STATE(623)] = 16228,
  [SMALL_STATE(624)] = 16267,
  [SMALL_STATE(625)] = 16306,
  [SMALL_STATE(626)] = 16345,
  [SMALL_STATE(627)] = 16373,
  [SMALL_STATE(628)] = 16407,
  [SMALL_STATE(629)] = 16441,
  [SMALL_STATE(630)] = 16477,
  [SMALL_STATE(631)] = 16511,
  [SMALL_STATE(632)] = 16547,
  [SMALL_STATE(633)] = 16583,
  [SMALL_STATE(634)] = 16617,
  [SMALL_STATE(635)] = 16651,
  [SMALL_STATE(636)] = 16685,
  [SMALL_STATE(637)] = 16721,
  [SMALL_STATE(638)] = 16757,
  [SMALL_STATE(639)] = 16787,
  [SMALL_STATE(640)] = 16817,
  [SMALL_STATE(641)] = 16851,
  [SMALL_STATE(642)] = 16882,
  [SMALL_STATE(643)] = 16915,
  [SMALL_STATE(644)] = 16946,
  [SMALL_STATE(645)] = 16977,
  [SMALL_STATE(646)] = 17010,
  [SMALL_STATE(647)] = 17043,
  [SMALL_STATE(648)] = 17076,
  [SMALL_STATE(649)] = 17107,
  [SMALL_STATE(650)] = 17140,
  [SMALL_STATE(651)] = 17171,
  [SMALL_STATE(652)] = 17203,
  [SMALL_STATE(653)] = 17233,
  [SMALL_STATE(654)] = 17261,
  [SMALL_STATE(655)] = 17289,
  [SMALL_STATE(656)] = 17321,
  [SMALL_STATE(657)] = 17343,
  [SMALL_STATE(658)] = 17372,
  [SMALL_STATE(659)] = 17401,
  [SMALL_STATE(660)] = 17430,
  [SMALL_STATE(661)] = 17459,
  [SMALL_STATE(662)] = 17494,
  [SMALL_STATE(663)] = 17529,
  [SMALL_STATE(664)] = 17559,
  [SMALL_STATE(665)] = 17587,
  [SMALL_STATE(666)] = 17617,
  [SMALL_STATE(667)] = 17633,
  [SMALL_STATE(668)] = 17662,
  [SMALL_STATE(669)] = 17687,
  [SMALL_STATE(670)] = 17716,
  [SMALL_STATE(671)] = 17745,
  [SMALL_STATE(672)] = 17772,
  [SMALL_STATE(673)] = 17801,
  [SMALL_STATE(674)] = 17825,
  [SMALL_STATE(675)] = 17847,
  [SMALL_STATE(676)] = 17871,
  [SMALL_STATE(677)] = 17891,
  [SMALL_STATE(678)] = 17913,
  [SMALL_STATE(679)] = 17933,
  [SMALL_STATE(680)] = 17953,
  [SMALL_STATE(681)] = 17977,
  [SMALL_STATE(682)] = 17990,
  [SMALL_STATE(683)] = 18007,
  [SMALL_STATE(684)] = 18024,
  [SMALL_STATE(685)] = 18037,
  [SMALL_STATE(686)] = 18050,
  [SMALL_STATE(687)] = 18071,
  [SMALL_STATE(688)] = 18084,
  [SMALL_STATE(689)] = 18097,
  [SMALL_STATE(690)] = 18114,
  [SMALL_STATE(691)] = 18127,
  [SMALL_STATE(692)] = 18144,
  [SMALL_STATE(693)] = 18157,
  [SMALL_STATE(694)] = 18170,
  [SMALL_STATE(695)] = 18183,
  [SMALL_STATE(696)] = 18196,
  [SMALL_STATE(697)] = 18219,
  [SMALL_STATE(698)] = 18242,
  [SMALL_STATE(699)] = 18255,
  [SMALL_STATE(700)] = 18278,
  [SMALL_STATE(701)] = 18295,
  [SMALL_STATE(702)] = 18308,
  [SMALL_STATE(703)] = 18325,
  [SMALL_STATE(704)] = 18338,
  [SMALL_STATE(705)] = 18351,
  [SMALL_STATE(706)] = 18364,
  [SMALL_STATE(707)] = 18385,
  [SMALL_STATE(708)] = 18398,
  [SMALL_STATE(709)] = 18421,
  [SMALL_STATE(710)] = 18434,
  [SMALL_STATE(711)] = 18447,
  [SMALL_STATE(712)] = 18460,
  [SMALL_STATE(713)] = 18473,
  [SMALL_STATE(714)] = 18486,
  [SMALL_STATE(715)] = 18509,
  [SMALL_STATE(716)] = 18522,
  [SMALL_STATE(717)] = 18535,
  [SMALL_STATE(718)] = 18552,
  [SMALL_STATE(719)] = 18565,
  [SMALL_STATE(720)] = 18582,
  [SMALL_STATE(721)] = 18595,
  [SMALL_STATE(722)] = 18612,
  [SMALL_STATE(723)] = 18629,
  [SMALL_STATE(724)] = 18650,
  [SMALL_STATE(725)] = 18663,
  [SMALL_STATE(726)] = 18676,
  [SMALL_STATE(727)] = 18693,
  [SMALL_STATE(728)] = 18710,
  [SMALL_STATE(729)] = 18723,
  [SMALL_STATE(730)] = 18736,
  [SMALL_STATE(731)] = 18749,
  [SMALL_STATE(732)] = 18766,
  [SMALL_STATE(733)] = 18779,
  [SMALL_STATE(734)] = 18792,
  [SMALL_STATE(735)] = 18809,
  [SMALL_STATE(736)] = 18822,
  [SMALL_STATE(737)] = 18835,
  [SMALL_STATE(738)] = 18848,
  [SMALL_STATE(739)] = 18871,
  [SMALL_STATE(740)] = 18884,
  [SMALL_STATE(741)] = 18901,
  [SMALL_STATE(742)] = 18914,
  [SMALL_STATE(743)] = 18927,
  [SMALL_STATE(744)] = 18940,
  [SMALL_STATE(745)] = 18953,
  [SMALL_STATE(746)] = 18966,
  [SMALL_STATE(747)] = 18986,
  [SMALL_STATE(748)] = 19006,
  [SMALL_STATE(749)] = 19026,
  [SMALL_STATE(750)] = 19044,
  [SMALL_STATE(751)] = 19060,
  [SMALL_STATE(752)] = 19076,
  [SMALL_STATE(753)] = 19090,
  [SMALL_STATE(754)] = 19106,
  [SMALL_STATE(755)] = 19122,
  [SMALL_STATE(756)] = 19140,
  [SMALL_STATE(757)] = 19156,
  [SMALL_STATE(758)] = 19168,
  [SMALL_STATE(759)] = 19186,
  [SMALL_STATE(760)] = 19202,
  [SMALL_STATE(761)] = 19222,
  [SMALL_STATE(762)] = 19242,
  [SMALL_STATE(763)] = 19254,
  [SMALL_STATE(764)] = 19274,
  [SMALL_STATE(765)] = 19290,
  [SMALL_STATE(766)] = 19306,
  [SMALL_STATE(767)] = 19318,
  [SMALL_STATE(768)] = 19336,
  [SMALL_STATE(769)] = 19348,
  [SMALL_STATE(770)] = 19366,
  [SMALL_STATE(771)] = 19381,
  [SMALL_STATE(772)] = 19396,
  [SMALL_STATE(773)] = 19411,
  [SMALL_STATE(774)] = 19426,
  [SMALL_STATE(775)] = 19441,
  [SMALL_STATE(776)] = 19456,
  [SMALL_STATE(777)] = 19471,
  [SMALL_STATE(778)] = 19488,
  [SMALL_STATE(779)] = 19503,
  [SMALL_STATE(780)] = 19520,
  [SMALL_STATE(781)] = 19535,
  [SMALL_STATE(782)] = 19550,
  [SMALL_STATE(783)] = 19567,
  [SMALL_STATE(784)] = 19582,
  [SMALL_STATE(785)] = 19597,
  [SMALL_STATE(786)] = 19612,
  [SMALL_STATE(787)] = 19627,
  [SMALL_STATE(788)] = 19644,
  [SMALL_STATE(789)] = 19659,
  [SMALL_STATE(790)] = 19674,
  [SMALL_STATE(791)] = 19689,
  [SMALL_STATE(792)] = 19702,
  [SMALL_STATE(793)] = 19719,
  [SMALL_STATE(794)] = 19734,
  [SMALL_STATE(795)] = 19745,
  [SMALL_STATE(796)] = 19762,
  [SMALL_STATE(797)] = 19779,
  [SMALL_STATE(798)] = 19794,
  [SMALL_STATE(799)] = 19805,
  [SMALL_STATE(800)] = 19820,
  [SMALL_STATE(801)] = 19837,
  [SMALL_STATE(802)] = 19854,
  [SMALL_STATE(803)] = 19869,
  [SMALL_STATE(804)] = 19886,
  [SMALL_STATE(805)] = 19903,
  [SMALL_STATE(806)] = 19920,
  [SMALL_STATE(807)] = 19935,
  [SMALL_STATE(808)] = 19950,
  [SMALL_STATE(809)] = 19967,
  [SMALL_STATE(810)] = 19984,
  [SMALL_STATE(811)] = 20001,
  [SMALL_STATE(812)] = 20018,
  [SMALL_STATE(813)] = 20035,
  [SMALL_STATE(814)] = 20052,
  [SMALL_STATE(815)] = 20069,
  [SMALL_STATE(816)] = 20084,
  [SMALL_STATE(817)] = 20099,
  [SMALL_STATE(818)] = 20116,
  [SMALL_STATE(819)] = 20133,
  [SMALL_STATE(820)] = 20148,
  [SMALL_STATE(821)] = 20165,
  [SMALL_STATE(822)] = 20180,
  [SMALL_STATE(823)] = 20195,
  [SMALL_STATE(824)] = 20206,
  [SMALL_STATE(825)] = 20221,
  [SMALL_STATE(826)] = 20236,
  [SMALL_STATE(827)] = 20253,
  [SMALL_STATE(828)] = 20268,
  [SMALL_STATE(829)] = 20285,
  [SMALL_STATE(830)] = 20300,
  [SMALL_STATE(831)] = 20317,
  [SMALL_STATE(832)] = 20332,
  [SMALL_STATE(833)] = 20347,
  [SMALL_STATE(834)] = 20362,
  [SMALL_STATE(835)] = 20377,
  [SMALL_STATE(836)] = 20388,
  [SMALL_STATE(837)] = 20405,
  [SMALL_STATE(838)] = 20420,
  [SMALL_STATE(839)] = 20437,
  [SMALL_STATE(840)] = 20452,
  [SMALL_STATE(841)] = 20469,
  [SMALL_STATE(842)] = 20486,
  [SMALL_STATE(843)] = 20503,
  [SMALL_STATE(844)] = 20518,
  [SMALL_STATE(845)] = 20529,
  [SMALL_STATE(846)] = 20546,
  [SMALL_STATE(847)] = 20561,
  [SMALL_STATE(848)] = 20576,
  [SMALL_STATE(849)] = 20591,
  [SMALL_STATE(850)] = 20608,
  [SMALL_STATE(851)] = 20622,
  [SMALL_STATE(852)] = 20636,
  [SMALL_STATE(853)] = 20650,
  [SMALL_STATE(854)] = 20664,
  [SMALL_STATE(855)] = 20678,
  [SMALL_STATE(856)] = 20692,
  [SMALL_STATE(857)] = 20706,
  [SMALL_STATE(858)] = 20720,
  [SMALL_STATE(859)] = 20734,
  [SMALL_STATE(860)] = 20748,
  [SMALL_STATE(861)] = 20760,
  [SMALL_STATE(862)] = 20774,
  [SMALL_STATE(863)] = 20788,
  [SMALL_STATE(864)] = 20802,
  [SMALL_STATE(865)] = 20816,
  [SMALL_STATE(866)] = 20826,
  [SMALL_STATE(867)] = 20836,
  [SMALL_STATE(868)] = 20850,
  [SMALL_STATE(869)] = 20864,
  [SMALL_STATE(870)] = 20874,
  [SMALL_STATE(871)] = 20888,
  [SMALL_STATE(872)] = 20900,
  [SMALL_STATE(873)] = 20914,
  [SMALL_STATE(874)] = 20928,
  [SMALL_STATE(875)] = 20942,
  [SMALL_STATE(876)] = 20954,
  [SMALL_STATE(877)] = 20968,
  [SMALL_STATE(878)] = 20982,
  [SMALL_STATE(879)] = 20994,
  [SMALL_STATE(880)] = 21008,
  [SMALL_STATE(881)] = 21022,
  [SMALL_STATE(882)] = 21034,
  [SMALL_STATE(883)] = 21048,
  [SMALL_STATE(884)] = 21058,
  [SMALL_STATE(885)] = 21072,
  [SMALL_STATE(886)] = 21086,
  [SMALL_STATE(887)] = 21100,
  [SMALL_STATE(888)] = 21110,
  [SMALL_STATE(889)] = 21124,
  [SMALL_STATE(890)] = 21138,
  [SMALL_STATE(891)] = 21152,
  [SMALL_STATE(892)] = 21166,
  [SMALL_STATE(893)] = 21180,
  [SMALL_STATE(894)] = 21194,
  [SMALL_STATE(895)] = 21208,
  [SMALL_STATE(896)] = 21218,
  [SMALL_STATE(897)] = 21228,
  [SMALL_STATE(898)] = 21242,
  [SMALL_STATE(899)] = 21252,
  [SMALL_STATE(900)] = 21266,
  [SMALL_STATE(901)] = 21280,
  [SMALL_STATE(902)] = 21290,
  [SMALL_STATE(903)] = 21304,
  [SMALL_STATE(904)] = 21318,
  [SMALL_STATE(905)] = 21332,
  [SMALL_STATE(906)] = 21346,
  [SMALL_STATE(907)] = 21360,
  [SMALL_STATE(908)] = 21374,
  [SMALL_STATE(909)] = 21388,
  [SMALL_STATE(910)] = 21398,
  [SMALL_STATE(911)] = 21412,
  [SMALL_STATE(912)] = 21426,
  [SMALL_STATE(913)] = 21440,
  [SMALL_STATE(914)] = 21454,
  [SMALL_STATE(915)] = 21468,
  [SMALL_STATE(916)] = 21482,
  [SMALL_STATE(917)] = 21496,
  [SMALL_STATE(918)] = 21510,
  [SMALL_STATE(919)] = 21524,
  [SMALL_STATE(920)] = 21538,
  [SMALL_STATE(921)] = 21552,
  [SMALL_STATE(922)] = 21566,
  [SMALL_STATE(923)] = 21580,
  [SMALL_STATE(924)] = 21594,
  [SMALL_STATE(925)] = 21608,
  [SMALL_STATE(926)] = 21622,
  [SMALL_STATE(927)] = 21636,
  [SMALL_STATE(928)] = 21650,
  [SMALL_STATE(929)] = 21664,
  [SMALL_STATE(930)] = 21676,
  [SMALL_STATE(931)] = 21690,
  [SMALL_STATE(932)] = 21704,
  [SMALL_STATE(933)] = 21718,
  [SMALL_STATE(934)] = 21732,
  [SMALL_STATE(935)] = 21746,
  [SMALL_STATE(936)] = 21760,
  [SMALL_STATE(937)] = 21770,
  [SMALL_STATE(938)] = 21784,
  [SMALL_STATE(939)] = 21798,
  [SMALL_STATE(940)] = 21812,
  [SMALL_STATE(941)] = 21826,
  [SMALL_STATE(942)] = 21840,
  [SMALL_STATE(943)] = 21854,
  [SMALL_STATE(944)] = 21868,
  [SMALL_STATE(945)] = 21882,
  [SMALL_STATE(946)] = 21896,
  [SMALL_STATE(947)] = 21910,
  [SMALL_STATE(948)] = 21924,
  [SMALL_STATE(949)] = 21938,
  [SMALL_STATE(950)] = 21952,
  [SMALL_STATE(951)] = 21966,
  [SMALL_STATE(952)] = 21980,
  [SMALL_STATE(953)] = 21994,
  [SMALL_STATE(954)] = 22008,
  [SMALL_STATE(955)] = 22019,
  [SMALL_STATE(956)] = 22030,
  [SMALL_STATE(957)] = 22039,
  [SMALL_STATE(958)] = 22050,
  [SMALL_STATE(959)] = 22061,
  [SMALL_STATE(960)] = 22072,
  [SMALL_STATE(961)] = 22083,
  [SMALL_STATE(962)] = 22094,
  [SMALL_STATE(963)] = 22105,
  [SMALL_STATE(964)] = 22116,
  [SMALL_STATE(965)] = 22127,
  [SMALL_STATE(966)] = 22138,
  [SMALL_STATE(967)] = 22149,
  [SMALL_STATE(968)] = 22158,
  [SMALL_STATE(969)] = 22169,
  [SMALL_STATE(970)] = 22180,
  [SMALL_STATE(971)] = 22189,
  [SMALL_STATE(972)] = 22198,
  [SMALL_STATE(973)] = 22209,
  [SMALL_STATE(974)] = 22218,
  [SMALL_STATE(975)] = 22229,
  [SMALL_STATE(976)] = 22238,
  [SMALL_STATE(977)] = 22249,
  [SMALL_STATE(978)] = 22260,
  [SMALL_STATE(979)] = 22271,
  [SMALL_STATE(980)] = 22282,
  [SMALL_STATE(981)] = 22293,
  [SMALL_STATE(982)] = 22304,
  [SMALL_STATE(983)] = 22313,
  [SMALL_STATE(984)] = 22322,
  [SMALL_STATE(985)] = 22333,
  [SMALL_STATE(986)] = 22344,
  [SMALL_STATE(987)] = 22353,
  [SMALL_STATE(988)] = 22364,
  [SMALL_STATE(989)] = 22373,
  [SMALL_STATE(990)] = 22384,
  [SMALL_STATE(991)] = 22395,
  [SMALL_STATE(992)] = 22406,
  [SMALL_STATE(993)] = 22415,
  [SMALL_STATE(994)] = 22424,
  [SMALL_STATE(995)] = 22435,
  [SMALL_STATE(996)] = 22446,
  [SMALL_STATE(997)] = 22457,
  [SMALL_STATE(998)] = 22468,
  [SMALL_STATE(999)] = 22479,
  [SMALL_STATE(1000)] = 22488,
  [SMALL_STATE(1001)] = 22499,
  [SMALL_STATE(1002)] = 22510,
  [SMALL_STATE(1003)] = 22521,
  [SMALL_STATE(1004)] = 22532,
  [SMALL_STATE(1005)] = 22543,
  [SMALL_STATE(1006)] = 22552,
  [SMALL_STATE(1007)] = 22563,
  [SMALL_STATE(1008)] = 22574,
  [SMALL_STATE(1009)] = 22585,
  [SMALL_STATE(1010)] = 22596,
  [SMALL_STATE(1011)] = 22607,
  [SMALL_STATE(1012)] = 22618,
  [SMALL_STATE(1013)] = 22629,
  [SMALL_STATE(1014)] = 22640,
  [SMALL_STATE(1015)] = 22651,
  [SMALL_STATE(1016)] = 22662,
  [SMALL_STATE(1017)] = 22671,
  [SMALL_STATE(1018)] = 22682,
  [SMALL_STATE(1019)] = 22691,
  [SMALL_STATE(1020)] = 22700,
  [SMALL_STATE(1021)] = 22711,
  [SMALL_STATE(1022)] = 22722,
  [SMALL_STATE(1023)] = 22731,
  [SMALL_STATE(1024)] = 22742,
  [SMALL_STATE(1025)] = 22753,
  [SMALL_STATE(1026)] = 22764,
  [SMALL_STATE(1027)] = 22775,
  [SMALL_STATE(1028)] = 22784,
  [SMALL_STATE(1029)] = 22793,
  [SMALL_STATE(1030)] = 22804,
  [SMALL_STATE(1031)] = 22815,
  [SMALL_STATE(1032)] = 22826,
  [SMALL_STATE(1033)] = 22835,
  [SMALL_STATE(1034)] = 22844,
  [SMALL_STATE(1035)] = 22855,
  [SMALL_STATE(1036)] = 22866,
  [SMALL_STATE(1037)] = 22875,
  [SMALL_STATE(1038)] = 22886,
  [SMALL_STATE(1039)] = 22897,
  [SMALL_STATE(1040)] = 22908,
  [SMALL_STATE(1041)] = 22919,
  [SMALL_STATE(1042)] = 22928,
  [SMALL_STATE(1043)] = 22937,
  [SMALL_STATE(1044)] = 22948,
  [SMALL_STATE(1045)] = 22959,
  [SMALL_STATE(1046)] = 22970,
  [SMALL_STATE(1047)] = 22981,
  [SMALL_STATE(1048)] = 22992,
  [SMALL_STATE(1049)] = 23003,
  [SMALL_STATE(1050)] = 23014,
  [SMALL_STATE(1051)] = 23025,
  [SMALL_STATE(1052)] = 23036,
  [SMALL_STATE(1053)] = 23047,
  [SMALL_STATE(1054)] = 23056,
  [SMALL_STATE(1055)] = 23067,
  [SMALL_STATE(1056)] = 23076,
  [SMALL_STATE(1057)] = 23085,
  [SMALL_STATE(1058)] = 23094,
  [SMALL_STATE(1059)] = 23105,
  [SMALL_STATE(1060)] = 23114,
  [SMALL_STATE(1061)] = 23125,
  [SMALL_STATE(1062)] = 23136,
  [SMALL_STATE(1063)] = 23144,
  [SMALL_STATE(1064)] = 23152,
  [SMALL_STATE(1065)] = 23160,
  [SMALL_STATE(1066)] = 23168,
  [SMALL_STATE(1067)] = 23176,
  [SMALL_STATE(1068)] = 23184,
  [SMALL_STATE(1069)] = 23192,
  [SMALL_STATE(1070)] = 23200,
  [SMALL_STATE(1071)] = 23208,
  [SMALL_STATE(1072)] = 23216,
  [SMALL_STATE(1073)] = 23224,
  [SMALL_STATE(1074)] = 23232,
  [SMALL_STATE(1075)] = 23240,
  [SMALL_STATE(1076)] = 23248,
  [SMALL_STATE(1077)] = 23256,
  [SMALL_STATE(1078)] = 23264,
  [SMALL_STATE(1079)] = 23272,
  [SMALL_STATE(1080)] = 23280,
  [SMALL_STATE(1081)] = 23288,
  [SMALL_STATE(1082)] = 23296,
  [SMALL_STATE(1083)] = 23304,
  [SMALL_STATE(1084)] = 23312,
  [SMALL_STATE(1085)] = 23320,
  [SMALL_STATE(1086)] = 23328,
  [SMALL_STATE(1087)] = 23336,
  [SMALL_STATE(1088)] = 23344,
  [SMALL_STATE(1089)] = 23352,
  [SMALL_STATE(1090)] = 23360,
  [SMALL_STATE(1091)] = 23368,
  [SMALL_STATE(1092)] = 23376,
  [SMALL_STATE(1093)] = 23384,
  [SMALL_STATE(1094)] = 23392,
  [SMALL_STATE(1095)] = 23400,
  [SMALL_STATE(1096)] = 23408,
  [SMALL_STATE(1097)] = 23416,
  [SMALL_STATE(1098)] = 23424,
  [SMALL_STATE(1099)] = 23432,
  [SMALL_STATE(1100)] = 23440,
  [SMALL_STATE(1101)] = 23448,
  [SMALL_STATE(1102)] = 23456,
  [SMALL_STATE(1103)] = 23464,
  [SMALL_STATE(1104)] = 23472,
  [SMALL_STATE(1105)] = 23480,
  [SMALL_STATE(1106)] = 23488,
  [SMALL_STATE(1107)] = 23496,
  [SMALL_STATE(1108)] = 23504,
  [SMALL_STATE(1109)] = 23512,
  [SMALL_STATE(1110)] = 23520,
  [SMALL_STATE(1111)] = 23528,
  [SMALL_STATE(1112)] = 23536,
  [SMALL_STATE(1113)] = 23544,
  [SMALL_STATE(1114)] = 23552,
  [SMALL_STATE(1115)] = 23560,
  [SMALL_STATE(1116)] = 23568,
  [SMALL_STATE(1117)] = 23576,
  [SMALL_STATE(1118)] = 23584,
  [SMALL_STATE(1119)] = 23592,
  [SMALL_STATE(1120)] = 23600,
  [SMALL_STATE(1121)] = 23608,
  [SMALL_STATE(1122)] = 23616,
  [SMALL_STATE(1123)] = 23624,
  [SMALL_STATE(1124)] = 23632,
  [SMALL_STATE(1125)] = 23640,
  [SMALL_STATE(1126)] = 23648,
  [SMALL_STATE(1127)] = 23656,
  [SMALL_STATE(1128)] = 23664,
  [SMALL_STATE(1129)] = 23672,
  [SMALL_STATE(1130)] = 23680,
  [SMALL_STATE(1131)] = 23688,
  [SMALL_STATE(1132)] = 23696,
  [SMALL_STATE(1133)] = 23704,
  [SMALL_STATE(1134)] = 23712,
  [SMALL_STATE(1135)] = 23720,
  [SMALL_STATE(1136)] = 23728,
  [SMALL_STATE(1137)] = 23736,
  [SMALL_STATE(1138)] = 23744,
  [SMALL_STATE(1139)] = 23752,
  [SMALL_STATE(1140)] = 23760,
  [SMALL_STATE(1141)] = 23768,
  [SMALL_STATE(1142)] = 23776,
  [SMALL_STATE(1143)] = 23784,
  [SMALL_STATE(1144)] = 23792,
  [SMALL_STATE(1145)] = 23800,
  [SMALL_STATE(1146)] = 23808,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(962),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block_statement_group, 1),
  [95] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block_statement_group, 1),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [99] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(309),
  [102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(384),
  [105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(384),
  [108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(55),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(261),
  [114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(261),
  [117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(260),
  [120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(599),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1143),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(958),
  [129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(348),
  [137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(178),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(246),
  [143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(962),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(966),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(974),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(219),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(279),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(429),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(244),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(801),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(994),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1104),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(821),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(328),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(321),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(825),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(749),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1098),
  [194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(348),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1088),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1087),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(586),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(584),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(593),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(381),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1029),
  [218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block_statement_group, 2),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block_statement_group, 2),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 3, .production_id = 20),
  [254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 3, .production_id = 20),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 3),
  [258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 3),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_block, 2),
  [262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_block, 2),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 23),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 4, .production_id = 23),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 22),
  [302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 22),
  [304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 23),
  [306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 3, .production_id = 23),
  [308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1116),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 113),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 113),
  [335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3),
  [339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 61),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 61),
  [343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 111),
  [345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 111),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 112),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 112),
  [351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 114),
  [353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 114),
  [355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 19),
  [361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 19),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 100),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 100),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 97),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 97),
  [371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 19),
  [373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 3, .production_id = 19),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 19),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 19),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 99),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 99),
  [383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 100),
  [385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 100),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 99),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 99),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 98),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 127),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 127),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 97),
  [409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 130),
  [411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 130),
  [413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 131),
  [415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 131),
  [417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 132),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 132),
  [421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 91),
  [423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 91),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 90),
  [427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 90),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 133),
  [431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 133),
  [433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 134),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 135),
  [441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 132),
  [443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 132),
  [445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 136),
  [447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 136),
  [449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 80),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 80),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 3),
  [455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 3),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 137),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 137),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 59),
  [463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_declaration, 4, .production_id = 59),
  [465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 3),
  [467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 3),
  [469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 101),
  [471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 101),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 19),
  [475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 19),
  [477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 55),
  [479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 55),
  [481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 143),
  [483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 143),
  [485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 145),
  [487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 145),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 83),
  [497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 83),
  [499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 82),
  [501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 82),
  [503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 81),
  [505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 81),
  [507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 52),
  [513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 52),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 79),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 79),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 78),
  [521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 78),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 53),
  [525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 53),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 54),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 54),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 52),
  [535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 52),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 55),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 54),
  [543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 54),
  [545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5),
  [547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5),
  [549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 159),
  [551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 159),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 160),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 160),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 161),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 162),
  [563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 162),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 163),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 163),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_body, 2),
  [571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_body, 2),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 59),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 59),
  [577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_body, 2),
  [579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_body, 2),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 183),
  [583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 183),
  [585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 59),
  [587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 59),
  [589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 6),
  [591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 6),
  [593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 59),
  [595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 59),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 102),
  [611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 102),
  [613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5, .production_id = 103),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5, .production_id = 103),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 22),
  [623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 22),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 173),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 173),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 172),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 172),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 171),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 8, .production_id = 171),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 117),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 117),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 170),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 170),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 187),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 187),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 169),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 169),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 186),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 186),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 185),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 185),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 168),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 168),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 190),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enhanced_for_statement, 9, .production_id = 190),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 167),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 167),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 166),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 166),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 118),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 118),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2),
  [697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2), SHIFT_REPEAT(276),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_block_statement_group_repeat1, 2), SHIFT_REPEAT(1005),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3, .production_id = 29),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3, .production_id = 29),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3),
  [713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 3, .production_id = 29),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 3, .production_id = 29),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 19),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 19),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3, .production_id = 28),
  [725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3, .production_id = 28),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6, .production_id = 60),
  [729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6, .production_id = 60),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 6),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 6),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 39),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 3, .production_id = 39),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4),
  [741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 5),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 5),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 4, .production_id = 60),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 4, .production_id = 60),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 188),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 188),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 66),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_variable_declaration, 4, .production_id = 66),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_declaration, 4, .production_id = 60),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_declaration, 4, .production_id = 60),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 153),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 153),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 189),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 189),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 84),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 84),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 152),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 152),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 23),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_with_resources_statement, 5, .production_id = 23),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 85),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 85),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 191),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 191),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 24),
  [817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 24),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 211),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 211),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 151),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 151),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 212),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 212),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 150),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 150),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1),
  [839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 213),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 213),
  [845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 147),
  [847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 147),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, .production_id = 218),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, .production_id = 218),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5),
  [855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 5, .production_id = 29),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 5, .production_id = 29),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 58),
  [863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 58),
  [865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4, .production_id = 59),
  [867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4, .production_id = 59),
  [869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 3),
  [871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 3),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_body, 2),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_body, 2),
  [877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_synchronized_statement, 3, .production_id = 21),
  [879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_synchronized_statement, 3, .production_id = 21),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_statement, 3),
  [885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3),
  [887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 20),
  [891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 20),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 184),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 4, .production_id = 184),
  [951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 165),
  [953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 3, .production_id = 165),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 210),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 5, .production_id = 210),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 217),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_constructor_invocation, 6, .production_id = 217),
  [965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(659),
  [968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(679),
  [971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1143),
  [974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(11),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2),
  [979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(348),
  [982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(299),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(821),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(421),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1098),
  [994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(348),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1078),
  [1000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1088),
  [1003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(1087),
  [1006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(586),
  [1009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(584),
  [1012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_body_declarations_repeat1, 2), SHIFT_REPEAT(593),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 2),
  [1033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body_declarations, 1),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), SHIFT(498),
  [1058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1063] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(689),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(576),
  [1076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(679),
  [1079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1143),
  [1082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(348),
  [1087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(307),
  [1090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(821),
  [1093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1098),
  [1096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(348),
  [1099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1088),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(1087),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(586),
  [1108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(584),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_body_repeat1, 2), SHIFT_REPEAT(593),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2),
  [1117] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(1128),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [1123] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_primary_expression, 1), REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(689),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .production_id = 92),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .production_id = 92),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 30),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 30),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, .production_id = 31),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, .production_id = 31),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 5, .production_id = 93),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 5, .production_id = 93),
  [1145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(576),
  [1160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1143),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(348),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(821),
  [1171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(348),
  [1174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1088),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(1087),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(586),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(584),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_annotation_type_body_repeat1, 2), SHIFT_REPEAT(593),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), SHIFT(193),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [1198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 4, .production_id = 65),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 4, .production_id = 65),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [1206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 16),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 16),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .production_id = 18),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .production_id = 18),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [1222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 56),
  [1224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 56),
  [1226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 57),
  [1228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 57),
  [1230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [1232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2),
  [1234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(283),
  [1237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_creation_expression_repeat1, 2), SHIFT_REPEAT(824),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions, 1),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions, 1),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2),
  [1252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(1109),
  [1255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(824),
  [1258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotated_type, 2),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotated_type, 2),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 6),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_marker_annotation, 2, .production_id = 5),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 50),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 50),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 51),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 17),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 17),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifiers, 1),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifiers, 1),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 15),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 3, .production_id = 15),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2),
  [1310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(350),
  [1313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(821),
  [1316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(350),
  [1319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 2),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 2),
  [1323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 104),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 104),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 4),
  [1329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 4),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 164),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 164),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_body, 3),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_body, 3),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 66),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 66),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, .production_id = 139),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, .production_id = 139),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 138),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 138),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 25),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 25),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation, 3, .production_id = 26),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 4),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 4),
  [1371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 2),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 2),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 3),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 3),
  [1379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1, .production_id = 2), SHIFT(502),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_argument_list, 3),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_argument_list, 3),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 39),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 39),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 109),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 109),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 106),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 106),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unannotated_type, 1),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unannotated_type, 1),
  [1408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(502),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 3, .production_id = 105),
  [1415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 3, .production_id = 105),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_initializer, 2),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_initializer, 2),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 77),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 77),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 2, .production_id = 76),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 2, .production_id = 76),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 3),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 2, .production_id = 74),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 2, .production_id = 74),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dimensions_expr, 4),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dimensions_expr, 4),
  [1441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 1, .production_id = 3),
  [1445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 94),
  [1447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 94),
  [1449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [1453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 49),
  [1457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 5),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 5),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 2),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 2),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 70),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 70),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_literal, 3),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_literal, 3),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10),
  [1481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 3),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 3),
  [1485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, .production_id = 36),
  [1487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, .production_id = 36),
  [1489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 51),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 50),
  [1495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 5, .production_id = 50),
  [1497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 158),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 158),
  [1501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 5, .production_id = 95),
  [1503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 5, .production_id = 95),
  [1505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 7, .production_id = 157),
  [1507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 7, .production_id = 157),
  [1509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 48),
  [1513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 8),
  [1517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 2, .production_id = 7),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [1523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [1525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 2),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 2),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 17),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 17),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 41),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 41),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 62),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 62),
  [1547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_initializer, 4),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_initializer, 4),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 3),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 3),
  [1555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 4, .production_id = 63),
  [1557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 4, .production_id = 63),
  [1559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 64),
  [1561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 4, .production_id = 64),
  [1563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 47),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .dynamic_precedence = 10, .production_id = 2),
  [1571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_reference, 4),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_reference, 4),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 4, .production_id = 46),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 4, .production_id = 46),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 129),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 129),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 15),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unqualified_object_creation_expression, 4, .production_id = 15),
  [1587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_invocation, 6, .production_id = 128),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_invocation, 6, .production_id = 128),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 34),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 34),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 1),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_floating_point_type, 1),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_floating_point_type, 1),
  [1603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 4, .production_id = 66),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 4, .production_id = 66),
  [1607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_declaration, 3, .production_id = 39),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_declaration, 3, .production_id = 39),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integral_type, 1),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integral_type, 1),
  [1615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1),
  [1620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, .production_id = 11),
  [1624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2),
  [1628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 5, .production_id = 71),
  [1630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 5, .production_id = 71),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 4),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 44),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 32),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 32),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_instanceof_expression, 3, .production_id = 35),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instanceof_expression, 3, .production_id = 35),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 33),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 33),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 96),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(447),
  [1689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(824),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifiers_repeat1, 2), SHIFT_REPEAT(447),
  [1695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 182),
  [1697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 5, .production_id = 182),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 32),
  [1707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 219),
  [1713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 8, .production_id = 219),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 216),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 216),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 215),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 215),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 214),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 7, .production_id = 214),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 27),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 209),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 209),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 208),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 208),
  [1737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 206),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotation_type_element_declaration, 6, .production_id = 206),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [1745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__element_value, 1),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 2),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_repeat1, 2), SHIFT_REPEAT(1127),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 3),
  [1808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 3),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3, .production_id = 69),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 5),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 5),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 4),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 4),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receiver_parameter, 2),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receiver_parameter, 2),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 148),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 4, .production_id = 115),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [1858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [1862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [1864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 5, .production_id = 144),
  [1866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2),
  [1868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 86),
  [1870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1), REDUCE(aux_sym_modifiers_repeat1, 1),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dimensions_expr_repeat1, 2),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 2),
  [1943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 2), SHIFT_REPEAT(802),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(616),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [1972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [1976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 1),
  [1978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [1988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(978),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [2000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__unannotated_type, 1), SHIFT(717),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 1),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource, 1),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2),
  [2027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(668),
  [2030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(797),
  [2033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(793),
  [2036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(790),
  [2039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_body_repeat1, 2), SHIFT_REPEAT(785),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [2044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 10),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 1, .production_id = 9),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 73),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 2, .production_id = 110),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 6),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 2, .production_id = 122),
  [2124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 2, .production_id = 122), SHIFT_REPEAT(757),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 1, .production_id = 10),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2),
  [2133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(276),
  [2136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat1, 2), SHIFT_REPEAT(1005),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 4, .production_id = 155),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 4, .production_id = 154),
  [2147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2),
  [2149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2), SHIFT_REPEAT(290),
  [2152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_block_repeat2, 2), SHIFT_REPEAT(1005),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uses_module_directive, 3, .production_id = 125),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 194),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 3, .production_id = 124),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 3, .production_id = 123),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 3, .production_id = 124),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 3, .production_id = 123),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 196),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_directive, 1),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_uses_module_directive, 3, .production_id = 43),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 181),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 3, .production_id = 121),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 197),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 180),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_module_directive, 3, .production_id = 120),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 179),
  [2193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 6, .production_id = 198),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 194),
  [2197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 196),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 197),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 6, .production_id = 198),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [2207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 5, .production_id = 178),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [2219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 201),
  [2221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 177),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 203),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 176),
  [2231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 175),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_opens_module_directive, 5, .production_id = 174),
  [2237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 177),
  [2239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dimensions_expr_repeat1, 2), SHIFT_REPEAT(824),
  [2242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 204),
  [2244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 176),
  [2246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 175),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports_module_directive, 5, .production_id = 174),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_provides_module_directive, 6, .production_id = 205),
  [2256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [2270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_type, 2),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 1),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(550),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 26),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_modifier, 1),
  [2285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_catch_type_repeat1, 2), SHIFT_REPEAT(607),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_requires_module_directive_repeat1, 1, .production_id = 88),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 8),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 2),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 37),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_id, 2, .production_id = 38),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 3),
  [2308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [2316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 13),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(961),
  [2342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [2348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2), SHIFT_REPEAT(558),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_bound_repeat1, 2),
  [2353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(559),
  [2356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [2358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [2366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [2368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [2376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 3),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 5),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 3),
  [2438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(241),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 72),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [2457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 140),
  [2459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [2461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [2463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 3),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throws, 2),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 108),
  [2477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 2, .production_id = 75),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1, .production_id = 2),
  [2481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 2),
  [2483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 2),
  [2485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_bound, 2),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_array_initializer, 4),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 1),
  [2495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(284),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2),
  [2504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_resource_specification_repeat1, 2), SHIFT_REPEAT(298),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 149),
  [2513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat2, 2, .production_id = 149), SHIFT_REPEAT(270),
  [2516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 195), SHIFT_REPEAT(799),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 195),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2),
  [2527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inferred_parameters_repeat1, 2), SHIFT_REPEAT(1139),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 193),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2), SHIFT_REPEAT(135),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_element_value_array_initializer_repeat1, 2),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 141),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_declarator, 3, .production_id = 142),
  [2555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 87), SHIFT_REPEAT(278),
  [2558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, .production_id = 87),
  [2560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 45), SHIFT_REPEAT(551),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 45),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 2, .production_id = 89),
  [2567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_initializer_repeat1, 2), SHIFT_REPEAT(168),
  [2570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 199),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 200),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [2588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 202), SHIFT_REPEAT(807),
  [2591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_provides_module_directive_repeat1, 2, .production_id = 202),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_module_directive_repeat1, 2, .production_id = 192),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [2601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 4, .production_id = 156),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(338),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_superclass, 2),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 19),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_constant, 3, .production_id = 126),
  [2638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2),
  [2640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_annotation_argument_list_repeat1, 2), SHIFT_REPEAT(1037),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 68), SHIFT_REPEAT(769),
  [2648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 68),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 1, .production_id = 12),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [2680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(524),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_rule, 3),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [2725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(678),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_declarator_list, 2, .production_id = 40),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extends_interfaces, 2),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 5, .production_id = 140),
  [2748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 2, .production_id = 14),
  [2750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_declarator_list_repeat1, 2, .production_id = 67),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 4),
  [2754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wildcard_bounds, 2),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 4, .production_id = 108),
  [2766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 3),
  [2768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2, .production_id = 2),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [2772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 2, .production_id = 73),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_label, 1),
  [2788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_value_pair, 3, .production_id = 119),
  [2808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__method_header, 3, .production_id = 75),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [2812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super_interfaces, 2),
  [2814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_declarator, 3, .production_id = 107),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, .production_id = 72),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameter, 3, .production_id = 42),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_expression_repeat1, 2, .production_id = 43),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_parameter, 3),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 4),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2858] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 4),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_permits, 2),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 5),
  [2882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 2, .production_id = 116),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_resource_specification, 3),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__default_value, 2, .production_id = 207),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_formal_parameter, 3, .production_id = 146),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inferred_parameters, 3),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asterisk, 1),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_java(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
