#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1248
#define LARGE_STATE_COUNT 22
#define SYMBOL_COUNT 207
#define ALIAS_COUNT 4
#define TOKEN_COUNT 92
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 104

enum {
  sym_identifier = 1,
  anon_sym_LF = 2,
  anon_sym_SEMI = 3,
  anon_sym_package = 4,
  anon_sym_import = 5,
  anon_sym_DOT = 6,
  sym_blank_identifier = 7,
  anon_sym_LPAREN = 8,
  anon_sym_RPAREN = 9,
  anon_sym_const = 10,
  anon_sym_COMMA = 11,
  anon_sym_EQ = 12,
  anon_sym_var = 13,
  anon_sym_func = 14,
  anon_sym_LBRACK = 15,
  anon_sym_RBRACK = 16,
  anon_sym_DOT_DOT_DOT = 17,
  anon_sym_type = 18,
  anon_sym_STAR = 19,
  anon_sym_struct = 20,
  anon_sym_LBRACE = 21,
  anon_sym_RBRACE = 22,
  anon_sym_interface = 23,
  anon_sym_PIPE = 24,
  anon_sym_TILDE = 25,
  anon_sym_map = 26,
  anon_sym_chan = 27,
  anon_sym_LT_DASH = 28,
  anon_sym_COLON_EQ = 29,
  anon_sym_PLUS_PLUS = 30,
  anon_sym_DASH_DASH = 31,
  anon_sym_STAR_EQ = 32,
  anon_sym_SLASH_EQ = 33,
  anon_sym_PERCENT_EQ = 34,
  anon_sym_LT_LT_EQ = 35,
  anon_sym_GT_GT_EQ = 36,
  anon_sym_AMP_EQ = 37,
  anon_sym_AMP_CARET_EQ = 38,
  anon_sym_PLUS_EQ = 39,
  anon_sym_DASH_EQ = 40,
  anon_sym_PIPE_EQ = 41,
  anon_sym_CARET_EQ = 42,
  anon_sym_COLON = 43,
  anon_sym_fallthrough = 44,
  anon_sym_break = 45,
  anon_sym_continue = 46,
  anon_sym_goto = 47,
  anon_sym_return = 48,
  anon_sym_go = 49,
  anon_sym_defer = 50,
  anon_sym_if = 51,
  anon_sym_else = 52,
  anon_sym_for = 53,
  anon_sym_range = 54,
  anon_sym_switch = 55,
  anon_sym_case = 56,
  anon_sym_default = 57,
  anon_sym_select = 58,
  anon_sym_new = 59,
  anon_sym_make = 60,
  anon_sym_PLUS = 61,
  anon_sym_DASH = 62,
  anon_sym_BANG = 63,
  anon_sym_CARET = 64,
  anon_sym_AMP = 65,
  anon_sym_SLASH = 66,
  anon_sym_PERCENT = 67,
  anon_sym_LT_LT = 68,
  anon_sym_GT_GT = 69,
  anon_sym_AMP_CARET = 70,
  anon_sym_EQ_EQ = 71,
  anon_sym_BANG_EQ = 72,
  anon_sym_LT = 73,
  anon_sym_LT_EQ = 74,
  anon_sym_GT = 75,
  anon_sym_GT_EQ = 76,
  anon_sym_AMP_AMP = 77,
  anon_sym_PIPE_PIPE = 78,
  sym_raw_string_literal = 79,
  anon_sym_DQUOTE = 80,
  sym__interpreted_string_literal_basic_content = 81,
  sym_escape_sequence = 82,
  sym_int_literal = 83,
  sym_float_literal = 84,
  sym_imaginary_literal = 85,
  sym_rune_literal = 86,
  sym_nil = 87,
  sym_true = 88,
  sym_false = 89,
  sym_iota = 90,
  sym_comment = 91,
  sym_source_file = 92,
  sym_package_clause = 93,
  sym_import_declaration = 94,
  sym_import_spec = 95,
  sym_dot = 96,
  sym_import_spec_list = 97,
  sym__declaration = 98,
  sym_const_declaration = 99,
  sym_const_spec = 100,
  sym_var_declaration = 101,
  sym_var_spec = 102,
  sym_function_declaration = 103,
  sym_method_declaration = 104,
  sym_type_parameter_list = 105,
  sym_parameter_list = 106,
  sym_parameter_declaration = 107,
  sym_variadic_parameter_declaration = 108,
  sym_type_alias = 109,
  sym_type_declaration = 110,
  sym_type_spec = 111,
  sym_expression_list = 112,
  sym_parenthesized_type = 113,
  sym__simple_type = 114,
  sym_generic_type = 115,
  sym_type_arguments = 116,
  sym_pointer_type = 117,
  sym_array_type = 118,
  sym_implicit_length_array_type = 119,
  sym_slice_type = 120,
  sym_struct_type = 121,
  sym_field_declaration_list = 122,
  sym_field_declaration = 123,
  sym_interface_type = 124,
  sym__interface_body = 125,
  sym_interface_type_name = 126,
  sym_constraint_elem = 127,
  sym_constraint_term = 128,
  sym_method_spec = 129,
  sym_map_type = 130,
  sym_channel_type = 131,
  sym_function_type = 132,
  sym_block = 133,
  sym__statement_list = 134,
  sym__statement = 135,
  sym_empty_statement = 136,
  sym__simple_statement = 137,
  sym_send_statement = 138,
  sym_receive_statement = 139,
  sym_inc_statement = 140,
  sym_dec_statement = 141,
  sym_assignment_statement = 142,
  sym_short_var_declaration = 143,
  sym_labeled_statement = 144,
  sym_empty_labeled_statement = 145,
  sym_fallthrough_statement = 146,
  sym_break_statement = 147,
  sym_continue_statement = 148,
  sym_goto_statement = 149,
  sym_return_statement = 150,
  sym_go_statement = 151,
  sym_defer_statement = 152,
  sym_if_statement = 153,
  sym_for_statement = 154,
  sym_for_clause = 155,
  sym_range_clause = 156,
  sym_expression_switch_statement = 157,
  sym_expression_case = 158,
  sym_default_case = 159,
  sym_type_switch_statement = 160,
  sym__type_switch_header = 161,
  sym_type_case = 162,
  sym_select_statement = 163,
  sym_communication_case = 164,
  sym__expression = 165,
  sym_parenthesized_expression = 166,
  sym_call_expression = 167,
  sym_variadic_argument = 168,
  sym_special_argument_list = 169,
  sym_argument_list = 170,
  sym_selector_expression = 171,
  sym_index_expression = 172,
  sym_slice_expression = 173,
  sym_type_assertion_expression = 174,
  sym_type_conversion_expression = 175,
  sym_composite_literal = 176,
  sym_literal_value = 177,
  sym_literal_element = 178,
  sym_keyed_element = 179,
  sym_func_literal = 180,
  sym_unary_expression = 181,
  sym_binary_expression = 182,
  sym_qualified_type = 183,
  sym_interpreted_string_literal = 184,
  aux_sym_source_file_repeat1 = 185,
  aux_sym_import_spec_list_repeat1 = 186,
  aux_sym_const_declaration_repeat1 = 187,
  aux_sym_const_spec_repeat1 = 188,
  aux_sym_var_declaration_repeat1 = 189,
  aux_sym_type_parameter_list_repeat1 = 190,
  aux_sym_parameter_list_repeat1 = 191,
  aux_sym_parameter_declaration_repeat1 = 192,
  aux_sym_type_declaration_repeat1 = 193,
  aux_sym_expression_list_repeat1 = 194,
  aux_sym_type_arguments_repeat1 = 195,
  aux_sym_field_declaration_list_repeat1 = 196,
  aux_sym_field_declaration_repeat1 = 197,
  aux_sym_interface_type_repeat1 = 198,
  aux_sym_constraint_elem_repeat1 = 199,
  aux_sym__statement_list_repeat1 = 200,
  aux_sym_expression_switch_statement_repeat1 = 201,
  aux_sym_type_switch_statement_repeat1 = 202,
  aux_sym_select_statement_repeat1 = 203,
  aux_sym_argument_list_repeat1 = 204,
  aux_sym_literal_value_repeat1 = 205,
  aux_sym_interpreted_string_literal_repeat1 = 206,
  alias_sym_field_identifier = 207,
  alias_sym_label_name = 208,
  alias_sym_package_identifier = 209,
  alias_sym_type_identifier = 210,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_LF] = "\n",
  [anon_sym_SEMI] = ";",
  [anon_sym_package] = "package",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [sym_blank_identifier] = "blank_identifier",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_const] = "const",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_var] = "var",
  [anon_sym_func] = "func",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_type] = "type",
  [anon_sym_STAR] = "*",
  [anon_sym_struct] = "struct",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_interface] = "interface",
  [anon_sym_PIPE] = "|",
  [anon_sym_TILDE] = "~",
  [anon_sym_map] = "map",
  [anon_sym_chan] = "chan",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_AMP_CARET_EQ] = "&^=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_COLON] = ":",
  [anon_sym_fallthrough] = "fallthrough",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym_return] = "return",
  [anon_sym_go] = "go",
  [anon_sym_defer] = "defer",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_range] = "range",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_select] = "select",
  [anon_sym_new] = "identifier",
  [anon_sym_make] = "identifier",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_BANG] = "!",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_CARET] = "&^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [sym_raw_string_literal] = "raw_string_literal",
  [anon_sym_DQUOTE] = "\"",
  [sym__interpreted_string_literal_basic_content] = "_interpreted_string_literal_basic_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_int_literal] = "int_literal",
  [sym_float_literal] = "float_literal",
  [sym_imaginary_literal] = "imaginary_literal",
  [sym_rune_literal] = "rune_literal",
  [sym_nil] = "nil",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_iota] = "iota",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym_package_clause] = "package_clause",
  [sym_import_declaration] = "import_declaration",
  [sym_import_spec] = "import_spec",
  [sym_dot] = "dot",
  [sym_import_spec_list] = "import_spec_list",
  [sym__declaration] = "_declaration",
  [sym_const_declaration] = "const_declaration",
  [sym_const_spec] = "const_spec",
  [sym_var_declaration] = "var_declaration",
  [sym_var_spec] = "var_spec",
  [sym_function_declaration] = "function_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_type_alias] = "type_alias",
  [sym_type_declaration] = "type_declaration",
  [sym_type_spec] = "type_spec",
  [sym_expression_list] = "expression_list",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym__simple_type] = "_simple_type",
  [sym_generic_type] = "generic_type",
  [sym_type_arguments] = "type_arguments",
  [sym_pointer_type] = "pointer_type",
  [sym_array_type] = "array_type",
  [sym_implicit_length_array_type] = "implicit_length_array_type",
  [sym_slice_type] = "slice_type",
  [sym_struct_type] = "struct_type",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_interface_type] = "interface_type",
  [sym__interface_body] = "_interface_body",
  [sym_interface_type_name] = "interface_type_name",
  [sym_constraint_elem] = "constraint_elem",
  [sym_constraint_term] = "constraint_term",
  [sym_method_spec] = "method_spec",
  [sym_map_type] = "map_type",
  [sym_channel_type] = "channel_type",
  [sym_function_type] = "function_type",
  [sym_block] = "block",
  [sym__statement_list] = "_statement_list",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym__simple_statement] = "_simple_statement",
  [sym_send_statement] = "send_statement",
  [sym_receive_statement] = "receive_statement",
  [sym_inc_statement] = "inc_statement",
  [sym_dec_statement] = "dec_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym_short_var_declaration] = "short_var_declaration",
  [sym_labeled_statement] = "labeled_statement",
  [sym_empty_labeled_statement] = "labeled_statement",
  [sym_fallthrough_statement] = "fallthrough_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_return_statement] = "return_statement",
  [sym_go_statement] = "go_statement",
  [sym_defer_statement] = "defer_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_clause] = "for_clause",
  [sym_range_clause] = "range_clause",
  [sym_expression_switch_statement] = "expression_switch_statement",
  [sym_expression_case] = "expression_case",
  [sym_default_case] = "default_case",
  [sym_type_switch_statement] = "type_switch_statement",
  [sym__type_switch_header] = "_type_switch_header",
  [sym_type_case] = "type_case",
  [sym_select_statement] = "select_statement",
  [sym_communication_case] = "communication_case",
  [sym__expression] = "_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_call_expression] = "call_expression",
  [sym_variadic_argument] = "variadic_argument",
  [sym_special_argument_list] = "argument_list",
  [sym_argument_list] = "argument_list",
  [sym_selector_expression] = "selector_expression",
  [sym_index_expression] = "index_expression",
  [sym_slice_expression] = "slice_expression",
  [sym_type_assertion_expression] = "type_assertion_expression",
  [sym_type_conversion_expression] = "type_conversion_expression",
  [sym_composite_literal] = "composite_literal",
  [sym_literal_value] = "literal_value",
  [sym_literal_element] = "literal_element",
  [sym_keyed_element] = "keyed_element",
  [sym_func_literal] = "func_literal",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_qualified_type] = "qualified_type",
  [sym_interpreted_string_literal] = "interpreted_string_literal",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_import_spec_list_repeat1] = "import_spec_list_repeat1",
  [aux_sym_const_declaration_repeat1] = "const_declaration_repeat1",
  [aux_sym_const_spec_repeat1] = "const_spec_repeat1",
  [aux_sym_var_declaration_repeat1] = "var_declaration_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_parameter_declaration_repeat1] = "parameter_declaration_repeat1",
  [aux_sym_type_declaration_repeat1] = "type_declaration_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_interface_type_repeat1] = "interface_type_repeat1",
  [aux_sym_constraint_elem_repeat1] = "constraint_elem_repeat1",
  [aux_sym__statement_list_repeat1] = "_statement_list_repeat1",
  [aux_sym_expression_switch_statement_repeat1] = "expression_switch_statement_repeat1",
  [aux_sym_type_switch_statement_repeat1] = "type_switch_statement_repeat1",
  [aux_sym_select_statement_repeat1] = "select_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_literal_value_repeat1] = "literal_value_repeat1",
  [aux_sym_interpreted_string_literal_repeat1] = "interpreted_string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_label_name] = "label_name",
  [alias_sym_package_identifier] = "package_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_blank_identifier] = sym_blank_identifier,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_func] = anon_sym_func,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_map] = anon_sym_map,
  [anon_sym_chan] = anon_sym_chan,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_AMP_CARET_EQ] = anon_sym_AMP_CARET_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_fallthrough] = anon_sym_fallthrough,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_go] = anon_sym_go,
  [anon_sym_defer] = anon_sym_defer,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_range] = anon_sym_range,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_new] = sym_identifier,
  [anon_sym_make] = sym_identifier,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_AMP_CARET] = anon_sym_AMP_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym__interpreted_string_literal_basic_content] = sym__interpreted_string_literal_basic_content,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_int_literal] = sym_int_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_imaginary_literal] = sym_imaginary_literal,
  [sym_rune_literal] = sym_rune_literal,
  [sym_nil] = sym_nil,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_iota] = sym_iota,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym_package_clause] = sym_package_clause,
  [sym_import_declaration] = sym_import_declaration,
  [sym_import_spec] = sym_import_spec,
  [sym_dot] = sym_dot,
  [sym_import_spec_list] = sym_import_spec_list,
  [sym__declaration] = sym__declaration,
  [sym_const_declaration] = sym_const_declaration,
  [sym_const_spec] = sym_const_spec,
  [sym_var_declaration] = sym_var_declaration,
  [sym_var_spec] = sym_var_spec,
  [sym_function_declaration] = sym_function_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_type_alias] = sym_type_alias,
  [sym_type_declaration] = sym_type_declaration,
  [sym_type_spec] = sym_type_spec,
  [sym_expression_list] = sym_expression_list,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym__simple_type] = sym__simple_type,
  [sym_generic_type] = sym_generic_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_pointer_type] = sym_pointer_type,
  [sym_array_type] = sym_array_type,
  [sym_implicit_length_array_type] = sym_implicit_length_array_type,
  [sym_slice_type] = sym_slice_type,
  [sym_struct_type] = sym_struct_type,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_interface_type] = sym_interface_type,
  [sym__interface_body] = sym__interface_body,
  [sym_interface_type_name] = sym_interface_type_name,
  [sym_constraint_elem] = sym_constraint_elem,
  [sym_constraint_term] = sym_constraint_term,
  [sym_method_spec] = sym_method_spec,
  [sym_map_type] = sym_map_type,
  [sym_channel_type] = sym_channel_type,
  [sym_function_type] = sym_function_type,
  [sym_block] = sym_block,
  [sym__statement_list] = sym__statement_list,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym__simple_statement] = sym__simple_statement,
  [sym_send_statement] = sym_send_statement,
  [sym_receive_statement] = sym_receive_statement,
  [sym_inc_statement] = sym_inc_statement,
  [sym_dec_statement] = sym_dec_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym_short_var_declaration] = sym_short_var_declaration,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_empty_labeled_statement] = sym_labeled_statement,
  [sym_fallthrough_statement] = sym_fallthrough_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_go_statement] = sym_go_statement,
  [sym_defer_statement] = sym_defer_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_clause] = sym_for_clause,
  [sym_range_clause] = sym_range_clause,
  [sym_expression_switch_statement] = sym_expression_switch_statement,
  [sym_expression_case] = sym_expression_case,
  [sym_default_case] = sym_default_case,
  [sym_type_switch_statement] = sym_type_switch_statement,
  [sym__type_switch_header] = sym__type_switch_header,
  [sym_type_case] = sym_type_case,
  [sym_select_statement] = sym_select_statement,
  [sym_communication_case] = sym_communication_case,
  [sym__expression] = sym__expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_variadic_argument] = sym_variadic_argument,
  [sym_special_argument_list] = sym_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_selector_expression] = sym_selector_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_slice_expression] = sym_slice_expression,
  [sym_type_assertion_expression] = sym_type_assertion_expression,
  [sym_type_conversion_expression] = sym_type_conversion_expression,
  [sym_composite_literal] = sym_composite_literal,
  [sym_literal_value] = sym_literal_value,
  [sym_literal_element] = sym_literal_element,
  [sym_keyed_element] = sym_keyed_element,
  [sym_func_literal] = sym_func_literal,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_qualified_type] = sym_qualified_type,
  [sym_interpreted_string_literal] = sym_interpreted_string_literal,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_import_spec_list_repeat1] = aux_sym_import_spec_list_repeat1,
  [aux_sym_const_declaration_repeat1] = aux_sym_const_declaration_repeat1,
  [aux_sym_const_spec_repeat1] = aux_sym_const_spec_repeat1,
  [aux_sym_var_declaration_repeat1] = aux_sym_var_declaration_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_parameter_declaration_repeat1] = aux_sym_parameter_declaration_repeat1,
  [aux_sym_type_declaration_repeat1] = aux_sym_type_declaration_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_interface_type_repeat1] = aux_sym_interface_type_repeat1,
  [aux_sym_constraint_elem_repeat1] = aux_sym_constraint_elem_repeat1,
  [aux_sym__statement_list_repeat1] = aux_sym__statement_list_repeat1,
  [aux_sym_expression_switch_statement_repeat1] = aux_sym_expression_switch_statement_repeat1,
  [aux_sym_type_switch_statement_repeat1] = aux_sym_type_switch_statement_repeat1,
  [aux_sym_select_statement_repeat1] = aux_sym_select_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_literal_value_repeat1] = aux_sym_literal_value_repeat1,
  [aux_sym_interpreted_string_literal_repeat1] = aux_sym_interpreted_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_label_name] = alias_sym_label_name,
  [alias_sym_package_identifier] = alias_sym_package_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_blank_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_func] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_map] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chan] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallthrough] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_go] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_range] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_make] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__interpreted_string_literal_basic_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_imaginary_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_rune_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_iota] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_package_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_dot] = {
    .visible = true,
    .named = true,
  },
  [sym_import_spec_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_const_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_var_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_length_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_type] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_type] = {
    .visible = true,
    .named = true,
  },
  [sym__interface_body] = {
    .visible = false,
    .named = true,
  },
  [sym_interface_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_elem] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_term] = {
    .visible = true,
    .named = true,
  },
  [sym_method_spec] = {
    .visible = true,
    .named = true,
  },
  [sym_map_type] = {
    .visible = true,
    .named = true,
  },
  [sym_channel_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_list] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_send_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_receive_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_inc_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_dec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_short_var_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fallthrough_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_go_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_defer_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_range_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_case] = {
    .visible = true,
    .named = true,
  },
  [sym_default_case] = {
    .visible = true,
    .named = true,
  },
  [sym_type_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__type_switch_header] = {
    .visible = false,
    .named = true,
  },
  [sym_type_case] = {
    .visible = true,
    .named = true,
  },
  [sym_select_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_communication_case] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_special_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_composite_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_value] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_element] = {
    .visible = true,
    .named = true,
  },
  [sym_keyed_element] = {
    .visible = true,
    .named = true,
  },
  [sym_func_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_interpreted_string_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_spec_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_const_spec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_var_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interface_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraint_elem_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statement_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_select_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpreted_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_label_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_package_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_arguments = 3,
  field_body = 4,
  field_capacity = 5,
  field_channel = 6,
  field_communication = 7,
  field_condition = 8,
  field_consequence = 9,
  field_element = 10,
  field_end = 11,
  field_field = 12,
  field_function = 13,
  field_index = 14,
  field_initializer = 15,
  field_key = 16,
  field_label = 17,
  field_left = 18,
  field_length = 19,
  field_name = 20,
  field_operand = 21,
  field_operator = 22,
  field_package = 23,
  field_parameters = 24,
  field_path = 25,
  field_receiver = 26,
  field_result = 27,
  field_right = 28,
  field_start = 29,
  field_tag = 30,
  field_type = 31,
  field_type_arguments = 32,
  field_type_parameters = 33,
  field_update = 34,
  field_value = 35,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_capacity] = "capacity",
  [field_channel] = "channel",
  [field_communication] = "communication",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_element] = "element",
  [field_end] = "end",
  [field_field] = "field",
  [field_function] = "function",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_package] = "package",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_receiver] = "receiver",
  [field_result] = "result",
  [field_right] = "right",
  [field_start] = "start",
  [field_tag] = "tag",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 3, .length = 2},
  [7] = {.index = 5, .length = 1},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 7, .length = 2},
  [11] = {.index = 9, .length = 2},
  [12] = {.index = 11, .length = 2},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 13, .length = 2},
  [15] = {.index = 13, .length = 2},
  [16] = {.index = 15, .length = 2},
  [17] = {.index = 17, .length = 2},
  [18] = {.index = 19, .length = 1},
  [19] = {.index = 20, .length = 2},
  [20] = {.index = 22, .length = 2},
  [21] = {.index = 24, .length = 2},
  [22] = {.index = 26, .length = 1},
  [23] = {.index = 17, .length = 2},
  [24] = {.index = 19, .length = 1},
  [25] = {.index = 27, .length = 1},
  [26] = {.index = 28, .length = 1},
  [27] = {.index = 29, .length = 2},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 1},
  [30] = {.index = 33, .length = 2},
  [31] = {.index = 35, .length = 3},
  [32] = {.index = 38, .length = 2},
  [33] = {.index = 40, .length = 2},
  [34] = {.index = 42, .length = 2},
  [35] = {.index = 44, .length = 3},
  [36] = {.index = 47, .length = 2},
  [37] = {.index = 49, .length = 3},
  [38] = {.index = 52, .length = 1},
  [39] = {.index = 53, .length = 3},
  [40] = {.index = 56, .length = 3},
  [41] = {.index = 59, .length = 3},
  [42] = {.index = 62, .length = 3},
  [43] = {.index = 65, .length = 1},
  [44] = {.index = 66, .length = 2},
  [45] = {.index = 68, .length = 2},
  [46] = {.index = 70, .length = 3},
  [47] = {.index = 52, .length = 1},
  [48] = {.index = 73, .length = 2},
  [49] = {.index = 17, .length = 2},
  [50] = {.index = 73, .length = 2},
  [52] = {.index = 75, .length = 2},
  [53] = {.index = 77, .length = 1},
  [54] = {.index = 78, .length = 1},
  [55] = {.index = 79, .length = 1},
  [56] = {.index = 80, .length = 3},
  [57] = {.index = 83, .length = 1},
  [58] = {.index = 84, .length = 2},
  [59] = {.index = 86, .length = 1},
  [60] = {.index = 87, .length = 2},
  [61] = {.index = 89, .length = 3},
  [62] = {.index = 92, .length = 3},
  [63] = {.index = 95, .length = 1},
  [64] = {.index = 68, .length = 2},
  [65] = {.index = 96, .length = 3},
  [66] = {.index = 99, .length = 2},
  [67] = {.index = 101, .length = 4},
  [68] = {.index = 105, .length = 4},
  [69] = {.index = 109, .length = 4},
  [70] = {.index = 113, .length = 4},
  [71] = {.index = 117, .length = 2},
  [72] = {.index = 117, .length = 2},
  [73] = {.index = 95, .length = 1},
  [74] = {.index = 119, .length = 3},
  [75] = {.index = 96, .length = 3},
  [76] = {.index = 122, .length = 3},
  [77] = {.index = 125, .length = 2},
  [78] = {.index = 127, .length = 3},
  [79] = {.index = 130, .length = 3},
  [80] = {.index = 133, .length = 2},
  [81] = {.index = 135, .length = 2},
  [82] = {.index = 137, .length = 2},
  [83] = {.index = 139, .length = 2},
  [84] = {.index = 141, .length = 1},
  [85] = {.index = 142, .length = 1},
  [86] = {.index = 143, .length = 2},
  [87] = {.index = 145, .length = 2},
  [88] = {.index = 147, .length = 2},
  [89] = {.index = 149, .length = 4},
  [90] = {.index = 153, .length = 5},
  [91] = {.index = 158, .length = 5},
  [92] = {.index = 163, .length = 4},
  [93] = {.index = 167, .length = 3},
  [94] = {.index = 170, .length = 2},
  [95] = {.index = 172, .length = 1},
  [96] = {.index = 173, .length = 3},
  [97] = {.index = 176, .length = 4},
  [98] = {.index = 180, .length = 2},
  [99] = {.index = 182, .length = 3},
  [100] = {.index = 185, .length = 2},
  [101] = {.index = 187, .length = 2},
  [102] = {.index = 189, .length = 4},
  [103] = {.index = 193, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_path, 0},
  [1] =
    {field_name, 0},
  [2] =
    {field_parameters, 1},
  [3] =
    {field_operand, 1},
    {field_operator, 0},
  [5] =
    {field_value, 1},
  [6] =
    {field_body, 1},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_type, 0},
    {field_type_arguments, 1},
  [11] =
    {field_body, 1},
    {field_type, 0},
  [13] =
    {field_name, 0},
    {field_path, 1},
  [15] =
    {field_name, 0},
    {field_name, 1},
  [17] =
    {field_name, 0},
    {field_type, 1},
  [19] =
    {field_type, 0},
  [20] =
    {field_name, 1},
    {field_parameters, 2},
  [22] =
    {field_parameters, 1},
    {field_result, 2},
  [24] =
    {field_body, 2},
    {field_parameters, 1},
  [26] =
    {field_element, 2},
  [27] =
    {field_label, 0},
  [28] =
    {field_value, 2},
  [29] =
    {field_condition, 1},
    {field_consequence, 2},
  [31] =
    {field_right, 1},
  [32] =
    {field_body, 2},
  [33] =
    {field_name, 2},
    {field_package, 0},
  [35] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [38] =
    {field_left, 0},
    {field_right, 2},
  [40] =
    {field_field, 2},
    {field_operand, 0},
  [42] =
    {field_channel, 0},
    {field_value, 2},
  [44] =
    {field_arguments, 2},
    {field_function, 0},
    {field_type_arguments, 1},
  [47] =
    {field_name, 0},
    {field_value, 2},
  [49] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
  [52] =
    {field_type, 1},
  [53] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [56] =
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [59] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [62] =
    {field_body, 3},
    {field_parameters, 1},
    {field_result, 2},
  [65] =
    {field_element, 3},
  [66] =
    {field_element, 3},
    {field_length, 1},
  [68] =
    {field_name, 0},
    {field_type, 2},
  [70] =
    {field_name, 0},
    {field_type, 2},
    {field_type_parameters, 1},
  [73] =
    {field_tag, 1},
    {field_type, 0},
  [75] =
    {field_name, 0},
    {field_parameters, 1},
  [77] =
    {field_update, 2},
  [78] =
    {field_condition, 1},
  [79] =
    {field_initializer, 0},
  [80] =
    {field_alias, 1, .inherited = true},
    {field_initializer, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [83] =
    {field_right, 0},
  [84] =
    {field_operand, 2},
    {field_type, 0},
  [86] =
    {field_operand, 0},
  [87] =
    {field_index, 2},
    {field_operand, 0},
  [89] =
    {field_name, 0},
    {field_type, 1},
    {field_value, 3},
  [92] =
    {field_name, 0},
    {field_name, 1},
    {field_value, 3},
  [95] =
    {field_name, 1},
  [96] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_type, 2},
  [99] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [101] =
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [105] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [109] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
    {field_result, 3},
  [113] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
  [117] =
    {field_tag, 2},
    {field_type, 1},
  [119] =
    {field_name, 0},
    {field_tag, 2},
    {field_type, 1},
  [122] =
    {field_name, 0},
    {field_parameters, 1},
    {field_result, 2},
  [125] =
    {field_key, 2},
    {field_value, 4},
  [127] =
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [130] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [133] =
    {field_condition, 1},
    {field_update, 3},
  [135] =
    {field_left, 0},
    {field_right, 3},
  [137] =
    {field_initializer, 0},
    {field_update, 3},
  [139] =
    {field_condition, 2},
    {field_initializer, 0},
  [141] =
    {field_initializer, 1},
  [142] =
    {field_communication, 1},
  [143] =
    {field_operand, 0},
    {field_type, 3},
  [145] =
    {field_end, 3},
    {field_operand, 0},
  [147] =
    {field_operand, 0},
    {field_start, 2},
  [149] =
    {field_name, 0},
    {field_name, 1},
    {field_type, 2},
    {field_value, 4},
  [153] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_result, 4},
    {field_type_parameters, 2},
  [158] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
    {field_receiver, 1},
    {field_result, 4},
  [163] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_tag, 3},
    {field_type, 2},
  [167] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [170] =
    {field_initializer, 1},
    {field_value, 3},
  [172] =
    {field_value, 0},
  [173] =
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [176] =
    {field_alternative, 6},
    {field_condition, 3},
    {field_consequence, 4},
    {field_initializer, 1},
  [180] =
    {field_type, 1},
    {field_type, 2},
  [182] =
    {field_capacity, 5},
    {field_end, 3},
    {field_operand, 0},
  [185] =
    {field_alias, 0},
    {field_value, 2},
  [187] =
    {field_initializer, 0},
    {field_value, 2},
  [189] =
    {field_capacity, 6},
    {field_end, 4},
    {field_operand, 0},
    {field_start, 2},
  [193] =
    {field_alias, 2},
    {field_initializer, 0},
    {field_value, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [2] = {
    [1] = alias_sym_package_identifier,
  },
  [8] = {
    [1] = alias_sym_label_name,
  },
  [11] = {
    [0] = alias_sym_type_identifier,
  },
  [12] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_package_identifier,
  },
  [23] = {
    [0] = alias_sym_type_identifier,
  },
  [24] = {
    [0] = alias_sym_type_identifier,
  },
  [25] = {
    [0] = alias_sym_label_name,
  },
  [30] = {
    [0] = alias_sym_package_identifier,
    [2] = alias_sym_type_identifier,
  },
  [33] = {
    [2] = alias_sym_field_identifier,
  },
  [45] = {
    [0] = alias_sym_type_identifier,
  },
  [46] = {
    [0] = alias_sym_type_identifier,
  },
  [47] = {
    [1] = alias_sym_type_identifier,
  },
  [48] = {
    [0] = alias_sym_type_identifier,
  },
  [49] = {
    [0] = alias_sym_field_identifier,
  },
  [51] = {
    [1] = alias_sym_type_identifier,
  },
  [52] = {
    [0] = alias_sym_field_identifier,
  },
  [70] = {
    [2] = alias_sym_field_identifier,
  },
  [71] = {
    [1] = alias_sym_type_identifier,
  },
  [73] = {
    [1] = alias_sym_field_identifier,
  },
  [74] = {
    [0] = alias_sym_field_identifier,
  },
  [75] = {
    [0] = alias_sym_field_identifier,
  },
  [76] = {
    [0] = alias_sym_field_identifier,
  },
  [91] = {
    [2] = alias_sym_field_identifier,
  },
  [92] = {
    [0] = alias_sym_field_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 6688
    ? (c < 2984
      ? (c < 2365
        ? (c < 1488
          ? (c < 886
            ? (c < 216
              ? (c < 181
                ? (c < 'a'
                  ? (c >= 'A' && c <= '_')
                  : (c <= 'z' || c == 170))
                : (c <= 181 || (c < 192
                  ? c == 186
                  : c <= 214)))
              : (c <= 246 || (c < 748
                ? (c < 710
                  ? (c >= 248 && c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))
                : (c <= 748 || (c < 880
                  ? c == 750
                  : c <= 884)))))
            : (c <= 887 || (c < 931
              ? (c < 904
                ? (c < 895
                  ? (c >= 890 && c <= 893)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 910
                  ? c == 908
                  : c <= 929)))
              : (c <= 1013 || (c < 1329
                ? (c < 1162
                  ? (c >= 1015 && c <= 1153)
                  : c <= 1327)
                : (c <= 1366 || (c < 1376
                  ? c == 1369
                  : c <= 1416)))))))
          : (c <= 1514 || (c < 1994
            ? (c < 1774
              ? (c < 1649
                ? (c < 1568
                  ? (c >= 1519 && c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1765
                  ? c == 1749
                  : c <= 1766)))
              : (c <= 1775 || (c < 1810
                ? (c < 1791
                  ? (c >= 1786 && c <= 1788)
                  : (c <= 1791 || c == 1808))
                : (c <= 1839 || (c < 1969
                  ? (c >= 1869 && c <= 1957)
                  : c <= 1969)))))
            : (c <= 2026 || (c < 2112
              ? (c < 2074
                ? (c < 2042
                  ? (c >= 2036 && c <= 2037)
                  : (c <= 2042 || (c >= 2048 && c <= 2069)))
                : (c <= 2074 || (c < 2088
                  ? c == 2084
                  : c <= 2088)))
              : (c <= 2136 || (c < 2185
                ? (c < 2160
                  ? (c >= 2144 && c <= 2154)
                  : c <= 2183)
                : (c <= 2190 || (c < 2308
                  ? (c >= 2208 && c <= 2249)
                  : c <= 2361)))))))))
        : (c <= 2365 || (c < 2703
          ? (c < 2544
            ? (c < 2474
              ? (c < 2437
                ? (c < 2392
                  ? c == 2384
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))
              : (c <= 2480 || (c < 2510
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || c == 2493))
                : (c <= 2510 || (c < 2527
                  ? (c >= 2524 && c <= 2525)
                  : c <= 2529)))))
            : (c <= 2545 || (c < 2613
              ? (c < 2579
                ? (c < 2565
                  ? c == 2556
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))
                : (c <= 2600 || (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)))
              : (c <= 2614 || (c < 2654
                ? (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)
                : (c <= 2654 || (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)))))))
          : (c <= 2705 || (c < 2869
            ? (c < 2784
              ? (c < 2741
                ? (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : (c <= 2736 || (c >= 2738 && c <= 2739)))
                : (c <= 2745 || (c < 2768
                  ? c == 2749
                  : c <= 2768)))
              : (c <= 2785 || (c < 2835
                ? (c < 2821
                  ? c == 2809
                  : (c <= 2828 || (c >= 2831 && c <= 2832)))
                : (c <= 2856 || (c < 2866
                  ? (c >= 2858 && c <= 2864)
                  : c <= 2867)))))
            : (c <= 2873 || (c < 2958
              ? (c < 2929
                ? (c < 2908
                  ? c == 2877
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2949
                  ? c == 2947
                  : c <= 2954)))
              : (c <= 2960 || (c < 2972
                ? (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)
                : (c <= 2972 || (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : c <= 2980)))))))))))
      : (c <= 2986 || (c < 4176
        ? (c < 3423
          ? (c < 3218
            ? (c < 3133
              ? (c < 3086
                ? (c < 3024
                  ? (c >= 2990 && c <= 3001)
                  : (c <= 3024 || (c >= 3077 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : c <= 3129)))
              : (c <= 3133 || (c < 3200
                ? (c < 3165
                  ? (c >= 3160 && c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3332
              ? (c < 3293
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : (c <= 3257 || c == 3261))
                : (c <= 3294 || (c < 3313
                  ? (c >= 3296 && c <= 3297)
                  : c <= 3314)))
              : (c <= 3340 || (c < 3389
                ? (c < 3346
                  ? (c >= 3342 && c <= 3344)
                  : c <= 3386)
                : (c <= 3389 || (c < 3412
                  ? c == 3406
                  : c <= 3414)))))))
          : (c <= 3425 || (c < 3749
            ? (c < 3585
              ? (c < 3507
                ? (c < 3461
                  ? (c >= 3450 && c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3520
                  ? c == 3517
                  : c <= 3526)))
              : (c <= 3632 || (c < 3716
                ? (c < 3648
                  ? (c >= 3634 && c <= 3635)
                  : (c <= 3654 || (c >= 3713 && c <= 3714)))
                : (c <= 3716 || (c < 3724
                  ? (c >= 3718 && c <= 3722)
                  : c <= 3747)))))
            : (c <= 3749 || (c < 3840
              ? (c < 3776
                ? (c < 3762
                  ? (c >= 3751 && c <= 3760)
                  : (c <= 3763 || c == 3773))
                : (c <= 3780 || (c < 3804
                  ? c == 3782
                  : c <= 3807)))
              : (c <= 3840 || (c < 3976
                ? (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : c <= 3948)
                : (c <= 3980 || (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : c <= 4159)))))))))
        : (c <= 4181 || (c < 4992
          ? (c < 4696
            ? (c < 4256
              ? (c < 4206
                ? (c < 4193
                  ? (c >= 4186 && c <= 4189)
                  : (c <= 4193 || (c >= 4197 && c <= 4198)))
                : (c <= 4208 || (c < 4238
                  ? (c >= 4213 && c <= 4225)
                  : c <= 4238)))
              : (c <= 4293 || (c < 4348
                ? (c < 4301
                  ? c == 4295
                  : (c <= 4301 || (c >= 4304 && c <= 4346)))
                : (c <= 4680 || (c < 4688
                  ? (c >= 4682 && c <= 4685)
                  : c <= 4694)))))
            : (c <= 4696 || (c < 4800
              ? (c < 4752
                ? (c < 4704
                  ? (c >= 4698 && c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4792
                  ? (c >= 4786 && c <= 4789)
                  : c <= 4798)))
              : (c <= 4800 || (c < 4824
                ? (c < 4808
                  ? (c >= 4802 && c <= 4805)
                  : c <= 4822)
                : (c <= 4880 || (c < 4888
                  ? (c >= 4882 && c <= 4885)
                  : c <= 4954)))))))
          : (c <= 5007 || (c < 6103
            ? (c < 5873
              ? (c < 5743
                ? (c < 5112
                  ? (c >= 5024 && c <= 5109)
                  : (c <= 5117 || (c >= 5121 && c <= 5740)))
                : (c <= 5759 || (c < 5792
                  ? (c >= 5761 && c <= 5786)
                  : c <= 5866)))
              : (c <= 5880 || (c < 5984
                ? (c < 5919
                  ? (c >= 5888 && c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6016
                  ? (c >= 5998 && c <= 6000)
                  : c <= 6067)))))
            : (c <= 6103 || (c < 6400
              ? (c < 6279
                ? (c < 6176
                  ? c == 6108
                  : (c <= 6264 || (c >= 6272 && c <= 6276)))
                : (c <= 6312 || (c < 6320
                  ? c == 6314
                  : c <= 6389)))
              : (c <= 6430 || (c < 6528
                ? (c < 6512
                  ? (c >= 6480 && c <= 6509)
                  : c <= 6516)
                : (c <= 6571 || (c < 6656
                  ? (c >= 6576 && c <= 6601)
                  : c <= 6678)))))))))))))
    : (c <= 6740 || (c < 43261
      ? (c < 11264
        ? (c < 8064
          ? (c < 7406
            ? (c < 7168
              ? (c < 7043
                ? (c < 6917
                  ? c == 6823
                  : (c <= 6963 || (c >= 6981 && c <= 6988)))
                : (c <= 7072 || (c < 7098
                  ? (c >= 7086 && c <= 7087)
                  : c <= 7141)))
              : (c <= 7203 || (c < 7312
                ? (c < 7258
                  ? (c >= 7245 && c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))
                : (c <= 7354 || (c < 7401
                  ? (c >= 7357 && c <= 7359)
                  : c <= 7404)))))
            : (c <= 7411 || (c < 8008
              ? (c < 7680
                ? (c < 7418
                  ? (c >= 7413 && c <= 7414)
                  : (c <= 7418 || (c >= 7424 && c <= 7615)))
                : (c <= 7957 || (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : c <= 8005)))
              : (c <= 8013 || (c < 8027
                ? (c < 8025
                  ? (c >= 8016 && c <= 8023)
                  : c <= 8025)
                : (c <= 8027 || (c < 8031
                  ? c == 8029
                  : c <= 8061)))))))
          : (c <= 8116 || (c < 8455
            ? (c < 8160
              ? (c < 8134
                ? (c < 8126
                  ? (c >= 8118 && c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))
                : (c <= 8140 || (c < 8150
                  ? (c >= 8144 && c <= 8147)
                  : c <= 8155)))
              : (c <= 8172 || (c < 8319
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || c == 8305))
                : (c <= 8319 || (c < 8450
                  ? (c >= 8336 && c <= 8348)
                  : c <= 8450)))))
            : (c <= 8455 || (c < 8490
              ? (c < 8484
                ? (c < 8469
                  ? (c >= 8458 && c <= 8467)
                  : (c <= 8469 || (c >= 8473 && c <= 8477)))
                : (c <= 8484 || (c < 8488
                  ? c == 8486
                  : c <= 8488)))
              : (c <= 8493 || (c < 8517
                ? (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : c <= 8511)
                : (c <= 8521 || (c < 8579
                  ? c == 8526
                  : c <= 8580)))))))))
        : (c <= 11492 || (c < 12704
          ? (c < 11720
            ? (c < 11631
              ? (c < 11559
                ? (c < 11506
                  ? (c >= 11499 && c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11568
                  ? c == 11565
                  : c <= 11623)))
              : (c <= 11631 || (c < 11696
                ? (c < 11680
                  ? (c >= 11648 && c <= 11670)
                  : (c <= 11686 || (c >= 11688 && c <= 11694)))
                : (c <= 11702 || (c < 11712
                  ? (c >= 11704 && c <= 11710)
                  : c <= 11718)))))
            : (c <= 11726 || (c < 12353
              ? (c < 12293
                ? (c < 11736
                  ? (c >= 11728 && c <= 11734)
                  : (c <= 11742 || c == 11823))
                : (c <= 12294 || (c < 12347
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)))
              : (c <= 12438 || (c < 12540
                ? (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)
                : (c <= 12543 || (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)))))))
          : (c <= 12735 || (c < 42786
            ? (c < 42240
              ? (c < 19968
                ? (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : (c <= 13312 || c == 19903))
                : (c <= 19968 || (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : c <= 42237)))
              : (c <= 42508 || (c < 42623
                ? (c < 42538
                  ? (c >= 42512 && c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : c <= 42783)))))
            : (c <= 42888 || (c < 43015
              ? (c < 42965
                ? (c < 42960
                  ? (c >= 42891 && c <= 42954)
                  : (c <= 42961 || c == 42963))
                : (c <= 42969 || (c < 43011
                  ? (c >= 42994 && c <= 43009)
                  : c <= 43013)))
              : (c <= 43018 || (c < 43138
                ? (c < 43072
                  ? (c >= 43020 && c <= 43042)
                  : c <= 43123)
                : (c <= 43187 || (c < 43259
                  ? (c >= 43250 && c <= 43255)
                  : c <= 43259)))))))))))
      : (c <= 43262 || (c < 65345
        ? (c < 43816
          ? (c < 43646
            ? (c < 43494
              ? (c < 43396
                ? (c < 43312
                  ? (c >= 43274 && c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43488
                  ? c == 43471
                  : c <= 43492)))
              : (c <= 43503 || (c < 43588
                ? (c < 43520
                  ? (c >= 43514 && c <= 43518)
                  : (c <= 43560 || (c >= 43584 && c <= 43586)))
                : (c <= 43595 || (c < 43642
                  ? (c >= 43616 && c <= 43638)
                  : c <= 43642)))))
            : (c <= 43695 || (c < 43744
              ? (c < 43712
                ? (c < 43701
                  ? c == 43697
                  : (c <= 43702 || (c >= 43705 && c <= 43709)))
                : (c <= 43712 || (c < 43739
                  ? c == 43714
                  : c <= 43741)))
              : (c <= 43754 || (c < 43785
                ? (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)
                : (c <= 43790 || (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)))))))
          : (c <= 43822 || (c < 64298
            ? (c < 55243
              ? (c < 44032
                ? (c < 43868
                  ? (c >= 43824 && c <= 43866)
                  : (c <= 43881 || (c >= 43888 && c <= 44002)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : c <= 55238)))
              : (c <= 55291 || (c < 64275
                ? (c < 64112
                  ? (c >= 63744 && c <= 64109)
                  : (c <= 64217 || (c >= 64256 && c <= 64262)))
                : (c <= 64279 || (c < 64287
                  ? c == 64285
                  : c <= 64296)))))
            : (c <= 64310 || (c < 64848
              ? (c < 64323
                ? (c < 64318
                  ? (c >= 64312 && c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)))
              : (c <= 64911 || (c < 65136
                ? (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)
                : (c <= 65140 || (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)))))))))
        : (c <= 65370 || (c < 66928
          ? (c < 66208
            ? (c < 65549
              ? (c < 65490
                ? (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : (c <= 65479 || (c >= 65482 && c <= 65487)))
                : (c <= 65495 || (c < 65536
                  ? (c >= 65498 && c <= 65500)
                  : c <= 65547)))
              : (c <= 65574 || (c < 65616
                ? (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))
                : (c <= 65629 || (c < 66176
                  ? (c >= 65664 && c <= 65786)
                  : c <= 66204)))))
            : (c <= 66256 || (c < 66504
              ? (c < 66384
                ? (c < 66349
                  ? (c >= 66304 && c <= 66335)
                  : (c <= 66368 || (c >= 66370 && c <= 66377)))
                : (c <= 66421 || (c < 66464
                  ? (c >= 66432 && c <= 66461)
                  : c <= 66499)))
              : (c <= 66511 || (c < 66776
                ? (c < 66736
                  ? (c >= 66560 && c <= 66717)
                  : c <= 66771)
                : (c <= 66811 || (c < 66864
                  ? (c >= 66816 && c <= 66855)
                  : c <= 66915)))))))
          : (c <= 66938 || (c < 67506
            ? (c < 67003
              ? (c < 66967
                ? (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))
                : (c <= 66977 || (c < 66995
                  ? (c >= 66979 && c <= 66993)
                  : c <= 67001)))
              : (c <= 67004 || (c < 67424
                ? (c < 67392
                  ? (c >= 67072 && c <= 67382)
                  : c <= 67413)
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= 'A' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1162
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : c <= 1153)
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 6656
    ? (c < 2979
      ? (c < 2308
        ? (c < 1376
          ? (c < 750
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? (c >= '0' && c <= '9')
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : c <= 748)))))
            : (c <= 750 || (c < 908
              ? (c < 895
                ? (c < 886
                  ? (c >= 880 && c <= 884)
                  : (c <= 887 || (c >= 890 && c <= 893)))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : c <= 906)))
              : (c <= 908 || (c < 1162
                ? (c < 931
                  ? (c >= 910 && c <= 929)
                  : (c <= 1013 || (c >= 1015 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))))))
          : (c <= 1416 || (c < 1969
            ? (c < 1765
              ? (c < 1646
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : (c <= 1522 || (c >= 1568 && c <= 1610)))
                : (c <= 1647 || (c < 1749
                  ? (c >= 1649 && c <= 1747)
                  : c <= 1749)))
              : (c <= 1766 || (c < 1808
                ? (c < 1786
                  ? (c >= 1774 && c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))))
            : (c <= 1969 || (c < 2088
              ? (c < 2048
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : (c <= 2037 || c == 2042))
                : (c <= 2069 || (c < 2084
                  ? c == 2074
                  : c <= 2084)))
              : (c <= 2088 || (c < 2160
                ? (c < 2144
                  ? (c >= 2112 && c <= 2136)
                  : c <= 2154)
                : (c <= 2183 || (c < 2208
                  ? (c >= 2185 && c <= 2190)
                  : c <= 2249)))))))))
        : (c <= 2361 || (c < 2693
          ? (c < 2527
            ? (c < 2451
              ? (c < 2417
                ? (c < 2384
                  ? c == 2365
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2447
                  ? (c >= 2437 && c <= 2444)
                  : c <= 2448)))
              : (c <= 2472 || (c < 2493
                ? (c < 2482
                  ? (c >= 2474 && c <= 2480)
                  : (c <= 2482 || (c >= 2486 && c <= 2489)))
                : (c <= 2493 || (c < 2524
                  ? c == 2510
                  : c <= 2525)))))
            : (c <= 2529 || (c < 2610
              ? (c < 2575
                ? (c < 2556
                  ? (c >= 2544 && c <= 2545)
                  : (c <= 2556 || (c >= 2565 && c <= 2570)))
                : (c <= 2576 || (c < 2602
                  ? (c >= 2579 && c <= 2600)
                  : c <= 2608)))
              : (c <= 2611 || (c < 2649
                ? (c < 2616
                  ? (c >= 2613 && c <= 2614)
                  : c <= 2617)
                : (c <= 2652 || (c < 2674
                  ? c == 2654
                  : c <= 2676)))))))
          : (c <= 2701 || (c < 2866
            ? (c < 2768
              ? (c < 2738
                ? (c < 2707
                  ? (c >= 2703 && c <= 2705)
                  : (c <= 2728 || (c >= 2730 && c <= 2736)))
                : (c <= 2739 || (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : c <= 2749)))
              : (c <= 2768 || (c < 2831
                ? (c < 2809
                  ? (c >= 2784 && c <= 2785)
                  : (c <= 2809 || (c >= 2821 && c <= 2828)))
                : (c <= 2832 || (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)))))
            : (c <= 2867 || (c < 2949
              ? (c < 2911
                ? (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2947
                  ? c == 2929
                  : c <= 2947)))
              : (c <= 2954 || (c < 2969
                ? (c < 2962
                  ? (c >= 2958 && c <= 2960)
                  : c <= 2965)
                : (c <= 2970 || (c < 2974
                  ? c == 2972
                  : c <= 2975)))))))))))
      : (c <= 2980 || (c < 4159
        ? (c < 3412
          ? (c < 3214
            ? (c < 3114
              ? (c < 3077
                ? (c < 2990
                  ? (c >= 2984 && c <= 2986)
                  : (c <= 3001 || c == 3024))
                : (c <= 3084 || (c < 3090
                  ? (c >= 3086 && c <= 3088)
                  : c <= 3112)))
              : (c <= 3129 || (c < 3168
                ? (c < 3160
                  ? c == 3133
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3205
                  ? c == 3200
                  : c <= 3212)))))
            : (c <= 3216 || (c < 3313
              ? (c < 3261
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3724
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3713
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : (c <= 3635 || (c >= 3648 && c <= 3654)))
                : (c <= 3714 || (c < 3718
                  ? c == 3716
                  : c <= 3722)))))
            : (c <= 3747 || (c < 3804
              ? (c < 3773
                ? (c < 3751
                  ? c == 3749
                  : (c <= 3760 || (c >= 3762 && c <= 3763)))
                : (c <= 3773 || (c < 3782
                  ? (c >= 3776 && c <= 3780)
                  : c <= 3782)))
              : (c <= 3807 || (c < 3913
                ? (c < 3904
                  ? c == 3840
                  : c <= 3911)
                : (c <= 3948 || (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)))))))))
        : (c <= 4159 || (c < 4888
          ? (c < 4688
            ? (c < 4238
              ? (c < 4197
                ? (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : (c <= 4189 || c == 4193))
                : (c <= 4198 || (c < 4213
                  ? (c >= 4206 && c <= 4208)
                  : c <= 4225)))
              : (c <= 4238 || (c < 4304
                ? (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : (c <= 4295 || c == 4301))
                : (c <= 4346 || (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)))))
            : (c <= 4694 || (c < 4792
              ? (c < 4746
                ? (c < 4698
                  ? c == 4696
                  : (c <= 4701 || (c >= 4704 && c <= 4744)))
                : (c <= 4749 || (c < 4786
                  ? (c >= 4752 && c <= 4784)
                  : c <= 4789)))
              : (c <= 4798 || (c < 4808
                ? (c < 4802
                  ? c == 4800
                  : c <= 4805)
                : (c <= 4822 || (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)))))))
          : (c <= 4954 || (c < 6016
            ? (c < 5792
              ? (c < 5121
                ? (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))
                : (c <= 5740 || (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : c <= 5786)))
              : (c <= 5866 || (c < 5952
                ? (c < 5888
                  ? (c >= 5873 && c <= 5880)
                  : (c <= 5905 || (c >= 5919 && c <= 5937)))
                : (c <= 5969 || (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : c <= 6000)))))
            : (c <= 6067 || (c < 6320
              ? (c < 6272
                ? (c < 6108
                  ? c == 6103
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))
              : (c <= 6389 || (c < 6512
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : c <= 6509)
                : (c <= 6516 || (c < 6576
                  ? (c >= 6528 && c <= 6571)
                  : c <= 6601)))))))))))))
    : (c <= 6678 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7401
            ? (c < 7098
              ? (c < 6981
                ? (c < 6823
                  ? (c >= 6688 && c <= 6740)
                  : (c <= 6823 || (c >= 6917 && c <= 6963)))
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))
              : (c <= 7141 || (c < 7296
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : (c <= 7247 || (c >= 7258 && c <= 7293)))
                : (c <= 7304 || (c < 7357
                  ? (c >= 7312 && c <= 7354)
                  : c <= 7359)))))
            : (c <= 7404 || (c < 7968
              ? (c < 7424
                ? (c < 7413
                  ? (c >= 7406 && c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7960
                  ? (c >= 7680 && c <= 7957)
                  : c <= 7965)))
              : (c <= 8005 || (c < 8025
                ? (c < 8016
                  ? (c >= 8008 && c <= 8013)
                  : c <= 8023)
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_rune_literal_character_set_1(int32_t c) {
  return (c < 'f'
    ? (c < '\\'
      ? (c < '\''
        ? c == '"'
        : c <= '\'')
      : (c <= '\\' || (c >= 'a' && c <= 'b')))
    : (c <= 'f' || (c < 't'
      ? (c < 'r'
        ? c == 'n'
        : c <= 'r')
      : (c <= 't' || c == 'v'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(109);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(109);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(112);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(113);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(131);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(8)
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(141);
      if (lookahead != 0) ADVANCE(142);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(109);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(102);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '<') ADVANCE(127);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(109);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(112);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(64);
      if (lookahead == '/') ADVANCE(113);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(128);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(131);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(108);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '%') ADVANCE(115);
      if (lookahead == '&') ADVANCE(112);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(63);
      if (lookahead == '/') ADVANCE(113);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == '<') ADVANCE(126);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(131);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      END_STATE();
    case 9:
      if (lookahead == '\'') ADVANCE(156);
      END_STATE();
    case 10:
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 11:
      if (lookahead == '*') ADVANCE(11);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == '*') ADVANCE(11);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == '-') ADVANCE(83);
      END_STATE();
    case 14:
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 15:
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(15);
      END_STATE();
    case 16:
      if (lookahead == '.') ADVANCE(74);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 21:
      if (lookahead == 'U') ADVANCE(55);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (lookahead != 0) ADVANCE(143);
      END_STATE();
    case 22:
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(9);
      END_STATE();
    case 23:
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(150);
      END_STATE();
    case 24:
      if (lookahead == '_') ADVANCE(32);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(151);
      END_STATE();
    case 25:
      if (lookahead == '`') ADVANCE(136);
      if (lookahead != 0) ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(38);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(152);
      END_STATE();
    case 27:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 28:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 29:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(150);
      END_STATE();
    case 30:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(9);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(151);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(31);
      END_STATE();
    case 34:
      if (sym_rune_literal_character_set_1(lookahead)) ADVANCE(9);
      if (lookahead == 'U') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(48);
      if (lookahead == 'x') ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(33);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(15);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(152);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(143);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 57:
      if (eof) ADVANCE(60);
      if (lookahead == '\n') ADVANCE(61);
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(13);
      if (lookahead == '=') ADVANCE(70);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(79);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 58:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(107);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '%') ADVANCE(116);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(76);
      if (lookahead == '+') ADVANCE(101);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(104);
      if (lookahead == '.') ADVANCE(65);
      if (lookahead == '/') ADVANCE(114);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ':') ADVANCE(99);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(125);
      if (lookahead == '=') ADVANCE(71);
      if (lookahead == '>') ADVANCE(130);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(109);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '~') ADVANCE(82);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 59:
      if (eof) ADVANCE(60);
      if (lookahead == '!') ADVANCE(106);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '&') ADVANCE(110);
      if (lookahead == '\'') ADVANCE(22);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(75);
      if (lookahead == '+') ADVANCE(100);
      if (lookahead == ',') ADVANCE(69);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(14);
      if (lookahead == '/') ADVANCE(10);
      if (lookahead == '0') ADVANCE(146);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(62);
      if (lookahead == '<') ADVANCE(13);
      if (lookahead == '[') ADVANCE(72);
      if (lookahead == ']') ADVANCE(73);
      if (lookahead == '^') ADVANCE(108);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(135);
      if (lookahead == '`') ADVANCE(25);
      if (lookahead == '{') ADVANCE(77);
      if (lookahead == '}') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(16);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(87);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(96);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(134);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_AMP_CARET_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(94);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(86);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '^') ADVANCE(122);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(133);
      if (lookahead == '^') ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(158);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(12);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '=') ADVANCE(88);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(89);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(90);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_CARET);
      if (lookahead == '=') ADVANCE(93);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_raw_string_literal);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(142);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym__interpreted_string_literal_basic_content);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(143);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(24);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(17);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(154);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '.') ADVANCE(28);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(26);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(155);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_int_literal);
      if (lookahead == '_') ADVANCE(32);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == '_') ADVANCE(36);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_float_literal);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(26);
      if (lookahead == 'i') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(153);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_imaginary_literal);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_rune_literal);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(158);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'v') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(sym_blank_identifier);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(16);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(17);
      if (lookahead == 'h') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'o') ADVANCE(23);
      if (lookahead == 'u') ADVANCE(24);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(26);
      if (lookahead == 'm') ADVANCE(27);
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(31);
      if (lookahead == 'i') ADVANCE(32);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(33);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(34);
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(36);
      if (lookahead == 't') ADVANCE(37);
      if (lookahead == 'w') ADVANCE(38);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'y') ADVANCE(40);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(41);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 17:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 20:
      if (lookahead == 'f') ADVANCE(46);
      END_STATE();
    case 21:
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 23:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_go);
      if (lookahead == 't') ADVANCE(51);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(52);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(54);
      END_STATE();
    case 30:
      if (lookahead == 'k') ADVANCE(55);
      if (lookahead == 'p') ADVANCE(56);
      END_STATE();
    case 31:
      if (lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 32:
      if (lookahead == 'l') ADVANCE(58);
      END_STATE();
    case 33:
      if (lookahead == 'c') ADVANCE(59);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 36:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(63);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(64);
      END_STATE();
    case 39:
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 40:
      if (lookahead == 'p') ADVANCE(66);
      END_STATE();
    case 41:
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(68);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 44:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 45:
      if (lookahead == 's') ADVANCE(71);
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(73);
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 48:
      if (lookahead == 'l') ADVANCE(76);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(78);
      END_STATE();
    case 51:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(80);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(82);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(83);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_map);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_nil);
      END_STATE();
    case 59:
      if (lookahead == 'k') ADVANCE(84);
      END_STATE();
    case 60:
      if (lookahead == 'g') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(86);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 68:
      if (lookahead == 'k') ADVANCE(92);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_chan);
      END_STATE();
    case 71:
      if (lookahead == 't') ADVANCE(93);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 73:
      if (lookahead == 'u') ADVANCE(95);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(96);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_func);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 80:
      if (lookahead == 'r') ADVANCE(99);
      END_STATE();
    case 81:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_iota);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_make);
      END_STATE();
    case 84:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(103);
      END_STATE();
    case 87:
      if (lookahead == 'c') ADVANCE(104);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(105);
      END_STATE();
    case 89:
      if (lookahead == 'c') ADVANCE(106);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(107);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(108);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_defer);
      END_STATE();
    case 97:
      if (lookahead == 'h') ADVANCE(109);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 100:
      if (lookahead == 'f') ADVANCE(111);
      END_STATE();
    case 101:
      if (lookahead == 'g') ADVANCE(112);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_range);
      END_STATE();
    case 103:
      if (lookahead == 'n') ADVANCE(113);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(114);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(115);
      END_STATE();
    case 106:
      if (lookahead == 'h') ADVANCE(116);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(117);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(118);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 111:
      if (lookahead == 'a') ADVANCE(120);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 119:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 120:
      if (lookahead == 'c') ADVANCE(124);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 123:
      if (lookahead == 'u') ADVANCE(125);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 125:
      if (lookahead == 'g') ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 127:
      if (lookahead == 'h') ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_fallthrough);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 59},
  [2] = {.lex_state = 59},
  [3] = {.lex_state = 59},
  [4] = {.lex_state = 59},
  [5] = {.lex_state = 59},
  [6] = {.lex_state = 59},
  [7] = {.lex_state = 59},
  [8] = {.lex_state = 59},
  [9] = {.lex_state = 59},
  [10] = {.lex_state = 59},
  [11] = {.lex_state = 59},
  [12] = {.lex_state = 59},
  [13] = {.lex_state = 59},
  [14] = {.lex_state = 59},
  [15] = {.lex_state = 59},
  [16] = {.lex_state = 59},
  [17] = {.lex_state = 59},
  [18] = {.lex_state = 59},
  [19] = {.lex_state = 59},
  [20] = {.lex_state = 59},
  [21] = {.lex_state = 59},
  [22] = {.lex_state = 59},
  [23] = {.lex_state = 59},
  [24] = {.lex_state = 59},
  [25] = {.lex_state = 59},
  [26] = {.lex_state = 59},
  [27] = {.lex_state = 57},
  [28] = {.lex_state = 57},
  [29] = {.lex_state = 59},
  [30] = {.lex_state = 57},
  [31] = {.lex_state = 57},
  [32] = {.lex_state = 59},
  [33] = {.lex_state = 59},
  [34] = {.lex_state = 59},
  [35] = {.lex_state = 59},
  [36] = {.lex_state = 59},
  [37] = {.lex_state = 59},
  [38] = {.lex_state = 59},
  [39] = {.lex_state = 59},
  [40] = {.lex_state = 59},
  [41] = {.lex_state = 59},
  [42] = {.lex_state = 59},
  [43] = {.lex_state = 59},
  [44] = {.lex_state = 59},
  [45] = {.lex_state = 59},
  [46] = {.lex_state = 59},
  [47] = {.lex_state = 59},
  [48] = {.lex_state = 59},
  [49] = {.lex_state = 59},
  [50] = {.lex_state = 59},
  [51] = {.lex_state = 59},
  [52] = {.lex_state = 59},
  [53] = {.lex_state = 59},
  [54] = {.lex_state = 59},
  [55] = {.lex_state = 59},
  [56] = {.lex_state = 59},
  [57] = {.lex_state = 59},
  [58] = {.lex_state = 59},
  [59] = {.lex_state = 59},
  [60] = {.lex_state = 59},
  [61] = {.lex_state = 59},
  [62] = {.lex_state = 59},
  [63] = {.lex_state = 59},
  [64] = {.lex_state = 59},
  [65] = {.lex_state = 59},
  [66] = {.lex_state = 59},
  [67] = {.lex_state = 59},
  [68] = {.lex_state = 59},
  [69] = {.lex_state = 59},
  [70] = {.lex_state = 59},
  [71] = {.lex_state = 59},
  [72] = {.lex_state = 59},
  [73] = {.lex_state = 59},
  [74] = {.lex_state = 59},
  [75] = {.lex_state = 59},
  [76] = {.lex_state = 59},
  [77] = {.lex_state = 59},
  [78] = {.lex_state = 59},
  [79] = {.lex_state = 59},
  [80] = {.lex_state = 59},
  [81] = {.lex_state = 59},
  [82] = {.lex_state = 59},
  [83] = {.lex_state = 59},
  [84] = {.lex_state = 59},
  [85] = {.lex_state = 59},
  [86] = {.lex_state = 59},
  [87] = {.lex_state = 59},
  [88] = {.lex_state = 59},
  [89] = {.lex_state = 59},
  [90] = {.lex_state = 59},
  [91] = {.lex_state = 59},
  [92] = {.lex_state = 59},
  [93] = {.lex_state = 59},
  [94] = {.lex_state = 59},
  [95] = {.lex_state = 59},
  [96] = {.lex_state = 59},
  [97] = {.lex_state = 59},
  [98] = {.lex_state = 59},
  [99] = {.lex_state = 59},
  [100] = {.lex_state = 59},
  [101] = {.lex_state = 59},
  [102] = {.lex_state = 59},
  [103] = {.lex_state = 59},
  [104] = {.lex_state = 59},
  [105] = {.lex_state = 59},
  [106] = {.lex_state = 59},
  [107] = {.lex_state = 59},
  [108] = {.lex_state = 59},
  [109] = {.lex_state = 59},
  [110] = {.lex_state = 59},
  [111] = {.lex_state = 59},
  [112] = {.lex_state = 59},
  [113] = {.lex_state = 59},
  [114] = {.lex_state = 59},
  [115] = {.lex_state = 59},
  [116] = {.lex_state = 59},
  [117] = {.lex_state = 59},
  [118] = {.lex_state = 59},
  [119] = {.lex_state = 59},
  [120] = {.lex_state = 59},
  [121] = {.lex_state = 59},
  [122] = {.lex_state = 59},
  [123] = {.lex_state = 59},
  [124] = {.lex_state = 59},
  [125] = {.lex_state = 59},
  [126] = {.lex_state = 59},
  [127] = {.lex_state = 59},
  [128] = {.lex_state = 59},
  [129] = {.lex_state = 59},
  [130] = {.lex_state = 59},
  [131] = {.lex_state = 59},
  [132] = {.lex_state = 59},
  [133] = {.lex_state = 59},
  [134] = {.lex_state = 59},
  [135] = {.lex_state = 59},
  [136] = {.lex_state = 59},
  [137] = {.lex_state = 59},
  [138] = {.lex_state = 59},
  [139] = {.lex_state = 59},
  [140] = {.lex_state = 59},
  [141] = {.lex_state = 59},
  [142] = {.lex_state = 59},
  [143] = {.lex_state = 59},
  [144] = {.lex_state = 59},
  [145] = {.lex_state = 59},
  [146] = {.lex_state = 59},
  [147] = {.lex_state = 59},
  [148] = {.lex_state = 59},
  [149] = {.lex_state = 59},
  [150] = {.lex_state = 59},
  [151] = {.lex_state = 59},
  [152] = {.lex_state = 59},
  [153] = {.lex_state = 59},
  [154] = {.lex_state = 59},
  [155] = {.lex_state = 59},
  [156] = {.lex_state = 59},
  [157] = {.lex_state = 59},
  [158] = {.lex_state = 59},
  [159] = {.lex_state = 59},
  [160] = {.lex_state = 59},
  [161] = {.lex_state = 59},
  [162] = {.lex_state = 59},
  [163] = {.lex_state = 59},
  [164] = {.lex_state = 59},
  [165] = {.lex_state = 59},
  [166] = {.lex_state = 59},
  [167] = {.lex_state = 59},
  [168] = {.lex_state = 59},
  [169] = {.lex_state = 59},
  [170] = {.lex_state = 59},
  [171] = {.lex_state = 59},
  [172] = {.lex_state = 59},
  [173] = {.lex_state = 59},
  [174] = {.lex_state = 59},
  [175] = {.lex_state = 59},
  [176] = {.lex_state = 59},
  [177] = {.lex_state = 59},
  [178] = {.lex_state = 59},
  [179] = {.lex_state = 59},
  [180] = {.lex_state = 59},
  [181] = {.lex_state = 59},
  [182] = {.lex_state = 59},
  [183] = {.lex_state = 59},
  [184] = {.lex_state = 59},
  [185] = {.lex_state = 59},
  [186] = {.lex_state = 59},
  [187] = {.lex_state = 59},
  [188] = {.lex_state = 59},
  [189] = {.lex_state = 59},
  [190] = {.lex_state = 59},
  [191] = {.lex_state = 59},
  [192] = {.lex_state = 59},
  [193] = {.lex_state = 59},
  [194] = {.lex_state = 59},
  [195] = {.lex_state = 59},
  [196] = {.lex_state = 59},
  [197] = {.lex_state = 59},
  [198] = {.lex_state = 59},
  [199] = {.lex_state = 59},
  [200] = {.lex_state = 59},
  [201] = {.lex_state = 59},
  [202] = {.lex_state = 59},
  [203] = {.lex_state = 59},
  [204] = {.lex_state = 59},
  [205] = {.lex_state = 59},
  [206] = {.lex_state = 59},
  [207] = {.lex_state = 59},
  [208] = {.lex_state = 59},
  [209] = {.lex_state = 59},
  [210] = {.lex_state = 59},
  [211] = {.lex_state = 59},
  [212] = {.lex_state = 59},
  [213] = {.lex_state = 59},
  [214] = {.lex_state = 59},
  [215] = {.lex_state = 59},
  [216] = {.lex_state = 59},
  [217] = {.lex_state = 59},
  [218] = {.lex_state = 59},
  [219] = {.lex_state = 59},
  [220] = {.lex_state = 59},
  [221] = {.lex_state = 59},
  [222] = {.lex_state = 59},
  [223] = {.lex_state = 59},
  [224] = {.lex_state = 59},
  [225] = {.lex_state = 59},
  [226] = {.lex_state = 59},
  [227] = {.lex_state = 59},
  [228] = {.lex_state = 59},
  [229] = {.lex_state = 59},
  [230] = {.lex_state = 59},
  [231] = {.lex_state = 59},
  [232] = {.lex_state = 59},
  [233] = {.lex_state = 59},
  [234] = {.lex_state = 59},
  [235] = {.lex_state = 57},
  [236] = {.lex_state = 57},
  [237] = {.lex_state = 1},
  [238] = {.lex_state = 1},
  [239] = {.lex_state = 57},
  [240] = {.lex_state = 57},
  [241] = {.lex_state = 57},
  [242] = {.lex_state = 57},
  [243] = {.lex_state = 57},
  [244] = {.lex_state = 57},
  [245] = {.lex_state = 57},
  [246] = {.lex_state = 57},
  [247] = {.lex_state = 57},
  [248] = {.lex_state = 57},
  [249] = {.lex_state = 57},
  [250] = {.lex_state = 57},
  [251] = {.lex_state = 57},
  [252] = {.lex_state = 57},
  [253] = {.lex_state = 57},
  [254] = {.lex_state = 57},
  [255] = {.lex_state = 57},
  [256] = {.lex_state = 7},
  [257] = {.lex_state = 57},
  [258] = {.lex_state = 57},
  [259] = {.lex_state = 57},
  [260] = {.lex_state = 57},
  [261] = {.lex_state = 57},
  [262] = {.lex_state = 57},
  [263] = {.lex_state = 57},
  [264] = {.lex_state = 57},
  [265] = {.lex_state = 57},
  [266] = {.lex_state = 57},
  [267] = {.lex_state = 57},
  [268] = {.lex_state = 57},
  [269] = {.lex_state = 57},
  [270] = {.lex_state = 57},
  [271] = {.lex_state = 57},
  [272] = {.lex_state = 57},
  [273] = {.lex_state = 57},
  [274] = {.lex_state = 57},
  [275] = {.lex_state = 57},
  [276] = {.lex_state = 57},
  [277] = {.lex_state = 57},
  [278] = {.lex_state = 57},
  [279] = {.lex_state = 57},
  [280] = {.lex_state = 57},
  [281] = {.lex_state = 57},
  [282] = {.lex_state = 57},
  [283] = {.lex_state = 1},
  [284] = {.lex_state = 57},
  [285] = {.lex_state = 57},
  [286] = {.lex_state = 57},
  [287] = {.lex_state = 57},
  [288] = {.lex_state = 1},
  [289] = {.lex_state = 57},
  [290] = {.lex_state = 1},
  [291] = {.lex_state = 1},
  [292] = {.lex_state = 59},
  [293] = {.lex_state = 1},
  [294] = {.lex_state = 1},
  [295] = {.lex_state = 1},
  [296] = {.lex_state = 1},
  [297] = {.lex_state = 4},
  [298] = {.lex_state = 4},
  [299] = {.lex_state = 1},
  [300] = {.lex_state = 1},
  [301] = {.lex_state = 1},
  [302] = {.lex_state = 1},
  [303] = {.lex_state = 1},
  [304] = {.lex_state = 1},
  [305] = {.lex_state = 1},
  [306] = {.lex_state = 1},
  [307] = {.lex_state = 1},
  [308] = {.lex_state = 1},
  [309] = {.lex_state = 1},
  [310] = {.lex_state = 4},
  [311] = {.lex_state = 1},
  [312] = {.lex_state = 1},
  [313] = {.lex_state = 1},
  [314] = {.lex_state = 1},
  [315] = {.lex_state = 1},
  [316] = {.lex_state = 1},
  [317] = {.lex_state = 1},
  [318] = {.lex_state = 1},
  [319] = {.lex_state = 1},
  [320] = {.lex_state = 1},
  [321] = {.lex_state = 1},
  [322] = {.lex_state = 1},
  [323] = {.lex_state = 1},
  [324] = {.lex_state = 1},
  [325] = {.lex_state = 1},
  [326] = {.lex_state = 1},
  [327] = {.lex_state = 1},
  [328] = {.lex_state = 1},
  [329] = {.lex_state = 1},
  [330] = {.lex_state = 1},
  [331] = {.lex_state = 1},
  [332] = {.lex_state = 1},
  [333] = {.lex_state = 1},
  [334] = {.lex_state = 1},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 4},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 4},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 4},
  [342] = {.lex_state = 4},
  [343] = {.lex_state = 4},
  [344] = {.lex_state = 4},
  [345] = {.lex_state = 4},
  [346] = {.lex_state = 4},
  [347] = {.lex_state = 4},
  [348] = {.lex_state = 4},
  [349] = {.lex_state = 4},
  [350] = {.lex_state = 4},
  [351] = {.lex_state = 4},
  [352] = {.lex_state = 4},
  [353] = {.lex_state = 4},
  [354] = {.lex_state = 4},
  [355] = {.lex_state = 4},
  [356] = {.lex_state = 4},
  [357] = {.lex_state = 4},
  [358] = {.lex_state = 4},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 4},
  [361] = {.lex_state = 4},
  [362] = {.lex_state = 4},
  [363] = {.lex_state = 4},
  [364] = {.lex_state = 4},
  [365] = {.lex_state = 4},
  [366] = {.lex_state = 4},
  [367] = {.lex_state = 4},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 4},
  [370] = {.lex_state = 4},
  [371] = {.lex_state = 4},
  [372] = {.lex_state = 4},
  [373] = {.lex_state = 4},
  [374] = {.lex_state = 4},
  [375] = {.lex_state = 4},
  [376] = {.lex_state = 4},
  [377] = {.lex_state = 4},
  [378] = {.lex_state = 5},
  [379] = {.lex_state = 5},
  [380] = {.lex_state = 5},
  [381] = {.lex_state = 5},
  [382] = {.lex_state = 5},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 5},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 5},
  [387] = {.lex_state = 5},
  [388] = {.lex_state = 5},
  [389] = {.lex_state = 5},
  [390] = {.lex_state = 5},
  [391] = {.lex_state = 5},
  [392] = {.lex_state = 5},
  [393] = {.lex_state = 5},
  [394] = {.lex_state = 5},
  [395] = {.lex_state = 5},
  [396] = {.lex_state = 5},
  [397] = {.lex_state = 5},
  [398] = {.lex_state = 5},
  [399] = {.lex_state = 5},
  [400] = {.lex_state = 5},
  [401] = {.lex_state = 5},
  [402] = {.lex_state = 5},
  [403] = {.lex_state = 5},
  [404] = {.lex_state = 5},
  [405] = {.lex_state = 5},
  [406] = {.lex_state = 5},
  [407] = {.lex_state = 5},
  [408] = {.lex_state = 5},
  [409] = {.lex_state = 5},
  [410] = {.lex_state = 5},
  [411] = {.lex_state = 5},
  [412] = {.lex_state = 5},
  [413] = {.lex_state = 5},
  [414] = {.lex_state = 5},
  [415] = {.lex_state = 5},
  [416] = {.lex_state = 5},
  [417] = {.lex_state = 5},
  [418] = {.lex_state = 5},
  [419] = {.lex_state = 5},
  [420] = {.lex_state = 5},
  [421] = {.lex_state = 6},
  [422] = {.lex_state = 6},
  [423] = {.lex_state = 6},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 6},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 6},
  [432] = {.lex_state = 6},
  [433] = {.lex_state = 6},
  [434] = {.lex_state = 6},
  [435] = {.lex_state = 6},
  [436] = {.lex_state = 6},
  [437] = {.lex_state = 6},
  [438] = {.lex_state = 6},
  [439] = {.lex_state = 6},
  [440] = {.lex_state = 6},
  [441] = {.lex_state = 6},
  [442] = {.lex_state = 6},
  [443] = {.lex_state = 6},
  [444] = {.lex_state = 6},
  [445] = {.lex_state = 6},
  [446] = {.lex_state = 6},
  [447] = {.lex_state = 6},
  [448] = {.lex_state = 6},
  [449] = {.lex_state = 6},
  [450] = {.lex_state = 6},
  [451] = {.lex_state = 6},
  [452] = {.lex_state = 6},
  [453] = {.lex_state = 6},
  [454] = {.lex_state = 6},
  [455] = {.lex_state = 6},
  [456] = {.lex_state = 6},
  [457] = {.lex_state = 6},
  [458] = {.lex_state = 6},
  [459] = {.lex_state = 6},
  [460] = {.lex_state = 6},
  [461] = {.lex_state = 2},
  [462] = {.lex_state = 6},
  [463] = {.lex_state = 57},
  [464] = {.lex_state = 2},
  [465] = {.lex_state = 6},
  [466] = {.lex_state = 7},
  [467] = {.lex_state = 57},
  [468] = {.lex_state = 2},
  [469] = {.lex_state = 57},
  [470] = {.lex_state = 2},
  [471] = {.lex_state = 2},
  [472] = {.lex_state = 57},
  [473] = {.lex_state = 2},
  [474] = {.lex_state = 2},
  [475] = {.lex_state = 2},
  [476] = {.lex_state = 7},
  [477] = {.lex_state = 2},
  [478] = {.lex_state = 2},
  [479] = {.lex_state = 6},
  [480] = {.lex_state = 7},
  [481] = {.lex_state = 7},
  [482] = {.lex_state = 7},
  [483] = {.lex_state = 7},
  [484] = {.lex_state = 7},
  [485] = {.lex_state = 2},
  [486] = {.lex_state = 2},
  [487] = {.lex_state = 2},
  [488] = {.lex_state = 7},
  [489] = {.lex_state = 2},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 6},
  [492] = {.lex_state = 2},
  [493] = {.lex_state = 6},
  [494] = {.lex_state = 2},
  [495] = {.lex_state = 2},
  [496] = {.lex_state = 2},
  [497] = {.lex_state = 2},
  [498] = {.lex_state = 2},
  [499] = {.lex_state = 2},
  [500] = {.lex_state = 6},
  [501] = {.lex_state = 2},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 2},
  [504] = {.lex_state = 6},
  [505] = {.lex_state = 2},
  [506] = {.lex_state = 6},
  [507] = {.lex_state = 2},
  [508] = {.lex_state = 2},
  [509] = {.lex_state = 2},
  [510] = {.lex_state = 2},
  [511] = {.lex_state = 6},
  [512] = {.lex_state = 2},
  [513] = {.lex_state = 2},
  [514] = {.lex_state = 2},
  [515] = {.lex_state = 2},
  [516] = {.lex_state = 2},
  [517] = {.lex_state = 2},
  [518] = {.lex_state = 2},
  [519] = {.lex_state = 0},
  [520] = {.lex_state = 6},
  [521] = {.lex_state = 6},
  [522] = {.lex_state = 7},
  [523] = {.lex_state = 6},
  [524] = {.lex_state = 2},
  [525] = {.lex_state = 2},
  [526] = {.lex_state = 6},
  [527] = {.lex_state = 2},
  [528] = {.lex_state = 2},
  [529] = {.lex_state = 2},
  [530] = {.lex_state = 2},
  [531] = {.lex_state = 2},
  [532] = {.lex_state = 2},
  [533] = {.lex_state = 2},
  [534] = {.lex_state = 2},
  [535] = {.lex_state = 2},
  [536] = {.lex_state = 7},
  [537] = {.lex_state = 7},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 6},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 6},
  [542] = {.lex_state = 6},
  [543] = {.lex_state = 6},
  [544] = {.lex_state = 6},
  [545] = {.lex_state = 6},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 6},
  [549] = {.lex_state = 7},
  [550] = {.lex_state = 7},
  [551] = {.lex_state = 7},
  [552] = {.lex_state = 7},
  [553] = {.lex_state = 6},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 7},
  [556] = {.lex_state = 7},
  [557] = {.lex_state = 7},
  [558] = {.lex_state = 7},
  [559] = {.lex_state = 7},
  [560] = {.lex_state = 7},
  [561] = {.lex_state = 7},
  [562] = {.lex_state = 7},
  [563] = {.lex_state = 7},
  [564] = {.lex_state = 7},
  [565] = {.lex_state = 7},
  [566] = {.lex_state = 7},
  [567] = {.lex_state = 7},
  [568] = {.lex_state = 7},
  [569] = {.lex_state = 7},
  [570] = {.lex_state = 7},
  [571] = {.lex_state = 7},
  [572] = {.lex_state = 7},
  [573] = {.lex_state = 7},
  [574] = {.lex_state = 7},
  [575] = {.lex_state = 7},
  [576] = {.lex_state = 7},
  [577] = {.lex_state = 6},
  [578] = {.lex_state = 7},
  [579] = {.lex_state = 7},
  [580] = {.lex_state = 7},
  [581] = {.lex_state = 7},
  [582] = {.lex_state = 6},
  [583] = {.lex_state = 7},
  [584] = {.lex_state = 6},
  [585] = {.lex_state = 6},
  [586] = {.lex_state = 6},
  [587] = {.lex_state = 7},
  [588] = {.lex_state = 6},
  [589] = {.lex_state = 6},
  [590] = {.lex_state = 6},
  [591] = {.lex_state = 6},
  [592] = {.lex_state = 6},
  [593] = {.lex_state = 6},
  [594] = {.lex_state = 6},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 6},
  [597] = {.lex_state = 6},
  [598] = {.lex_state = 6},
  [599] = {.lex_state = 6},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 6},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 6},
  [604] = {.lex_state = 6},
  [605] = {.lex_state = 6},
  [606] = {.lex_state = 6},
  [607] = {.lex_state = 6},
  [608] = {.lex_state = 6},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 6},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 6},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 6},
  [615] = {.lex_state = 6},
  [616] = {.lex_state = 6},
  [617] = {.lex_state = 6},
  [618] = {.lex_state = 6},
  [619] = {.lex_state = 6},
  [620] = {.lex_state = 6},
  [621] = {.lex_state = 6},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 6},
  [624] = {.lex_state = 6},
  [625] = {.lex_state = 6},
  [626] = {.lex_state = 6},
  [627] = {.lex_state = 6},
  [628] = {.lex_state = 6},
  [629] = {.lex_state = 6},
  [630] = {.lex_state = 6},
  [631] = {.lex_state = 6},
  [632] = {.lex_state = 6},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 6},
  [635] = {.lex_state = 6},
  [636] = {.lex_state = 6},
  [637] = {.lex_state = 6},
  [638] = {.lex_state = 6},
  [639] = {.lex_state = 6},
  [640] = {.lex_state = 6},
  [641] = {.lex_state = 6},
  [642] = {.lex_state = 6},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 6},
  [645] = {.lex_state = 6},
  [646] = {.lex_state = 6},
  [647] = {.lex_state = 6},
  [648] = {.lex_state = 57},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 6},
  [651] = {.lex_state = 6},
  [652] = {.lex_state = 6},
  [653] = {.lex_state = 6},
  [654] = {.lex_state = 6},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 6},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 0},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 57},
  [742] = {.lex_state = 57},
  [743] = {.lex_state = 57},
  [744] = {.lex_state = 57},
  [745] = {.lex_state = 57},
  [746] = {.lex_state = 57},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 0},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 57},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 57},
  [783] = {.lex_state = 57},
  [784] = {.lex_state = 57},
  [785] = {.lex_state = 57},
  [786] = {.lex_state = 57},
  [787] = {.lex_state = 57},
  [788] = {.lex_state = 57},
  [789] = {.lex_state = 57},
  [790] = {.lex_state = 57},
  [791] = {.lex_state = 57},
  [792] = {.lex_state = 57},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 57},
  [795] = {.lex_state = 57},
  [796] = {.lex_state = 57},
  [797] = {.lex_state = 57},
  [798] = {.lex_state = 57},
  [799] = {.lex_state = 57},
  [800] = {.lex_state = 57},
  [801] = {.lex_state = 57},
  [802] = {.lex_state = 57},
  [803] = {.lex_state = 57},
  [804] = {.lex_state = 57},
  [805] = {.lex_state = 57},
  [806] = {.lex_state = 57},
  [807] = {.lex_state = 57},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 57},
  [815] = {.lex_state = 57},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 57},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 57},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 0},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 57},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 57},
  [842] = {.lex_state = 0},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 57},
  [845] = {.lex_state = 57},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 57},
  [848] = {.lex_state = 0},
  [849] = {.lex_state = 57},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 0},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 57},
  [856] = {.lex_state = 57},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 57},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 57},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 57},
  [867] = {.lex_state = 57},
  [868] = {.lex_state = 57},
  [869] = {.lex_state = 57},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 57},
  [873] = {.lex_state = 57},
  [874] = {.lex_state = 57},
  [875] = {.lex_state = 57},
  [876] = {.lex_state = 57},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 57},
  [879] = {.lex_state = 57},
  [880] = {.lex_state = 57},
  [881] = {.lex_state = 57},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 57},
  [884] = {.lex_state = 57},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 57},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 57},
  [889] = {.lex_state = 57},
  [890] = {.lex_state = 57},
  [891] = {.lex_state = 57},
  [892] = {.lex_state = 57},
  [893] = {.lex_state = 57},
  [894] = {.lex_state = 57},
  [895] = {.lex_state = 57},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 57},
  [898] = {.lex_state = 57},
  [899] = {.lex_state = 57},
  [900] = {.lex_state = 57},
  [901] = {.lex_state = 57},
  [902] = {.lex_state = 57},
  [903] = {.lex_state = 57},
  [904] = {.lex_state = 57},
  [905] = {.lex_state = 0},
  [906] = {.lex_state = 57},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 57},
  [909] = {.lex_state = 57},
  [910] = {.lex_state = 57},
  [911] = {.lex_state = 57},
  [912] = {.lex_state = 57},
  [913] = {.lex_state = 57},
  [914] = {.lex_state = 57},
  [915] = {.lex_state = 57},
  [916] = {.lex_state = 57},
  [917] = {.lex_state = 57},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 57},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 57},
  [922] = {.lex_state = 57},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 57},
  [925] = {.lex_state = 57},
  [926] = {.lex_state = 57},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 57},
  [929] = {.lex_state = 57},
  [930] = {.lex_state = 57},
  [931] = {.lex_state = 57},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 57},
  [934] = {.lex_state = 57},
  [935] = {.lex_state = 57},
  [936] = {.lex_state = 57},
  [937] = {.lex_state = 57},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 57},
  [941] = {.lex_state = 57},
  [942] = {.lex_state = 3},
  [943] = {.lex_state = 57},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 57},
  [946] = {.lex_state = 57},
  [947] = {.lex_state = 57},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 57},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 3},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 57},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 3},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 3},
  [960] = {.lex_state = 57},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 3},
  [963] = {.lex_state = 3},
  [964] = {.lex_state = 3},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 3},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 3},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 3},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 3},
  [977] = {.lex_state = 57},
  [978] = {.lex_state = 3},
  [979] = {.lex_state = 57},
  [980] = {.lex_state = 57},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 57},
  [983] = {.lex_state = 3},
  [984] = {.lex_state = 3},
  [985] = {.lex_state = 3},
  [986] = {.lex_state = 57},
  [987] = {.lex_state = 57},
  [988] = {.lex_state = 57},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 57},
  [1007] = {.lex_state = 57},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 57},
  [1012] = {.lex_state = 57},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 57},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 57},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 57},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 57},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 57},
  [1058] = {.lex_state = 57},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 57},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 57},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 57},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 57},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 57},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 0},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 57},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 57},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 57},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 57},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 0},
  [1124] = {.lex_state = 0},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 57},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 0},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 0},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 0},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 0},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 0},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 0},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 0},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 0},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 0},
  [1158] = {.lex_state = 57},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 0},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 0},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 0},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 0},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 0},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 0},
  [1181] = {.lex_state = 0},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 0},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 0},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 0},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 0},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 0},
  [1224] = {.lex_state = 0},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 0},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 0},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 0},
  [1247] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_blank_identifier] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_func] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_map] = ACTIONS(1),
    [anon_sym_chan] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_CARET_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_fallthrough] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_go] = ACTIONS(1),
    [anon_sym_defer] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_range] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_make] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_AMP_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_int_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_imaginary_literal] = ACTIONS(1),
    [sym_rune_literal] = ACTIONS(1),
    [sym_nil] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_iota] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(1213),
    [sym_package_clause] = STATE(263),
    [sym_import_declaration] = STATE(263),
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_function_declaration] = STATE(263),
    [sym_method_declaration] = STATE(263),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(1130),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_package_clause] = STATE(263),
    [sym_import_declaration] = STATE(263),
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_function_declaration] = STATE(263),
    [sym_method_declaration] = STATE(263),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(1130),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(73),
    [sym_identifier] = ACTIONS(75),
    [anon_sym_SEMI] = ACTIONS(78),
    [anon_sym_package] = ACTIONS(81),
    [anon_sym_import] = ACTIONS(84),
    [anon_sym_LPAREN] = ACTIONS(87),
    [anon_sym_const] = ACTIONS(90),
    [anon_sym_var] = ACTIONS(93),
    [anon_sym_func] = ACTIONS(96),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_type] = ACTIONS(102),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_struct] = ACTIONS(108),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(114),
    [anon_sym_map] = ACTIONS(117),
    [anon_sym_chan] = ACTIONS(120),
    [anon_sym_LT_DASH] = ACTIONS(123),
    [anon_sym_fallthrough] = ACTIONS(126),
    [anon_sym_break] = ACTIONS(129),
    [anon_sym_continue] = ACTIONS(132),
    [anon_sym_goto] = ACTIONS(135),
    [anon_sym_return] = ACTIONS(138),
    [anon_sym_go] = ACTIONS(141),
    [anon_sym_defer] = ACTIONS(144),
    [anon_sym_if] = ACTIONS(147),
    [anon_sym_for] = ACTIONS(150),
    [anon_sym_switch] = ACTIONS(153),
    [anon_sym_select] = ACTIONS(156),
    [anon_sym_new] = ACTIONS(159),
    [anon_sym_make] = ACTIONS(159),
    [anon_sym_PLUS] = ACTIONS(162),
    [anon_sym_DASH] = ACTIONS(162),
    [anon_sym_BANG] = ACTIONS(162),
    [anon_sym_CARET] = ACTIONS(162),
    [anon_sym_AMP] = ACTIONS(162),
    [sym_raw_string_literal] = ACTIONS(165),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_int_literal] = ACTIONS(171),
    [sym_float_literal] = ACTIONS(171),
    [sym_imaginary_literal] = ACTIONS(165),
    [sym_rune_literal] = ACTIONS(165),
    [sym_nil] = ACTIONS(171),
    [sym_true] = ACTIONS(171),
    [sym_false] = ACTIONS(171),
    [sym_iota] = ACTIONS(171),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_package_clause] = STATE(263),
    [sym_import_declaration] = STATE(263),
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_function_declaration] = STATE(263),
    [sym_method_declaration] = STATE(263),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(1130),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(174),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_package] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1036),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1036),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(180),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(182),
    [anon_sym_default] = ACTIONS(182),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1005),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1005),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(184),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(186),
    [anon_sym_default] = ACTIONS(186),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(996),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(996),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(188),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(190),
    [anon_sym_default] = ACTIONS(190),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(998),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(998),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(192),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(194),
    [anon_sym_default] = ACTIONS(194),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(995),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(995),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(196),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(198),
    [anon_sym_default] = ACTIONS(198),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(879),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1048),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(200),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(202),
    [anon_sym_default] = ACTIONS(202),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(879),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1088),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(204),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(206),
    [anon_sym_default] = ACTIONS(206),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1231),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1231),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(208),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1221),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1221),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(210),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1163),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1163),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(212),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1187),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1187),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(214),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(901),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(216),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_case] = ACTIONS(218),
    [anon_sym_default] = ACTIONS(218),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1236),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1236),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(220),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1179),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1179),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement_list] = STATE(1181),
    [sym__statement] = STATE(838),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_empty_labeled_statement] = STATE(1181),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(176),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_RBRACE] = ACTIONS(224),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(901),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym__declaration] = STATE(910),
    [sym_const_declaration] = STATE(910),
    [sym_var_declaration] = STATE(910),
    [sym_type_declaration] = STATE(910),
    [sym_expression_list] = STATE(756),
    [sym_parenthesized_type] = STATE(1204),
    [sym__simple_type] = STATE(1204),
    [sym_generic_type] = STATE(1001),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1001),
    [sym_implicit_length_array_type] = STATE(1129),
    [sym_slice_type] = STATE(1001),
    [sym_struct_type] = STATE(1001),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1001),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(910),
    [sym__statement] = STATE(879),
    [sym_empty_statement] = STATE(910),
    [sym__simple_statement] = STATE(910),
    [sym_send_statement] = STATE(914),
    [sym_inc_statement] = STATE(914),
    [sym_dec_statement] = STATE(914),
    [sym_assignment_statement] = STATE(914),
    [sym_short_var_declaration] = STATE(914),
    [sym_labeled_statement] = STATE(910),
    [sym_fallthrough_statement] = STATE(910),
    [sym_break_statement] = STATE(910),
    [sym_continue_statement] = STATE(910),
    [sym_goto_statement] = STATE(910),
    [sym_return_statement] = STATE(910),
    [sym_go_statement] = STATE(910),
    [sym_defer_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_for_statement] = STATE(910),
    [sym_expression_switch_statement] = STATE(910),
    [sym_type_switch_statement] = STATE(910),
    [sym_select_statement] = STATE(910),
    [sym__expression] = STATE(283),
    [sym_parenthesized_expression] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_selector_expression] = STATE(316),
    [sym_index_expression] = STATE(316),
    [sym_slice_expression] = STATE(316),
    [sym_type_assertion_expression] = STATE(316),
    [sym_type_conversion_expression] = STATE(316),
    [sym_composite_literal] = STATE(316),
    [sym_func_literal] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_qualified_type] = STATE(1001),
    [sym_interpreted_string_literal] = STATE(316),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(15),
    [anon_sym_const] = ACTIONS(17),
    [anon_sym_var] = ACTIONS(19),
    [anon_sym_func] = ACTIONS(178),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(39),
    [anon_sym_fallthrough] = ACTIONS(41),
    [anon_sym_break] = ACTIONS(43),
    [anon_sym_continue] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(47),
    [anon_sym_return] = ACTIONS(49),
    [anon_sym_go] = ACTIONS(51),
    [anon_sym_defer] = ACTIONS(53),
    [anon_sym_if] = ACTIONS(55),
    [anon_sym_for] = ACTIONS(57),
    [anon_sym_switch] = ACTIONS(59),
    [anon_sym_select] = ACTIONS(61),
    [anon_sym_new] = ACTIONS(63),
    [anon_sym_make] = ACTIONS(63),
    [anon_sym_PLUS] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(65),
    [anon_sym_BANG] = ACTIONS(65),
    [anon_sym_CARET] = ACTIONS(65),
    [anon_sym_AMP] = ACTIONS(65),
    [sym_raw_string_literal] = ACTIONS(67),
    [anon_sym_DQUOTE] = ACTIONS(69),
    [sym_int_literal] = ACTIONS(71),
    [sym_float_literal] = ACTIONS(71),
    [sym_imaginary_literal] = ACTIONS(67),
    [sym_rune_literal] = ACTIONS(67),
    [sym_nil] = ACTIONS(71),
    [sym_true] = ACTIONS(71),
    [sym_false] = ACTIONS(71),
    [sym_iota] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_expression_list] = STATE(754),
    [sym_parenthesized_type] = STATE(1244),
    [sym__simple_type] = STATE(1244),
    [sym_generic_type] = STATE(1055),
    [sym_pointer_type] = STATE(836),
    [sym_array_type] = STATE(1055),
    [sym_implicit_length_array_type] = STATE(1150),
    [sym_slice_type] = STATE(1055),
    [sym_struct_type] = STATE(1055),
    [sym_interface_type] = STATE(836),
    [sym_map_type] = STATE(1055),
    [sym_channel_type] = STATE(836),
    [sym_function_type] = STATE(836),
    [sym_block] = STATE(929),
    [sym__simple_statement] = STATE(1202),
    [sym_send_statement] = STATE(1121),
    [sym_inc_statement] = STATE(1121),
    [sym_dec_statement] = STATE(1121),
    [sym_assignment_statement] = STATE(1121),
    [sym_short_var_declaration] = STATE(1121),
    [sym_for_clause] = STATE(1128),
    [sym_range_clause] = STATE(1128),
    [sym__expression] = STATE(297),
    [sym_parenthesized_expression] = STATE(369),
    [sym_call_expression] = STATE(369),
    [sym_selector_expression] = STATE(369),
    [sym_index_expression] = STATE(369),
    [sym_slice_expression] = STATE(369),
    [sym_type_assertion_expression] = STATE(369),
    [sym_type_conversion_expression] = STATE(369),
    [sym_composite_literal] = STATE(369),
    [sym_func_literal] = STATE(369),
    [sym_unary_expression] = STATE(369),
    [sym_binary_expression] = STATE(369),
    [sym_qualified_type] = STATE(1055),
    [sym_interpreted_string_literal] = STATE(369),
    [sym_identifier] = ACTIONS(226),
    [anon_sym_SEMI] = ACTIONS(228),
    [anon_sym_LPAREN] = ACTIONS(230),
    [anon_sym_func] = ACTIONS(232),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_STAR] = ACTIONS(234),
    [anon_sym_struct] = ACTIONS(29),
    [anon_sym_LBRACE] = ACTIONS(31),
    [anon_sym_interface] = ACTIONS(33),
    [anon_sym_map] = ACTIONS(35),
    [anon_sym_chan] = ACTIONS(37),
    [anon_sym_LT_DASH] = ACTIONS(236),
    [anon_sym_range] = ACTIONS(238),
    [anon_sym_new] = ACTIONS(240),
    [anon_sym_make] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(242),
    [anon_sym_DASH] = ACTIONS(242),
    [anon_sym_BANG] = ACTIONS(242),
    [anon_sym_CARET] = ACTIONS(242),
    [anon_sym_AMP] = ACTIONS(242),
    [sym_raw_string_literal] = ACTIONS(244),
    [anon_sym_DQUOTE] = ACTIONS(246),
    [sym_int_literal] = ACTIONS(248),
    [sym_float_literal] = ACTIONS(248),
    [sym_imaginary_literal] = ACTIONS(244),
    [sym_rune_literal] = ACTIONS(244),
    [sym_nil] = ACTIONS(248),
    [sym_true] = ACTIONS(248),
    [sym_false] = ACTIONS(248),
    [sym_iota] = ACTIONS(248),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(250), 1,
      anon_sym_LBRACE,
    STATE(310), 1,
      sym__expression,
    STATE(755), 1,
      sym_expression_list,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    STATE(1222), 1,
      sym__simple_statement,
    STATE(1224), 1,
      sym__type_switch_header,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1121), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [118] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(252), 1,
      anon_sym_LBRACE,
    STATE(342), 1,
      sym__expression,
    STATE(758), 1,
      sym_expression_list,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    STATE(1235), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1121), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [233] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(254), 1,
      anon_sym_LBRACE,
    STATE(342), 1,
      sym__expression,
    STATE(758), 1,
      sym_expression_list,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    STATE(1168), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1121), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [348] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(256), 1,
      anon_sym_LBRACE,
    STATE(342), 1,
      sym__expression,
    STATE(758), 1,
      sym_expression_list,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    STATE(1195), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1121), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [463] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(258), 1,
      anon_sym_LBRACE,
    STATE(342), 1,
      sym__expression,
    STATE(758), 1,
      sym_expression_list,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    STATE(1167), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1121), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [578] = 17,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(266), 1,
      anon_sym_LPAREN,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(270), 1,
      anon_sym_LBRACK,
    ACTIONS(272), 1,
      anon_sym_STAR,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(284), 1,
      anon_sym_LT_DASH,
    ACTIONS(286), 1,
      sym_comment,
    STATE(242), 1,
      sym_block,
    ACTIONS(260), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(236), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(264), 34,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [674] = 17,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(266), 1,
      anon_sym_LPAREN,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(270), 1,
      anon_sym_LBRACK,
    ACTIONS(272), 1,
      anon_sym_STAR,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(284), 1,
      anon_sym_LT_DASH,
    ACTIONS(286), 1,
      sym_comment,
    STATE(289), 1,
      sym_block,
    ACTIONS(288), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(239), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(290), 34,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [770] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(298), 1,
      sym__expression,
    STATE(753), 1,
      sym_expression_list,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    STATE(1191), 1,
      sym__simple_statement,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(1121), 5,
      sym_send_statement,
      sym_inc_statement,
      sym_dec_statement,
      sym_assignment_statement,
      sym_short_var_declaration,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [882] = 24,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(294), 1,
      anon_sym_LF,
    ACTIONS(298), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(302), 1,
      anon_sym_LBRACK,
    ACTIONS(304), 1,
      anon_sym_STAR,
    ACTIONS(306), 1,
      anon_sym_LT_DASH,
    ACTIONS(314), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(909), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(296), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(310), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    ACTIONS(312), 9,
      sym_raw_string_literal,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [991] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(318), 1,
      sym_identifier,
    ACTIONS(323), 1,
      anon_sym_LPAREN,
    ACTIONS(326), 1,
      anon_sym_func,
    ACTIONS(329), 1,
      anon_sym_LBRACK,
    ACTIONS(332), 1,
      anon_sym_STAR,
    ACTIONS(335), 1,
      anon_sym_struct,
    ACTIONS(338), 1,
      anon_sym_interface,
    ACTIONS(341), 1,
      anon_sym_map,
    ACTIONS(344), 1,
      anon_sym_chan,
    ACTIONS(347), 1,
      anon_sym_LT_DASH,
    ACTIONS(316), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    STATE(284), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(321), 35,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_type,
      anon_sym_LBRACE,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [1082] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(354), 1,
      anon_sym_COMMA,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(362), 1,
      anon_sym_RBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(545), 1,
      sym__expression,
    STATE(939), 1,
      sym_literal_element,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1084), 1,
      sym_keyed_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1199] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(376), 1,
      anon_sym_COMMA,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(973), 1,
      sym_literal_element,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1073), 1,
      sym_keyed_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1316] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(380), 1,
      anon_sym_COMMA,
    ACTIONS(382), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(954), 1,
      sym_literal_element,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1017), 1,
      sym_keyed_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1433] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(384), 1,
      anon_sym_COMMA,
    ACTIONS(386), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(958), 1,
      sym_literal_element,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1052), 1,
      sym_keyed_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1550] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(388), 1,
      anon_sym_COMMA,
    ACTIONS(390), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(944), 1,
      sym_literal_element,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1040), 1,
      sym_keyed_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1667] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(392), 1,
      anon_sym_COMMA,
    ACTIONS(394), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(969), 1,
      sym_literal_element,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1003), 1,
      sym_keyed_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1784] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(396), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [1898] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(398), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2012] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(400), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2126] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(402), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2240] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(404), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2354] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(406), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2468] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(408), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2582] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(410), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2696] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(412), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2810] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(414), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [2924] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(416), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3038] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(418), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3152] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1029), 1,
      sym_literal_element,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1152), 1,
      sym_keyed_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3263] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(545), 1,
      sym__expression,
    STATE(1002), 1,
      sym_literal_value,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1151), 1,
      sym_literal_element,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3371] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(466), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    STATE(1143), 1,
      sym_expression_list,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1225), 2,
      sym_send_statement,
      sym_receive_statement,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3477] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(444), 1,
      anon_sym_LBRACE,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(520), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1232), 1,
      sym_expression_list,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3582] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(450), 1,
      anon_sym_range,
    STATE(526), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1104), 1,
      sym_expression_list,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3687] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(454), 1,
      anon_sym_RPAREN,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(504), 1,
      sym__expression,
    STATE(1010), 1,
      sym_variadic_argument,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3792] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(462), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [3897] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(464), 1,
      anon_sym_RBRACK,
    ACTIONS(466), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(637), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4002] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(468), 1,
      anon_sym_RPAREN,
    STATE(523), 1,
      sym__expression,
    STATE(1079), 1,
      sym_variadic_argument,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4107] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4212] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(472), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4317] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(474), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4422] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(476), 1,
      anon_sym_RPAREN,
    STATE(521), 1,
      sym__expression,
    STATE(1076), 1,
      sym_variadic_argument,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4527] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(478), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4632] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(480), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4737] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(482), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4842] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(484), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [4947] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(486), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5052] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(488), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5157] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(490), 1,
      sym_identifier,
    ACTIONS(492), 1,
      anon_sym_RBRACK,
    ACTIONS(494), 1,
      anon_sym_STAR,
    STATE(636), 1,
      sym__expression,
    STATE(1077), 1,
      sym_parameter_declaration,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1085), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5262] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(496), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5367] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(498), 1,
      anon_sym_RPAREN,
    STATE(506), 1,
      sym__expression,
    STATE(1049), 1,
      sym_variadic_argument,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5472] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(500), 1,
      anon_sym_RPAREN,
    STATE(491), 1,
      sym__expression,
    STATE(1020), 1,
      sym_variadic_argument,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5577] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(450), 1,
      anon_sym_range,
    STATE(526), 1,
      sym__expression,
    STATE(1097), 1,
      sym_expression_list,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5682] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(502), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5787] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(504), 1,
      anon_sym_RPAREN,
    STATE(493), 1,
      sym__expression,
    STATE(1039), 1,
      sym_variadic_argument,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5892] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    ACTIONS(508), 1,
      anon_sym_COLON,
    STATE(606), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(961), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [5994] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(510), 1,
      anon_sym_RBRACK,
    STATE(615), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6096] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(512), 1,
      anon_sym_SEMI,
    STATE(650), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6198] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(548), 1,
      sym__expression,
    STATE(1097), 1,
      sym_expression_list,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6300] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6402] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(516), 1,
      anon_sym_RBRACK,
    STATE(631), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6504] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(518), 1,
      anon_sym_RBRACK,
    STATE(619), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6606] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(548), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1104), 1,
      sym_expression_list,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6708] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(520), 1,
      anon_sym_RBRACK,
    STATE(601), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6810] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(464), 1,
      anon_sym_RBRACK,
    STATE(637), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [6912] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    ACTIONS(522), 1,
      anon_sym_RBRACK,
    STATE(645), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(961), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7014] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(524), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7116] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(522), 1,
      anon_sym_RBRACK,
    STATE(645), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7218] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    ACTIONS(526), 1,
      anon_sym_COLON,
    STATE(608), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(961), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7320] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(492), 1,
      anon_sym_RBRACK,
    STATE(636), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7422] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(899), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7524] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(540), 1,
      anon_sym_RBRACK,
    STATE(610), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7626] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(542), 1,
      anon_sym_RBRACK,
    STATE(597), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7728] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(544), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7830] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(526), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1188), 1,
      sym_expression_list,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [7932] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8034] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(548), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8136] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(898), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8238] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(550), 1,
      anon_sym_SEMI,
    STATE(630), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8340] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(526), 1,
      sym__expression,
    STATE(1097), 1,
      sym_expression_list,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8442] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(552), 1,
      anon_sym_RBRACK,
    STATE(598), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8544] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(554), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8646] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(556), 1,
      anon_sym_RBRACK,
    STATE(621), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8748] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(908), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8850] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(912), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [8952] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(577), 1,
      sym__expression,
    STATE(1097), 1,
      sym_expression_list,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9054] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    ACTIONS(558), 1,
      anon_sym_COLON,
    STATE(592), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(961), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9156] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(560), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9258] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    ACTIONS(562), 1,
      anon_sym_COLON,
    STATE(612), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(961), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9360] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(916), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9462] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(564), 1,
      anon_sym_RBRACK,
    STATE(588), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9564] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(566), 1,
      anon_sym_RBRACK,
    STATE(593), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9666] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9768] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9870] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(572), 1,
      anon_sym_RBRACK,
    STATE(594), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [9972] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    ACTIONS(574), 1,
      anon_sym_COLON,
    STATE(603), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(961), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10074] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(576), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10176] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(578), 1,
      anon_sym_RBRACK,
    STATE(614), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10278] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(872), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10380] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(580), 1,
      anon_sym_RBRACK,
    STATE(596), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10482] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(582), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10584] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(584), 1,
      anon_sym_RPAREN,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10686] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(902), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10788] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(904), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10890] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(539), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1148), 1,
      sym_variadic_argument,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [10992] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(906), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11094] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    ACTIONS(586), 1,
      anon_sym_COLON,
    STATE(618), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(961), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11196] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(464), 1,
      sym__expression,
    STATE(873), 1,
      sym_expression_list,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11298] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(526), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    STATE(1104), 1,
      sym_expression_list,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11400] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(486), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11499] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(624), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11598] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    STATE(294), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1204), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11697] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(582), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11796] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    ACTIONS(590), 1,
      anon_sym_chan,
    STATE(341), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11895] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(422), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [11994] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    STATE(293), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1204), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12093] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    STATE(291), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1204), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12192] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    STATE(290), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1204), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12291] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(341), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12390] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(592), 1,
      anon_sym_STAR,
    STATE(627), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1094), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12489] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(379), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12588] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(481), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12687] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(484), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12786] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(479), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12885] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(634), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [12984] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(488), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13083] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(480), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13182] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(482), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13281] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(592), 1,
      anon_sym_STAR,
    STATE(628), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1094), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13380] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    ACTIONS(590), 1,
      anon_sym_chan,
    STATE(483), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13479] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(589), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13578] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(592), 1,
      anon_sym_STAR,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13677] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(460), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13776] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(626), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13875] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(475), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [13974] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_chan,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14073] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(471), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14172] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(485), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14271] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(462), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14370] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(468), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14469] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(470), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14568] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(625), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14667] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(459), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14766] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(465), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14865] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(422), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [14964] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(620), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15063] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(477), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15162] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15261] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(616), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15360] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(592), 1,
      anon_sym_STAR,
    STATE(646), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1094), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15459] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(641), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15558] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(607), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15657] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    ACTIONS(590), 1,
      anon_sym_chan,
    STATE(474), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15756] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(483), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1246), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15855] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(647), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [15954] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(474), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16053] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(651), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16152] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(592), 1,
      anon_sym_STAR,
    STATE(639), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1094), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16251] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    STATE(296), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16350] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(629), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16449] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(420), 1,
      sym_identifier,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_func,
    ACTIONS(426), 1,
      anon_sym_STAR,
    ACTIONS(428), 1,
      anon_sym_LT_DASH,
    ACTIONS(436), 1,
      anon_sym_DQUOTE,
    STATE(483), 1,
      sym__expression,
    STATE(1140), 1,
      sym_implicit_length_array_type,
    ACTIONS(430), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(434), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(432), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(438), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1060), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(550), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16548] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(473), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16647] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(494), 1,
      anon_sym_STAR,
    ACTIONS(506), 1,
      sym_identifier,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16746] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(592), 1,
      anon_sym_STAR,
    STATE(640), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1094), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16845] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(385), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [16944] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(341), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17043] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(384), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17142] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(635), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17241] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(382), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17340] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(604), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17439] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(590), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(382), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17538] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(652), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17637] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17736] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(623), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17835] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    ACTIONS(590), 1,
      anon_sym_chan,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [17934] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18033] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(599), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18132] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    ACTIONS(592), 1,
      anon_sym_STAR,
    STATE(653), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1094), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18231] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(336), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18330] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(337), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18429] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(383), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18528] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(617), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18627] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(338), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18726] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(638), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18825] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    ACTIONS(590), 1,
      anon_sym_chan,
    STATE(296), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1204), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [18924] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(642), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19023] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(605), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19122] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19221] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(339), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19320] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(226), 1,
      sym_identifier,
    ACTIONS(230), 1,
      anon_sym_LPAREN,
    ACTIONS(232), 1,
      anon_sym_func,
    ACTIONS(234), 1,
      anon_sym_STAR,
    ACTIONS(236), 1,
      anon_sym_LT_DASH,
    ACTIONS(246), 1,
      anon_sym_DQUOTE,
    STATE(340), 1,
      sym__expression,
    STATE(1150), 1,
      sym_implicit_length_array_type,
    ACTIONS(240), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(244), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(242), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(248), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1055), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(369), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19419] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(661), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19518] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(487), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19617] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    STATE(296), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1204), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19716] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(292), 1,
      sym_identifier,
    ACTIONS(300), 1,
      anon_sym_func,
    ACTIONS(528), 1,
      anon_sym_LPAREN,
    ACTIONS(530), 1,
      anon_sym_STAR,
    ACTIONS(532), 1,
      anon_sym_LT_DASH,
    ACTIONS(538), 1,
      anon_sym_DQUOTE,
    STATE(474), 1,
      sym__expression,
    STATE(1106), 1,
      sym_implicit_length_array_type,
    ACTIONS(308), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1243), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(536), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(534), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(312), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(993), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(492), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19815] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(654), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [19914] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(590), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20013] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(591), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20112] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(590), 1,
      anon_sym_chan,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20211] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(632), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20310] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(644), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20409] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(382), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20508] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(350), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(358), 1,
      anon_sym_STAR,
    ACTIONS(364), 1,
      anon_sym_LT_DASH,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(950), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(368), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20607] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(381), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20706] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(584), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20805] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(585), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [20904] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(452), 1,
      sym_identifier,
    ACTIONS(456), 1,
      anon_sym_STAR,
    ACTIONS(458), 1,
      anon_sym_LT_DASH,
    STATE(586), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(460), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21003] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(541), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21102] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(542), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21201] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(543), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21300] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_LPAREN,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(27), 1,
      anon_sym_STAR,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(39), 1,
      anon_sym_LT_DASH,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_func,
    ACTIONS(588), 1,
      sym_identifier,
    STATE(295), 1,
      sym__expression,
    STATE(1129), 1,
      sym_implicit_length_array_type,
    ACTIONS(63), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1204), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(67), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(65), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(71), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1001), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(316), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21399] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(594), 1,
      sym_identifier,
    ACTIONS(596), 1,
      anon_sym_LPAREN,
    ACTIONS(598), 1,
      anon_sym_func,
    ACTIONS(600), 1,
      anon_sym_STAR,
    ACTIONS(602), 1,
      anon_sym_LT_DASH,
    ACTIONS(610), 1,
      anon_sym_DQUOTE,
    STATE(380), 1,
      sym__expression,
    STATE(1105), 1,
      sym_implicit_length_array_type,
    ACTIONS(604), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1245), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(608), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(606), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(612), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(1091), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(390), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21498] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(544), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21597] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(422), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21696] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_LBRACK,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(356), 1,
      anon_sym_func,
    ACTIONS(372), 1,
      anon_sym_DQUOTE,
    ACTIONS(440), 1,
      sym_identifier,
    ACTIONS(442), 1,
      anon_sym_STAR,
    ACTIONS(446), 1,
      anon_sym_LT_DASH,
    STATE(421), 1,
      sym__expression,
    STATE(1099), 1,
      sym_implicit_length_array_type,
    ACTIONS(366), 2,
      anon_sym_new,
      anon_sym_make,
    STATE(1240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(370), 3,
      sym_raw_string_literal,
      sym_imaginary_literal,
      sym_rune_literal,
    STATE(836), 4,
      sym_pointer_type,
      sym_interface_type,
      sym_channel_type,
      sym_function_type,
    ACTIONS(448), 5,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
    ACTIONS(374), 6,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
    STATE(860), 6,
      sym_generic_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_map_type,
      sym_qualified_type,
    STATE(429), 12,
      sym_parenthesized_expression,
      sym_call_expression,
      sym_selector_expression,
      sym_index_expression,
      sym_slice_expression,
      sym_type_assertion_expression,
      sym_type_conversion_expression,
      sym_composite_literal,
      sym_func_literal,
      sym_unary_expression,
      sym_binary_expression,
      sym_interpreted_string_literal,
  [21795] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(618), 1,
      anon_sym_DOT,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    STATE(285), 1,
      sym_type_arguments,
    ACTIONS(614), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(616), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [21858] = 5,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(286), 1,
      sym_comment,
    STATE(278), 1,
      sym_block,
    ACTIONS(623), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(625), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [21918] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(631), 1,
      anon_sym_DOT,
    ACTIONS(634), 1,
      anon_sym_LPAREN,
    ACTIONS(637), 1,
      anon_sym_LBRACK,
    ACTIONS(640), 1,
      anon_sym_LBRACE,
    ACTIONS(642), 1,
      anon_sym_COLON,
    STATE(306), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21988] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(631), 1,
      anon_sym_DOT,
    ACTIONS(634), 1,
      anon_sym_LPAREN,
    ACTIONS(637), 1,
      anon_sym_LBRACK,
    ACTIONS(640), 1,
      anon_sym_LBRACE,
    ACTIONS(644), 1,
      anon_sym_COLON,
    STATE(306), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22058] = 5,
    ACTIONS(276), 1,
      anon_sym_LBRACE,
    ACTIONS(286), 1,
      sym_comment,
    STATE(286), 1,
      sym_block,
    ACTIONS(646), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(648), 44,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22118] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(650), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(652), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22173] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(654), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(656), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22228] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(658), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(660), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22283] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(662), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(664), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22338] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(666), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(668), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22393] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(670), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(672), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22448] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(674), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(676), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22503] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(678), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(680), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22558] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(682), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(684), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22613] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(686), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(688), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22668] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(690), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(692), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22723] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(694), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(696), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22778] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(698), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(700), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22833] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(702), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(704), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22888] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(706), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(708), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22943] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(710), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(712), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [22998] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(716), 1,
      anon_sym_DOT,
    ACTIONS(719), 1,
      anon_sym_LPAREN,
    ACTIONS(723), 1,
      anon_sym_COMMA,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(728), 1,
      anon_sym_LBRACK,
    ACTIONS(731), 1,
      anon_sym_RBRACK,
    ACTIONS(734), 1,
      anon_sym_STAR,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    STATE(426), 1,
      sym_literal_value,
    STATE(665), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(823), 1,
      sym_type_arguments,
    STATE(1061), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(629), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
    ACTIONS(627), 13,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23091] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(745), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23146] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(747), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(749), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23201] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(751), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(753), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23256] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(755), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(757), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23311] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(759), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(761), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23366] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(763), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(765), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23421] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(767), 1,
      ts_builtin_sym_end,
    ACTIONS(771), 1,
      anon_sym_LF,
    ACTIONS(773), 1,
      anon_sym_SEMI,
    ACTIONS(769), 44,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23480] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(776), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(778), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23535] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(780), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(782), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23590] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(784), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(786), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23645] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(788), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(790), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23700] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(792), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(794), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23755] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(796), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(798), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23810] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(800), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(802), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23865] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(796), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(798), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23920] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(804), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(806), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [23975] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(808), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(810), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24030] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(812), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(814), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24085] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(816), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(818), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24140] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(796), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(798), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24195] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(820), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(822), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24250] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(824), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(826), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24305] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(828), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(830), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24360] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(832), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(834), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24415] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(836), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(838), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24470] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(840), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(842), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24525] = 19,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_LF,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_LPAREN,
    ACTIONS(852), 1,
      anon_sym_COMMA,
    ACTIONS(856), 1,
      anon_sym_LBRACK,
    ACTIONS(862), 1,
      anon_sym_LT_DASH,
    ACTIONS(864), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(866), 1,
      anon_sym_DASH_DASH,
    ACTIONS(870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(872), 1,
      anon_sym_PIPE_PIPE,
    STATE(308), 1,
      sym_argument_list,
    STATE(751), 1,
      aux_sym_expression_list_repeat1,
    STATE(1103), 1,
      sym_type_arguments,
    ACTIONS(846), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(860), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(868), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(858), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(854), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [24612] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(874), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(876), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24667] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(878), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(880), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24722] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(882), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(884), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24777] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(886), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(888), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24832] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(631), 1,
      anon_sym_DOT,
    ACTIONS(634), 1,
      anon_sym_LPAREN,
    ACTIONS(637), 1,
      anon_sym_LBRACK,
    ACTIONS(640), 1,
      anon_sym_LBRACE,
    STATE(306), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [24899] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(890), 2,
      ts_builtin_sym_end,
      anon_sym_LF,
    ACTIONS(892), 45,
      anon_sym_SEMI,
      anon_sym_package,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_type,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_LBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_int_literal,
      sym_float_literal,
      sym_imaginary_literal,
      sym_rune_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [24954] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_LPAREN,
    ACTIONS(856), 1,
      anon_sym_LBRACK,
    ACTIONS(870), 1,
      anon_sym_AMP_AMP,
    ACTIONS(894), 1,
      anon_sym_LF,
    STATE(308), 1,
      sym_argument_list,
    STATE(1103), 1,
      sym_type_arguments,
    ACTIONS(860), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(868), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(858), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(896), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
  [25026] = 11,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_LPAREN,
    ACTIONS(856), 1,
      anon_sym_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LF,
    STATE(308), 1,
      sym_argument_list,
    STATE(1103), 1,
      sym_type_arguments,
    ACTIONS(860), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(868), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(858), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(896), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_BANG,
      anon_sym_CARET,
      anon_sym_AMP,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
      sym_imaginary_literal,
      sym_rune_literal,
    ACTIONS(898), 30,
      anon_sym_package,
      anon_sym_import,
      anon_sym_const,
      anon_sym_var,
      anon_sym_func,
      anon_sym_type,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_fallthrough,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_goto,
      anon_sym_return,
      anon_sym_go,
      anon_sym_defer,
      anon_sym_if,
      anon_sym_for,
      anon_sym_switch,
      anon_sym_select,
      anon_sym_new,
      anon_sym_make,
      sym_identifier,
      sym_int_literal,
      sym_float_literal,
      sym_nil,
      sym_true,
      sym_false,
      sym_iota,
  [25150] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_LPAREN,
    ACTIONS(856), 1,
      anon_sym_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LF,
    STATE(308), 1,
      sym_argument_list,
    STATE(1103), 1,
      sym_type_arguments,
    ACTIONS(860), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(858), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(896), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25218] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_LPAREN,
    ACTIONS(856), 1,
      anon_sym_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LF,
    STATE(308), 1,
      sym_argument_list,
    STATE(1103), 1,
      sym_type_arguments,
    ACTIONS(858), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(896), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25284] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_LPAREN,
    ACTIONS(856), 1,
      anon_sym_LBRACK,
    ACTIONS(894), 1,
      anon_sym_LF,
    STATE(308), 1,
      sym_argument_list,
    STATE(1103), 1,
      sym_type_arguments,
    ACTIONS(896), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25348] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_DOT,
    ACTIONS(850), 1,
      anon_sym_LPAREN,
    ACTIONS(856), 1,
      anon_sym_LBRACK,
    ACTIONS(900), 1,
      anon_sym_LF,
    STATE(308), 1,
      sym_argument_list,
    STATE(1103), 1,
      sym_type_arguments,
    ACTIONS(902), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25412] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(844), 1,
      anon_sym_SEMI,
    ACTIONS(854), 1,
      anon_sym_EQ,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_COMMA,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    ACTIONS(916), 1,
      anon_sym_LT_DASH,
    ACTIONS(920), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(922), 1,
      anon_sym_DASH_DASH,
    ACTIONS(928), 1,
      anon_sym_AMP_AMP,
    ACTIONS(930), 1,
      anon_sym_PIPE_PIPE,
    STATE(365), 1,
      sym_argument_list,
    STATE(751), 1,
      aux_sym_expression_list_repeat1,
    STATE(911), 1,
      sym_block,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(926), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(914), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(924), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(918), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [25503] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(844), 1,
      anon_sym_SEMI,
    ACTIONS(854), 1,
      anon_sym_EQ,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_COMMA,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    ACTIONS(916), 1,
      anon_sym_LT_DASH,
    ACTIONS(920), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(922), 1,
      anon_sym_DASH_DASH,
    ACTIONS(928), 1,
      anon_sym_AMP_AMP,
    ACTIONS(930), 1,
      anon_sym_PIPE_PIPE,
    STATE(365), 1,
      sym_argument_list,
    STATE(751), 1,
      aux_sym_expression_list_repeat1,
    STATE(855), 1,
      sym_block,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(926), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(914), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(924), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(918), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [25594] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(784), 1,
      anon_sym_LF,
    ACTIONS(786), 44,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25647] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(780), 1,
      anon_sym_LF,
    ACTIONS(782), 44,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_else,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25700] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(932), 1,
      anon_sym_LPAREN,
    STATE(308), 1,
      sym_special_argument_list,
    ACTIONS(629), 42,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25757] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(934), 1,
      anon_sym_LF,
    ACTIONS(936), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25809] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(938), 1,
      anon_sym_LF,
    ACTIONS(940), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25861] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_LF,
    ACTIONS(944), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25913] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 1,
      anon_sym_LF,
    ACTIONS(745), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25965] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(946), 1,
      anon_sym_LF,
    ACTIONS(948), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26017] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_LF,
    ACTIONS(952), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26069] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(954), 1,
      anon_sym_LF,
    ACTIONS(956), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26121] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(958), 1,
      anon_sym_LF,
    ACTIONS(960), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26173] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_SEMI,
    ACTIONS(854), 1,
      anon_sym_EQ,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_COMMA,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    ACTIONS(916), 1,
      anon_sym_LT_DASH,
    ACTIONS(920), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(922), 1,
      anon_sym_DASH_DASH,
    ACTIONS(928), 1,
      anon_sym_AMP_AMP,
    ACTIONS(930), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(962), 1,
      anon_sym_DOT,
    ACTIONS(964), 1,
      anon_sym_LBRACE,
    STATE(365), 1,
      sym_argument_list,
    STATE(751), 1,
      aux_sym_expression_list_repeat1,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(926), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(914), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(924), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(918), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [26261] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_LF,
    ACTIONS(968), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26313] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_LF,
    ACTIONS(972), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26365] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(747), 1,
      anon_sym_LF,
    ACTIONS(749), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26417] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(974), 1,
      anon_sym_LF,
    ACTIONS(976), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26469] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_LF,
    ACTIONS(980), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26521] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(629), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26573] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(982), 1,
      anon_sym_LF,
    ACTIONS(984), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26625] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(986), 1,
      anon_sym_LF,
    ACTIONS(988), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26677] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(990), 1,
      anon_sym_LF,
    ACTIONS(992), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26729] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(994), 1,
      anon_sym_LF,
    ACTIONS(996), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26781] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(998), 1,
      anon_sym_LF,
    ACTIONS(1000), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26833] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1002), 1,
      anon_sym_LF,
    ACTIONS(1004), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26885] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1006), 1,
      anon_sym_LF,
    ACTIONS(1008), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26937] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_LF,
    ACTIONS(1012), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26989] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LF,
    ACTIONS(1016), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27041] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1018), 1,
      anon_sym_LF,
    ACTIONS(1020), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27093] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_LF,
    ACTIONS(1024), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27145] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_LF,
    ACTIONS(1028), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27197] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1030), 1,
      anon_sym_LF,
    ACTIONS(1032), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27249] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_LF,
    ACTIONS(1036), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27301] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1038), 1,
      anon_sym_LF,
    ACTIONS(1040), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27353] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1042), 1,
      anon_sym_LF,
    ACTIONS(1044), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27405] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1046), 1,
      anon_sym_LF,
    ACTIONS(1048), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27457] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1050), 1,
      anon_sym_LF,
    ACTIONS(1052), 43,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27509] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 1,
      anon_sym_DOT,
    ACTIONS(731), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_LBRACK,
    STATE(357), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    STATE(365), 1,
      sym_argument_list,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(896), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27631] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    STATE(365), 1,
      sym_argument_list,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(896), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27694] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    STATE(365), 1,
      sym_argument_list,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(896), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(914), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27759] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 1,
      anon_sym_EQ,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    STATE(365), 1,
      sym_argument_list,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(926), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(914), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(924), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27828] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 1,
      anon_sym_EQ,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    ACTIONS(928), 1,
      anon_sym_AMP_AMP,
    STATE(365), 1,
      sym_argument_list,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(926), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(914), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(924), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [27899] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    STATE(365), 1,
      sym_argument_list,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(902), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(900), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27960] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_LBRACE,
    ACTIONS(854), 1,
      anon_sym_EQ,
    ACTIONS(904), 1,
      anon_sym_DOT,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    ACTIONS(908), 1,
      anon_sym_COMMA,
    ACTIONS(910), 1,
      anon_sym_LBRACK,
    ACTIONS(920), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(922), 1,
      anon_sym_DASH_DASH,
    ACTIONS(928), 1,
      anon_sym_AMP_AMP,
    ACTIONS(930), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1057), 1,
      anon_sym_LT_DASH,
    STATE(365), 1,
      sym_argument_list,
    STATE(751), 1,
      aux_sym_expression_list_repeat1,
    STATE(1134), 1,
      sym_type_arguments,
    ACTIONS(926), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(914), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(924), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(912), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(918), 12,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [28045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 1,
      anon_sym_LPAREN,
    STATE(365), 1,
      sym_special_argument_list,
    ACTIONS(629), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1010), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1000), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(998), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(938), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(978), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(780), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(950), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1016), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(942), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1002), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1022), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(966), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(934), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(970), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(982), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1018), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1042), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1038), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(956), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(954), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1034), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1046), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1050), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(974), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(958), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1006), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1026), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 1,
      anon_sym_DOT,
    ACTIONS(731), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_LBRACK,
    ACTIONS(1061), 1,
      anon_sym_LBRACE,
    STATE(395), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29824] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1069), 1,
      anon_sym_EQ,
    ACTIONS(1071), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1083), 1,
      anon_sym_PIPE_PIPE,
    STATE(393), 1,
      sym_argument_list,
    STATE(1109), 1,
      sym_type_arguments,
    ACTIONS(1079), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1075), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1077), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1073), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(1067), 13,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [29892] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1109), 1,
      sym_type_arguments,
    ACTIONS(896), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29948] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1109), 1,
      sym_type_arguments,
    ACTIONS(896), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1073), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30006] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1109), 1,
      sym_type_arguments,
    ACTIONS(902), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(900), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30062] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1109), 1,
      sym_type_arguments,
    ACTIONS(896), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1075), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1073), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 19,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30122] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 1,
      anon_sym_EQ,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_LBRACK,
    STATE(393), 1,
      sym_argument_list,
    STATE(1109), 1,
      sym_type_arguments,
    ACTIONS(1079), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1075), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1077), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1073), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 15,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30186] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 1,
      anon_sym_EQ,
    ACTIONS(1063), 1,
      anon_sym_DOT,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    ACTIONS(1071), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      anon_sym_AMP_AMP,
    STATE(393), 1,
      sym_argument_list,
    STATE(1109), 1,
      sym_type_arguments,
    ACTIONS(1079), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1075), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1077), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1073), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 14,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_PIPE,
  [30252] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    STATE(393), 1,
      sym_special_argument_list,
    ACTIONS(629), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 21,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(974), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1034), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(780), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(956), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(954), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(950), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(934), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(942), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1006), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(978), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(938), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1010), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1016), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1022), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(966), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(970), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(982), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1000), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(998), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1018), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1042), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1038), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1026), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1046), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1050), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1002), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 14,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(958), 22,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31797] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(902), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(900), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31849] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(896), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1093), 1,
      anon_sym_LPAREN,
    STATE(452), 1,
      sym_special_argument_list,
    ACTIONS(629), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 23,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31946] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(716), 1,
      anon_sym_DOT,
    ACTIONS(1054), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(731), 2,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(629), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1046), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(938), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(982), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(950), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1034), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(942), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(934), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(970), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1050), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(978), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(974), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(958), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1006), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1010), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(966), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1002), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1016), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1000), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(998), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(780), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(956), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(954), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1022), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1018), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1038), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1042), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1026), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 8,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33359] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(896), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33416] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(896), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
  [33479] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(631), 1,
      anon_sym_DOT,
    ACTIONS(634), 1,
      anon_sym_LPAREN,
    ACTIONS(637), 1,
      anon_sym_LBRACK,
    ACTIONS(1111), 1,
      anon_sym_LBRACE,
    STATE(498), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33530] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(896), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33591] = 21,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_LF,
    ACTIONS(1119), 1,
      anon_sym_DOT,
    ACTIONS(1121), 1,
      anon_sym_LPAREN,
    ACTIONS(1123), 1,
      anon_sym_COMMA,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1127), 1,
      anon_sym_LBRACK,
    ACTIONS(1129), 1,
      anon_sym_STAR,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1139), 1,
      anon_sym_LT_DASH,
    ACTIONS(1141), 1,
      sym_raw_string_literal,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    STATE(656), 1,
      aux_sym_field_declaration_repeat1,
    STATE(1090), 1,
      sym_interpreted_string_literal,
    ACTIONS(1117), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(859), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [33666] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1149), 1,
      anon_sym_COMMA,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1161), 1,
      anon_sym_PIPE_PIPE,
    STATE(496), 1,
      sym_argument_list,
    STATE(820), 1,
      aux_sym_expression_list_repeat1,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(854), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1157), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [33729] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(896), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33782] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 1,
      anon_sym_EQ,
    ACTIONS(916), 1,
      anon_sym_LT_DASH,
    ACTIONS(918), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1163), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1173), 1,
      anon_sym_PIPE,
    ACTIONS(1175), 1,
      anon_sym_COLON,
    ACTIONS(1185), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1187), 1,
      anon_sym_PIPE_PIPE,
    STATE(557), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1147), 1,
      sym_type_arguments,
    ACTIONS(1179), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1183), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1177), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1181), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1171), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [33854] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LF,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1127), 1,
      anon_sym_LBRACK,
    ACTIONS(1129), 1,
      anon_sym_STAR,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1139), 1,
      anon_sym_LT_DASH,
    ACTIONS(1189), 1,
      anon_sym_LPAREN,
    STATE(806), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(321), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [33916] = 10,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(896), 13,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33968] = 18,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(1191), 1,
      anon_sym_LF,
    ACTIONS(1195), 1,
      anon_sym_LPAREN,
    ACTIONS(1197), 1,
      anon_sym_COMMA,
    ACTIONS(1199), 1,
      anon_sym_EQ,
    ACTIONS(1201), 1,
      anon_sym_LBRACK,
    ACTIONS(1203), 1,
      anon_sym_STAR,
    ACTIONS(1205), 1,
      anon_sym_LT_DASH,
    STATE(472), 1,
      aux_sym_const_spec_repeat1,
    STATE(1171), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(1193), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [34036] = 11,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1157), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(896), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34090] = 9,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(896), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34140] = 18,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(1195), 1,
      anon_sym_LPAREN,
    ACTIONS(1197), 1,
      anon_sym_COMMA,
    ACTIONS(1201), 1,
      anon_sym_LBRACK,
    ACTIONS(1203), 1,
      anon_sym_STAR,
    ACTIONS(1205), 1,
      anon_sym_LT_DASH,
    ACTIONS(1207), 1,
      anon_sym_LF,
    ACTIONS(1211), 1,
      anon_sym_EQ,
    STATE(741), 1,
      aux_sym_const_spec_repeat1,
    STATE(1175), 2,
      sym_parenthesized_type,
      sym__simple_type,
    ACTIONS(1209), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [34208] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1161), 1,
      anon_sym_PIPE_PIPE,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1069), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1157), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34266] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(900), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(902), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34314] = 8,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(896), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 1,
      anon_sym_DOT,
    ACTIONS(731), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_LBRACK,
    ACTIONS(1213), 1,
      anon_sym_LBRACE,
    STATE(558), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34412] = 12,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_LF,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_AMP_AMP,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(896), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PIPE_PIPE,
    ACTIONS(1157), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34468] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(1215), 1,
      anon_sym_LPAREN,
    STATE(496), 1,
      sym_special_argument_list,
    ACTIONS(629), 26,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34509] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1069), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1067), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_EQ,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34572] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1173), 1,
      anon_sym_PIPE,
    STATE(557), 1,
      sym_argument_list,
    STATE(1147), 1,
      sym_type_arguments,
    ACTIONS(896), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1179), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1183), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1177), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1181), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(894), 5,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1171), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34631] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    STATE(557), 1,
      sym_argument_list,
    STATE(1147), 1,
      sym_type_arguments,
    ACTIONS(896), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(894), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34678] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1173), 1,
      anon_sym_PIPE,
    ACTIONS(1185), 1,
      anon_sym_AMP_AMP,
    STATE(557), 1,
      sym_argument_list,
    STATE(1147), 1,
      sym_type_arguments,
    ACTIONS(896), 2,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(1179), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1183), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1177), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(894), 4,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1181), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1171), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34739] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    STATE(557), 1,
      sym_argument_list,
    STATE(1147), 1,
      sym_type_arguments,
    ACTIONS(902), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(900), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34786] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    STATE(557), 1,
      sym_argument_list,
    STATE(1147), 1,
      sym_type_arguments,
    ACTIONS(1179), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(896), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 12,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34837] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1161), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1219), 1,
      anon_sym_LF,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1221), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1157), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34894] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1161), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1223), 1,
      anon_sym_LF,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1225), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1157), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [34951] = 13,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1145), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_LPAREN,
    ACTIONS(1151), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1161), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1227), 1,
      anon_sym_LF,
    STATE(496), 1,
      sym_argument_list,
    STATE(1127), 1,
      sym_type_arguments,
    ACTIONS(1155), 4,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1229), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
    ACTIONS(1157), 6,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
    ACTIONS(1153), 7,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35008] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 1,
      anon_sym_DOT,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    ACTIONS(1169), 1,
      anon_sym_LBRACK,
    ACTIONS(1173), 1,
      anon_sym_PIPE,
    STATE(557), 1,
      sym_argument_list,
    STATE(1147), 1,
      sym_type_arguments,
    ACTIONS(1179), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1177), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(896), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 9,
      anon_sym_COMMA,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35063] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(934), 1,
      anon_sym_LF,
    ACTIONS(936), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35099] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1026), 1,
      anon_sym_LF,
    ACTIONS(1028), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35135] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1231), 1,
      anon_sym_RPAREN,
    ACTIONS(1233), 1,
      anon_sym_COMMA,
    ACTIONS(1235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1038), 1,
      aux_sym_argument_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35201] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(627), 1,
      anon_sym_LF,
    ACTIONS(629), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35237] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1253), 1,
      anon_sym_RPAREN,
    ACTIONS(1255), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1021), 1,
      aux_sym_argument_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35303] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(966), 1,
      anon_sym_LF,
    ACTIONS(968), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35339] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(970), 1,
      anon_sym_LF,
    ACTIONS(972), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35375] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(954), 1,
      anon_sym_LF,
    ACTIONS(956), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35411] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(982), 1,
      anon_sym_LF,
    ACTIONS(984), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35447] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(946), 1,
      anon_sym_LF,
    ACTIONS(948), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35483] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(994), 1,
      anon_sym_LF,
    ACTIONS(996), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35519] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(631), 1,
      anon_sym_DOT,
    ACTIONS(731), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35567] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(998), 1,
      anon_sym_LF,
    ACTIONS(1000), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35603] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    STATE(818), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(316), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [35661] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1018), 1,
      anon_sym_LF,
    ACTIONS(1020), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35697] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1263), 1,
      anon_sym_RPAREN,
    ACTIONS(1265), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1064), 1,
      aux_sym_argument_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35763] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1042), 1,
      anon_sym_LF,
    ACTIONS(1044), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35799] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1267), 1,
      anon_sym_RPAREN,
    ACTIONS(1269), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1037), 1,
      aux_sym_argument_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [35865] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(747), 1,
      anon_sym_LF,
    ACTIONS(749), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35901] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1046), 1,
      anon_sym_LF,
    ACTIONS(1048), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35937] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(780), 1,
      anon_sym_LF,
    ACTIONS(782), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35973] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(950), 1,
      anon_sym_LF,
    ACTIONS(952), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36009] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    ACTIONS(614), 1,
      anon_sym_COMMA,
    ACTIONS(716), 1,
      anon_sym_DOT,
    ACTIONS(1054), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(731), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(629), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 15,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36059] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1030), 1,
      anon_sym_LF,
    ACTIONS(1032), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36095] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1034), 1,
      anon_sym_LF,
    ACTIONS(1036), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36131] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1022), 1,
      anon_sym_LF,
    ACTIONS(1024), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36167] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(958), 1,
      anon_sym_LF,
    ACTIONS(960), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36203] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(974), 1,
      anon_sym_LF,
    ACTIONS(976), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36239] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1006), 1,
      anon_sym_LF,
    ACTIONS(1008), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36275] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(990), 1,
      anon_sym_LF,
    ACTIONS(992), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36311] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(614), 1,
      anon_sym_RPAREN,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(723), 1,
      anon_sym_COMMA,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1271), 1,
      anon_sym_DOT,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1275), 1,
      anon_sym_LBRACK,
    ACTIONS(1277), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(665), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(823), 1,
      sym_type_arguments,
    STATE(1061), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [36379] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1279), 1,
      anon_sym_DOT,
    ACTIONS(1283), 1,
      anon_sym_LBRACE,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1297), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36445] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1299), 1,
      anon_sym_RPAREN,
    ACTIONS(1301), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1086), 1,
      aux_sym_argument_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1303), 1,
      anon_sym_LPAREN,
    STATE(557), 1,
      sym_special_argument_list,
    ACTIONS(629), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 19,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36551] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    ACTIONS(1307), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1071), 1,
      aux_sym_argument_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36617] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1038), 1,
      anon_sym_LF,
    ACTIONS(1040), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36653] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_LF,
    ACTIONS(980), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36689] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(918), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [36753] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(986), 1,
      anon_sym_LF,
    ACTIONS(988), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36789] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(784), 1,
      anon_sym_LF,
    ACTIONS(786), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36825] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(743), 1,
      anon_sym_LF,
    ACTIONS(745), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36861] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1014), 1,
      anon_sym_LF,
    ACTIONS(1016), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36897] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1010), 1,
      anon_sym_LF,
    ACTIONS(1012), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36933] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(938), 1,
      anon_sym_LF,
    ACTIONS(940), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36969] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1050), 1,
      anon_sym_LF,
    ACTIONS(1052), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37005] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(942), 1,
      anon_sym_LF,
    ACTIONS(944), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37041] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1002), 1,
      anon_sym_LF,
    ACTIONS(1004), 27,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_case,
      anon_sym_default,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT,
      anon_sym_LT_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1038), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1020), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1018), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37147] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1311), 1,
      anon_sym_RPAREN,
    ACTIONS(1313), 1,
      anon_sym_COMMA,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1066), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37210] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1235), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1317), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37271] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    STATE(1008), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37334] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(894), 4,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PIPE_PIPE,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37391] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(894), 5,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37446] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(896), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 9,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37499] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(896), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 12,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37548] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1323), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37607] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(614), 1,
      anon_sym_RBRACK,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(723), 1,
      anon_sym_COMMA,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1275), 1,
      anon_sym_LBRACK,
    ACTIONS(1325), 1,
      anon_sym_DOT,
    STATE(665), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(823), 1,
      sym_type_arguments,
    STATE(1061), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37672] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1327), 1,
      anon_sym_RPAREN,
    ACTIONS(1329), 1,
      anon_sym_COMMA,
    STATE(1046), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [37735] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_LBRACE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1297), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1331), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1051), 1,
      aux_sym_expression_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [37798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(745), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(743), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(629), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(980), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(978), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(749), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(747), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37938] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(716), 1,
      anon_sym_DOT,
    ACTIONS(731), 1,
      anon_sym_LPAREN,
    ACTIONS(1054), 1,
      anon_sym_LBRACK,
    STATE(426), 1,
      sym_literal_value,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(629), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(627), 17,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37983] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1342), 1,
      anon_sym_LBRACE,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(447), 1,
      sym_block,
    STATE(850), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(316), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [38044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(990), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(782), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(780), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(956), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(954), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(946), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(950), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(942), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1004), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1002), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(938), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(786), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(784), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(934), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(996), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(994), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1026), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1012), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1010), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1008), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1006), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(958), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(974), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(988), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(986), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1016), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1014), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1052), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1050), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1046), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1034), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1030), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38814] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      anon_sym_SEMI,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1346), 1,
      anon_sym_DOT,
    STATE(452), 1,
      sym_argument_list,
    STATE(864), 1,
      aux_sym_expression_list_repeat1,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [38877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1042), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1024), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1022), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1000), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(998), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(966), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39017] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(896), 3,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(970), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39101] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(896), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
    ACTIONS(894), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39154] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(894), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39209] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1087), 1,
      anon_sym_DOT,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(894), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(984), 7,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_COLON,
      anon_sym_AMP,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(982), 20,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
      anon_sym_COLON_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39301] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1348), 1,
      anon_sym_RBRACK,
    ACTIONS(1350), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39361] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1352), 1,
      anon_sym_RPAREN,
    ACTIONS(1354), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39421] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1356), 1,
      anon_sym_RPAREN,
    ACTIONS(1358), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39481] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1223), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39539] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1360), 1,
      anon_sym_RBRACK,
    ACTIONS(1362), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39599] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1364), 1,
      anon_sym_RBRACK,
    ACTIONS(1366), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39659] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1368), 1,
      anon_sym_RBRACK,
    ACTIONS(1370), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39719] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1372), 1,
      anon_sym_RPAREN,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1141), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [39779] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1374), 1,
      anon_sym_RBRACK,
    ACTIONS(1376), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39839] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1378), 1,
      anon_sym_RBRACK,
    ACTIONS(1380), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39899] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1382), 1,
      anon_sym_RBRACK,
    ACTIONS(1384), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [39959] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
    ACTIONS(1388), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40019] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1390), 1,
      anon_sym_RPAREN,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1141), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40079] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1392), 1,
      anon_sym_RBRACK,
    ACTIONS(1394), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40139] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1396), 1,
      anon_sym_RPAREN,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1141), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40199] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1398), 1,
      anon_sym_RBRACK,
    ACTIONS(1400), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40259] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1402), 1,
      anon_sym_RPAREN,
    ACTIONS(1404), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40319] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1297), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(844), 1,
      sym_block,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40379] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1406), 1,
      anon_sym_RBRACK,
    ACTIONS(1408), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40439] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1410), 1,
      anon_sym_RPAREN,
    ACTIONS(1412), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40499] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1414), 1,
      anon_sym_RBRACK,
    ACTIONS(1416), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40559] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1418), 1,
      anon_sym_RPAREN,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1141), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40619] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1420), 1,
      anon_sym_RBRACK,
    ACTIONS(1422), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40679] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1424), 1,
      anon_sym_RPAREN,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1141), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40739] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1426), 1,
      anon_sym_RBRACK,
    ACTIONS(1428), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40799] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1430), 1,
      anon_sym_RPAREN,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1141), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [40859] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1432), 1,
      anon_sym_RBRACK,
    ACTIONS(1434), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40919] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1436), 1,
      anon_sym_RBRACK,
    ACTIONS(1438), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [40979] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1440), 1,
      anon_sym_RPAREN,
    ACTIONS(1442), 1,
      anon_sym_COMMA,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41039] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1067), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41097] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1444), 1,
      anon_sym_RBRACK,
    ACTIONS(1446), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41157] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1448), 1,
      anon_sym_RBRACK,
    ACTIONS(1450), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41217] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1297), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1067), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41275] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1452), 1,
      anon_sym_RBRACK,
    ACTIONS(1454), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41335] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(818), 2,
      sym_parameter_list,
      sym__simple_type,
    ACTIONS(316), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [41391] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1456), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41448] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1223), 1,
      anon_sym_LBRACE,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1297), 1,
      anon_sym_PIPE_PIPE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41505] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1458), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41562] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1460), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41619] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1462), 1,
      anon_sym_RPAREN,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41676] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1464), 1,
      anon_sym_RPAREN,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41733] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1297), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1466), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41790] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1468), 1,
      anon_sym_SEMI,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41847] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1470), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41904] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1472), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [41961] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1476), 1,
      anon_sym_COMMA,
    ACTIONS(1478), 1,
      anon_sym_EQ,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(649), 1,
      aux_sym_const_spec_repeat1,
    STATE(868), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42020] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1486), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42077] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42134] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1490), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42191] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1492), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42248] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1494), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42305] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42362] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42419] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1500), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42476] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1502), 1,
      anon_sym_COLON,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42533] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      sym_identifier,
    ACTIONS(1315), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(1141), 2,
      sym_parameter_declaration,
      sym_variadic_parameter_declaration,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42590] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1504), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42647] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1506), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42704] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1508), 1,
      anon_sym_RPAREN,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42761] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1510), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42818] = 15,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1127), 1,
      anon_sym_LBRACK,
    ACTIONS(1129), 1,
      anon_sym_STAR,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1139), 1,
      anon_sym_LT_DASH,
    ACTIONS(1189), 1,
      anon_sym_LPAREN,
    ACTIONS(1512), 1,
      anon_sym_LF,
    ACTIONS(1514), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(1047), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42875] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1476), 1,
      anon_sym_COMMA,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    ACTIONS(1516), 1,
      anon_sym_EQ,
    STATE(757), 1,
      aux_sym_const_spec_repeat1,
    STATE(856), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [42934] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1518), 1,
      anon_sym_SEMI,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [42991] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1520), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43048] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1285), 1,
      anon_sym_PIPE,
    ACTIONS(1295), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1297), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1522), 1,
      anon_sym_LBRACE,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1289), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1287), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1291), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1281), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43105] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1239), 1,
      anon_sym_PIPE,
    ACTIONS(1249), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1251), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1524), 1,
      anon_sym_RPAREN,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1243), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1247), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1241), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1245), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1237), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43162] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_DOT,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1526), 1,
      anon_sym_RBRACK,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43219] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    ACTIONS(1528), 1,
      anon_sym_LBRACE,
    STATE(561), 1,
      sym_block,
    STATE(1056), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43275] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    ACTIONS(1530), 1,
      anon_sym_COMMA,
    STATE(761), 1,
      aux_sym_field_declaration_repeat1,
    STATE(867), 1,
      sym_parenthesized_type,
    STATE(869), 1,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43333] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    ACTIONS(1532), 1,
      anon_sym_LBRACE,
    STATE(419), 1,
      sym_block,
    STATE(1087), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43389] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1534), 1,
      sym_identifier,
    ACTIONS(1536), 1,
      anon_sym_RBRACK,
    STATE(1138), 1,
      sym_parameter_declaration,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43445] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    ACTIONS(1538), 1,
      anon_sym_LBRACE,
    STATE(535), 1,
      sym_block,
    STATE(1009), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43501] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(322), 1,
      sym_block,
    STATE(1053), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43557] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_LBRACK,
    ACTIONS(1099), 1,
      anon_sym_PIPE,
    ACTIONS(1109), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1217), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1540), 1,
      anon_sym_DOT,
    STATE(452), 1,
      sym_argument_list,
    STATE(1155), 1,
      sym_type_arguments,
    ACTIONS(1103), 2,
      anon_sym_AMP,
      anon_sym_SLASH,
    ACTIONS(1107), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1101), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
    ACTIONS(1105), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1097), 5,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_AMP_CARET,
  [43611] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    ACTIONS(1542), 1,
      sym_identifier,
    STATE(322), 1,
      sym_block,
    STATE(1053), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43667] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1544), 1,
      anon_sym_LBRACE,
    STATE(247), 1,
      sym_block,
    STATE(1144), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43723] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1333), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    ACTIONS(1546), 1,
      anon_sym_LBRACE,
    STATE(353), 1,
      sym_block,
    STATE(1069), 2,
      sym_parameter_list,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43779] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1548), 1,
      anon_sym_COMMA,
    STATE(759), 1,
      aux_sym_parameter_declaration_repeat1,
    STATE(1062), 1,
      sym__simple_type,
    STATE(1063), 1,
      sym_parenthesized_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43837] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    ACTIONS(1550), 1,
      anon_sym_EQ,
    ACTIONS(1552), 1,
      anon_sym_LBRACK,
    STATE(721), 1,
      sym_type_parameter_list,
    STATE(925), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43893] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1534), 1,
      sym_identifier,
    ACTIONS(1554), 1,
      anon_sym_RBRACK,
    STATE(1138), 1,
      sym_parameter_declaration,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [43949] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1556), 1,
      anon_sym_RBRACK,
    STATE(1031), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44002] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1558), 1,
      anon_sym_type,
    STATE(1184), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44055] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1560), 1,
      anon_sym_RBRACK,
    STATE(1031), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44108] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1534), 1,
      sym_identifier,
    STATE(1077), 1,
      sym_parameter_declaration,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44161] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1562), 1,
      anon_sym_type,
    STATE(1184), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44214] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1564), 1,
      anon_sym_type,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44267] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1566), 1,
      anon_sym_RBRACK,
    STATE(1031), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44320] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1568), 1,
      anon_sym_type,
    STATE(1184), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44373] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1570), 1,
      anon_sym_RBRACK,
    STATE(1031), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44426] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1572), 1,
      anon_sym_RBRACK,
    STATE(1031), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44479] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1534), 1,
      sym_identifier,
    STATE(1138), 1,
      sym_parameter_declaration,
    STATE(1065), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44532] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1574), 1,
      anon_sym_RBRACK,
    STATE(1031), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44585] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(833), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44635] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1014), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44685] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(831), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44735] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1582), 1,
      anon_sym_LT_DASH,
    STATE(249), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44785] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1199), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44835] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1582), 1,
      anon_sym_LT_DASH,
    STATE(244), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44885] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1582), 1,
      anon_sym_LT_DASH,
    STATE(287), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44935] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1201), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [44985] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1582), 1,
      anon_sym_LT_DASH,
    STATE(271), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45035] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1185), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45085] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    STATE(269), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45135] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(590), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(829), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45185] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1586), 1,
      anon_sym_LT_DASH,
    STATE(827), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45235] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(997), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45285] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1035), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45335] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(824), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45385] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(999), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45435] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1588), 1,
      anon_sym_LT_DASH,
    STATE(798), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45485] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(808), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45535] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(794), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45585] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1233), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45635] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1153), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45685] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(789), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45735] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(831), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45785] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1590), 1,
      anon_sym_chan,
    STATE(829), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45835] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1592), 1,
      anon_sym_LT_DASH,
    STATE(827), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45885] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1582), 1,
      anon_sym_LT_DASH,
    ACTIONS(1594), 1,
      anon_sym_chan,
    STATE(276), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45935] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(803), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [45985] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1582), 1,
      anon_sym_LT_DASH,
    STATE(240), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46035] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1135), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46085] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(262), 1,
      sym_identifier,
    ACTIONS(268), 1,
      anon_sym_func,
    ACTIONS(274), 1,
      anon_sym_struct,
    ACTIONS(278), 1,
      anon_sym_interface,
    ACTIONS(280), 1,
      anon_sym_map,
    ACTIONS(282), 1,
      anon_sym_chan,
    ACTIONS(1576), 1,
      anon_sym_LPAREN,
    ACTIONS(1578), 1,
      anon_sym_LBRACK,
    ACTIONS(1580), 1,
      anon_sym_STAR,
    ACTIONS(1584), 1,
      anon_sym_LT_DASH,
    STATE(277), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(260), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46135] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1166), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46185] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1054), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46235] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1592), 1,
      anon_sym_LT_DASH,
    STATE(819), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46285] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(808), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46335] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1162), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46385] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1223), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46435] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1177), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46485] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1344), 1,
      anon_sym_LT_DASH,
    STATE(813), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46535] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(886), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46585] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(790), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46635] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(884), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46685] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1044), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46735] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1210), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46785] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1092), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46835] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    STATE(787), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46885] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(35), 1,
      anon_sym_map,
    ACTIONS(37), 1,
      anon_sym_chan,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    ACTIONS(1336), 1,
      anon_sym_func,
    ACTIONS(1338), 1,
      anon_sym_LBRACK,
    ACTIONS(1340), 1,
      anon_sym_STAR,
    ACTIONS(1586), 1,
      anon_sym_LT_DASH,
    STATE(819), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46935] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1484), 1,
      anon_sym_LT_DASH,
    ACTIONS(1596), 1,
      anon_sym_chan,
    STATE(786), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [46985] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1043), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47035] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1113), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      anon_sym_func,
    ACTIONS(1131), 1,
      anon_sym_struct,
    ACTIONS(1133), 1,
      anon_sym_interface,
    ACTIONS(1135), 1,
      anon_sym_map,
    ACTIONS(1137), 1,
      anon_sym_chan,
    ACTIONS(1474), 1,
      anon_sym_LPAREN,
    ACTIONS(1480), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_STAR,
    ACTIONS(1588), 1,
      anon_sym_LT_DASH,
    STATE(785), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(804), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47085] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(813), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47135] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1031), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47185] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1184), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47235] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1196), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47285] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1230), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47335] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(833), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47385] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1192), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47435] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1070), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47485] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1013), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47535] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(1172), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47585] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_struct,
    ACTIONS(33), 1,
      anon_sym_interface,
    ACTIONS(714), 1,
      sym_identifier,
    ACTIONS(726), 1,
      anon_sym_func,
    ACTIONS(737), 1,
      anon_sym_map,
    ACTIONS(739), 1,
      anon_sym_chan,
    ACTIONS(741), 1,
      anon_sym_LT_DASH,
    ACTIONS(1259), 1,
      anon_sym_LBRACK,
    ACTIONS(1261), 1,
      anon_sym_STAR,
    ACTIONS(1273), 1,
      anon_sym_LPAREN,
    STATE(824), 2,
      sym_parenthesized_type,
      sym__simple_type,
    STATE(836), 10,
      sym_generic_type,
      sym_pointer_type,
      sym_array_type,
      sym_slice_type,
      sym_struct_type,
      sym_interface_type,
      sym_map_type,
      sym_channel_type,
      sym_function_type,
      sym_qualified_type,
  [47635] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1600), 1,
      anon_sym_LF,
    ACTIONS(1602), 1,
      anon_sym_COMMA,
    STATE(741), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1598), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [47665] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(662), 1,
      anon_sym_LF,
    ACTIONS(664), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [47691] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_LF,
    ACTIONS(672), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [47717] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_LF,
    ACTIONS(818), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [47743] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(808), 1,
      anon_sym_LF,
    ACTIONS(810), 17,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [47769] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1600), 1,
      anon_sym_LF,
    ACTIONS(1598), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_func,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_struct,
      anon_sym_RBRACE,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      anon_sym_LT_DASH,
      anon_sym_case,
      anon_sym_default,
      sym_identifier,
  [47794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(664), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(662), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [47818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(672), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(670), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [47842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(808), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [47866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(816), 10,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LT_DASH,
      anon_sym_COLON,
  [47890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(908), 1,
      anon_sym_COMMA,
    STATE(752), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1605), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [47915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      anon_sym_COMMA,
    STATE(752), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1067), 13,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [47940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1610), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [47961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 1,
      anon_sym_EQ,
    ACTIONS(1616), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1610), 11,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [47984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1610), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1620), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48026] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1624), 1,
      anon_sym_COMMA,
    STATE(757), 1,
      aux_sym_const_spec_repeat1,
    ACTIONS(1600), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1598), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1627), 12,
      anon_sym_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_CARET_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
  [48072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_COMMA,
    STATE(759), 1,
      aux_sym_parameter_declaration_repeat1,
    ACTIONS(1633), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1631), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
    ACTIONS(1600), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
  [48116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 1,
      anon_sym_COMMA,
    STATE(761), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(1640), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1638), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48140] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(614), 1,
      anon_sym_LF,
    ACTIONS(1119), 1,
      anon_sym_DOT,
    ACTIONS(1645), 1,
      anon_sym_LBRACK,
    STATE(797), 1,
      sym_type_arguments,
    ACTIONS(616), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1647), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1651), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1655), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 1,
      anon_sym_DOT,
    ACTIONS(1659), 1,
      anon_sym_LBRACK,
    STATE(823), 1,
      sym_type_arguments,
    ACTIONS(614), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [48243] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 1,
      sym_identifier,
    ACTIONS(1663), 1,
      anon_sym_DOT,
    ACTIONS(1665), 1,
      sym_blank_identifier,
    ACTIONS(1667), 1,
      anon_sym_LPAREN,
    ACTIONS(1669), 1,
      sym_raw_string_literal,
    ACTIONS(1671), 1,
      anon_sym_DQUOTE,
    STATE(272), 1,
      sym_interpreted_string_literal,
    STATE(1016), 1,
      sym_dot,
    STATE(270), 2,
      sym_import_spec,
      sym_import_spec_list,
  [48275] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(1663), 1,
      anon_sym_DOT,
    ACTIONS(1673), 1,
      sym_identifier,
    ACTIONS(1675), 1,
      sym_blank_identifier,
    ACTIONS(1677), 1,
      anon_sym_RPAREN,
    ACTIONS(1679), 1,
      sym_raw_string_literal,
    STATE(772), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1089), 1,
      sym_dot,
    STATE(1102), 1,
      sym_import_spec,
    STATE(1120), 1,
      sym_interpreted_string_literal,
  [48309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1681), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48327] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(1663), 1,
      anon_sym_DOT,
    ACTIONS(1673), 1,
      sym_identifier,
    ACTIONS(1675), 1,
      sym_blank_identifier,
    ACTIONS(1679), 1,
      sym_raw_string_literal,
    ACTIONS(1685), 1,
      anon_sym_RPAREN,
    STATE(768), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1089), 1,
      sym_dot,
    STATE(1102), 1,
      sym_import_spec,
    STATE(1120), 1,
      sym_interpreted_string_literal,
  [48361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_LT_DASH,
    ACTIONS(1687), 6,
      anon_sym_func,
      anon_sym_struct,
      anon_sym_interface,
      anon_sym_map,
      anon_sym_chan,
      sym_identifier,
  [48379] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1691), 1,
      sym_identifier,
    ACTIONS(1694), 1,
      anon_sym_DOT,
    ACTIONS(1697), 1,
      sym_blank_identifier,
    ACTIONS(1700), 1,
      anon_sym_RPAREN,
    ACTIONS(1702), 1,
      sym_raw_string_literal,
    ACTIONS(1705), 1,
      anon_sym_DQUOTE,
    STATE(772), 1,
      aux_sym_import_spec_list_repeat1,
    STATE(1089), 1,
      sym_dot,
    STATE(1102), 1,
      sym_import_spec,
    STATE(1120), 1,
      sym_interpreted_string_literal,
  [48413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1710), 1,
      anon_sym_RBRACE,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(1045), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48438] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1714), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(1045), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1716), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(1045), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48488] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1718), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(955), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1720), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(1045), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1722), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(951), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48563] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1724), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(945), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48588] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1726), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(1045), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48613] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(1728), 1,
      anon_sym_RBRACE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(1045), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48638] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_LF,
    ACTIONS(712), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48654] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(702), 1,
      anon_sym_LF,
    ACTIONS(704), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48670] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_LF,
    ACTIONS(656), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48686] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(796), 1,
      anon_sym_LF,
    ACTIONS(798), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48702] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(796), 1,
      anon_sym_LF,
    ACTIONS(798), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48718] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(650), 1,
      anon_sym_LF,
    ACTIONS(652), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48734] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(836), 1,
      anon_sym_LF,
    ACTIONS(838), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48750] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(886), 1,
      anon_sym_LF,
    ACTIONS(888), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48766] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(686), 1,
      anon_sym_LF,
    ACTIONS(688), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48782] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(682), 1,
      anon_sym_LF,
    ACTIONS(684), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48798] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(792), 1,
      anon_sym_LF,
    ACTIONS(794), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48814] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1708), 1,
      sym_identifier,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    STATE(915), 1,
      sym_constraint_term,
    STATE(1019), 1,
      sym_qualified_type,
    STATE(1045), 4,
      sym__interface_body,
      sym_interface_type_name,
      sym_constraint_elem,
      sym_method_spec,
  [48836] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_LF,
    ACTIONS(668), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48852] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(812), 1,
      anon_sym_LF,
    ACTIONS(814), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48868] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_LF,
    ACTIONS(753), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48884] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(878), 1,
      anon_sym_LF,
    ACTIONS(880), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48900] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(820), 1,
      anon_sym_LF,
    ACTIONS(822), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48916] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(690), 1,
      anon_sym_LF,
    ACTIONS(692), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48932] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(763), 1,
      anon_sym_LF,
    ACTIONS(765), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48948] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(706), 1,
      anon_sym_LF,
    ACTIONS(708), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48964] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(788), 1,
      anon_sym_LF,
    ACTIONS(790), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48980] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(796), 1,
      anon_sym_LF,
    ACTIONS(798), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [48996] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LF,
    ACTIONS(757), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49012] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_LF,
    ACTIONS(834), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49028] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_LF,
    ACTIONS(876), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49044] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(776), 1,
      anon_sym_LF,
    ACTIONS(778), 7,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(792), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(690), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(812), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(686), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49138] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_DOT,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    ACTIONS(1730), 1,
      anon_sym_LF,
    ACTIONS(1734), 1,
      sym_raw_string_literal,
    STATE(1058), 1,
      sym_interpreted_string_literal,
    ACTIONS(1732), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49161] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_LF,
    ACTIONS(1736), 1,
      anon_sym_COMMA,
    STATE(815), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1069), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(776), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49232] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1149), 1,
      anon_sym_COMMA,
    ACTIONS(1605), 1,
      anon_sym_LF,
    STATE(815), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1739), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(702), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(878), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(886), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49303] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(788), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(796), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(796), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(763), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(650), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49394] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(796), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49420] = 7,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_DOT,
    ACTIONS(1189), 1,
      anon_sym_LPAREN,
    ACTIONS(1741), 1,
      anon_sym_LF,
    ACTIONS(1745), 1,
      anon_sym_PIPE,
    STATE(648), 1,
      sym_parameter_list,
    ACTIONS(1743), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49443] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(706), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON,
  [49469] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1747), 1,
      anon_sym_RBRACE,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    STATE(863), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49487] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1753), 1,
      anon_sym_LF,
    ACTIONS(1755), 1,
      anon_sym_SEMI,
    STATE(845), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1757), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1759), 1,
      anon_sym_RBRACE,
    ACTIONS(1761), 1,
      anon_sym_case,
    STATE(851), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [49523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1763), 2,
      sym_blank_identifier,
      sym_identifier,
    ACTIONS(1700), 4,
      anon_sym_DOT,
      anon_sym_RPAREN,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [49537] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1765), 1,
      sym_identifier,
    ACTIONS(1767), 1,
      anon_sym_LF,
    ACTIONS(1769), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1771), 1,
      anon_sym_RBRACE,
    ACTIONS(1773), 1,
      anon_sym_case,
    ACTIONS(1776), 1,
      anon_sym_default,
    STATE(842), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [49571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1779), 1,
      anon_sym_RBRACE,
    STATE(853), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49589] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1781), 1,
      anon_sym_LF,
    ACTIONS(1785), 1,
      anon_sym_else,
    ACTIONS(1783), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49605] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1787), 1,
      anon_sym_LF,
    ACTIONS(1789), 1,
      anon_sym_SEMI,
    STATE(866), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(206), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1791), 1,
      anon_sym_RBRACE,
    STATE(853), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49641] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    ACTIONS(1793), 1,
      anon_sym_LF,
    ACTIONS(1797), 1,
      sym_raw_string_literal,
    STATE(1093), 1,
      sym_interpreted_string_literal,
    ACTIONS(1795), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1799), 1,
      anon_sym_RBRACE,
    ACTIONS(1801), 1,
      anon_sym_case,
    STATE(870), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [49679] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1803), 1,
      sym_identifier,
    ACTIONS(1805), 1,
      anon_sym_LF,
    ACTIONS(1807), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1342), 1,
      anon_sym_LBRACE,
    STATE(442), 1,
      sym_block,
    ACTIONS(874), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [49711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1761), 1,
      anon_sym_case,
    ACTIONS(1809), 1,
      anon_sym_RBRACE,
    STATE(842), 3,
      sym_default_case,
      sym_communication_case,
      aux_sym_select_statement_repeat1,
  [49729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1811), 1,
      anon_sym_RBRACE,
    STATE(865), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1813), 1,
      anon_sym_RBRACE,
    ACTIONS(1815), 1,
      anon_sym_case,
    ACTIONS(1818), 1,
      anon_sym_default,
    STATE(853), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1821), 1,
      anon_sym_RBRACE,
    STATE(846), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49783] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_LF,
    ACTIONS(1827), 1,
      anon_sym_else,
    ACTIONS(1825), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49799] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LF,
    ACTIONS(1833), 1,
      anon_sym_EQ,
    ACTIONS(1831), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [49815] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(614), 1,
      anon_sym_LBRACE,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    ACTIONS(1325), 1,
      anon_sym_DOT,
    ACTIONS(1659), 1,
      anon_sym_LBRACK,
    STATE(663), 1,
      sym_parameter_list,
    STATE(823), 1,
      sym_type_arguments,
  [49837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1801), 1,
      anon_sym_case,
    ACTIONS(1835), 1,
      anon_sym_RBRACE,
    STATE(848), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [49855] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    ACTIONS(1837), 1,
      anon_sym_LF,
    ACTIONS(1841), 1,
      sym_raw_string_literal,
    STATE(1083), 1,
      sym_interpreted_string_literal,
    ACTIONS(1839), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    STATE(430), 1,
      sym_literal_value,
    ACTIONS(755), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [49891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1843), 1,
      anon_sym_RBRACE,
    STATE(843), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49909] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    ACTIONS(1845), 1,
      anon_sym_LF,
    ACTIONS(1849), 1,
      sym_raw_string_literal,
    STATE(1057), 1,
      sym_interpreted_string_literal,
    ACTIONS(1847), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [49929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1851), 1,
      anon_sym_RBRACE,
    STATE(853), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1739), 1,
      anon_sym_COLON,
    STATE(871), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1605), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [49965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1749), 1,
      anon_sym_case,
    ACTIONS(1751), 1,
      anon_sym_default,
    ACTIONS(1853), 1,
      anon_sym_RBRACE,
    STATE(853), 3,
      sym_expression_case,
      sym_default_case,
      aux_sym_expression_switch_statement_repeat1,
  [49983] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1855), 1,
      anon_sym_LF,
    ACTIONS(1858), 1,
      anon_sym_SEMI,
    STATE(866), 1,
      aux_sym__statement_list_repeat1,
    ACTIONS(1861), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50001] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    ACTIONS(1863), 1,
      anon_sym_LF,
    ACTIONS(1867), 1,
      sym_raw_string_literal,
    STATE(1011), 1,
      sym_interpreted_string_literal,
    ACTIONS(1865), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50021] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1869), 1,
      anon_sym_LF,
    ACTIONS(1873), 1,
      anon_sym_EQ,
    ACTIONS(1871), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50037] = 6,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DQUOTE,
    ACTIONS(1863), 1,
      anon_sym_LF,
    ACTIONS(1875), 1,
      sym_raw_string_literal,
    STATE(1006), 1,
      sym_interpreted_string_literal,
    ACTIONS(1865), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 1,
      anon_sym_RBRACE,
    ACTIONS(1879), 1,
      anon_sym_case,
    ACTIONS(1882), 1,
      anon_sym_default,
    STATE(870), 3,
      sym_default_case,
      sym_type_case,
      aux_sym_type_switch_statement_repeat1,
  [50075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1069), 1,
      anon_sym_COLON,
    ACTIONS(1885), 1,
      anon_sym_COMMA,
    STATE(871), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1067), 3,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [50093] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1888), 1,
      anon_sym_LF,
    ACTIONS(1890), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50106] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1892), 1,
      anon_sym_LF,
    ACTIONS(1894), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50119] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1896), 1,
      anon_sym_LF,
    ACTIONS(1900), 1,
      anon_sym_PIPE,
    STATE(880), 1,
      aux_sym_constraint_elem_repeat1,
    ACTIONS(1898), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50136] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LF,
    ACTIONS(1904), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50149] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1906), 1,
      anon_sym_LF,
    ACTIONS(1908), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50162] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(1914), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(960), 1,
      sym_field_declaration,
  [50181] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1916), 1,
      anon_sym_LF,
    ACTIONS(1918), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50194] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1920), 1,
      anon_sym_LF,
    ACTIONS(1861), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50207] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1922), 1,
      anon_sym_LF,
    ACTIONS(1926), 1,
      anon_sym_PIPE,
    STATE(880), 1,
      aux_sym_constraint_elem_repeat1,
    ACTIONS(1924), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50224] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1929), 1,
      anon_sym_LF,
    ACTIONS(1931), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50237] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(1933), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(1050), 1,
      sym_field_declaration,
  [50256] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1935), 1,
      anon_sym_LF,
    ACTIONS(1937), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50269] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1939), 1,
      anon_sym_LF,
    ACTIONS(1941), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50282] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      sym_identifier,
    ACTIONS(1945), 1,
      anon_sym_RPAREN,
    STATE(918), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1158), 2,
      sym_type_alias,
      sym_type_spec,
  [50299] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1947), 1,
      anon_sym_LF,
    ACTIONS(1949), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      sym_identifier,
    ACTIONS(1954), 1,
      anon_sym_RPAREN,
    STATE(887), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1158), 2,
      sym_type_alias,
      sym_type_spec,
  [50329] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1956), 1,
      anon_sym_LF,
    ACTIONS(1958), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50342] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1960), 1,
      anon_sym_LF,
    ACTIONS(1962), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50355] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1964), 1,
      anon_sym_LF,
    ACTIONS(1966), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50368] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1968), 1,
      anon_sym_LF,
    ACTIONS(1970), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50381] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1972), 1,
      anon_sym_LF,
    ACTIONS(1974), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50394] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_LF,
    ACTIONS(1978), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50407] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1980), 1,
      anon_sym_LF,
    ACTIONS(1982), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50420] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_LF,
    ACTIONS(1986), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50433] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(1988), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(947), 1,
      sym_field_declaration,
  [50452] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1990), 1,
      anon_sym_LF,
    ACTIONS(1992), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50465] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1994), 1,
      anon_sym_LF,
    ACTIONS(1996), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50478] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1998), 1,
      anon_sym_LF,
    ACTIONS(2000), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50491] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2002), 1,
      anon_sym_LF,
    ACTIONS(2004), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50504] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2006), 1,
      anon_sym_LF,
    ACTIONS(2008), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50517] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2010), 1,
      anon_sym_LF,
    ACTIONS(2012), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50530] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2014), 1,
      anon_sym_LF,
    ACTIONS(2016), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50543] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2018), 1,
      anon_sym_LF,
    ACTIONS(2020), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(2022), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(1050), 1,
      sym_field_declaration,
  [50575] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2024), 1,
      anon_sym_LF,
    ACTIONS(2026), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(2028), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(1050), 1,
      sym_field_declaration,
  [50607] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2030), 1,
      anon_sym_LF,
    ACTIONS(2032), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50620] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2034), 1,
      anon_sym_LF,
    ACTIONS(2036), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50633] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2038), 1,
      anon_sym_LF,
    ACTIONS(2040), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50646] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2042), 1,
      anon_sym_LF,
    ACTIONS(2044), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50659] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_LF,
    ACTIONS(2048), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50672] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2050), 1,
      anon_sym_LF,
    ACTIONS(2052), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50685] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_LF,
    ACTIONS(846), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50698] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1900), 1,
      anon_sym_PIPE,
    ACTIONS(2054), 1,
      anon_sym_LF,
    STATE(874), 1,
      aux_sym_constraint_elem_repeat1,
    ACTIONS(2056), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [50715] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2058), 1,
      anon_sym_LF,
    ACTIONS(2060), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50728] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2062), 1,
      anon_sym_LF,
    ACTIONS(2064), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      sym_identifier,
    ACTIONS(2066), 1,
      anon_sym_RPAREN,
    STATE(887), 1,
      aux_sym_type_declaration_repeat1,
    STATE(1158), 2,
      sym_type_alias,
      sym_type_spec,
  [50758] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2068), 1,
      anon_sym_LF,
    ACTIONS(2070), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50771] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(2072), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(1050), 1,
      sym_field_declaration,
  [50790] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2074), 1,
      anon_sym_LF,
    ACTIONS(2076), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50803] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_LF,
    ACTIONS(2080), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50816] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(2082), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(1050), 1,
      sym_field_declaration,
  [50835] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2084), 1,
      anon_sym_LF,
    ACTIONS(2086), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50848] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_LF,
    ACTIONS(2090), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50861] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2092), 1,
      anon_sym_LF,
    ACTIONS(2094), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(2096), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(1050), 1,
      sym_field_declaration,
  [50893] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2098), 1,
      anon_sym_LF,
    ACTIONS(2100), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50906] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2102), 1,
      anon_sym_LF,
    ACTIONS(2104), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50919] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2106), 1,
      anon_sym_LF,
    ACTIONS(2108), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50932] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2110), 1,
      anon_sym_LF,
    ACTIONS(2112), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    ACTIONS(2114), 1,
      anon_sym_RBRACE,
    STATE(847), 1,
      sym_qualified_type,
    STATE(937), 1,
      sym_field_declaration,
  [50964] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2116), 1,
      anon_sym_LF,
    ACTIONS(2118), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50977] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2120), 1,
      anon_sym_LF,
    ACTIONS(2122), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [50990] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2124), 1,
      anon_sym_LF,
    ACTIONS(2126), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51003] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2128), 1,
      anon_sym_LF,
    ACTIONS(2130), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51016] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2132), 1,
      anon_sym_LF,
    ACTIONS(2134), 1,
      anon_sym_SEMI,
    ACTIONS(2136), 1,
      anon_sym_RBRACE,
    STATE(977), 1,
      aux_sym_field_declaration_list_repeat1,
  [51032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2138), 1,
      sym_identifier,
    ACTIONS(2141), 1,
      anon_sym_RPAREN,
    STATE(938), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1118), 1,
      sym_var_spec,
  [51048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 1,
      anon_sym_COMMA,
    ACTIONS(2145), 1,
      anon_sym_RBRACE,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    STATE(1074), 1,
      aux_sym_literal_value_repeat1,
  [51064] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2149), 1,
      anon_sym_LF,
    ACTIONS(2151), 1,
      anon_sym_SEMI,
    ACTIONS(2153), 1,
      anon_sym_RBRACE,
    STATE(982), 1,
      aux_sym_interface_type_repeat1,
  [51080] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2155), 1,
      anon_sym_LF,
    ACTIONS(2157), 1,
      anon_sym_SEMI,
    ACTIONS(2159), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      aux_sym_field_declaration_list_repeat1,
  [51096] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2161), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2163), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51110] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_LF,
    ACTIONS(2167), 1,
      anon_sym_SEMI,
    ACTIONS(2169), 1,
      anon_sym_RBRACE,
    STATE(982), 1,
      aux_sym_interface_type_repeat1,
  [51126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2171), 1,
      anon_sym_COMMA,
    ACTIONS(2173), 1,
      anon_sym_RBRACE,
    STATE(1025), 1,
      aux_sym_literal_value_repeat1,
  [51142] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_LF,
    ACTIONS(2177), 1,
      anon_sym_SEMI,
    ACTIONS(2179), 1,
      anon_sym_RBRACE,
    STATE(943), 1,
      aux_sym_interface_type_repeat1,
  [51158] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_LF,
    ACTIONS(2183), 1,
      anon_sym_SEMI,
    ACTIONS(2185), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      aux_sym_field_declaration_list_repeat1,
  [51174] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_LF,
    ACTIONS(2189), 1,
      anon_sym_SEMI,
    ACTIONS(2191), 1,
      anon_sym_RBRACE,
    STATE(941), 1,
      aux_sym_field_declaration_list_repeat1,
  [51190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(2193), 1,
      anon_sym_if,
    STATE(924), 2,
      sym_block,
      sym_if_statement,
  [51204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      sym_identifier,
    ACTIONS(2198), 1,
      anon_sym_RPAREN,
    STATE(949), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1098), 1,
      sym_const_spec,
  [51220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(650), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [51230] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2200), 1,
      anon_sym_LF,
    ACTIONS(2202), 1,
      anon_sym_SEMI,
    ACTIONS(2204), 1,
      anon_sym_RBRACE,
    STATE(987), 1,
      aux_sym_interface_type_repeat1,
  [51246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1910), 1,
      sym_identifier,
    ACTIONS(1912), 1,
      anon_sym_STAR,
    STATE(847), 1,
      sym_qualified_type,
    STATE(1050), 1,
      sym_field_declaration,
  [51262] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2206), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2163), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2208), 1,
      anon_sym_COMMA,
    ACTIONS(2210), 1,
      anon_sym_RBRACE,
    STATE(1034), 1,
      aux_sym_literal_value_repeat1,
  [51292] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2212), 1,
      anon_sym_LF,
    ACTIONS(2214), 1,
      anon_sym_SEMI,
    ACTIONS(2216), 1,
      anon_sym_RBRACE,
    STATE(940), 1,
      aux_sym_interface_type_repeat1,
  [51308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(2193), 1,
      anon_sym_if,
    STATE(919), 2,
      sym_block,
      sym_if_statement,
  [51322] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2218), 1,
      anon_sym_DQUOTE,
    STATE(968), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2220), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2222), 1,
      anon_sym_COMMA,
    ACTIONS(2224), 1,
      anon_sym_RBRACE,
    STATE(1041), 1,
      aux_sym_literal_value_repeat1,
  [51352] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2226), 1,
      anon_sym_DQUOTE,
    STATE(953), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2228), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51366] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_LF,
    ACTIONS(2232), 1,
      anon_sym_SEMI,
    ACTIONS(2234), 1,
      anon_sym_RBRACE,
    STATE(946), 1,
      aux_sym_field_declaration_list_repeat1,
  [51382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LPAREN,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2240), 1,
      anon_sym_RBRACK,
    STATE(1072), 1,
      aux_sym_type_arguments_repeat1,
  [51398] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2242), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2163), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51412] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2244), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2163), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51426] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2246), 1,
      anon_sym_DQUOTE,
    STATE(963), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2248), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      sym_identifier,
    ACTIONS(2252), 1,
      anon_sym_RPAREN,
    STATE(975), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1098), 1,
      sym_const_spec,
  [51456] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2254), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2256), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      sym_identifier,
    ACTIONS(2261), 1,
      anon_sym_RPAREN,
    STATE(974), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1118), 1,
      sym_var_spec,
  [51486] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2163), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2265), 1,
      anon_sym_COMMA,
    ACTIONS(2267), 1,
      anon_sym_RBRACE,
    STATE(1067), 1,
      aux_sym_literal_value_repeat1,
  [51516] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2269), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2163), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym_COMMA,
    STATE(971), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(2274), 2,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [51544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_LPAREN,
    ACTIONS(2278), 1,
      anon_sym_LBRACK,
    STATE(28), 1,
      sym_parameter_list,
    STATE(1139), 1,
      sym_type_parameter_list,
  [51560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2280), 1,
      anon_sym_COMMA,
    ACTIONS(2282), 1,
      anon_sym_RBRACE,
    STATE(1082), 1,
      aux_sym_literal_value_repeat1,
  [51576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      sym_identifier,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
    STATE(938), 1,
      aux_sym_var_declaration_repeat1,
    STATE(1118), 1,
      sym_var_spec,
  [51592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      sym_identifier,
    ACTIONS(2286), 1,
      anon_sym_RPAREN,
    STATE(949), 1,
      aux_sym_const_declaration_repeat1,
    STATE(1098), 1,
      sym_const_spec,
  [51608] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2288), 1,
      anon_sym_DQUOTE,
    STATE(962), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2290), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51622] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2292), 1,
      anon_sym_LF,
    ACTIONS(2294), 1,
      anon_sym_SEMI,
    ACTIONS(2296), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      aux_sym_field_declaration_list_repeat1,
  [51638] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2298), 1,
      anon_sym_DQUOTE,
    STATE(984), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2300), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51652] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(1922), 1,
      anon_sym_LF,
    ACTIONS(1924), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [51664] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2302), 1,
      anon_sym_LF,
    ACTIONS(1745), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [51676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1943), 1,
      sym_identifier,
    ACTIONS(2304), 1,
      anon_sym_LPAREN,
    STATE(878), 2,
      sym_type_alias,
      sym_type_spec,
  [51690] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2306), 1,
      anon_sym_LF,
    ACTIONS(2309), 1,
      anon_sym_SEMI,
    ACTIONS(2312), 1,
      anon_sym_RBRACE,
    STATE(982), 1,
      aux_sym_interface_type_repeat1,
  [51706] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2314), 1,
      anon_sym_DQUOTE,
    STATE(970), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2316), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51720] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_DQUOTE,
    STATE(966), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2163), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51734] = 4,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2320), 1,
      anon_sym_DQUOTE,
    STATE(942), 1,
      aux_sym_interpreted_string_literal_repeat1,
    ACTIONS(2322), 2,
      sym__interpreted_string_literal_basic_content,
      sym_escape_sequence,
  [51748] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2324), 1,
      anon_sym_LF,
    ACTIONS(2326), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_PIPE,
  [51760] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2328), 1,
      anon_sym_LF,
    ACTIONS(2330), 1,
      anon_sym_SEMI,
    ACTIONS(2332), 1,
      anon_sym_RBRACE,
    STATE(982), 1,
      aux_sym_interface_type_repeat1,
  [51776] = 5,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_LF,
    ACTIONS(2337), 1,
      anon_sym_SEMI,
    ACTIONS(2340), 1,
      anon_sym_RBRACE,
    STATE(988), 1,
      aux_sym_field_declaration_list_repeat1,
  [51792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 1,
      anon_sym_RPAREN,
    ACTIONS(2344), 1,
      anon_sym_COMMA,
    STATE(989), 1,
      aux_sym_parameter_list_repeat1,
  [51805] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1712), 1,
      anon_sym_TILDE,
    ACTIONS(2347), 1,
      sym_identifier,
    STATE(979), 1,
      sym_constraint_term,
  [51818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      sym_identifier,
    ACTIONS(2349), 1,
      anon_sym_LPAREN,
    STATE(903), 1,
      sym_const_spec,
  [51831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      sym_identifier,
    ACTIONS(2351), 1,
      anon_sym_LPAREN,
    STATE(900), 1,
      sym_var_spec,
  [51844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(2353), 1,
      anon_sym_LBRACE,
    STATE(510), 1,
      sym_literal_value,
  [51857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    ACTIONS(2355), 1,
      sym_identifier,
    STATE(662), 1,
      sym_parameter_list,
  [51870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2357), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2359), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 1,
      anon_sym_RPAREN,
    ACTIONS(2363), 1,
      anon_sym_COMMA,
    STATE(1078), 1,
      aux_sym_expression_list_repeat1,
  [51901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2240), 1,
      anon_sym_RBRACK,
    STATE(1072), 1,
      aux_sym_type_arguments_repeat1,
  [51923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_LBRACE,
    ACTIONS(2367), 1,
      anon_sym_COMMA,
    STATE(1000), 1,
      aux_sym_expression_list_repeat1,
  [51936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(2370), 1,
      anon_sym_LBRACE,
    STATE(307), 1,
      sym_literal_value,
  [51949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1323), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [51958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2265), 1,
      anon_sym_COMMA,
    ACTIONS(2267), 1,
      anon_sym_RBRACE,
    STATE(1067), 1,
      aux_sym_literal_value_repeat1,
  [51971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2372), 1,
      anon_sym_COMMA,
    ACTIONS(2374), 1,
      anon_sym_COLON,
    STATE(971), 1,
      aux_sym_type_arguments_repeat1,
  [51984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2376), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [51993] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2378), 1,
      anon_sym_LF,
    ACTIONS(2380), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52004] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2378), 1,
      anon_sym_LF,
    ACTIONS(2380), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_RPAREN,
    ACTIONS(2384), 1,
      anon_sym_COMMA,
    STATE(1024), 1,
      aux_sym_parameter_list_repeat1,
  [52028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(1538), 1,
      anon_sym_LBRACE,
    STATE(515), 1,
      sym_block,
  [52041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 1,
      anon_sym_RPAREN,
    ACTIONS(1265), 1,
      anon_sym_COMMA,
    STATE(1064), 1,
      aux_sym_argument_list_repeat1,
  [52054] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2378), 1,
      anon_sym_LF,
    ACTIONS(2380), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52065] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2378), 1,
      anon_sym_LF,
    ACTIONS(2380), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 1,
      anon_sym_RPAREN,
    ACTIONS(2388), 1,
      anon_sym_COMMA,
    STATE(1030), 1,
      aux_sym_expression_list_repeat1,
  [52089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 1,
      anon_sym_COMMA,
    ACTIONS(2392), 1,
      anon_sym_RBRACK,
    STATE(1032), 1,
      aux_sym_type_arguments_repeat1,
  [52102] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_RBRACK,
    STATE(1015), 1,
      aux_sym_type_parameter_list_repeat1,
  [52115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 1,
      anon_sym_DQUOTE,
    ACTIONS(2399), 1,
      sym_raw_string_literal,
    STATE(246), 1,
      sym_interpreted_string_literal,
  [52128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2208), 1,
      anon_sym_COMMA,
    ACTIONS(2210), 1,
      anon_sym_RBRACE,
    STATE(1034), 1,
      aux_sym_literal_value_repeat1,
  [52141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 1,
      anon_sym_RPAREN,
    ACTIONS(2401), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_argument_list_repeat1,
  [52154] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2404), 1,
      anon_sym_LF,
    ACTIONS(2406), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 1,
      anon_sym_RPAREN,
    ACTIONS(1233), 1,
      anon_sym_COMMA,
    STATE(1038), 1,
      aux_sym_argument_list_repeat1,
  [52178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(470), 1,
      anon_sym_RPAREN,
    ACTIONS(2408), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_argument_list_repeat1,
  [52191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1671), 1,
      anon_sym_DQUOTE,
    ACTIONS(2410), 1,
      sym_raw_string_literal,
    STATE(252), 1,
      sym_interpreted_string_literal,
  [52204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(582), 1,
      anon_sym_RPAREN,
    ACTIONS(2412), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_expression_list_repeat1,
  [52217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_RPAREN,
    ACTIONS(2414), 1,
      anon_sym_COMMA,
    STATE(989), 1,
      aux_sym_parameter_list_repeat1,
  [52230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(414), 1,
      anon_sym_RBRACE,
    ACTIONS(2416), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [52243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1572), 1,
      anon_sym_RBRACK,
    ACTIONS(2418), 1,
      anon_sym_COMMA,
    STATE(971), 1,
      aux_sym_type_arguments_repeat1,
  [52256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_COMMA,
    ACTIONS(2423), 1,
      anon_sym_RBRACE,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [52269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_RPAREN,
    ACTIONS(2425), 1,
      anon_sym_COMMA,
    STATE(989), 1,
      aux_sym_parameter_list_repeat1,
  [52282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_COLON,
    ACTIONS(2423), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [52293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(524), 1,
      anon_sym_RPAREN,
    ACTIONS(2427), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_expression_list_repeat1,
  [52306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [52315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 1,
      anon_sym_RBRACK,
    ACTIONS(2429), 1,
      anon_sym_COMMA,
    STATE(971), 1,
      aux_sym_type_arguments_repeat1,
  [52328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 1,
      anon_sym_RPAREN,
    ACTIONS(2431), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_expression_list_repeat1,
  [52341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 1,
      anon_sym_RBRACE,
    ACTIONS(2434), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [52354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2372), 1,
      anon_sym_COMMA,
    ACTIONS(2436), 1,
      anon_sym_COLON,
    STATE(1004), 1,
      aux_sym_type_arguments_repeat1,
  [52367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52376] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(502), 1,
      anon_sym_RPAREN,
    ACTIONS(2440), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_argument_list_repeat1,
  [52389] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 1,
      anon_sym_RPAREN,
    ACTIONS(2442), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_argument_list_repeat1,
  [52402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1253), 1,
      anon_sym_RPAREN,
    ACTIONS(1255), 1,
      anon_sym_COMMA,
    STATE(1021), 1,
      aux_sym_argument_list_repeat1,
  [52415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 1,
      anon_sym_COMMA,
    ACTIONS(2173), 1,
      anon_sym_RBRACE,
    STATE(1025), 1,
      aux_sym_literal_value_repeat1,
  [52428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(410), 1,
      anon_sym_RBRACE,
    ACTIONS(2444), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [52441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(514), 1,
      anon_sym_RPAREN,
    ACTIONS(2446), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_expression_list_repeat1,
  [52454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      anon_sym_COMMA,
    ACTIONS(2450), 1,
      anon_sym_RBRACK,
    STATE(1026), 1,
      aux_sym_type_arguments_repeat1,
  [52467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_RPAREN,
    ACTIONS(2454), 1,
      anon_sym_COMMA,
    STATE(1023), 1,
      aux_sym_expression_list_repeat1,
  [52480] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LF,
    ACTIONS(2312), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_RPAREN,
    ACTIONS(2460), 1,
      anon_sym_COMMA,
    STATE(1028), 1,
      aux_sym_parameter_list_repeat1,
  [52504] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_LF,
    ACTIONS(2464), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [52524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 1,
      anon_sym_RPAREN,
    ACTIONS(1269), 1,
      anon_sym_COMMA,
    STATE(1037), 1,
      aux_sym_argument_list_repeat1,
  [52537] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_LF,
    ACTIONS(2340), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1331), 1,
      anon_sym_COMMA,
    ACTIONS(1605), 1,
      anon_sym_LBRACE,
    STATE(1000), 1,
      aux_sym_expression_list_repeat1,
  [52561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 1,
      anon_sym_COMMA,
    ACTIONS(2224), 1,
      anon_sym_RBRACE,
    STATE(1041), 1,
      aux_sym_literal_value_repeat1,
  [52574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    STATE(309), 1,
      sym_block,
  [52587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_RPAREN,
    ACTIONS(2472), 1,
      anon_sym_COMMA,
    STATE(1042), 1,
      aux_sym_expression_list_repeat1,
  [52600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    STATE(350), 1,
      sym_literal_value,
  [52613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(1528), 1,
      anon_sym_LBRACE,
    STATE(569), 1,
      sym_block,
  [52626] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2476), 1,
      anon_sym_LF,
    ACTIONS(2478), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52637] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2480), 1,
      anon_sym_LF,
    ACTIONS(2482), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_RBRACK,
    ACTIONS(2484), 1,
      anon_sym_COMMA,
    STATE(1015), 1,
      aux_sym_type_parameter_list_repeat1,
  [52661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(1213), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_literal_value,
  [52674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 1,
      anon_sym_RPAREN,
    ACTIONS(2490), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_argument_list_repeat1,
  [52714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_RPAREN,
    ACTIONS(2496), 1,
      anon_sym_COMMA,
    STATE(1068), 1,
      aux_sym_parameter_list_repeat1,
  [52736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 1,
      anon_sym_RBRACE,
    ACTIONS(2498), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [52749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1430), 1,
      anon_sym_RPAREN,
    ACTIONS(2500), 1,
      anon_sym_COMMA,
    STATE(989), 1,
      aux_sym_parameter_list_repeat1,
  [52762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(1546), 1,
      anon_sym_LBRACE,
    STATE(375), 1,
      sym_block,
  [52775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 1,
      anon_sym_RPAREN,
    ACTIONS(2504), 1,
      anon_sym_COMMA,
    STATE(1080), 1,
      aux_sym_expression_list_repeat1,
  [52788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 1,
      anon_sym_RPAREN,
    ACTIONS(2506), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_argument_list_repeat1,
  [52801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 1,
      anon_sym_RBRACK,
    ACTIONS(2508), 1,
      anon_sym_COMMA,
    STATE(971), 1,
      aux_sym_type_arguments_repeat1,
  [52814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2280), 1,
      anon_sym_COMMA,
    ACTIONS(2282), 1,
      anon_sym_RBRACE,
    STATE(1082), 1,
      aux_sym_literal_value_repeat1,
  [52827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 1,
      anon_sym_RBRACE,
    ACTIONS(2510), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [52840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(560), 1,
      anon_sym_RPAREN,
    ACTIONS(2512), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_expression_list_repeat1,
  [52853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1299), 1,
      anon_sym_RPAREN,
    ACTIONS(1301), 1,
      anon_sym_COMMA,
    STATE(1086), 1,
      aux_sym_argument_list_repeat1,
  [52866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 1,
      anon_sym_COMMA,
    ACTIONS(2516), 1,
      anon_sym_RBRACK,
    STATE(1059), 1,
      aux_sym_type_parameter_list_repeat1,
  [52879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(2518), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_expression_list_repeat1,
  [52892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1305), 1,
      anon_sym_RPAREN,
    ACTIONS(1307), 1,
      anon_sym_COMMA,
    STATE(1071), 1,
      aux_sym_argument_list_repeat1,
  [52905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    ACTIONS(2520), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym_expression_list_repeat1,
  [52918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(2522), 1,
      sym_raw_string_literal,
    STATE(1113), 1,
      sym_interpreted_string_literal,
  [52931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(398), 1,
      anon_sym_RBRACE,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    STATE(1027), 1,
      aux_sym_literal_value_repeat1,
  [52944] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_LF,
    ACTIONS(2528), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [52955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 1,
      anon_sym_COMMA,
    ACTIONS(2145), 1,
      anon_sym_RBRACE,
    STATE(1074), 1,
      aux_sym_literal_value_repeat1,
  [52968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LPAREN,
    ACTIONS(2492), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 1,
      anon_sym_RPAREN,
    ACTIONS(2530), 1,
      anon_sym_COMMA,
    STATE(1018), 1,
      aux_sym_argument_list_repeat1,
  [52992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      anon_sym_LPAREN,
    ACTIONS(1532), 1,
      anon_sym_LBRACE,
    STATE(420), 1,
      sym_block,
  [53005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(200), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [53014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      anon_sym_DQUOTE,
    ACTIONS(2532), 1,
      sym_raw_string_literal,
    STATE(1115), 1,
      sym_interpreted_string_literal,
  [53027] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2534), 1,
      anon_sym_LF,
    ACTIONS(2536), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [53038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(755), 1,
      anon_sym_LPAREN,
    ACTIONS(1061), 1,
      anon_sym_LBRACE,
    STATE(396), 1,
      sym_literal_value,
  [53051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_RPAREN,
    ACTIONS(2540), 1,
      anon_sym_COMMA,
    STATE(1075), 1,
      aux_sym_expression_list_repeat1,
  [53064] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2542), 1,
      anon_sym_LF,
    ACTIONS(2544), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [53075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LPAREN,
    ACTIONS(2546), 1,
      anon_sym_RPAREN,
  [53085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      sym_identifier,
    STATE(862), 1,
      sym_qualified_type,
  [53095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1906), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2018), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53111] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2550), 1,
      anon_sym_LF,
    ACTIONS(2552), 1,
      anon_sym_SEMI,
  [53121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(360), 1,
      anon_sym_LBRACE,
    STATE(430), 1,
      sym_literal_value,
  [53131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1954), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [53139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_LBRACE,
    STATE(800), 1,
      sym_field_declaration_list,
  [53149] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2556), 1,
      anon_sym_LF,
    ACTIONS(2558), 1,
      anon_sym_SEMI,
  [53159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 1,
      anon_sym_LPAREN,
    STATE(323), 1,
      sym_argument_list,
  [53169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2010), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 1,
      anon_sym_LBRACE,
    STATE(396), 1,
      sym_literal_value,
  [53187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2353), 1,
      anon_sym_LBRACE,
    STATE(510), 1,
      sym_literal_value,
  [53197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      sym_identifier,
    ACTIONS(2564), 1,
      anon_sym_LPAREN,
  [53207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      sym_identifier,
    ACTIONS(2568), 1,
      anon_sym_LPAREN,
  [53217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 1,
      anon_sym_LPAREN,
    STATE(400), 1,
      sym_argument_list,
  [53227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      anon_sym_LPAREN,
    STATE(467), 1,
      sym_parameter_list,
  [53237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(655), 1,
      sym_parameter_list,
  [53247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_LBRACE,
    STATE(262), 1,
      sym_field_declaration_list,
  [53257] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(698), 1,
      anon_sym_LF,
    ACTIONS(700), 1,
      anon_sym_SEMI,
  [53267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      anon_sym_LBRACE,
    STATE(830), 1,
      sym_field_declaration_list,
  [53277] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(674), 1,
      anon_sym_LF,
    ACTIONS(676), 1,
      anon_sym_SEMI,
  [53287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1935), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(657), 1,
      sym_parameter_list,
  [53305] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2576), 1,
      anon_sym_LF,
    ACTIONS(2578), 1,
      anon_sym_SEMI,
  [53315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      sym_identifier,
    ACTIONS(2582), 1,
      anon_sym_LPAREN,
  [53325] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(804), 1,
      anon_sym_LF,
    ACTIONS(806), 1,
      anon_sym_SEMI,
  [53335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [53343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(664), 1,
      sym_parameter_list,
  [53353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      sym_identifier,
    ACTIONS(2586), 1,
      anon_sym_LPAREN,
  [53363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(659), 1,
      sym_parameter_list,
  [53373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      sym_identifier,
    ACTIONS(2590), 1,
      anon_sym_LPAREN,
  [53383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(502), 1,
      sym_parameter_list,
  [53393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_LPAREN,
    STATE(517), 1,
      sym_argument_list,
  [53403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(31), 1,
      anon_sym_LBRACE,
    STATE(911), 1,
      sym_block,
  [53413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2370), 1,
      anon_sym_LBRACE,
    STATE(307), 1,
      sym_literal_value,
  [53423] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(771), 1,
      anon_sym_LF,
    ACTIONS(2594), 1,
      anon_sym_SEMI,
  [53433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 2,
      sym_raw_string_literal,
      anon_sym_DQUOTE,
  [53441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(660), 1,
      sym_parameter_list,
  [53451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(906), 1,
      anon_sym_LPAREN,
    STATE(376), 1,
      sym_argument_list,
  [53469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      sym_identifier,
    ACTIONS(2602), 1,
      anon_sym_LPAREN,
  [53487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2198), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [53495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2397), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [53503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_LPAREN,
    STATE(27), 1,
      sym_parameter_list,
  [53513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1213), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_literal_value,
  [53523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2342), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(554), 1,
      sym_parameter_list,
  [53541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 2,
      anon_sym_EQ,
      anon_sym_COLON_EQ,
  [53549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1544), 1,
      anon_sym_LBRACE,
    STATE(279), 1,
      sym_block,
  [53559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      sym_identifier,
    ACTIONS(2608), 1,
      anon_sym_LPAREN,
  [53569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parameter_list,
  [53579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      anon_sym_LPAREN,
    STATE(568), 1,
      sym_argument_list,
  [53589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      sym_identifier,
    ACTIONS(2610), 1,
      anon_sym_LPAREN,
  [53607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      anon_sym_LBRACE,
    STATE(350), 1,
      sym_literal_value,
  [53617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2612), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [53625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [53633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2614), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1257), 1,
      anon_sym_LPAREN,
    STATE(622), 1,
      sym_parameter_list,
  [53651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1089), 1,
      anon_sym_LPAREN,
    STATE(443), 1,
      sym_argument_list,
  [53661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      sym_identifier,
    ACTIONS(2616), 1,
      anon_sym_LPAREN,
  [53671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      sym_identifier,
    ACTIONS(2618), 1,
      anon_sym_LPAREN,
  [53681] = 3,
    ACTIONS(286), 1,
      sym_comment,
    ACTIONS(2620), 1,
      anon_sym_LF,
    ACTIONS(2622), 1,
      anon_sym_SEMI,
  [53691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 2,
      anon_sym_RPAREN,
      sym_identifier,
  [53699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2624), 1,
      anon_sym_RBRACK,
  [53706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2282), 1,
      anon_sym_RBRACE,
  [53713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2626), 1,
      anon_sym_RBRACK,
  [53720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 1,
      anon_sym_RBRACE,
  [53727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      anon_sym_RBRACE,
  [53734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_RPAREN,
  [53741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
  [53748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2634), 1,
      anon_sym_LBRACE,
  [53755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 1,
      anon_sym_LBRACE,
  [53762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2638), 1,
      anon_sym_chan,
  [53769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2640), 1,
      anon_sym_chan,
  [53776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2642), 1,
      anon_sym_EQ,
  [53783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_RPAREN,
  [53790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      anon_sym_RPAREN,
  [53797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2648), 1,
      anon_sym_RPAREN,
  [53804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2650), 1,
      anon_sym_EQ,
  [53811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 1,
      sym_identifier,
  [53818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2654), 1,
      anon_sym_RPAREN,
  [53825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      sym_identifier,
  [53832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2658), 1,
      anon_sym_RBRACE,
  [53839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 1,
      anon_sym_RBRACE,
  [53846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2660), 1,
      anon_sym_RBRACE,
  [53853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2662), 1,
      sym_identifier,
  [53860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 1,
      anon_sym_RPAREN,
  [53867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2666), 1,
      anon_sym_RPAREN,
  [53874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2668), 1,
      anon_sym_RBRACK,
  [53881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_LBRACE,
  [53888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2672), 1,
      anon_sym_RBRACE,
  [53895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2674), 1,
      anon_sym_COLON,
  [53902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2676), 1,
      sym_identifier,
  [53909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 1,
      anon_sym_RBRACE,
  [53916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2678), 1,
      anon_sym_SEMI,
  [53923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2680), 1,
      anon_sym_RBRACK,
  [53930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2682), 1,
      anon_sym_COLON,
  [53937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_RPAREN,
  [53944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2684), 1,
      anon_sym_LBRACE,
  [53951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 1,
      anon_sym_RPAREN,
  [53958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 1,
      anon_sym_RPAREN,
  [53965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2690), 1,
      anon_sym_chan,
  [53972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_RBRACK,
  [53979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2694), 1,
      anon_sym_chan,
  [53986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_RPAREN,
  [53993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2696), 1,
      anon_sym_SEMI,
  [54000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_RPAREN,
  [54007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 1,
      anon_sym_LPAREN,
  [54014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2700), 1,
      anon_sym_LBRACE,
  [54021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_RPAREN,
  [54028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2702), 1,
      anon_sym_LBRACE,
  [54035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      anon_sym_RBRACE,
  [54042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 1,
      anon_sym_RPAREN,
  [54049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2706), 1,
      anon_sym_RPAREN,
  [54056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2708), 1,
      anon_sym_RPAREN,
  [54063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2710), 1,
      anon_sym_LBRACE,
  [54070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2712), 1,
      ts_builtin_sym_end,
  [54077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
  [54084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2716), 1,
      anon_sym_LBRACE,
  [54091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2718), 1,
      anon_sym_RPAREN,
  [54098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 1,
      sym_identifier,
  [54105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2722), 1,
      sym_identifier,
  [54112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2724), 1,
      anon_sym_RPAREN,
  [54119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_LBRACE,
  [54126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2728), 1,
      anon_sym_RBRACE,
  [54133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_SEMI,
  [54140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_LBRACE,
  [54147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2734), 1,
      anon_sym_LBRACE,
  [54154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_COLON,
  [54161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_LBRACK,
  [54168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_LBRACE,
  [54175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_RPAREN,
  [54182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      sym_identifier,
  [54189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      anon_sym_RPAREN,
  [54196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2748), 1,
      anon_sym_RBRACE,
  [54203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 1,
      anon_sym_COLON_EQ,
  [54210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 1,
      anon_sym_RPAREN,
  [54217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 1,
      anon_sym_RBRACE,
  [54224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 1,
      anon_sym_LBRACE,
  [54231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_RBRACE,
  [54238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2758), 1,
      sym_identifier,
  [54245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      sym_identifier,
  [54252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 1,
      anon_sym_LBRACK,
  [54259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LPAREN,
  [54266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 1,
      sym_identifier,
  [54273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_LBRACK,
  [54280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2768), 1,
      anon_sym_LPAREN,
  [54287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2770), 1,
      anon_sym_LPAREN,
  [54294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LPAREN,
  [54301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_LPAREN,
  [54308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LBRACK,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(22)] = 0,
  [SMALL_STATE(23)] = 118,
  [SMALL_STATE(24)] = 233,
  [SMALL_STATE(25)] = 348,
  [SMALL_STATE(26)] = 463,
  [SMALL_STATE(27)] = 578,
  [SMALL_STATE(28)] = 674,
  [SMALL_STATE(29)] = 770,
  [SMALL_STATE(30)] = 882,
  [SMALL_STATE(31)] = 991,
  [SMALL_STATE(32)] = 1082,
  [SMALL_STATE(33)] = 1199,
  [SMALL_STATE(34)] = 1316,
  [SMALL_STATE(35)] = 1433,
  [SMALL_STATE(36)] = 1550,
  [SMALL_STATE(37)] = 1667,
  [SMALL_STATE(38)] = 1784,
  [SMALL_STATE(39)] = 1898,
  [SMALL_STATE(40)] = 2012,
  [SMALL_STATE(41)] = 2126,
  [SMALL_STATE(42)] = 2240,
  [SMALL_STATE(43)] = 2354,
  [SMALL_STATE(44)] = 2468,
  [SMALL_STATE(45)] = 2582,
  [SMALL_STATE(46)] = 2696,
  [SMALL_STATE(47)] = 2810,
  [SMALL_STATE(48)] = 2924,
  [SMALL_STATE(49)] = 3038,
  [SMALL_STATE(50)] = 3152,
  [SMALL_STATE(51)] = 3263,
  [SMALL_STATE(52)] = 3371,
  [SMALL_STATE(53)] = 3477,
  [SMALL_STATE(54)] = 3582,
  [SMALL_STATE(55)] = 3687,
  [SMALL_STATE(56)] = 3792,
  [SMALL_STATE(57)] = 3897,
  [SMALL_STATE(58)] = 4002,
  [SMALL_STATE(59)] = 4107,
  [SMALL_STATE(60)] = 4212,
  [SMALL_STATE(61)] = 4317,
  [SMALL_STATE(62)] = 4422,
  [SMALL_STATE(63)] = 4527,
  [SMALL_STATE(64)] = 4632,
  [SMALL_STATE(65)] = 4737,
  [SMALL_STATE(66)] = 4842,
  [SMALL_STATE(67)] = 4947,
  [SMALL_STATE(68)] = 5052,
  [SMALL_STATE(69)] = 5157,
  [SMALL_STATE(70)] = 5262,
  [SMALL_STATE(71)] = 5367,
  [SMALL_STATE(72)] = 5472,
  [SMALL_STATE(73)] = 5577,
  [SMALL_STATE(74)] = 5682,
  [SMALL_STATE(75)] = 5787,
  [SMALL_STATE(76)] = 5892,
  [SMALL_STATE(77)] = 5994,
  [SMALL_STATE(78)] = 6096,
  [SMALL_STATE(79)] = 6198,
  [SMALL_STATE(80)] = 6300,
  [SMALL_STATE(81)] = 6402,
  [SMALL_STATE(82)] = 6504,
  [SMALL_STATE(83)] = 6606,
  [SMALL_STATE(84)] = 6708,
  [SMALL_STATE(85)] = 6810,
  [SMALL_STATE(86)] = 6912,
  [SMALL_STATE(87)] = 7014,
  [SMALL_STATE(88)] = 7116,
  [SMALL_STATE(89)] = 7218,
  [SMALL_STATE(90)] = 7320,
  [SMALL_STATE(91)] = 7422,
  [SMALL_STATE(92)] = 7524,
  [SMALL_STATE(93)] = 7626,
  [SMALL_STATE(94)] = 7728,
  [SMALL_STATE(95)] = 7830,
  [SMALL_STATE(96)] = 7932,
  [SMALL_STATE(97)] = 8034,
  [SMALL_STATE(98)] = 8136,
  [SMALL_STATE(99)] = 8238,
  [SMALL_STATE(100)] = 8340,
  [SMALL_STATE(101)] = 8442,
  [SMALL_STATE(102)] = 8544,
  [SMALL_STATE(103)] = 8646,
  [SMALL_STATE(104)] = 8748,
  [SMALL_STATE(105)] = 8850,
  [SMALL_STATE(106)] = 8952,
  [SMALL_STATE(107)] = 9054,
  [SMALL_STATE(108)] = 9156,
  [SMALL_STATE(109)] = 9258,
  [SMALL_STATE(110)] = 9360,
  [SMALL_STATE(111)] = 9462,
  [SMALL_STATE(112)] = 9564,
  [SMALL_STATE(113)] = 9666,
  [SMALL_STATE(114)] = 9768,
  [SMALL_STATE(115)] = 9870,
  [SMALL_STATE(116)] = 9972,
  [SMALL_STATE(117)] = 10074,
  [SMALL_STATE(118)] = 10176,
  [SMALL_STATE(119)] = 10278,
  [SMALL_STATE(120)] = 10380,
  [SMALL_STATE(121)] = 10482,
  [SMALL_STATE(122)] = 10584,
  [SMALL_STATE(123)] = 10686,
  [SMALL_STATE(124)] = 10788,
  [SMALL_STATE(125)] = 10890,
  [SMALL_STATE(126)] = 10992,
  [SMALL_STATE(127)] = 11094,
  [SMALL_STATE(128)] = 11196,
  [SMALL_STATE(129)] = 11298,
  [SMALL_STATE(130)] = 11400,
  [SMALL_STATE(131)] = 11499,
  [SMALL_STATE(132)] = 11598,
  [SMALL_STATE(133)] = 11697,
  [SMALL_STATE(134)] = 11796,
  [SMALL_STATE(135)] = 11895,
  [SMALL_STATE(136)] = 11994,
  [SMALL_STATE(137)] = 12093,
  [SMALL_STATE(138)] = 12192,
  [SMALL_STATE(139)] = 12291,
  [SMALL_STATE(140)] = 12390,
  [SMALL_STATE(141)] = 12489,
  [SMALL_STATE(142)] = 12588,
  [SMALL_STATE(143)] = 12687,
  [SMALL_STATE(144)] = 12786,
  [SMALL_STATE(145)] = 12885,
  [SMALL_STATE(146)] = 12984,
  [SMALL_STATE(147)] = 13083,
  [SMALL_STATE(148)] = 13182,
  [SMALL_STATE(149)] = 13281,
  [SMALL_STATE(150)] = 13380,
  [SMALL_STATE(151)] = 13479,
  [SMALL_STATE(152)] = 13578,
  [SMALL_STATE(153)] = 13677,
  [SMALL_STATE(154)] = 13776,
  [SMALL_STATE(155)] = 13875,
  [SMALL_STATE(156)] = 13974,
  [SMALL_STATE(157)] = 14073,
  [SMALL_STATE(158)] = 14172,
  [SMALL_STATE(159)] = 14271,
  [SMALL_STATE(160)] = 14370,
  [SMALL_STATE(161)] = 14469,
  [SMALL_STATE(162)] = 14568,
  [SMALL_STATE(163)] = 14667,
  [SMALL_STATE(164)] = 14766,
  [SMALL_STATE(165)] = 14865,
  [SMALL_STATE(166)] = 14964,
  [SMALL_STATE(167)] = 15063,
  [SMALL_STATE(168)] = 15162,
  [SMALL_STATE(169)] = 15261,
  [SMALL_STATE(170)] = 15360,
  [SMALL_STATE(171)] = 15459,
  [SMALL_STATE(172)] = 15558,
  [SMALL_STATE(173)] = 15657,
  [SMALL_STATE(174)] = 15756,
  [SMALL_STATE(175)] = 15855,
  [SMALL_STATE(176)] = 15954,
  [SMALL_STATE(177)] = 16053,
  [SMALL_STATE(178)] = 16152,
  [SMALL_STATE(179)] = 16251,
  [SMALL_STATE(180)] = 16350,
  [SMALL_STATE(181)] = 16449,
  [SMALL_STATE(182)] = 16548,
  [SMALL_STATE(183)] = 16647,
  [SMALL_STATE(184)] = 16746,
  [SMALL_STATE(185)] = 16845,
  [SMALL_STATE(186)] = 16944,
  [SMALL_STATE(187)] = 17043,
  [SMALL_STATE(188)] = 17142,
  [SMALL_STATE(189)] = 17241,
  [SMALL_STATE(190)] = 17340,
  [SMALL_STATE(191)] = 17439,
  [SMALL_STATE(192)] = 17538,
  [SMALL_STATE(193)] = 17637,
  [SMALL_STATE(194)] = 17736,
  [SMALL_STATE(195)] = 17835,
  [SMALL_STATE(196)] = 17934,
  [SMALL_STATE(197)] = 18033,
  [SMALL_STATE(198)] = 18132,
  [SMALL_STATE(199)] = 18231,
  [SMALL_STATE(200)] = 18330,
  [SMALL_STATE(201)] = 18429,
  [SMALL_STATE(202)] = 18528,
  [SMALL_STATE(203)] = 18627,
  [SMALL_STATE(204)] = 18726,
  [SMALL_STATE(205)] = 18825,
  [SMALL_STATE(206)] = 18924,
  [SMALL_STATE(207)] = 19023,
  [SMALL_STATE(208)] = 19122,
  [SMALL_STATE(209)] = 19221,
  [SMALL_STATE(210)] = 19320,
  [SMALL_STATE(211)] = 19419,
  [SMALL_STATE(212)] = 19518,
  [SMALL_STATE(213)] = 19617,
  [SMALL_STATE(214)] = 19716,
  [SMALL_STATE(215)] = 19815,
  [SMALL_STATE(216)] = 19914,
  [SMALL_STATE(217)] = 20013,
  [SMALL_STATE(218)] = 20112,
  [SMALL_STATE(219)] = 20211,
  [SMALL_STATE(220)] = 20310,
  [SMALL_STATE(221)] = 20409,
  [SMALL_STATE(222)] = 20508,
  [SMALL_STATE(223)] = 20607,
  [SMALL_STATE(224)] = 20706,
  [SMALL_STATE(225)] = 20805,
  [SMALL_STATE(226)] = 20904,
  [SMALL_STATE(227)] = 21003,
  [SMALL_STATE(228)] = 21102,
  [SMALL_STATE(229)] = 21201,
  [SMALL_STATE(230)] = 21300,
  [SMALL_STATE(231)] = 21399,
  [SMALL_STATE(232)] = 21498,
  [SMALL_STATE(233)] = 21597,
  [SMALL_STATE(234)] = 21696,
  [SMALL_STATE(235)] = 21795,
  [SMALL_STATE(236)] = 21858,
  [SMALL_STATE(237)] = 21918,
  [SMALL_STATE(238)] = 21988,
  [SMALL_STATE(239)] = 22058,
  [SMALL_STATE(240)] = 22118,
  [SMALL_STATE(241)] = 22173,
  [SMALL_STATE(242)] = 22228,
  [SMALL_STATE(243)] = 22283,
  [SMALL_STATE(244)] = 22338,
  [SMALL_STATE(245)] = 22393,
  [SMALL_STATE(246)] = 22448,
  [SMALL_STATE(247)] = 22503,
  [SMALL_STATE(248)] = 22558,
  [SMALL_STATE(249)] = 22613,
  [SMALL_STATE(250)] = 22668,
  [SMALL_STATE(251)] = 22723,
  [SMALL_STATE(252)] = 22778,
  [SMALL_STATE(253)] = 22833,
  [SMALL_STATE(254)] = 22888,
  [SMALL_STATE(255)] = 22943,
  [SMALL_STATE(256)] = 22998,
  [SMALL_STATE(257)] = 23091,
  [SMALL_STATE(258)] = 23146,
  [SMALL_STATE(259)] = 23201,
  [SMALL_STATE(260)] = 23256,
  [SMALL_STATE(261)] = 23311,
  [SMALL_STATE(262)] = 23366,
  [SMALL_STATE(263)] = 23421,
  [SMALL_STATE(264)] = 23480,
  [SMALL_STATE(265)] = 23535,
  [SMALL_STATE(266)] = 23590,
  [SMALL_STATE(267)] = 23645,
  [SMALL_STATE(268)] = 23700,
  [SMALL_STATE(269)] = 23755,
  [SMALL_STATE(270)] = 23810,
  [SMALL_STATE(271)] = 23865,
  [SMALL_STATE(272)] = 23920,
  [SMALL_STATE(273)] = 23975,
  [SMALL_STATE(274)] = 24030,
  [SMALL_STATE(275)] = 24085,
  [SMALL_STATE(276)] = 24140,
  [SMALL_STATE(277)] = 24195,
  [SMALL_STATE(278)] = 24250,
  [SMALL_STATE(279)] = 24305,
  [SMALL_STATE(280)] = 24360,
  [SMALL_STATE(281)] = 24415,
  [SMALL_STATE(282)] = 24470,
  [SMALL_STATE(283)] = 24525,
  [SMALL_STATE(284)] = 24612,
  [SMALL_STATE(285)] = 24667,
  [SMALL_STATE(286)] = 24722,
  [SMALL_STATE(287)] = 24777,
  [SMALL_STATE(288)] = 24832,
  [SMALL_STATE(289)] = 24899,
  [SMALL_STATE(290)] = 24954,
  [SMALL_STATE(291)] = 25026,
  [SMALL_STATE(292)] = 25096,
  [SMALL_STATE(293)] = 25150,
  [SMALL_STATE(294)] = 25218,
  [SMALL_STATE(295)] = 25284,
  [SMALL_STATE(296)] = 25348,
  [SMALL_STATE(297)] = 25412,
  [SMALL_STATE(298)] = 25503,
  [SMALL_STATE(299)] = 25594,
  [SMALL_STATE(300)] = 25647,
  [SMALL_STATE(301)] = 25700,
  [SMALL_STATE(302)] = 25757,
  [SMALL_STATE(303)] = 25809,
  [SMALL_STATE(304)] = 25861,
  [SMALL_STATE(305)] = 25913,
  [SMALL_STATE(306)] = 25965,
  [SMALL_STATE(307)] = 26017,
  [SMALL_STATE(308)] = 26069,
  [SMALL_STATE(309)] = 26121,
  [SMALL_STATE(310)] = 26173,
  [SMALL_STATE(311)] = 26261,
  [SMALL_STATE(312)] = 26313,
  [SMALL_STATE(313)] = 26365,
  [SMALL_STATE(314)] = 26417,
  [SMALL_STATE(315)] = 26469,
  [SMALL_STATE(316)] = 26521,
  [SMALL_STATE(317)] = 26573,
  [SMALL_STATE(318)] = 26625,
  [SMALL_STATE(319)] = 26677,
  [SMALL_STATE(320)] = 26729,
  [SMALL_STATE(321)] = 26781,
  [SMALL_STATE(322)] = 26833,
  [SMALL_STATE(323)] = 26885,
  [SMALL_STATE(324)] = 26937,
  [SMALL_STATE(325)] = 26989,
  [SMALL_STATE(326)] = 27041,
  [SMALL_STATE(327)] = 27093,
  [SMALL_STATE(328)] = 27145,
  [SMALL_STATE(329)] = 27197,
  [SMALL_STATE(330)] = 27249,
  [SMALL_STATE(331)] = 27301,
  [SMALL_STATE(332)] = 27353,
  [SMALL_STATE(333)] = 27405,
  [SMALL_STATE(334)] = 27457,
  [SMALL_STATE(335)] = 27509,
  [SMALL_STATE(336)] = 27570,
  [SMALL_STATE(337)] = 27631,
  [SMALL_STATE(338)] = 27694,
  [SMALL_STATE(339)] = 27759,
  [SMALL_STATE(340)] = 27828,
  [SMALL_STATE(341)] = 27899,
  [SMALL_STATE(342)] = 27960,
  [SMALL_STATE(343)] = 28045,
  [SMALL_STATE(344)] = 28099,
  [SMALL_STATE(345)] = 28148,
  [SMALL_STATE(346)] = 28197,
  [SMALL_STATE(347)] = 28246,
  [SMALL_STATE(348)] = 28295,
  [SMALL_STATE(349)] = 28344,
  [SMALL_STATE(350)] = 28393,
  [SMALL_STATE(351)] = 28442,
  [SMALL_STATE(352)] = 28491,
  [SMALL_STATE(353)] = 28540,
  [SMALL_STATE(354)] = 28589,
  [SMALL_STATE(355)] = 28638,
  [SMALL_STATE(356)] = 28687,
  [SMALL_STATE(357)] = 28736,
  [SMALL_STATE(358)] = 28785,
  [SMALL_STATE(359)] = 28834,
  [SMALL_STATE(360)] = 28883,
  [SMALL_STATE(361)] = 28932,
  [SMALL_STATE(362)] = 28981,
  [SMALL_STATE(363)] = 29030,
  [SMALL_STATE(364)] = 29079,
  [SMALL_STATE(365)] = 29128,
  [SMALL_STATE(366)] = 29177,
  [SMALL_STATE(367)] = 29226,
  [SMALL_STATE(368)] = 29275,
  [SMALL_STATE(369)] = 29324,
  [SMALL_STATE(370)] = 29373,
  [SMALL_STATE(371)] = 29422,
  [SMALL_STATE(372)] = 29471,
  [SMALL_STATE(373)] = 29520,
  [SMALL_STATE(374)] = 29569,
  [SMALL_STATE(375)] = 29618,
  [SMALL_STATE(376)] = 29667,
  [SMALL_STATE(377)] = 29716,
  [SMALL_STATE(378)] = 29765,
  [SMALL_STATE(379)] = 29824,
  [SMALL_STATE(380)] = 29892,
  [SMALL_STATE(381)] = 29948,
  [SMALL_STATE(382)] = 30006,
  [SMALL_STATE(383)] = 30062,
  [SMALL_STATE(384)] = 30122,
  [SMALL_STATE(385)] = 30186,
  [SMALL_STATE(386)] = 30252,
  [SMALL_STATE(387)] = 30301,
  [SMALL_STATE(388)] = 30345,
  [SMALL_STATE(389)] = 30389,
  [SMALL_STATE(390)] = 30433,
  [SMALL_STATE(391)] = 30477,
  [SMALL_STATE(392)] = 30521,
  [SMALL_STATE(393)] = 30565,
  [SMALL_STATE(394)] = 30609,
  [SMALL_STATE(395)] = 30653,
  [SMALL_STATE(396)] = 30697,
  [SMALL_STATE(397)] = 30741,
  [SMALL_STATE(398)] = 30785,
  [SMALL_STATE(399)] = 30829,
  [SMALL_STATE(400)] = 30873,
  [SMALL_STATE(401)] = 30917,
  [SMALL_STATE(402)] = 30961,
  [SMALL_STATE(403)] = 31005,
  [SMALL_STATE(404)] = 31049,
  [SMALL_STATE(405)] = 31093,
  [SMALL_STATE(406)] = 31137,
  [SMALL_STATE(407)] = 31181,
  [SMALL_STATE(408)] = 31225,
  [SMALL_STATE(409)] = 31269,
  [SMALL_STATE(410)] = 31313,
  [SMALL_STATE(411)] = 31357,
  [SMALL_STATE(412)] = 31401,
  [SMALL_STATE(413)] = 31445,
  [SMALL_STATE(414)] = 31489,
  [SMALL_STATE(415)] = 31533,
  [SMALL_STATE(416)] = 31577,
  [SMALL_STATE(417)] = 31621,
  [SMALL_STATE(418)] = 31665,
  [SMALL_STATE(419)] = 31709,
  [SMALL_STATE(420)] = 31753,
  [SMALL_STATE(421)] = 31797,
  [SMALL_STATE(422)] = 31849,
  [SMALL_STATE(423)] = 31901,
  [SMALL_STATE(424)] = 31946,
  [SMALL_STATE(425)] = 31999,
  [SMALL_STATE(426)] = 32039,
  [SMALL_STATE(427)] = 32079,
  [SMALL_STATE(428)] = 32119,
  [SMALL_STATE(429)] = 32159,
  [SMALL_STATE(430)] = 32199,
  [SMALL_STATE(431)] = 32239,
  [SMALL_STATE(432)] = 32279,
  [SMALL_STATE(433)] = 32319,
  [SMALL_STATE(434)] = 32359,
  [SMALL_STATE(435)] = 32399,
  [SMALL_STATE(436)] = 32439,
  [SMALL_STATE(437)] = 32479,
  [SMALL_STATE(438)] = 32519,
  [SMALL_STATE(439)] = 32559,
  [SMALL_STATE(440)] = 32599,
  [SMALL_STATE(441)] = 32639,
  [SMALL_STATE(442)] = 32679,
  [SMALL_STATE(443)] = 32719,
  [SMALL_STATE(444)] = 32759,
  [SMALL_STATE(445)] = 32799,
  [SMALL_STATE(446)] = 32839,
  [SMALL_STATE(447)] = 32879,
  [SMALL_STATE(448)] = 32919,
  [SMALL_STATE(449)] = 32959,
  [SMALL_STATE(450)] = 32999,
  [SMALL_STATE(451)] = 33039,
  [SMALL_STATE(452)] = 33079,
  [SMALL_STATE(453)] = 33119,
  [SMALL_STATE(454)] = 33159,
  [SMALL_STATE(455)] = 33199,
  [SMALL_STATE(456)] = 33239,
  [SMALL_STATE(457)] = 33279,
  [SMALL_STATE(458)] = 33319,
  [SMALL_STATE(459)] = 33359,
  [SMALL_STATE(460)] = 33416,
  [SMALL_STATE(461)] = 33479,
  [SMALL_STATE(462)] = 33530,
  [SMALL_STATE(463)] = 33591,
  [SMALL_STATE(464)] = 33666,
  [SMALL_STATE(465)] = 33729,
  [SMALL_STATE(466)] = 33782,
  [SMALL_STATE(467)] = 33854,
  [SMALL_STATE(468)] = 33916,
  [SMALL_STATE(469)] = 33968,
  [SMALL_STATE(470)] = 34036,
  [SMALL_STATE(471)] = 34090,
  [SMALL_STATE(472)] = 34140,
  [SMALL_STATE(473)] = 34208,
  [SMALL_STATE(474)] = 34266,
  [SMALL_STATE(475)] = 34314,
  [SMALL_STATE(476)] = 34362,
  [SMALL_STATE(477)] = 34412,
  [SMALL_STATE(478)] = 34468,
  [SMALL_STATE(479)] = 34509,
  [SMALL_STATE(480)] = 34572,
  [SMALL_STATE(481)] = 34631,
  [SMALL_STATE(482)] = 34678,
  [SMALL_STATE(483)] = 34739,
  [SMALL_STATE(484)] = 34786,
  [SMALL_STATE(485)] = 34837,
  [SMALL_STATE(486)] = 34894,
  [SMALL_STATE(487)] = 34951,
  [SMALL_STATE(488)] = 35008,
  [SMALL_STATE(489)] = 35063,
  [SMALL_STATE(490)] = 35099,
  [SMALL_STATE(491)] = 35135,
  [SMALL_STATE(492)] = 35201,
  [SMALL_STATE(493)] = 35237,
  [SMALL_STATE(494)] = 35303,
  [SMALL_STATE(495)] = 35339,
  [SMALL_STATE(496)] = 35375,
  [SMALL_STATE(497)] = 35411,
  [SMALL_STATE(498)] = 35447,
  [SMALL_STATE(499)] = 35483,
  [SMALL_STATE(500)] = 35519,
  [SMALL_STATE(501)] = 35567,
  [SMALL_STATE(502)] = 35603,
  [SMALL_STATE(503)] = 35661,
  [SMALL_STATE(504)] = 35697,
  [SMALL_STATE(505)] = 35763,
  [SMALL_STATE(506)] = 35799,
  [SMALL_STATE(507)] = 35865,
  [SMALL_STATE(508)] = 35901,
  [SMALL_STATE(509)] = 35937,
  [SMALL_STATE(510)] = 35973,
  [SMALL_STATE(511)] = 36009,
  [SMALL_STATE(512)] = 36059,
  [SMALL_STATE(513)] = 36095,
  [SMALL_STATE(514)] = 36131,
  [SMALL_STATE(515)] = 36167,
  [SMALL_STATE(516)] = 36203,
  [SMALL_STATE(517)] = 36239,
  [SMALL_STATE(518)] = 36275,
  [SMALL_STATE(519)] = 36311,
  [SMALL_STATE(520)] = 36379,
  [SMALL_STATE(521)] = 36445,
  [SMALL_STATE(522)] = 36511,
  [SMALL_STATE(523)] = 36551,
  [SMALL_STATE(524)] = 36617,
  [SMALL_STATE(525)] = 36653,
  [SMALL_STATE(526)] = 36689,
  [SMALL_STATE(527)] = 36753,
  [SMALL_STATE(528)] = 36789,
  [SMALL_STATE(529)] = 36825,
  [SMALL_STATE(530)] = 36861,
  [SMALL_STATE(531)] = 36897,
  [SMALL_STATE(532)] = 36933,
  [SMALL_STATE(533)] = 36969,
  [SMALL_STATE(534)] = 37005,
  [SMALL_STATE(535)] = 37041,
  [SMALL_STATE(536)] = 37077,
  [SMALL_STATE(537)] = 37112,
  [SMALL_STATE(538)] = 37147,
  [SMALL_STATE(539)] = 37210,
  [SMALL_STATE(540)] = 37271,
  [SMALL_STATE(541)] = 37334,
  [SMALL_STATE(542)] = 37391,
  [SMALL_STATE(543)] = 37446,
  [SMALL_STATE(544)] = 37499,
  [SMALL_STATE(545)] = 37548,
  [SMALL_STATE(546)] = 37607,
  [SMALL_STATE(547)] = 37672,
  [SMALL_STATE(548)] = 37735,
  [SMALL_STATE(549)] = 37798,
  [SMALL_STATE(550)] = 37833,
  [SMALL_STATE(551)] = 37868,
  [SMALL_STATE(552)] = 37903,
  [SMALL_STATE(553)] = 37938,
  [SMALL_STATE(554)] = 37983,
  [SMALL_STATE(555)] = 38044,
  [SMALL_STATE(556)] = 38079,
  [SMALL_STATE(557)] = 38114,
  [SMALL_STATE(558)] = 38149,
  [SMALL_STATE(559)] = 38184,
  [SMALL_STATE(560)] = 38219,
  [SMALL_STATE(561)] = 38254,
  [SMALL_STATE(562)] = 38289,
  [SMALL_STATE(563)] = 38324,
  [SMALL_STATE(564)] = 38359,
  [SMALL_STATE(565)] = 38394,
  [SMALL_STATE(566)] = 38429,
  [SMALL_STATE(567)] = 38464,
  [SMALL_STATE(568)] = 38499,
  [SMALL_STATE(569)] = 38534,
  [SMALL_STATE(570)] = 38569,
  [SMALL_STATE(571)] = 38604,
  [SMALL_STATE(572)] = 38639,
  [SMALL_STATE(573)] = 38674,
  [SMALL_STATE(574)] = 38709,
  [SMALL_STATE(575)] = 38744,
  [SMALL_STATE(576)] = 38779,
  [SMALL_STATE(577)] = 38814,
  [SMALL_STATE(578)] = 38877,
  [SMALL_STATE(579)] = 38912,
  [SMALL_STATE(580)] = 38947,
  [SMALL_STATE(581)] = 38982,
  [SMALL_STATE(582)] = 39017,
  [SMALL_STATE(583)] = 39066,
  [SMALL_STATE(584)] = 39101,
  [SMALL_STATE(585)] = 39154,
  [SMALL_STATE(586)] = 39209,
  [SMALL_STATE(587)] = 39266,
  [SMALL_STATE(588)] = 39301,
  [SMALL_STATE(589)] = 39361,
  [SMALL_STATE(590)] = 39421,
  [SMALL_STATE(591)] = 39481,
  [SMALL_STATE(592)] = 39539,
  [SMALL_STATE(593)] = 39599,
  [SMALL_STATE(594)] = 39659,
  [SMALL_STATE(595)] = 39719,
  [SMALL_STATE(596)] = 39779,
  [SMALL_STATE(597)] = 39839,
  [SMALL_STATE(598)] = 39899,
  [SMALL_STATE(599)] = 39959,
  [SMALL_STATE(600)] = 40019,
  [SMALL_STATE(601)] = 40079,
  [SMALL_STATE(602)] = 40139,
  [SMALL_STATE(603)] = 40199,
  [SMALL_STATE(604)] = 40259,
  [SMALL_STATE(605)] = 40319,
  [SMALL_STATE(606)] = 40379,
  [SMALL_STATE(607)] = 40439,
  [SMALL_STATE(608)] = 40499,
  [SMALL_STATE(609)] = 40559,
  [SMALL_STATE(610)] = 40619,
  [SMALL_STATE(611)] = 40679,
  [SMALL_STATE(612)] = 40739,
  [SMALL_STATE(613)] = 40799,
  [SMALL_STATE(614)] = 40859,
  [SMALL_STATE(615)] = 40919,
  [SMALL_STATE(616)] = 40979,
  [SMALL_STATE(617)] = 41039,
  [SMALL_STATE(618)] = 41097,
  [SMALL_STATE(619)] = 41157,
  [SMALL_STATE(620)] = 41217,
  [SMALL_STATE(621)] = 41275,
  [SMALL_STATE(622)] = 41335,
  [SMALL_STATE(623)] = 41391,
  [SMALL_STATE(624)] = 41448,
  [SMALL_STATE(625)] = 41505,
  [SMALL_STATE(626)] = 41562,
  [SMALL_STATE(627)] = 41619,
  [SMALL_STATE(628)] = 41676,
  [SMALL_STATE(629)] = 41733,
  [SMALL_STATE(630)] = 41790,
  [SMALL_STATE(631)] = 41847,
  [SMALL_STATE(632)] = 41904,
  [SMALL_STATE(633)] = 41961,
  [SMALL_STATE(634)] = 42020,
  [SMALL_STATE(635)] = 42077,
  [SMALL_STATE(636)] = 42134,
  [SMALL_STATE(637)] = 42191,
  [SMALL_STATE(638)] = 42248,
  [SMALL_STATE(639)] = 42305,
  [SMALL_STATE(640)] = 42362,
  [SMALL_STATE(641)] = 42419,
  [SMALL_STATE(642)] = 42476,
  [SMALL_STATE(643)] = 42533,
  [SMALL_STATE(644)] = 42590,
  [SMALL_STATE(645)] = 42647,
  [SMALL_STATE(646)] = 42704,
  [SMALL_STATE(647)] = 42761,
  [SMALL_STATE(648)] = 42818,
  [SMALL_STATE(649)] = 42875,
  [SMALL_STATE(650)] = 42934,
  [SMALL_STATE(651)] = 42991,
  [SMALL_STATE(652)] = 43048,
  [SMALL_STATE(653)] = 43105,
  [SMALL_STATE(654)] = 43162,
  [SMALL_STATE(655)] = 43219,
  [SMALL_STATE(656)] = 43275,
  [SMALL_STATE(657)] = 43333,
  [SMALL_STATE(658)] = 43389,
  [SMALL_STATE(659)] = 43445,
  [SMALL_STATE(660)] = 43501,
  [SMALL_STATE(661)] = 43557,
  [SMALL_STATE(662)] = 43611,
  [SMALL_STATE(663)] = 43667,
  [SMALL_STATE(664)] = 43723,
  [SMALL_STATE(665)] = 43779,
  [SMALL_STATE(666)] = 43837,
  [SMALL_STATE(667)] = 43893,
  [SMALL_STATE(668)] = 43949,
  [SMALL_STATE(669)] = 44002,
  [SMALL_STATE(670)] = 44055,
  [SMALL_STATE(671)] = 44108,
  [SMALL_STATE(672)] = 44161,
  [SMALL_STATE(673)] = 44214,
  [SMALL_STATE(674)] = 44267,
  [SMALL_STATE(675)] = 44320,
  [SMALL_STATE(676)] = 44373,
  [SMALL_STATE(677)] = 44426,
  [SMALL_STATE(678)] = 44479,
  [SMALL_STATE(679)] = 44532,
  [SMALL_STATE(680)] = 44585,
  [SMALL_STATE(681)] = 44635,
  [SMALL_STATE(682)] = 44685,
  [SMALL_STATE(683)] = 44735,
  [SMALL_STATE(684)] = 44785,
  [SMALL_STATE(685)] = 44835,
  [SMALL_STATE(686)] = 44885,
  [SMALL_STATE(687)] = 44935,
  [SMALL_STATE(688)] = 44985,
  [SMALL_STATE(689)] = 45035,
  [SMALL_STATE(690)] = 45085,
  [SMALL_STATE(691)] = 45135,
  [SMALL_STATE(692)] = 45185,
  [SMALL_STATE(693)] = 45235,
  [SMALL_STATE(694)] = 45285,
  [SMALL_STATE(695)] = 45335,
  [SMALL_STATE(696)] = 45385,
  [SMALL_STATE(697)] = 45435,
  [SMALL_STATE(698)] = 45485,
  [SMALL_STATE(699)] = 45535,
  [SMALL_STATE(700)] = 45585,
  [SMALL_STATE(701)] = 45635,
  [SMALL_STATE(702)] = 45685,
  [SMALL_STATE(703)] = 45735,
  [SMALL_STATE(704)] = 45785,
  [SMALL_STATE(705)] = 45835,
  [SMALL_STATE(706)] = 45885,
  [SMALL_STATE(707)] = 45935,
  [SMALL_STATE(708)] = 45985,
  [SMALL_STATE(709)] = 46035,
  [SMALL_STATE(710)] = 46085,
  [SMALL_STATE(711)] = 46135,
  [SMALL_STATE(712)] = 46185,
  [SMALL_STATE(713)] = 46235,
  [SMALL_STATE(714)] = 46285,
  [SMALL_STATE(715)] = 46335,
  [SMALL_STATE(716)] = 46385,
  [SMALL_STATE(717)] = 46435,
  [SMALL_STATE(718)] = 46485,
  [SMALL_STATE(719)] = 46535,
  [SMALL_STATE(720)] = 46585,
  [SMALL_STATE(721)] = 46635,
  [SMALL_STATE(722)] = 46685,
  [SMALL_STATE(723)] = 46735,
  [SMALL_STATE(724)] = 46785,
  [SMALL_STATE(725)] = 46835,
  [SMALL_STATE(726)] = 46885,
  [SMALL_STATE(727)] = 46935,
  [SMALL_STATE(728)] = 46985,
  [SMALL_STATE(729)] = 47035,
  [SMALL_STATE(730)] = 47085,
  [SMALL_STATE(731)] = 47135,
  [SMALL_STATE(732)] = 47185,
  [SMALL_STATE(733)] = 47235,
  [SMALL_STATE(734)] = 47285,
  [SMALL_STATE(735)] = 47335,
  [SMALL_STATE(736)] = 47385,
  [SMALL_STATE(737)] = 47435,
  [SMALL_STATE(738)] = 47485,
  [SMALL_STATE(739)] = 47535,
  [SMALL_STATE(740)] = 47585,
  [SMALL_STATE(741)] = 47635,
  [SMALL_STATE(742)] = 47665,
  [SMALL_STATE(743)] = 47691,
  [SMALL_STATE(744)] = 47717,
  [SMALL_STATE(745)] = 47743,
  [SMALL_STATE(746)] = 47769,
  [SMALL_STATE(747)] = 47794,
  [SMALL_STATE(748)] = 47818,
  [SMALL_STATE(749)] = 47842,
  [SMALL_STATE(750)] = 47866,
  [SMALL_STATE(751)] = 47890,
  [SMALL_STATE(752)] = 47915,
  [SMALL_STATE(753)] = 47940,
  [SMALL_STATE(754)] = 47961,
  [SMALL_STATE(755)] = 47984,
  [SMALL_STATE(756)] = 48005,
  [SMALL_STATE(757)] = 48026,
  [SMALL_STATE(758)] = 48051,
  [SMALL_STATE(759)] = 48072,
  [SMALL_STATE(760)] = 48096,
  [SMALL_STATE(761)] = 48116,
  [SMALL_STATE(762)] = 48140,
  [SMALL_STATE(763)] = 48165,
  [SMALL_STATE(764)] = 48184,
  [SMALL_STATE(765)] = 48203,
  [SMALL_STATE(766)] = 48221,
  [SMALL_STATE(767)] = 48243,
  [SMALL_STATE(768)] = 48275,
  [SMALL_STATE(769)] = 48309,
  [SMALL_STATE(770)] = 48327,
  [SMALL_STATE(771)] = 48361,
  [SMALL_STATE(772)] = 48379,
  [SMALL_STATE(773)] = 48413,
  [SMALL_STATE(774)] = 48438,
  [SMALL_STATE(775)] = 48463,
  [SMALL_STATE(776)] = 48488,
  [SMALL_STATE(777)] = 48513,
  [SMALL_STATE(778)] = 48538,
  [SMALL_STATE(779)] = 48563,
  [SMALL_STATE(780)] = 48588,
  [SMALL_STATE(781)] = 48613,
  [SMALL_STATE(782)] = 48638,
  [SMALL_STATE(783)] = 48654,
  [SMALL_STATE(784)] = 48670,
  [SMALL_STATE(785)] = 48686,
  [SMALL_STATE(786)] = 48702,
  [SMALL_STATE(787)] = 48718,
  [SMALL_STATE(788)] = 48734,
  [SMALL_STATE(789)] = 48750,
  [SMALL_STATE(790)] = 48766,
  [SMALL_STATE(791)] = 48782,
  [SMALL_STATE(792)] = 48798,
  [SMALL_STATE(793)] = 48814,
  [SMALL_STATE(794)] = 48836,
  [SMALL_STATE(795)] = 48852,
  [SMALL_STATE(796)] = 48868,
  [SMALL_STATE(797)] = 48884,
  [SMALL_STATE(798)] = 48900,
  [SMALL_STATE(799)] = 48916,
  [SMALL_STATE(800)] = 48932,
  [SMALL_STATE(801)] = 48948,
  [SMALL_STATE(802)] = 48964,
  [SMALL_STATE(803)] = 48980,
  [SMALL_STATE(804)] = 48996,
  [SMALL_STATE(805)] = 49012,
  [SMALL_STATE(806)] = 49028,
  [SMALL_STATE(807)] = 49044,
  [SMALL_STATE(808)] = 49060,
  [SMALL_STATE(809)] = 49073,
  [SMALL_STATE(810)] = 49086,
  [SMALL_STATE(811)] = 49099,
  [SMALL_STATE(812)] = 49112,
  [SMALL_STATE(813)] = 49125,
  [SMALL_STATE(814)] = 49138,
  [SMALL_STATE(815)] = 49161,
  [SMALL_STATE(816)] = 49180,
  [SMALL_STATE(817)] = 49193,
  [SMALL_STATE(818)] = 49206,
  [SMALL_STATE(819)] = 49219,
  [SMALL_STATE(820)] = 49232,
  [SMALL_STATE(821)] = 49251,
  [SMALL_STATE(822)] = 49264,
  [SMALL_STATE(823)] = 49277,
  [SMALL_STATE(824)] = 49290,
  [SMALL_STATE(825)] = 49303,
  [SMALL_STATE(826)] = 49316,
  [SMALL_STATE(827)] = 49329,
  [SMALL_STATE(828)] = 49342,
  [SMALL_STATE(829)] = 49355,
  [SMALL_STATE(830)] = 49368,
  [SMALL_STATE(831)] = 49381,
  [SMALL_STATE(832)] = 49394,
  [SMALL_STATE(833)] = 49407,
  [SMALL_STATE(834)] = 49420,
  [SMALL_STATE(835)] = 49443,
  [SMALL_STATE(836)] = 49456,
  [SMALL_STATE(837)] = 49469,
  [SMALL_STATE(838)] = 49487,
  [SMALL_STATE(839)] = 49505,
  [SMALL_STATE(840)] = 49523,
  [SMALL_STATE(841)] = 49537,
  [SMALL_STATE(842)] = 49553,
  [SMALL_STATE(843)] = 49571,
  [SMALL_STATE(844)] = 49589,
  [SMALL_STATE(845)] = 49605,
  [SMALL_STATE(846)] = 49623,
  [SMALL_STATE(847)] = 49641,
  [SMALL_STATE(848)] = 49661,
  [SMALL_STATE(849)] = 49679,
  [SMALL_STATE(850)] = 49695,
  [SMALL_STATE(851)] = 49711,
  [SMALL_STATE(852)] = 49729,
  [SMALL_STATE(853)] = 49747,
  [SMALL_STATE(854)] = 49765,
  [SMALL_STATE(855)] = 49783,
  [SMALL_STATE(856)] = 49799,
  [SMALL_STATE(857)] = 49815,
  [SMALL_STATE(858)] = 49837,
  [SMALL_STATE(859)] = 49855,
  [SMALL_STATE(860)] = 49875,
  [SMALL_STATE(861)] = 49891,
  [SMALL_STATE(862)] = 49909,
  [SMALL_STATE(863)] = 49929,
  [SMALL_STATE(864)] = 49947,
  [SMALL_STATE(865)] = 49965,
  [SMALL_STATE(866)] = 49983,
  [SMALL_STATE(867)] = 50001,
  [SMALL_STATE(868)] = 50021,
  [SMALL_STATE(869)] = 50037,
  [SMALL_STATE(870)] = 50057,
  [SMALL_STATE(871)] = 50075,
  [SMALL_STATE(872)] = 50093,
  [SMALL_STATE(873)] = 50106,
  [SMALL_STATE(874)] = 50119,
  [SMALL_STATE(875)] = 50136,
  [SMALL_STATE(876)] = 50149,
  [SMALL_STATE(877)] = 50162,
  [SMALL_STATE(878)] = 50181,
  [SMALL_STATE(879)] = 50194,
  [SMALL_STATE(880)] = 50207,
  [SMALL_STATE(881)] = 50224,
  [SMALL_STATE(882)] = 50237,
  [SMALL_STATE(883)] = 50256,
  [SMALL_STATE(884)] = 50269,
  [SMALL_STATE(885)] = 50282,
  [SMALL_STATE(886)] = 50299,
  [SMALL_STATE(887)] = 50312,
  [SMALL_STATE(888)] = 50329,
  [SMALL_STATE(889)] = 50342,
  [SMALL_STATE(890)] = 50355,
  [SMALL_STATE(891)] = 50368,
  [SMALL_STATE(892)] = 50381,
  [SMALL_STATE(893)] = 50394,
  [SMALL_STATE(894)] = 50407,
  [SMALL_STATE(895)] = 50420,
  [SMALL_STATE(896)] = 50433,
  [SMALL_STATE(897)] = 50452,
  [SMALL_STATE(898)] = 50465,
  [SMALL_STATE(899)] = 50478,
  [SMALL_STATE(900)] = 50491,
  [SMALL_STATE(901)] = 50504,
  [SMALL_STATE(902)] = 50517,
  [SMALL_STATE(903)] = 50530,
  [SMALL_STATE(904)] = 50543,
  [SMALL_STATE(905)] = 50556,
  [SMALL_STATE(906)] = 50575,
  [SMALL_STATE(907)] = 50588,
  [SMALL_STATE(908)] = 50607,
  [SMALL_STATE(909)] = 50620,
  [SMALL_STATE(910)] = 50633,
  [SMALL_STATE(911)] = 50646,
  [SMALL_STATE(912)] = 50659,
  [SMALL_STATE(913)] = 50672,
  [SMALL_STATE(914)] = 50685,
  [SMALL_STATE(915)] = 50698,
  [SMALL_STATE(916)] = 50715,
  [SMALL_STATE(917)] = 50728,
  [SMALL_STATE(918)] = 50741,
  [SMALL_STATE(919)] = 50758,
  [SMALL_STATE(920)] = 50771,
  [SMALL_STATE(921)] = 50790,
  [SMALL_STATE(922)] = 50803,
  [SMALL_STATE(923)] = 50816,
  [SMALL_STATE(924)] = 50835,
  [SMALL_STATE(925)] = 50848,
  [SMALL_STATE(926)] = 50861,
  [SMALL_STATE(927)] = 50874,
  [SMALL_STATE(928)] = 50893,
  [SMALL_STATE(929)] = 50906,
  [SMALL_STATE(930)] = 50919,
  [SMALL_STATE(931)] = 50932,
  [SMALL_STATE(932)] = 50945,
  [SMALL_STATE(933)] = 50964,
  [SMALL_STATE(934)] = 50977,
  [SMALL_STATE(935)] = 50990,
  [SMALL_STATE(936)] = 51003,
  [SMALL_STATE(937)] = 51016,
  [SMALL_STATE(938)] = 51032,
  [SMALL_STATE(939)] = 51048,
  [SMALL_STATE(940)] = 51064,
  [SMALL_STATE(941)] = 51080,
  [SMALL_STATE(942)] = 51096,
  [SMALL_STATE(943)] = 51110,
  [SMALL_STATE(944)] = 51126,
  [SMALL_STATE(945)] = 51142,
  [SMALL_STATE(946)] = 51158,
  [SMALL_STATE(947)] = 51174,
  [SMALL_STATE(948)] = 51190,
  [SMALL_STATE(949)] = 51204,
  [SMALL_STATE(950)] = 51220,
  [SMALL_STATE(951)] = 51230,
  [SMALL_STATE(952)] = 51246,
  [SMALL_STATE(953)] = 51262,
  [SMALL_STATE(954)] = 51276,
  [SMALL_STATE(955)] = 51292,
  [SMALL_STATE(956)] = 51308,
  [SMALL_STATE(957)] = 51322,
  [SMALL_STATE(958)] = 51336,
  [SMALL_STATE(959)] = 51352,
  [SMALL_STATE(960)] = 51366,
  [SMALL_STATE(961)] = 51382,
  [SMALL_STATE(962)] = 51398,
  [SMALL_STATE(963)] = 51412,
  [SMALL_STATE(964)] = 51426,
  [SMALL_STATE(965)] = 51440,
  [SMALL_STATE(966)] = 51456,
  [SMALL_STATE(967)] = 51470,
  [SMALL_STATE(968)] = 51486,
  [SMALL_STATE(969)] = 51500,
  [SMALL_STATE(970)] = 51516,
  [SMALL_STATE(971)] = 51530,
  [SMALL_STATE(972)] = 51544,
  [SMALL_STATE(973)] = 51560,
  [SMALL_STATE(974)] = 51576,
  [SMALL_STATE(975)] = 51592,
  [SMALL_STATE(976)] = 51608,
  [SMALL_STATE(977)] = 51622,
  [SMALL_STATE(978)] = 51638,
  [SMALL_STATE(979)] = 51652,
  [SMALL_STATE(980)] = 51664,
  [SMALL_STATE(981)] = 51676,
  [SMALL_STATE(982)] = 51690,
  [SMALL_STATE(983)] = 51706,
  [SMALL_STATE(984)] = 51720,
  [SMALL_STATE(985)] = 51734,
  [SMALL_STATE(986)] = 51748,
  [SMALL_STATE(987)] = 51760,
  [SMALL_STATE(988)] = 51776,
  [SMALL_STATE(989)] = 51792,
  [SMALL_STATE(990)] = 51805,
  [SMALL_STATE(991)] = 51818,
  [SMALL_STATE(992)] = 51831,
  [SMALL_STATE(993)] = 51844,
  [SMALL_STATE(994)] = 51857,
  [SMALL_STATE(995)] = 51870,
  [SMALL_STATE(996)] = 51879,
  [SMALL_STATE(997)] = 51888,
  [SMALL_STATE(998)] = 51901,
  [SMALL_STATE(999)] = 51910,
  [SMALL_STATE(1000)] = 51923,
  [SMALL_STATE(1001)] = 51936,
  [SMALL_STATE(1002)] = 51949,
  [SMALL_STATE(1003)] = 51958,
  [SMALL_STATE(1004)] = 51971,
  [SMALL_STATE(1005)] = 51984,
  [SMALL_STATE(1006)] = 51993,
  [SMALL_STATE(1007)] = 52004,
  [SMALL_STATE(1008)] = 52015,
  [SMALL_STATE(1009)] = 52028,
  [SMALL_STATE(1010)] = 52041,
  [SMALL_STATE(1011)] = 52054,
  [SMALL_STATE(1012)] = 52065,
  [SMALL_STATE(1013)] = 52076,
  [SMALL_STATE(1014)] = 52089,
  [SMALL_STATE(1015)] = 52102,
  [SMALL_STATE(1016)] = 52115,
  [SMALL_STATE(1017)] = 52128,
  [SMALL_STATE(1018)] = 52141,
  [SMALL_STATE(1019)] = 52154,
  [SMALL_STATE(1020)] = 52165,
  [SMALL_STATE(1021)] = 52178,
  [SMALL_STATE(1022)] = 52191,
  [SMALL_STATE(1023)] = 52204,
  [SMALL_STATE(1024)] = 52217,
  [SMALL_STATE(1025)] = 52230,
  [SMALL_STATE(1026)] = 52243,
  [SMALL_STATE(1027)] = 52256,
  [SMALL_STATE(1028)] = 52269,
  [SMALL_STATE(1029)] = 52282,
  [SMALL_STATE(1030)] = 52293,
  [SMALL_STATE(1031)] = 52306,
  [SMALL_STATE(1032)] = 52315,
  [SMALL_STATE(1033)] = 52328,
  [SMALL_STATE(1034)] = 52341,
  [SMALL_STATE(1035)] = 52354,
  [SMALL_STATE(1036)] = 52367,
  [SMALL_STATE(1037)] = 52376,
  [SMALL_STATE(1038)] = 52389,
  [SMALL_STATE(1039)] = 52402,
  [SMALL_STATE(1040)] = 52415,
  [SMALL_STATE(1041)] = 52428,
  [SMALL_STATE(1042)] = 52441,
  [SMALL_STATE(1043)] = 52454,
  [SMALL_STATE(1044)] = 52467,
  [SMALL_STATE(1045)] = 52480,
  [SMALL_STATE(1046)] = 52491,
  [SMALL_STATE(1047)] = 52504,
  [SMALL_STATE(1048)] = 52515,
  [SMALL_STATE(1049)] = 52524,
  [SMALL_STATE(1050)] = 52537,
  [SMALL_STATE(1051)] = 52548,
  [SMALL_STATE(1052)] = 52561,
  [SMALL_STATE(1053)] = 52574,
  [SMALL_STATE(1054)] = 52587,
  [SMALL_STATE(1055)] = 52600,
  [SMALL_STATE(1056)] = 52613,
  [SMALL_STATE(1057)] = 52626,
  [SMALL_STATE(1058)] = 52637,
  [SMALL_STATE(1059)] = 52648,
  [SMALL_STATE(1060)] = 52661,
  [SMALL_STATE(1061)] = 52674,
  [SMALL_STATE(1062)] = 52683,
  [SMALL_STATE(1063)] = 52692,
  [SMALL_STATE(1064)] = 52701,
  [SMALL_STATE(1065)] = 52714,
  [SMALL_STATE(1066)] = 52723,
  [SMALL_STATE(1067)] = 52736,
  [SMALL_STATE(1068)] = 52749,
  [SMALL_STATE(1069)] = 52762,
  [SMALL_STATE(1070)] = 52775,
  [SMALL_STATE(1071)] = 52788,
  [SMALL_STATE(1072)] = 52801,
  [SMALL_STATE(1073)] = 52814,
  [SMALL_STATE(1074)] = 52827,
  [SMALL_STATE(1075)] = 52840,
  [SMALL_STATE(1076)] = 52853,
  [SMALL_STATE(1077)] = 52866,
  [SMALL_STATE(1078)] = 52879,
  [SMALL_STATE(1079)] = 52892,
  [SMALL_STATE(1080)] = 52905,
  [SMALL_STATE(1081)] = 52918,
  [SMALL_STATE(1082)] = 52931,
  [SMALL_STATE(1083)] = 52944,
  [SMALL_STATE(1084)] = 52955,
  [SMALL_STATE(1085)] = 52968,
  [SMALL_STATE(1086)] = 52979,
  [SMALL_STATE(1087)] = 52992,
  [SMALL_STATE(1088)] = 53005,
  [SMALL_STATE(1089)] = 53014,
  [SMALL_STATE(1090)] = 53027,
  [SMALL_STATE(1091)] = 53038,
  [SMALL_STATE(1092)] = 53051,
  [SMALL_STATE(1093)] = 53064,
  [SMALL_STATE(1094)] = 53075,
  [SMALL_STATE(1095)] = 53085,
  [SMALL_STATE(1096)] = 53095,
  [SMALL_STATE(1097)] = 53103,
  [SMALL_STATE(1098)] = 53111,
  [SMALL_STATE(1099)] = 53121,
  [SMALL_STATE(1100)] = 53131,
  [SMALL_STATE(1101)] = 53139,
  [SMALL_STATE(1102)] = 53149,
  [SMALL_STATE(1103)] = 53159,
  [SMALL_STATE(1104)] = 53169,
  [SMALL_STATE(1105)] = 53177,
  [SMALL_STATE(1106)] = 53187,
  [SMALL_STATE(1107)] = 53197,
  [SMALL_STATE(1108)] = 53207,
  [SMALL_STATE(1109)] = 53217,
  [SMALL_STATE(1110)] = 53227,
  [SMALL_STATE(1111)] = 53237,
  [SMALL_STATE(1112)] = 53247,
  [SMALL_STATE(1113)] = 53257,
  [SMALL_STATE(1114)] = 53267,
  [SMALL_STATE(1115)] = 53277,
  [SMALL_STATE(1116)] = 53287,
  [SMALL_STATE(1117)] = 53295,
  [SMALL_STATE(1118)] = 53305,
  [SMALL_STATE(1119)] = 53315,
  [SMALL_STATE(1120)] = 53325,
  [SMALL_STATE(1121)] = 53335,
  [SMALL_STATE(1122)] = 53343,
  [SMALL_STATE(1123)] = 53353,
  [SMALL_STATE(1124)] = 53363,
  [SMALL_STATE(1125)] = 53373,
  [SMALL_STATE(1126)] = 53383,
  [SMALL_STATE(1127)] = 53393,
  [SMALL_STATE(1128)] = 53403,
  [SMALL_STATE(1129)] = 53413,
  [SMALL_STATE(1130)] = 53423,
  [SMALL_STATE(1131)] = 53433,
  [SMALL_STATE(1132)] = 53441,
  [SMALL_STATE(1133)] = 53451,
  [SMALL_STATE(1134)] = 53459,
  [SMALL_STATE(1135)] = 53469,
  [SMALL_STATE(1136)] = 53477,
  [SMALL_STATE(1137)] = 53487,
  [SMALL_STATE(1138)] = 53495,
  [SMALL_STATE(1139)] = 53503,
  [SMALL_STATE(1140)] = 53513,
  [SMALL_STATE(1141)] = 53523,
  [SMALL_STATE(1142)] = 53531,
  [SMALL_STATE(1143)] = 53541,
  [SMALL_STATE(1144)] = 53549,
  [SMALL_STATE(1145)] = 53559,
  [SMALL_STATE(1146)] = 53569,
  [SMALL_STATE(1147)] = 53579,
  [SMALL_STATE(1148)] = 53589,
  [SMALL_STATE(1149)] = 53597,
  [SMALL_STATE(1150)] = 53607,
  [SMALL_STATE(1151)] = 53617,
  [SMALL_STATE(1152)] = 53625,
  [SMALL_STATE(1153)] = 53633,
  [SMALL_STATE(1154)] = 53641,
  [SMALL_STATE(1155)] = 53651,
  [SMALL_STATE(1156)] = 53661,
  [SMALL_STATE(1157)] = 53671,
  [SMALL_STATE(1158)] = 53681,
  [SMALL_STATE(1159)] = 53691,
  [SMALL_STATE(1160)] = 53699,
  [SMALL_STATE(1161)] = 53706,
  [SMALL_STATE(1162)] = 53713,
  [SMALL_STATE(1163)] = 53720,
  [SMALL_STATE(1164)] = 53727,
  [SMALL_STATE(1165)] = 53734,
  [SMALL_STATE(1166)] = 53741,
  [SMALL_STATE(1167)] = 53748,
  [SMALL_STATE(1168)] = 53755,
  [SMALL_STATE(1169)] = 53762,
  [SMALL_STATE(1170)] = 53769,
  [SMALL_STATE(1171)] = 53776,
  [SMALL_STATE(1172)] = 53783,
  [SMALL_STATE(1173)] = 53790,
  [SMALL_STATE(1174)] = 53797,
  [SMALL_STATE(1175)] = 53804,
  [SMALL_STATE(1176)] = 53811,
  [SMALL_STATE(1177)] = 53818,
  [SMALL_STATE(1178)] = 53825,
  [SMALL_STATE(1179)] = 53832,
  [SMALL_STATE(1180)] = 53839,
  [SMALL_STATE(1181)] = 53846,
  [SMALL_STATE(1182)] = 53853,
  [SMALL_STATE(1183)] = 53860,
  [SMALL_STATE(1184)] = 53867,
  [SMALL_STATE(1185)] = 53874,
  [SMALL_STATE(1186)] = 53881,
  [SMALL_STATE(1187)] = 53888,
  [SMALL_STATE(1188)] = 53895,
  [SMALL_STATE(1189)] = 53902,
  [SMALL_STATE(1190)] = 53909,
  [SMALL_STATE(1191)] = 53916,
  [SMALL_STATE(1192)] = 53923,
  [SMALL_STATE(1193)] = 53930,
  [SMALL_STATE(1194)] = 53937,
  [SMALL_STATE(1195)] = 53944,
  [SMALL_STATE(1196)] = 53951,
  [SMALL_STATE(1197)] = 53958,
  [SMALL_STATE(1198)] = 53965,
  [SMALL_STATE(1199)] = 53972,
  [SMALL_STATE(1200)] = 53979,
  [SMALL_STATE(1201)] = 53986,
  [SMALL_STATE(1202)] = 53993,
  [SMALL_STATE(1203)] = 54000,
  [SMALL_STATE(1204)] = 54007,
  [SMALL_STATE(1205)] = 54014,
  [SMALL_STATE(1206)] = 54021,
  [SMALL_STATE(1207)] = 54028,
  [SMALL_STATE(1208)] = 54035,
  [SMALL_STATE(1209)] = 54042,
  [SMALL_STATE(1210)] = 54049,
  [SMALL_STATE(1211)] = 54056,
  [SMALL_STATE(1212)] = 54063,
  [SMALL_STATE(1213)] = 54070,
  [SMALL_STATE(1214)] = 54077,
  [SMALL_STATE(1215)] = 54084,
  [SMALL_STATE(1216)] = 54091,
  [SMALL_STATE(1217)] = 54098,
  [SMALL_STATE(1218)] = 54105,
  [SMALL_STATE(1219)] = 54112,
  [SMALL_STATE(1220)] = 54119,
  [SMALL_STATE(1221)] = 54126,
  [SMALL_STATE(1222)] = 54133,
  [SMALL_STATE(1223)] = 54140,
  [SMALL_STATE(1224)] = 54147,
  [SMALL_STATE(1225)] = 54154,
  [SMALL_STATE(1226)] = 54161,
  [SMALL_STATE(1227)] = 54168,
  [SMALL_STATE(1228)] = 54175,
  [SMALL_STATE(1229)] = 54182,
  [SMALL_STATE(1230)] = 54189,
  [SMALL_STATE(1231)] = 54196,
  [SMALL_STATE(1232)] = 54203,
  [SMALL_STATE(1233)] = 54210,
  [SMALL_STATE(1234)] = 54217,
  [SMALL_STATE(1235)] = 54224,
  [SMALL_STATE(1236)] = 54231,
  [SMALL_STATE(1237)] = 54238,
  [SMALL_STATE(1238)] = 54245,
  [SMALL_STATE(1239)] = 54252,
  [SMALL_STATE(1240)] = 54259,
  [SMALL_STATE(1241)] = 54266,
  [SMALL_STATE(1242)] = 54273,
  [SMALL_STATE(1243)] = 54280,
  [SMALL_STATE(1244)] = 54287,
  [SMALL_STATE(1245)] = 54294,
  [SMALL_STATE(1246)] = 54301,
  [SMALL_STATE(1247)] = 54308,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(892),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(238),
  [78] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(935),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1238),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(767),
  [87] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(149),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(991),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(992),
  [96] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(994),
  [99] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(57),
  [102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(981),
  [105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(179),
  [108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1114),
  [111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(13),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1227),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1226),
  [120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(726),
  [123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(205),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(892),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(849),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(841),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1218),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(30),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(212),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(158),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(29),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(21),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(22),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1215),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(301),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(213),
  [165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(316),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(959),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(316),
  [174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 2),
  [182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_case, 2),
  [184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_case, 3, .production_id = 7),
  [188] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 98),
  [190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 4, .production_id = 98),
  [192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 3, .production_id = 85),
  [194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_communication_case, 3, .production_id = 85),
  [196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 3, .production_id = 38),
  [198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_case, 3, .production_id = 38),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 3),
  [202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 3),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 2),
  [206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 2),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 25),
  [218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_labeled_statement, 2, .production_id = 25),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 55),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 83),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 54),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 39),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 39),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, .production_id = 19),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, .production_id = 19),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(235),
  [321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(547),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1146),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(81),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(708),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1112),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1205),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1242),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(710),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(1200),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(550),
  [440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(681),
  [623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 67),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 67),
  [627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(1229),
  [634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(696),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 40),
  [648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 40),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 5),
  [656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 5),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 68),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 68),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 5),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_type, 3, .production_id = 22),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_type, 3, .production_id = 22),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 14),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 14),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 70),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 70),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4, .dynamic_precedence = 2),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4, .dynamic_precedence = 2),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 4, .production_id = 44),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 4, .production_id = 44),
  [690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 2),
  [696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 2),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 2, .production_id = 15),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 2, .production_id = 15),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5, .dynamic_precedence = 2),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5, .dynamic_precedence = 2),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1229),
  [719] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1), SHIFT(687),
  [723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), SHIFT(1182),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(86),
  [731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_type, 1, .dynamic_precedence = -1, .production_id = 1), REDUCE(sym__expression, 1),
  [734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(703),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 2),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 2),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpreted_string_literal, 3),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpreted_string_literal, 3),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 6),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 6),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_type, 1),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_type, 1),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec_list, 3),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec_list, 3),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_type, 2),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_type, 2),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 1), SHIFT_REPEAT(292),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 4),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 4),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, .production_id = 30),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 3, .production_id = 30),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 3, .production_id = 26),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 3, .production_id = 26),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 2),
  [802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 2),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_spec, 1, .production_id = 3),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_channel_type, 2, .production_id = 7),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 90),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 90),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 91),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 91),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3, .dynamic_precedence = 2),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3, .dynamic_precedence = 2),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type, 3),
  [838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type, 3),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package_clause, 2, .production_id = 2),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statement, 1),
  [846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statement, 1),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 1),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 20),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 20),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 11),
  [882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 69),
  [884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 69),
  [886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_map_type, 5, .production_id = 77),
  [888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_map_type, 5, .production_id = 77),
  [890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 41),
  [892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 41),
  [894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 31),
  [896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 31),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 6),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 2),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 2),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 6, .production_id = 96),
  [940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 6, .production_id = 96),
  [942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 12),
  [950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_composite_literal, 2, .production_id = 13),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_composite_literal, 2, .production_id = 13),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 4, .production_id = 42),
  [960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 4, .production_id = 42),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 88),
  [968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 88),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 5, .production_id = 87),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 5, .production_id = 87),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 3),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 3),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 8, .production_id = 102),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 8, .production_id = 102),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 3),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 3),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 7, .production_id = 99),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 7, .production_id = 99),
  [994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selector_expression, 3, .production_id = 33),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selector_expression, 3, .production_id = 33),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 86),
  [1000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_assertion_expression, 5, .production_id = 86),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_func_literal, 3, .production_id = 21),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_func_literal, 3, .production_id = 21),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, .production_id = 35),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, .production_id = 35),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 5),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 5),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 58),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 5, .dynamic_precedence = -1, .production_id = 58),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 5),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 5),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4, .production_id = 60),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4, .production_id = 60),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_expression, 4, .production_id = 59),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_expression, 4, .production_id = 59),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_argument_list, 4),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_argument_list, 4),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_value, 4),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_value, 4),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 58),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_conversion_expression, 4, .dynamic_precedence = -1, .production_id = 58),
  [1054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(696),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [1069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 24),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 24),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_receive_statement, 1, .production_id = 57),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 1, .production_id = 4),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 2, .production_id = 16),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 2, .production_id = 16),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_defer_statement, 2),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_defer_statement, 2),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_send_statement, 3, .production_id = 34),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_send_statement, 3, .production_id = 34),
  [1227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_go_statement, 2),
  [1229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_go_statement, 2),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_element, 1),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 5), SHIFT(538),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 2, .production_id = 28),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_receive_statement, 3, .production_id = 32),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 2, .production_id = 52),
  [1514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 2, .production_id = 52),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_clause, 4, .production_id = 81),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2),
  [1602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1241),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [1607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(141),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_spec_repeat1, 2), SHIFT_REPEAT(1176),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 66),
  [1633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 66),
  [1635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 66), SHIFT_REPEAT(1182),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 66),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 66),
  [1642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 66), SHIFT_REPEAT(1237),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [1647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 63),
  [1649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_declaration_repeat1, 2, .production_id = 63),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 73),
  [1653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, .production_id = 73),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 3),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 5),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 5),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameter_list, 4),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4),
  [1691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1081),
  [1694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1131),
  [1697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1089),
  [1700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [1702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(1120),
  [1705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_spec_list_repeat1, 2), SHIFT_REPEAT(959),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 47),
  [1732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 47),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(182),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type_name, 1, .production_id = 1),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type_name, 1, .production_id = 1),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_term, 1, .production_id = 1),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [1757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_list, 1),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_spec_list_repeat1, 2),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [1767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [1769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 1),
  [1771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2),
  [1773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(52),
  [1776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_select_statement_repeat1, 2), SHIFT_REPEAT(1193),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [1781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 78),
  [1783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 78),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 1, .production_id = 18),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 1, .production_id = 18),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 1),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2),
  [1815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(95),
  [1818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_switch_statement_repeat1, 2), SHIFT_REPEAT(1193),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 27),
  [1825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 27),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [1829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 37),
  [1831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 37),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 49),
  [1839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 49),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 38),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 38),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [1855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(20),
  [1858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2), SHIFT_REPEAT(20),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 75),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 75),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 2, .production_id = 17),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 2, .production_id = 17),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2),
  [1879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(694),
  [1882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_switch_statement_repeat1, 2), SHIFT_REPEAT(1193),
  [1885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(144),
  [1888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 3, .production_id = 36),
  [1890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 3, .production_id = 36),
  [1892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 62),
  [1894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 62),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_elem, 2),
  [1898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_elem, 2),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [1902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 3),
  [1904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 3),
  [1906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inc_statement, 2),
  [1908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inc_statement, 2),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 2),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 2),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statement_list_repeat1, 2),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraint_elem_repeat1, 2),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constraint_elem_repeat1, 2),
  [1926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constraint_elem_repeat1, 2), SHIFT_REPEAT(990),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 3),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 3),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dec_statement, 2),
  [1937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dec_statement, 2),
  [1939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 3, .production_id = 46),
  [1941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 3, .production_id = 46),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias, 3, .production_id = 45),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_alias, 3, .production_id = 45),
  [1951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2), SHIFT_REPEAT(666),
  [1954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_declaration_repeat1, 2),
  [1956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 4),
  [1958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 4),
  [1960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 5, .production_id = 56),
  [1962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 5, .production_id = 56),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 3),
  [1966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 3),
  [1968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [1970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, .production_id = 8),
  [1972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallthrough_statement, 1),
  [1974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallthrough_statement, 1),
  [1976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 3),
  [1978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 3),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [1982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, .production_id = 8),
  [1984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [1986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 7),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [1990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [1992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 2, .production_id = 8),
  [1994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 62),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 62),
  [1998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 4, .production_id = 61),
  [2000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 4, .production_id = 61),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 2),
  [2004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 2),
  [2006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 25),
  [2008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 25),
  [2010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, .production_id = 31),
  [2012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, .production_id = 31),
  [2014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 2),
  [2016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 2),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_var_declaration, 3, .production_id = 32),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_var_declaration, 3, .production_id = 32),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 4, .production_id = 61),
  [2026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 4, .production_id = 61),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_spec, 5, .production_id = 89),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_spec, 5, .production_id = 89),
  [2034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [2042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, .production_id = 29),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, .production_id = 29),
  [2046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 5, .production_id = 89),
  [2048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 5, .production_id = 89),
  [2050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_declaration, 4),
  [2052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_declaration, 4),
  [2054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_elem, 1),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_elem, 1),
  [2058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_spec, 3, .production_id = 36),
  [2060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_spec, 3, .production_id = 36),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 3),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 79),
  [2070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 79),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4),
  [2076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4),
  [2078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 94),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 7, .production_id = 94),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 97),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 97),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_spec, 2, .production_id = 23),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_spec, 2, .production_id = 23),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 84),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 84),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_switch_statement, 4, .production_id = 56),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_switch_statement, 4, .production_id = 56),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 2, .production_id = 9),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 84),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 5, .production_id = 84),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_declaration, 4),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_declaration, 4),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [2118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 4, .production_id = 7),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 94),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_switch_statement, 6, .production_id = 94),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_statement, 4),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_statement, 4),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [2138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2), SHIFT_REPEAT(633),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_declaration_repeat1, 2),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [2169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [2183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [2185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2), SHIFT_REPEAT(469),
  [2198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_const_declaration_repeat1, 2),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [2204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2),
  [2256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpreted_string_literal_repeat1, 2), SHIFT_REPEAT(966),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [2271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(731),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [2298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_term, 1, .production_id = 1),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [2306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2), SHIFT_REPEAT(793),
  [2309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2), SHIFT_REPEAT(793),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interface_type_repeat1, 2),
  [2314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_term, 2, .production_id = 51),
  [2326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_term, 2, .production_id = 51),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [2332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [2334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(952),
  [2337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(952),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2),
  [2344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2), SHIFT_REPEAT(643),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 4, .production_id = 38),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_case, 5, .production_id = 98),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_communication_case, 4, .production_id = 85),
  [2367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(166),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [2376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_case, 4, .production_id = 7),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 92),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, .production_id = 92),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2), SHIFT_REPEAT(678),
  [2397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(125),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_type_name, 1),
  [2406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_type_name, 1),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2), SHIFT_REPEAT(50),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literal_value_repeat1, 2),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(202),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_case, 3),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interface_type_repeat1, 2),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_spec, 3, .production_id = 76),
  [2464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_spec, 3, .production_id = 76),
  [2466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_list, 4),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 72),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 72),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 71),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 71),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, .production_id = 17),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, .production_id = 65),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, .production_id = 18),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 74),
  [2528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, .production_id = 74),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 48),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 48),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, .production_id = 50),
  [2544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, .production_id = 50),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [2578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1159),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot, 1),
  [2598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_argument, 2),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 3, .production_id = 64),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyed_element, 3),
  [2614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, .production_id = 38),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 80),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 4, .production_id = 82),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 5, .production_id = 93),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 5, .production_id = 95),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 100),
  [2712] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 7, .production_id = 101),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_switch_header, 9, .production_id = 103),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [2732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_length_array_type, 4, .production_id = 43),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, .production_id = 53),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_go(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
